 {
       ----------------------------------------------------------
            :   ,  
           (), 1 , . 
                   e-mail: piettropro@fmi.uni-sofia.bg
       -----------------------------------------------------------

   :
         -  -  
                     
 .        .
        -        .
             :  -  
   ;    -           
     ;    -           
 -.      ""      .    
 ,          1    48    
 .           11 ,   9.  
 Lines            .
         10 .
        -       -
     .          
   -        Cells  1  48     
       .        
   :        (  A   L)     
             -  .
            ,     
   -  .            
     ,    . 
     O(12*11).
      -  .      
        CellLines (48*3),   
     2  3    .     
   ,              . 
    .
      -          
 .  ,              ,  
   12             12-
       .    ,   
       12- ,       
 .  ,        12- ,
            .    
 ,           - 
 :        ""      6.    
        6-       
                  .   
 ,              6-.  
 -      :        
 "",  ..          
     .   repeat-until 
      "".     
     ""       
           ,          ""
    .  ,      
   ,  -    .     
         ""    ,      .
     O(12*11*3),     , 
       .
 }

 program Star;
 {$A+,B-,D+,E+,F-,G+,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V-,X+}
 {$M 16384,0,655360}

 const
   Lines : array['A'..'L',1..11] of Byte =
    ((  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15),  {A}
     (  0, 16, 17, 18, 19, 20, 21, 22, 23, 24,  0),  {B}
     (  0, 25, 26, 27, 28, 29, 30, 31, 32, 33,  0),  {C}
     ( 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44),  {D}
     ( 34, 35, 25, 26, 17, 18,  8,  9,  2,  3,  1),  {E}
     (  0, 36, 37, 27, 28, 19, 20, 10, 11,  4,  0),  {F}
     (  0, 45, 38, 39, 29, 30, 21, 22, 12, 13,  0),  {G}
     ( 48, 46, 47, 40, 41, 31, 32, 23, 24, 14, 15),  {H}
     ( 48, 46, 45, 38, 37, 27, 26, 17, 16,  6,  5),  {I}
     (  0, 47, 40, 39, 29, 28, 19, 18,  8,  7,  0),  {J}
     (  0, 42, 41, 31, 30, 21, 20, 10,  9,  2,  0),  {K}
     ( 44, 43, 33, 32, 23, 22, 12, 11,  4,  3,  1)); {L}

 var
   F : Text;
   Flag,NoSolution : Boolean;
   Ch : Char;
   I,J,K,L,MaxLines,MaxCell,MaxNum,ReadyCnt,Minimum,Maximum : Integer;
   MaxDigits : array['A'..'L'] of Integer;
   Ready : array['A'..'L'] of Boolean;
   Cells : array[1..48] of Byte;
   CellLines : array[1..48,1..3] of Char;


 BEGIN
 { Read input file: }
 Assign(F,'..\STAR.I10'); FileMode:=0; Reset(F);
 for Ch:='A' to 'L' do Read(F,MaxDigits[Ch]);
 Close(F);

 { Find maximum: }
 NoSolution:=False;
 FillChar(Cells,SizeOf(Cells),10);
 for Ch:='A' to 'L' do
   begin
     Flag:=False;
     for I:=1 to 11 do
       if (Lines[Ch,I]>0) and (MaxDigits[Ch]<=Cells[Lines[Ch,I]]) then
         begin Cells[Lines[Ch,I]]:=MaxDigits[Ch]; Flag:=True; end;
     if not Flag then NoSolution:=True;
   end;
 Maximum:=0;
 for I:=1 to 48 do Inc(Maximum,Cells[I]);

 { Build CellLines: }
 FillChar(CellLines,SizeOf(CellLines),#0);
 for Ch:='A' to 'L' do for I:=1 to 11 do
   if CellLines[Lines[Ch,I],1]=#0 then CellLines[Lines[Ch,I],1]:=Ch
   else if CellLines[Lines[Ch,I],2]=#0 then CellLines[Lines[Ch,I],2]:=Ch
     else CellLines[Lines[Ch,I],3]:=Ch;
 { Find minimum: }
 Minimum:=0; ReadyCnt:=0;
 FillChar(Cells,SizeOf(Cells),0);
 FillChar(Ready,SizeOf(Ready),False);
 for Ch:='A' to 'L' do if MaxDigits[Ch]=0 then
   begin Ready[Ch]:=True; Inc(ReadyCnt); end;
 repeat
   { Find a cell which will satisfy maximum lines: }
   MaxLines:=0;
   for Ch:='A' to 'L' do if not Ready[Ch] then Break;
   if Ready[Ch] then Break;
   for I:=1 to 11 do
     begin
       K:=Lines[Ch,I]; if (K=0) or (Cells[K]<>0) then Continue;
       Flag:=False; L:=0;
       for J:=1 to 3 do if CellLines[K,J]<>#0 then
         begin
           if MaxDigits[CellLines[K,J]]<MaxDigits[Ch] then
             begin Flag:=True; Break; end;
           if (not Ready[CellLines[K,J]]) and
             (MaxDigits[CellLines[K,J]]=MaxDigits[Ch]) then
             Inc(L);
         end;
       if Flag then Continue;
       if L>MaxLines then
         begin MaxLines:=L; MaxCell:=K; MaxNum:=MaxDigits[Ch]; end;
     end;
   if MaxLines=0 then Break;
   Cells[MaxCell]:=MaxNum;
   for J:=1 to 3 do if CellLines[MaxCell,J]<>#0 then
     if MaxDigits[CellLines[MaxCell,J]]=MaxNum then
       Ready[CellLines[MaxCell,J]]:=True;
   Inc(ReadyCnt,MaxLines);
   Inc(Minimum,MaxNum);
 until ReadyCnt>=12;
 if ReadyCnt<12 then NoSolution:=True;

 { Write output file: }
 Assign(F,'STAR.OUT'); FileMode:=2; Rewrite(F);
 if NoSolution then
   WriteLn(F,'NO SOLUTION')
 else
   WriteLn(F,Minimum,' ',Maximum);
 Close(F);
 END.