{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{ Sursa neterminata.. }

{$S-,I-,R-,Q-,N+}
{$M 65000,0,655360}

Program Contour;

type adivect=array[1..500] of byte;

var fin,fout:text;
    xp,yp,xaux,yaux:array[1..2000] of real;
    mat:array[1..500] of ^adivect;
    i,j,j1,j2,k,n,np:integer;
    x1,y1,x2,y2:array[1..20] of real;
    xs,ys:array[1..20,1..4,1..2] of real;
    vaux:real;

procedure check(x1,y1,x2,y2,x3,y3,x4,y4:real);
var a1,b1,c1,a2,b2,c2:real;
    xi,yi:real;
begin

a1:=y1-y2;
b1:=x2-x1;
c1:=x1*y2-x2*y1;

a2:=y3-y4;
b2:=x4-x3;
c2:=x3*y4-x4*y3;

if (abs(a2*b1-a1*b2)>0.0001) then
   begin
      xi:=(b2*c1-b1*c2)/(a2*b1-a1*b2);
      yi:=(c2*a1-c1*a2)/(a2*b1-a1*b2);

      if (xi>=x1) and (xi<=x2) and (xi>=x3) and (xi<=x4) and
         (yi>=y1) and (yi<=y2) and (yi>=y3) and (yi<=y4) then
            begin

            end;
   end;

end;

begin

for i:=1 to 500 do
   begin
      new(mat[i]);
      fillchar(mat[i]^,sizeof(mat[i]^),0);
   end;

assign(fin,'contour.inp');
reset(fin);
readln(fin,n);

np:=0;
for i:=1 to n do
   begin
      readln(fin,x1[i],y1[i],x2[i],y2[i]);
      inc(np);
      xp[np]:=x1[i]; yp[np]:=y1[i];
      inc(np);
      xp[np]:=x1[i]; yp[np]:=y2[i];
      inc(np);
      xp[np]:=x2[i]; yp[np]:=y1[i];
      inc(np);
      xp[np]:=x2[i]; yp[np]:=y2[i];

      mat[np-3]^[np-2]:=1; mat[np-2]^[np-3]:=1;
      mat[np-3]^[np-1]:=1; mat[np-1]^[np-3]:=1;

      {--}

      xs[i,1,1]:=x1[i]; ys[i,1,1]:=y1[i];
      xs[i,1,2]:=x1[i]; ys[i,1,2]:=y2[i];

      xs[i,2,1]:=x1[i]; ys[i,2,1]:=y2[i];
      xs[i,2,2]:=x2[i]; ys[i,2,2]:=y2[i];

      xs[i,3,1]:=x2[i]; ys[i,3,1]:=y2[i];
      xs[i,3,2]:=x2[i]; ys[i,3,2]:=y1[i];

      xs[i,4,1]:=x2[i]; ys[i,4,1]:=y1[i];
      xs[i,4,2]:=x1[i]; ys[i,4,2]:=y1[i];

      for j:=1 to 4 do
         begin
            if (xs[i,j,1]>xs[i,j,2]) then
               begin
                  vaux:=xs[i,j,1];
                  xs[i,j,1]:=xs[i,j,2];
                  xs[i,j,2]:=vaux;
               end
            else
            if (ys[i,j,1]>ys[i,j,2]) then
               begin
                  vaux:=ys[i,j,1];
                  ys[i,j,1]:=ys[i,j,2];
                  ys[i,j,2]:=vaux;
               end;
         end;

      for k:=1 to i-1 do
         for j1:=1 to 4 do
            for j2:=1 to 4 do
               check(xs[k,j1,1],ys[k,j1,1],xs[k,j1,2],ys[k,j1,2],
                     xs[i,j2,1],ys[i,j2,1],xs[i,j2,2],ys[i,j2,2]);


   end;

close(fin);



assign(fout,'contour.out');
rewrite(fout);

close(fout);

end.