{ -- Zadacha 3
     Ivan Sashov Vasilchev
     Sofia
}

program comp;

type pvertex=^vertex;
     prib=^rib;

vertex=record
ribs:prib;
stored:integer;
index:integer;
parent:integer;
lastrib:prib;
end;

rib=record
next:prib;
prev:prib;
len:integer;
vertex:pvertex;
end;

type
pvl=^vertex_list;
vertex_list=record
prev:pvl;
vert:pvertex;
path:integer;
next:pvl;
end;



var root:pvertex;
    vl:vertex_list;
    inf,ouf:text;
    N,K:integer;

procedure Init;
begin
getmem(root,sizeof(vertex));
root^.ribs:=nil;
root^.lastrib:=nil;
root^.stored:=0;
vl.prev:=nil;
vl.vert:=nil;
vl.next:=nil;
assign(inf,'COMP.INP');
reset(inf);
assign(ouf,'COMP.OUT');
rewrite(ouf);
read(inf,N);
read(inf,K);
readln(inf);

end;


procedure vertadd(_vert:pvertex;_path:integer);
var t:pvl;
begin
getmem(t,sizeof(vertex_list));
t^.vert:=_vert;
t^.path:=_path;
t^.prev:=vl.next;
vl.next:=t;
end;

procedure create_rib(from:pvertex;_to:pvertex;_len:integer);
var mrib:prib;
begin
getmem(mrib,sizeof(rib));
mrib^.prev:=nil;
mrib^.next:=nil;
mrib^.vertex:=_to;
mrib^.len:=_len;
if from^.ribs=nil then
begin
from^.ribs:=mrib;
from^.lastrib:=mrib;
end
else
begin
from^.lastrib^.next:=mrib;
mrib^.prev:=from^.lastrib;
from^.lastrib:=mrib;
end;

end;

function create_vertex(_stored,_index,_parent:integer):pvertex;
var mvert:pvertex;
begin
getmem(mvert,sizeof(vertex));
mvert^.ribs:=nil;
mvert^.stored:=_stored;
mvert^.index:=_index;
mvert^.parent:=_parent;
create_vertex:=mvert;
end;


procedure read_data;
var j:integer;
    s, { stored}
    i, {index }
    p, {path}
    pi {parent index }
    :integer;

begin
for j:=1 to n-1 do
begin
read(inf,i); { index }
read(inf,pi); {parent index }
read(inf,s); { stored computers }
read(inf,p); { path length }
vertadd(create_vertex(s,i,pi),p);
readln(inf);
end;
end;


function find_vertex(_index:integer):pvertex;
var tl:pvl;
begin

tl:=vl.next;
while (tl^.vert^.index<>_index) or (tl^.next<>nil) do tl:=tl^.next;

if tl^.vert^.index=_index then find_vertex:=tl^.vert else find_vertex:=nil;
end;

procedure complete; { zavurshva obrabotkata na dannite }
var tvl:pvl;
    prnt:pvertex;
begin
tvl:=vl.next;

while tvl<>nil do
begin
prnt:=find_vertex(tvl^.vert^.index);
if prnt<>nil then { found it }
begin
create_rib(prnt,tvl^.vert,tvl^.path); { add the rib }
end;
tvl:=tvl^.next;
end;

end;

procedure finish;
begin
close(inf);
close(ouf);
end;

begin
Init;
read_data;

end.