//Ivan Yosifov , 8A , NPMG , SOFIA
#include <fstream.h>
#include <mem.h>

typedef long* TIArr;
struct TProg {
       long iCT;
       long iRem;
};

TIArr *iT;
long iN;

void saveResult(long i);

int loadData(){
  ifstream inpf("rapp.inp",ios::in);

  inpf >> iN;
  if (iN==1) {
     long i;
     inpf >> i;
     saveResult(i);
     return 0;
  }
  if (iN==2) {
     long i1,i2;
     inpf >> i1 >> i2;
     saveResult(i1+i2);
     return 0;
  }
  iT=new TIArr[iN];
  iT[iN-1]=new long[1];
  iT[iN-2]=new long[1];
  for (int i=0;i<iN-2;i++){
      iT[i]=new long[2];
      inpf >> iT[i][0] >> iT[i][1];
  }
  inpf >> iT[iN-2][0] >> iT[iN-1][0];
  inpf >> i;
  return 1;
}

long getL(TProg prog[],long iL){
  long iR=0;

  for (long i=0;i<iL;i++)
      if (prog[i].iRem<iN-2)
	 iR+=2;
      else
	 iR+=1;
  return iR;
}

int process(){
  TProg *prog1,*prog2;
  long i,iL1=2,iL2,iDone,iP;

  prog1=new TProg[2];
  prog1[0].iRem=1;
  prog1[0].iCT=iT[0][0];
  prog1[1].iRem=3;
  prog1[1].iCT=iT[0][1];
  do {
    iDone=1;
    iP=0;
    iL2=getL(prog1,iL1);
    prog2=new TProg[iL2];
    for (i=0;i<iL1;i++){
	 if (prog1[i].iRem<=iN-3){
	    iDone=0;
	    prog2[iP].iRem=prog1[i].iRem+3;
	    prog2[iP].iCT=prog1[i].iCT+iT[prog1[i].iRem][1];
	    iP++;
	 }
	 if (prog1[i].iRem>iN-1) {
	    prog2[iP].iRem=prog1[i].iRem;
	    prog2[iP].iCT=prog1[i].iCT;
	    iP++;
	 }
	 if ((prog1[i].iRem>iN-3) &&
	     (prog1[i].iRem<iN)){
	    iDone=0;
	    prog2[iP].iRem=prog1[i].iRem+1;
	    prog2[iP].iCT=prog1[i].iCT+iT[prog1[i].iRem][0];
	    iP++;
	 }
    }
    iL1=iL2;
    delete []prog1;
    prog1=new TProg[iL1];
    memmove(prog1,prog2,sizeof(TProg)*iL1);
  } while (iDone==0);

  long iMax=-1;
  for (i=0;i<iL1;i++)
      if ((iMax==-1) ||
	  (prog1[i].iCT<iMax))
	 iMax=prog1[i].iCT;
  return iMax;
}

void saveResult(long i){
  ofstream outf("rapp.out",ios::out);

  outf << i;
}

int main(){
  if (loadData())
     saveResult(process());

  for (long i=0;i<=iN-2;i++)
      delete []iT[i];
  delete []iT[iN-2];
  delete []iT[iN-1];
  delete []iT;
  return 0;
}