//Ivan Yosifov , 8A , NPMG , SOFIA
#include <fstream.h>

enum TDirect {dLeft,dDown,dRigth,dUp};

int iN,iK;
int iX=1,iY=1;

inline int between(int i1,int i2,int i3){
  if (
       ((i1>=i2) &&
	(i1<=i3))
      ||
       ((i1>=i3) &&
	(i1<=i2))
     )
     return 1;
  else
     return 0;
}

void loadData(){
  ifstream inpf("tab.inp",ios::in);

  inpf >> iN >> iK;
}

void saveResult(){
  ofstream outf("tab.out",ios::out);

  outf << iY << ' ' << iX;
}

void process(){
  int iHorzL=iN,iVertL=iN-1,iC=1;
  TDirect cDir=dRigth;

  do {
    switch (cDir) {
	   case dRigth: {
			 if (between(iK,iC,iC+iHorzL-1)){
			    iX+=iK-iC;
			    return;
			 }
			 else {
			   cDir=dDown;
			   iC+=iHorzL;
			   iX+=iHorzL-1;
			   iY++;
			   iHorzL--;
			 }
		       } break;
	   case dDown: {
			 if (between(iK,iC,iC+iVertL-1)){
			    iY+=iK-iC;
			    return;
			 }
			 else {
			   cDir=dLeft;
			   iC+=iVertL;
			   iX--;
			   iY+=iVertL-1;
			   iVertL--;
			 }
		       } break;
	   case dLeft: {
			 if (between(iK,iC,iC+iHorzL-1)){
			    iX-=iK-iC;
			    return;
			 }
			 else {
			   cDir=dUp;
			   iC+=iHorzL;
			   iX-=iHorzL-1;
			   iY--;
			   iHorzL--;
			 }
		       } break;
	   case dUp: {
		       if (between(iK,iC,iC+iVertL-1)){
			  iY-=iK-iC;
			  return;
		       }
		       else {
			 cDir=dRigth;
			 iC+=iHorzL;
			 iX++;
			 iY-=iVertL-1;
			 iVertL--;
		       }
		     } break;
    }
  } while (iC!=iK);
}

int main(){
  loadData();
  process();
  saveResult();

  return 0;
}