(* NACIONALNA OLIMPIADA PO INFORMATIKA - 17 MART 2002 *)
(* VTORI KRUG - TEMA ZA 9 - 10 KLAS *)
(* grad Haskovo - PMG-Haskovo *)
(* Nikolay Georgiev Semov  - 10b *)

Program Poly;

Uses Crt, Dos;

Type T1ChL = Array[1..9] Of Byte;
     TMChL = Array[1..16] Of T1ChL;

Var  P1, P2 : TMChL;
     PC1, PC2 : Byte;
     R : Array[1..256] Of T1ChL;
     RC : Integer;

Function CByte(S : String) : Byte;
Var Ret : Byte; C : Integer;
Begin
   Val(S, Ret, C);
   CByte := Ret;
End;

Procedure ReadData;
Var Ch : Char;
    F : Text;
    I, J : Byte;
Begin
   For I := 1 To 16 Do For J := 1 To 9 Do Begin P1[I][J] := 0; P2[I][J] := 0; End;
   Assign(F, 'POLY.INP');
   Reset(F);
   I := 1;
   While Not EOLn(F) Do Begin
      Read(F, Ch);
      Case Ch Of
      'x' : Begin
               Read(F, Ch);
               J := CByte(Ch);
               Inc(P1[I][J]);
            End;
      '^' : Begin
               Read(F, Ch);
               Inc(P1[I][J], (CByte(Ch)-1));
            End;
      '+' : Inc(I);
      End;
   End;
   PC1 := I;
   I := 1;
   While Not EOF(F) Do Begin
      Read(F, Ch);
      Case Ch Of
      'x' : Begin
               Read(F, Ch);
               J := CByte(Ch);
               Inc(P2[I][J]);
            End;
      '^' : Begin
               Read(F, Ch);
               Inc(P2[I][J], (CByte(Ch)-1));
            End;
      '+' : Inc(I);
      End;
   End;
   PC2 := I;
   Close(F);
End;

Procedure MultiplyEx(E1, E2 : T1ChL; Var M : T1ChL);
Var I : Byte;
Begin
   For I := 1 To 9 Do M[i] := E1[i] + E2[i];
End;

Function GetES(E : T1ChL) : Byte;
Var I, Ret : Byte;
Begin
   Ret := 0;
   For I := 1 To 9 Do Inc(Ret, E[I]);
   GetES := Ret;
End;

Function GetELex(E1, E2 : T1ChL) : Byte;
Var I : Byte;
Begin
   For I := 1 To 9 Do Begin
      If E1[I] < E2[I] Then Begin
         GetELex := 2;
         Exit;
      End;
      If E1[I] > E2[I] Then Begin
         GetELex := 1;
         Exit;
      End;
   End;
   GetELex := 0;
End;

Procedure SwapEx(Var E1, E2 : T1ChL);
Var T : T1ChL;
Begin
   T := E1; E1 := E2; E2 := T;
End;

Procedure SortIt;
Var I, J : Integer;
    L1 : Byte;
Begin
   For I := 1 To RC - 1 Do
      For J := I + 1 To RC Do Begin
         L1 := GetELex(R[I], R[J]);
         If L1 = 2 Then SwapEx(R[I], R[J]);
         If L1 = 0 Then If GetES(R[J]) > GetES(R[I]) Then SwapEx(R[I], R[J]);
      End;
End;

Procedure ProceedData;
Var I, J : Byte;
Begin
   RC := 0;
   For I := 1 To PC1 Do
      For J := 1 To PC2 Do Begin
         Inc(RC);
         MultiplyEx(P1[I], P2[J], R[RC]);
      End;
    SortIt;
End;

Function CStr(S : Byte) : String;
Var Ret : String;
Begin
   Str(S, Ret);
   CStr := Ret;
End;

Procedure WriteData;
Var I, J : Integer;
    F : Text;
    TS : String;
Begin
   Assign(F, 'POLY.OUT');
   ReWrite(F);
   For I := 1 To RC Do Begin
      TS := '';
      For J := 1 To 9 Do Begin
         If R[I][J] > 0 Then TS := TS + 'x' + CStr(J);
         If R[I][J] > 1 Then TS := TS + '^' + CStr(R[I][J]);
         If R[I][J] > 0 Then TS := TS + ' ';
      End;
      If I < RC Then TS := TS + '+ ';
      Write(F, TS);
   End;
   Close(F);
End;

BEGIN
   ReadData;
   ProceedData;
   WriteData;
END.