/*
   Mihail Volen Mukov
   Pleven
   11 -12
*/

/* INCLUDES *****************************************************************/
   #include <fstream>
   #include <string>
   #include <cstdlib>
   #include <cmath>

   using namespace std;

/* CONSTANTS ****************************************************************/
   const int MAX = 100002;

/* CLASSES ******************************************************************/

   class hall
   {
   public:
      hall() { childs = 0; }
   
      int parent;
      int comps;
      int len2parent;
      int childs;
   };

/* GLOBALS ******************************************************************/
   ifstream fin("comp.inp");
   ofstream fout("comp.out");

   int halls;
   int maxcomps;
   hall m[MAX];
   unsigned long long int res = 0;

/* FUNCTIONS ****************************************************************/
/****************************************************************************/
   void done()
   {

      fout << res << endl;
   
      fin.close();
      fout.close();
      exit(0);
   }
/****************************************************************************/
   void init()
   {  m[0].parent = -1;
      m[0].comps = 0;
      m[0].len2parent = 0;
      m[0].childs = 0;

   
      fin >> halls >> maxcomps;
      for (int i = 0; i < halls - 1; i++)
      {  int hallno;
         int parentno;
         int comps;
         int len2parent;

         fin >> hallno >> parentno >> comps >> len2parent;
         hallno--;
         parentno--;

         m[hallno].parent = parentno;
         m[hallno].comps = comps;
         m[hallno].len2parent = len2parent;
         m[parentno].childs++;
      }
   }
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
   void run()
   {
      int i2done = halls - 1;
      while (i2done > 0)
      {
         for (int i = 1; i < halls; i++)
            if ((m[i].childs == 0) && (m[i].comps > -1))
            {
               res += (2 * m[i].len2parent)
                      * ((m[i].comps + maxcomps - 1) / maxcomps);

               m[m[i].parent].comps += m[i].comps;
               m[i].comps = -1;
               m[m[i].parent].childs --;

               i2done--;
            }
      }
      
   }
/****************************************************************************/
   int main()
   {
      init();
      run();
      done();
      
      return 0;
   }
/****************************************************************************/

