/*
   Mihail Volen Mukov
   Pleven
   11 -12
*/

/* INCLUDES *****************************************************************/
   #include <fstream>
   #include <string>
   #include <string.h>
   #include <cstdlib>
   #include <cmath>

   using namespace std;

/* CONSTANTS ****************************************************************/
   const int MAX = 22;

/* CLASSES ******************************************************************/
/* GLOBALS ******************************************************************/
   ifstream fin("sums.inp");
   ofstream fout("sums.out");

   int n;
   int c_a, c_b;
   int a[MAX], b[MAX];

   int c_output = 0;
   string output[MAX * MAX * MAX];

/* FUNCTIONS ****************************************************************/
/****************************************************************************/
   void done()
   {
      fout << c_output - 1 << endl;
      if (c_output - 1 > 0)
         for (int i = 0; i < c_output; i++)
            fout << output[i] << endl;

   
      fin.close();
      fout.close();
      exit(0);
   }
/****************************************************************************/
   void init()
   {  fin >> n;

      char ch;
      int flag;
   
      flag = 0;
      while(true)
      {
         fin >> a[c_a];
         flag += a[c_a];
         c_a++;
         
         if (flag >= n) break;
         
         fin >> ch;
      }
      
      flag = 0;
      while (true)
      {
         fin >> b[c_b];
         flag += b[c_b];
         c_b++;

         if (flag >= n) break;
         
         fin >> ch;
      }
      
   }
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
   int fcmp(const void* e1, const void* e2)
   {  if ((*((int*)e1)) < (*((int*)e2))) return 1;
      return -1;
   }
/****************************************************************************/
   void run()
   {
      qsort(a, c_a, sizeof(a[0]), fcmp);
      qsort(b, c_b, sizeof(b[0]), fcmp);
      
      output[c_output] = "";
      for (int i = 0; i < c_a - 1; i++)
      {  output[c_output] += itoa(a[i], NULL, 10);
         output[c_output] += '+';
      }
      output[c_output] += itoa(a[c_a - 1], NULL, 10);
      
      c_output++;
      
      int i = 0;
      while (i < c_b)
      {
     /*void qsort(void *base, size_t numelem, size_t size,
                int (*cmp)(const void *e1, const void *e2));
     */
         qsort(a + i, c_a - i, sizeof(a[0]), fcmp);
         qsort(b + i, c_b - i, sizeof(b[0]), fcmp);

         if (a[i] == b[i])
         {  i++;
            continue;
         }
         
         if (a[i] < b[i])
         {
            a[i] += a[i + 1];
            
            for (int j = i + 1; j < c_a - 1; j++)
               a[j] = a[j + 1];
            c_a--;
            
         } else
            {
               a[c_a] = a[i] - b[i];
               a[i] = b[i];
               c_a++;
               
               i++;
            }


         output[c_output] = "";
         for (int i = 0; i < c_a - 1; i++)
         {  output[c_output] += itoa(a[i], NULL, 10);
            output[c_output] += '+';
         }
         output[c_output] += itoa(a[c_a - 1], NULL, 10);
         
         c_output++;

      }
   
   }
/****************************************************************************/
   int main()
   {
      init();
      run();
      done();
      
      return 0;
   }
/****************************************************************************/

