/*Borislav Kirilov Kirilov grad Pleven*/
#include<fstream>
#include<string>
#include<cstdlib>
#define MAX 101

using namespace std;

/****************************************************************************/

  const char *inp_file = "stir.inp";
  const char *out_file = "stir.out";

/****************************************************************************/
  int mas[MAX],b[MAX],sol[MAX],N;
/****************************************************************************/
  void init();
  void calculate();
  void done();
/****************************************************************************/
void main(){
  init();
  calculate();
  done();
}
/****************************************************************************/
void init(){
  memset(mas,0,sizeof(mas));
  memset(b,0,sizeof(b));
  memset(sol,0,sizeof(sol));
  
  ifstream fin(inp_file);

  fin>>N;
  for (int i=0;i<N-1;i++) fin>>b[i];

  for (int i=0;i<N;i++) mas[i]=i+1;

  fin.close();
}
/****************************************************************************/
void calculate(){
  int j,p;
  for (int i=0;i<N-1;i++) {
    p=0;
    for (int j=0;j<N;j++) {
      if (mas[j]>0) p++;
      if (p==b[i]+1) {p=j;  break;}
    }
    sol[i]=mas[p];  mas[p]=-10;
  }
  for (int i=0;i<N;i++) if (mas[i]>=0) {sol[N-1]=mas[i]; break;}
}
/****************************************************************************/
void done(){
  ofstream fout(out_file);

  for (int i=0;i<N;i++) fout<<sol[i]<<" ";

  fout<<endl;
  fout.close();
  exit(0);
}
/****************************************************************************/

