/*
   Ivaylo Penkov Riskov
   OMG, Plovdiv
   11 now klas
*/

#include <stdio.h>
#include <stdlib.h>

typedef unsigned long ulong;

struct tree {
	ulong	    comps;
	ulong	    count;
        ulong       length;
	ulong       *leafs;
};

typedef struct tree tree;
ulong cap;
ulong nodecount;
ulong total;
tree nodes[100000];

ulong traverse(ulong node) {
	int i, sum;

	if (nodes[node].count == 0)
        	return 2*nodes[node].length*(nodes[node].comps/cap +
                       (nodes[node].comps%cap ? 1 : 0));

        for (sum = 0, i = 0; i < nodes[node].count; i++) {
        	sum += traverse(nodes[node].leafs[i]);
                nodes[node].comps += nodes[nodes[node].leafs[i]].comps;
        }
        return sum + 2*nodes[node].length*(nodes[node].comps/cap +
                       (nodes[node].comps%cap ? 1 : 0));
}

int main() {
	FILE *f;
        ulong i, j, k, l, n;

        for (i = 0; i < 100000; i++) {
        	nodes[i].count = nodes[i].length = nodes[i].comps = 0;
                nodes[i].leafs = NULL;
        }
        f = fopen("comp.inp", "rt");
        fscanf(f, "%lu %lu", &nodecount, &cap);
        for (i = 0; i < nodecount; i++) {
        	fscanf(f, "%lu %lu %lu %lu", &n, &j, &k, &l);
                nodes[n-1].comps = k;
                nodes[j-1].count++;
                nodes[j-1].leafs = (ulong *)realloc(nodes[j-1].leafs,
                                   nodes[j-1].count*sizeof(ulong));
                nodes[j-1].leafs[nodes[j-1].count-1] = n-1;
                nodes[n-1].length = l;
        }
        fclose(f);

        total = 0;

        f = fopen("comp.out", "wt");
        fprintf(f, "%lu\n", traverse(0));
        fclose(f);
        
        return 0;
}
