//
// Zadacha 2 (Sumi) - SUMS
//
// Ivan Zahariev
// grad Razgrad
//

#include <sys\stat.h>
#include <stdio.h>
#include <fcntl.h>

#define TRUE	1==1
#define FALSE	0==1

#define MAXSUB	19	/* maksimalen broi subiraemi = Max.N*1 */

int bs[MAXSUB], es[MAXSUB];	/* bs=nachalna suma, es=kraina suma */
int bsn, esn;			/* broi na elementite suotvetno v bs i es */
int n, m=-1;	/* N i M */

void readdata() {
  int fd, i, j, cr;
  char tmps[3], ch;

  if ((fd=open("SUMS.INP", O_RDONLY|O_TEXT)) == -1) {
    perror("open()");
    exit(1);
  }

  memset(bs, -1, sizeof(bs));
  memset(es, -1, sizeof(es));
  memset(tmps, 0, 3);
  i=0;
  do {
    read(fd, &ch, 1);
    if (ch != '\n') {
      tmps[i++]=ch;
    }
  } while (ch != '\n');
  n=atoi(tmps);

  i=j=cr=0;
  memset(tmps, 0, 3);
  do {
    read(fd, &ch, 1);
    if (ch != '+' && ch != '\n' && !eof(fd)) {
      tmps[i++]=ch;
    } else
      if (strlen(tmps) > 0) {
	if (cr == 0) {
	  bs[j++]=atoi(tmps);
	  bsn=j;
	}
	else {
	  es[j++]=atoi(tmps);
	  esn=j;
	}
	i=0;
	memset(tmps, 0, 3);
      }
    if (ch == '\n') {	/* vreme e da prochetem krainata suma -> es */
      ++cr;
      j=0;
    }
  } while (!eof(fd));

  close(fd);
}

void think() {
  /* :-) */
}

int sortfunc(const void *a, const void *b) {
  return *(int *)a - *(int *)b;
}

int identical() {
  int i;
  int thesame=TRUE;

  if (bsn != esn) return FALSE;	/* ako broia na elementite e !=, niama kak da sa ednakvi */
  qsort((void *)bs, bsn, sizeof(bs[0]), sortfunc);
  qsort((void *)es, esn, sizeof(es[0]), sortfunc);
  for (i=0; i < MAXSUB; ++i)
    if (bs[i] != es[i]) thesame=FALSE;

  return thesame;
}

void writeresult() {
  int fd, i;
  char tmps[3];

  if ((fd=creat("SUMS.OUT", S_IREAD|S_IWRITE)) == -1) {
    perror("creat()");
    exit(1);
  }

  if (m == 0) {
    sprintf(tmps, "0\n");
    write(fd, tmps, strlen(tmps));
  }
  close(fd);

}

int main() {

  readdata();
  if (identical()) {
    m=0;
  } else think();
  writeresult();

  return 0;
}