// Veselin Raychev 11z SMG

#include <stdio.h>

long long otgovor;

int comps[100000];
int tatkomu[100000];
int tatkor[100000];
char iamtatko[100000];

int fifo[200000],fifof,fifot,fifon;

int n,k,km1;

int main(void)
{
  FILE* f;
  int i,a1,a2,a3,a4,tmp;

  f = fopen("comp.inp","rt");
  fscanf(f,"%d %d",&n,&k);
  km1 = k-1;

  n--;
  for (i=0;i<n;i++)
  {
    fscanf(f,"%d %d %d %d",&a1,&a2,&a3,&a4);
    a1--; a2--;
    iamtatko[a2]++;

    tatkomu[a1] = a2;
    comps[a1] = a3;
    tatkor[a1] = a4;
  }
  n++;
  fclose(f);

  fifof = 0;
  for (i=0;i<n;i++)
  {
    if (iamtatko[i]==0)
    {
      fifo[fifot] = i;
      fifot++;
    }
  }
  fifon = fifot;
  do {

    for (i=fifof;i<fifot;i++)
    {

      a1 = fifo[i];
      a2 = tatkomu[a1];

      tmp = (comps[a1]+km1)/k;
      otgovor+= (2*tmp*tatkor[a1]);

      comps[a2] += comps[a1];
      if (iamtatko[a2]) // This should be always true
      {
        iamtatko[a2]--;
        if (iamtatko[a2]==0)
        {
          fifo[fifon] = a2;
          fifon++;
        }
      }
    }
    fifof = fifot;
    fifot = fifon;
  } while (fifo[fifof]!=0);

//  printf("%d\n",fifof);

  f = fopen("comp.out","wt");
  fprintf(f,"%lld\n",otgovor);
  fclose(f);

  return 0;
}
