// Veselin Raychev 11z SMG

#include <stdio.h>

int m1[21],m2[21];

FILE* outf;

typedef struct {
  int has[1];
  void* goon[31];
} chislo;

chislo ch;

int printm(int* m)
{
  int i;
  fprintf(outf,"%d",m[0]);
  for (i=1;m[i]!=0;i++)
  {
    fprintf(outf,"+%d",m[i]);
  }
  fprintf(outf,"\n");
}

int freerov(chislo* chis)
{
  int i;
  chislo* ch1;

  chis->has[0] = 0;
  for (i=0;i<31;i++)
  {
    ch1 = chis->goon[i];
    if (ch1!=NULL)
    {
      freerov(ch1);
      chis->goon[i] = NULL;
      free(ch1);
    }
  }
}

int tukalie(int *m, int hods)
{
  int i;
  chislo* cc;

  cc = &ch;
  for (i=0;m[i]!=0;i++)
  {
      if (cc->goon[ m[i] ]==NULL)
      {
        cc->goon[ m[i] ] = (void*)(malloc(sizeof(chislo)));
        memset(cc->goon[ m[i] ],0,sizeof(chislo));
      }
      cc = (chislo*)(cc->goon[ m[i] ]);
  }
  if ((cc->has[0]))
  {
    if (cc->has[0] <= hods) { return 1; }
  }
  cc->has[0] = hods;
  return 0;
}

int sortm(int* m)
{
  int i,j,t;
  for (i=0;i<19;i++)
  {
    for (j=i+1;j<20;j++)
    {
      if (m[j]>m[i])
      {
        t = m[j]; m[j]=m[i]; m[i]=t;
      }
    }
  }
}

int equalm(int* mas1,int* mas2)
{
  int i;
  for (i=0;mas1[i]!=0;i++)
  {
    if (mas1[i]!=mas2[i]) { return 0; }
  }
  return 1;
}

int depthrov(int* m,int hod,int ostavat)
{
  int i,j,c,r;
  int mas1[21];

//  printf("%d -- ",hod);
//  printm(m);
  if (equalm(m,m1)) {
   outf = fopen("sums.out","wt");
   fprintf(outf,"%d\n",hod-1); printm(m); return 1; }
  if (ostavat==0) { return 0; }

  for (i=0;i<21;i++)
  {
    if (m[i]==0) { c=i; break; }
  }

  for (i=0;i<c;i++)
  {
    for (j=i+1;j<c;j++)
    {
      memcpy(mas1,m,21*4);
      mas1[i]+=mas1[j];
      mas1[j] = 0;
      sortm(mas1);
      if (tukalie(mas1,hod)==0)
      {
        r = depthrov(mas1,hod+1,ostavat-1);
        if (r)
        {
          printm(m);
          return 1;
        }

      }
    }
  }

  for (i=0;i<c;i++)
  {
    for (j=1;j<m[i];j++)
    {
      memcpy(mas1,m,21*4);
      mas1[c] = j;
      mas1[i] = mas1[i]-j;
      sortm(mas1);
      if (tukalie(mas1,hod)==0)
      {
        r = depthrov(mas1,hod+1,ostavat-1);
        if (r)
        {
          printm(m);
          return 1;
        }
      }
    }
  }

  return 0;
}

int main(void)
{
  int i,sm,tms,t;
  FILE* f;
  f = fopen("sums.inp","rt");
  fscanf(f,"%d",&sm);

  fscanf(f,"%d",&tms);
  m1[0] = tms;
  i = 0;
  while (tms<sm)
  {
    i++;
    fscanf(f,"+%d",&t);
    m1[i]=t; tms+=t;
  } sortm(m1);

  fscanf(f,"%d",&tms);
  m2[0] = tms;
  i = 0;
  while (tms<sm)
  {
    i++;
    fscanf(f,"+%d",&t);
    m2[i]=t; tms+=t;
  } sortm(m2);

  fclose(f);

  if (equalm(m1,m2)) {
    f = fopen("sums.out","wt");
    fprintf(f,"0\n");
    fclose(f);
  } else {

    for (i=2;i<22;i++)
    {
      tukalie(m2,1);
      if (depthrov(m2,1,i)==1) { fclose(outf); return 0; }
      freerov(&ch);
    }
  }

  return 0;
}
