// Boris Nikolaev Daskalov 9klass SMG Sofia
#include <fstream.h>
#include <math.h>
#include <stdlib.h>
#define LEFT 	0
#define RIGHT 1
#define UP		2
#define DOWN	3
#define DL		4
#define DR		5
#define UL 		6
#define UR		7
#define IN		8
#define COL		9

unsigned float pdistance(long x1,long y1,long x2,long y2)
{
	return sqrt(pow(abs(x1-x2),2)+pow(abs(y1-y2),2));
};

unsigned float ldistance(long a,long b)
{
	return abs(a-b);
};



class rect
{
public:
	long x1,y1,x2,y2;
	long* dists;
};
int left(rect a,rect b)
{
	return (a.x2 <= b.x1);
}
int right(rect a,rect b)
{
	return left(b,a);
}
int down(rect a,rect b)
{
	return (a.y2 <= b.y1);
}
int up(rect a,rect b)
{
	return up(b,a);
}
int inv(rect a,rect b)
{
	return (a.y1 > b.y1 && a.y2 < b.y2);
}
int inh(rect a,rect b)
{
	return (a.x1 > b.x1 && a.x2 < b.x2);
}

int distances[20][20];
int dist(rect a,rect b)
{
	if(left(a,b)&&down(a,b))
		return pdistance(a.x2,a.y2,b.x1,b.y1);
	if(left(a,b)&&up(a,b))
		return pdistance(a.x2,a.y1,b.x1,b.y2);
	if(left(a,b)&&inv(a,b))
		return ldistance(a.x2,b.x1);
	if(up(a,b)&&inh(a,b))
		return ldistance(a.y1,b.y2);
	if(right(a,b)&&up(a,b))
		return pdistance(a.x1,a.y1,b.x2,b.y2);
	if(right(a,b)&&inv(a,b))
		return ldistance(a.x1,b.x2);
	if(right(a,b)&&down(a,b))
		return pdistance(a.x1,a.y2,b.x2,b.y1);
	if(down(a,b)&&inh(a,b))
		return ldistance(a.y2,b.y1);
}


void getdists(rect* rects,unsigned int n,unsigned int index)
{
	unsigned int i,cnt=0;
	for(i=0;i<n;i++)
	{
		if(i==index)
			continue;
		rects[index].dists[cnt]=dist(rects[index],rects[i]);
		cnt++;
	}
}
int main()
{
	ifstream in("code.inp");
	ofstream out("code.out");
	unsigned int i,n;
	rect rects[20];
	in >> n;
	for(i=0;i<n;i++)
	{
		in >> rects[i].x1 >> rects[i].y1 >> rects[i].x2 >> rects[i].y2;
		rects[i].dists=new losts[n-1];
	}
	for(i=0;i<n;i++)
		getdists(rects,n,i);
}


