/* George Tsankov - Sofia - SMG - 11 star */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MAXN 100100


int N, K;
int deg[MAXN];
int deg1[MAXN];
int *g[MAXN];
int l[MAXN];
int par[MAXN];
int que[MAXN];
int used[MAXN];
unsigned long long c[MAXN];
unsigned long long P;


void read_all(void);
void do_all(void);
void BFS(void);
void getto(int u);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i, j, k;

  FILE *f = fopen("comp.inp", "rt");
  fscanf(f, "%d %d", &N, &K);
  for (i = 1; i < N; i++) {
    fscanf(f, "%d", &j);  j--;
    fscanf(f, "%d %lld %d", &par[j], &c[j], &l[j]);  k = --par[j];
    deg[k]++;
    g[k] = (int *)realloc(g[k], deg[k]*sizeof(*g[k]));
    g[k][deg[k]-1] = j;
  }
  fclose(f);
}




void do_all(void)
{
  int i;

  BFS();
  for (i = 0; i < N; i++) {
    getto(que[i]);
  }
}




void BFS(void)
{
  int i, j, u;
  int ir, iw;

  ir = iw = 0;
  for (i = 0; i < N; i++) {
    if (deg[i] == 0)  que[iw++] = i;
  }
  memmove(deg1, deg, sizeof(deg));
  while (ir < iw) {
    u = que[ir++];
    j = par[u];
    deg1[j]--;
    if (deg1[j] == 0)  que[iw++] = j;
  }
}




void getto(int u)
{
  int i;

/*  if (u%100 == 0) {
    printf("%d\n", u);
  }*/
  for (i = 0; i < deg[u]; i++) {
    g[u][i];
/*    getto(g[u][i]);*/
    c[u] += c[g[u][i]];
    P += 2ll*l[g[u][i]]*ceil(1.*c[g[u][i]]/K);
  }
}




void write_all(void)
{
  FILE *f = fopen("comp.out", "wt");
  fprintf(f, "%llu\n", P);
  fclose(f);
}


