/*
Nikola Momchev Momchev
11 z klas
SMG
*/
#include <stdio.h>

#define N 100001
#define M 200001

int n,k;
int par[N];
int path[N];
int mass[N];
int deg[N];

int cur;

int isin[N];
int queue[M], qb, qe;
void qpush(int a)
{
  queue[qe]=a;
  qe = (qe+1)%M;
  isin[a] = 1;
}
int qpop(void)
{
  isin[qb] = 0;
  int a = queue[qb];
  qb = (qb+1)%M;
  return a;
}

void scan(void)
{
  par[0] = -1;
  path[0] = -1;

  scanf("%d %d\n", &n, &k);

  for(int i=0; i<n-1; i++)
  {
    int x,y,z,t;
    scanf("%d %d %d %d\n", &x, &y, &z, &t);
    x--;
    y--;
    par[x] = y;
    mass[x] = z;
    path[x] = t;
    isin[y] = 1;
    deg[y] ++;
  }

  for(int i=0; i<n; i++)
  {
    if(!isin[i])
      qpush(i);
    else
      isin[i] = 0;
  }
}

void doit()
{
  for(int v = qpop();v!=0; v = qpop())
  {
    cur += path[v]*(mass[v]/k);
    if(mass[v]%k!=0)
      cur+=path[v];
      
    mass[par[v]] += mass[v];
    deg[par[v]]--;

    if(!deg[par[v]])
      qpush(par[v]);
  }
}

int main(void)
{
  freopen("comp.inp", "r", stdin);
  freopen("comp.out", "w", stdout);

  scan();
  doit();

  printf("%d\n", 2*cur);
  
  fclose(stdin);
  fclose(stdout);
  return 0;
}
