/*
Nikola Momchev Momchev
11 z klas
SMG
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define N 21
#define M 700

#define max(a,b) ((a>b)?a:b)
#define min(a,b) ((a<b)?a:b)

int n;

int rp;
int res[M][N];
int mass[M];
int prev[M];

int queue[M], qb, qe;
void qpush(int a)
{
  queue[qe]=a;
  qe = (qe+1)%M;
}
int qpop(void)
{
  int a = queue[qb];
  qb = (qb+1)%M;
  return a;
}

int stack[N], sp;
void push(int a)
{
  stack[sp++] = a;
}
int pop(void)
{
  return stack[--sp];
}

void foo(int sum, int a)
{
  if(sum==n)
  {
    for(int i=0; i<sp; i++)
      res[rp][stack[i]-1]++;
    rp++;
  }
  else
    for(int i=a; i>0; i--)
    {
      if(i+sum<=n)
      {
        push(i);
        foo(sum+i, i);
        pop();
      }
    }
}

int beg, end;
int bmass[N];

int cmp(const void* a, const void *b)
{
  return (*(int*)a)-(*(int*)b);
}

void scan(void)
{
  char c;
  int x;

  for(scanf("%d%c", &x, &c); c=='+'; scanf("%d%c", &x, &c))
    push(x);
  push(x);

  memset(bmass, 0, sizeof(bmass));
  for(int i=0; i<sp; i++)
    bmass[stack[i]-1]++;

  for(int i=0; i<rp; i++)
  {
    if(memcmp(bmass, res[i], sizeof(bmass))==0)
    {
      beg = i;
      break;
    }
  }

  sp = 0;
  for(scanf("%d%c", &x, &c); c=='+'; scanf("%d%c", &x, &c))
    push(x);
  push(x);

  memset(bmass, 0, sizeof(bmass));
  for(int i=0; i<sp; i++)
    bmass[stack[i]-1]++;

  for(int i=0; i<rp; i++)
  {
    if(memcmp(bmass, res[i], sizeof(bmass))==0)
    {
      end = i;
      break;
    }
  }
}

int areneigh(int x, int y)
{
  int huj=0;
  for(int i=0; i<n; i++)
    huj += max(res[x][i], res[y][i])-min(res[x][i], res[y][i]);

  return huj==3;
}

int doit()
{
  for(int a=beg; a!=end; a=qpop())
  {
    for(int i=0; i<rp; i++)
    {
      if(areneigh(a,i) && (mass[i]==0 && i!=beg) )
      {
        mass[i] = mass[a]+1;
        prev[i] = a;
        qpush(i);
      }
    }
  }
}

int print(int a)
{
  int flag = 0;
  for(int i=0; i<n; i++)
  {
    for(int j=0; j<res[a][i]; j++)
    {
      if(flag)
      {
        printf("+");
      }
      else
        flag = 1;

      printf("%d",i+1);
    }
  }
  printf("\n");
}

int main(void)
{
  freopen("sums.inp", "r", stdin);
  freopen("sums.out", "w", stdout);

  scanf("%d\n", &n);

  foo(0, n);
  scan();
  doit();
  sp = 0;

  for(int i=end; i!=beg; i=prev[i])
    push(i);
  push(beg);

  printf("%d\n", mass[end]);
  for(int i=pop(); sp!=0; i=pop())
    print(i);
  print(end);

  
  fclose(stdin);
  fclose(stdout);
  return 0;
}
