{
 Veselin Anreiv Georgiev
 Stara Zagora
 }

{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 65520,0,655360}

const infile = 'sums.inp';
     outfile = 'sums.out';

type  arr   = array [1..40] of byte;
      ttype = record
              a : arr;
              l : byte;
              end;
      trace = array [1..40] of ttype;

var N : integer;
    a,b   : ttype;
    s1,s2 : string;
    c     : trace;
    sav   : trace;
    clk0  : longint absolute 0:$046C;
    clk   : longint;


Procedure InX;
 var t : text;
 begin
 assign(t, infile);
 reset(t);
 readln(t,n);
 readln(t,s1);
 readln(t,s2);
 close(t);
 end;

procedure trim(var s : string);
 var i : byte;
 begin
 for i:=1 to length(s) do if
  not (s[i] in ['0'..'9','+']) then
   begin
   delete(s,i,1);
   exit;
   end;
 end;

procedure convert;
 procedure doconvert(s : string;var l : byte;var a : arr);
  var d : integer;
  begin
  while length(s)>=2 do
   begin
   inc(l);
   val(copy(s,1,pos('+',s)-1),a[l],d);
   delete(s,1,pos('+',s));
   end;
  inc(l);
  val(s,a[l],d);
  end;

 var i : integer;
 begin
 for i:=1 to 20 do
  begin
  trim(s1);
  trim(s2);
  end;
 doconvert(s1,a.l,a.a);
 doconvert(s2,b.l,b.a);
 end;

Procedure sw(var a , b : byte);
 var  c : byte;
 begin
 c:=a;
 a:=b;
 b:=c;
 end;

 Procedure sort1(var a : arr;l : byte);
  var i,d : byte;
        f : boolean;
  begin
  d := l -1;
  repeat
  f:=FALSE;
  for i:=1 to d do if a[i]<a[i+1] then
   begin
   sw(a[i],a[i+1]);
   f := TRUE;
   end;
  dec(d);
  until not f;
  end;


Procedure sort;
 begin
 sort1(a.a,a.l);
 sort1(b.a,b.l);
 end;

Procedure Out0;
 var t : text;
 begin
 assign(t, outfile);
 rewrite(t);
 writeln(t, 0);
 close(t);
 halt(0);
 end;

Procedure OutX(level : byte);
 var t : text;
     i,j : byte;
     k : ttype;
 begin
 assign(t, outfile);
 rewrite(t);
 writeln(t,levEL-1);
 writeln(t,s1);
 for i:=2 to level - 1 do
  begin
  k:=c[i];
  sort1(k.a,k.l);
  for j:=1 to k.l-1 do write(t,k.a[j],'+');
  writeln(t, k.a[k.l]);
  end;
 writeln(t,s2);
 close(t);
 halt(0);
 end;


Function eq(var a,b : TType) : boolean;
 var c1,c2 : array [0..40] of byte;
     i     : byte;
 begin
 eq:=FALSE;
 if a.l <> b.l then exit;
 fillchar(c1,sizeof(c1),0);
 fillchar(c2,sizeof(c2),0);
 for i:=1 to a.l do inc(c1[a.a[i]]);
 for i:=1 to b.l do inc(c2[b.a[i]]);
 for i:=1 to 20 do if c1[i]<>c2[i] then exit;
 eq := TRUE;
 end;


Procedure Op_Split(index,num : byte);
 begin
 inc(a.l);
 a.a[a.l]:=a.a[index] - num;
 a.a[index]:=num;
 end;

Procedure OP_add(i1,i2 : byte);
 var i : byte;
 begin
 inc(a.a[i1],a.a[i2]);
 for i:=i2 to a.l-1 do a.a[i]:=a.a[i+1];
 dec(a.l);
 end;

Procedure badsolution;
 var l,i : byte;
 begin
 fillchar(a,sizeof(a),0);
 fillchar(b,sizeof(b),0);
 convert;
 sort;
 l:=0;
 while a.l>1 do
  begin
  inc(l);
  c[l]:=a;
  op_add(1,2);
  end;
 for i:=1 to b.l-1 do
  begin
  inc(l);
  c[l]:=a;
  op_split(1,a.a[1]-b.a[i]);
  end;
 outx(l+1);
 end;


var maxlev : byte;

Procedure Bt(lev : byte);
 var i,j,f : integer;
 begin
 if clk0 - clk > 17 then badsolution;
 if eq(a,b) then outX(lev);
 if lev>maxlev then exit;
 c[lev]:=a;
 f:=a.l;
 for i:=1 to f do
  for j:=1 to a.a[i]-1 do
  begin
  op_split(i,j);
  bt(lev + 1);
  a:=c[lev];
  end;
 for i:=1 to f - 1 do
  for j:= i + 1 to f do
   begin
   OP_add(i,j);
   bt(lev + 1);
   a:=c[lev];
   end;

 end;

Procedure DoWork;
 var i : integer;
 begin
 convert;
 sort;
 if eq(a,b) then out0;
 for i:=1 to 20 do
  begin
  maxlev:=i;
  bt(1);
  end;

 end;

BEGIN
clk:=clk0;
InX;
Dowork;
END.
