{Marin Nozhchev, Stara Zagora}

const
 ifn = 'comp.inp';
 ofn = 'comp.out';
 maxn = 100010;

type
 TVinfo =
  record
   vn, f, bc, ds : longint;
  end;
var
 t : text;
 bc, ans, n, k : longint;
 vs : array [1 .. maxn] of TVinfo;
 tg : array [0 .. maxn] of longint;

procedure input;
var
 a, b, c, d, i : longint;

begin
 assign (t, ifn);
 reset (t);
 readln (t, n, k);
 with vs[1] do
  begin
   vn := 1;
   f := 0;
   bc := 0;
   ds := 0;
  end;

 for i := 1 to n-1 do
  begin
   readln (t, a, b, c, d);
   vs[a].f := b;
   vs[a].vn := a;
   vs[a].bc := c;
   vs[a].ds := d;
  end;

 close (t);
end;

procedure sort (l, r : longint);
var
 i, j : longint;
 k, c : TVinfo;

begin
 i := l;
 j := r;
 k := vs[(l+r) div 2];

 repeat
  while vs[i].f < k.f do inc (i);
  while k.f < vs[j].f do dec (j);
  if i <= j then
   begin
    c := vs[i];
    vs[i] := vs[j];
    vs[j] := c;
    inc (i);
    dec (j);
   end;
 until i > j;

 if i < r then sort(i, r);
 if l < j then sort (l, j);
end;

procedure filltg;
var
 i, j : longint;

begin
 tg[0] := 1;
 j := 0;
 for i := 1 to n do
   if vs[i].f <> j then
    begin
     j := vs[i].f;
     tg[j] := i;
    end;
end;

function process (f, v : longint; var bc : longint) : longint;
var
 y, i, c, x : longint;

begin
 bc := vs[v].bc;
 c := 0;
 i := tg[vs[v].vn];

 if i > 0 then
  while (i <=n) and (vs[i].f = vs[v].vn) do
   begin
    y := process (v, i, x);
    if x > 0 then
     begin
      bc := bc + x;
      c := c + y;
     end;
    inc (i);
   end;

 x := bc div k;
 if bc mod k > 0 then
  inc (x);

 process := c + 2*x*vs[v].ds;
end;

procedure output;
var
 i : longint;

begin
 assign (t, ofn);
 rewrite (t);
 writeln (t, ans);
 close (t);
end;

begin
 input;
 sort (1, n);
 filltg;
 ans := process (0, 1, bc);
 output;
end.
