{Marin Nozhchev, Stara Zagora}

const
 ifn = 'sums.inp';
 ofn = 'sums.out';
 ranl = 1000;
 hs = 199999;
 eln = 100000;
 hv = 19;

type
 tarr =
  record
   l : byte;
   d : array [1 .. 20] of byte;
  end;

 tlist =
  record
   x : tarr;
   nx : longint;
  end;

var
 t : text;
 hel, al, maxl, n : longint;
 a, st, dest, sdest : tarr;
 ans : array [1 .. ranl] of tarr;
 h : array [0 .. hs] of longint;
 el : array [1 .. eln] of tlist;

procedure s2arr (var s : string; var a : Tarr);
var
 p : longint;
 c : string;
 cd : integer;

begin
 while s <> '' do
  begin
   inc (a.l);
   p := pos('+', s);
   if p = 0 then p := length(s)+1;
   c := copy (s, 1, p-1);
   val (c, a.d[a.l], cd);
   if cd > 0 then
    writeln (n, ' in error');
   delete(s,1,p);
  end;
end;

procedure sort (var a : Tarr);
var
 i, j : longint;
 c : byte;

begin
 with a do
 for i := l downto 2 do
  for j := 2 to l do
   if d[j] < d[j-1] then
    begin
     c := d[j];
     d[j] := d[j-1];
     d[j-1] := c;
    end;
end;


procedure input;
var
 i : longint;
 s : string;

begin
 assign (t, ifn);
 reset (t);
 readln (t, n);
 readln (t, s);
 s2arr (s, st);
 readln (t, s);
 s2arr (s, dest);
 sdest := dest;
 sort (sdest);
 close (t);
end;

procedure output (b : boolean);
var
 i, j : longint;

begin
 al := maxl-1;
 assign (t, ofn);
 rewrite (t);
 if not b then
  writeln (t, 0)
 else
  begin
   writeln (t, al);

    with st do
     begin
      write (t, d[1]);
      for j := 2 to l do
       write (t, '+', d[j]);
      writeln (t);
     end;

   for i := 2 to al+1 do
    with ans[i] do
     begin
      write (t, d[1]);
      for j := 2 to l do
       write (t, '+', d[j]);
      writeln (t);
     end;
  end;
 close (t);
 halt (0);
end;

function eq (var a,b : tarr): boolean;
var
 i : longint;

begin
 eq := false;
 if a.l <> b.l then
  exit;
 for i := 1 to a.l do
  if a.d[i] <> b.d[i] then
   exit;
 eq := true;
end;

procedure bt (l : longint);
var
 k, i, j, x, y : longint;
 m : tarr;

begin
 if l > maxl then
  exit;

 sort (a);

 ans[l] := a;
 if eq(a, sdest) then
  output (true);

 x := 0;
 for i := 1 to a.l do
  x := (x*hv + a.d[i]) mod hs;

 y := h[x];
 while y <> 0 do
  begin
   if eq(el[y].x, a) then exit;
   y := el[y].nx;
  end;

 if hel < eln then
  begin
   inc (hel);
   el[hel].x := a;
   el[hel].nx := h[x];
   h[x] := hel;
  end;

 if l = maxl then
  exit;
 m := a;

 if a.l >= sdest.l then
 for i := 1 to a.l do
  for j := i+1 to a.l do
   begin
    x := a.d[i];
    y := a.d[j];
    a.d[i] := x+y;
    a.d[j] := a.d[a.l];

    dec (a.l);
    bt (l+1);

    a := m;
   end;


 if a.l <= sdest.l then
 for i := 1 to a.l do
    for j := 1 to a.d[i]-1 do
     begin
      inc (a.l);
      a.d[a.l] :=j;
      a.d[i] := a.d[i]-j;
      bt (l+1);
      a := m;
     end;
end;

begin
 input;
 a := st;
 sort (a);
 if eq (a, sdest) then
  output (false);
 for maxl := abs(sdest.l - a.l) to ranl do
  begin
   fillchar (h, sizeof (h), 0);
   hel := 0;
   bt (1);
  end;
end.
