{ Ruslan Velkov, Stara Zagora }
Program Sums;
Uses DOS;
Const max_num = 19;
Type SumType     = Array[1..max_num] of Byte;
     SumListPtr  = ^SumListType;
     SumListType = Record
                     s: SumType;
                     next: SumListPtr
                   End;
     StringPtr   = ^String;
     TimeRec     = Record
                     h,m,s,s1: Word;
                   End;
Const inp_file = 'SUMS.INP';
      out_file = 'SUMS.OUT';
Var f: Text; n,i,j,sol_cnt: Byte;
    slst,spos,prev: SumListPtr;
    s1,s2: ^SumType;
    s,sol: StringPtr;
    hp: Pointer;
    ch: Char;
    t1,t2: TimeRec;

  Function ExtractNum(Var s: String; z: Byte): Byte;
  Var ss,sn: String; i: Integer; v: Byte;
  Begin
    ss:=''; sn:='0123456789';
    While (s<>'') and (Pos(s[1],sn)>0) do
      Begin ss:=ss+s[1]; Delete(s,1,1) End;
    If z=1 then Delete(s,1,1);

    Val(ss,v,i);
    ExtractNum:=v
  End;

  Function Match(s1,s2: SumType): Boolean;
  Var i: Byte; b: Boolean;

  Begin
    b:=true;
    For i:=1 to max_num do b:=b and (s1[i]=s2[i]);
    Match:=b
  End;

  Function String_of(b: Byte): String;
  Var s: String;
  Begin
    Str(b,s); String_of:=s
  End;

  Function Exist(ss: SumListPtr): Boolean;
  Var b: Boolean; sp: SumListPtr;
  Begin
    b:=false;
    sp:=slst;
    While not b and (sp<>ss) do
      Begin
        b:=b or Match(sp^.s,ss^.s);
        sp:=sp^.next
      End;
    Exist:=b
  End;

  Function CountSol(s: String): Byte;
  Var i,j: Byte;
  Begin
    j:=0;
    For i:=1 to length(s) do
      If s[i]=';' then Inc(j);
    CountSol:=j
  End;

  Function Up(s1,s2: SumType): Boolean;
  Var i: Byte; b: Boolean;
  Begin
    b:=false;
    For i:=1 to max_num do
      b:=b or ((s2[i]>0) and (s1[i]>s2[i]));
    Up:=b
  End;

  Function RunTime: Real;
  Var l: LongInt;
  Begin
    With t2 do GetTime(h,m,s,s1);
    If t2.s1<t1.s1 then
      Begin l:=t2.s1+100-t1.s1; Inc(t1.s) End Else l:=t2.s1-t1.s1;
    If t2.s<t1.s then
      Begin Inc(l,(t2.s+60-t1.s)*100); Inc(t1.m) End Else Inc(l,(t2.s-t1.s)*100);
    If t2.m<t1.m then
      Begin Inc(l,(t2.m+60-t1.m)*6000); Inc(t1.h) End Else Inc(l,(t2.m-t1.m)*6000);
    If t2.h<t1.h then
      Inc(l,(t2.h+24-t1.h)*6000*24) Else Inc(l,(t2.h-t1.h)*6000*24);
    RunTime:=l/100
  End;

  Function Solution(i: Byte; s: StringPtr; spos,prev: SumListPtr): Boolean;
  Var j,k: Byte; b: Boolean; ss: StringPtr;
  Begin
    If RunTime>5 then Exit;

    New(ss);
    ss^:=s^; s:=ss;
    Solution:=true;
    prev:=spos;

    If Match(s1^,s2^) then
      Begin
        j:=CountSol(s^);
        If j<sol_cnt then Begin sol^:=s^; sol_cnt:=j End;
        Exit
      End;

    New(spos^.next);
    FillChar(spos^.next^,SizeOf(spos^),$00);
    spos^.next^.s:=spos^.s;
    spos:=spos^.next;

    For j:=2 to max_num do
      If (s1^[j]>0) and (s1^[j]>s2^[j]) then
        Begin
          Dec(s1^[j]);
          For k:=1 to j div 2 do
            Begin
              If RunTime>5 then Exit;


              Inc(s1^[k]);
              Inc(s1^[j-k]);
              spos^.s:=s1^;
              If not Exist(spos) and not Up(s1^,s2^) and
                 ((s2^[k]>0) and (s1^[k]<=s2^[k]) or (s2^[k]=0)) and
                 ((s2^[j-k]>0) and (s1^[j-k]<=s2^[j-k]) or (s2^[j-k]=0)) then
                Begin
                  s^:=s^+String_of(j)+'-'+String_of(k)+';';
                  Solution:=Solution(i+1,s,spos,prev);
                  Delete(s^,length(s^),1);
                  While (s^<>'') and (s^[length(s^)]<>';') do
                    Delete(s^,length(s^),1)
                End;
              Dec(s1^[k]);
              Dec(s1^[j-k])
            End;
          Inc(s1^[j])
        End;
    For j:=1 to max_num-1 do
      If s1^[j]>s2^[j] then
        For k:=j to max_num do
          If (j=k) and (s1^[k]>s2^[k]) or
             (j<>k) and (s1^[k]>s2^[k]) and (j+k<=max_num) then
            Begin
              If RunTime>5 then Exit;

              Dec(s1^[j]);
              Dec(s1^[k]);
              Inc(s1^[j+k]);
              spos^.s:=s1^;
              If not Exist(spos) and not Up(s1^,s2^) then
                Begin
                  s^:=s^+String_of(j)+'+'+String_of(k)+';';
                  Solution:=Solution(i+1,s,spos,prev);
                  Delete(s^,length(s^),1);
                  While (s^<>'') and (s^[length(s^)]<>';') do
                    Delete(s^,length(s^),1)
                End;
              Dec(s1^[j+k]);
              Inc(s1^[j]);
              Inc(s1^[k])
            End;

    Release(spos);
    Release(ss);
    prev^.next:=nil;
    Solution:=false
  End;

Begin
  Mark(hp);
  With t1 do GetTime(h,m,s,s1);

  New(slst); spos:=slst; sol_cnt:=$FF;
  New(s); s^:='';
  New(sol); sol^:='';
  New(s1); New(s2);
  FillChar(spos^,SizeOf(spos^),$00);
  FillChar(s1^,SizeOf(s1^),$00);
  FillChar(s2^,SizeOf(s2^),$00);

  Assign(f,inp_file); Reset(f);
  ReadLn(f,n);
  ReadLn(f,s^);
  While s^<>'' do Inc(s1^[ExtractNum(s^,1)]);
  ReadLn(f,s^);
  While s^<>'' do Inc(s2^[ExtractNum(s^,1)]);
  Close(f);
  spos^.s:=s1^;

  If Solution(0,s,spos,nil) then;

  s1^:=spos^.s;
  Assign(f,out_file); Rewrite(f);
  WriteLn(f,sol_cnt);
  While sol^<>'' do
    Begin
      s^:='';
      For i:=1 to max_num do
        For j:=1 to s1^[i] do s^:=s^+String_of(i)+'+';
      Delete(s^,length(s^),1);
      WriteLn(f,s^);

      i:=ExtractNum(sol^,0);
      ch:=sol^[1]; Delete(sol^,1,1);
      j:=ExtractNum(sol^,1);

      If ch='+' then
        Begin
          Dec(s1^[i]);
          Dec(s1^[j]);
          Inc(s1^[i+j])
        End Else
        Begin
          Dec(s1^[i]);
          Inc(s1^[j]);
          Inc(s1^[i-j])
        End
    End;
  s^:='';
  For i:=1 to max_num do
    For j:=1 to s1^[i] do s^:=s^+String_of(i)+'+';
  Delete(s^,length(s^),1);
  WriteLn(f,s^);

  Close(f);

  Release(hp)
End.
