/* Ivan Nikolaev Penev - Varna */

#include <stdio.h>
#include <string.h>

#define MAXL 80
#define MAXN 9
#define MAXM 30

        FILE *f,*f2;
        int alpha[MAXM+1][MAXN+1]={0};
        int beta[MAXM+1][MAXN+1]={0};
        int delta[MAXM+1][MAXM+1][MAXN+1]={0};
        int gamma[(MAXM+1)*(MAXM+1)][MAXN+1]={0};
        char p1[MAXL+6],p2[MAXL+6],p[MAXL+6];
        int k1,k2,n,i,m;

/*        void read1 (void) {

            int i,j,m;

            fscanf (f,"%d %d %d",&n,&k1,&k2);
            for (i=1; i<=k1; i++)
            	for (m=1; m<=n; m++) fscanf (f,"%d ",&alpha[i][m]);

            for (j=1; j<=k2; j++)
            	for (m=1; m<=n; m++) fscanf (f,"%d ",&beta[j][m]);
        }
        void write1 (void) {

        	int i,j,m;

            for (i=1; i<=k1; i++) {
            	for (j=1; j<=k2; j++) {
                	for (m=1; m<=MAXN; m++)
                    	fprintf (f,"%d ",delta[i][j][m]);
                    fprintf (f,"     ");
                }
                fprintf (f,"\n");
            }
        }
*/

        void solve (void) {

        	int i,j,m;

            for (i=1; i<=k1; i++)
            	for (j=1; j<=k2; j++)
                	for (m=1; m<=MAXN; m++)
                    	delta[i][j][m]=alpha[i][m]+beta[j][m];
        }

        void init_matrix (void) {

        	int k,l;
            char ch;

            fgets (p1,MAXL+2,f);
            l=strlen(p1)-1;
            p1[l]=p1[l+1]=p1[l+2]=p1[l+3]='\0';
            k=0; i=1;
            while (p1[k])
            	if (p1[k]=='x') {
                	k=k+1; ch=p1[k];
                    alpha[i][ch-'0']=1;
                    if (p1[k+1]=='\0') break;
                    if (p1[k+1]=='^') {
                    	alpha[i][ch-'0']+=p1[k+2]-'0'-1;
                        k=k+4;
                    } else k=k+2;
                    if (p1[k]=='\0') break;
                    if (p1[k]=='+') { i++; k=k+2; }
                }
            k1=i;

            fgets (p2,MAXL+2,f);
            l=strlen(p2)-1;
            p2[l]=p2[l+1]=p2[l+2]=p2[l+3]='\0';
            k=0; i=1;
            while (p2[k])
            	if (p2[k]=='x') {
                	k=k+1; ch=p2[k];
                    beta[i][ch-'0']=1;
                    if (p2[k+1]=='\0') break;
                    if (p2[k+1]=='^') {
                    	beta[i][ch-'0']+=p2[k+2]-'0'-1;
                        k=k+4;
                    } else k=k+2;
                    if (p2[k]=='\0') break;
                    if (p2[k]=='+') { i++; k=k+2; }
                }
            k2=i;

        }

        void product (void) {

        	int i,j,m,k=0,l;

            p[0]='\0';
        	for (i=1; i<=k1; i++)
            	for (j=1; j<=k2; j++) {
                	for (m=1; m<=MAXN; m++)
                    	if (delta[i][j][m]) {
                    		p[k++]='x'; p[k++]=m+'0';
                            if (delta[i][j][m]>1) {
                            	p[k++]='^';
                                if (delta[i][j][m]>9)
                                	p[k++]=delta[i][j][m]/10+'0';
                                p[k++]=delta[i][j][m]%10+'0';

                            }
                        	p[k++]=' ';
                         }
                         p[k++]='+'; p[k++]=' '; p[k]='\0';
                     }
            l=strlen (p)-1;
            while (p[l]==' ' || p[l]=='+') { p[l]='\0'; l=strlen (p)-1; }
        }

        int less (int m1[MAXN+1], int m2[MAXN+1]) {

        	int i,s1,s2;

            i=0;
            do i++; while (m1[i]==m2[i] && i<MAXN);
            if (m1[i]>m2[i]) return 1;
            else if (m1[i]<m2[i]) return -1;
            	 else {
                 	s1=s2=0;
                    for (i=1; i<=MAXN; i++) { s1+=m1[i]; s2+=m2[i]; }
                    if (s1>s2) return 1;
                    else if (s1<s2) return -1;
                    		else return 0;
                 }
        }

        void sort (void) {

        	int i,j,ind;
            int min[MAXN+1],buf[MAXN+1];

            for (i=1; i<k1*k2; i++) {
                for (m=1; m<=MAXN; m++) min[m]=gamma[i][m];
                ind=i;
            	for (j=i+1; i<=k1*k2; j++)
                	if (less (gamma[j],min)) {
                    	for (m=1; m<=MAXN; m++) min[m]=gamma[j][m];
                        ind=j;
                    }
                for (m=1; m<=MAXN; m++) buf[m]=gamma[i][m];
                for (m=1; m<=MAXN; m++) gamma[i][m]=min[m];
                for (m=1; m<=MAXN; m++) gamma[ind][m]=buf[m];
            }
        }

        void to_vector (void) {

        	int i,j,k=0,m;

            for (i=1; i<=k1; i++)
            	for (j=1; j<=k2; j++) {
                	k++;
                    for (m=1; m<=MAXN; m++) gamma[k][m]=delta[i][j][m];
                }
        }

        void to_matrix (void) {

        	int i,j,k=0,m;

            for (i=1; i<=k1; i++)
            	for (j=1; j<=k2; j++) {
                	k++;
                    for (m=1; m<=MAXN; m++) delta[i][j][m]=gamma[k][m];
                }
        }

        int main (void) {

        	f=fopen ("poly.inp","rt");
            init_matrix ();
            fclose (f);

       		/*f=fopen ("poly2.inp","rt");
            read1 ();
            fclose (f);*/
            solve ();
            /*to_vector ();
            sort ();
            to_matrix ();*/
            product ();
            f=fopen ("poly.out","wt");
            /*for (i=1; i<=k1; i++) {
            	for (m=1; m<=MAXN; m++) if (alpha[i][m])
            		fprintf (f,"%d: %d ",m,alpha[i][m]);
                fprintf (f,"\n");
            }
            for (i=1; i<=k1; i++) {
            	for (m=1; m<=MAXN; m++) if (beta[i][m])
            		fprintf (f,"%d: %d ",m,beta[i][m]);
                fprintf (f,"\n");
            }*/

         	fputs (p,f);
            fclose (f);

            return 0;
        }
