// Slavi Marinov Marinov Varna

#include <stdio.h>
#include <string.h>
#include <vector>
#include <queue>

#define inp     "comp.inp"
#define out     "comp.out"

#define MAX 200001
#define PREC 0.000001

long int n,k;
long int pcs[MAX];
vector<int> m[MAX];
long int price[MAX];
long int sum[MAX];
char visited[MAX];
long int parent[MAX];
char pushed[MAX];
queue<int> q;
int total=0;

int dfs1 (int v) {
int i;
     if (visited[v]==1) return 0;
     visited[v]=1;
     sum[v]=pcs[v];
     for (i=0;i<m[v].size();i++) {
         sum[v]+=dfs1(m[v][i]);
     }
     return sum[v];
}

void init() {
long int i,num,father,pc,len;
     FILE *f = fopen ( inp , "r" );
     fscanf(f,"%d %d",&n,&k);
     for (i=1;i<n;i++) {
         fscanf(f,"%d %d %d %d",&num,&father,&pc,&len);
         m[father].push_back(num);
         parent[num]=father;
         pcs[num]=pc;
         price[num]=len;
     }
     fclose(f);
     memset(visited,0,sizeof(visited));
}

int OK(int ver) {
int i;
    if (pushed[ver]) return 0;
    for (i=0;i<m[ver].size();i++)
        if (pushed[m[ver][i]]==0) return 0;
    return 1;
}

void solve() {
long int i,x,p;
double tmp1;
long int tmp2;
     for (i=1;i<=n;i++)
         if (m[i].size()==0) {
            q.push(i);
         }
     for (i=1;i<=n;i++)
         if (sum[i]=pcs[i]) {
            q.push(i);
         }

     while (!q.empty()) {
           x=q.front();
           q.pop();
           if (pcs[x]!=0) {
              if (OK(x)) {
                  pushed[x]=1;
                  p=parent[x];
                  if(!pushed[p]) q.push(p);
                  pcs[p]+=pcs[x];
                  tmp1=double(pcs[x])/k;
                  tmp2=pcs[x]/k;
                  if (tmp1-tmp2>PREC) tmp2++;
                  total+=tmp2*2*price[x];
              }
           } else pushed[x]=1;
     }
}

void output() {
     FILE* f = fopen ( out, "w");
     fprintf(f,"%ld\n",total);
     fclose(f);
}

int main () {
    init();
    sum[1]=dfs1(1);
    solve();
    output();
    return 0;
}
