/*
NAME   : Valentin Stoianov Mihov
CLASS  : 11/12
CITY   : Varna
TASK   : STIR
*/

#include <stdio.h>
#include <string.h>
#define INPF "stir.inp"
#define OUTF "stir.out"
#define MAXN 120

int pos[MAXN],n;
int sol[MAXN];
int used[MAXN];

void Init()
  {
    FILE *f=fopen(INPF,"rt");
    fscanf(f,"%d",&n);
    for(int i=0;i<n-1;i++)
      fscanf(f,"%d",&pos[i]);
    pos[n-1]=0;
    fclose(f);
  }

void Output()
  {
    FILE *f=fopen(OUTF,"wt");
    for(int i=0;i<n-1;i++)
      fprintf(f,"%d ",sol[i]);
    fprintf(f,"%d\n",sol[n-1]);
    fclose(f);
    exit(0);
  }

void Find(int p)
  {
    int br;
    if(p==-1)
      Output();
    for(int i=n;i>=pos[p]+1;i--)
      if(!used[i])
        {
          br=0;
          for(int j=p+1;j<n;j++)
            if(sol[j]<i) br++;
          if(br==pos[p])
            {
              sol[p]=i;
              used[i]=1;
              Find(p-1);
              used[i]=0;
            }
        }
  }

void main()
  {
    Init();
    Find(n-1);
  }
