//Anton Simov Babadjanov, 10 klas, Bourgas
#include <fstream.h>
#include <math.h>
#include <stdlib.h>

long int min(long int i, long int j)
{
	 return ( (i < j) ? i : j);
}

int main()
{
	fstream fin, fout;
	int h, v;
	int i, j, t;
	long int *x1, *x2, *y1, *y2;
	double *dist;
	int n;

	fin.open("dist.inp", ios::in);
	fout.open("dist.out", ios::out);
	fin >> n;

	x1 = new long int[n];
	x2 = new long int[n];
	y1 = new long int[n];
	y2 = new long int[n];
	dist = new double[n];


	for (i = 0; i < n; i++)
		fin >> x1[i] >> y1[i] >> x2[i] >> y2[i];


	for (i = 0; i < n; i++)
	{
		dist[i] = 0;
		for (j = 0; j < n; j++)
		{
			if (j==i)
				continue;

			h = 0;
			v = 0;

			if ( (x1[i] <= x1[j] && x1[j] <= x2[i]) ||
					 (x1[i] <= x2[j] && x2[j] <= x2[i]) ||
					 (x1[j] <= x1[i] && x2[i] <= x2[j]) )
					h = 1;

			if ( (y1[i] <= y1[j] && y1[j] <= y2[i]) ||
					 (y1[i] <= y2[j] && y2[j] <= y2[i])	||
					 (y1[j] <= y1[i] && y2[i] <= y2[j]) )
					v = 1;

			if (h & v)
				dist[i] = 0;
			else if (h)
			{
				t = min( min( min(abs(y1[i]-y1[j]), abs(y2[i]-y1[j])) , abs(y1[i]-y2[j]) ) , abs(y2[i]-y2[j]) );
					dist[j] = t;
			}
			else if (v)
			{
				t = min( min( min(abs(x1[i]-x1[j]), abs(x2[i]-x1[j])) , abs(x1[i]-x2[j]) ) , abs(x2[i]-x2[j]) );
					dist[j] = t;
			}
			else
			{
				h = min( min( min(abs(x1[i]-x1[j]), abs(x2[i]-x1[j])) , abs(x1[i]-x2[j]) ) , abs(x2[i]-x2[j]) );
				v = min( min( min(abs(y1[i]-y1[j]), abs(y2[i]-y1[j])) , abs(y1[i]-y2[j]) ) , abs(y2[i]-y2[j]) );
					dist[j] = sqrt(pow(h,2)+pow(v,2));
			}
		}

		if (!i)
		{
			t=1;
			h=1;
		}
		else
		{
			t=0;
			h=0;
		}

		for (j = 0; j < n; j++)
		{
			if (j==i)
				continue;
			if (dist[j] < dist[t])
				t = j;
			if (dist[j] > dist[h])
				h = j;
		}

		fout << t+1 << " ";

		for (j = t+1; j < n; j++)
		{
			if (j==i)
				continue;

			if (dist[j] == dist[t])
				fout << j+1 << " ";
		}

		do
		{
			v = t;
			for (j = 0; j < n; j++)
			{
				if (j==i)
					continue;
				if (dist[v] < dist[j])
				{
					if (v == t)
						t = j;
					else
						if (dist[j] < dist[t])
							t = j;
				}
			}

			if (v!=t)
				fout << t+1 << " ";

			for (j = t+1; j < n; j++)
			{
				if (j==i)
					continue;
				if (dist[j] == dist[t])
					fout << j+1 << " ";
			}
		} while (t!=h);

		fout << endl;
	}

	delete [] x1;
	delete [] x2;
	delete [] y1;
	delete [] y2;
	delete [] dist;
	fin.close();
	fout.close();

	return 0;
}
