{Alexander Plamenow Dimitrow, 11 klas, Dobrich}
const
  nMax=100000;
  FinStr='comp.inp';
  FoutStr='comp.out';
Type
  nType=0..nMax;
  Tvzel=
        record
          comps, len, lenHere, numNasl, father:LongInt;
          used:boolean;
        End;
  TGraph=array[nType]of TVzel;
Var
  Graph:TGraph;
  n:nType;
  k:nType;

   procedure ReadIn;
     Var
       Fin:Text;
       i, j:nType;
     Begin
       Assign(Fin, FinStr);
       ReSet(Fin);

       ReadLn(Fin, N, K);
       with graph[1] do
        begin
          len:=0;
          comps:=0;
          father:=0;
          Used:=false;
        end;
       for i:=1 to N-1 do
        begin
          read(Fin, j);
          with Graph[j] do
           begin
             ReadLn(Fin, father, comps, len);
             Used:=false;
           end;
        end;

       Close(Fin);
     End;

   procedure NumKlons;
     var
       i, j:nType;
     Begin
       for i:=2 to n do
         Graph[Graph[i].father].NumNasl:=Graph[Graph[i].father].NumNasl+1;
     End;

   function FindListo:nType;
     var
       i:nType;
     begin
       for i:=1 to n do
         with Graph[i] do
          if (not Used) and (NumNasl=0) then
           begin
             FindListo:=i;
             EXIT;
           end;
     End;

   function TrialsForComps(num:LongInt):LongInt;
     Begin
       if num mod k =0 then
         TrialsForComps:=num div k
       else TrialsForComps:=num div k+1;
     End;

   procedure Solve;
     var
       Done:boolean;
       i:nType;
     Begin
       NumKlons;
       Done:=false;
       While not Done do
        begin
          i:=FindListo;
          if i=1 then
            Done:=true
          else
           begin
             with Graph[i] do
              begin
                Graph[father].comps:=Graph[father].comps+comps;
                Graph[father].numNasl:=Graph[father].numNasl-1;
                Graph[father].lenHere:=Graph[father].lenHere+TrialsForComps(comps)*2*len+lenHere;
                Used:=true;
              end;
           end;
        end;
     End;

   procedure Print;
     var
       Fout:Text;
     Begin
       Assign(Fout, FoutStr);
       ReWrite(Fout);

       Write(Fout,  Graph[1].lenHere);

       Close(Fout);
     End;

Begin
  ReadIn;
  Solve;
  Print;
End.