{Alexander Plamenow Dimitrow, 11 klas, Dobrich}
Const
  nMax=100;
  FinStr='stir.inp';
  FoutStr='stir.out';
Type
  nType=0..nMax;
  TRed=array[nType]of integer;
  TUsed=array[nType]of Boolean;
Var
  n:nType;
  A, B:TRed;
  Used:TUsed;

   procedure ReadIn;
     var
       Fin:Text;
       i:nType;
     Begin
       Assign(Fin, FinStr);
       ReSet(Fin);

       ReadLn(Fin, n);
       for i:=1 to n-1 do
         Read(Fin,  B[i]);

       Close(Fin);

       for i:=1 to n do
         Used[i]:=false;
     End;

   function HowManyAfter(i:nType):nType;
     var
       br, j:nType;
     Begin
       br:=0;
       for j:=i+1 to n do
         if not Used[j] then
           inc(br);

       HowManyAfter:=br;
     End;

   procedure Solve;
     var
       max, i:nType;
       MadeOne:Boolean;
     Begin
       max:=n;
       While max>0 do
        begin
          MadeOne:=false;
          for i:=1 to n-1 do
            if (HowManyAfter(i)=B[i])and(not Used[i]) then
             begin
               A[i]:=max;
               Used[i]:=true;
               dec(max);
               MadeOne:=true;
               Break;
             end;
          if not MadeOne then
            for i:=n downto 1 do
             if not Used[i] then
              begin
                A[i]:=max;
                dec(max);
                Used[i]:=true;
                Break;
              end;
        end;
     End;

   procedure Print;
     var
       Fout:Text;
       i:nType;
     Begin
       Assign(Fout, FoutStr);
       ReWrite(Fout);

       Write(Fout,  A[1]);
       for i:=2 to n do
         Write(Fout,  ' ', A[i]);

       Close(Fout);
     End;

Begin
  ReadIn;
  Solve;
  Print;
End.