#include <fstream>
#include <iostream>

using namespace std;

//#define DEBUG

#define MAXN 301
#define INF 2000000000

#define min(a,b) (((a) < (b))?(a):(b))
#define max(a,b) (((a) > (b))?(a):(b))

int start(int i, int j, int dir);

int n;
int d[MAXN];
int c[MAXN];
int sol[MAXN][MAXN][2];
int pat[MAXN][MAXN][2];
int totc[MAXN];

int main(){


  for(int i = 0; i < MAXN; i++){
    c[i] = 0;
    d[i] = 0;
    totc[i] = 0;
  }

  for(int k = 0; k < 2; k++){
    for(int i = 0; i < MAXN; i++){
     for(int j = 0; j < MAXN; j++){
       sol[i][j][k] = INF;
       pat[i][j][k] = 0;
     }
    }
  }

  ifstream in("drain.inp");
  ofstream out("drain.out");

  in >> n;

  for(int i = 1; i <= n; i++){
    in >> d[i] >> c[i];
    totc[i] = totc[i-1] + c[i];
  }
  totc[n+1] = totc[n];

  for(int i = 1; i < n; i++){
    sol[i][i+1][0] = (totc[i] + totc[n] - totc[i+1]) * (d[i+1] - d[i]);
    sol[i][i+1][1] = (totc[i-1] + totc[n] - totc[i]) * (d[i+1] - d[i]);
  }

  for(int k = 2; k < n; k++){
    for(int i = 1; i + k <= n; i++){
      int j = i+k;

      int path = 0;
      int best = INF;
      if(best > (sol[i+1][j][0] + (totc[i] + totc[n] - totc[j])*(d[i+1] - d[i]))){
        best =   sol[i+1][j][0] + (totc[i] + totc[n] - totc[j])*(d[i+1] - d[i]);
        path = 1;
      }
      if(best > (sol[i+1][j][1] + (totc[i] + totc[n] - totc[j])*(d[j] - d[i]))){
        best =   sol[i+1][j][1] + (totc[i] + totc[n] - totc[j])*(d[j] - d[i]);
        path = 2;
      }
      if(best > (sol[i][j-1][0] + (totc[i-1] + totc[n] - totc[j-1] + totc[i-1] + totc[n] - totc[j])*(d[j] - d[i]))){
        best =   sol[i][j-1][0] + (totc[i-1] + totc[n] - totc[j-1] + totc[i-1] + totc[n] - totc[j])*(d[j] - d[i]);
        path = 3;
      }
      if(best > (sol[i][j-1][1] + (totc[i-1] + totc[n] - totc[j])*(d[j] - d[i]) + (totc[i-1] + totc[n] - totc[j-1])*(d[j] - d[j-1]))){
        best =   sol[i][j-1][1] + (totc[i-1] + totc[n] - totc[j])*(d[j] - d[i]) + (totc[i-1] + totc[n] - totc[j-1])*(d[j] - d[j-1]);
        path = 4;
      }


      sol[i][j][0] = best;
      pat[i][j][0] = path;


      best = INF;
      if(best > (sol[i+1][j][0] + (totc[i] + totc[n] - totc[j])*(d[i+1] - d[i]) + (totc[i-1] + totc[n] - totc[j])*(d[j] - d[i]))){
       best =    sol[i+1][j][0] + (totc[i] + totc[n] - totc[j])*(d[i+1] - d[i]) + (totc[i-1] + totc[n] - totc[j])*(d[j] - d[i]);
       path = 5;
      }
      if(best > (sol[i+1][j][1] + (totc[i] + totc[n] - totc[j] + totc[i-1] + totc[n] - totc[j])*(d[j] - d[i]))){
        best =   sol[i+1][j][1] + (totc[i] + totc[n] - totc[j] + totc[i-1] + totc[n] - totc[j])*(d[j] - d[i]);
        path = 6;
      }
      if(best > (sol[i][j-1][0] + (totc[i-1] + totc[n] - totc[j-1])*(d[j] - d[i]))){
        best =   sol[i][j-1][0] + (totc[i-1] + totc[n] - totc[j-1])*(d[j] - d[i]);
        path = 7;
      }
      if(best > (sol[i][j-1][1] + (totc[i-1] + totc[n] - totc[j-1])*(d[j] - d[j-1]))){
        best =   sol[i][j-1][1] + (totc[i-1] + totc[n] - totc[j-1])*(d[j] - d[j-1]);
        path = 8;
      }

      sol[i][j][1] = best;
      pat[i][j][1] = path;
    }
  }

  if(sol[1][n][0] < sol[1][n][1]){

    out << sol[1][n][0] << endl;
    out << start(1,n,0) << endl;
  }
  else{

    out << sol[1][n][0] << endl;
    out << start(1,n,0) << endl;
  }
  
  
  return 0;
}

int start(int i, int j, int dir){

//#ifdef DEBUG
//  cout << ((dir == 0)? i : j )<< " ";
//#endif

  if(i + 1 == j){
    return (dir == 0) ? i : j;
  }

  switch(pat[i][j][dir])
  {
  case 1:
    start(i+1, j, 0);
    break;
  case 2:
    start(i+1, j, 1);
    break;
  case 3:
    start(i, j-1, 0);
    break;
  case 4:
    start(i, j-1, 1);
    break;
  case 5:
    start(i+1, j, 0);
    break;
  case 6:
    start(i+1, j, 1);
    break;
  case 7:
    start(i, j-1, 0);
    break;
  case 8:
    start(i, j-1, 1);
    break;
  }
}
