#include <stdio.h>

#define N 512

long long din[N][N][2];
int from[N][N][2];

int n;
int pos[N];
int debit[N];
long long sum[N];

void scan(void)
{
  scanf("%d", &n);

  for(int i=0; i<n; i++)
  {
    scanf("%d %d",&pos[i], &debit[i]);
    sum[i+1] = sum[i]+debit[i];
  }
}

void foo(int l, int r, int w)
{
  if(l==r)
  {
    from[l][l][w] = l;
    din[l][l][w] = 0;
    return;
  }

  if(din[l][r][w])
    return;

  if(w==0)
  {
    foo(l+1, r, 0);
    foo(l+1, r, 1);
    long long left = din[l+1][r][0] + (pos[l+1]-pos[l])*(sum[n]-sum[r+1]+sum[l+1]);
    long long right = din[l+1][r][1] + (pos[r]-pos[l])*(sum[n]-sum[r+1]+sum[l+1]);

    if(left<right)
    {
      din[l][r][w] = din[l+1][r][0] + (pos[l+1]-pos[l])*(sum[n]-sum[r+1]+sum[l+1]);
      from[l][r][w] = from[l+1][r][0];
    }
    else
    {
      din[l][r][w] = din[l+1][r][1] + (pos[r]-pos[l])*(sum[n]-sum[r+1]+sum[l+1]);
      from[l][r][w] = from[l+1][r][1];
    }
  }
  else
  {
    foo(l, r-1, 0);
    foo(l, r-1, 1);
    long long left = din[l][r-1][0] + (pos[r]-pos[l])*(sum[n]-sum[r]+sum[l]);
    long long right = din[l][r-1][1] + (pos[r]-pos[r-1])*(sum[n]-sum[r]+sum[l]);

    if(left<right)
    {
      din[l][r][w] = din[l][r-1][0] + (pos[r]-pos[l])*(sum[n]-sum[r]+sum[l]);
      from[l][r][w] = from[l][r-1][0];
    }
    else
    {
      din[l][r][w] = din[l][r-1][1] + (pos[r]-pos[r-1])*(sum[n]-sum[r]+sum[l]);
      from[l][r][w] = from[l][r-1][1];
    }
  }
}

int main(void)
{
  freopen("drain.inp", "r", stdin);
  freopen("drain.out", "w", stdout);

  scan();
  foo(0,n-1,0);
  foo(0,n-1,1);

  long long f = (din[0][n-1][0] < din[0][n-1][1])?0:1;
  printf("%lld\n%d\n", din[0][n-1][f], from[0][n-1][f]+1);
  
  fclose(stdin);
  fclose(stdout);
  return 0;
}
