#include <fstream>
#include <cstring>

struct hole {
  int r,d;
};

int n;
int fr,lr;
hole h[300];
ifstream fin("drain.inp");
ofstream fout("drain.out");

int straight(int s)
{
  int min=2000000000,d=0;
  // go left first
  if (s!=0)
  {
    int t=0;
    for (int i=s-1;i>=0;i--)
    {
      t+=h[i+1].r-h[i].r;
      d+=t*h[i].d;
    }
    t+=h[s].r-h[0].r;
    for (int i=s+1;i<n;i++)
    {
      t+=h[i].r-h[i-1].r;
      d+=t*h[i].d;
    }
    min=d;
  }

  // go right first
  if (s!=n-1)
  {
    int t=0;d=0;
    for (int i=s+1;i<n;i++)
    {
      t+=h[i].r-h[i-1].r;
      d+=t*h[i].d;
    }
    t+=h[n-1].r-h[s].r;
    for (int i=s-1;i>=0;i--)
    {
      t+=h[i+1].r-h[i].r;
      d+=t*h[i].d;
    }
  }

  return min<d?min:d;
}


int done[300];

int leftto(int s)
{
  while (done[s]&&(s>=0)) s--;
  return s;
}

int rightto(int s)
{
  while (done[s]&&(s<n)) s++;
  return s;
}

int choice(int s)
{
  memset(done,0,sizeof(done));
  int l,r;
  int t=0;
  int d=0;
  while (true)
  {
    done[s]=1;
    l=leftto(s);r=rightto(s);
    if ((l<0)&&(r>=n)) break;
    
    if (l<0)
    {
      t+=h[r].r-h[s].r;
      d+=t*h[r].d;
      s=r;
    }else
      if (r>=n)
      {
        t+=h[s].r-h[l].r;
        d+=t*h[l].d;
        s=l;
      }else
        if ((h[r].r-h[s].r)*h[r].d<=(h[s].r-h[l].r)*h[l].d)
        {
          t+=h[r].r-h[s].r;
          d+=t*h[r].d;
          s=r;
        }else
          if ((h[r].r-h[s].r)*h[r].d>(h[s].r-h[l].r)*h[l].d)
          {
            t+=h[s].r-h[l].r;
            d+=t*h[l].d;
            s=l;
          }
  }
  return d;
}


int greed(int &l)
{
  int s,min=2000000000;
  for (int i=0;i<n;i++)
    if ((s=straight(i))<min) {min=s;l=i;}

  for (int i=0;i<n;i++)
    if ((s=choice(i))<min) {min=s;l=i;}

  return min;
}

int main()
{
  fin >> n;
  for (int i=0;i<n;i++)
    fin >> h[i].r >> h[i].d;

  fr=h[0].r;
  lr=h[n-1].r;

  int d,s;
  d=greed(s);

  fout << d << endl << s+1 << endl;
  
  return 0;
}
