
#include <stdio.h>

#define NOT_CHECKED -200000

int n, m, nosolve = 0;
int c[1000][1000];
struct {
  int value;
  int mmh;
} g[1000];

int main(void)  {

  FILE *fp;

  int index, i, j, B, C;

  fp = fopen("work.inp", "rt");

  fscanf(fp, "%d %d", &n, &m);

  for(index = 0; index < m; index++)  {
    fscanf(fp, "%d %d %d", &i, &j, &B);
    if(i > j) {
      i=i+j-(j=i);
      B=0-B;
      nosolve = 1;
    }
    if(c[i-1][j-1])  {
      if(c[i-1][j-1] == NOT_CHECKED) C = 0;
      else C = c[i-1][j-1];
      if(nosolve) {
        i=i+j-(j=i);
        B=0-B;
      }
      if(C+B<0)  {
        fclose(fp);
        fp = fopen("work.out", "w+");
        fprintf(fp, "NO SOLUTION");
        fclose(fp);
        return 0;
      }
      if(nosolve) {
        i=i+j-(j=i);
        B=0-B;
      }
      c[i-1][j-1] = (C<B)?C:B;
    }
    else c[i-1][j-1] = B;
    if(!c[i-1][j-1]) c[i-1][j-1] = NOT_CHECKED;
  }

  nosolve = 0;

  for(i=1;i<n;i++)  {
    g[i].value = NOT_CHECKED;
    g[i].mmh = - NOT_CHECKED;
  }
  g[0].value = 0;
  g[0].mmh = - NOT_CHECKED;

  for(i = 0; i < n-1; i++)  {
    for(j = i + 1; j < n; j++)  {
      if( (g[j].value == NOT_CHECKED) && (c[i][j]) )  {
        if(c[i][j] == NOT_CHECKED) B = 0;
        else B = c[i][j];
        g[j].value = g[i].value - B;
        if(B<=0) g[i].mmh = g[j].value+B;
        else g[j].mmh = g[i].value-B;;
      }
      else if(c[i][j]) {
        if(c[i][j] == NOT_CHECKED) B = 0;
        else B = c[i][j];
        if(B<=0) {
          if(g[i].value-B > g[j].mmh)  {
            nosolve = 1;
            break;
          }
          g[j].value = (g[i].value - B > g[j].value)?g[i].value - B:g[j].value;
          g[i].mmh = g[j].value+B;
          if(g[i].value > g[i].mmh)  {
            nosolve = 1;
            break;
          }
        }
        else  {
          if(g[i].mmh-B < g[j].value)  {
            nosolve = 1;
            break;
          }
          g[i].value = (g[j].value+B > g[i].value)?g[j].value+B:g[i].value;
          g[j].mmh = g[i].value-B;
        }
      }
    }
    if(nosolve) break;
  }

  fclose(fp);

  fp = fopen("work.out", "w+");

  if(nosolve)  {
    fprintf(fp, "NO SOLUTION");
  } else {
    fprintf(fp, "%d", g[0].value);
    for(i=1;i<n;i++)  fprintf(fp, "\n%d", g[i].value);
  }
  fclose(fp);

  return 0;
}
