#include<fstream.h>
//#include<stdlib.h>
//#include<string.h>
//#include<math.h>
#define int int

const char inf[30]="work.inp", outf[30]="work.out";
const int maxN=1002;
const int infinity=10000000;
int N,M;
int rel[maxN][maxN];  //Ti-Tj<=rel[i][j]
void init()
{
   ifstream fin(inf);
   fin>>N>>M;
   for(int i=0; i<N; i++)
      for(int j=0; j<N; j++)
         rel[i][j]=infinity;
   int a,b,diff;
   for(int i=0; i<M; i++)
   {
      fin>>a>>b>>diff;
      rel[a-1][b-1]=diff;
   }
   fin.close();
}
int res[maxN];
bool solve()
{
   for(int i=0; i<N; i++)
   {
      for(int j=i+1; j<N; j++)
      {
         if(rel[i][j]==infinity) continue;
         if(rel[i][j]+rel[j][i]<0)
         {
            return false;
         }
         for(int k=i+1; k<N; k++)
         {
            if(rel[k][i]==infinity) continue;
            if(rel[k][j]>rel[i][j]+rel[k][i])
               rel[k][j]=rel[k][i]+rel[i][j];
            int m;
            m=1;
         }
      }
   }
   int relres[maxN];
   relres[N-1]=0;
   for(int i=N-2; i>=0; i--)
   {
      int lb=-infinity, rb=infinity;
      for(int j=i+1; j<N; j++)
      {
         if((relres[j]+rel[i][j]<rb)&&(rel[i][j]<infinity)) rb=relres[j]+rel[i][j];
         if((relres[j]-rel[j][i]>lb)&&(rel[j][i]<infinity)) lb=relres[j]-rel[j][i];
      }
      if(lb>-infinity) {relres[i]=lb; continue;}
      if(rb<infinity) {relres[i]=rb; continue;}
      relres[i]=0;
   }
   int min=relres[0]; int ind=0;
   for(int i=1; i<N; i++)
   {
      if(min>relres[i]) {min=relres[i]; ind=i;}
   }
   for(int i=0; i<N; i++)
      relres[i]-=min;
   memcpy(res,relres,N*sizeof(int));
   return true;
}

void output(bool b)
{
   ofstream fout(outf);
   if(!b)
   {
      fout<<"NO SOLUTION"<<endl;
   }
   else
   {
      for(int i=0; i<N; i++)
         fout<<res[i]<<endl;
   }
   fout.close();
}

int main()
{
   init();
   output(solve());
   return 0;
}
