Const
  nMax=16;
  FinStr='board.inp';
  FoutStr='board.out';

Type
  nType=0..nMax;
  TBoard=Array[nType, nType] Of Integer;
Var
  n, m:nType;
  Board:TBoard;
  AnsNum, Trim:Integer;

    Procedure ReadIn;
      Var
        Fin:Text;
      Begin
        Assign(Fin, FinStr);
        ReSet(Fin);

        Read(Fin, m, n);

        Close(Fin);
      End;

    Function FindMax:Integer;
      Var
        Max, i, j:Integer;
      Begin
        Max:=Board[1, 1];
        For i:=1 To m Do
          For j:=1 To n Do
            If Max< Board[i, j] Then
              Max:=Board[i, j];

        FindMax:=Max;
      End;

    Function FindNum(n:Integer):Integer;
      Var
        Num:Integer;
      Begin
        Num:=0;
        While n>0 Do
         Begin
           Inc(Num);
           n:=n Div 10;
         End;

        FindNum:=Num;
      End;

    Procedure Print;
      Var
        Max, Num, i, j:Integer;
        Fout:Text;
      Begin
        Max:=FindMax;
        Num:=FindNum(Max);
        Inc(Num);

        Assign(Fout, FoutStr);
        ReWrite(Fout);

        If AnsNum=0 Then
          Write(Fout, 0)
        Else
         Begin
           For i:=1 To m-1 Do
            Begin
              For j:=1 To n Do
               Begin
                 Write(Fout,  Board[i, j]:Num)
               End;
              WriteLn(Fout);
            End;
           For j:=1 To n Do
             Write(Fout, Board[m, j]:Num);
         End;

        Close(Fout);

        Halt(1);
      End;

    Procedure Solve0(m, n:Integer);
      Var
        i, j:nType;
      Begin
        If ( (m=2) And (n=3) ) Then
         Begin
           Board[1, 1]:=1;
           Board[1, 2]:=1;
           Board[2, 1]:=1;
           Board[1, 3]:=2;
           Board[2, 2]:=2;
           Board[2, 3]:=2;
           Trim:=2;
         End
        Else
          If ( (m=3) And (n=2) ) Then
           Begin
            Board[1, 1]:=1;
            Board[1, 2]:=1;
            Board[2, 1]:=1;
            Board[2, 2]:=2;
            Board[3, 1]:=2;
            Board[3, 2]:=2;
            Trim:=2;
           End
          Else
           Begin
             If (m mod 2)=0 Then
              Begin
                Solve0(m div 2, n);
                For i:=m div 2 + 1 To m Do
                 Begin
                   For j:=1 To n Do
                     Board[i, j]:=Board[i- ( m Div 2 ), j] + Trim;
                 End;
                Trim:=Trim*2;
              End
             Else
              If (n mod 2)=0 Then
               Begin
                 Solve0(m, n div 2);
                 For j:=n div 2 + 1 To n Do
                  Begin
                    For i:=1 To m Do
                      Board[i, j]:=Board[i, j- ( n Div 2 )] + Trim;
                  End;
                 Trim:=Trim*2;
               End
              Else
               Begin
               {  WriteLn(
                 Write('Gre6ka:', m, ' , ', n);
                 Halt(1);}
                 AnsNum:=0;
                 Print;
               End;
           End;
    End;

  Procedure Solve1;
    Begin
      AnsNum:=0;
    End;

  Procedure Solve2;
    Begin
      AnsNum:=0;
    End;


    Procedure Solve;
      Begin
        Case (m*n mod 3) Of
          0:
            If m*n mod 6 = 0 Then
             Begin
               Solve0(m, n);
               AnsNum:=1;
             End
            Else
              AnsNum:=0;
          1:Solve1;
          2:Solve2;
        End;
      End;

Begin
  ReadIn;
  Solve;
  Print;
End.