//---------------------------------------------------------------------------

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused

#include <stdlib.h>
#include <stdio.h>

float drain[301];
int spos[301];
int filled[301];
int N;

float maxdrain=0;

float calculate(int t) {
    int i; float m=0;
    for (i=0;i<N;i++) {
        if (!filled[i]) m+=drain[i]*t;
    }
    return m;
}

int level=0;
int curfirst;
int bestresult=-1;

int sort_function( const void *a, const void *b)
{
   if (*(float*)a<*(float*)b) return 1;
   else if (*(float*)a==*(float*)b) return 0;
   return -1;
}

float curdrain=0;
float curmaxdrain=0;

float drains[301];
int saves[301];
int la[301];
float k[301];

float bluskai(int n) {
    int i,j,l=1,s;
    float kmax,totaldrain=0;
    while (l<N) {
        saves[n]=0;
        drains[n]=0;
        la[n]=0;
        j=n-1;i=0;
        curdrain=curmaxdrain;
        s=n;
        while (j>=0) {
            if (filled[j]) {j--; continue;}
            drains[j]=curdrain*(spos[s]-spos[j])*2+drains[s];
            saves[j]=saves[s]+drain[j];
            curdrain-=drain[j];
            la[j]=++i;
            k[j]=drains[j]/saves[j];
            s=j;
            j--;
        }
        j=n+1;i=0;
        curdrain=curmaxdrain;
        s=n;
        while (j<N) {
            if (filled[j]) {j++; continue;}
            drains[j]=curdrain*(spos[j]-spos[s])*2+drains[s];
            saves[j]=saves[s]+drain[j];
            curdrain-=drain[j];
            la[j]=++i;
            k[j]=drains[j]/saves[j];
            s=j;
            j++;
        }
        j=-1;kmax=10000000000000000000;
        k[n]=kmax*10;
        for (i=0;i<N;i++) {
            if (!filled[i])
                if (k[i]<kmax) {
                    kmax=k[i];
                    j=i;
                }
        }
        l+=la[j];
        s=abs(n-j)/(n-j);
        for (i=j;i!=n;i+=s) filled[i]=1;
        curmaxdrain-=saves[j];
        n=j;
        totaldrain+=drains[j]/2;
    }
    return totaldrain;
}

float iterate(void) {
    int i,n;
    float max=100000000000000000000,cur;
    for (n=0;n<N;n++) {
        curmaxdrain=maxdrain-drain[n];
        for (i=0;i<N;i++) filled[i]=0;
        filled[n]=1;
        cur=bluskai(n);
        if (cur<max) {
            max=cur;
            bestresult=n;
        }
    }
    return max;
}


int main(int argc, char* argv[])
{
    int i;
    float result;

    FILE *fin=fopen("DRAIN.INP","r"),*fout=fopen("DRAIN.OUT","w");
    fscanf(fin,"%d",&N);
    for (i=0;i<N;i++) {
        fscanf(fin,"%d",&spos[i]);
        fscanf(fin,"%f",&drain[i]);
        maxdrain+=drain[i];
        filled[i]=0;
    }

    fclose(fin);

    result=iterate();

    fprintf(fout,"%.0f\n%d\n",result,bestresult+1);
    fclose(fout);

    return 0;
}
//---------------------------------------------------------------------------
