Const
        InFile = 'Drain.inp';
        OutFile = 'Drain.out';

        MAXN = 350;

Var
        FIn,FOut  : Text;
        a         : array [0..MAXN,0..MAXN+1,1..2] of longint;
        sumL,sumR : array [0..MAXN] of longint;
        d,raz     : array [0..MAXN] of longint;
        n,i       : longint;

function min(a,b : longint) : longint;
begin
        if a < b then
                min := a
        else
                min := b;
end;

function rec(x,y,dir : longint) : Longint;
var
        r : longint;

begin
        if a[x,y,dir] <> -1 then
                rec := a[x,y,dir]
        else begin
                if dir = 1 then begin
                        if  x = 1 then
                                r := (raz[y]-raz[x]) * sumR[y] +  a[0,y,2]
                        else
                                r := min(
                                           (raz[x] - raz[x-1])*(sumL[x-1] + sumR[y])
                                           + rec(x-1,y,1),
                                           (raz[y] - raz[x])*(sumL[x-1] + sumR[y])
                                           + rec(x-1,y,2)
                                        );
                end
                else begin
                        if y = n then
                                r := (raz[y] - raz[x])*sumL[x] + a[x,n+1,1]
                        else
                                r := min(
                                          (raz[y] - raz[x])*(sumL[x]+sumR[y+1]) +
                                                rec(x,y+1,1),
                                          (raz[y+1] - raz[y])*(sumL[x] + sumR[y+1]) +
                                                rec(x,y+1,2)
                                        );
                end;
                a[x,y,dir] := r;
                rec := r;
        end;
end;

procedure solve;
var
        i,j,k : longint;
        r     : longint;
        r2    : longint;
        r3    : longint;

begin
        for i := 0 to N do
                for j := i+1 to N+1 do
                        for k := 1 to 2 do
                                a[i,j,k] := -1;

        sumL[0] := 0;
        for i := 1 to N do
                sumL[i] := sumL[i-1] + d[i];

        sumR[n+1] := 0;
        for i := n downto 1 do
                sumR[i] := sumR[i+1] + d[i];

        r := 0;

        a[0,n,2] := 0;
        a[1,n+1,1] := 0;

        for i := n-1 downto 1 do begin
                r := 0;
                for j := i+1 to N do
                        r := r + (raz[j] - raz[i])*d[j];
                a[0,i,2] := r;
        end;

        r := 0;

        for i := 2 to n do begin
                r := 0;
                for j := 1 to i-1 do
                        r := r + (raz[i] - raz[j])*d[j];

                a[i,n+1,1] := r;

        end;

        r := a[0,1,2]; j := 1;

        if r > a[n,n+1,1] then begin
                j := n;
                r := a[n,n+1,1];
        end;

        for i := 2 to n-1 do begin
                r2 := min( (raz[i] - raz[i-1])*(sumL[i-1] + sumR[i+1]) +
                           rec(i-1,i+1,1),
                           (raz[i+1] - raz[i])*(sumL[i-1] + sumR[i+1]) +
                           rec(i-1,i+1,2)
                         );

                if r2 < r then begin
                        r := r2;
                        j := i;
                end;

        end;

        writeln(FOut,r);
        writeln(FOut,j);
end;

Begin
        assign(FIn,InFile);     reset(FIn);
        assign(FOut,OutFile);   rewrite(FOut);
        readln(FIn,N);
        for i := 1 to N do
                readln(FIn,raz[i],d[i]);
        close(Fin);
        solve;
        close(Fout);
End.
