#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>

#define MAX 1000

struct help
{
 int st;
 int w;
} g[MAX][MAX];
long n,m;
long long st[MAX];
int used[MAX];
int vl[MAX];



 inline  void input()
    {
     ifstream fin ("work.inp");
     fin >> n >> m;
     int a,b,c;
     while (m>0)
       {
        m--;
        fin >> a>> b >>c;
        a--;b--;
        if (c <= 0)
           {
            g[a][0].w++;
            g[a][g[a][0].w].st = -c;
            g[a][g[a][0].w].w = b;
            vl[b]++;
           }
           else
             {
              g[b][0].w++;
              g[b][g[b][0].w].st = c;
              g[b][g[b][0].w].w = a;
              vl[a]++;
             };
       };
     fin.close();
    };

 inline int search()
   {
    int i;
    for (i=0;i<n;i++)
      if (!used[i] && vl[i] == 0) return i;
    return -1;
   };
   
    
 inline int solve()
   {
    int i,j,k;
    for (i=0;i<n;i++)
      {
       j =search();
       if (j == -1) return 0;
       used[j] = 1;
       for (k=1;k<=g[j][0].w; k++)
         {
          if ( st[j] + g[j][k].st  > st[g[j][k].w]) st[g[j][k].w] = st[j] + g[j][k].st;
          if (!used[g[j][k].w]) vl[g[j][k].w]--;
         };
      };
   };

 inline void output()
   {
    ofstream fout("work.out");
    int i;
    if (!solve()) fout << "NO SOLUTION";
         else  for (i=0;i<n;i++) fout << st[i]<<endl;
    fout.close();
   };


int main()
{
 input();
 output();
 return 0;
};
