#include <fstream.h>
#include <stdlib.h>

#define nadqsno 1
#define nalqvo -1

int n;

struct drain{
	int donach;
   long debit;
}tech[300];

long litri;
int heli;

int readdata(void)
{
	fstream fin("drain.inp", ios::in);
   int i,c=0,p;

   fin >> n;

   for(i=0;i<n;i++){
   	fin >> tech[i].donach >> tech[i].debit;
      if(tech[i].debit>c) { c=tech[i].debit; p=i; }
   }

   fin.close();
   return p;
}

long sum(int place, int dir)
{
   long clit = 0;
   int i, ckil=0;
   
   for(i=place+dir;(i>=0 && i<n);i+=dir)
   	clit+=tech[i].debit;
   for(i=place-dir;(i>=0 && i<n);i-=dir){
     	ckil+=abs(tech[i+dir].donach-tech[i].donach);
	}
	return(clit*ckil);
}

long go(int place, int dir)
{
   long clit = 0;
   int i, j, ckil=0;
   
   for(i=place+dir;(i>=0 && i<n);i+=dir){
   	ckil=abs(tech[i-dir].donach-tech[i].donach);
      clit+=ckil*tech[i].debit;
      for(j=i+dir;(j>=0 && j<n);j+=dir)
      	clit+=ckil*tech[j].debit;
   }
   return clit;
}

void solve(int kade)
{
   long d=sum(kade,nadqsno),l=sum(kade,nalqvo);
   tech[kade].debit=0;
   if(kade==0){
      litri=go(kade,nadqsno);
      return;
   } else if(kade==n-1){
   	litri= go(kade,nalqvo);
      return;
   }
   else{
   	if(d < l)
      	litri=2*d+go(kade,nalqvo)+go(kade,nadqsno);
      else
        	litri=2*l+go(kade,nalqvo)+go(kade,nadqsno);
   }
}

void spitout(void)
{
   fstream fout("drain.out", ios::out);
   fout << litri << "\n" << heli+1;
   fout.close();
}

void main(void)
{
   int i,c=1;
   int ednakvi[300];
   int a=readdata();
   int hlp=0, hel;

   ednakvi[0]=a;

   for(i=a+1;i<n;i++)
   	if(tech[i].debit==tech[a].debit)
			ednakvi[c++]=i;

   if(c==1){
   	heli=a;
      goto slv;
   }

   if(c==n){
   	heli=0;
      goto slv;
   }

   for(i=0;i<c;i++){
   	if(sum(ednakvi[i],nalqvo)>hlp){
      	hlp=sum(ednakvi[i],nalqvo);
         hel=ednakvi[i];
      }
      if(sum(ednakvi[i],nadqsno)>hlp){
         hlp=sum(ednakvi[i],nadqsno);
         hel=ednakvi[i];
      }
   }

   heli=hel;

slv:
   solve(heli);
   spitout();
}
