#include <stdio.h>
#include <math.h>

#define MAXN 512

typedef struct Hole THole;
struct Hole {
       unsigned l, f, v;
};

THole h[MAXN];
int n, bs;
unsigned maxf = 1000000001;

void dfs(int s, int v, unsigned c, int l, int r, unsigned a) {
     int i, d, t;
     
     if (c < maxf) {
        h[v].v = 1;
        a -= h[v].f;
        if (l == -1 && r == -1) {
           maxf = c;
           bs = s + 1;
        }
        else {
             if (l != -1) {
                d = abs(h[l].l - h[v].l);
                for (i = l - 1; i >= 0 && h[i].v == 1; --i)
                    ;
                dfs(s, l, c+a*d, i, r, a);
             }
             if (r != -1) {
                d = abs(h[r].l - h[v].l);
                for (i = r + 1; i < n && h[i].v == 1; ++i)
                    ;
                dfs(s, r, c+a*d, l, ((i == n) ? -1 : i), a);
             }
        }
        h[v].v = 0;
     }
}

int main(void) {
    FILE *fin, *fout;
    int i;
    unsigned a;

    fin = fopen("drain.inp", "r");
    fout = fopen("drain.out", "w");

    fscanf(fin, "%d\n", &n);
    for (i = 0; i < n; ++i)
        fscanf(fin, "%u %u\n", &h[i].l, &h[i].f);

    a = 0;
    for (i = 0; i < n; ++i)
        a += h[i].f;
        
    for (i = 0; i < n; ++i) {
        dfs(i, i, 0, i-1, ((i == n - 1) ? -1 : i + 1), a);
    }

    fprintf(fout, "%u\n%d\n", maxf, bs);

    fclose(fin);
    fclose(fout);
    
    return 0;
}
