{$R-}
Const
  nMax=20;
  FinStr='perm.inp';
  FoutStr='perm.out';

Type
  nType=0..nMax;
  TP=Array[nType]Of nType;
Var
  n, k:nType;
  Ans:LongInt;
  p:TP;

   Procedure Swap(VAR a, b:nType);
     Var
       x:nType;
     Begin
       x:=a;
       a:=b;
       b:=x;
     End;

   Procedure ReadIn;
     Var
       Fin:Text;
     Begin
       Assign(Fin, FinStr);
       ReSet(Fin);

       Read(Fin, n, k);

       Close(Fin);
     End;

   Function CyclesP:LongInt;
     Type
       TNotUsed=Array[nType]Of Boolean;
     Var
       NotUsed:TNotUsed;
       TF, First, i, Next:nType;
       Res:LongInt;
     Begin
       Res:=0;
       For i:=1 To n Do
         NotUsed[i]:=True;
       For First:=1 To n Do
         If NotUsed[First] Then
           If First=P[First] Then
            Begin
              Inc(Res);
              NotUsed[First]:=False;
            End
           Else
             Begin
               TF:=First;
               Next:=p[TF];
               While Next<>First Do
                Begin
                  NotUsed[TF]:=False;
                  TF:=Next;
                  Next:=p[TF];
                End;
               NotUsed[TF]:=False;
               Inc(Res);
             End;
       CyclesP:=Res;
     End;


   Procedure Solve;
     Var
       i, j, pos, l, r:nType;
     Begin
       For i:=1 To n Do
         p[i]:=i;
       p[0]:=0;
       While i>0 Do
        Begin
          {WriteLn;
          For i:=1 To n Do
            Write(p[i], ' ');}

          If k=CyclesP Then
            Inc(Ans);

          i:=n-1;
          While p[i]>p[i+1] Do
            Dec(i);
          Pos:=i+1;
          For j:=i+2 To n Do
            If (p[j]>p[i])And(p[pos]>p[j]) Then
              pos:=j;
          Swap(P[i], P[pos]);
          l:=i+1;
          r:=n;
          While l<r Do
           Begin
             Swap(p[l], p[r]);
             Dec(r); Inc(l);
           End;
        End;
     End;

   Procedure Print;
     Var
       Fout:Text;
     Begin
       Assign(Fout, FoutStr);
       ReWrite(Fout);

       Write(Fout, Ans);

       Close(Fout);
     End;

Begin
  ReadIn;
  Solve;
  Print;
End.
