#include <stdio.h>
#include <time.h>
#include <stdlib.h>

#define DIR_UP	-1
#define DIR_DOWN	1
#define DIR_LEFT  2
#define DIR_RIGHT 3

int x[100000];
int y[100000];
int dir[100000];
int ptr = 0;
int nextx, nexty;
int tx1, tx2, ty1, ty2;
int noti;

void convert(int i) {
	switch (dir[i]) {
    	case DIR_UP:
        	ty1 = y[i]-1;
            ty2 = y[i];
            tx1 = tx2 = x[i];
        break;
    	case DIR_DOWN:
        	ty2 = y[i]+1;
            ty1 = y[i];
            tx1 = tx2 = x[i];
        break;
    	case DIR_LEFT:
        	tx1 = x[i]-1;
            tx2 = x[i];
            ty1 = ty2 = y[i];
        break;
    	case DIR_RIGHT:
        	tx2 = x[i]+1;
            tx1 = x[i];
            ty1 = ty2 = y[i];
        break;
    }
}

int check(int x1, int x2, int y1, int y2) {
	int i, j;
    
	for (i = 0; i < ptr; i++) {
       	if (!(x1== x[i] ^ x2==x[i]))
           	continue;
       	if (!(y1== y[i] ^ y2==y[i]))
           	continue;
        convert(i);
        if (x1 > x2)
        	j = x1, x1 = x2, x2 = j;
        if (y1 > y2)
        	j = y1, y1 = y2, y2 = j;
        if (tx1 == x1 && tx2 == x2 && ty1 == y1 && ty2 == y2)
        	return 1;
    }
    return 0;
}

int getdir() {
	int i, t;
	int candoit = 0;
    
	for (i = ptr-1; i >= 0; i-=2) {
    	nextx = x[i]; nexty = y[i];
	   	if (!check(nextx, nexty, nextx, nexty-1)) {
        	candoit = DIR_UP;
        	if (rand()%10 > 7)
	          	return DIR_UP;
        }
        
	   	if (!check(nextx, nexty, nextx, nexty+1)) {
        	candoit = DIR_DOWN;
        	if (rand()%10 > 7)
	          	return DIR_DOWN;
        }
	   	if (!check(nextx, nexty, nextx-1, nexty)) {
        	candoit = DIR_LEFT;
        	if (rand()%10 > 7)
    	      	return DIR_LEFT;
        }
	   	if (!check(nextx, nexty, nextx+1, nexty)) {
        	candoit = DIR_RIGHT;
        	if (rand()%10 > 7)
	          	return DIR_RIGHT;
        }
    }
    return candoit;
}

int main() {
    int x1, x2, y1, y2;
    int d;
	FILE *f;

start:
	srand(time(NULL));
	f = fopen("temp", "rb");
    if (f) {
    	fread(&ptr, 4, 1, f);
        fread(x, 4, ptr, f);
        fread(y, 4, ptr, f);
        fread(dir, 4, ptr, f);
        fclose(f);
    }
	scanf("%i %i %i %i", &x1, &y1, &x2, &y2);
    ptr++;
    x[ptr] = x1;
    y[ptr] = y1;
    if (x2 > x1)
    	dir[ptr++] = DIR_RIGHT;
    else if (x2 < x1)
    	dir[ptr++] = DIR_LEFT;
    else if (y2 > y1)
    	dir[ptr++] = DIR_DOWN;
    else if (y2 < y1)
    	dir[ptr++] = DIR_UP;

    d = getdir();
    dir[ptr] = d;
    x[ptr] = nextx;
    y[ptr++] = nexty;
    switch (d) {
    	case DIR_UP:
        	printf("%i %i %i %i\n", nextx, nexty,nextx, nexty-1);
        break;
    	case DIR_DOWN:
        	printf("%i %i %i %i\n", nextx, nexty,nextx, nexty+1);
        break;
    	case DIR_LEFT:
        	printf("%i %i %i %i\n", nextx, nexty,nextx-1, nexty);
        break;
    	case DIR_RIGHT:
        	printf("%i %i %i %i\n", nextx, nexty,nextx+1, nexty);
        break;
    }
    f = fopen("temp", "wb");
   	fwrite(&ptr, 4, 1, f);
    fwrite(x, 4, ptr, f);
    fwrite(y, 4, ptr, f);
    fwrite(dir, 4, ptr, f);
    fclose(f);
	return 0;
}
