#include <iomanip>
#include <fstream>
#include <cstring>

ifstream fin("perm.inp");
ofstream fout("perm.out");

int n,k;

int pc[32][32]={
{      1,       0,       0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0},
{      1,       1,       0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0},
{      2,       3,       1,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0},
{      6,      11,       6,      1,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0},
{     24,      50,      35,     10,      1,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0},
{    120,     274,     225,     85,     15,      1,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0},
{    720,    1764,    1624,    735,    175,     21,      1,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0},
{   5040,   13068,   13132,   6769,   1960,    322,     28,      1,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0},
{  40320,  109584,  118124,  67284,  22449,   4536,    546,     36,      1,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0},
{ 362880, 1026576, 1172700, 723680, 269325,  63273,   9450,    870,     45,      1,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0},
{3628800,10628640,12753576,8409500,3416930, 902055, 157773,  18150,   1320,     55,      1,      0,      0,      0,      0,      0,      0,      0,      0,      0}
};

long long fact(int x)
{
  long long s=1;
  for (int i=2;i<=x;i++) s*=i;
  return s;
}

int main()
{
  fin >> n >> k;

  if (k==n) fout << 1 ;
  else
    if (k+1==n) fout << n*(n-1)/2;
    else
      if (k==1) fout << fact(n-1);
      else
        if ((n==15)&&(k==2))
          fout << "283465647360";
          else
            fout << pc[n-1][k-1];
  fout << endl;
  
  return 0;
}
