#include <stdio.h>

FILE *fn;
long long fac[32];
long long nnk[32][32];
long long n, k, ans;
long long perm[20];

long long build(long long a, long long b, long long c, long long d) {
  long long i, j, l=1, m;

  if (a==0) {
    perm[c]=0;
    m=0;
    for (i=0; i<c-1; i++) {
      l*=nnk[n-m][perm[i]]*fac[perm[i]-1];
      m+=perm[i];
    }
    l*=fac[perm[c-1]-1];
    m=1;
    for (i=0; i<c; i++) {
      if (perm[i]==perm[i+1]) m++;
      else if (m>1) {
        l/=fac[m];
        m=1;
      }
    }
    ans+=l;
  } else {
    if (a%d) j=a/d+1;
    else j=a/d;
    for (i=b; i>=j; i--) {
      perm[c]=i;
      build(a-i, a-i-d+2, c+1, d-1);
    }
  }
}

int main(void) {
long long i, j;

fn=fopen("PERM.INP", "r");
fscanf(fn, "%lld %lld", &n, &k);
fclose(fn);

fac[0]=1;
fac[1]=1;
for (i=2; i<21; i++) fac[i]=fac[i-1]*i;
for (i=0; i<21; i++) for (j=0; j<=i; j++) nnk[i][j]=fac[i]/(fac[j]*fac[i-j]);
build(n, n-k+1, 0, k);

fn=fopen("PERM.OUT", "w");
fprintf(fn, "%lld\n", ans);
fclose(fn);

return 0;
}
