#include <stdio.h>
#define MAX 10001
int M[MAX][4];
int N=0;
#define LEFT 1
#define RIGHT -1
int Face(int x1,int y1,int x2,int y2,int x3,int y3)
{
 return(x1*y2+x2*y3+x3*y1-x1*y3-x2*y1-x3*y2);
}
int Chk(int x, int y)
{
 long long s1,s2,s3,s4;
 s1=Face(M[x][0],M[x][1],M[x][2],M[x][3],M[y][0],M[y][1]);
 s2=Face(M[x][0],M[x][1],M[x][2],M[x][3],M[y][2],M[y][3]);
 if(s1*s2>0) return 0;
 s3=Face(M[y][0],M[y][1],M[y][2],M[y][3],M[x][0],M[x][1]);
 s4=Face(M[y][0],M[y][1],M[y][2],M[y][3],M[x][2],M[x][3]);
 if (s3*s4>0) return 0;
 return 1;
}

long long side(int x1,int y1,int x2, int y2, int x3,int y3)
{
 long long S;
 if(x1==x2) return (x3-x2);
 S=(x2-x1)*((y2-y1)*(x3-x1) + (y1-y3)*(x2-x1) );
 return S;
}

int Chk1(int x, int y)                     //optimizirana versia
{
 long long s1,s2,s3,s4;
 s1=side(M[x][0],M[x][1],M[x][2],M[x][3],M[y][0],M[y][1]);
 s2=side(M[x][0],M[x][1],M[x][2],M[x][3],M[y][2],M[y][3]);
 s3=side(M[y][0],M[y][1],M[y][2],M[y][3],M[x][0],M[x][1]);
 s4=side(M[y][0],M[y][1],M[y][2],M[y][3],M[x][2],M[x][3]);
 return(((s1*s2)<=0)&&((s3*s4)<=0));
}



void Init()
{
 FILE *in=fopen("ots.inp","r");
 while( !feof(in))
 {
 fscanf(in,"%d %d %d %d\n",&M[N][0],&M[N][1],&M[N][2],&M[N][3]);
  N++;
  }
 fclose(in);
}




void main()
{
 int i,j;
 long long S=0;
 Init();
 for(i=0;i<N-1;i++) for(j=i+1;j<N;j++) if(Chk(i,j)) S++;
 FILE* out=fopen("ots.out","w");
 fprintf(out,"%lld\n",S);
 fclose(out);
}


