type
  tline = record
            a, b, c : real;
          end;
  point = record
            x, y : longint;
          end;
  tpoint = record
             n, k : point;
           end;

var
  i, j, n : integer;
  lines : array[1..10000] of tline;
  points : array[1..10000] of tpoint;
  br : dword;

Function DefLine(b, e : point) : tline;
var
  l : tline;
  begin
    if b.y - e.y = 0 then
      begin
        l.a := 0;
        l.b := 1;
        l.c := -b.y;
      end
    else
      begin
        l.a := 1;
        l.b := (e.x - b.x) / (b.y - e.y);
        l.c := -b.x - (e.x - b.x) / (b.y - e.y) * b.y;
      end;
    DefLine := l;
  end;

Procedure ReadInp;
var
  f : text;
  begin
    assign(f, 'ots.inp');
    reset(f);
    i := 0;
    while not EoF(f) do
      begin
        inc(i);
        readln(f, points[i].n.x, points[i].n.y, points[i].k.x, points[i].k.y);
        lines[i] := DefLine(points[i].n, points[i].k);
      end;
    close(f);
    n := i;
  end;

Procedure Solution;
  begin
    br := 0;
    for i := 1 to n - 1 do
      for j := i + 1 to n do
        if (lines[j].a*points[i].n.x + lines[j].b*points[i].n.y + lines[j].c)*(lines[j].a*points[i].k.x + lines[j].b*points[i].k.y + lines[j].c) <= 0 then
        if (lines[i].a*points[j].n.x + lines[i].b*points[j].n.y + lines[i].c)*(lines[i].a*points[j].k.x + lines[i].b*points[j].k.y + lines[i].c) <= 0 then
        inc(br);
  end;

Procedure WriteOut;
var
  f : text;
  begin
    assign(f, 'ots.out');
    rewrite(f);
    writeln(f, br);
    close(f);
  end;

begin
  ReadInp;
  Solution;
  WriteOut;
end.
