const inp = 'ots.inp';
      out = 'ots.out';
      Eps = 0.001;
      MaxO = 10000;


type TPoint = record
              x, y: word;
              end;
     TOts = record
            x1, x2, y1, y2: word;
            end;
     TOtsArr = array[1..MaxO] of TOts;

     TLine = record
            A, B, C: extended;
            end;

     TLineArr = array[1..MaxO] of TLine;


var Fin, Fout: text;
    o: TOtsArr;
    n: integer;
    count: longint;
    l: TLineArr;

{############################################################################}
Procedure Done;
begin
close(Fin); close(Fout);
halt;
end;

{############################################################################}
function min(a, b: word): word;
begin
if a < b then min:= a else min:= b;
end;

{############################################################################}
function max(a, b: word): word;
begin
if a > b then max:= a else max:= b;
end;

{############################################################################}
procedure Init;
begin
assign(Fin, inp); reset(Fin);
assign(Fout, out); rewrite(Fout);
end;

{############################################################################}
procedure Solve;
var d1, d2, d3, d4: real;
    i: integer;

begin
count:= 0;
n:= 0;

while not EoF(Fin) do
  begin
  inc(n);
  readln(Fin, o[n].x1, o[n].y1, o[n].x2, o[n].y2);
  l[n].A:= o[n].y1 - o[n].y2;
  l[n].B:= o[n].x2 - o[n].x1;
  l[n].C:= (o[n].y2 * o[n].x1) - (o[n].y1 * o[n].x2);

  for i:=1 to n-1 do
    begin
    if (abs(l[i].A * l[n].B - l[i].B * l[n].A) < Eps) and
       (abs(l[i].A * l[n].C - l[i].C * l[n].A) < Eps) then
       begin
       if abs(l[n].B) < Eps then
         begin
         if min(o[i].y1, o[i].y2) > max(o[n].y1, o[n].y2) then continue;
         if min(o[n].y1, o[n].y2) > max(o[i].y1, o[i].y2) then continue;
         inc(count); continue;
         end;
       if min(o[i].x1, o[i].x2) > max(o[n].x1, o[n].x2) then continue;
       if min(o[n].x1, o[n].x2) > max(o[i].x1, o[i].x2) then continue;
       inc(count); continue;
       end;
    if abs(l[i].A * l[n].B - l[i].B * l[n].A) < Eps then continue;

    d1:= l[i].A * o[n].x1 + l[i].B * o[n].y1 + l[i].C;
    d2:= l[i].A * o[n].x2 + l[i].B * o[n].y2 + l[i].C;
    if d1 * d2 > 0 then continue;

    d1:= l[n].A * o[i].x1 + l[n].B * o[i].y1 + l[n].C;
    d2:= l[n].A * o[i].x2 + l[n].B * o[i].y2 + l[n].C;
    if d1 * d2 > 0 then continue;

    inc(count);
    end;
  end;
writeln(Fout, count);
end;

{############################################################################}
{############################################################################}
{############################################################################}
BEGIN
Init;
Solve;
Done;
END.
