#include <stdio.h>

#define MAXN 32

long long c[MAXN][MAXN];
int n, k;

int main(void) {
    FILE *fin, *fout;
    int i, j;

    fin = fopen("perm.inp", "r");
    fout = fopen("perm.out", "w");

    fscanf(fin, "%d %d\n", &n, &k);

    c[0][0] = 1;

    for (i = 1; i <= n; ++i)
        for (j = 1; j <= k; ++j)
            c[i][j] = (i-1) * c[i-1][j] + c[i-1][j-1];

    fprintf(fout, "%lld\n", c[n][k]);

    fclose(fin);
    fclose(fout);
    
    return 0;
}
