Const
        TempFile = 'temp';

        MAXN = 20000;

        LEFT  = 1;
        RIGHT = 2;
        UP    = 4;
        DOWN  = 8;
        ENEMY = 16;
        VISIT = 32;

Type
        TPoint = record
                x,y   : longint;
                flags : byte;
        end;

        PNode = ^TNode;

        TNode = record
                x,y,level  : longint;
                next : PNode;
        end;

        TPOS = array [1..MAXN] of TPoint;

Var
        F           : file of TPoint;
        n           : longint;
        a           : TPOS;
        tmp         : TPOS;
        b           : TPOS;
        count       : integer;
        p           : TPoint;
        p2          : TPoint;
        x1,y1,x2,y2 : longint;
        fl1,fl2     : boolean;
        pp,qq         : PNode;
        XX,YY       : longint;
        XXX,YYY,i     : longint;
        z1,z2       : longint;
        min          : longint;
        xxxx,yyyy,xxxxx,yyyyy : longint;

procedure push(x,y,level : longint);
var
        w : PNode;

begin
        new(W);
        w^.x := x;
        w^.y := y;
        w^.level := level;
        w^.next := nil;

        if qq = nil then begin
                qq := w;
                pp := w;
        end
        else begin
                pp^.next := w;
                pp := w;
        end;
end;

procedure pop(var x,y,level : longint);
var
        w : PNode;
begin
        w := qq;
        qq := qq^.next;
        x := w^.x;
        y := w^.y;
        level := w^.level;
        dispose(w);
end;


procedure add(var P : TPoint; x,y : longint; flag : byte);
begin

        p.flags := p.flags or flag;

        if y > p.y then begin
                p.flags := p.flags or UP;
        end
        else
                if y < p.y then begin
                        p.flags := p.flags or DOWN;
                end
                else
                        if x > p.x then begin
                                p.flags := p.flags or RIGHT;
                        end
                        else begin
                                p.flags := p.flags or LEFT;
                        end;
end;

function check(x,y : longint;var t : boolean;var id : longint) : boolean;
var
        i : longint;
begin
        for i := 1 to count do
                if (b[i].x = x) and ( b[i].y = y ) then begin
                        check := false;
                        id := i;
                        t := (b[i].flags and ENEMY) <> 0;
                        exit;
                end;

        check := true;
end;

function solve(z1,z2 : longint) : longint;
var
        id,id2  : longint;
        i,j,x,y : longint;
        oldCount : longint;
        t       : boolean;

        level   : longint;
        fl      : boolean;
        min     : longint;
        xxxx,yyyy,xxxxx,yyyyy : longint;


begin
        pp := nil; qq := nil;
        b := a;

        count := n;

        b[z1].flags := b[z1].flags or VISIT;
        push(b[z1].x,b[z1].y,0);

        fl := false;

        XXX := 0;


        while qq <> nil do begin

                pop(i,j,level);

                if level > 20 then
                        exit;

                check(i,j,t,id);

                if ( b[id].flags and LEFT = 0) then begin
                        x := i - 1;
                        y := j;
                        if check(x,y,t,id2) then begin
                            if XXX = 0 then begin
                                XX := i; XXX := j;
                                yy := x; yyy := y;
                            end;

                            inc(count);
                            b[count].x := x;
                            b[count].y := y;
                            b[count].flags := VISIT or RIGHT;
                            b[id].flags := b[id].flags or LEFT;
                            push(x,y,level+1);
                        end
                        else begin
                                if b[id2].flags and VISIT = 0 then begin
                                        if t then begin
                                                XX := i;
                                                YY := j;
                                                XXX := x;
                                                YYY := y;
                                                solve := level;
                                                exit;
                                        end
                                        else begin
                                                b[id].flags := b[id].flags or LEFT;
                                                b[id2].flags := b[id2].flags or RIGHT or VISIT;
                                                push(x,y,level+1);
                                        end;
                                end;
                        end;
                end;
                if b[id].flags and RIGHT = 0 then begin
                        x := i+1;
                        y := j;

                        if check(x,y,t,id2) then begin
                                if XXX = 0 then begin
                                   XX := i; XXX := j;
                                   yy := x; yyy := y;
                                end;

                                inc(count);
                                b[count].x := x;
                                b[count].y := y;
                                b[count].flags := VISIT or LEFT;
                                b[id].flags := b[id].flags or RIGHT;
                                push(x,y,level+1);
                        end
                        else begin
                                if b[id2].flags and VISIT = 0 then begin
                                        if t then begin
                                                xx := i;
                                                xxx := x;
                                                yy := j;
                                                yyy := y;
                                                solve := level;
                                                exit;
                                        end
                                        else begin
                                                b[id2].flags := b[id2].flags or VISIT or LEFT;
                                                b[id].flags := b[id].flags or RIGHT;
                                                push(x,y,level+1);
                                        end;
                                end;
                        end;

                end;

                if b[id].flags and UP = 0 then begin
                        x := i;
                        y := j+1;

                        if check(x,y,t,id2) then begin
                                if XXX = 0 then begin
                                   XX := i; XXX := j;
                                   yy := x; yyy := y;
                                end;

                                inc(count);
                                b[count].x := x;
                                b[count].y := y;
                                b[count].flags := VISIT or DOWN;
                                b[id].flags := b[id].flags or UP;
                                push(x,y,level+1);
                        end
                        else begin
                                if b[id2].flags and VISIT = 0 then begin
                                        if t then begin
                                                xx := i;
                                                xxx := x;
                                                yy := j;
                                                yyy := y;
                                                solve := level;
                                                exit;
                                        end
                                        else begin
                                                b[id2].flags := b[id2].flags or VISIT or DOWN;
                                                b[id].flags := b[id].flags or UP;
                                                push(x,y,level+1);
                                        end;
                                end;
                        end;
                end;

                if b[id].flags and DOWN = 0 then begin
                        x := i;
                        y := j-1;

                        if check(x,y,t,id2) then begin
                                if XXX = 0 then begin
                                    XX := i; XXX := j;
                                    yy := x; yyy := y;
                                 end;

                                inc(count);
                                b[count].x := x;
                                b[count].y := y;
                                b[count].flags := VISIT or UP;
                                b[id].flags := b[id].flags or DOWN;
                                push(x,y,level+1);
                        end
                        else begin
                                if b[id2].flags and VISIT = 0 then begin
                                        if t then begin
                                                xx := i;
                                                xxx := x;
                                                yy := j;
                                                yyy := y;
                                                solve := level;
                                                exit;
                                        end
                                        else begin
                                                b[id2].flags := b[id2].flags or VISIT or UP;
                                                b[id].flags := b[id].flags or DOWN;
                                                push(x,y,level+1);
                                        end;
                                end;
                        end;
                end;
        end;
end;

procedure swap(var a,b : longint);
var
        tmp : longint;
begin
        tmp := a;
        a := b;
        b := tmp;
end;

Begin

        readln(x1,y1,x2,y2);

        if (x1 > x2) or ( (x1 = x2) and (y1 > y2)) then begin
                swap(x1,x2);
                swap(y1,y2);
        end;

        fl1 := false;
        fl2 := false;


        n := 0;

        assign(F,tempFile);
        {$I-}
                reset(F);
        {$I+}

        if ioresult <> 0 then begin
                rewrite(F);
                if not fl1 then begin
                                p2.x := x1;
                                p2.y := y1;
                                p2.flags := 0;
                                add(p2,x2,y2,ENEMY);
                                inc(n);
                                z1 := n;
                                a[n] := p2;
                                fl1 := true;
                end;
                if not fl2 then begin
                                p2.x := x2;
                                p2.y := y2;
                                p2.flags := 0;
                                add(p2,x1,y1,ENEMY);
                                inc(n);
                                z2 := n;
                                a[n] := p2;
                                fl2 := true;
                end;

        end
        else begin
                while not eof(F) do begin
                        read(F,P);

                        if (not fl1) and ((p.x = x1) and (p.y = y1)) then begin
                                add(p,x2,y2,ENEMY);
                                z1 := n+1;
                                fl1 := true;
                        end;


                        if (not fl2) and (p.x = x2) and (p.y = y2) then begin
                                add(p,x1,y1,ENEMY);
                                z2 := n+1;
                                fl2 := true;
                        end;

                        inc(n);
                        a[n] := p;
                end;

                if not fl1 then begin
                                p2.x := x1;
                                p2.y := y1;
                                p2.flags := 0;
                                add(p2,x2,y2,ENEMY);
                                inc(n);
                                z1 := n;
                                a[n] := p2;
                                fl1 := true;
                end;
                if not fl2 then begin
                                p2.x := x2;
                                p2.y := y2;
                                p2.flags := 0;
                                add(p2,x1,y1,ENEMY);
                                inc(n);
                                z2 := n;
                                a[n] := p2;
                                fl2 := true;
                end;
        end;

        close(F);

        min := solve(z1,z2);
        xxxx := xx;
        yyyy := yy;
        xxxxx := xxx;
        yyyyy := yyy;

        if min <= solve(z2,z1) then begin
                xx := xxxx;
                yy := yyyy;
                xxx := xxxxx;
                yyy := yyyyy;
        end;




        fl1 := false;
        fl2 := false;

        rewrite(F);

        if (xx > xxx) or ( (xx= xxx) and ( yy> yyy)) then begin
                swap(xx,xxx);
                swap(yy,yyy);
        end;

        for i := 1 to n do begin
                if (xx = a[i].x) and ( yy = a[i].y) then begin
                        add(a[i],xxx,yyy,0);
                        fl1 := true;
                end;
                if (xxx = a[i].x) and ( yyy = a[i].y) then begin
                        add(a[i],xx,yy,0);
                        fl2 := true;
                end;
                write(F,a[i]);
        end;

        if not fl1 then begin
                p.x := xx;
                p.y := yy;
                p.flags := 0;
                add(p,xxx,yyy,0);
                write(F,p);
        end;

        if not fl2 then begin
                p.x := xxx;
                p.y := yyy;
                p.flags := 0;
                add(p,xx,yy,0);
                write(F,P);
        end;

        close(F);
        writeln(xx,' ',yy,' ',xxx,' ',yyy);
End.
