{$MODE objfpc}

{Uses
  SysUtils;}

Var
  Res : Integer;
{  Res1, Res2, Res3, Res4, Res5, Res6, Res7 : Integer;}
  N : Integer;
  S : Array[0..10066] Of Record
    X1, Y1, X2, Y2 : Integer;
  End;
  cachedX2, cachedY2, cachedX3, cachedY3 : Integer;
  cached23 : Double;

Function CP(X1, Y1, X2, Y2, X3, Y3 : Integer) : Integer; Inline;

Var
  Q : Double;

Begin
  Q := ((Double(Y1 + Y2)) * (Double(X2 - X1))) +
       ((Double(Y2 + Y3)) * (Double(X3 - X2))) +
       ((Double(Y3 + Y1)) * (Double(X1 - X3)));
  If Q > 0 Then
    CP := 1
  Else
    If Q < 0 Then
      CP := -1
    Else
      CP := 0;
End;

Function CPcache(X1, Y1, X2, Y2, X3, Y3 : Integer) : Integer; Inline;

Var
  Q : Double;

Begin
  If (X2 <> cachedX2) Or (Y2 <> cachedY2) Or (X3 <> cachedX3) Or (Y3 <> cachedY3) Then
  Begin
{    Writeln('---');
    Writeln(cachedX2, ' ', X2);
    Writeln(cachedY2, ' ', Y2);
    Writeln(cachedX3, ' ', X3);
    Writeln(cachedY3, ' ', Y3);}
    cachedX2 := X2;
    cachedY2 := Y2;
    cachedX3 := X3;
    cachedY3 := Y3;
    cached23 := (Double(Y2 + Y3)) * (Double(X3 - X2));
{    Write('.');}
  End
{  Else
    Write(',')};
  Q := ((Double(Y1 + Y2)) * (Double(X2 - X1))) +
       cached23 +
       ((Double(Y3 + Y1)) * (Double(X1 - X3)));
  If Q > 0 Then
    CPcache := 1
  Else
    If Q < 0 Then
      CPcache := -1
    Else
      CPcache := 0;
End;

Procedure ReadIn;

Var
  F : Text;

Begin
  ASSign(F, 'OTS.INP');
  Reset(F);
  N := 0;
  While Not EoF(F) Do
  Begin
    Inc(N);
    Readln(F, S[N].X1, S[N].Y1, S[N].X2, S[N].Y2);
  End;
  Close(F);
End;

Procedure WriteOut;

Var
  F : Text;

Begin
  ASSign(F, 'OTS.OUT');
  Rewrite(F);
  Writeln(F, Res);
  Close(F);
End;

Procedure Bahur;

Var
  I, J : Integer;
  aX1, aY1, aX2, aY2 : Integer;
  bX1, bY1, bX2, bY2 : Integer;
  aXmax, aYmax : Integer;
  aXmin, aYmin : Integer;
  a1, a2, b1, b2 : Integer;
  a1in, a2in, b1in, b2in : Boolean;
{  adif, bdif : Boolean;}

Begin
  Res := 0;
  For I := 1 To N - 1 Do
  Begin
    aX1 := S[I].X1;
    aY1 := S[I].Y1;
    aX2 := S[I].X2;
    aY2 := S[I].Y2;
    aXmax := aX1;
    If aX2 > aXmax Then
      aXmax := aX2;
    aYmax := aY1;
    If aY2 > aYmax Then
      aYmax := aY2;
    aXmin := aX1;
    If aX2 < aXmin Then
      aXmin := aX2;
    aYmin := aY1;
    If aY2 < aYmin Then
      aYmin := aY2;
    For J := I + 1 To N Do
    Begin
      bX1 := S[J].X1;
      bY1 := S[J].Y1;
      bX2 := S[J].X2;
      bY2 := S[J].Y2;
      If ((bX1 > aXmax) And (bX2 > aXmax)) Or
         ((bX1 < aXmin) And (bX2 < aXmin)) Or
         ((bY1 > aYmax) And (bY2 > aYmax)) Or
         ((bY1 < aYmin) And (bY2 < aYmin)) Then
      Begin
        Continue;
      End;
      a1 := CP(aX1, aY1, bX1, bY1, bX2, bY2);
      a2 := CP(aX2, aY2, bX1, bY1, bX2, bY2);
      b1 := CPcache(bX1, bY1, aX1, aY1, aX2, aY2);
      b2 := CPcache(bX2, bY2, aX1, aY1, aX2, aY2);
      If (((a1 < 0) And (a2 > 0)) Or ((a1 > 0) And (a2 < 0))) And
         (((b1 < 0) And (b2 > 0)) Or ((b1 > 0) And (b2 < 0))) Then
      Begin
        Inc(Res);
{        Inc(Res1);}

{        If ((bX1 > aXmax) And (bX2 > aXmax)) Or
           ((bX1 < aXmin) And (bX2 < aXmin)) Or
           ((bY1 > aYmax) And (bY2 > aYmax)) Or
           ((bY1 < aYmin) And (bY2 < aYmin)) Then
        Begin
          Writeln('whoops');
          Writeln(aX1);
          Writeln(aY1);
          Writeln(aX2);
          Writeln(aY2);
          Writeln(bX1);
          Writeln(bY1);
          Writeln(bX2);
          Writeln(bY2);
          Halt;
        End;}

        Continue;
      End;
      If (a1 <> 0) And (a2 <> 0) And (b1 <> 0) And (b2 <> 0) Then
        Continue;
      If ((aX1 = bX1) And (aY1 = bY1)) Or
         ((aX1 = bX2) And (aY1 = bY2)) Or
         ((aX2 = bX1) And (aY2 = bY1)) Or
         ((aX2 = bX2) And (aY2 = bY2)) Then
      Begin
        Inc(Res);
{        Inc(Res2);}
        Continue;
      End;
      If a1 = 0 Then
      Begin
        If bX1 <> bX2 Then
        Begin {use x}
          a1in := ((aX1 >= bX1) And (aX1 <= bX2)) Or
                  ((aX1 >= bX2) And (aX1 <= bX1));
        End
        Else
        Begin {use y}
          a1in := ((aY1 >= bY1) And (aY1 <= bY2)) Or
                  ((aY1 >= bY2) And (aY1 <= bY1));
        End;
      End
      Else
        a1in := False;
      If a1in Then
      Begin
        Inc(Res);
{        Inc(Res3);}
        Continue;
      End;
      If a2 = 0 Then
      Begin
        If bX1 <> bX2 Then
        Begin {use x}
          a1in := ((aX2 >= bX1) And (aX2 <= bX2)) Or
                  ((aX2 >= bX2) And (aX2 <= bX1));
        End
        Else
        Begin {use y}
          a2in := ((aY2 >= bY1) And (aY2 <= bY2)) Or
                  ((aY2 >= bY2) And (aY2 <= bY1));
        End;
      End
      Else
        a2in := False;
      If a2in Then
      Begin
        Inc(Res);
{        Inc(Res4);}
        Continue;
      End;
      If b1 = 0 Then
      Begin
        If aX1 <> aX2 Then
        Begin {use x}
          b1in := ((bX1 >= aX1) And (bX1 <= aX2)) Or
                  ((bX1 >= aX2) And (bX1 <= aX1));
        End
        Else
        Begin {use y}
          b1in := ((bY1 >= aY1) And (bY1 <= aY2)) Or
                  ((bY1 >= aY2) And (bY1 <= aY1));
        End;
      End
      Else
        b1in := False;
      If b1in Then
      Begin
        Inc(Res);
{        Inc(Res5);}
        Continue;
      End;
      If b2 = 0 Then
      Begin
        If aX1 <> aX2 Then
        Begin {use x}
          b1in := ((bX2 >= aX1) And (bX2 <= aX2)) Or
                  ((bX2 >= aX2) And (bX2 <= aX1));
        End
        Else
        Begin {use y}
          b2in := ((bY2 >= aY1) And (bY2 <= aY2)) Or
                  ((bY2 >= aY2) And (bY2 <= aY1));
        End;
      End
      Else
        b2in := False;
      If b2in Then
      Begin
        Inc(Res);
{        Inc(Res6);}
      End;
    End;
  End;
End;

Begin
  cachedX2 := -1000;
  ReadIn;
  Bahur;
  WriteOut;
{  Writeln('res1 ', res1);
  Writeln('res2 ', res2);
  Writeln('res3 ', res3);
  Writeln('res4 ', res4);
  Writeln('res5 ', res5);
  Writeln('res6 ', res6);}
End.
