#include<fstream.h>
//#include<iostream.h>
//#include<stdlib.h>
//#include<string.h>
//#include<math.h>
#define int long long
const char inf[30]="perm.inp", outf[30]="perm.out";
const int maxN=20;
int N,K;
void init()
{
   ifstream fin(inf);
   fin>>N>>K;
   fin.close();
}

void output(unsigned int res)
{
   ofstream fout(outf);
   fout<<res<<endl;
   fout.close();
}

unsigned int fact[maxN+1];

void findfact()
{
   fact[0]=1;
   for(int i=1; i<=N; i++)
      fact[i]=fact[i-1]*i;
}

unsigned int comb[maxN+1][maxN+1];
void findcomb()
{
  comb[1][0]=1;
  comb[1][1]=1;
  for(int n=2; n<=N; n++)
  {
     comb[n][0]=1;
     comb[n][n]=1;
     for(int k=1; k<n; k++)
	comb[n][k]=comb[n-1][k-1]+comb[n-1][k];
  }
}

unsigned int findsol(int n,int k)
{
   if(k==1) return fact[n-1];
   if(k>n) return 0;
   //k>1
   unsigned int res=0;
   for(int i=0; i<n-(k-1); i++)
   {
      unsigned int res2;
      res2=findsol(n-i-1,k-1)*comb[n-1][i]*fact[i];
      res+=res2;
   }
   return res;
}
unsigned int res;
void solve()
{
   findfact();
   findcomb();
   res=findsol(N,K);
}

int main()
{
   init();
   solve();
   output(res);
   return 0;
}