#include <stdio.h>

#define MAXLEN 512
#define MAXN 300000
#define MAXM 512

char pass[MAXN+1];
char *w[MAXM];
int c[MAXN+1];
int l[MAXM];
int n, m;

int cmp(int s, int pos) {
    char *p1, *p2;

    p1 = pass+pos;
    p2 = w[s];

    while (*p1 && *p1 == *p2) {
          ++p1;
          ++p2;
    }

    return (*p2 == '\0');
}

int main(void) {
    FILE *fin, *fout;
    int i, j, t, t2;

    fin = fopen("pass.inp", "r");
    fscanf(fin, "%d %d\n", &n, &m);
    for (i = 0; i < n; ++i)
        pass[i] = fgetc(fin);
    pass[i] = '\0';
    for (i = 0; i < m; ++i) {
        w[i] = (char*)malloc(sizeof(char) * MAXLEN);
        fscanf(fin, "%s\n", w[i]);
        l[i] = strlen(w[i]);
    }
    fclose(fin);

    c[n] = 0;
    for (i = n - 1; i >= 0; --i) {
        c[i] = c[i+1] + 1;
        t = n - i;
        for (j = 0; j < m; ++j)
            if (l[j] <= t && cmp(j, i) && c[i] > c[t2=i+l[j]])
               c[i] = c[t2];
    }
    
    fout = fopen("pass.out", "w");
    fprintf(fout, "%d\n", c[0]);
    fclose(fout);
    
    return 0;
}
