#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


#define MAXN 10100
#define MAXS 210
#define MAXOUTS 100100

int arr[MAXN];
char s[MAXS];
char outs[MAXOUTS][10];
int nouts;
int I;
int N, L;
int M, P;



void read_all(void);
void do_all(void);
int calce1(int i1, int i2, int *preg);
int calce2(int i1, int i2, int *preg);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i, j;
  char s1[MAXS];
  
  FILE *f = fopen("assem.inp", "rt");
  for (i = 0; i < 9; i++) {
    fscanf(f, "%d", &arr[i]);
  }
  fgets(s1, sizeof(s1), f);
  fgets(s1, sizeof(s1), f);
  for (i = j = 0; s1[i]; i++) {
    if (s1[i] <= ' ')  continue;
    if (s1[i] == 'X')  continue;
    s[j++] = s1[i];
  }
  fclose(f);
  L = j;
}



void do_all(void)
{
  int i, reg;

  I = 10;
  P = calce1(0, L, &reg);
  if (strncmp(outs[nouts-1], "STO", 3) == 0)  nouts--;
}



int calce1(int i1, int i2, int *preg)
{
  int i, ist, reg;
  int br, nbr, num, res;

  *preg = I++;
  res = 0;
  if (i1+1 == i2) {
    *preg = s[i1]-'0';
    sprintf(outs[nouts++], "LOA %d\n", *preg);
    return arr[s[i1]-'1'];
  }
  if (i1 == i2)  return -1;
  if (s[i1] == '(' && s[i2-1] == ')') {
    nbr = br = 0;
    for (i = i1+1; i < i2-1; i++) {
      if (s[i] == '(')  br++;
      if (s[i] == ')')  br--;
      if (br < 0)  break;
    }
    if (i >= i2-1)  return calce1(i1+1, i2-1, &reg);
  }
  nbr = br = 0;
  ist = i1;
  for (i = i1; i <= i2; i++) {
    if (i < i2) {
      if (s[i] == '(')  {br++;continue;}
      if (s[i] == ')')  {br--;continue;}
      if (br != 0)  continue;
      nbr++;
    }
    if (i == i2 || s[i] == '+') {
      num = calce2(ist, i, &reg);
      if (num >= 0) {
        res += num;
        if (ist > i1)  sprintf(outs[nouts++], "ADD %d\n", *preg);
        sprintf(outs[nouts++], "STO %d\n", *preg);
      }
      ist = i+1;
    }
  }
  return res;
}



int calce2(int i1, int i2, int *preg)
{
  int i, ist, reg;
  int br, nbr, num, res;

  *preg = I++;
  res = 1;
  if (i1+1 == i2) {
    *preg = s[i1]-'0';
    sprintf(outs[nouts++], "LOA %d\n", *preg);
    return arr[s[i1]-'1'];
  }
  if (i1 == i2)  return -1;
  if (s[i1] == '(' && s[i2-1] == ')') {
    nbr = br = 0;
    for (i = i1+1; i < i2-1; i++) {
      if (s[i] == '(')  br++;
      if (s[i] == ')')  br--;
      if (br < 0)  break;
    }
    if (i >= i2-1)  return calce1(i1+1, i2-1, &reg);
  }
  nbr = br = 0;
  ist = i1;
  for (i = i1; i <= i2; i++) {
    if (i < i2) {
      if (s[i] == '(')  {br++;continue;}
      if (s[i] == ')')  {br--;continue;}
      if (br != 0)  continue;
      nbr++;
    }
    if (i == i2 || s[i] == '*') {
      num = calce1(ist, i, &reg);
      if (num >= 0) {
        res *= num;
        if (ist > i1)  sprintf(outs[nouts++], "MUL %d\n", *preg);
        sprintf(outs[nouts++], "STO %d\n", *preg);
      }
      ist = i+1;
    }
  }
  return res;
}



void write_all(void)
{
  int i;
  
  FILE *f = fopen("assem.out", "wt");
  fprintf(f, "%d\n%d\n", P, nouts);
  for (i = 0; i < nouts; i++)
    fprintf(f, "%s", outs[i]);
  fclose(f);
}


