#include <stdio.h>
#include <string.h>

#define MAXN 350000
#define MAXL 500

#define inp "pass1.inp"
#define out "pass.out"

int l,n;
char m[MAXL][MAXL];
char s[MAXN];
int best[MAXN];

void init () {
int i;
    FILE *f = fopen ( inp , "r");
    fscanf(f,"%d\n%d\n",&l,&n);
    fscanf(f,"%s",&s);
    for (i=1;i<=n;i++)
        fscanf(f,"%s",&m[i]);
    fclose(f);
}

void solve () {
int i,j,k,l2,min;
     best[0] = 0;
     for (i=0;i<l;i++) {
         min = best[i]+1;
         for (j=1;j<=n;j++) {
             l2 = strlen(m[j]);
             if (l2<=(i+1)) {
                for (k=l2-1;k>=0;k--)
                    if (m[j][k]!=s[i+1-l2+k]) break;
                if (k==(-1)) {
                   if (best[i-l2+1]<min) min = best[i-l2+1];
                }
                if (min==0) break;
             }
         }
         best[i+1] = min;
     }
}

void print () {
     FILE *f = fopen ( out ,"w");
     fprintf(f,"%d\n",best[l]);
     fclose(f);
}

int main () {
    init ();
    solve();
    print();
    return 0;
}
