#include <stdio.h>

double facts[25];

int vot[32];
int votsum;

int redica[32];
int rmin,rmax,rcou;

int n,req;

FILE* outf;

double howoften(int p,int s,int ones)
{
  double r;

  if (s>rmax) { return 0.0; }

  if (p==rcou)
  {
    if (s>=rmin) { return facts[ones]*facts[n-1-ones]; }
    return 0.0;
  }

  r =howoften(p+1, s           , ones   );
  r+=howoften(p+1, s+redica[p] , ones+1 );

  return r;
}

int printfr(double r)
{
  int a,b;
  a = r + 1e-6;
  b = ( (int)( r*100 + 1e-6 ) )%100;

/*  if (a==12)
  {
    printf("Error\n");
  }*/

  if (b%10>=5) { b/=10; b++; if (b==10) { a++; b=0; } }
  else { b/=10; }

  if (b==0)
  { fprintf(outf,"%d\n",a); } else { fprintf(outf,"%d.%d\n",a,b); }
}

int shshc(int no)
{
  int i,j,r;

  r = vot[no];

  j = 0;
  for (i=0;i<n;i++)
  {
    redica[j] = vot[i];
    if (i!=no) { j++; }
  }
  rcou = n-1;
  rmax = req-1;
  rmin = req-r;

//  printf("%.1lf\n",howoften(0,0,0)/((double)facts[n])*100.0);
  printfr(howoften(0,0,0)/((double)facts[n])*100.0);
}


int main(void)
{
  FILE* f;
  int i;
  double ch;

  ch = 1.0;
  facts[0] = ch;
  for (i=1;i<25;i++)
  {
    ch*=i;
    facts[i] = ch;
  }

  f = fopen("shsh.inp","rt");

  outf = fopen("shsh.out","wt");

  fscanf(f,"%d ",&n);
  while (n)
  {
    fscanf(f,"%d ",&req);

    for (i=0;i<n;i++)
    {
      fscanf(f,"%d ",&vot[i]);
    }

    for (i=0;i<n;i++)
    {
      shshc(i);
    }

    fscanf(f,"%d ",&n);
    if (n) { fprintf(outf,"\n"); }

  }


  fclose(f);
  fclose(outf);

  return 0;
}
