#include <fstream>
#include <cstring>

ifstream fin("lines.inp");
ofstream fout("lines.out");


int n;
int sc[1024];
int sn=0;
int s[1024][1024];
short m[1024][1024];
int r=0;


void next(int l,int k)
{
  m[l][k]=r;
  for (int i=1;i<=n;i++)
    for (int j=1;j<=sc[i];j++)
      if (s[l][k]==s[i][j])
        if (m[l][k]!=m[i][j])
        {
          next(i,j);
          return;
        }

  if ((k<sc[l])&&(m[l][k+1]!=m[l][k])) {next(l,k+1);return;}
  if ((k>    0)&&(m[l][k-1]!=m[l][k])) {next(l,k-1);return;}
}


int main()
{
  fin >> n;
  while (n)
  {
    memset(s,0,sizeof(s));
    memset(m,0,sizeof(m));

    int num=0;
    for (int i=1;i<=n;i++) fin >> sc[i];
    for (int l=1;l<=n;l++)
    {
      int ln;
      fin >> ln;
      for (int i=1;i<=sc[ln];i++)
      {
        if (s[l][i]) num=s[l][i];
        else s[l][i]=++num;
        int x;fin >> x;
        for (int j=0;j<x;j++)
        {
          int y,z;
          fin >> y >> z;
          s[y][z]=num;
        }
      }
    }

    r=0;
    for (int i=1;i<=n;i++)
      for (int j=1;j<=sc[i];j++)
        if (m[i][j]==0)
        {
          r++;
          next(i,j);
        }

    fout << r << endl;
    fin >> n;
  }
  return 0;
}
