#include <stdio.h>
#include <string.h>

#define INP "lines.inp"
#define OUT "lines.out"

#define MAX 1010

struct station { int a,b; } stops[MAX];

int n,id,s[MAX],ind[MAX][MAX],m[MAX][MAX],c,lastc,nasl[MAX];
int big;

void rec(int node) {
int i;
     for (i=1;i<=big;i++)
         if (m[node][i]) break;
     if (i==(big+1)) return;
     m[node][i]--;
     m[i][node]--;
     nasl[node]--;
     nasl[i]--;
     rec(i);
}

int solve () {
int i,j,paths;
int sum;
    paths = 0;
    for (i=1;i<=big;i++) {
        if (nasl[i]==1) {
           paths++;
           rec(i);
        }
    }
    for (i=1;i<=big;i++) {
        if (nasl[i]>0) {
           paths++;
           rec(i);
        }
    }
    sum = 0;
    for (i=1;i<=big;i++)
        for (j=1;j<=big;j++)
                sum+=m[i][j]/2;
    paths+=sum/2;
    return paths;
}

int main () {
int i,j,k,x,a,b;
    FILE *finp = fopen ( INP , "r" );
    FILE *fout = fopen ( OUT , "w" );

    while (1) {
          fscanf(finp,"%d",&n);
          if(n==0) break;
          memset(m,0,sizeof(m));
          memset(ind,0,sizeof(ind));
          memset(s,0,sizeof(s));
          memset(stops,0,sizeof(stops));
          memset(nasl,0,sizeof(nasl));
          big = 0;
          for (i=1;i<=n;i++) fscanf(finp,"%d",&s[i]);
          for (i=1;i<=n;i++) {
              fscanf(finp, "%d",&id);
              for (j=1;j<=s[id];j++) {
                  fscanf(finp,"%d",&x);
                  c = ind[id][j];
                  for (k=1;k<=x;k++) {
                      fscanf(finp,"%d%d",&stops[k].a,&stops[k].b);
                      a = stops[k].a;
                      b = stops[k].b;
                      if (ind[a][b] != 0) c = ind[a][b];
                  }
                  if (c==0) { c = big+1;  big = c; }
                  for (k=1;k<=x;k++)
                      ind[stops[k].a][stops[k].b] = c;
                  if (j>1) {
                     m[lastc][c]++;
                     m[c][lastc]++;
                     nasl[lastc]++;
                     nasl[c]++;
                  }
                  lastc = c;
              }
          }
          fprintf(fout,"%d\n",solve());
    }
    fclose(finp);
    fclose(fout);
    return 0;
}
