#include <stdio.h>
#include <string.h>
#include <math.h>

#define INP "points.inp"
#define OUT "points.out"

#define MAX 1010

struct point { double x,y; };
struct point p[MAX];
int v[MAX];

double dist( struct point p1,struct point p2) {
     return (p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y);
}

int m[MAX][MAX];
int n;

void DFS(int node) {
int i;
     if (v[node]==1) return;
     v[node] = 1;
     for (i=1;i<=n;i++)
         if (m[node][i]==1)
            DFS(i);
}

int main () {
int i,j;
double dst;
double sdst;
int comps;
    FILE *finp = fopen ( INP , "r" );
    FILE *fout = fopen ( OUT , "w" );
    while (1) {
          fscanf(finp,"%d",&n);
          if (n==0) break;
          fscanf(finp,"%lf",&dst);
          memset(m,0,sizeof(m));
          memset(v,0,sizeof(v));
          comps = 0;
          sdst = dst*dst;
          for (i=1;i<=n;i++) fscanf (finp,"%lf%lf",&p[i].x,&p[i].y);
          for (i=1;i<=n;i++)
              for (j=i+1;j<=n;j++) {
                  double tmp;
                  tmp = dist(p[i],p[j]);
                  if (tmp<=sdst) { m[i][j] = 1; m[j][i] = 1; }
              }
          for (i=1;i<=n;i++)
              if (v[i]==0) {
                 comps++;
                 DFS(i);
              }
          fprintf(fout,"%d\n",comps);
    }
    fclose(finp);
    fclose(fout);
    return 0;
}
