#include <stdio.h>
#include <math.h>

int slows(int a)
{
  int r,i;

  r=0;
  for (i=1;i<a;i++)
  {
    if (a%i==0) { r+=i; }
  }

  if (r>=a) { /*printf("gt %d\n",r);*/ r=0; }

  return r;
}

int fasts(int n)
{
  int i,t1,t2,t3,t4,n1,n2;

  n2=sqrt(n)+2.1;
  
  i=1;
  n1=n;

  t4=1;
  
  while (n1!=1)
  {
    i++;
    if ((i>=n2) && (t4==1)) { break; } // Simple number

    t2=1;
    t3=1; // n^0
    
    while (n1%i==0)
    {
      n1/=i;

      t2*=i;
      t3+=t2; // + n^pass
    }
    t4*=t3;
    if (t4>=n) { break; } // Not decreasing
  }
  
  if (t4!=1) { t4-=n; }

  if (t4>=n) { t4=0; }

  return t4;
}

int slowl(int n)
{
  int c,n1;
  n1=n;
  
  c=0;
  while (n1)
  {
    c++;
    if (n1==1) { n1=0; } else { n1 = fasts(n1); }
  }
  return c;
}



int main(void)
{
  int i,a,b,n,p,n1;
  FILE* f;

  f = fopen("seq.inp","rt");
  fscanf(f,"%d %d",&a,&b);
  fclose(f);


  p=a; n=0;
  for (i=a;i<=b;i++)
  {
    n1=slowl(i);

//    printf("%d %d\n",i,n1);
    
    if (n1>n) { n=n1; p=i; }
  }

  f = fopen("seq.out","wt");
  fprintf(f,"%d %d\n",p,n);
  fclose(f);

  return 0;
}
