#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define HSIZE 100000

typedef struct Node TNode;

struct Node {
       int k, v;
       TNode *next;
};

TNode *h[HSIZE];

void add(int key, int val) {
     int p;
     TNode *nn;

     nn = (TNode*)malloc(sizeof(TNode));
     nn->k = key;
     nn->v = val;
     p = key % HSIZE;
     nn->next = h[p];
     h[p] = nn;
}

int get(int key) {
    int p;
    TNode *sn;

    p = key % HSIZE;
//    printf("%d\n",key);
    for (sn = h[p]; sn != NULL && sn->k != key; sn = sn->next)
        ;

    return ((sn == NULL) ? -1 : sn->v);
}

///*
int s(int n) {
    int r, i, sq;

    r = get(n);
    if (r == -1) {
        r = 1;
        sq = (int)sqrt(n);
        for (i = 2; i < sq; ++i)
            if (n % i == 0) {
               r += i + n / i;
               if (r > n)
                  break;
            }
        if (sq != 1 && n % sq == 0) {
           r += sq;
           if (sq*sq != n)
              r += n / sq;
        }
        add(n, r);
    }

    return r;
}
//*/


/*
#define MAXS 10000

int smp[MAXS], t[MAXS], cs, r, c[MAXS];

void gen(int l) {
     int tmp, i, j;
     
     if (l > cs) {
        tmp = 1;
        for (i = 0; i <= cs; ++i)
            for (j = 0; j < c[i]; ++j)
                tmp *= smp[i];
        r += tmp;
     }
     else {
          for (i = 0; i <= t[l]; ++i) {
              c[l] = i;
              gen(l+1);
          }
     }
}

int s(int n) {
    int i;

    r = -n;
    cs = -1;
    i = 2;
    while (n > 1) {
          if (n % i == 0) {
             smp[++cs] = i;
             t[cs] = 0;
          }
          while (n % i == 0) {
                n /= i;
                ++t[cs];
          }
          ++i;
    }
    
    gen(0);

    return r;
}
*/

int main(void) {
    FILE *fin, *fout;
    int a, b, i, mss, msl, np, sp, sl;

    fin = fopen("seq.inp", "r");
    fscanf(fin, "%d %d\n", &a, &b);
    fclose(fin);

    msl = 0;

    for (i = a; i <= b; ++i) {
        sl = 1;
        sp = i;
        while (sp != 1) {
              np = s(sp);
              if (np >= sp)
                 break;
              sp = np;
              ++sl;
        }
        if (sl > msl) {
           mss = i;
           msl = sl;
        }
    }
    
    fout = fopen("seq.out", "w");
    fprintf(fout, "%d %d\n", mss, msl);
    fclose(fout);
    
    return 0;
}
