{$MODE objfpc}

Procedure BahurEncode;

Var
  Num : Integer;
  Target : Array[1..6] Of Integer;
  A, B, C, D, E, F : Integer;
  I, J : Integer;
  tmp : Integer;

Begin
  Readln(Target[1], Target[2], Target[3], Target[4], Target[5], Target[6]);

  For I := 1 To 5 Do
    For J := I + 1 To 6 Do
      If Target[I] > Target[J] Then
      Begin
        tmp := Target[I];
        Target[I] := Target[J];
        Target[J] := tmp;
      End;

  Num := 0;
  For A := 1 To 44 Do
    For B := A + 1 To 45 Do
      For C := B + 1 To 46 Do
        For D := C + 1 To 47 Do
          For E := D + 1 To 48 Do
            For F := E + 1 To 49 Do
            Begin
              If (A = Target[1]) And
                 (B = Target[2]) And
                 (C = Target[3]) And
                 (D = Target[4]) And
                 (E = Target[5]) And
                 (F = Target[6]) Then
              Begin
                For I := 1 To 24 Do
                Begin
                  Write(Num And 1);
                  Num := Num Shr 1;
                End;
                Writeln;
                Halt;
              End;
              Inc(Num);
            End;
End;

Procedure BahurDecode;

Var
  Num : Integer;
  Target : Integer;
  A, B, C, D, E, F : Integer;
  I : Integer;
  S : String;

Begin
  Readln(S);
  Target := 0;
  For I := 24 DownTo 1 Do
  Begin
    Target := Target Shl 1;
    If S[I] = '1' Then
      Target := Target Or 1;
  End;

  Num := 0;
  For A := 1 To 44 Do
    For B := A + 1 To 45 Do
      For C := B + 1 To 46 Do
        For D := C + 1 To 47 Do
          For E := D + 1 To 48 Do
            For F := E + 1 To 49 Do
            Begin
              If Num = Target Then
              Begin
                Writeln(A, ' ', B, ' ', C, ' ', D, ' ', E, ' ', F);
                Halt;
              End;
              Inc(Num);
            End;
End;

Begin
  BahurEncode;
End.
