#include <stdio.h>
#include <string.h>

int TO=500000;
int a,b;
int pS[500000];
int pl[500000];

int S(int x)
{
  int i;
  int s=0;
  if (x<TO) return pS[x]+1;
  for (i=2;i<=x/2;i++)
    if (x%i==0) s+=i;
  return s+1;
}

void pre()
{
  int i,j;
  memset(pS,0,sizeof(pS));
  for (i=2;i<TO/2;i++)
  {
    for (j=2*i;j<TO;j+=i)
      pS[j]+=i;
  }
}

int seqlen(int s)
{
  int y;
  if (s==1) return 0;
  if (pl[s]) return pl[s];
  y=S(s);
  if (y>=s) return pl[s]=0;
  return pl[s]=seqlen(y)+1;
}

int main()
{
  int i,j,r=0;
  FILE *fin=fopen("seq.inp","r");
  FILE *fout=fopen("seq.out","w");
  fscanf(fin,"%i %i",&a,&b);
  if (b<TO) TO=b;
  memset(pl,0,sizeof(pl));
  pre();
  for (i=a;i<=b;i++)
    if (seqlen(i)+1>r) r=pl[j=i]+1;
  fprintf(fout,"%i %i\n",j,r);
  fclose(fout);
  return 0;
}
