#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#define MAXN 32

long long catalan[MAXN][MAXN];
char s[2*MAXN];
int is;
int st[MAXN];
int ist;
int arr[MAXN];
int iarr;
int N;
long long K;
long long P;



void read_all(void);
void do_all(void);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  FILE *f = fopen("fax.inp", "rt");
  fscanf(f, "%d %lld", &N, &K);
  fclose(f);
}



void do_all(void)
{
  int i, j;
  long long d1, d2;

  N += 4;
  catalan[1][0] = 1ll;
  for (i = 1; i <= N; i++) {
    for (j = i; j <= N; j++) {
      catalan[i][j] = catalan[i][j-1] + catalan[i-1][j];
    }
  }
  N -= 4;
  P = catalan[N+1][N+1];
  i = j = N+1;
  for (is = 0; is < 2*N; is++) {
    d1 = catalan[i][j-1];
    d2 = catalan[i-1][j];
    if (K > d1) {
      K -= d1;
      s[is] = '(';
      i--;
    }
    else {
      s[is] = ')';
      j--;
    }
  }

  ist = iarr = 0;
  for (j = 1, i = 0; s[i]; i++) {
    if (s[i] == '(') {
      st[ist++] = j++;
    }
    else {
      arr[iarr++] = st[--ist];
    }
  }
}



void write_all(void)
{
  int i;
  
  FILE *f = fopen("fax.out", "wt");
  fprintf(f, "%lld\n", P);
  for (i = 0; i < N; i++) {
    fprintf(f, "%d%s", arr[i], (i==N-1)?"\n":" ");
  }
  fclose(f);
}
