#include <stdio.h>

#define VBIG 0x3F3F3F3F
#define VB1 0x3F

int gr[1024][1024];
int grc[1024];

int gor[1024];
int ine[1024];
int ind[1024];

int n,m,ffr,fto;

int main(void)
{
  FILE* f;
  int i,j,a,b,c,gth,ith,p;
  double r;

  memset(gr,VB1,1024*1024*4);
  
  f = fopen("hill.inp","rt");
  fscanf(f,"%d %d ",&n,&m);
  for (i=0;i<m;i++)
  {
    fscanf(f,"%d %d %d ",&a,&b,&c); a--; b--;
    gr[a][b] = c; grc[a]++;
    gr[b][a] = c; grc[b]++;
  }
  fscanf(f,"%d %d ",&ffr,&fto); ffr--; fto--;
  fclose(f);

  for (i=0;i<n;i++) { gor[i]=VBIG; } gor[ffr]=0; // Start from

  for (j=0;j<n;j++)
  {

/*    printf("Step %d\n",j);
    for (i=0;i<n;i++)
    {
      printf("%.2lf:%.2lf ",(double)(gor[i]*.25),(double)(ine[i]*.25));
    }
    printf("\n"); */
  
    p = -1; gth=VBIG-1; ith=0;
    for (i=0;i<n;i++)
    {
      if (ind[i]==0)
      {
        if ((gor[i]<gth) || ((gor[i]==gth) && (ine[i]>ith)))
        {
          p = i;
          gth = gor[i];
          ith = ine[i];
        }
      }
    }
    if (p==-1) { break; }
    ind[p]=1;
    
    for (i=0;i<n;i++)
    {
      if (ind[i]) { continue; }
      
      if (gr[p][i]!=VBIG)
      {
        // Fuel consumed
        a = gr[p][i]*2 - ith;
        if (a<0) { a=0; } a+=gth;
        // New inertia
        b = gr[p][i];

        if ((a<gor[i]) || ((a==gor[i]) && (b>ine[i])))
        {
          gor[i]=a;
          ine[i]=b;
        }
      }
    }
  }

  r = (double)gor[fto]*.25 + 1e-4;

  f = fopen("hill.out","wt");
  fprintf(f,"%.2lf\n",r);
  fclose(f);
  
  return 0;
}
