#include <stdio.h>

#define INP "hill.inp"
#define OUT "hill.out"

#define MAX_P 1010
#define INF 2000000000
#define real float

int m,n,x[MAX_P][MAX_P];
int A,B;

real max(real a, real b) { if (a>b) return a; else return b; }

void init () {
int a,b,c;
int i;
     FILE *f = fopen ( INP , "r");
     fscanf(f,"%d%d",&n,&m);
     for (i=1;i<=m;i++) {
         fscanf(f,"%d%d%d",&a,&b,&c);
         x[a][b] = x[b][a] = c;
     }
     fscanf(f,"%d%d",&A,&B);
}

void solve () {
real dist[MAX_P];
int prev[MAX_P];
int minn;
real min;
int i;
real dst;
char visited[MAX_P];
     FILE *f = fopen ( OUT , "w");
     for (i=0;i<MAX_P;i++) {
         visited[i] = 0;
         prev[i] = 0;
         dist[i] = INF;
     }
     dist[A] = 0;
     while (1) {
           minn = -1;
           min = INF;
           for (i=1;i<=n;i++)
               if ((dist[i]<min)&&(!visited[i])) {
                  min = dist[i];
                  minn = i;
               }
           if (minn ==-1) break;
           visited[minn] = 1;
           for (i=1;i<=n;i++)
               if (x[minn][i]) {
                  dst = dist[minn]+max(x[minn][i]/2.0-x[prev[minn]][minn]/4.0,0);
                  if (dst<dist[i]) { dist[i] = dst; prev[i] = minn; }
               }
     }
     if (dist[B]==INF) fprintf(f,"0\n"); else
     fprintf(f,"%.2f\n",dist[B]);
     fclose(f);
}


int main () {
    init ();
    solve();
    return 0;
}
