#include <stdio.h>
#include <string.h>

#define INP "naver.inp"
#define OUT "naver.out"
#define MAXC 601
#define MAXL 1010

int n = 0;
int m[MAXC],o[MAXC];
int og[MAXC];
int x[MAXC][MAXC];
int sz = 0;

int cmp(const void *a, const void *b) { return *((int *)a)-*((int *)b); }

void init () {
     FILE *f = fopen ( INP , "r");
     while (!feof(f)) fscanf(f,"%d\n",&m[++n]);
     fclose(f);
     memset(og,0,sizeof(og));
}

/*void impossible () {
     printf("Incorrect data\n");
     exit(0);
}*/

void build() {
int i,j,k;
     memset(og,0,sizeof(og));
     for (i=1;i<=n;i++)
         for (j=1;j<=n;j++)
             if (i!=j)
                  for (k=j+1;k<=n;k++)
                      if (i!=k) {
                         if (2*m[i]==(m[j]+m[k])) {
                            if (x[i][j]) {
//                               if (x[k][i]) impossible();
                               x[i][k] = 1;
                               continue;
                            }
                            if (x[i][k]) {
//                               if (x[i][j]) impossible();
                               x[i][j] = 1;
                               continue;
                            }
                            if (x[j][i]) {
//                               if (x[i][k]) impossible();
                               x[k][i] = 1;
                               continue;
                            }
                            if (x[k][i]) {
//                               if (x[i][j]) impossible();
                               x[j][i] = 1;
                               continue;
                            }
                            x[i][j] = 1;
                            x[i][k] = 1;
                         }
                         if ((m[j]+m[k])>2*m[i]) break;
                      }
     for (i=1;i<=n;i++)
         for (j=1;j<=n;j++)
             if (x[i][j]) og[i]++;
}

int ok() {
int i,j,k;
    for (i=1;i<=n;i++)
        for (j=1;j<i;j++)
            for (k=i+1;k<=n;k++)
                if (2*m[o[i]]==(m[o[j]]+m[o[k]])) return 0;
    return 1;

}

int ok2() {
int i,j,k;
    for (i=1;i<=n;i++)
        for (j=1;j<i;j++)
            for (k=i+1;k<=n;k++)
                if (2*o[i]==(o[j]+o[k])) return 0;
    return 1;

}


void printam() {
int i,j;
     for (i=1;i<=n;i++) {
         for (j=1;j<=n;j++)
             printf("%d ",x[i][j]);
         printf("\n");
     }
}

void solve () {
int i,j;
int l = 1;
     build();
//     printam();
     while (l<=n) {
           for (i=1;i<=n;i++)
               if (og[i]==0) {
                  og[i]=-1;
                  for (j=1;j<=n;j++) if (x[j][i]) { x[j][i] = 0; og[j]--; }
                  o[l] = i;
                  break;
               }
           if (i>n) {
              for (i=1;i<=n;i++)
                  if (og[i]!=(-1)) o[l++] = i;
           }
           l++;
     }
}

void print () {
int i;
     FILE *f = fopen ( OUT , "w");
     for (i=1;i<=n;i++)
         fprintf(f,"%d%c",m[o[i]],(i==n)?('\n'):(' '));
     fclose(f);
     exit(0);
}

void print2 () {
int i;
     FILE *f = fopen ( OUT , "w");
     for (i=1;i<=n;i++)
         fprintf(f,"%d%c",o[i],(i==n)?('\n'):(' '));
     fclose(f);
     exit(0);
}

void solve_again() {
int i;
int odd[MAXC],even[MAXC],e1[MAXC],e2[MAXC],o1[MAXC],o2[MAXC];
int ec=0,oc=0,e1c=0,e2c=0,o1c=0,o2c=0;
int step;
     memset(odd,0,sizeof(odd));
     memset(even,0,sizeof(even));
     memset(e1,0,sizeof(e1));
     memset(e2,0,sizeof(e2));
     memset(o1,0,sizeof(o1));
     memset(o2,0,sizeof(o2));
     for (i=1;i<=n;i++)
         if (m[i]%2) odd[++oc] = m[i]; else even[++ec] = m[i];
     step = 0;
     for (i=ec-1;i>0;i-=2) {
         step++;
         e1[++e1c] = even[i]; e2[++e2c] = even[i-1];
/*         if (step%2) { e1[++e1c] = even[i]; e2[++e2c] = even[i-1]; }
         else     { e1[++e1c] = even[i-1]; e2[++e2c] = even[i]; }*/
     }
     step = 0;
     for (i=oc-1;i>0;i-=2) {
         step++;
         o1[++o1c] = odd[i]; o2[++o2c] = odd[i-1];
/*         if (step%2) { o1[++o1c] = odd[i]; o2[++o2c] = odd[i-1]; }
         else     { o1[++o1c] = odd[i-1]; o2[++o2c] = odd[i]; }*/
     }
     if (e1[e1c]==0) e1c--;
     if (e2[e2c]==0) e2c--;
     if (o1[o1c]==0) o1c--;
     if (o2[o2c]==0) o2c--;     
     for (i=o1c;i>0;i--) o[++sz] = o1[i];
     if (oc>0) o[++sz] = odd[oc];
     for (i=1;i<=o2c;i++) o[++sz] = o2[i];
     for (i=e1c;i>0;i--) o[++sz] = e1[i];
     if (ec>0) o[++sz] = even[ec];
     for (i=1;i<=e2c;i++) o[++sz] = e2[i];
}


void solve_again2() {
int i;
int odd[MAXC],even[MAXC],e1[MAXC],e2[MAXC],o1[MAXC],o2[MAXC];
int ec=0,oc=0,e1c=0,e2c=0,o1c=0,o2c=0;
int step;
     memset(odd,0,sizeof(odd));
     memset(even,0,sizeof(even));
     memset(e1,0,sizeof(e1));
     memset(e2,0,sizeof(e2));
     memset(o1,0,sizeof(o1));
     memset(o2,0,sizeof(o2));
     for (i=1;i<=n;i++)
         if (m[i]%2) odd[++oc] = m[i]; else even[++ec] = m[i];
     step = 0;
     for (i=ec-1;i>0;i-=2) {
         step++;
//         e1[++e1c] = even[i]; e2[++e2c] = even[i-1];
         if (step%2) { e1[++e1c] = even[i]; e2[++e2c] = even[i-1]; }
         else     { e1[++e1c] = even[i-1]; e2[++e2c] = even[i]; }
     }
     step = 0;
     for (i=oc-1;i>0;i-=2) {
         step++;
//         o1[++o1c] = odd[i]; o2[++o2c] = odd[i-1];
         if (step%2) { o1[++o1c] = odd[i]; o2[++o2c] = odd[i-1]; }
         else     { o1[++o1c] = odd[i-1]; o2[++o2c] = odd[i]; }
     }
     if (e1[e1c]==0) e1c--;
     if (e2[e2c]==0) e2c--;
     if (o1[o1c]==0) o1c--;
     if (o2[o2c]==0) o2c--;     
     for (i=o1c;i>0;i--) o[++sz] = o1[i];
     if (oc>0) o[++sz] = odd[oc];
     for (i=1;i<=o2c;i++) o[++sz] = o2[i];
     for (i=e1c;i>0;i--) o[++sz] = e1[i];
     if (ec>0) o[++sz] = even[ec];
     for (i=1;i<=e2c;i++) o[++sz] = e2[i];
     print2();
}

int main () {
    init ();
    qsort(m,n+1,sizeof(int),cmp);
    solve();
    if (ok()) print();
    solve_again();
    if (ok2()) print2();
    solve_again2();
    if(ok2()) print2();
    return 0;
}
