const inp = 'hill.inp';
      out = 'hill.out';
      MaxN = 1000;
      BEZKRAINOST = 250000000;

type TGrid = array[1..MaxN, 1..MaxN] of integer;
     Tcost = array[1..MaxN] of int64;
     TE = array[1..MaxN] of integer;
     TUsed = array[1..MaxN] of boolean;


var Fin, Fout: text;
    n, A, B, ind: integer;
    m: longint;
    path: TGrid;
    used: Tused;
    e: TE;
    cost: TCost;

{############################################################################}
procedure Done;
begin
close(fin); close(fout);
halt;
end;

{############################################################################}
procedure Init;
var i: longint;
    g1, g2, l: integer;

begin
assign(Fin, inp); reset(Fin);
assign(Fout, out); rewrite(Fout);
readln(Fin, n ,m);
fillchar(path, sizeof(path), 0);
for i:=1 to m do
  begin
  readln(Fin, g1, g2, l);
  path[g1, g2]:= 4*l;
  path[g2, g1]:= 4*l;
  end;
readln(Fin, A, B);
if A=b then
  begin
  writeln(Fout, '0.00');
  done;
  end;
end;

{############################################################################}
Procedure Solve;
var i: integer;
    R: real;

begin
for i:=1 to n do cost[i]:= BEZKRAINOST;
fillchar(E, sizeof(E), 0);
fillchar(used, sizeof(used), false);

cost[A]:= 0;
e[A]:= 0;
ind:= A;

while ind <> B do
  begin
  used[ind]:= true;
  for i:=1 to n do
    if (not used[i]) and (i <> ind) and (path[i, ind] <> 0) then
      if cost[i] > cost[ind] + path[i, ind] div 2 - e[ind] then
        begin
        cost[i]:= cost[ind] + path[i, ind] div 2 - e[ind];
        e[i]:= path[i, ind] div 4;
        end;
  ind:= 0;
  for i:=1 to n do
    if (not used[i]) and (cost[i] < BEZKRAINOST) then
      begin
      ind:= i; break;
      end;
  if ind=0 then
    begin
    writeln(Fout, 0);
    done;
    end;
  for i:= ind+1 to n do
    if (not used[i]) and (cost[i] < cost[ind]) then ind:= i;
  end;
R:= cost[B];
R:= R / 4;
writeln(Fout, R:0:2);
end;

{############################################################################}
{############################################################################}
{############################################################################}
BEGIN
Init;
Solve;
Done;
END.
