{$MODE objfpc}

Uses
  SysUtils;

Type
  MyExcp = Class(Exception)
  End;

Const
  timeLim = 21;

Var
  N : Integer;
  Ar : Array[0..567] Of Integer;
  Pr : Array[0..567] Of Integer;
  Used : Array[0..567] Of Boolean;
  timeS, timeC : Word;

Procedure Shuffle;

Var
  I, J, K : Integer;
  tmp : Integer;

Begin
  For K := 1 To 1000 Do
  Begin
    I := Random(N) + 1;
    J := Random(N) + 1;
    tmp := Ar[I];
    Ar[I] := Ar[J];
    Ar[J] := tmp;
  End;
End;

Procedure WriteOut;

Var
  I : Integer;
  F : Text;

Begin
  ASSign(F, 'NAVER.OUT');
  Rewrite(F);
  Write(F, Pr[1]);
  For I := 2 To N Do
    Write(F, ' ', Pr[I]);
  Writeln(F);
  Close(F);
  Halt;
End;

Function Check : Boolean;

Var
  I, J, K : Integer;

Begin
  For K := 2 To N - 1 Do
    For I := 1 To K - 1 Do
      For J := K + 1 To N Do
        If (Pr[I] + Pr[J]) = (2*Pr[K]) Then
          Exit(False);
  Check := True;
End;

Function Check(N : Integer) : Boolean;

Var
  I, J, K : Integer;

Begin
  For K := 2 To N - 1 Do
    For I := 1 To K - 1 Do
      If (Pr[I] + Pr[N]) = (2*Pr[K]) Then
        Exit(False);
  Check := True;
End;

Procedure Bahur(Q : Integer);

Var
  I : Integer;

Begin
  If Q > N Then
    If Check Then
      WriteOut;
  timeC := MemW[$46C];
  If Word(timeC - timeS) > timeLim Then
    Raise MyExcp.Create('...');
  For I := 1 To N Do
    If Not Used[I] Then
    Begin
      Used[I] := True;
      Pr[Q] := Ar[I];
      If Check(Q) Then
        Bahur(Q + 1);
      Used[I] := False;
    End;
End;

Procedure ReadIn;

Var
  F : Text;

Begin
  N := 0;
  ASSign(F, 'NAVER.INP');
  Reset(F);
  While Not EoLn(F) Do
  Begin
    Inc(N);
    Read(F, Ar[N]);
  End;
  Close(F);
End;

Begin
  ReadIn;
  Repeat
    Try
      timeS := MemW[$46C];
      FillChar(Used, SizeOf(Used), 0);
      Bahur(1);
    Except
      On MyExcp Do
        Shuffle;
    End;
  Until False;
End.
