var
  a: array[1..210,1..210] of byte;
  u,v: array[1..16] of integer;
  s: array[1..16] of byte;
  n,m,k: integer;
  i,j,v1,v2: integer;
  F: text;
  name: string;

function StrongConnected: Boolean;
var
  cntA,cntB,i: integer;
  visited: array[1..210] of byte;

Procedure DFSA(u: integer);
var
  v: integer;
begin
  visited[u]:=1;
  cntA:=cntA+1;
  for v:=1 to n do
    if (visited[v]=0) and  (a[u,v]=1) then
      DFSA(v);
end;

Procedure DFSB(u: integer);
var
  v: integer;
begin
  visited[u]:=1;
  cntB:=cntB+1;
  for v:=1 to n do
    if (visited[v]=0) and  (a[v,u]=1) then
      DFSB(v);
end;

begin
  for i:=1 to n do
    visited[i]:=0;
  cntA:=0;
  DFSA(1);
  for i:=1 to n do
    visited[i]:=0;
  cntB:=0;
  DFSB(1);
  if (cntA=n) and (cntB=n) then
    StrongConnected:=true
  else
    StrongConnected:=false;
end;


begin
  readln(n,m,k);
  for i:=1 to n do
    for j:=1 to n do
      a[i,j]:=0;
  for i:=1 to m-k do
    begin
      readln(v1,v2);
      Inc(a[v1,v2]);
    end;
  for i:=1 to k do
    begin
      readln(u[i],v[i]);
      Inc(a[u[i],v[i]]);
    end;

  for i:=1 to k do
    s[i]:=0;

  repeat
    for i:=1 to k do
      if s[i]=0 then
        begin
          a[u[i],v[i]]:=1;
          a[v[i],u[i]]:=0;
        end
      else
        begin
          a[u[i],v[i]]:=0;
          a[v[i],u[i]]:=1;
        end;

    if StrongConnected then
      begin
        for i:=1 to k do
          write(s[i]);
        writeln;
        exit;
      end;

   i:=k;
   while (i>0) and (s[i]=1) do
     begin
       s[i]:=0;
       i:=i-1;
     end;
   if i>0 then s[i]:=1;
  until i=0;

  writeln('No way');

end.
