program friend;

const
	MAXN					= 30000;

type
	Integer					= LongInt;

var
	fp					: Array [1 .. MAXN] of Integer;
	Max					: Array [1 .. MAXN] of Integer;
	i, j, N, M				: Integer;

procedure writeMax;
var
	i, maxx					: Integer;
begin
	for i := 1 to N do Max[i] := 0;
	for i := 1 to N do inc(Max[fp[i]]);
	maxx := Max[1];
	for i := 2 to N do
		if (maxx < Max[i]) then
			Max[i] := maxx;
	writeln(maxx);
end;

procedure somethingLikeSort(a, b : Integer; var c, d : Integer);
begin
	if (fp[a] > fp[b]) then begin
		c := b;
		d := a;
	end
	else begin
		c := a;
		d := b;
	end;
end;

procedure read_and_solve;
var
	a, b					: Integer;
	c, d					: Integer;
begin
	readln(N, M);
	for i := 1 to M do begin
		readln(a, b);
		if (fp[a] <> fp[b]) then begin
			somethingLikeSort(a, b, c, d);
			for j := 1 to (d - 1) do
				if (fp[j] = fp[d]) then
					fp[j] := fp[c];
			for j := (d + 1) to N do
				if (fp[j] = fp[d]) then
					fp[j] := fp[c];
			fp[d] := fp[c];
		end;
	end;
end;

procedure Init;
begin
	for i := 1 to MAXN do begin
		fp[i] := i;
	end;
end;
		

begin
	Init;
	read_and_solve;
	writeMax;
end.