program sork;

uses
	usrv;

const
	get_k						= 0;
	get_c						= 1;
	send_c						= 2;
	stop						= 3;

type
	Integer						= LongInt;

var
	K						: Integer;
	F						: Array [1 .. 200] of Integer;
	finished					: Array [1 .. 200] of Boolean;
	answ						: LongInt;

procedure Init;	
var
	i						: Integer;
begin
	srv(get_k, 1024,  K);
	for i := 1 to K do
		finished[i] := False;
end;

function finally_done : Boolean;
var
	i						: Integer;
begin
	for i := 1 to K do
		if (not finished[i]) then begin
			finally_done := False;
			Exit;
		end;
	finally_done := True;
end;

procedure Solve;
var
	i						: Integer;
	tmin, min					: Integer;
begin
	for i := 1 to K do
		srv(get_c, i, F[i]);
	repeat
		tmin := 2000000001;
		for i := 1 to K do
			if (not finished[i]) and (F[i] < tmin) then begin
				tmin := F[i];
				min := i;
			end;
		srv(send_c, F[min], answ);
		srv(get_c, min, F[min]);
		if (F[min] = -1) then
			finished[min] := True;
	until(finally_done);
end;

procedure Finalize;
begin
	srv(stop, 1024, answ);
end;

begin
	Init;
	Solve;
	Finalize;
end.
	