#include <fstream.h>

extern void srv(int, int, int*);

#define MAXOP 249000
#define MAX   4000000
#define MAXVAL 2000000001

int N,res;
int data[MAX];
int count=0;
int empty[300];
int nempty=0;
int sorted=0;
int opers=0;



void adjust_up(int x)
 {
  int save = data[x];
  int parent = x / 2;
  while (parent>=1)
   {
    if (save>data[parent])
     {
      data[x] = data[parent];
      x = parent;
     };
    parent/=2;
   };
  data[x] = save;
 };

void adjust_down()
 {
  int parent = 1;
  int save = data[1];
  int child = 2;
  while (child<=count)
   {
    if ((child+1)<=count)
     if (data[child+1]>data[child])
      child++;
    if (save<data[child])
     {
      data[parent] = data[child];
      parent = child;
      child*=2;
     }
    else
     break;
   };
  data[parent]=save;
 };


void insert(int d)
 {
  count++;
  data[count]=d;
  adjust_up(count);
 };


int extract()
 {
  if (count<1)
   return MAXVAL;
  int save = data[1];
  data[1] = data[count];
  count--;
  adjust_down();
  return save;
 };

void testheap()
 {
  insert(-5);
  insert(-10);
  insert(-9);
  cout << extract()<<endl;
  cout << extract()<<endl;
  cout << extract()<<endl;
  cout << extract()<<endl;  
 };

int main()
 {
//  testheap();
//  cout<<endl;
//  cout<<endl;
  srv(0,0,&N);
//  cout << N <<endl;
  while (nempty<N)
   {
    if (opers==MAXOP)
     {
      opers=0;
      res = extract();
      if (res!=MAXVAL)
       srv(2,res,NULL);
     };
    int i;
    for (i=1;i<=N;i++)
     if (empty[i]==0)
      {
       srv(1,i,&res);
//       cout<<res<<endl;
       opers++;
       if (res==-1)
        {
         nempty++;
         if (nempty==N)
          {
           break;
          };
         empty[i]=1;
        }
       else //res!=-1
        {
         insert(-res);
        };
      };
    res = extract();
    if (res!=MAXVAL)
     {
      srv(2,-res,NULL);
      opers--;
     };
   };
  res=extract();
  while (res!=MAXVAL)
   {
    srv(2,-res,NULL);
    res = extract();
   };
  srv(3,0,&N);
 };
