#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define INP "friend.in"
#define OUT "friend.out"

#define MAXV 31000
#define MAXE 510000

long *t[MAXV];
long v[MAXV];
long l[MAXE],r[MAXE];
long sz[MAXV];
long size = 0;
long m,n;
long max = -1;

void DFS(int node) {
int i;
	if (v[node]) return;
	v[node] = 1;
	size++;
	for (i=0;i<sz[node];i++)
		DFS(t[node][i]);
}

int main () {
int i;
	FILE *f;// = fopen ( INP , "r");
	f = stdin;
	fscanf(f,"%d%d",&n,&m);
	memset(sz,0,sizeof(sz));
	for (i=0;i<m;i++) {
		fscanf(f,"%d%d",&l[i],&r[i]);
		sz[l[i]]++;
		sz[r[i]]++;
	}
//	fclose(f);
	for (i=1;i<=n;i++) {
		t[i] = (long *)malloc(sizeof(long)*(sz[i]+3));
		sz[i] = 0;
	}
	for (i=0;i<m;i++) {
	int x = l[i],y = r[i];
		t[x][sz[x]++] = y;
		t[y][sz[y]++] = x;
	}
	memset(v,0,sizeof(v));
	for (i=1;i<=n;i++) {
		if (!v[i]) {
			size = 0;
			DFS(i);
			if (size>max) max = size;
		}
	}
	printf("%d\n",max);
	return 0;
}