#include <stdio.h>
#include <string.h>
//#include <time.h>
#include <vector>
#include <queue>
#define MAXN 30010

short group[MAXN];
short gr_br=0;
short br[MAXN+1];
vector<short> nasl[MAXN];
int n,m;
int mmax=0;

void Init()
  {
    int a,b;
//    freopen("friend.in","rt",stdin);
    scanf("%d%d",&n,&m);
    memset(group,0,sizeof(group));
    memset(br,0,sizeof(br));
    for(int i=0;i<m;i++)    
      {
        scanf("%d%d",&a,&b);
        a--;
        b--;
        nasl[a].push_back(b);
        nasl[b].push_back(a);
      }
  }

void BFS(short vr)
  {
    queue<short> q;
    short v;
    q.push(vr);
    group[vr]=gr_br;
    br[gr_br]++;
    while(!q.empty())
      {
        v=q.front();
        q.pop();
        for(int i=0;i<nasl[v].size();i++)
          if(!group[nasl[v][i]])
            {
              q.push(nasl[v][i]);
              group[nasl[v][i]]=gr_br;
              br[gr_br]++;
            }
      }
  }

void Solve()
  {
    for(int i=0;i<n;i++)
      if(!group[i])
        {
          gr_br++;
          BFS(i);
          if(br[gr_br]>mmax) mmax=br[gr_br];
        }
  }

void Output()
  {
    printf("%d\n",mmax);
  }

int main()
  {
//    clock();
    Init();
    Solve();
    Output();
//  printf("Time : %f\n",(double)clock()/CLOCKS_PER_SEC);
    return 0;
  }
