type
  PTVert = ^TVert;
  TVert = record
    no: longint;
    next: PTVert;
  end;

var
  m: array[1..30000] of PTVert;
  o: array[1..30000] of PTVert;
  vis: array[1..30000] of boolean;
  n,k,i,x,y,max,c: longint;

procedure add(v,s: longint);
var q: PTVert;
begin
  new(q);
  q^.no:= s;
  q^.next:= nil;
  if m[v] = nil then
  begin
    m[v]:= q;
    o[v]:= q;
  end else
  begin
    o[v]^.next:= q;
    o[v]:= o[v]^.next;
  end;
end;

procedure scan(x: longint);
var q: PTVert;
begin
  vis[x]:= true;
  c:= c + 1;
  q:= m[x];
  while q <> nil do
  begin
    if not vis[q^.no] then scan(q^.no);
    q:= q^.next;
  end;
end;

begin
  readln(n,k);
  for i:= 1 to n do m[i]:= nil;
  for i:= 1 to n do o[i]:= nil;
  for i:= 1 to n do vis[i]:= false;
  for i:= 1 to k do
  begin
    readln(x,y);
    add(x,y);
    add(y,x);
  end;
  max:= 0;
  for i:= 1 to n do if not vis[i] then
  begin
    c:= 0;
    scan(i);
    if c > max then max:= c;
  end;
  writeln(max);
end.