#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define maxn 30110 // trq sa 30000
#define maxp 500100 // trq sa 500000

  long n, m;
  long Pa[maxp][2];
  long *A[maxn];
  long V[maxn];
  long Gr[maxn];
  long gbr;
  long P[maxn];

  void ReadData ()
    {
      long i;
      scanf ("%ld %ld",&n,&m);
      for (i = 1; i <= m; i++)
	{
	  scanf ("%ld %ld",&Pa[i][0],&Pa[i][1]);
	  V[Pa[i][0]]++;
	  V[Pa[i][1]]++;
	}
      for (i = 1; i <= n; i++)
	A[i] = (long*)calloc (V[i] + 3, sizeof (long));
      memset (V, 0, sizeof (V));
      long x, y;
      for (i = 1; i <= m; i++)
	{
	  x = Pa[i][0];
	  y = Pa[i][1];
	  V[x]++;
	  V[y]++;
	  A[x][V[x]] = y;
	  A[y][V[y]] = x;
	}
    }

  void DFS (long vr)
    {
      P[vr] = 1;
      Gr[gbr]++;
      for (long i = 1; i <= V[vr]; i++)
	if (!P[A[vr][i]])
	  DFS (A[vr][i]);
    }

  long Solve ()
    {
      long i;
      for (i = 1; i <= n; i++)
	if (!P[i])
	  {
	    gbr++;
	    DFS (i);
	  }
      long res = -1;
      for (i = 1; i <= gbr; i++)
	if (Gr[i] > res)
	  res = Gr[i];
      return res;
    }

  int main ()
    {
      ReadData ();
      printf ("%ld\n",Solve ());
      return 0;
    }
