#include <stdio.h>
#include <stdlib.h>

#define true 1
#define false  0

struct Node;

typedef struct Node *List;

struct Node {
	int d;
	List next;
};

void insert(List *l, int x) {
	List p;
	if (*l == NULL) {
		*l = malloc(sizeof(struct Node));
		(*l)->d = x;
		(*l)->next = NULL;
		return;
	}
	p = *l;
	for ( ; ; ) {
		if (p->d == x) return;
		if (p->next == NULL) {
			p->next = malloc(sizeof(struct Node));
			p->next->d = x;
			p->next->next = NULL;
			return;
		}
		p = p->next;
	}

}

int num[30000 + 1];
int visited[30000 + 1];
int N;
int M;
List a[30000 + 1];
int c;

void dfs(int x, int c) {/* JG 'c' kato global promenliva?*/
	List p;
	if (visited[x]) return;
	visited[x] = true;
	num[c]++;
	p = a[x];
	while (p != NULL) {
		dfs(p->d, c);
		p = p->next;
	}
}


void dfs2(int x) {
	List p;
	if (visited[x]) return;
	visited[x] = true;
	num[c]++;
	p = a[x];
	while (p != NULL) {
		dfs2(p->d);
		p = p->next;
	}
}

int main(void) {
	int i;
	int max;
	List p;
	scanf("%d%d", &N, &M);
	for (i = 1; i <= N; i++) {
		a[i] = NULL;
		num[i] = 0;
		visited[i] = false;
	}


	for (i = 0; i < M; i++) {
		int tmpa;
		int tmpb;
		scanf("%d%d", &tmpa, &tmpb);
		/*
		printf("tmpa=%d\n", tmpa);
		printf("tmpb=%d\n", tmpb);
		*/
		insert(&a[tmpa], tmpb);
		insert(&a[tmpb], tmpa);
	}

	/*
	for (i = 1; i <= N; i++) {
		printf("%d: ", i);
		p = a[i];
		while (p != NULL) {
			printf("%d -> ", p->d);
			p = p->next;
		}
		printf("\n");
	}
	*/

	for (i = 1; i <= N; i++) {
		/*
		dfs(i, i);
		*/
		c = i;
		dfs2(i);
	}

	/*
	for  (i = 1; i <= N; i++) {
		printf("num[%d]=%d\n", i, num[i]);
	}
	*/

	max = 0;
	for (i = 1; i <= N; i++) {
		if (num[i] > max) max = num[i];
	}

	printf("%d\n", max);
	
	return 0;
}
