#include <stdio.h>
#include <stdlib.h>
#define MAX 1<<15
FILE *fi, *fo;
typedef struct vex vex;
struct vex  {
  int d;
  vex *v;
};

vex vx[MAX];
int v[MAX];
int vn, en;
int cur, ans;

void add (int d1, int d2)  {
  vex *t=&vx[d1];
  while (t->v!=NULL)  {
    if (t->v->d==d2) return;
    t=t->v;
  }
  t->v=(vex*) malloc (sizeof(vex*));
  t->v->d=d2;
  t->v->v=NULL;
}
void init ()  {
  int i, x, y;
//fi=fopen ("friend.in", "r");
//fo=fopen ("friend.out", "w");
  fi=stdin;
  fo=stdout;
  fscanf (fi, "%d%d", &vn, &en);
  for (i=1; i<=en; ++i)  {
    fscanf (fi, "%d%d", &x, &y);
    add (x,y);
    add (y,x);
  }
}
void dfs (int i)  {
  vex *t=&vx[i];
  ++cur;
  v[i]=1;
  while (t->v!=NULL)  {
    if (!v[t->v->d]) dfs (t->v->d);
    t=t->v;
  }
}
void think ()  {
  int i;
  for (i=1; i<=vn; ++i)
    if (!v[i])  {
      cur=0;
      dfs (i);
      if (ans<cur) ans=cur;
    }
}
void print ()  {
/*
  int i;
  vex *t;
  for (i=1; i<=vn; ++i)  {
    printf ("%d", i);
    t=&vx[i];
    while (t->v!=NULL)  {
      printf (" %d", t->v->d);
    t=t->v;
    }
    printf ("\n");
  }
*/
  fprintf (fo, "%d", ans);
  fclose (fi);
  fclose (fo);
}
int main ()  {
  init ();
  think ();
  print ();
  return 0;
}

