/* INCLUDES *****************************************************************/
   #include <iostream>
   //#include <cstdlib>

   #include <vector>
   #include <queue>

   using namespace std;

/* CONSTANTS ****************************************************************/
/* CLASSES ******************************************************************/
/* GLOBALS ******************************************************************/

   int n;
   vector<vector<int> > es;

   int maxg;

   vector<bool> vs;

   queue<int> q;

/* FUNCTIONS ****************************************************************/
/****************************************************************************/
/*   void done()
   {
      exit(0);
   }
/****************************************************************************/
   void init()
   {
      cin >> n;
      es.resize(n + 2);

      int m;
      cin >> m;
      for (int i = 0; i < m; ++i)
      {
         int a;
         int b;

         cin >> a >> b;

         es[a].push_back(b);
         es[b].push_back(a);
      }
   }
/****************************************************************************/
/****************************************************************************/
   void run()
   {
      maxg = 0;

      vs.resize(n + 2, false);

      for (int i = 1; i <= n; ++i)
         if (vs[i] == false)
         {
            int _maxg = 1;

            vs[i] = true;
            q.push(i);
            while (!q.empty())
            {
               int v = q.front();
               q.pop();

               for (int i = 0; i < es[v].size(); ++i)
                  if (vs[es[v][i]] == false)
                  {
                     ++_maxg;
                     vs[es[v][i]] = true;
                     q.push(es[v][i]);
                  }
            }
            if (_maxg > maxg) maxg = _maxg;
         }

      cout << maxg << endl << flush;
   }
/****************************************************************************/
   int main()
   {
      init();
      run();
      //done();

      return 0;
   }
/****************************************************************************/

