#include <stdio.h>

char state[101];
int n;

// pc's_numbers_that_k_will_cross - our_numbers_that_k_will_cross
int how_much_good(int k)
{
    int i;
    int q=0;                            // base quality = 0

    for (i=1;i<=n;i++)                  // look for k's divisors in 1..N
        if (k%i==0 && state[i]=='O')    // if this number will be crossed
        {
            if (i%2==1) q++;            // ... and it will cross pc's number, it is good
            else q--;                   // ... else it's bad
        }
        
    return q;
}

int main()
{
    int i,best,best_c;

    scanf("%d ",&n);                    // get N
    scanf("%s",&state[1]);              // get current state

    i=1;                                // find first possible number
    while (state[i]!='O' || i%2)        // continue while odd or crossed
          i++;
    best=i;
    best_c=how_much_good(i);            // i's "quality"


    for (i=1;i<=n;i++)                  // we will try each number to see if it's better
    {
        if (i%2) continue;              // we are interested only in even numbers
        if (state[i]!='O') continue;    // ... and not crossed ones
        
        if (how_much_good(i)>best_c)    // if i is better than best,
        {
            best=i;                     // save i
            best_c=how_much_good(i);    // ... and it's "quality"
        }
    }

    printf("%d\n",best);                // output best number
    
    return 0;
}
