program expr;

type
	Integer				= LongInt;

var
	N, K				: Integer;
	M				: Array [1 .. 8] of Integer;
	B				: Array [1 .. 3000] of Boolean;

procedure readInput;
begin
	readln(N);
	K := 0;
	while (not eoln) do begin
		K := K + 1;
		read(M[K]);
	end;
end;	

procedure Init;
var
	i				: Integer;
begin
	for i := 1 to 3000 do
		B[i] := False;
	for i := 1 to K do
		B[M[i]] := True;
end;

function findInd(a : Integer) : Integer;
var
	i				: Integer;
begin
	for i := 1 to K do
		if (M[i] = a) then begin
			findInd := i;
			Exit;
		end;
end;

procedure Solve;
var
	i, j				: Integer;
	hr				: Integer;
begin
	for i := 1 to (K - 1) do
		for j := i + 1 to K do begin
			if (M[i] + M[j] = N) then begin
				writeln('(', M[i], '+', M[j], ')');
				Exit;
			end else begin
				if (M[i] + M[j] > N) and (B[M[i] + M[j] - N])
				and (findInd(M[i] + M[j] - N) <> i) and
				(findInd(M[i] + M[j] - N) <> j) then begin
					writeln('((', M[i], '+', M[j], ')-', M[i]+M[j]-N, ')');
					Exit;
				end;
				hr := N - (M[i] + M[j]);
				if (M[i] + M[j] < N) and (B[hr]) 
				and (findInd(hr) <> i) and
				(findInd(hr) <> j) then begin
					writeln('((', M[i], '+', M[j], ')+', hr, ')');
					Exit;
				end;
				hr := M[i] + M[j];
				if (hr > N) and (hr mod N = 0) and (B[hr div N]) and
				(findInd(hr div N) <> i) and (findInd(hr div N) <> j) then begin
					writeln('((', M[i], '+', M[j], ')/', hr div N, ')');	
					Exit;
				end;
				if (hr < N) and (N mod hr = 0) and (B[N div hr]) and
				(findInd(N div hr) <> i) and (findInd(N div hr) <> j) then begin
					writeln('((', M[i], '+', M[j], ')*', N div hr, ')');
					Exit;
				end;
			end;
			if (M[i] * M[j] = N) then begin
				writeln('(', M[i], '*', M[j], ')');
				Exit;
			end else begin
				hr := M[i] * M[j];
				if (hr > N) then begin
					if (B[hr - N]) and (findInd(hr - N) <> i) and
					(findInd(hr - N) <> j) then begin
						writeln('((', M[i], '*', M[j], ')-', hr-N, ')');
						Exit;
					end;
					if (hr mod N = 0) and (B[hr div N]) and
					(findInd(hr div N) <> i) and (findInd(hr div N) <> j)
					then begin
						writeln('((', M[i], '*', M[j], ')/', hr div N, ')');
						Exit;
					end;
				end else begin
					if (B[N - hr]) and (findInd(N - hr) <> i) and
					(findInd(N - hr) <> j) then begin
						writeln('((', M[i], '*', M[j], ')+', N-hr, ')');
						Exit;
					end;
					if (N mod hr = 0) and (B[N div hr]) and
					(findInd(N div hr) <> i) and (findInd(N div hr) <> j)
					then begin
						writeln('((', M[i], '*', M[j], ')*', N div hr, ')');
						Exit;
					end;
				end;
			end;
			if (M[i] > M[j]) then begin
				if (M[i] - M[j] = N) then begin
					writeln('(', M[i], '-', M[j], ')');
					Exit;
				end else begin
				hr := M[i] - M[j];
				if (hr > N) then begin
					if (B[hr - N]) and (findInd(hr - N) <> i) and
					(findInd(hr - N) <> j) then begin
						writeln('((', M[i], '-', M[j], ')-', hr-N, ')');
						Exit;
					end;
					if (hr mod N = 0) and (B[hr div N]) and
					(findInd(hr div N) <> i) and (findInd(hr div N) <> j)
					then begin
						writeln('((', M[i], '-', M[j], ')/', hr div N, ')');
						Exit;
					end;
				end else begin
					if (B[N - hr]) and (findInd(N - hr) <> i) and
					(findInd(N - hr) <> j) then begin
						writeln('((', M[i], '-', M[j], ')+', N-hr, ')');
						Exit;
					end;
					if (N mod hr = 0) and (B[N div hr]) and
					(findInd(N div hr) <> i) and (findInd(N div hr) <> j)
					then begin
						writeln('((', M[i], '-', M[j], ')*', N div hr, ')');
						Exit;
					end;
				end;
			end;
				end;
				if ((M[i] mod M[j] = 0) and (M[i] div M[j] = N)) then begin
					writeln('(', M[i], '/', M[j], ')');
					Exit;
				end else if (M[i] mod M[j] = 0) or (M[j] mod M[i] = 0) then begin
				if (M[i] > M[j]) then
					hr := M[i] div M[j]
				else
					hr := M[j] div M[i];
				if (hr > N) then begin
					if (B[hr - N]) and (findInd(hr - N) <> i) and
					(findInd(hr - N) <> j) then begin
						writeln('((', M[i], '/', M[j], ')-', hr-N, ')');
						Exit;
					end;
					if (hr mod N = 0) and (B[hr div N]) and
					(findInd(hr div N) <> i) and (findInd(hr div N) <> j)
					then begin
						writeln('((', M[i], '/', M[j], ')/', hr div N, ')');
						Exit;
					end;
				end else begin
					if (B[N - hr]) and (findInd(N - hr) <> i) and
					(findInd(N - hr) <> j) then begin
						writeln('((', M[i], '/', M[j], ')+', N-hr, ')');
						Exit;
					end;
					if (N mod hr = 0) and (B[N div hr]) and
					(findInd(N div hr) <> i) and (findInd(N div hr) <> j)
					then begin
						writeln('((', M[i], '/', M[j], ')*', N div hr, ')');
						Exit;
					end;
				end;
			end;
		end;
end;

begin
	readInput;
	Init;
	Solve;
end.
