#include <stdio.h>
#include <stdlib.h>
#include <string.h>

const int maxm = 10;
const int maxl = 3001;

int a[maxm];
int n,m;

int sign[maxm];
int num[maxm];
char not_used[maxl];

int d[maxm][maxm][maxl];
int path[maxm][maxm][maxl][4];

int z;

/*************/
void input()
{

  scanf("%d",&n);

  int i=0,j;
  do {
    j=-1;
    scanf("%d",&j);

    if (j==-1) break;
    if (j==n) {
      printf("%d\n",n);
      exit(0);
    }

    i++;
    a[i]=j;

  } while (1);
  m=i;
}
/*************/
int val(int x, int s, int y)
{
  int t=-1;
  if (s==0) t=x+y;
  else if (s==1) t=x-y;
  else if (s==2) t=x*y;
  else if (s==3 && (x%y==0)) t=x/y;

  if (t<0 || t>maxl) return -1;
  else return t;
}
/*************/
void print_sign(int s)
{
  if (s==0) printf("+");
  else if (s==1) printf("-");
  else if (s==2) printf("*");
  else if (s==3) printf("/");
}
/*************/
void output(int x,int y,int k,int asd)
{
  if (x==y)
    printf("%d",num[x]);
  else {
    printf("(");

    output(x,k,path[x][k-x+1][path[x][y-x+1][asd][1]][0],path[x][y-x+1][asd][1]);
    print_sign(path[x][y-x+1][asd][2]);
    output(k+1,y,path[k+1][y-k][path[x][y-x+1][asd][3]][0],path[x][y-x+1][asd][3]);

    printf(")");
  }
}
/*************/
void find()
{
  memset(d, 0, sizeof(d));

  int i,j,k,l,p,q;

  for(i=1; i<=z; i++) {
    d[i][1][0]=1;
    d[i][1][1]=num[i];
  }

  for(k=2; k<=z; k++)
    for(i=1; i<=z-k+1; i++)
      for(j=i; j<i+k-1; j++)
        for(p=1; p<=d[i][j-i+1][0]; p++)
          for(q=1; q<=d[j+1][k+i-j-1][0]; q++) {
            l=val(d[i][j-i+1][p],sign[j],d[j+1][k+i-j-1][q]);
            if (l!=-1) {
              d[i][k][0]++;
              d[i][k][d[i][k][0]]=l;
              path[i][k][l][0]=j;
              path[i][k][l][1]=d[i][j-i+1][p];
              path[i][k][l][2]=sign[j];
              path[i][k][l][3]=d[j+1][k+i-j-1][q];
            }
          }

  for(i=1; i<=d[1][z][0]; i++)
    if (d[1][z][i]==n) {
      output(1,z,path[1][z][n][0],n);
      printf("\n");
      exit(0);
    }
}
/*************/
void build(int x)
{
  int i,j;
  
  if (x==z+1)
    find();
  else {
    for(i=0; i<4; i++)
      for(j=1; j<=m; j++)
        if (not_used[a[j]]) {
          sign[x]=i;
          num[x]=a[j];
          not_used[a[j]]=0;
          build(x+1);
          not_used[a[j]]=1;
        }
  }
}
/*************/
void go()
{
  int i,j,k;
  
  for(z=2; z<=m; z++) {

    memset(not_used, 0x01, sizeof(not_used));
    build(1);
  }
}
/*************/
int main()
{
  input();
  go();

  return 0;
}
