#include <iostream.h>
#include <string.h>

#define MINI(x, y) (x<y?x:y)
#define MAXLONG 2000000000

unsigned int mas[201][201];
int A, B, C, d;

unsigned int res[201];
int a1, b1, c1, cent1;
int mino;

void
refill (int *x, int *y, int max)
{
  mino = MINI(*x, max - *y);
  *x -= mino; *y += mino;
}

void
Deep(short a, short b, short c, unsigned int cent)
{
  if (mas[a][b] == MAXLONG || (mas[a][b] > cent && mas[a][b] != MAXLONG) )
  {
    mas[a][b] = cent;
    if (cent < res[a]) res[a] = cent;
    if (cent < res[b]) res[b] = cent;
    if (cent < res[c]) res[c] = cent;

    if (a)
    {
      if (B > b)
      {
        a1 = a; b1 = b; c1 = c;
        refill(&a1, &b1, B);
        Deep(a1, b1, c1, mino + cent);
      }
      if (C > c)
      {
        a1 = a; b1 = b; c1 = c;
        refill(&a1, &c1, C);
        Deep(a1, b1, c1, mino + cent);
      }
    }
    if (b)
    {
      if (A > a)
      {
        a1 = a; b1 = b; c1 = c;
        refill(&b1, &a1, A);
        Deep(a1, b1, c1, mino + cent);
      }
      if (C > c)
      {
        a1 = a; b1 = b; c1 = c;
        refill(&b1, &c1, C);
        Deep(a1, b1, c1, mino + cent);
      }
    }
    if (c)
    {
      if (A > a)
      {
        a1 = a; b1 = b; c1 = c;
        refill(&c1, &a1, A);
        Deep(a1, b1, c1, mino + cent);
      }
      if (B > b)
      {
        a1 = a; b1 = b; c1 = c;
        refill(&c1, &b1, B);
        Deep(a1, b1, c1, mino + cent);
      }
    }
  }
}

int
main()
{
  register int i, j;
  cin >> A >> B >> C >> d;

  for (i = 0; i < 201; i++)
    for (j = 0; j < 201; j++)
      mas[i][j] = MAXLONG;
  for (i = 0; i < 201; i++)
    res[i] = MAXLONG;

  Deep(0, 0, C, 0);

  while (res[d] == MAXLONG)
    d--;
  cout << res[d] << " " << d << endl;

  return 0;
}
