#include <climits>
#include <cstdlib>
#include <iostream>

using namespace std;

int a;
int b;
int c;
int d;
int A;
int B;
int C;
int D;

bool visited[200 + 1][200 + 1];
int na[200 + 1][200 + 1][6];
int nb[200 + 1][200 + 1][6];
int nl[200 + 1][200 + 1][6];
int nea[200 + 1][200 + 1][6];
int neb[200 + 1][200 + 1][6];
int nel[200 + 1][200 + 1][6];
int nn[200 + 1][200 + 1];
int DD[200 + 1][200 + 1];

const int INF = INT_MAX / 2;

void pr_ab(int& a, int& b, int& c, int &d) {
	if (a + b > B) {
		d = B - b;
		a -= B - b;
		b = B;
	} else {
		d = a;
		b += a;
		a = 0;
	}
}

void pr_ba(int& a, int& b, int& c, int &d) {
	if (b + a > A) {
		d = A - a;
		b -= A - a;
		a = A;
	} else {
		d = b;
		a += b;
		b = 0;
	}
}

void pr_ac(int& a, int& b, int& c, int &d) {
	d = a;
	c += a;
	a = 0;
}

void pr_ca(int& a, int& b, int& c, int &d) {
	if (c + a > A) {
		d = A - a;
		c -= A - a;
		a = A;
	} else {
		d = c;
		a += c;
		c = 0;
	}
}

void pr_bc(int& a, int& b, int& c, int &d) {
	d = b;
	c += b;
	b = 0;
}

void pr_cb(int& a, int& b, int& c, int &d) {	
	if (c + b > B) {
		d = B - b;
		c -= B - b;
		b = B;
	} else {
		d = c;
		b += c;
		c = 0;
	}
}

void obh(int a, int b) {
	if (visited[a][b]) return;
	visited[a][b] = true;
	int c = C - a - b;
	//cout << "obh a=" << a << " b=" << b << " c=" << c << '\n';
	int ta;
	int tb;
	int tc;
	int td;
	ta = a;
	tb = b;
	tc = c;
	pr_ab(ta, tb, tc, td);
	obh(ta, tb);
	na[a][b][0] = ta;
	nb[a][b][0] = tb;
	nl[a][b][0] = td;
	ta = a;
	tb = b;
	tc = c;
	pr_ba(ta, tb, tc, td);
	obh(ta, tb);
	na[a][b][1] = ta;
	nb[a][b][1] = tb;
	nl[a][b][1] = td;
	ta = a;
	tb = b;
	tc = c;
	pr_ac(ta, tb, tc, td);
	obh(ta, tb);
	na[a][b][2] = ta;
	nb[a][b][2] = tb;
	nl[a][b][2] = td;
	ta = a;
	tb = b;
	tc = c;
	pr_ca(ta, tb, tc, td);
	obh(ta, tb);
	na[a][b][3] = ta;
	nb[a][b][3] = tb;
	nl[a][b][3] = td;
	ta = a;
	tb = b;
	tc = c;
	pr_bc(ta, tb, tc, td);
	obh(ta, tb);
	na[a][b][4] = ta;
	nb[a][b][4] = tb;
	nl[a][b][4] = td;
	ta = a;
	tb = b;
	tc = c;
	pr_cb(ta, tb, tc, td);
	obh(ta, tb);
	na[a][b][5] = ta;
	nb[a][b][5] = tb;
	nl[a][b][5] = td;
}

void build() {
	obh(a, b);
}

void sv() {
	for (int a = 0; a <= C; a++) {
		for (int b = 0; b <= C; b++) {
			if (visited[a][b]) {
				for (int i = 0; i < 6; i++) {
					if (na[a][b][i] == a && nb[a][b][i] == b) continue;
					//bool found = false;
					for (int j = 0; j < nn[a][b]; j++) {
						if (nea[a][b][j] == a && neb[a][b][j] == b) continue;
					}
					nea[a][b][nn[a][b]] = na[a][b][i];
					neb[a][b][nn[a][b]] = nb[a][b][i];
					nel[a][b][nn[a][b]] = nl[a][b][i];
					nn[a][b]++;
				}
			}
		}
	}
}

void dijkstra() {//JG STL?
	int nv = 0;
	for (int i = 0; i <= C; i++) {
		for (int j = 0; j <= C; j++) {
			if (visited[i][j]) nv++;
		}
	}
	for (int i = 0; i <= C; i++) {
		for (int j = 0; j <= C; j++) {
			visited[i][j] = false;
			DD[i][j] = INF;
		}
	}

	DD[0][0] = 0;

	while (nv > 0) {
		int ma;
		int mb;
		int mindist = INF;
		for (int i = 0; i <= C; i++) {
			for (int j = 0; j <= C; j++) {
				if (DD[i][j] < mindist && !visited[i][j]) {
					mindist = DD[i][j];
					ma = i;
					mb = j;
				}
			}
		}
		nv--;
		visited[ma][mb] = true;

		for (int i = 0; i < 6; i++) {
			int tmp;
			if ((tmp = DD[ma][mb] + nel[ma][mb][i]) < DD[nea[ma][mb][i]][neb[ma][mb][i]]) {
				DD[nea[ma][mb][i]][neb[ma][mb][i]] = tmp;
			}
		}
	}
}

int main() {
	cin >> A >> B >> C >> D;
	for (int i = 0; i <= C; i++) {
		for (int j = 0; j <= C; j++) {
			visited[i][j] = false;
			nn[i][j] = 0;
		}
	}
	build();
	sv();
	dijkstra();
	/*
	for (int i = 0; i <= C; i++) {
		for (int j = 0; j <= C; j++) {
			cout  << "DD[" << i << "][" << j << "]=" << DD[i][j] << '\n';
		}
	}
	*/
	int best[200 + 1];
	for (int i = 0; i <= 200; i++) best[i] = INF;
	for (int i = 0; i <= C; i++) {
		for (int j = 0; j <= C; j++) {
			if (DD[i][j] < best[i]) {
				best[i] = DD[i][j];
			}
			if (DD[i][j] < best[j]) {
				best[j] = DD[i][j];
			}
			if (DD[i][j] < best[C - i - j]) {
				best[C - i - j] = DD[i][j];
			}
		}
	}
	/*
	for (int i = D; i >= 0; i--) {
		cout << "best[" << i << "]=" << best[i] << '\n';
	}
	*/
	for (int i = D; i >= 0; i--) {
		if (best[i] != INF) {
			cout << best[i] << ' ' << i << '\n';
			exit(EXIT_SUCCESS);
		}
	}
}
