#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#define MAXF 201
#define MIN(a,b) ((a)>(b)?(b):(a))
#define INF 0xFFFF
#define TIME_LIMIT 0.9

unsigned short used[MAXF][MAXF][MAXF];
int a,b,c,d;
unsigned short curr;
unsigned short max=0;
unsigned short w=INF;

void Output();

void Check(int water,int total)
  {
    if(water<=d && water>max) { max=water;w=total;return;}
    if(water==max && total<w) { w=total; }
  }

void Find(int aa,int bb,int cc)
  {
    unsigned short tmp;
    if((float)clock()/CLOCKS_PER_SEC>TIME_LIMIT) Output();
    if(used[aa][bb][cc]<=curr) return;
    used[aa][bb][cc]=curr;
    Check(aa,curr);
    Check(bb,curr);
    Check(cc,curr);
    if(aa)
      {
        if(bb<b)
          {
            tmp=MIN(b,bb+aa);
            curr+=(tmp-bb);
            Find(aa-(tmp-bb),tmp,cc);
            curr-=(tmp-bb);
          }
        if(cc<c)
          {
            tmp=MIN(c,cc+aa);
            curr+=(tmp-cc);
            Find(aa-(tmp-cc),bb,tmp);
            curr-=(tmp-cc);
          }
      }      
    if(bb)
      {
        if(aa<a)
          {
            tmp=MIN(a,aa+bb);
            curr+=(tmp-aa);
            Find(tmp,bb-(tmp-aa),cc);
            curr-=(tmp-aa);
          }
        if(cc<c)
          {
            tmp=MIN(c,cc+bb);
            curr+=(tmp-cc);
            Find(aa,bb-(tmp-cc),tmp);
            curr-=(tmp-cc);
          }
      }      
    if(cc)
      {
        if(aa<a)
          {
            tmp=MIN(a,aa+cc);
            curr+=(tmp-aa);
            Find(tmp,bb,cc-(tmp-aa));
            curr-=(tmp-aa);
          }
        if(bb<b)
          {
            tmp=MIN(c,bb+cc);
            curr+=(tmp-bb);
            Find(aa,tmp,cc-(tmp-bb));
            curr-=(tmp-bb);
          }
      }      
  }

void Output()
  {
    printf("%d %d\n",max,w);
    exit(0);
  }
  
int main()
  {
    int i,j,k;
    clock();
//    freopen("fill.in","rt",stdin);
    scanf("%d%d%d%d",&a,&b,&c,&d);
    memset(used,1,sizeof(used));
    curr=0;
    Find(0,0,c);
//    printf("Time : %f sec.\n",(double)clock()/CLOCKS_PER_SEC);
    return 0;
  }
