#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <list>
#define MAXN 8
#define INF 0x7FFFFFFF
#define INFs 10
#define MAXC 3001
#define TIME_LIMIT 4.9

using namespace std;

int N;
short c[MAXN];
short c_br=0;
short used[MAXN];
short res=0,mmin=INFs;
list<char> curr;
list<char> opt;

void Output();

void Init()
  {
//    freopen("expr.in","rt",stdin);
    scanf("%d",&N);
    for(c_br=0;!feof(stdin) && c_br<MAXN;)
       scanf(" %d ",&c[c_br++]);
  }

void CheckSol()
  {
    if(res<mmin)
      {
        mmin=res;
        opt=curr;
//        Output();
      }      
  }

void AddOperBack1(list<char> &curr,char oper,short num)
  {
    char nums[4];
    int i;
    curr.push_front('(');
    curr.push_back(oper);
    sprintf(nums,"%d",num);
    for(i=0;i<strlen(nums);i++)
      curr.push_back(nums[i]);
    curr.push_back(')');
  }

void AddOperBack2(list<char> &curr,char oper1,char oper2,short num1,short num2)
  {
    char nums[4];
    int i;
    curr.push_front('(');
    curr.push_back(oper1);
    curr.push_back('(');
    sprintf(nums,"%d",num1);
    for(i=0;i<strlen(nums);i++)
      curr.push_back(nums[i]);
    curr.push_back(oper2);
    sprintf(nums,"%d",num2);
    for(i=0;i<strlen(nums);i++)
      curr.push_back(nums[i]);
    curr.push_back(')');
    curr.push_back(')');
  }


void AddOperFront1(list<char> &curr,char oper,short num)
  {
    char nums[4];
    int i;
    curr.push_back(')');
    curr.push_front(oper);
    sprintf(nums,"%d",num);
    for(i=strlen(nums)-1;i>=0;i--)
      curr.push_front(nums[i]);
    curr.push_front('(');
  }


void AddOperFront2(list<char> &curr,char oper1,char oper2,short num1,short num2)
  {
    char nums[4];
    int i;
    curr.push_back(')');
    curr.push_front(oper1);
    curr.push_front(')');
    sprintf(nums,"%d",num1);
    for(i=strlen(nums)-1;i>=0;i--)
      curr.push_front(nums[i]);
    curr.push_front(oper2);
    sprintf(nums,"%d",num2);
    for(i=strlen(nums)-1;i>=0;i--)
      curr.push_front(nums[i]);
    curr.push_front('(');
    curr.push_front('(');
  }

void RemoveOperBack1(list<char> &curr)
  {
    curr.pop_back();
    curr.pop_front();
    while(*curr.rbegin()>='0' && *curr.rbegin()<='9') curr.pop_back();
    curr.pop_back();
  }
  
void RemoveOperFront1(list<char> &curr)
  {
    curr.pop_back();
    curr.pop_front();
    while(*curr.begin()>='0' && *curr.begin()<='9') curr.pop_front();
    curr.pop_front();
  }

void RemoveOperBack2(list<char> &curr)
  {
    curr.pop_back();
    curr.pop_front();
    curr.pop_back();
    while(*curr.rbegin()>='0' && *curr.rbegin()<='9') curr.pop_back();
    curr.pop_back();
    while(*curr.rbegin()>='0' && *curr.rbegin()<='9') curr.pop_back();
    curr.pop_back();
    curr.pop_back();
  }

void RemoveOperFront2(list<char> &curr)
  {
    curr.pop_back();
    curr.pop_front();
    curr.pop_front();
    while(*curr.begin()>='0' && *curr.begin()<='9') curr.pop_front();
    curr.pop_front();
    while(*curr.begin()>='0' && *curr.begin()<='9') curr.pop_front();
    curr.pop_front();
    curr.pop_front();
  }




void Find(int sum)
  {
    short i,j;
//    if(sum>res*res) return;
    if((double)clock()/CLOCKS_PER_SEC>TIME_LIMIT) Output();
    if(sum>=(INF/MAXC)) return;
    if(res>mmin) return;
    if(sum==N)
      {
        CheckSol();
        return;
      }
    for(i=0;i<c_br;i++)
      if(!used[i])
        {
          used[i]=1;
          if(!curr.empty())
            {
              // Pribaviame samo edin operant ot diasnata strana
              res++;
              AddOperBack1(curr,'+',c[i]);
              Find(sum+c[i]);
              RemoveOperBack1(curr);
              if(sum>c[i])
                {
                  AddOperBack1(curr,'-',c[i]);
                  Find(sum-c[i]);
                  RemoveOperBack1(curr);
                }
              AddOperBack1(curr,'*',c[i]);
              Find(sum*c[i]);
              RemoveOperBack1(curr);
              if(sum && !(sum%c[i]))
                {
                  AddOperBack1(curr,'/',c[i]);
                  Find(sum/c[i]);
                  RemoveOperBack1(curr);
                }
              // Sega ot liavata strana
              if(c[i]>sum)
                {
                  AddOperFront1(curr,'-',c[i]);
                  Find(c[i]-sum);
                  RemoveOperFront1(curr);
                }
              if(sum && !(c[i]%sum))
                {
                  AddOperFront1(curr,'/',c[i]);
                  Find(c[i]/sum);
                  RemoveOperFront1(curr);
                }
            }
          for(j=i+1;j<c_br;j++)
            if(!used[j])
              {
                used[j]=1;
                res++;
                // Privaviame dva operanda ot diasnata strana
                if(sum)
                  {
                    AddOperBack2(curr,'*','+',c[i],c[j]);
                    Find(sum*(c[i]+c[j]));
                    RemoveOperBack2(curr);
                  }
                if(sum && c[i]>c[j])
                  {
                    AddOperBack2(curr,'*','-',c[i],c[j]);
                    Find(sum*(c[i]-c[j]));
                    RemoveOperBack2(curr);
                  }
                if(sum && c[j]>c[i])
                  {
                    AddOperBack2(curr,'*','-',c[j],c[i]);
                    Find(sum*(c[j]-c[i]));
                    RemoveOperBack2(curr);
                  }
                if(sum && !(sum%(c[i]+c[j])))
                  {
                    AddOperBack2(curr,'/','+',c[i],c[j]);
                    Find(sum/(c[i]+c[j]));
                    RemoveOperBack2(curr);
                  }
                if(sum && c[i]>c[j] && !(sum%(c[i]-c[j])))
                  {
                    AddOperBack2(curr,'/','-',c[i],c[j]);
                    Find(sum/(c[i]-c[j]));
                    RemoveOperBack2(curr);
                  }
                if(sum && c[j]>c[i] && !(sum%(c[j]-c[i])))
                  {
                    AddOperBack2(curr,'/','-',c[j],c[i]);
                    Find(sum/(c[j]-c[i]));
                    RemoveOperBack2(curr);
                  }

                // Pribaviame ot liavata strana
                if(sum && !((c[i]+c[j])%sum))
                  {
                    AddOperFront2(curr,'/','+',c[i],c[j]);
                    Find((c[i]+c[j])/sum);
                    RemoveOperFront2(curr);
                  }
                if(c[i]>c[j] && sum && !((c[i]-c[j])%sum))
                  {
                    AddOperFront2(curr,'/','-',c[i],c[j]);
                    Find((c[i]-c[j])/sum);
                    RemoveOperFront2(curr);
                  }
                if(c[j]>c[i] && sum && !((c[j]-c[i])%sum))
                  {
                    AddOperFront2(curr,'/','-',c[j],c[i]);
                    Find((c[j]-c[i])/sum);
                    RemoveOperFront2(curr);
                  }
                res--;
                used[j]=0;
              }
        res--;
        used[i]=0;
      }
  }
void Solve()
  {
    int j,i,k;
    char nums[4];
    memset(used,0,sizeof(used));
//    memset(oper,0,sizeof(oper));
    curr.clear();
    for(i=0;i<c_br;i++)
      {
        used[i]=1;
        curr.clear();
        sprintf(nums,"%d",c[i]);
        for(k=0;k<strlen(nums);k++)
          curr.push_back(nums[k]);
        Find(c[i]);
        for(j=i+1;j<c_br;j++)        
          {
            used[j]=1;
            // Apochvame sys sybirane
            curr.clear();
            curr.push_front('(');
            sprintf(nums,"%d",c[i]);
            for(k=0;k<strlen(nums);k++)
              curr.push_back(nums[k]);
            curr.push_back('+');
            sprintf(nums,"%d",c[j]);
            for(k=0;k<strlen(nums);k++)
              curr.push_back(nums[k]);
            curr.push_back(')');
            Find(c[i]+c[j]);
            // Zapochvame sys umnojenie
            curr.clear();
            curr.push_front('(');
            sprintf(nums,"%d",c[i]);
            for(k=0;k<strlen(nums);k++)
              curr.push_back(nums[k]);
            curr.push_back('*');
            sprintf(nums,"%d",c[j]);
            for(k=0;k<strlen(nums);k++)
              curr.push_back(nums[k]);
            curr.push_back(')');
            Find(c[i]*c[j]);
            // Zapochvame sys izvajdane
            if(c[i]-c[j]>0)
              {
                curr.clear();
                curr.push_front('(');
                sprintf(nums,"%d",c[i]);
                for(k=0;k<strlen(nums);k++)
                  curr.push_back(nums[k]);
                curr.push_back('-');
                sprintf(nums,"%d",c[j]);
                for(k=0;k<strlen(nums);k++)
                 curr.push_back(nums[k]);
                curr.push_back(')');
                Find(c[i]-c[j]);
              }
            if(c[j]-c[i]>0)
              {
                curr.clear();
                curr.push_front('(');
                sprintf(nums,"%d",c[j]);
                for(k=0;k<strlen(nums);k++)
                  curr.push_back(nums[k]);
                curr.push_back('-');
                sprintf(nums,"%d",c[i]);
                for(k=0;k<strlen(nums);k++)
                 curr.push_back(nums[k]);
                curr.push_back(')');
                Find(c[j]-c[i]);
              }
            // Zapochvame sys delenie
            if(c[i]%c[j]==0)
              {
                curr.clear();
                curr.push_front('(');
                sprintf(nums,"%d",c[i]);
                for(k=0;k<strlen(nums);k++)
                  curr.push_back(nums[k]);
                curr.push_back('%');
                sprintf(nums,"%d",c[j]);
                for(k=0;k<strlen(nums);k++)
                 curr.push_back(nums[k]);
                curr.push_back(')');
                Find(c[i]-c[j]);
              }
            if(c[j]%c[i]==0)
              {
                curr.clear();
                curr.push_front('(');
                sprintf(nums,"%d",c[j]);
                for(k=0;k<strlen(nums);k++)
                  curr.push_back(nums[k]);
                curr.push_back('/');
                sprintf(nums,"%d",c[i]);
                for(k=0;k<strlen(nums);k++)
                 curr.push_back(nums[k]);
                curr.push_back(')');
                Find(c[j]/c[i]);
              }
            used[j]=0;
          }
        used[i]=0;
      }
  }

void Output()
  {
    for(list<char>::iterator i=opt.begin();i!=opt.end();i++)
      if((*i>='0' && *i<='9') || *i==')' || *i=='(' || *i=='+' || *i=='-' || *i=='*' || *i=='/') printf("%c",*i);
    printf("\n");
    exit(0);
  }

int main()
  {
    clock();
    Init();
    for(int i=0;i<c_br;i++)
      if(c[i]==N)
        {
          printf("%d\n",N);
          return 0;
        }
    Solve();
    Output();
//    printf("Time : %f sec.\n",(double)clock()/CLOCKS_PER_SEC);
    return 0;
  }
