/* INCLUDES *****************************************************************/
   #include <iostream>
   //#include <cstdlib>
   #include <values.h>

   #include <vector>
   #include <queue>

   using namespace std;

/* CONSTANTS ****************************************************************/
   int const MAX = 201;
   int const MAXVAL = MAXSHORT - 202;
   //int const MAXINC = 1000000;

/* CLASSES ******************************************************************/
   class node;
/* GLOBALS ******************************************************************/

   short int a;
   short int b;
   short int c;
   short int d;

   short int d1;
   int f;

   int inc;

   //int m[MAX][MAX][MAX];
   vector<vector<vector<short int> > > m;

   priority_queue<node> pq;

   int sub;

/* CLASSES ******************************************************************/

   class node
   {
   public:
      node() {}
      node(int _a, int _b, int _c): a(_a), b(_b), c(_c) {}
      node(node const& _n): a(_n.a), b(_n.b), c(_n.c) {}
      node& operator = (node const& _n)
      {
         a = _n.a;
         b = _n.b;
         c = _n.c;
         return *this;
      }/**/
      ~node() {}

      bool operator < (node const& _n) const
      {
         return m[a][b][c] > m[_n.a][_n.b][_n.c];
      }

      short int a;
      short int b;
      short int c;
      //int d;
   };

/* FUNCTIONS ****************************************************************/
/****************************************************************************/
/*   void done()
   {
      exit(0);
   }
/****************************************************************************/
   void init()
   {
      cin >> a >> b >> c >> d;
      //cout << a << ' ' << b << ' ' << c << ' ' << d << endl;
   }
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
   void run()
   {
      /*for (int i = 0; i < MAX; ++i)
         for (int j = 0; j < MAX; ++j)
            for (int k = 0; k < MAX; ++k)
               m[i][j][k] = MAXVAL;
      */
      /*for (int i = 0; i <= a; ++i)
         for (int j = 0; j <= b; ++j)
            for (int k = 0; k <= c; ++k)
               m[i][j][k] = MAXVAL;
      */
      m.resize(a + 1);
      for (int i = 0; i <= a; ++i)
      {
         m[i].resize(b + 1);
         for (int j = 0; j <= b; ++j)
            m[i][j].resize(c + 1, MAXVAL);
      }

      //inc = 0;

      f = -1;
      d1 = -1;

      m[0][0][c] = 0;
      pq.push(node(0, 0, c));
      while (!pq.empty())
      {
         node n = pq.top();
         pq.pop();

         if (n.a == d || n.b == d || n.c == d)
         {
            d1 = d;
            f = m[n.a][n.b][n.c];
            break;
         }

         if (n.a < d && n.a > d1)
         {
            d1 = n.a;
            f = m[n.a][n.b][n.c];
         }

         if (n.b < d && n.b > d1)
         {
            d1 = n.b;
            f = m[n.a][n.b][n.c];
         }

         if (n.c < d && n.c > d1)
         {
            d1 = n.c;
            f = m[n.a][n.b][n.c];
         }

         //if (++inc > MAXINC) break;

         // a->b
         sub = min(n.a, (short int)(b - n.b));
         if (m[n.a - sub][n.b + sub][n.c] > m[n.a][n.b][n.c] + sub)
         {
            m[n.a - sub][n.b + sub][n.c] = m[n.a][n.b][n.c] + sub;
            pq.push(node(n.a - sub, n.b + sub, n.c));
         }
         // a->c
         sub = min(n.a, (short int)(c - n.c));
         if (m[n.a - sub][n.b][n.c + sub] > m[n.a][n.b][n.c] + sub)
         {
            m[n.a - sub][n.b][n.c + sub] = m[n.a][n.b][n.c] + sub;
            pq.push(node(n.a - sub, n.b, n.c + sub));
         }

         // b->a
         sub = min(n.b, (short int)(a - n.a));
         if (m[n.a + sub][n.b - sub][n.c] > m[n.a][n.b][n.c] + sub)
         {
            m[n.a + sub][n.b - sub][n.c] = m[n.a][n.b][n.c] + sub;
            pq.push(node(n.a + sub, n.b - sub, n.c));
         }
         // b->c
         sub = min(n.b, (short int)(c - n.c));
         if (m[n.a][n.b - sub][n.c + sub] > m[n.a][n.b][n.c] + sub)
         {
            m[n.a][n.b - sub][n.c + sub] = m[n.a][n.b][n.c] + sub;
            pq.push(node(n.a, n.b - sub, n.c + sub));
         }

         // c->a
         sub = min(n.c, (short int)(a - n.a));
         if (m[n.a + sub][n.b][n.c - sub] > m[n.a][n.b][n.c] + sub)
         {
            m[n.a + sub][n.b][n.c - sub] = m[n.a][n.b][n.c] + sub;
            pq.push(node(n.a + sub, n.b, n.c - sub));
         }
         // c->b
         sub = min(n.c, (short int)(b - n.b));
         if (m[n.a][n.b + sub][n.c - sub] > m[n.a][n.b][n.c] + sub)
         {
            m[n.a][n.b + sub][n.c - sub] = m[n.a][n.b][n.c] + sub;
            pq.push(node(n.a, n.b + sub, n.c - sub));
         }
      }

      cout << f << ' ' << d1 << endl;
   }
/****************************************************************************/
   int main()
   {
      init();
      run();
      //done();

      return 0;
   }
/****************************************************************************/

