#define MAX_N 15
#define MAX_CUBES 100
int data[MAX_N];
int diffs[MAX_N];

int curr_diffs[MAX_N];
int curr_cube[MAX_N];

int found_cubes[MAX_CUBES][MAX_N];
int last_cube;
int max;

void read() {
     int i;
     
     max = 0;
     for (i = 0; i<12; i++) {
         scanf("%d", &data[i]);
         diffs[data[i]]++;
         if (data[i]> max)
            max = data[i];
     }
}

int check_s_rect(int a1, int a2, int a3, int a4 , int index, int mul) {
    if ((a1 == found_cubes[index][mul*4]) &&
        (a2 == found_cubes[index][mul*4+1])&&
        (a3 == found_cubes[index][mul*4+2])&&
        (a4 == found_cubes[index][mul*4+3]))
            return 1;

    return 0;
}
int check_rect(int a1, int a2, int a3, int a4, int index,int mul) {
    int res;
    
    res = 0;
    res = res | check_s_rect(a1,a2, a3, a4, index, mul);
    res = res | check_s_rect(a2,a3,a4,a1, index, mul);
    res = res | check_s_rect(a3,a4,a1,a2, index, mul);
    res = res | check_s_rect(a4,a1, a2, a3, index, mul);

    return res;
}

int checkcube() {
  int i,j,res;

  for (i = 0;i < last_cube;i++){
      res = 0;
      for (j = 0; j < 6; j++)  {
         res +=check_rect(curr_cube[4*i], curr_cube[4*i+1], curr_cube[4*i+2], curr_cube[4*i+3], i,j);
      }
      if (res == 6)
         return 1;
  }
  
  return 0;
}

void addcube() {
     int i;
     
     for (i = 0; i<13;i++)
          found_cubes[last_cube][i] = curr_cube[i];

     last_cube++;
}

int buildcube(int pos) {
    int i;

    if (pos == 11) {
       for (i = 1; i<=max; i++)
           if (curr_diffs[i] >0) {
              curr_cube[pos] = i;
              if (!checkcube())
                 addcube();
           }


    }
    
    for (i = 1; i<=max; i++) {
        if ( curr_diffs[i]> 0) {
            curr_diffs[i]--;
            
            curr_cube[pos] = i;
            buildcube(pos+1);
            curr_diffs[i]++;
        }
    }
}

int solve() {
    int i;
    
    for (i = 0 ;i<=MAX_N;i++)
        curr_diffs[i] = diffs[i];
        
    buildcube(0);
}

void write() {
     printf("%d\n", last_cube);  
}

int precalc() {
    int nums = 0;
    int i;

    for (i = 0 ; i<15;i++)
    if (diffs[i] != 0)
      nums++;

    if (nums == 0)
       nums = 1;
       
    printf("%d\n", nums-1);
    return 1;
}

int main() {
    read();
    
    if (precalc()) {
       return 0;
    }

    solve();
    write();    
    return 0;
}
