#include <stdio.h>
#define MAX_N 10
#define MNOGO 1000000
#define TIME_TO_WORK 3

long start_time;
int nums[MAX_N];
int used[MAX_N];
int result;
int m;
int minops;

int cmp_proc( int * a1, int *a2) {
    return *a2- *a1;
}
int read() {
    scanf("%d", &result);
    m = 1;
    
    while ( scanf("%d", &nums[m]) == 1) m++;
    m--;

    qsort(nums+1,m+1,sizeof(nums[1]), cmp_proc);
}

int min2(int a1, int a2) {
    if (a1<a2)
       return a1;
    else
       return a2;
}

int min( int a1, int a2, int a3, int a4) {
    return min2(min2(min2(a1,a2),a3),a4);
}

int solve(int res) {
    int i;
    int real_min = MNOGO;
    int mins[5];

    for (i =0;i<4;i++)
       mins[i] = MNOGO;
     
    if (res == 0 )
       return 0;
       
    for (i = 1; i<=m;i++)
        if (!used[i]){
            int m_min;
            
            used[i] =1;
            
            mins[0] =  solve(res*nums[i]) +1;
            if ((result % nums[i]) == 0)
                mins[1] = solve(res/nums[i])+1;
            else
                mins[1] = MNOGO;
                
            mins[2] = solve(res+nums[i])+1;
            mins[3] = solve(res-nums[i])+1;

            used[i] = 0;
            
            m_min = min(mins[0], mins[1], mins[2], mins[3]);
            if (m_min < real_min)
              real_min = m_min;

//            printf("%d\n",time(0));
            if (time(0) - start_time > TIME_TO_WORK)
                return real_min;
        }

    return real_min;
}

int findops(int res, int depth) {
    int i;
    
   if (depth >= minops-1) {
      for (i = 1;i<=m;i++)
          if (!used[i])
          if ( res == nums[i]) {
             printf("%d", nums[i]);
             return 1;
          }

      return 0;
   }
      
   if (depth > minops)
      return 0;
      
     for (i = 1; i<=m ;i++)
         if (!used[i]){
            used[i] = 1;
            if (findops(res*nums[i],depth+1)){
               printf("/%d)", nums[i]);
               return 1;
            }

            if ((res% nums[i]) == 0)
               if (findops(res/nums[i],depth+1)) {
                  printf("*%d)", nums[i]);
                  return 1;
               }

            if (findops(res+nums[i],depth+1)) {
               printf("-%d)", nums[i]);
               return 1;
            }
            
            if (findops(res-nums[i], depth+1)) {
               printf("+%d)", nums[i]);
               return 1;
            }

            used[i] = 0;
         }

   return 0;
}

int main() {
    int i;
    
    start_time = time(0);
    
    read();
    minops = solve(result);
    
    for (i = 1; i<minops;i++)
        printf("(");
        
    findops(result,0);
    printf("\n");
    
    return 0;
}
