#include <stdio.h>
#include <string.h>
#include <limits.h>

#define MAX_N 210
#define MAX_LEN 1000000

struct TMas{
 int a,b;
};

struct TFill{
 int a,b,fill;
};

int    mas[MAX_N][MAX_N];
struct TMas tail[MAX_LEN];

int a,b,c,d;
int beg=0,vend=0;

void solve();
void output();
struct TFill Fill1(struct TMas src);
struct TFill Fill2(struct TMas src);
struct TFill Fill3(struct TMas src);
struct TFill Fill4(struct TMas src);
struct TFill Fill5(struct TMas src);
struct TFill Fill6(struct TMas src);

int main(void){
 int i,j;
 
 for(i=0; i<MAX_N; i++)
  for(j=0; j<MAX_N; j++)
   mas[i][j]=-1;
   
 scanf("%d %d %d %d", &a, &b, &c, &d);
 solve();
 output();
 
 return 0;
}

void solve(){
 struct TMas x;
 struct TFill y;
 
 tail[vend].a=0; tail[vend++].b=0;
 mas[0][0]=0;
 
 while(beg<vend){
  x=tail[beg++];
  
  y=Fill1(x);
  if((mas[y.a][y.b]==-1||mas[y.a][y.b]>y.fill+mas[x.a][x.b])&&y.fill!=0) {mas[y.a][y.b]=y.fill+mas[x.a][x.b]; tail[vend].a=y.a; tail[vend++].b=y.b;}

  y=Fill2(x);
  if((mas[y.a][y.b]==-1||mas[y.a][y.b]>y.fill+mas[x.a][x.b])&&y.fill!=0) {mas[y.a][y.b]=y.fill+mas[x.a][x.b]; tail[vend].a=y.a; tail[vend++].b=y.b;}

  y=Fill3(x);
  if((mas[y.a][y.b]==-1||mas[y.a][y.b]>y.fill+mas[x.a][x.b])&&y.fill!=0) {mas[y.a][y.b]=y.fill+mas[x.a][x.b]; tail[vend].a=y.a; tail[vend++].b=y.b;}

  y=Fill4(x);
  if((mas[y.a][y.b]==-1||mas[y.a][y.b]>y.fill+mas[x.a][x.b])&&y.fill!=0) {mas[y.a][y.b]=y.fill+mas[x.a][x.b]; tail[vend].a=y.a; tail[vend++].b=y.b;}

  y=Fill5(x);
  if((mas[y.a][y.b]==-1||mas[y.a][y.b]>y.fill+mas[x.a][x.b])&&y.fill!=0) {mas[y.a][y.b]=y.fill+mas[x.a][x.b]; tail[vend].a=y.a; tail[vend++].b=y.b;}

  y=Fill6(x);
  if((mas[y.a][y.b]==-1||mas[y.a][y.b]>y.fill+mas[x.a][x.b])&&y.fill!=0) {mas[y.a][y.b]=y.fill+mas[x.a][x.b]; tail[vend].a=y.a; tail[vend++].b=y.b;}
 }
 
}

struct TFill Fill1(struct TMas src){
 struct TFill y;

 y.b=src.b+src.a;
 y.a=0;
 if(y.b>b) {y.a=y.b-b; y.b=b;}
 y.fill=src.a-y.a;

 return y;
}

struct TFill Fill2(struct TMas src){
 struct TFill y;
 
 y.b=src.b;
 y.a=0;
 y.fill=src.a;

 return y;
}

struct TFill Fill3(struct TMas src){
 struct TFill y;

 y.a=src.b+src.a;
 y.b=0;
 if(y.a>a) {y.b=y.a-a; y.a=a;}
 y.fill=src.b-y.b;

 return y;
}

struct TFill Fill4(struct TMas src){
 struct TFill y;

 y.a=src.a;
 y.b=0;
 y.fill=y.b;

 return y;
}

struct TFill Fill5(struct TMas src){
 struct TFill y;
 int tmp;

 tmp=c-src.a-src.b;
 y.a=src.a+tmp;
 tmp=0;
 if(y.a>a) y.a=a;
 y.b=src.b;
 y.fill=y.a-src.a;

 return y;
}

struct TFill Fill6(struct TMas src){
 struct TFill y;
 int tmp;

 tmp=c-src.a-src.b;
 y.b=src.b+tmp;
 if(y.b>b) y.b=b;
 y.a=src.a;
 y.fill=y.b-src.b;
 
 return y;
}

void output(){
 int i,j;
 int min=INT_MAX;
 int min_el=-1;
 
 for(i=0; i<=c; i++)
  for(j=0; j<=c; j++){
   if(i>=min_el&&i<=d&&mas[i][j]!=-1) min_el=i;
   if(j>=min_el&&d>=j&&mas[i][j]!=-1)min_el=j;
   if((c-i-j)>=min_el&&(c-i-j)<=d&&mas[i][j]!=-1) min_el=c-i-j;
  }


 for(i=0; i<=c; i++)
  for(j=0; j<=c; j++)
   if((i==min_el||j==min_el||(c-i-j)==min_el)&&mas[i][j]<min&&mas[i][j]!=-1) min=mas[i][j];

 printf("%d %d\n", min, min_el);
}

