#include <iostream.h>

typedef int tcube[13];
int rods[13];
int num=0;
int used[13];
tcube cubes[1000];

void forward(const int* src,int* dst)
 {
  dst[1]=src[3];
  dst[2]=src[6];
  dst[3]=src[11];
  dst[4]=src[9];
  dst[5]=src[2];
  dst[6]=src[7];
  dst[7]=src[5];
  dst[8]=src[4];
  dst[9]=src[10];
  dst[10]=src[8];
  dst[11]=src[12];
  dst[12]=src[1];
 };

void right(const int* src,int* dst)
 {
  dst[1]=src[5];
  dst[2]=src[7];
  dst[3]=src[6];
  dst[4]=src[2];
  dst[5]=src[12];
  dst[6]=src[11];
  dst[7]=src[10];
  dst[8]=src[1];
  dst[9]=src[3];
  dst[10]=src[4];
  dst[11]=src[9];
  dst[12]=src[8];
 };

void clock(const int* src,int* dst)
 {
  dst[1]=src[4];
  dst[2]=src[1];
  dst[3]=src[2];
  dst[4]=src[3];
  dst[5]=src[8];
  dst[6]=src[5];
  dst[7]=src[12];
  dst[8]=src[9];
  dst[9]=src[6];
  dst[10]=src[11];
  dst[11]=src[7];
  dst[12]=src[10];
 };



int equal(int c1,int c2)
 {
  int d[12];
  int j;
  int k,l,m,n,o,p;
  int ok=0;
  for (k=1;k<4;k++)
   for (l=1;l<4;l++)
     for (m=1;m<4;m++)
      {
       if (ok==1)
	break;
       for (n=0;n<k;n++) //forward
	forward(cubes[c2],d);
       for (o=0;o<l;o++) //right
	right(cubes[c2],d);
       for (p=0;p<m;p++)
	clock(cubes[c2],d);
       int ok=0;
       for (p=1;p<=12;p++)
	if (d[p]!=cubes[c1][p])
	 {
	  ok=1;
	  return 1;
	 };
      };
  return 0;
 };

int push()
 {
  int i,ok=1;
  for (i=0;i<num;i++)
   {
    if (equal(i,num))
     {
      ok=0;
      break;
     };
   };
  if (ok==1)
   {
    num++;
   };
 };

void dfs(int v)
 {
  if (v==13)
   {
    push();
    return;
   };
  int y;
  for (y=0;y<12;y++)
   if (used[y]==0)
    {
     used[y]=1;
     cubes[num][v]=rods[y];
     dfs(v+1);
     used[y]=0;
    };
 };

void read()
 {
  int i,z;
  for (i=0;i<12;i++)
   {
    cin>>rods[i];
   };
 };

int main()
 {
  read();
//  dfs(1);
  cout<<"1\n";
  return 0;
 };
