Const
 MaxD     = 256;
 MaxValue = MaxLongInt div 2;

Var
 A,B,C,D,Dp : LongInt;
 Res        : Array[0..MaxD] Of LongInt;
{ Don        : Array[0..MaxD,0..MaxD,0..MaxD] Of LongInt;}
 Can        : Boolean;

 Procedure Swap(Var L1,L2 : LongInt);
 Var
  Tmp : LongInt;
 Begin
  Tmp := L1;
  L1  := L2;
  L2  := Tmp;
 End;

 Function Min(X,Y : LongInt) : LongInt;
 Begin
  If X < Y Then
   Min := X
  Else
   Min := Y;
 End;

 Function Min3(X,Y,Z : LongInt) : LongInt;
 Begin
  Min3 := Min(X,Min(Y,Z));
 End;

{ Procedure TryRec(X,Y,Z,Val : LongInt);
 Var
  XY,XZ,YZ,
  ZX,YX,ZY,
  Ax,By,Cz : LongInt;
 Begin
  If Don[X,Y,Z] < MaxValue Then
   Begin
    Exit;
   End;

  Don[X,Y,Z] := Val;

  If (X = Dp) or (Y = Dp) or (Z = Dp) Then
   Begin
    Can := True;
    Res[Dp] := Min(Res[Dp],Val);
    Exit;
   End;

  Ax := A - X;
  By := B - Y;
  Cz := C - Z;

  XY := Min(By,X);
  XZ := Min(Cz,X);
  YX := Min(Ax,Y);
  YZ := Min(Cz,Y);
  ZX := Min(Ax,Z);
  ZY := Min(By,Z);

  TryRec(X+YX,Y-YX,Z,Val+YX);
  TryRec(X+ZX,Y,Z-ZX,Val+ZX);

  TryRec(X-XY,Y+XY,Z,Val+XY);
  TryRec(X,Y+ZY,Z-ZY,Val+ZY);

  TryRec(X-XZ,Y,Z+XZ,Val+XZ);
  TryRec(X,Y-YZ,Z+YZ,Val+YZ);
 End;
}

 Function Try(L : LongInt) : LongInt;
 Var
  NewR : LongInt;
 Begin
  If (L < 0) or (L > A+B+C) Then
   Begin
    Exit;
   End;

  If Res[L] < MaxValue Then
   Begin
    Try := Res[L];
    Exit;
   End;

  Res[L] := Min3(  A + Try(L-A),
                   B + Try(L-B),
                   C + Try(L-C));

  NewR := Min3  (  A + Try(L+A),
                   B + Try(L+B),
                   C + Try(L+C));

  Res[L] := Min(Res[L], NewR);

  Try := Res[L];
 End;

Var
 I,J,L : LongInt;
Begin
 For I:=1 To MaxD Do
  Res[I] := MaxValue;

 Readln(A, B, C, D);

 If A>B Then Swap(A,B);

 Res[A] := A;
 If C-B = A Then Res[A] := Min(Res[A], B);

 Res[B] := B;
 If C-A = B Then Res[B] := Min(Res[B], A);

 Res[C] := 0;

 Res[0] := 0;

{ For I:=1 To 200 Do
  For J:=1 To 200 Do
   For L:=1 To 200 Do
    Don[I,J,L] := MaxValue;
}

 For Dp:=D DownTo 1 Do
  Begin
   If C < Dp Then Continue;
   If (C < A) and (C<>Dp) Then Continue;
   {Can := False;
   TryRec(0,0,C,0);
   If Can Then} Try(Dp) {Else Continue};
   If Res[Dp] < MaxValue Then
    Begin
     Writeln(Res[Dp], ' ', Dp);
     Halt(0);
    End;
  End;
End.
