Const
  DataMax = 200;

Type
  TData = Integer;
  THowNdx = 0..DataMax;
  THow = Array[THowNdx]Of TData;

Var
  A, B, C, D, Ans, Fill : TData;
  How, Where, Cost : THow;
  Num : TData;


   Procedure ReadIn;
     Begin
       ReadLn(A, B, C, D);
     End;

   Procedure Print;
     Begin
       WriteLn(Ans, ' ', Fill);
     End;

   Procedure Swap( Var A, B:TData);
     Begin
       If @A <> @B Then
        Begin
          A:= A Xor B;
          B:= A Xor B;
          A:= A Xor B;
        End;
     End;

   Function Min( A, B : TData) : TData;
     Begin
       If A < B Then
         Min:=A
       Else
         Min:=B;
     End;

   Function Can ( Var Ans2, Fill2 : TData) : Boolean;
     Var
       Can_ : Boolean;
       I, J, Fill3 : TData;
     Begin
       Can_:=False;
       Fill2:=MaxInt;
       For I:=Num DownTo 1 Do
         For J:=Num DownTo 1 Do
           If (I <> J)
              And (Where[I] <> Where[J])
              And (How[I] + How[J] = Ans2)  Then
            Begin
              Can_:=True;
              Fill3:=Cost[I] + Cost[J];
              If (Ans2 < Where[I]) And (Ans < Where[J]) Then
                Fill3:=Fill3 + Min(How[I], How[J])
              Else If (Ans2 < Where[I]) And (How[I] < How[J]) Then
                Inc(Fill3, How[I])
              Else
                Inc(Fill3, How[J]);
              Dec(Fill3, Min(How[I], How[J]));
              If Fill3 < Fill2 Then
                Fill2:=Fill3;
            End;

       Can:=Can_;
     End;

   Procedure StupidSolve;
     Begin
       { golemi typni, osobeno Num-a }
       Num:=1;
       How[Num]:=B;
       Where[Num]:=B;
       Cost[Num]:=B;

       Inc(Num);
       How[Num]:=C - B;
       Where[Num]:=C;
       Cost[Num]:=B;

       Inc(Num);
       How[Num]:=A;
       Where[Num]:=A;
       Cost[Num]:=A;

       Inc(Num);
       How[Num]:=C - A;
       Where[Num]:=C;
       Cost[Num]:=A;

       Inc(Num);
       How[Num]:=A;
       Where[Num]:=A;
       Cost[Num]:=Cost[1] + A;

       Inc(Num);
       How[Num]:=B - A;
       Where[Num]:=B;
       Cost[Num]:=Cost[Num - 1];

       Ans:=D;
       While (Not Can(Ans, Fill)) And (Ans > 0) Do
         Dec(Ans);

       If Ans < 0 Then
        Begin
          Ans:=0;
          Fill:=0;
        End;
     End;

   Procedure Solve;
     Var
       Ans2, Fill2 : TData;
       OverFlow : Boolean;
     Begin
       If A > B Then
         Swap(A, B);
       If (D >= C) Then
        Begin
          Ans:=D;
          Fill:=0;
        End
       Else If (D = A) Or (D = B) Then
        Begin
          Ans:=D;
          Fill:=D;
        End
       Else If (C <= A) Then
        Begin
          Ans:=C;
          Fill:=0;
        End
       Else If (A < C) And (C < B) Then
        Begin
          If D < A Then
           Begin
             Ans:=C; Fill:=0;
             While (Ans > D) Do
              Begin
                Ans:=Ans - A;
                Fill:=Fill + 2*A;
                If C - Ans > B Then
                 Begin
                   Fill:=A;
                   Ans:=0;
                   Break;
                 End;
              End;
             Dec(Fill, A);
           End
          Else If (A < D) And (D < 2*A) Then
           Begin
             Ans:=A;
             Fill:=A;
           End
          Else If (A < D) And (D < C) Then
           Begin
             Ans:=A;
             Fill:=2*A;
             While Ans < D Do
              Begin
                Inc(Ans, A);
                Fill:=Fill + 2*A;
                If (Ans > B) Then
                   Break;
              End;
             Dec(Ans, A);
             Fill:=Fill - 2*A;

             Ans2:=C; Fill2:=0;
             While (Ans2 > D) Do
              Begin
                Ans2:=Ans2 - A;
                Fill2:=Fill2 + 2*A;
                If C - Ans2 > B Then
                 Begin
                   Fill2:=A;
                   Ans2:=0;
                   Break;
                 End;
              End;
             Dec(Fill2, A);

             If Ans2 > Ans Then
              Begin
                Ans:=Ans2;
                Fill:=Fill2;
              End;
           End;
        End
       Else
        Begin
          { tuka e interesno ama ...}
          StupidSolve;
        End;
     End;

Begin
  ReadIn;
  Solve;
  Print;
End.