#include <stdio.h>

#define MAXC 8

int ans;
int color[MAXC];
int uq[13] = {1, 1, 5, 7, 27, 38, 48, 38, 27, 7, 5, 1, 1};
int p[13][13];

void readf(void);
void solve(void);
void writef(void);

int main(void) {
	readf();
	solve();
	writef();

	return 0;
}

void readf(void) {
	int i, a;

	for (i = 0; i < 12; ++i) {
		scanf("%d", &a);
		color[a-1]++;
	}
}

void solve(void) {
	int i, j, t, l;

	l = 0;
	for (i = 0; i < MAXC; ++i)
		if (color[i] == 2 || color[i] == 1)
			l = 1;

	if (l) {
	for (i = 0; i < MAXC; ++i)
		for (j = i + 1; j < MAXC; ++j)
			if (color[i] > color[j]) {
				t = color[i];
				color[i] = color[j];
				color[j] = t;
			}
	}
	else {
	for (i = 0; i < MAXC; ++i)
		for (j = i + 1; j < MAXC; ++j)
			if (color[i] < color[j]) {
				t = color[i];
				color[i] = color[j];
				color[j] = t;
			}
	}

	p[0][0] = 1;
	for (i = 1; i <= 12; ++i) {
		p[i][0] = 1;
		for (j = 1; j <= i; ++j)
			p[i][j] = p[i-1][j-1] + p[i-1][j];
	}

	for (i = 0; color[i] == 0; ++i)
		;

	ans = uq[color[i]];
	l = 12 - color[i];

	for (i++; l > 0; ++i) {
		ans *= p[l][color[i]];
		l -= color[i];
	}
}

void writef(void) {
	printf("%d\n", ans);
}
