#include <stdio.h>

#undef min

#define MAXN 128

int n, k, p, ans;
int a[MAXN];
int c[MAXN][MAXN];

void readf(void);
void solve(void);
void writef(void);

int main(void) {
    readf();
    solve();
    writef();
    
    return 0;
}

void readf(void) {
     for (p = 0; scanf("%d", &a[p]) == 1; ++p)
         n += a[p];
     k = a[--p];
     n -= k;
}

void solve(void) {
     int i, j, t, x;

     int min(int a, int b);
     
     c[0][0] = 1;
     for (i = 1; i <= n; ++i)
         for (j = 1; j <= i; ++j)
             for (t = 1; t <= j; ++t)
                 c[i][j] += c[i-t][min(i-t, t)];

     for (i = 0; i < p; ++i)
         for (j = i + 1; j < p; ++j)
             if (a[i] < a[j]) {
                t = a[i];
                a[i] = a[j];
                a[j] = t;
             }

     for (i = j = 0, t = n; i < p; ++i) {
         j += c[t][a[i]-1];
         t -= a[i];
     }

     x = j - k;
     if (x < 0)
        ans = j;
     else {
          ans = -1;
          for (p = 0, t = n; t > 0; ++p) {
              for (i = 1; x >= c[t][i]; ++i)
                  ;
              a[p] = i;
              x -= c[t][i-1];
              t -= i;
          }
     }
}

void writef(void) {
     int i;

     if (ans == -1) {
        printf("%d", a[0]);
        for (i = 1; i < p; ++i)
            printf(" %d", a[i]);
        putchar('\n');
     }
     else
         printf("%d\n", ans);
}

int min(int a, int b) {
    return ((a < b) ? a : b);
}

