#include <stdio.h>
#include <string.h>

#define INP "club.in"

#define MAX 1000010

int m1[MAX],m2[MAX],t[MAX];

int n = 0;

int left(int node) { return 2*node; }
int right(int node) { return 2*node+1; }
int parent(int node) { return node/2; }

/****************************************/
void hup(int index,int sz) {
int tmp;
int par;
     while (index!=1) {
           par= parent(index);
           if (t[par]>t[index]) {
              tmp = t[par];
              t[par] = t[index];
              t[index]  = tmp;
              index = par;
           } else break;
     }
}

void hdown(int index,int sz) {
int l,r,mi;
int tmp;
     while (index<=sz) {
           l = left(index);
           r = right(index);
           mi = index;
           if (l<=sz && t[l]<t[mi]) mi = l;
           if (r<=sz && t[r]<t[mi]) mi = r;
           if (mi!=index) {
              tmp = t[mi];
              t[mi] = t[index];
              t[index] = tmp;
              index = mi;
           } else break;
           
     }
}

/****************************************************/

void heapsort1(int sz) {
int tmp;
int i;
     for (i=1;i<=sz;i++) {
         t[i] = m1[i];
         hup(i,i);
     }
     for (i=1;i<=sz;i++) {
         m1[i] = t[1];
         t[1] = t[sz-i+1];
         hdown(1,sz-i);
     }
}


void heapsort2(int sz) {
int tmp;
int i;
     for (i=1;i<=sz;i++) {
         t[i] = m2[i];
         hup(i,i);
     }
     for (i=1;i<=sz;i++) {
         m2[i] = t[1];
         t[1] = t[sz-i+1];
         hdown(1,sz-i);
     }
}



int main () {
int k,n=1,x,y,i;
int res = 0;
int inside = 0;
int m1i,m2i,nst;
int can;
//    FILE *f = fopen ( INP , "r");
    scanf("%d",&k);
    memset(m1,0,sizeof(m1));
    memset(m2,0,sizeof(m2));
    while (scanf("%d%d",&x,&y)==2) {
          m1[n] = x;
          m2[n] = x+y;
//          m1[n].st = m2[n].st = x;
//          m1[n].fi = m2[n].fi = x+y;
          n++;
    }
    n--;
//    fclose(f);
    heapsort1(n);
    heapsort2(n);

    // m1 - startowi wremena
    // m2 - finish wremena
    for (m1i=1,m2i=1;m1i<=n && m2i<=n;) {
        while (m1[m1i]<m2[m2i] && m1i<=n) { inside++; m1i++; }
        if (m2[m2i] == m1[m1i]) {
//           can = 1;
           nst = m1[m1i];
           while (m2[m2i] == nst && m2i<=n) { inside--; m2i++; }
           if (inside>=k)
              res++;
           while (m1[m1i] == nst && m1i<=n) { m1i++; inside++; }
        }
        while (m1[m1i]>m2[m2i] && m2i<=n) { inside--; m2i++; }
        // else can = 0;
//        if (can && inside>=k) res++;
    }
    printf("%d\n",res);
    return 0;
}
