#include <stdio.h>

int dia[32][21];
int p[21];
int m, L;

void print() {
	int i, j;

	for (i = 0; i < m; i++)
		for (j = 0; j < p[i]; j++)
			printf("%i%c", dia[j][i], j == p[i] - 1 ? '\n' : ' ');
}

int is_valid(int col, int row) {
	int i, j[21];
	int x;

	x = dia[col][row];
	for (i = 0; i < m; i++) {
		j[i] = 0;
		while (j[i] < p[i] && dia[ j[i] ][i] <= x)
			j[i]++;
		j[i]--;
	}

	if ((row + 2 < m && j[row + 1] == j[row + 2]) || j[row + 1] == -1)
		return 0;
	dia[j[row + 1]][row + 1] = x;
	j[row + 1]--;
	while (x-- > 1) {
		for (i = 0; i + 1 < m; i++)
			if (j[i] > j[i + 1])
				break;
		dia[ j[i] ][i] = x;
		j[i]--;
	}
	return 1;
}

int main() {
	int i, j, flag, k;

	scanf("%i", &m);
	for (i = 0; i < m; i++)
		scanf("%i", p + i);
	scanf("%i", &L);

	for (i = 0; i < m; i++)
		for (j = 0; j < p[i]; j++)
			scanf("%i", &dia[j][i]);

	k = L;
	while (L) {
		flag = 0;
		for (i = 0; i < m - 1; i++)
			for (j = 1; j < p[i]; j++)
				if (is_valid(j, i)) {
					flag = 1;
					goto l1;
				}
		if (!flag)
			break;
l1:
		L--;
	}

	if (L) {
		printf("%i\n", k - L);
		return 0;
	}

	print();
	return 0;
}
