#include <stdio.h>

int h[356];

int mx = 1;

void search(int l, int r, int m);

typedef struct {
	int l, r, pl;
} SQueue;

int qe, qb;
SQueue queue[90000];

int calc_pl(int l, int r) {
	int d, diff, pl;

	d = r - l;
	if (!d)
		return -300;
	if (h[l] >= h[r]) {
		diff = h[l] - h[r];
		pl = (d - diff)/2;
	}
	else {
		diff = h[r] - h[l];
		pl = diff + (d - diff)/2;
	}
	return pl;
}

void ask(void) {
	int l, r, pl, m;

	l = queue[qb].l;
	r = queue[qb].r;
	pl = queue[qb++].pl;

	if (h[l] + pl <= mx)
		return;

	m = l + pl;
	printf("%i\n", m);
	fflush(stdout);
	scanf("%i", h + m);
	if (h[m] > mx)
		mx = h[m];

	pl = calc_pl(l, m);
	if (h[l] + pl > mx) {
		queue[qe].l = l;
		queue[qe].r = m;
		queue[qe++].pl = pl;
	}

	pl = calc_pl(m, r);
	if (h[m] + pl > mx) {
		queue[qe].l = m;
		queue[qe].r = r;
		queue[qe++].pl = pl;
	}
}

int main() {
	int n;

	scanf("%i", &n);

	h[0] = h[n] = 0;
	h[1] = h[n - 1] = 1;
	qe = qb = 0;
	queue[qe].l = 1;
	queue[qe].r = n - 1;
	queue[qe++].pl = calc_pl(1, n - 1);
	while (qe > qb)
		ask();
	while (n-- > 0)
		if (h[n] == mx)
			break;

	printf("-1 %i %i\n", n, mx);
	fflush(stdout);

	return 0;
}
