#include <limits.h>
#include <iostream.h>

int N;
int M;
int S[2000 + 1];
int SS[2000 + 1][2000 + 1];//JG 16 MB
int cache[2000 + 1][2000 + 1];//JG 16 MB
int cachei[2000 + 1][2000 + 1];//JG 16 MB

class Node {
	public:
	int d;
	Node* left;
	Node* right;
};

int f(int l, int r) {
	if (cache[l][r] >= 0) return cache[l][r];
	if (l > r) return cache[l][r] = 0;
	int min = INT_MAX;//JG
	int mini;
	for (int i = l; i <= r; i++) {
		int x = f(l, i - 1) + f(i + 1, r) + SS[l][r];
		if (x < min) {
			min = x;
			mini = i;
		}
	}
	cachei[l][r] = mini;
	return cache[l][r] = min;
}

void fill_SS() {
	for (int i = 1; i <= N; i++) {
		int sum = 0;
		for (int j = i; j <= N; j++) {
			sum += S[j];
			SS[i][j] = sum;
		}
	}
}

Node* build_tree(int l, int r) {
	if (l > r) return NULL;
	Node* p = new Node;
	p->d = cachei[l][r];
	p->left = build_tree(l, p->d - 1);
	p->right = build_tree(p->d + 1, r);
	return p;
}

void print_tree(Node* tree, int t = 0) {
	if (tree == NULL) return;
	print_tree(tree->right, t + 1);
	for (int i = 0; i < t; i++) cout << ' ';
	cout << tree->d << '\n';
	print_tree(tree->left, t + 1);
}

void print(Node* tree, int r, char c) {
	if (tree == NULL) return;
	print(tree->right, tree->d, '>');
	cout << tree->d << ' ' << r << ' ' << c << '\n';
	print(tree->left, tree->d, '<');
}

int main() {
	cin >> N >> M;
	for (int i = 1; i <= N; i++) {
		cin >> S[i];
	}
	for (int i = 0; i <= N; i++) {
		for (int j = 0; j <= N; j++) {
			cache[i][j] = -1;
		}
	}
	fill_SS();
	int tmp = f(1, N);
	//cout << "tmp=" << tmp << '\n';
	Node* tree = build_tree(1, N);
	//print_tree(tree);
	cout << tree->d << '\n';
	print(tree->right, tree->d, '>');
	print(tree->left, tree->d, '<');
}