#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//#define INP "diag.in"

#define MAX 32

#define MAX_SOLN 512

#define UNDEF -1


int sln[MAX_SOLN];
int p[MAX],m,l; // INPUT promenliwite
int row[MAX];
int var[MAX][MAX];
int out[MAX][MAX];

int varc(int rows,int max) { // smiata po kolko na4ina moje da se polu4i
			     // *max* za *rows* reda
			     // redowete sa rows, t.e. 1,2,3,...,rows
int i,ret=0;
	if (var[rows][max]!=UNDEF) return var[rows][max];
	if (rows==1) return max+1;
	for (i=0;i<=max;i++)
		ret+=varc(rows-1,max-i);
	return var[rows][max] = ret;
}

void decode(int index,int mas[]) { // po poreden nomer pylni masiw sz
int res = 0;
int i,j,prev;
	for (i=0;i<=m;i++) mas[i]=0;
	index++;
//	if (index==0) return;
	for (i=1;i<=m;i++) {
		prev = 0;
		for(j=0;j<=p[i];j++) {
//			if (j==0) res=0; else
			res=varc(m-i+1,j);
			if (res>=index) { mas[i]=j; res=prev; index-=prev; break; }
//			if (res==index) { mas[i] = j; break; }
			prev = res;
		}
	}
}

int encode(int mas[]) { // po masiw namira porednia mu nomer
int i,j,ret=0;
	for (i=1;i<=m;i++) {
//		for (j=mas[i];j>=0;j--)
			ret+=varc(m-i+1,mas[i]-1);
	}
	return ret;
}



int pos(int index) { // wry6ta kolko reshenia ima ot dadena formi4ka
int ret = 0;
int r[MAX];
int i;
int can = 1;
	if (sln[index]!=UNDEF) return sln[index];
	decode(index,r);
	for(i=1;i<=m;i++)
		if (r[i]!=p[i]) can = 0;
	if (can) return 1;
	for(i=1;i<=m;i++) {
		if (r[i]<p[i] && (i==1 || r[i]<r[i-1])) {
			r[i]++;
			ret+=pos(encode(r));
			r[i]--;
		}
	}
	return sln[index] = ret;
}


int main () {
int i,j,k=0,sz[MAX],x,form_index=0,index,tindex,prev;
	FILE *f ;//= fopen ( INP , "r");
	f = stdin;
	fscanf(f,"%d",&m);
	for (i=0;i<MAX_SOLN;i++) sln[i] = UNDEF;
	for (i=0;i<MAX;i++) for(j=0;j<MAX;j++) var[i][j] = UNDEF;
	for (i=1;i<=m;i++) { fscanf(f,"%d",&p[i]); k+=p[i]; }
	fscanf(f,"%d",&l);
	for (i=1;i<=m;i++)
		for (j=1;j<=p[i];j++) {
			fscanf(f,"%d",&x);
			row[x] = i;
		}
//	fclose(f);
//	decode(8,sz);
//	printf("%d\n",varc(2,1));
	index = 0;
	for(i=1;i<=k;i++) {
		decode(form_index,sz);
		for (j=1;j<row[i];j++) { // probvame da slojim I na j-ti red
			if (sz[j]<p[j] && (j==1 || sz[j]<sz[j-1])) {
				sz[j]++;
				index+=pos(encode(sz));
				sz[j]--;
			}
		}
		sz[row[i]]++;
		form_index=encode(sz);
	}
	if (index<l) {
		printf("%d\n",index);
		exit(0);
	} else {
		index = index-l+1;
		tindex=0;
		memset(sz,0,sizeof(sz));
		for(i=1;i<=k;i++) {

			prev = 0;
                        tindex = 0;
//			decode(form_index,sz);
			for (j=1;j<=m;j++) { // probvame da slojim I na j-ti red

				if (sz[j]<p[j] && (j==1 || sz[j]<sz[j-1])) {
					sz[j]++;
					tindex+=pos(encode(sz));
					if (tindex>=index) {
						out[j][sz[j]] = i;
						index-=prev;
						break;
					}
					prev = tindex;
					sz[j]--;
				}
			}
//			sz[row[i]]++;
//			form_index=encode(sz);


		}
		for(i=1;i<=m;i++)
			for(j=1;j<=p[i];j++)
				printf("%d%c",out[i][j],(j==p[i])?'\n':' ');
	}

	return 0;
}