#include <stdio.h>

#define MAX 2048

//#define INP "bintree.in"

#define UNDEF -1

#define INF 2000000000

int m[MAX][MAX];
int p[MAX],n,sum;


int tree(int beg,int end) {
int i,res,index,min=INF;
	if (beg>end) return m[beg][end] = 0;
	if (beg==end) return m[beg][end] = p[beg];
	if (m[beg][end]!=UNDEF) return m[beg][end];
	for (i=beg;i<=end;i++) {
		res = p[i]+2*tree(beg,i-1)+2*tree(i+1,end);
		if (res<min) {
			min = res;
		}
	}
	return m[beg][end] = min;
}

void prints(int root,int beg,int end) {
int i,res;
	if (beg>end) return;
	if (beg==end) { printf("%d %d %c\n",beg,root,(beg<root)?'<':'>'); return; }
	for (i=beg;i<=end;i++) {
		res = p[i]+2*m[beg][i-1]+2*m[i+1][end];
		if (res==m[beg][end]) break;
	}
	if (root==-1)
		printf("%d\n",i);
	else
		printf("%d %d %c\n",i,root,(i<root)?'<':'>');
	prints(i,beg,i-1);
	prints(i,i+1,end);
}

int main () {
int i,j;
        //FILE *f ;
        //f = stdin;// = fopen ( INP , "r");
        scanf("%d%d",&n,&sum);
        for (i=1;i<=n;i++) scanf("%d",&p[i]);
	for (i=1;i<=MAX;i++)
		for(j=1;j<=MAX;j++)
			m[i][j] = UNDEF;
//	fclose(f);
	tree(1,n);
	prints(-1,1,n);
	fflush(stdout);
	return 0;
}
