#include <stdio.h>

#define MAX	2010
#define INF	2000000010

long n,m,s[MAX],sum[MAX],res[MAX][MAX];
long path[MAX][MAX];

void solve(void)
{long i,j,k,best,bi,tek;

 for(i=1;i<=n;i++) { res[i][i]=s[i]; path[i][i]=i; }

 for(i=1;i<n;i++) //distance from diag
 {
  for(j=1;j<=n;j++)
   if(i+j>n) break;
   else
   {
    bi=-1;
    best=INF;
    for(k=j;k<=i+j;k++)
    {
     tek=res[j][k-1]+res[k+1][i+j]+s[k]+(sum[k-1]-sum[j-1])+(sum[i+j]-sum[k]);
     if(tek<best) { best=tek; bi=k; }
    }
    res[j][i+j]=best;
    path[j][i+j]=bi;
   }
 }
}

void rec(long i,long j)
{
 if(i==j) return;
 if(i<=path[i][j]-1)
 {
  printf("%ld %ld <\n",path[i][path[i][j]-1],path[i][j]);
  rec(i,path[i][j]-1);
 }
 if(path[i][j]+1<=j)
 {
  printf("%ld %ld >\n",path[path[i][j]+1][j],path[i][j]);
  rec(path[i][j]+1,j);
 }
}

void main()
{long i;

// freopen("bintree.in","r",stdin);

 scanf("%ld%ld",&n,&m);
 for(i=1;i<=n;i++)
 {
  scanf("%ld",s+i);
  sum[i]=s[i]+sum[i-1];
 }

// fclose(stdin);

 solve();

// freopen("bintree.out","w",stdout);

 printf("%ld\n",path[1][n]);
 rec(1,n);

// fclose(stdout);
}
