#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define MAXN 2100

int N, M;

int s[MAXN];
int prto[MAXN];
int subt[MAXN][MAXN];
int rootat[MAXN][MAXN];



int print_answer(int i1, int i2);
int cmp_s(const void *a, const void *b);




int main(void)
{
  int i, j, k, c;

  /*freopen("1.txt", "rt", stdin);*/
  scanf("%d %d", &N, &M);
  for (i = 0; i < N; i++) {
    scanf("%d", &s[i]);
    prto[i] += s[i];
    prto[i+1] = prto[i];
  }
  memset(subt, 0, sizeof(subt));
  subt[0][0] = 0;
  for (i = 1; i < N; i++) {
    subt[i][i] = 0;
    rootat[i][i] = i;
    for (j = i-1; j >= 0; j--) {
      subt[j][i] = 1<<29;
      for (k = j; k <= i; k++) {
        c = prto[i]-prto[j]+s[j] - s[k] + subt[j][k-1] + subt[k+1][i];
        if (c < subt[j][i]) {
          subt[j][i] = c;
          rootat[j][i] = k;
        }
      }
    }
  }
  printf("%d\n", 1+rootat[0][N-1]);
  print_answer(0, N-1);
  /*qsort(s, N, sizeof(s[0]), cmp_s);
  printf("%d\n", s[0][1]);
  for (i = 1, c = '<'; i < N; i++, c='<'+'>'-c) {
    par = s[(i-1)/2][1];
    printf("%d %d %c\n", s[i][1], par, c);
  }*/

  return 0;
}


int print_answer(int i1, int i2)
{
  int r = rootat[i1][i2], r1, r2 = r1 = -1;

  if (i1 <= r-1)  r1 = print_answer(i1, r-1);
  if (r+1 <= i2)  r2 = print_answer(r+1, i2);
  if (r1 >= 0)  printf("%d %d <\n", 1+r1, 1+r);
  if (r2 >= 0)  printf("%d %d >\n", 1+r2, 1+r);
  return r;
}


int cmp_s(const void *a, const void *b)
{
  if (((int *)a)[0] < ((int *)b)[0])  return 1;
  if (((int *)a)[0] > ((int *)b)[0])  return -1;
  return 0;
}
