/*
TASK: POINTS
LANG: C
*/

#include <stdio.h>
#include <math.h>

#define MAXN            1010

int n;
int mas[MAXN][2];
int area;
int border;
int inside;
int ans;

void CalcArea()
{
  int i;
  int res;
  int x1,y1,x2,y2;

  area = 0;

  for(i=1;i<=n;i++)
  {
    x1 = mas[i][0];
    y1 = mas[i][1];
    x2 = mas[i+1][0];
    y2 = mas[i+1][1];

    res = x1*y2 - x2*y1;

    area += res;
  }

  if(area<0)
    area *= (-1);
}

void input()
{
  int i;

  scanf("%d",&n);

  for(i=1;i<=n;i++)
    scanf("%d %d",&mas[i][0],&mas[i][1]);

  mas[n+1][0] = mas[1][0];
  mas[n+1][1] = mas[1][1];
}

int Nod(int a, int b)
{
  int buf;

  if(a<b)
  {
    buf = a;
    a = b;
    b = buf;
  }

  if(b==0)
    return a;

  while((a%b)!=0)
  {
    buf = b;
    b = a%b;
    a = buf;
  }

  return b;
}

void CalcBorder()
{
  int i;
  int r1,r2;
  int res;

  border = 0;

  for(i=1;i<=n;i++)
  {
    r1 = abs(mas[i][0]-mas[i+1][0]);
    r2 = abs(mas[i][1]-mas[i+1][1]);
    res = Nod(r1,r2);

    border+=res;
  }
}

void CalcInside()
{
  inside = (area+2-border)/2;
}

void solve()
{
  int i;

  CalcArea();
  CalcBorder();
  CalcInside();
}

void output()
{
  ans = inside + border;

  printf("%d\n",ans);
}

int main()
{
//  freopen("pointst.txt","r",stdin);

  input();
  solve();
  output();

  return 0;
}

