/*
TASK : POINTS
LANG : C
*/
#include <stdio.h>

#define MAXN 1500
#define ABS(a) ((a) > 0 ? (a) : (-(a)))

int pts[MAXN][2];
int P,S,V;
int n,res;

void Init()
  {
    int i;

//    freopen("points.in","rt",stdin);
    scanf("%d",&n);

    for (i = 0;i < n;i++)
      scanf("%d%d",&pts[i][0],&pts[i][1]);
  }

int GCD(int a,int b)
  {
    if (a < b) return GCD(b,a);
    if (b == 0) return a;
    return GCD(b,a % b);
  }

void Solve()
  {
    int i,a,b;

    P = 0;
    for (i = 0;i < n - 1;i++)
      {
        a = ABS(pts[i + 1][0] - pts[i][0]);
        b = ABS(pts[i + 1][1] - pts[i][1]);
        P += GCD(a,b);
      }
    a = ABS(pts[0][0] - pts[n - 1][0]);
    b = ABS(pts[0][1] - pts[n - 1][1]);
    P += GCD(a,b);


    S = 0;
    pts[n][0] = pts[0][0];
    pts[n][1] = pts[0][1];
    for (i = 0;i < n;i++)
      S += pts[i][0]*pts[i + 1][1] - pts[i][1]*pts[i + 1][0];

    S = ABS(S);
    V = (S + 2 - P) / 2;
    res = V + P;
  }

void Output()
  {
    printf("%d\n",res);
  }

int main()
  {
    Init();
    Solve();
    Output();
    return 0;
  }
