/*
TASK : TRAV
LANG : C
*/

#include <stdio.h>
//#include <time.h>

#define MAXN 16
#define MAXM 64
#define MAX(a,b) ((a) > (b) ? (a) : (b))

short perm[MAXN];
int T[MAXN][MAXM];
int n,m;
short opt[MAXN];
int min_t = 0x7FFFFFFF;
int curr_t[MAXN][MAXM];
int tmp;
int used[MAXN];

void Init()
  {
    int i,j;

//    freopen("trav.in","rt",stdin);

    scanf("%d%d",&n,&m);
    for (i = 0;i < n;i++)
      for (j = 0;j < m;j++)
        scanf("%d",&T[i][j]);
  }

void Try(int pos)
  {
    int i,j;

    if (tmp >= min_t) return;

    if (pos == n)
      {
        min_t = tmp;
        memcpy(opt,perm,sizeof(perm));
        return;
      }

    for (i = 0;i < n;i++)
      if (!used[i])
        {

          curr_t[i][0] = MAX(curr_t[perm[pos - 1]][0],T[i][0]);
          for (j = 1;j < m;j++)
            curr_t[i][j] = MAX(curr_t[perm[pos - 1]][j],curr_t[i][j - 1] + T[i][j]);

          tmp += curr_t[i][m - 1];

          perm[pos] = i;
          used[i] = 1;
          Try(pos + 1);
          used[i] = 0;
          perm[pos] = 0;

          tmp -= curr_t[i][m - 1];
        }
  }

void Solve()
  {
    int i,j;
    for (i = 0;i < n;i++)
      {
        curr_t[i][0] = T[i][0];
        for (j = 1;j < m;j++)
          curr_t[i][j] = curr_t[i][j - 1] + T[i][j];

        tmp = curr_t[i][m - 1];
        used[i] = 1;
        perm[0] = i;
        Try(1);
        used[i] = 0;
      }
  }

void Output()
  {
    int i;

    for (i = 0;i < n - 1;i++)
      printf("%d ",opt[i] + 1);
    printf("%d\n",opt[n - 1] + 1);
  }

int main()
  {
//    clock();
    Init();
    Solve();
    Output();
//    printf("Time : %lf\n",(double)clock() / CLOCKS_PER_SEC);
    return 0;
  }

