#include <stdio.h>
#include "module.h"

int n;
int move[128][2];
int cur;
int ques;
int que[524288];
int neis[524288];
int type[524288];
int depth[524288];
int best[524288];
FILE *fn;

int main() {
	int i, j, q, f;
	char tmp1, tmp2, tmp3, tmp4, tmp5, tmp6;
	int kx, ky, cx, cy, bx, by, turn;
	int x, y;
	char bnx;
	long bny;

	fn = fopen("chess.in", "r");
	fscanf(fn, "%c%c %c%c %c%c", &tmp1, &tmp2, &tmp3, &tmp4, &tmp5, &tmp6);
	cur = ((tmp1-'a')<<15)+((tmp2-'1')<<12)+((tmp3-'a')<<9)+((tmp4-'1')<<6)+((tmp5-'a')<<3)+tmp6-'1';
	fscanf(fn, "%d", &n);
	for (i=0; i<n; i++) fscanf(fn, "%d %d", &move[i][0], &move[i][1]);
	fclose(fn);

	for (i=0; i<524288; i++) {
		by = i%8;
		bx = (i>>3)%8;
		cy = (i>>6)%8;
		cx = (i>>9)%8;
		ky = (i>>12)%8;
		kx = (i>>15)%8;
		turn = i>>18;
		if ((kx==cx && ky==cy) || (bx==cx && by==cy) || (kx==bx && ky==by)) continue;
		if (turn) {
			if (bx-kx<=1 && kx-bx<=1 && by-ky<=1 && ky-by<=1) {
				type[i] = 1;
				depth[i] = 1;
				best[i] = kx*8+ky;
				que[ques] = i;
				ques++;
			} else if ((bx-cx<=1 && cx-bx<=1 && by-cy<=1 && cy-by<=1) && !(kx-cx<=1 && cx-kx<=1 && ky-cy<=1 && cy-ky<=1)) {
				type[i] = 1;
				depth[i] = 1;
				best[i] = cx*8+cy;
				que[ques] = i;
				ques++;
			} else {
				for (x=bx-1; x<=bx+1; x++) if (x>=0 && x<=7) for (y=by-1; y<=by+1; y++) if (y>=0 && y<=7) {
					if ((x!=bx || y!=by) && (x!=cx || y!=cy) && (x!=kx || y!=ky)) neis[i]++;
				}
			}
		} else {
			if (bx-kx<=1 && kx-bx<=1 && by-ky<=1 && ky-by<=1) {
				type[i] = 1;
				depth[i] = 1;
				best[i] = bx*8+by;
				que[ques] = i;
				ques++;
			} else {
				for (j=0; j<n; j++) if (cx+move[j][0]==bx && cy+move[j][1]==by) break;
				if (j<n) {
					type[i] = 1;
					depth[i] = 1;
					best[i] = 64+bx*8+by;
					que[ques] = i;
					ques++;
				} else {
					for (x=kx-1; x<=kx+1; x++) if (x>=0 && x<=7) for (y=ky-1; y<=ky+1; y++) if (y>=0 && y<=7) {
						if ((x!=bx || y!=by) && (x!=cx || y!=cy) && (x!=kx || y!=ky)) neis[i]++;
					}
					for (j=0; j<n; j++) {
						x = cx+move[j][0];
						y = cy+move[j][1];
						if (x>=0 && x<=7 && y>=0 && y<=7 && (x!=kx || y!=ky)) neis[i]++;
					}
				}
			}
		}
	}

	for (i=0; i<ques; i++) {
		q = que[i];
		if (q==cur) break;
		by = q%8;
		bx = (q>>3)%8;
		cy = (q>>6)%8;
		cx = (q>>9)%8;
		ky = (q>>12)%8;
		kx = (q>>15)%8;
		turn = q>>18;
		if (turn) {
			for (x=kx-1; x<=kx+1; x++) if (x>=0 && x<=7) for (y=ky-1; y<=ky+1; y++) if (y>=0 && y<=7) {
				if ((x!=bx || y!=by) && (x!=cx || y!=cy) && (x!=kx || y!=ky)) {
					f = q-(1<<18)+(x-kx)*(1<<15)+(y-ky)*(1<<12);
					if (type[f]==0) {
						if (type[q]==2) {
							type[f] = 1;
							depth[f] = depth[q]+1;
							best[f] = kx*8+ky;
							que[ques] = f;
							ques++;
						} else if ((--neis[f])==0) {
							type[f] = 2;
							depth[f] = depth[q]+1;
							best[f] = kx*8+ky;
							que[ques] = f;
							ques++;
						}
					}
				}
			}
			for (j=0; j<n; j++) {
				x = cx-move[j][0];
				y = cy-move[j][1];
				if (x>=0 && x<=7 && y>=0 && y<=7 && (x!=bx || y!=by) && (x!=cx || y!=cy) && (x!=kx || y!=ky)) {
					f = q-(1<<18)+(x-cx)*(1<<9)+(y-cy)*(1<<6);
					if (type[f]==0) {
						if (type[q]==2) {
							type[f] = 1;
							depth[f] = depth[q]+1;
							best[f] = 64+cx*8+cy;
							que[ques] = f;
							ques++;
						} else if ((--neis[f])==0) {
							type[f] = 2;
							depth[f] = depth[q]+1;
							best[f] = 64+cx*8+cy;
							que[ques] = f;
							ques++;
						}
					}
				}
			}
		} else {
			for (x=bx-1; x<=bx+1; x++) if (x>=0 && x<=7) for (y=by-1; y<=by+1; y++) if (y>=0 && y<=7) {
				if ((x!=bx || y!=by) && (x!=cx || y!=cy) && (x!=kx || y!=ky)) {
					f = q+(1<<18)+(x-bx)*8+y-by;
					if (type[f]==0) {
						if (type[q]==2) {
							type[f] = 1;
							depth[f] = depth[q]+1;
							best[f] = bx*8+by;
							que[ques] = f;
							ques++;
						} else if ((--neis[f])==0) {
							type[f] = 2;
							depth[f] = depth[q]+1;
							best[f] = bx*8+by;
							que[ques] = f;
							ques++;
						}
					}
				}
			}
		}
	}

	while (1) {
		if (type[cur]!=1) printf("LOSS\n");
		if (best[cur]>>6) {
			moveColonel('a'+(best[cur]>>3)%8, 1+best[cur]%8);
			cur = (cur&0770077)+(1<<18)+((best[cur]%64)<<6);
		} else {
			moveKing('a'+(best[cur]>>3), 1+best[cur]%8);
			cur = (cur&07777)+(1<<18)+(best[cur]<<12);
		}
		if (((cur&0770000)>>12) == cur%64 || ((cur&07700)>>6) == cur%64) break;
		getKing(&bnx, &bny);
		cur = (cur&0777700)+(bnx-'a')*8+bny-1;
		if ((cur&077) == (cur&07700)>>6) {
			moveKing('a'+(cur>>3)%8, 1+cur%8);
			break;
		}
	}

	return 0;
}
