#include <stdio.h>
#include <vector>
using namespace std;

const int inf = 1023456789;
const int N = 10002;

struct Type{
	int conn;
	int dist;
	Type(){}
	Type(int _conn, int _dist){
		conn = _conn;
		dist = _dist;
	}
};

vector<Type> data[N];
int dist[N];
bool used[N];
int n, m;
int i, j;

void Input(){
//	freopen("fast.in", "rt", stdin);
	scanf("%d%d", &n, &m);
	for(i=1; i<=m; i++){
		int p, q, w;
		scanf("%d%d%d", &p, &q, &w);
		data[p].push_back(Type(q, w));
		data[q].push_back(Type(p, w));
	}
}

inline int max(int p, int q){
	return p > q ? p : q;
}
inline int min(int p, int q){
	return p < q ? p : q;
}


void Solve(){
	
	dist[1] = inf;
	int best = 1;

	while(best != 0){
		used[best] = true;
		for(i=0; i<data[best].size(); i++)
			dist[data[best][i].conn] = max(
					dist[data[best][i].conn],
					min(data[best][i].dist, dist[best])
					);
		best = 0;
		for(i=1; i<=n; i++)
			if(dist[i] > dist[best] && !used[i])
				best = i;
	}
	printf("%d\n", dist[n]);
}

int main(){
	Input();
	Solve();
	return 0;
}

