#include <iostream.h>

const ARRAY_SIZE=170;
const OUTPUT=50;

unsigned int city_net[ARRAY_SIZE][ARRAY_SIZE];
int N=0;
long M=0;
int out_N=0;
unsigned int OUT[OUTPUT];
char passed[ARRAY_SIZE];

void initialize()
{
	for(int i=0;i<ARRAY_SIZE;i++)
	{
		for (int j=0;j<ARRAY_SIZE;j++)
		{
			city_net[i][j]=0;
		}
		passed[i]=0;
	}
	for (i=0;i<OUTPUT;i++)
	{
		OUT[i]=65001;
	}
	return;
}

void write()
{
	unsigned int temp=0;
	if (out_N==0)
	{
		if (OUT[0]==65001)
		{
			cout<<0;
			return;
		}
		cout<<OUT[0];
		return;
	}

	for (int i=0;i<out_N;i++)
	{
		if ((OUT[i]>temp)&&(OUT[i]!=65001)) temp=OUT[i];
	}

	cout<<temp;
	return;
}

void read()
{
	int temp1=0;
	int temp2=0;

	cin>>N>>M;
	for(int i=0;i<M;i++)
	{
		cin>>temp1>>temp2;
		temp1--;
		temp2--;
		cin>>city_net[temp1][temp2];
	}
	return;
}

int make(int last,unsigned int lastout)
{
	if (last==N-1) return 1;

	for (int i=0;i<N;i++)
	{
		if ((city_net[last][i]>0)&&(passed[i]==0))
		{
			if (city_net[last][i]<OUT[out_N]) OUT[out_N]=city_net[last][i];
			passed[i]=1;
			if (make(i,OUT[out_N])==0)
			{
				passed[i]=0;
				OUT[out_N]=lastout;
			}
			else
			{
				out_N++;
				OUT[out_N]=lastout;
				passed[i]=0;
			}
		}
	}
	return 0;
}



int main()
{
	initialize();
	read();
	passed[0]=1;
	make(0,65001);

	write();
	return 0;
}