#include <fstream.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

struct point
{
 long int x; long int y;
 int i;
 } points[ 2001 ];
int n;
int visited[ 2000 ];

struct angle
{
  point p1;
  point p2;
 } angles[ 2000 ];

int ac=0;

void init( )
{
//  ifstream cin( "rays.in" );
  cin>>n;

 for ( int i=0; i<=n; i++ )
	 {
	 cin>>points[ i ].x>>points[ i ].y;
	 points[ i ].i = i;
	 }
// cin.close( );
 memset( visited, 0, sizeof( visited ) );
}

int ccw( point p0, point p1, point p2 )
{
 int dx1 = p1.x - p0.x;
 int dx2 = p2.x - p0.x;
 int dy1 = p1.y - p0.y;
 int dy2 = p2.y - p0.y;

 if ( dx1*dy2 > dx2 * dy1 )
		return 1;

 if ( dx1*dy2 < dx2 * dy1 )
		return -1;

 if ( dx1*dy1 < dx2 * dy2 )
	 	return -1;

 if ( dx1*dx1 + dy1*dy1 > dx2 * dx2 + dy2*dy2 )
	   return +1;
 return 0;
}

int cmp ( const void* a, const void* b )
{
 angle* p = (angle*) a;
 angle* q = (angle*) b;

 int dist1 = sqrt( pow( p->p1.x - p->p2.x, 2 ) + pow( p->p2.y - p->p1.y, 2 ) );
 int dist2 = sqrt( pow( q->p1.x - q->p2.x, 2 ) + pow( q->p2.y - q->p1.y, 2 ) );

 return dist1 - dist2;
}

void solve( )
{
  point p = points[ 2 ];
  point o = points[ 0 ];
  point p2;

	int x;

	  x = 1;
  while ( x <= n )
	{
	  x = 1;
	  while ( x <= n  )
	  {
		if ( ccw( o, p, points[ x ] ) == -1 )
		  break;
		x++;
	  }

   	if ( x < n )
		 {
		  p = points[ x ];
		  x = 1;
		 }
      else
		  	x = n+1;
	}
 visited[ p.i ] = 1;

 x = 1;
 p2 = points[ 3 ];

 while ( x <= n )
 {
   int y = 1;

   while ( y <= n  )
		 {
		  if ( ccw( o, p2, points[ y ] ) == -1  && !visited[ points[ y ].i ] )
			  p2 = points[ y ];
			y++;
		  }
	visited[ p2.i ] = 1;

	angles[ ++ac ].p1 = p;
	angles[ ac ].p2 = p2;
	p = p2;
	p2 = points[ x+1 ];
	x++;
 }

 qsort( angles+1, ac, sizeof( angles[ 0 ] ), cmp );

 int i;
 for ( i=1; i<=ac; i++ )
	 if ( angles[ i ].p1.i != angles[ i ].p2.i )
		 cout<<angles[ i ].p1.i<<" "<<angles[ i ].p2.i<<endl;
}


void main( )
{
 init( );
 solve( );
}
