const
  maxn = 3000;

type
  tang = record
    v, x, y : double;
    i : integer;
  end;

var
  f : text;

  y : tang;
  ox, oy, k : double;
  n, i, j, r : integer;

  ang : array[0..maxn] of tang;
  res : array[0..maxn] of tang;

function max(a, b : double) : double;
begin if a<b then max:=b else max:=a; end;

function min(a, b : double) : double;
begin if a<b then min:=a else min:=b; end;

procedure input;
var d, sa, ca : double;
begin
  assign(f, '');
  reset(f);
  readln(f, n);
  readln(f, ox, oy);
  for i:=1 to n do
  begin
    ang[i].i:=i;
    readln(f, ang[i].x, ang[i].y);
    with ang[i] do
    begin
      d:=sqrt(sqr(x-ox)+sqr(y-oy));
      sa:=(y-oy)/d;
      ca:=(x-ox)/d;
      if ca=0 then begin if sa>0 then v:=90 else v:=270; end
      else
      begin
        v:=arctan(sa/ca)/pi*180;
        //writeln(v:0:2);
        if (x < ox) then v:=180+v
        else if y < oy then v:=360+v;
      end;
    end;
  end;
  close(f);
end;

procedure sortang(l,r: longint);
var
   x : tang;
   i,j: longint;
begin
   i:=l;
   j:=r;
   x:=ang[(l+r) div 2];
   repeat
     while ang[i].v<x.v do inc(i);
     while x.v<ang[j].v do dec(j);
     if not(i>j) then
       begin
          y:=ang[i];
          ang[i]:=ang[j];
          ang[j]:=y;
          inc(i);
          j:=j-1;
       end;
   until i>j;
   if l<j then
     sortang(l,j);
   if i<r then
     sortang(i,r);
end;

procedure sortres(l,r: longint);
var
   x : tang;
   i,j: longint;
begin
   i:=l;
   j:=r;
   x:=res[(l+r) div 2];
   repeat
     while (res[i].v<x.v)or((res[i].v=x.v)and(res[i].x<x.x))or
           ((res[i].v=x.v)and(res[i].x=x.x)and(res[i].y<x.y)) do inc(i);
     while (x.v<res[j].v)or((x.v=res[j].v)and(x.x<res[j].x))or
           ((x.v=res[j].v)and(x.x=res[j].x)and(x.y<res[j].y)) do dec(j);
     if not(i>j) then
       begin
          y:=res[i];
          res[i]:=res[j];
          res[j]:=y;
          inc(i);
          j:=j-1;
       end;
   until i>j;
   if l<j then
     sortres(l,j);
   if i<r then
     sortres(i,r);
end;

begin
  input;
  sortang(1, n);

  j:=0;
  for i:=1 to n-1 do
  begin
    r:=i+1;
    while ang[r].v=ang[i].v do inc(r);
    k:=ang[r].v-ang[i].v;
    if (k<180)and(k>0) then
    begin
      inc(j);
      res[j].x:=min(ang[r].i, ang[i].i); res[j].y:=max(ang[r].i, ang[i].i);
      res[j].v:=k;
    end;
  end;
  k:=ang[1].v+360-ang[n].v;
  if (k<180)and(k>0) then
  begin
    inc(j);
    res[j].x:=ang[1].i; res[j].y:=ang[n].i;
    res[j].v:=k;
  end;

  sortres(1, j);

  for i:=1 to j do writeln(min(res[i].x, res[i].y):0:0,' ',max(res[i].x, res[i].y):0:0);
end.
