const
   MAXN = 10000;
type
   pnode = ^tnode;
   tnode = record
      v, w : longint;
      next : pnode;
   end;
   trec = record
      v1, v2 : longint;
      w : longint;
   end;
var
   n, m : longint;
   a : array[1..MAXN] of pnode;
   heap : array [1..MAXN] of trec;
   z : longint;

procedure swap(i, j : longint);
var t : trec;
begin
   t:=heap[i];
   heap[i]:=heap[j];
   heap[j]:=t;
end;

procedure push(v1, v2, w : longint);
var i : longint;
begin
   inc(z);
   heap[z].v1:=v1;
   heap[z].v2:=v2;
   heap[z].w:=w;
   i:=z;
   while (i > 1) and (heap[i].w > heap[i div 2].w) do
   begin
      swap(i, i div 2);
      i:=i div 2;
   end;
end;

function pop(var v1, v2, w : longint) : boolean;
var i, c1, c2 : longint;
begin
   if z = 0 then
   begin
      pop:=false;
      exit;
   end;
   w:=heap[1].w;
   v1:=heap[1].v1;
   v2:=heap[1].v2;
   heap[1]:=heap[z];
   dec(z);
   i:=1;
   while true do
   begin
      c1:=i*2; c2:=i*2+1;
      if c1 > z then break;
      if c1 < z then
         if heap[c2].w > heap[c1].w then
            c1:=c2;
      if heap[i].w < heap[c1].w then
         swap(i, c1)
      else
         break;
      i:=c1;
   end;
   pop:=true;
end;

function getw(v1, v2 : longint) : longint;
var p : pnode; x : longint;
begin
   x:=-1;
   p:=a[v1];
   while p <> nil do
   begin
      if p^.v = v2 then
      begin
         x:=p^.w;
         break;
      end;
      p:=p^.next;
   end;
   getw:=x;
end;

function min(a, b : longint) : longint;
begin
   if a < b then min:=a else min:=b;
end;

function doit : longint;
var
   i, j : longint;
   p : pnode;
   u : array[1..MAXN] of longint;
   max : longint;
   v1, v2, t : longint;
begin
   fillchar(u, sizeof(u), 0);
   u[1]:=100000000;
   z:=0;
   p:=a[1];
   while p <> nil do
   begin
      push(1, p^.v, p^.w);
      p:=p^.next;
   end;

   for i:=2 to n do
   begin
      if not pop(v1, v2, max) then
      begin
         doit:=0;
         exit;
      end;
      if u[v1] <> 0 then begin t:=v1; v1:=v2; v2:=t; end;
      u[v1]:=min(max, u[v2]);
      p:=a[v1];
      while p <> nil do
      begin
         if u[p^.v] = 0 then
            push(v1, p^.v, p^.w);
         p:=p^.next;
      end;
   end;
   doit:=u[n];
end;

var
   i : longint;
   t : pnode;
   v1, v2, w : longint;
begin
   readln(n, m);
   for i:=1 to m do
   begin
      readln(v1, v2, w);
      new(t);
      t^.next:=a[v1];
      t^.v:=v2;
      t^.w:=w;
      a[v1]:=t;
      new(t);
      t^.next:=a[v2];
      t^.v:=v1;
      t^.w:=w;
      a[v2]:=t;
   end;

   w:=doit;

   writeln(w);
end.
