/*
NAME : Rostislav
PROG : fast
LANG : C
*/
#include <stdio.h>

 struct edge
  {
   long v1,v2,v;
  }tmp,heap[131072];

 long n,m,c,f[16384];

 long getroot (long v)
  {
   long u,koren;
   koren=v;
   while (f[koren]!=0)
    koren=f[koren];
   while (v!=koren)
    {
     u=f[v];
     f[v]=koren;
     v=u;
    }
   return koren;
  }

 void add (struct edge z)
  {
   long i;
   heap[++c]=z;
   i=c;
   while (i!=1)
    if (heap[i].v>heap[i/2].v)
     {
      tmp=heap[i];
      heap[i]=heap[i/2];
      heap[i/2]=tmp;
      i/=2;
     }
      else
       break;
  }

 void del ()
  {
   long i,w;
   heap[1]=heap[c--];
   i=1;
   while (i*2<=c)
    {
     w=i*2;
     if (w!=c && heap[w].v<heap[w+1].v)
      w++;
     if (heap[i].v<heap[w].v)
      {
       tmp=heap[i];
       heap[i]=heap[w];
       heap[w]=tmp;
       i=w;
      }
       else
        break;
    }
  }

 int main ()
  {
   long i,k1,k2;
   scanf("%ld%ld",&n,&m);
   c=0;
   for (i=1;i<=m;i++)
    {
     scanf("%ld%ld%ld",&tmp.v1,&tmp.v2,&tmp.v);
     add(tmp);
    }
   while (c!=0)
    {
     k1=getroot(heap[1].v1);
     k2=getroot(heap[1].v2);
     if (k1!=k2)
      f[k1]=k2;
     k1=getroot(1);
     k2=getroot(n);
     if (k1==k2)
      break;
     del();
    }
   if (c==0)
    printf("0\n");
     else
      printf("%ld\n",heap[1].v);
   return 0;
  }


