program fast;

type ogr    = 1 .. 10000;

     plist  = ^tlist;

     tlist  = record
       cross : smallint;
       w     : word;
       next  : plist;
     end;

     tcross = record
       pos  : boolean;
       nasl : plist;
     end;

var  arr : array[ogr] of tcross;
     n   : smallint;
     m   : integer;
     max : word;

procedure input;

 var i     : integer;
     b , e : ogr;
     w     : word;

 procedure addrebro(i, j : ogr; w : word);

  var p : plist;

   begin
     new(p);
     p^.cross := j;
     p^.w := w;
     p^.next := arr[i].nasl;
     arr[i].nasl := p
   end;


  begin
    max := 0;
    readln(n, m);
    for i := 1 to n do begin
      arr[i].pos := false;
      arr[i].nasl := nil
    end;
    for i := 1 to m do begin
      readln(b, e, w);
      addrebro(b, e, w);
      addrebro(e, b, w)
    end
  end;

procedure analize(min : word);
  begin if min > max then max := min end;

procedure dfs(i : smallint; min : word);

 var p : plist;

  begin
    if i = n then analize(min)
    else if not arr[i].pos then begin
      arr[i].pos := true;
      p := arr[i].nasl;
      while p <> nil do begin
        if min > p^.w then min := p^.w;
        dfs(p^.cross, min);
        p := p^.next
      end;
      arr[i].pos := false;
    end
  end;

procedure output;

 var i : smallint;
     q : plist;

  begin
    write(max);
    for i := 1 to n do
      while arr[i].nasl <> nil do begin
        q := arr[i].nasl;
        arr[i].nasl := arr[i].nasl^.next;
        dispose(q)
      end
  end;

begin
  input;
  dfs(1, 65000);
  output
end.