#define MAX 10000

unsigned int road[MAX][2];
char used_road[MAX];
unsigned int width[MAX];
unsigned int min_width = (unsigned int) -1;
unsigned int max_width = 0;

unsigned int n;
unsigned int m;

void find_road ( unsigned int from, unsigned int to )
{
    unsigned int i;
    unsigned int old_width;
    
    if ( from == to ) {
//      printf ( "road found with width: %u\n", min_width );
        if ( max_width < min_width )
            max_width = min_width;
        return;
    }
    
    for ( i = 0; i < m; i++ ) {
        if ( road[i][0] == from  && !used_road[i] ) {
            used_road[i] = 1;
            old_width = min_width;
            if ( min_width > width[i] )
                min_width = width[i];
            find_road ( road[i][1], to );
            min_width = old_width;
            used_road[i] = 0;
        }
        else if ( road[i][1] == from && !used_road[i] ) {
            old_width = min_width;
            if ( min_width > width[i] )
                min_width = width[i];
            used_road[i] = 1;
            find_road ( road[i][0], to );
            min_width = old_width;
            used_road[i] = 0;
        }
    }
};

main ()
{
    unsigned int i;
    
    printf ( "croses, roads: " );
    scanf ( "%u %u", &n, &m );
    for ( i = 0; i < m; i++ ) {
        printf ( "from, to, width: " );
        scanf ( "%u %u %u", &road[i][0], &road[i][1], &width[i] );
        road[i][0]--;
        road[i][1]--;
        used_road[i] = 0;
    }

    find_road ( 0, n - 1 );
    printf ( "max_width: %u\n", max_width );
    
    getch ();
};
