#include <stdio.h>
#include <search.h>
#include <malloc.h>

#define MAXV 100000
#define MAXE 10000

typedef struct vex vex;
struct vex{
  int e1;
  int e2;
  int val;
};

typedef struct spi spi;
struct spi{
  int e;
  spi *next;
};


int bo;
//int b[MAXE][MAXE];
spi b[MAXE];
int pos[MAXE];
int n, m;
vex a[MAXE];

void dfs(int e) {
  int i;
  spi *t;
  t=(spi *)malloc(sizeof(spi));
  pos[e] = 1;
  if(e == n-1) bo = 1;
  else {
    *t = b[e];
    while(t->next != NULL) {
      t = t->next;
      if(!pos[t->e])
	dfs(t->e);
    }
  }
}

int cmp(const void *e1, const void *e2) {
  return ((vex *)e2)->val - ((vex *)e1)->val;
}



int main() {
  int i, j, k, x, y, z;
  int tr[MAXV];
  int kx, ky;
  spi *t;
  spi *p;

//  freopen("c.in", "r", stdin);

  scanf("%d%d", &n, &m);
  for(i=0; i<n; i++) {
    tr[i] = i;
    b[i].e = 0;
    b[i].next = NULL;
  }

  for(i=0; i<m; i++) {
    scanf("%d%d%d", &x, &y, &z);
    x--;
    y--;
    t = (spi *)malloc(sizeof(spi));
    t->e = y;
    t->next = b[x].next;
    b[x].next = t;
    b[x].e++;
    t = (spi *)malloc(sizeof(spi));
    t->e = x;
    t->next = b[y].next;
    b[y].next = t;
    b[y].e++;
    a[i].e1 = x;
    a[i].e2 = y;
    a[i].val = z;
  }

  qsort(a, m, sizeof(a[0]), cmp);

  bo = 0;
  dfs(0);
//  bo = 1;

  if(bo) {

    for(i=0; i<m; i++) {
      x = a[i].e1;
      y = a[i].e2;
      while(tr[x]!=x) x = tr[x];
      kx = x;
      while(tr[y]!=y) y = tr[y];
      ky = y;
      if(kx!=ky) {
	if(kx == 0 || kx == n-1) {
	  if(ky == 0 || ky == n-1) {
	    printf("%d", a[i].val);
	    return 0;
	  }
	  else tr[ky] = kx;
	}
	else if(ky == 0 || ky == n-1) {
	  if(kx == 0 || kx == n-1) {
	    printf("%d", a[i].val);
	    return 0;
	  }
	  else tr[kx] = ky;
	}
	else tr[kx] = ky;
      }
    }
  }
  else printf("0");
  return 0;
}