//Boris Nikolaev Daskalov 11a SMG
#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

#define MAX(a,b) ((a)<(b)?(b):(a))
#define MIN(a,b) ((a)>(b)?(b):(a))

typedef struct _edge Edge;

struct _edge
{
 int end;
 int width;
 Edge* next;
};

Edge* verts[10001];
int best[10001];
int n,m;

void add_edge(int a,int b,int w)
{
 Edge* p=malloc(sizeof(Edge));
 p->end=b;
 p->width=w;
 p->next=verts[a];
 verts[a]=p;

 p=malloc(sizeof(Edge));
 p->end=a;
 p->width=w;
 p->next=verts[b];
 verts[b]=p;
}

int get_best()
{
 int res=0,i;
 for(i=1;i<=n;i++)
    if(best[res]<best[i])
        res=i;
 return res;
}

void d()
{
 int cur=1;
 Edge* p;
 do
 {
        for(p=verts[cur];p!=NULL;p=p->next)
            if(best[p->end]>=0)
               best[p->end]=MAX(best[p->end],MIN(best[cur],p->width));
        best[cur] = -best[cur];
        cur=get_best();
 } while(best[cur]>0);
}

int main()
{
 int i,a,b,w;
 ///Comment before submission////////////
// freopen(stdin,"fast.in","r");
 scanf("%i %i",&n,&m);
 for(i=0;i<m;i++)
 {
        scanf("%i %i %i",&a,&b,&w);
        add_edge(a,b,w);
 }
 best[0]=0;
 best[1]=INT_MAX;
 d();
 printf("%d",-best[n]);
 return 0;
}











