//Boris Nikolaev Daskalov 11a SMG

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

typedef struct
{
 int x,y,k;
} Point;

int n;
Point arr[2048];
int idx[2048];
double phi[2048];
int point_cmp(const Point* a,const Point* b)
{
  return  -((a->x - arr[0].x)*(b->y - arr[0].y) -
            (b->x - arr[0].x)*(a->y - arr[0].y));
}

int idx_cmp(const int *a,const int* b)
{
 if((phi[*a] - phi[*b]) < .0000000000001)
            return *a - *b;
 else
     return phi[*a] > phi[*b] ? -1 : 1;
}

inline double s(Point a,Point b)
{
 return a.x*b.x + a.y*b.y;
}

inline double m(Point a)
{
 return sqrt(a.x*a.x + a.y*a.y);
}

int main()
{
 int i;
 scanf("%i",&n);
 for(i=0;i<=n;i++)
 {
    scanf("%i %i",&arr[i].x,&arr[i].y);
    arr[i].k=i;
    arr[i].x-=arr[0].x;
    arr[i].y-=arr[0].y;
 }
 qsort(arr+1,n,sizeof(Point),(int (*)(const void*,const void*))point_cmp);
 for(i=1;i<=n;i++)
 {
    idx[i]=i;
    phi[i]=s(arr[i],arr[i+1])/(m(arr[i])*m(arr[i+1]));
 }
 qsort(idx+1,n-1,sizeof(int),(int (*)(const void*,const void*))idx_cmp);
 for(i=1;i<n;i++)
    printf("%d %d\n",arr[idx[i]].k,arr[idx[i]+1].k);
 return 0;
}
