#include <stdio.h>
#include <stdlib.h>
#define MAX (10100)
#define INF (1 << 29)

int min (int a, int b)  {
  return a <= b ? a : b;
}

int h[MAX], hi;
int d[MAX];
int ix[MAX];
void hu (int e);
void hd (int e);
void hr (int e);
void hb ();
int hc ();

typedef struct vex vex;
typedef struct edg edg;

struct vex  {
  int d;
  edg *e;
};

struct edg  {
  int l;
  vex *v;
};

vex vx[MAX];
int vn, en;
int tx, ty;
int ans;

void add (int d1, int d2, int l)  {
  vex *t;

  t = &vx[d1];

  while (t -> e != NULL)  {
        if (t -> e -> v -> d == d2) return;
        t = t -> e -> v;
  }

  t -> e = (edg*) malloc (sizeof(edg*));
  t -> e -> l = l;
  t -> e -> v = (vex*) malloc (sizeof(vex*));
  t -> e -> v -> d = d2;
  t -> e -> v -> e = NULL;
}

void init ()  {
  int i, x, y, z;

//freopen ("fast.in" , "r", stdin );
//freopen ("fast.out", "w", stdout);

  scanf ("%d%d", &vn, &en);

  hi = vn;

  for (i = 1; i <= en; ++i)  {
    scanf ("%d%d%d", &x, &y, &z);
    add (x, y, z);
    add (y, x, z);
  }

  for (i = 1; i <= vn; ++i)  {
    ix[i] = i;
    h[i] = i;
  }

  d[1] = INF;

  hb ();
}

void think ()  {
  int i, e, p;
  vex *t;

  tx = 1;
  ty = vn;

  for (i = 1; i <= vn; ++i)  {
    e = h[1];

    if (e == ty)
      return;

    h[1] = h[hi];
    ix[h[hi]] = 1;
    hi--;
    hd (1);

    t = &vx[e];

    while (t -> e != NULL)  {
      if (d[t -> e -> v -> d] < (p = min (d[e], t -> e -> l)))  {
        d[t -> e -> v -> d] = p;
        hr (ix[t -> e -> v ->d]);
      }
      t = t -> e ->v;
    }
  }
}

void print ()  {
  int i;
  vex *t;

/*
  for (i = 1; i <= vn; ++i)  {
    printf ("%d", i);

    t = &vx[i];

    while (t -> e != NULL)  {
      printf (" %d", t -> e -> v -> d);
      t = t -> e -> v;
    }

    printf ("\n");
  }
*/

  ans = d[vn];

  printf ("%d\n", ans);
}

int main ()  {
  init ();
  think ();
  print ();

  return 0;
}

void hu (int e)  {
  int i, ti, te;

  ti = ix[e];
  te = h[e];
  i = e;

  for (;;)  {
    if (i == 1) break;
    if (d[h[i / 2]] >= d[te]) break;
    ix[h[i / 2]] = i;
    h[i] = h[i / 2];
    i = i / 2;
  }

  h[i] = te;
  ix[te] = i;
}

void hd (int e)  {
  int i, ti, te, m;

  ti = ix[e];
  te = h[e];
  i = e;

  for (;;)  {
    if (2 * i > hi) break;
    m = 2 * i;
    if (2 * i + 1 <= hi && d[h[2 * i + 1]] > d[h[m]]) ++m;
    if (d[h[m]] <= d[te]) break;
    ix[h[m]] = i;
    h[i] = h[m];
    i = m;
  }

  h[i] = te;
  ix[te] = i;
}

void hr (int e)  {
  if (e != 1 && d[h[e]] > d[h[e / 2]])
    hu (e);
  else
    hd (e);
}

void hb ()  {
  int i;

  for (i = hi / 2; 1 <= i; --i)
    hd (i);
}

int hc ()  {
  int i;

  for (i = 2; i <= hi; ++i)
    if (d[h[i]] > d[h[i / 2]] || ix[h[i]] != i)
      return 0;

  return 1;
}

