#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#define N 2002

#define ORFACE(m11,m12,m21,m22) ((m11)*(m22)-(m12)*(m21))
#define ORFACE2(x1,x2,x3,y1,y2,y3) ORFACE((x2)-(x1),(x3)-(x1),(y2)-(y1),(y3)-(y1))
#define ORFACE3(p1,p2,p3) ORFACE(p2.x-p1.x,p3.x-p1.x,p2.y-p1.y,p3.y-p1.y)

struct SPoint
{
  int x,y;
};

struct SAngle
{
  int p1,p2;
  float ang;
};

int n;
SPoint mas[N];
int ptr[N];
SPoint null;
SAngle angles[2*N];
int angn;

void readf(istream &in)
{
  int i;
  in>>n;
  in>>null.x>>null.y;
  for(i=0; i<n; i++)
  {
    in>>mas[i].x>>mas[i].y;
    ptr[i]=i;
  }
}

int sortf(const void *a, const void *b)
{
  int *p1, *p2, res;
  p1=(int*)a;
  p2=(int*)b;
  //cout<<*p1<<' '<<*p2<<endl;
  res=ORFACE3(mas[*p1],null,mas[*p2]);
  if(res) return res;
  return *p1 - *p2;
}

void writef()
{
  int i;
  for(i=0; i<angn; i++)
  {
    cout<<1+angles[i].p1<<' '<<1+angles[i].p2<<endl;
  }
}

/*void solve()
{
  int i;
  for(i=0; i<
} */

SAngle findAngle(SAngle an)
{
  float a,b,c;
  a=(mas[an.p1].x-null.x)*(mas[an.p1].x-null.x)+(mas[an.p1].y-null.y)*(mas[an.p1].y-null.y);
  b=(mas[an.p2].x-null.x)*(mas[an.p2].x-null.x)+(mas[an.p2].y-null.y)*(mas[an.p2].y-null.y);
  c=(mas[an.p1].x-mas[an.p2].x)*(mas[an.p1].x-mas[an.p2].x)+(mas[an.p1].y-mas[an.p2].y)*(mas[an.p1].y-mas[an.p2].y);
  an.ang=acos((a+b-c)/(2*sqrt(a*b)));
  return an;
}

void makeAng()
{
  int i,j,k,l;
  SAngle angl;
  for(i=0; i<n-1; i++)
  {
    for(j= i+1; j<n; j++)
    {
      if(ORFACE3(mas[ptr[i]],null,mas[ptr[j]]))
      {
	if(ptr[i]>ptr[j])
	{
	  l=ptr[j];k=ptr[i];
	}
	else
	{
	  l=ptr[i];k=ptr[j];
	}
	angles[angn].p1=l;
	angles[angn].p2=k;
	angles[angn]=findAngle(angles[angn]);
	angn++;
	break;
      }
    }
    j++;
    for(; j<n; j++)
    {
      if(ORFACE3(mas[ptr[i]],null,mas[ptr[j]]))
      {
	if(ptr[i]>ptr[j])
	{
	  l=ptr[j];k=ptr[i];
	}
	else
	{
	  l=ptr[i];k=ptr[j];
	}
	angl.p1=l;
	angl.p2=k;
	angl=findAngle(angl);
	if(angl.ang>angles[angn-1].ang)break;
	angles[angn++]=angl;
      }
    }
  }
  if(ORFACE3(mas[ptr[0]],null,mas[ptr[n-1]])>0)
  {
      if(ORFACE3(mas[ptr[i]],null,mas[ptr[j]]))
      {
	if(ptr[0]>ptr[n-1])
	{
	  l=ptr[0];k=ptr[n-1];
	}
	else
	{
	  l=ptr[0];k=ptr[n-1];
	}
	angles[angn].p1=l;
	angles[angn].p2=k;
	angles[angn]=findAngle(angles[angn]);
	angn++;
      }
  }
}

int comp(const void*a, const void*b)
{
  SAngle *an1, *an2;
  an1=(SAngle*)a;
  an2=(SAngle*)b;
  if(an1->ang-an2->ang)return an2->ang-an1->ang;
  if(an1->p1-an2->p1)return an1->p1-an2->p1;
  return an1->p2-an2->p2;
}

int main()
{
  readf(cin);
  qsort(ptr,n,sizeof(int),sortf);
  makeAng();
  qsort(angles,angn,sizeof(SAngle),comp);
  writef();
  return 0;
}