#include <stdio.h>
#include <stdlib.h>

#define mmin(a, b) (a) < (b) ? (a) : (b)

typedef struct {
  unsigned short a, b, w;
} road;

char used[10000];
unsigned short res = 65001, tmp, N;
long M, c, i, l, r, m;
road roads[200000];

int cmp(const void *a, const void *b)
{
  if(((road *)a)->a < ((road *)b)->a)
    return -1;
  else
    if(((road *)a)->a > ((road *)b)->a)
      return 1;
    else
      if(((road *)a)->w < ((road *)b)->w)
        return 1;
      else
        if(((road *)a)->w > ((road *)b)->w)
          return -1;
  return 0;
}

long find(short a)
{
  l = 0;
  r = M*2-1;
  while(l <= r)
  {
    m = (l + r) / 2;
    if(a < roads[m].a)
      r = m-1;
    else
     if(a > roads[m].a)
       l = m+1;
     else
     {
       while(roads[m].a == a)
         m--;
       return m+1;
     }
  }
  return -1;
}

unsigned short track(short pos)
{
  long way;
  unsigned short best = 0;
  if(pos == N)
    return 65001;
  if((way = find(pos)) == -1)
    return 0;
  while(best <= roads[way].w)
  {
    while(used[roads[way].b])
      way++;
    if(roads[way].a == pos)
    {
       used[roads[way].b] = 1;
       tmp = track(roads[way].b);
       tmp = mmin(tmp, roads[way].w);
       if(tmp > best)
         best = tmp;
       used[roads[way].b] = 0;
       way++;
    }
    else
      break;
  }
  return best;
}

int main(void)
{
  scanf("%hu %ld", &N, &M);
  for(c = 0, i = 0; c < M; c++)
  {
    scanf("%hu %hu %hu", &roads[i].a, &roads[i].b, &roads[i].w);
    roads[i + 1].b = roads[i].a;
    roads[i + 1].a = roads[i].b;
    roads[++i].w = roads[i-1].w;
    i++;
  }
  qsort(roads, M * 2, sizeof(road), cmp);
  for(tmp = 0; tmp < N; tmp++)
    used[tmp] = 0;
  used[1] = 1;
  printf("%hu\n", track(1));
  return 0;
}
