  #include <stdio.h>
  #define MAXN 10000
  #define MAXM 100000

  struct edge
  {
   long i,j,w;
  };

  edge a[MAXM];
  long n,m;

  void qsort(long l, long r)
  {
   long i=l,j=r,k=a[(l+r)/2].w;
   while(i<j)
   {
    while(a[i].w>k) i++;
    while(a[j].w<k) j--;
    if(i<=j)
    {
     long x=a[i].w;
     a[i].w=a[j].w;
     a[j].w=x;
     x=a[i].i;
     a[i].i=a[j].i;
     a[j].i=x;
     x=a[i].j;
     a[i].j=a[j].j;
     a[j].j=x;
     i++;
     j--;
    }
   }
   if(l<j) qsort(l,j);
   if(i<r) qsort(i,r);
  }

  int kruskal()
  {
   long i,j,ai,aj,n1=n-1;
   long root[MAXN];
   for(i=0;i<n;i++) root[i]=i;
   for(i=0;i<n1;i++)
   {
    ai=a[i].i;
    aj=a[i].j;
    if(root[ai]!=root[aj])
    {
     int nr=root[ai]<root[aj] ? root[ai]:root[aj];
     int oldr=root[ai]>root[aj] ? root[ai]:root[aj];
     for(j=0;j<n;j++) if(root[j]==oldr) root[j]=nr;
     if(root[n1]==0)
     {
       printf("%ld\n",a[i].w);
       return 1;
     }
    }
   }
   printf("0\n");
   return 0;
  }

  int main()
  {
   long i,j,w,b;
   scanf("%ld%ld",&n,&m);
   for(b=0;b<m;b++)
   {
    scanf("%ld%ld%ld",&i,&j,&a[b].w);
    a[b].i=--i;
    a[b].j=--j;
   }
   qsort(0,m-1);
   kruskal();
   return 0;
  }
