#include <iostream.h>
#include <math.h>

class Rays
{
	int N;
	int outputted;
	int a[2000][2];
	int angles[2000][2];
//	int final[2000][2];
	float anglecos[2000];
	float cosinus(int xn, int yn, int xi, int yi, int xj, int yj);
	void sort(int smallest);
	public:
		void input();
		void eval();
};

void Rays::input()
{
   int i;

   cin >> N;
   for(i=0;i<(N+1);i++)
   {
		cin >> a[i][0] >> a[i][1];
   }
}

float Rays::cosinus(int xn, int yn, int xi, int yi, int xj, int yj)
{
	float a,b,c;
	float cosinusa;

	a = sqrt((xi-xn)*(xi-xn) + (yi - yn)*(yi - yn));
	b = sqrt((xj-xn)*(xj-xn) + (yj - yn)*(yj - yn));
	c = sqrt((xi-xj)*(xi-xj) + (yi - yj)*(yi - yj));

	cosinusa = (a*a + b*b - c*c)/(2*a*b);

	return cosinusa;
}

void Rays::eval()
{
	int i;

	for(i=0;i<(N+1);i++)
	{
		angles[i][0] = i+1;
		angles[i][1] = i+2;
		anglecos[i] = cosinus(a[0][0], a[0][1], a[i+1][0], a[i+1][1], a[i+2][0], a[i+2][1]);
	}

	outputted = 0;
	sort(1);
}

void Rays::sort(int smallest)
{
	int i;
	int smallest_i;

	for(i=0;i<(N+1);i++)
	{
		if(anglecos[i] < smallest)
		{
			smallest = anglecos[i];
			smallest_i = i;
		}
	}

	cout << angles[smallest_i][0] << " " << angles[smallest_i][1] << "\n";
	outputted++;

	if(outputted < N)
		sort(smallest);
}

/*

void Rays::output()
{
	int i;

	for(i=0;i<(N+1);i++)
	{
		cout << final[i][0] << " " << final[i][1] << "\n";
	}
}
*/

int main()
{
	Rays obj;

	obj.input();
	obj.eval();

   return 0;
}