/*
	Alexander Yordanov Simeonov
	Greda Group International
*/

#include <stdio.h>
#include <math.h>

#define MAX 2004
#define MAX_ANGLES 2004

typedef struct point {
	int x, y;
} point;

typedef struct ray {
	int id;
    double deg;
} ray;

typedef struct angle {
    int i;
    int j;
    double deg;
} angle;

point points[MAX];
ray   rays[MAX];
angle angles[MAX_ANGLES];

int n, angles_count;

int bahur(const void *x, const void *y) {
	if ( ((ray *)x)->deg - ((ray *)y)->deg > 0 ) {
    	return 1;
    } else {
    	return -1;
    }
}

int bahur_2(const void *x, const void *y) {
	if (((angle *)x)->deg != ((angle *)y)->deg) {
        if (((angle *)x)->deg - ((angle *)y)->deg > 0) {
        	return 1;
        } else {
        	return -1;
        }
    } else {
        if ( ((angle *)x)->i - ((angle *)y)->i != 0) {
           return ((angle *)x)->i - ((angle *)y)->i;
        } else {
          return ((angle *)x)->j - ((angle *)y)->j;
        }
    }
}

double atan_deg(double x, double y) {
	double r =atan2(y, x) * 180 / M_PI;

    if (r<0) {
    	return (r + 360);
    } else {
	    return r;
    }
}

void put_in() {
	int i;

	scanf("%d", &n);
    scanf("%d %d", &points[0].x, &points[0].y);

    for (i=1; i<=n; i++) {
     	scanf("%d %d", &points[i].x, &points[i].y);

        points[i].x -= points[0].x;
        points[i].y -= points[0].y;

        rays[i-1].deg = atan_deg(points[i].x, points[i].y);
        rays[i-1].id  = i;
    }
}

void fuck() {
	int i, c, last;
    double deg;

	qsort(&rays[0], n, sizeof(ray), bahur);

//	rays[0].id  = rays[n].id;
//    rays[0].deg = rays[n].deg;

//	rays[n+1].id  = rays[0].id;
//    rays[n+1].deg = rays[0].deg;

    angles_count = 0;

    for (i=0; i<n; i++) {

    	last = -1;

        c = 1;
        while (rays[i].deg - rays[(i-c+n) % n].deg == 0) {
        	c++;
        }

        c = (i-c+n) % n;

    	deg = fabs(rays[i].deg - rays[c].deg);

		if (rays[c].id > rays[i].id && deg < 180) {

            angles[angles_count].i   = rays[i].id;
            angles[angles_count].j   = rays[c].id;
            angles[angles_count].deg = fabs(rays[i].deg - rays[c].deg);
         	angles_count++;

            last = c;
        }

        c = 1;
        while (rays[i].deg - rays[(i+c) % n].deg == 0) {
        	c++;
        }

        c = (i+c) % n;

        if (c == last) continue;

    	deg = fabs(rays[i].deg - rays[c].deg);

        if (rays[c].id > rays[i].id && deg < 180) {

            angles[angles_count].i   = rays[i].id;
            angles[angles_count].j   = rays[c].id;
            angles[angles_count].deg = fabs(rays[i].deg - rays[c].deg);
         	angles_count++;

        }
    }

    qsort(&angles[0], angles_count, sizeof(angle), bahur_2);
}

void put_out() {
	int i;

    for (i=0; i<angles_count; i++) {
        printf("%d %d\n", angles[i].i, angles[i].j);
    }
}

int main() {
	put_in();
	fuck();
	put_out();

	return 0;
}
