#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MAXN            2010

typedef struct s1
{
  double x,y;

} tpoint;

typedef struct s2
{
  double val;
  int ind;
  int ind2;

} tangle;


int n;
tpoint points[MAXN];
tangle angles[MAXN];
double dist[MAXN];
double dist2[MAXN];
tangle ans[2*MAXN];
int brans;

void input()
{
  int i;

  scanf("%d",&n);

  for(i=0;i<=n;i++)
  {
    scanf("%lf %lf",&points[i].x,&points[i].y);
  }
}

double Dist(double x1, double y1, double x2, double y2)
{
  double r1,r2;
  double res;

  r1 = fabs(x1-x2);
  r2 = fabs(y1-y2);

  res = sqrt(r1*r1 + r2*r2);

  return (res);
}

double Dist2(double x1, double y1, double x2, double y2)
{
  double r1,r2;
  double res;

  r1 = fabs(x1-x2);
  r2 = fabs(y1-y2);

  res = r1*r1 + r2*r2;

  return (res);
}


int cmp(const void *e2, const void *e1)
{

  if( ((tangle*)e1)->val > ((tangle*)e2)->val )
    return 1;
  else
    return -1;
}

int cmp2(const void *e1, const void *e2)
{

  if( ((tangle*)e1)->val > ((tangle*)e2)->val )
    return 1;
  else
    if( ((tangle*)e1)->val < ((tangle*)e2)->val )
      return -1;


  if( ((tangle*)e1)->ind > ((tangle*)e2)->ind )
    return 1;
  else
    if( ((tangle*)e1)->ind < ((tangle*)e2)->ind )
      return -1;


  if( ((tangle*)e1)->ind2 > ((tangle*)e2)->ind2 )
    return 1;
  else
    if( ((tangle*)e1)->ind2 < ((tangle*)e2)->ind2 )
      return -1;


}


void solve()
{
  int i;
  double px,py;
  double ang;
  double s1;
  int k1,k2;
  int buf;
  double buf2;

  px = points[0].x;
  py = points[0].y;

  points[0].x = 0;
  points[0].y = 0;

  for(i=1;i<=n;i++)
  {
    points[i].x -= px;
    points[i].y -= py;
  }

  angles[0].val = 2.0;
  angles[0].ind = 0;

  for(i=1;i<=n;i++)
  {
    angles[i].val = (points[i].x)/Dist(0.0,0.0,points[i].x,points[i].y);
    if(points[i].y<0)
    {
      angles[i].val *= (-1);
      angles[i].val -= 2.0;
    }
    angles[i].ind = i;
  }

  qsort(angles,n+1,sizeof(tangle),cmp);

  for(i=1;i<=n;i++)
  {
    dist[i] = Dist(0.0,0.0,points[i].x,points[i].y);
    dist2[i] = Dist2(0.0,0.0,points[i].x,points[i].y);
  }

  brans = 0;

  for(i=1;i<n;i++)
  {
    if((angles[i].val-angles[i+1].val)>=2.0)   // ako agala e nad 180 gr.
      continue;

    if(angles[i].val==angles[i+1].val)         // ako agala e 0 gr.
      continue;

    k1 = angles[i].ind;
    k2 = angles[i+1].ind;

    if(k1>k2)
    {
      buf = k1;
      k1 = k2;
      k2 = buf;
    }

    s1 = Dist2(points[k1].x,points[k1].y,points[k2].x,points[k2].y);
    ang = dist2[k1] + dist2[k2] - s1;

    ang /= (2*dist[k1]*dist[k2]);

//    if((angles[i].val-angles[i+1].val)<2.0)   // ako agala e pod 180 gr.
//    {
      ans[brans].ind = k1;
      ans[brans].ind2 = k2;
      ans[brans].val = -ang;
      brans++;
//    }
  }

  buf2 = (angles[1].val-angles[n].val);

  if(buf2>2.0)
  {
    k1 = angles[1].ind;
    k2 = angles[n].ind;

    if(k1>k2)
    {
      buf = k1;
      k1 = k2;
      k2 = buf;
    }

    s1 = Dist2(points[k1].x,points[k1].y,points[k2].x,points[k2].y);
    ang = dist2[k1] + dist2[k2] - s1;

    ang /= (2*dist[k1]*dist[k2]);

    ans[brans].ind = k1;
    ans[brans].ind2 = k2;
    ans[brans].val = -ang;

    brans++;
  }

  qsort(ans,brans,sizeof(tangle),cmp2);

}

void output()
{
  int i;

  for(i=0;i<brans;i++)
    printf("%d %d\n",ans[i].ind,ans[i].ind2);

}

int main()
{
//  printf("Reading from file...\n");
//  freopen("raystest.inp","r",stdin);

  input();
  solve();
  output();

  return 0;
}

