#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define IN  "fast.in"
#define MAX_N 10010
#define MAX_VAL 10000000

struct TStack{
 int node;
 int dist;
 struct TStack *next;
};

struct TStack *mas[MAX_N];
int used[MAX_N];
int flow[MAX_N];

int n,m;


void add(struct TStack **stack, int node, int dd);
int  min(int aa, int bb);
void solve();

int main(void){
 int a,b,d;
 int i;

 memset(used,0,sizeof(used));
 memset(flow,0,sizeof(flow));

 //freopen(IN,"r",stdin);
 scanf("%d %d", &n, &m);
 for(i=0; i<=n; i++) mas[i]=NULL;

 for(i=0; i<m; i++){
  scanf("%d %d %d", &a, &b, &d);
  add(&mas[a], b, d);
  add(&mas[b], a, d);
 }

 solve();

 printf("%d\n", flow[n]);
 return 0;
}

void add(struct TStack **stack, int node, int dd){
 struct TStack *tmp;

 tmp=(struct TStack *)malloc(sizeof(struct TStack));
 tmp->node=node;
 tmp->dist=dd;
 tmp->next=*stack;
 *stack=tmp;
}

void solve(){
 int i;
 int maxind,maxval;
 struct TStack *tmp;

 flow[1]=MAX_VAL;

 while(1){

  maxind=-1; maxval=-1;
  for(i=1; i<=n; i++){
   if(!used[i]&&flow[i]>maxval) {maxval=flow[i]; maxind=i;}
  }

  if(maxind==-1) return;
  used[maxind]=1;

  tmp=mas[maxind];
  used[maxind]=1;
  if(maxind==n) return ;

  while(tmp!=NULL){
   if(flow[tmp->node]<min(tmp->dist,flow[maxind])){
    flow[tmp->node]=min(tmp->dist,flow[maxind]);
   }
   tmp=tmp->next;
  }

 }

}

int min(int aa, int bb){
 return (aa<bb) ? aa:bb;
}

