/*
PROG : perm
NAME : vladimir nedev
*/

#include <stdio.h>

#define MAX     20

long n, k;
long long res[MAX][MAX][MAX];

long long recurse(long n, long left, long last)
{
   long i;

   if(n==0)
     if(left==0)
       return 1;
     else
       return 0;

   if(res[n][left][last])
     return res[n][left][last]-1;

   for(i=1; i<=n; i++)
      if(i<last)
      {
        res[n][left][last]+=recurse(n-1, left, i);
      }
      else
      {
        res[n][left][last]+=recurse(n-1, left-1, i);
      }

   res[n][left][last]++;

   return res[n][left][last]-1;
}

int main()
{
   scanf("%ld%ld", &n, &k);
   printf("%lld\n", recurse(n, k, n+1));

   return 0;
}

