#include <stdio.h>
#include <string.h>

#define MAXN 20

long long T[MAXN][MAXN];
long long C[MAXN][MAXN];
int n,k;

void Init()
  {
    memset(T,0,sizeof(T));
    scanf("%d%d",&n,&k);
  }

void Pre()
  {
    int i,j;
    memset(C,0,sizeof(C));
    C[1][1] = C[1][0] = 1;
    for (i = 2;i <= n;i++)
      {
        C[i][0] = C[i][i] = 1;
        for (j = 1;j < i;j++)
          C[i][j] = C[i - 1][j] + C[i - 1][j - 1];
      }
  }

void Solve()
  {
    int i,j,l,m;
    for (i = 1;i <= n;i++) T[i][0] = T[i][i - 1] = 1;
    for (i = 2;i <= n;i++)
      for (j = 1;j < i - 1;j++)
        {
          T[i][j] += T[i - 1][j] + T[i - 1][j - 1];
          for (l = 1;l < i - 1;l++)
            for (m = 0;m <= j - 1;m++)
              T[i][j] += C[i - 1][l]*T[l][m]*T[i - 1 - l][j - 1 - m];
        }

  }

void Output()
  {
    printf("%lld\n",T[n][k]);
  }

int main()
  {
    Init();
    Pre();
    Solve();
    Output();
    return 0;
  }
