const
     nm_max              = 10000;
     w_max               = 70000;

type
    integer              = longint;

var
   a_ot, a_do, a_dal                   : array[1..nm_max] of integer;
   res                                 : array[1..nm_max] of integer;
   wth                                 : array[1..nm_max] of boolean;

   M,N,i,j                             : integer;

procedure pr_exchange(var a,b : integer);
          var
             buf        : integer;
          begin
               buf:=a;
               a:=b;
               b:=buf;
          end;

procedure pr_sort;

          procedure qsort(l,r : integer);
                    var
                       i, j, x, y               : integer;
                       b_ot, b_do, b_dal        : integer;
                    begin
                         i:=l; j:=r; x:=a_ot[(l+r) DIV 2];
                         repeat
                               while a_ot[i]<x do
                                     i:=i+1;
                               while x<a_ot[j] do
                                     j:=j-1;
                               if i<=j then
                                  begin
                                       b_ot:=a_ot[i];
                                       a_ot[i]:=a_ot[j];
                                       a_ot[j]:=b_ot;

                                       b_do:=a_do[i];
                                       a_do[i]:=a_do[j];
                                       a_do[j]:=b_do;

                                       b_dal:=a_dal[i];
                                       a_dal[i]:=a_dal[j];
                                       a_dal[j]:=b_dal;


                                       i:=i+1; j:=j-1;
                                  end;
                         until i>j;
                         if l<j then
                            qsort(l,j);
                         if i<r then
                            qsort(i,r);
                    end;

          begin
               qsort(1,M);
          end;

procedure read_inp;
          var
             i                          : integer;
          begin
               readln(N,M);
               for i := 1 to M do
                   begin
                        readln(a_ot[i], a_do[i], a_dal[i]);
                        if a_ot[i]>a_do[i] then
                           pr_exchange(a_ot[i],a_do[i]);
                   end;
               pr_sort;
          end;

function pr_min(a,b     : integer) : integer;
         begin
               if a < b then
                  pr_min:=a
               else
                   pr_min:=b;
         end;

function pr_max(a,b     : integer) : integer;
         begin
              if a > b then
                 pr_max:=a
              else
                  pr_max:=b;
         end;

procedure do_prob;
          begin
               res[1]:=w_max;
               wth[1]:=true;
               for i := 1 to M do
                   begin
                        if wth[a_ot[i]] then
                           begin
                                if not wth[a_do[i]] then
                                   begin
                                        res[a_do[i]]:=pr_min(res[a_ot[i]], a_dal[i]);
                                        wth[a_do[i]]:=true;
                                   end
                                else
                                    res[a_do[i]]:=pr_max( pr_min(res[a_ot[i]], a_dal[i]), res[a_do[i]]);

                           end;



                   end;

          end;

procedure write_outp;
          begin
                writeln(res[N]);
          end;


begin
     read_inp;
     do_prob;
     write_outp;

end.