#include <stdio.h>
#define MAXN 1000
#define INFINITY 10
unsigned a[MAXN][MAXN];
unsigned N,M;
unsigned max = 0;

int floyd(){
	unsigned k,i,j;
	for(k=0;k<N;k++)
		for(i=0;i<N;i++)
			for(j=0;j<N;j++)
				if(a[i][j] > a[i][k] + a[k][j])
					a[i][j] = a[i][k] + a[k][j];

	for(k=0;k<N;k++)
		a[k][k] = INFINITY;

	return 0;
}

int main(){
	scanf("%d %d",&N,&M);
	for(unsigned x=0;x<N;x++)
		for(unsigned y=0;y<N;y++)
			a[x][y] = INFINITY;

	unsigned m,n;

	for(unsigned k=0;k<M;k++){
		scanf("%u %u",&m,&n);
		a[m-1][n-1] = 1;
		a[n-1][m-1] = 1;
	}

	floyd();

	for(m=0;m<N;m++){
		for(n=0;n<N;n++)
			printf("%3d ",a[m][n]);
		printf("\n");
	}

	for(m=0;m<N;m++)
		for(n=0;n<N;n++)
			if((a[m][n] < INFINITY) && (a[m][n] > max))
				max = a[m][n];

	printf("%u\n",--max);

	return 0;
}