#include <stdio.h>
#define MAXN 100000
#define good 0
#define bad 1

char a[MAXN + 1];
char stack[MAXN + 1];
unsigned N,M;
unsigned st = 0;
unsigned mst = 0;
unsigned minlen = (unsigned)(-1);
unsigned minpath[MAXN + 1];


int walk(unsigned start,unsigned length){
	if(start >= N+1) {
		if(minlen > length){
			minlen = length;

			for(unsigned i=1;i<=st;i++)
				minpath[i] = stack[i];
			mst = st;
		}
		return 0;
	}

	stack[st++] = start;

	
	if(a[start] == good && a[start+4] == good)
		walk(start+4,length+1);

	if(a[start] == good && a[start+3] == good)
		walk(start+3,length+1);

	if(a[start] == good && a[start+2] == good)
		walk(start+2,length+1);

	walk(start+1,length+1);


	st--;

	return 0;
}

int main(){
	unsigned u,de;
	scanf("%d %d",&N,&M);
	for(u=0;u<=N;u++)
		a[u] = good;

	for(u=1;u<=M;u++){
		scanf("%d",&de);
		a[de] = bad;
	}

	walk(0,0);

	printf("%d\n",--minlen);
	for(unsigned i=1;i<mst;i++)
		printf("%d\n",minpath[i]);

	return 0;
}