/*

Anton Viktorov Evangelatov
SMG
Sofia
B

*/

#include <iostream>

using namespace std;

long Changes [1000][1000];

int N;
long M;

void Input ()
{
  cin >> N >> M;

  for (int i=1; i<=N; i++)
  {
    for (int j=1; j<=N; j++)
    {
      Changes [i][j] = 9999999;
    }
  }

  int First, Second;

  for (int i=0; i<M; i++)
  {
    cin >> First >> Second;

    Changes [First][Second] = 1;
    Changes [Second][First] = 1;
  }
}

void shortPath ()
{
  for (int k=1; k<=N; k++)
  {
    for (int i=1; i<=N; i++)
    {
      for (int j=1; j<=N; j++)
      {
        if (i == j || i == k || k == j) continue;

        if (Changes [i][j] > (Changes [i][k] + Changes [k][j]))
        {
          Changes [i][j] = Changes [i][k] + Changes [k][j];
        }
      }
    }
  }
}

int Solve ()
{
  long nMax = 0;

  shortPath ();

  for (int i=1; i<=N; i++)
  {
    for (int j=1; j<=N; j++)
    {
      if (i == j) continue;

      if (nMax < Changes [i][j]) nMax = Changes [i][j];
    }
  }

  return nMax;
}


int main ()
{
  Input ();

  cout << Solve () - 1 << '\n';

  return 0;
}
