#include <stdio.h>
#include <alloc.h>

long n, m, *bridge, *path, *cpath;

long min, counter;

long i;

int walk(long step, long index);

int main()
{
	long t;

	scanf("%ld %ld", &n, &m);

	bridge = (long *)malloc(n*sizeof(long)+5);
	path   = (long *)malloc(n*sizeof(long)+5);
	cpath  = (long *)malloc(n*sizeof(long)+5);

	for(i=0; i<=n; i++)
		bridge[i] = 0;

	for(i=0; i<m; i++) {
		scanf("%ld", &t);
		bridge[t] = 1;
	}

	min = n;
	counter = 0;

	walk(0, 0);

	printf("%ld\n", min-1);
	for(i=1; i<min; i++)
		printf("%ld\n", path[i]);

	return 0;
}


int walk(long step, long index)
{
	if(step > n) {
		if(counter < min) {
			min = counter;
			for(i=0; i<min; i++)
				path[i] = cpath[i];
		}
		counter = index;
		return 0;
	}

	counter++;
	cpath[index] = step;

	if(bridge[step] == 1) walk(step+1, index+1);
	if(bridge[step+2] != 1) walk(step+2, index+1);
	if(bridge[step+3] != 1) walk(step+3, index+1);
	if(bridge[step+4] != 1) walk(step+4, index+1);
	walk(step+1, index+1);

	return 0;
}