program cups;

const
	MAXN					= 10;
	MAXSOL					= 1000000;

type
	Integer					= LongInt;
	TMove					= record
		a, b				: Integer;
	end;

var
	cup					: Array [1 .. MAXN] of Integer;
	N, K					: Integer;
	m					: Array [1 .. MAXSOL] of TMove;	
	sol					: LongInt;
	i					: Integer;

procedure readInput;
begin
	readln(N, K);
end;

procedure writeOutput;
begin

	writeln(sol);
	for i := 1 to sol do
		writeln(m[i].a, ' ', m[i].b);
end;

procedure Solve;
var
	i, j					: Integer;
begin
	cup[1] := K;
	for i := 2 to N do
		cup[i] := 0;
	sol := 0;
	if (K > 1) then begin
		for i := 1 to (N - 1) do begin
			while (cup[i] > 1) do begin
				cup[i] := cup[i] - 1;
				cup[N] := cup[N] + 1;
				j := N;
				sol := sol + 1;
				m[sol].a := i; m[sol].b := N;
					while (j > i + 1) do begin
						cup[j] := cup[j] - 1;
						cup[j - 1] := cup[j - 1] + 1;
						sol := sol + 1;
						m[sol].a := j; m[sol].b := j - 1;	
						j := j - 1;
					end;
			end;
			cup[i] := cup[i] - 1;
			cup[i + 1] := cup[i + 1] + 1;
			sol := sol + 1;
			m[sol].a := i;
			m[sol].b := i + 1;
		end;
		if (N > 2) then
			while (cup[N] > 2) do begin
				cup[N] := cup[N] - 1;
				cup[1] := cup[1] + 1;
				sol := sol + 1;
				m[sol].a := N;
				m[sol].b := 1;
			end;
	end else
		for i := 1 to (N - 1) do begin
			sol := sol + 1;
			m[sol].a := i;
			m[sol].b := i + 1;
		end;
end;

begin
	readInput;
	Solve;
	writeOutput;
end.