#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXN 100500

int n,m;
int *nasl[MAXN];
int *w[MAXN];
int *max_d[MAXN];

int nasl_br[MAXN];
int curr_w = 0;
int visited[MAXN];
int back_d[MAXN];
int parent[MAXN];
int max_t[MAXN]; // Total, global MAX!!
int max[MAXN];
int tmp;
int stack[MAXN][3];
int stack_sz = 0;

void Init()
  {
    int i;

//    freopen("path.in","rt",stdin);
    scanf("%d%d",&n,&m);
    for (i = 0;i < m;i++)
      {
        int a,b,c;
        scanf("%d %d %d",&a,&b,&c);
        a--;b--;
        nasl[a] = (int*)realloc(nasl[a],(nasl_br[a] + 1)*sizeof(int));
        nasl[a][nasl_br[a]] = b;

        nasl[b] = (int*)realloc(nasl[b],(nasl_br[b] + 1)*sizeof(int));
        nasl[b][nasl_br[b]] = a;

        w[a] = (int*)realloc(w[a],(nasl_br[a] + 1)*sizeof(int));
        w[a][nasl_br[a]] = c;

        w[b] = (int*)realloc(w[b],(nasl_br[b] + 1)*sizeof(int));
        w[b][nasl_br[b]] = c;

        max_d[b] = (int*)realloc(max_d[b],(nasl_br[b] + 1)*sizeof(int));
        max_d[b][nasl_br[b]] = -1;

        max_d[a] = (int*)realloc(max_d[a],(nasl_br[a] + 1)*sizeof(int));
        max_d[a][nasl_br[a]] = -1;

        nasl_br[a]++;
        nasl_br[b]++;
      }
  }

int DFS(int vr)
  {
    int i;

    stack[0][0] = 0;
    stack[0][1] = vr;
    stack[0][2] = 0;
    stack_sz = 1;

    while (stack_sz)
      {
        start :
        i = stack[stack_sz - 1][0];
        vr = stack[stack_sz - 1][1];
        curr_w = stack[stack_sz - 1][2];

        visited[vr] = 1;
        back_d[vr] = curr_w;
        for (;i < nasl_br[vr];i++)
          if (!visited[nasl[vr][i]])
            {
              curr_w += w[vr][i];
              parent[nasl[vr][i]] = vr;

              stack[stack_sz][0] = 0;
              stack[stack_sz][1] = nasl[vr][i];
              stack[stack_sz][2] = curr_w;
              stack_sz++;

              curr_w -= w[vr][i];

              goto start;
            }

        for (i = 0;i < nasl_br[vr];i++)
          if (nasl[vr][i] != parent[vr])
            {
              max_d[vr][i] = max[nasl[vr][i]] + w[vr][i];

              if (max_d[vr][i] > max[vr])
                max[vr] = max_d[vr][i];
            }

        stack_sz--;
      }
  }

void DFS2()
  {
    int i,j;
    int tmp;

    for (i = 0;i < n;i++)
      {
        max_t[i] = back_d[i];
        if (max_t[i] < max[i]) max_t[i] = max[i];

        if (parent[i] != -1)
          {
            for (j = 0;j < nasl_br[parent[i]];j++)
              if (nasl[parent[i]][j] == i)
                {
                  tmp = w[parent[i]][j];
                  break;
                }

            for (j = 0;j < nasl_br[parent[i]];j++)
              if (nasl[parent[i]][j] != i)
                {
                  if (max_t[i] < tmp + max_d[parent[i]][j])
                    max_t[i] = tmp + max_d[parent[i]][j];
                }
          }
      }
  }

void Solve()
  {
    int i;

    memset(visited,0,sizeof(visited));

    for (i = 0;i < n;i++)
      if (nasl_br[i] == 1)
        {
          parent[i] = -1;
          DFS(i);
          memset(visited,0,sizeof(visited));
          DFS2();
          break;
        }
  }

void Output()
  {
    int i;

    for (i = 0;i < n;i++)
      printf("%d\n",max_t[i]);
  }

int main()
  {
    Init();
    Solve();
    Output();
    return 0;
  }
