#include <stdio.h>
#include <stdlib.h>
#include <time.h>

int values[12][64];
int depend[12][10];
int size[12];
int used[64],X[64];
int n,m;
int best = 2000000000;

void output(int value) {
     printf("%d\n",value);
     exit(0);
}

void rec(int x) {
int i,j,res=0,sum=0;
     if (clock()/(float)CLOCKS_PER_SEC>=0.9) {
        output(best);
     }
     if (x==30) {
        for (i=1;i<=n;i++) {
            res = 0;
            for (j=1;j<=size[i];j++) {
                res+=(1<<(size[i]-j))*X[depend[i][j]];
            }
            sum+=values[i][res];
        }
        if (sum<best) {
           best = sum;
        }
        return;
     }
     if (!used[x]) {
        rec(x+1);
        return;
     }
     X[x] = 0;
     rec(x+1);
     X[x] = 1;
     rec(x+1);
}

int main () {
int i,j;
//    freopen ( "minval.in" , "r", stdin);
    scanf("%d%d",&n,&m);
    for (i=1;i<=n;i++) {
        scanf("%d",&size[i]);
        for (j=1;j<=size[i];j++) {
            scanf("%d",&depend[i][j]);
            used[depend[i][j]] = 1;
        }
        for (j=0;j<(1<<size[i]);j++) {
            scanf("%d",&values[i][j]);
        }
    }
    clock();
    rec(1);
    output(best);
    return 0;
}
