#include <stdio.h>

#define maxN 300
#define maxP 29
#define maxM 9
#define maxC 5

int P,N=0,M,C[maxM+1],Sp[maxM+1][maxC+1];
int Z[maxN+1][maxP+1],Value[maxN+1],A[maxN+1][maxN+1];
int Sit[maxP+1],Res=30000,Path[maxM+1];

void init();
void makevertex(int poz);
int nextvariation();
void makegraph();
void solve(int poz,int vertex,int Cur);

int main()
{
 init();
 makegraph();
 for (int bk=1;bk<=N;bk++) solve(1,bk,Value[bk]);
 printf("%d\n",Res);
 return 0;
}

void init()
{
 int i,j;
 scanf("%d%d",&M,&P);
 for (i=1;i<=M;makevertex(i),i++)
	for (scanf("%d",&C[i]),j=1;j<=C[i];j++)
	   scanf("%d",&Sp[i][j]);

}

void makevertex(int poz)
{
 int k;
 for (k=1;k<=P;k++) Sit[k]=2;
 for (k=1;k<=C[poz];k++)
	 Sit[Sp[poz][k]]=0;
 do	{
	for (N++,k=1;k<=P;k++) Z[N][k]=Sit[k];
	scanf("%d",&Value[N]); }
 while (nextvariation());
}

int nextvariation()
{
 int bci;
 for (bci=P;bci;bci--)
	if (Sit[bci]==0) {
		Sit[bci]=1;
		for (bci++;bci<=P;bci++)
		   if (Sit[bci]==1) Sit[bci]=0;
		return 1; }
 return 0;
}

void makegraph()
{
 int i,j,k;
 for (i=1;i<N;i++)
	for (j=i+1;j<=N;A[j][i]=A[i][j],j++)
		for (A[i][j]=1,k=1;k<=P;k++)
 if ( (Z[i][k]==0&&Z[j][k]==1) || (Z[i][k]==1&&Z[j][k]==0) )
			A[i][j]=0;
}

void solve(int poz,int vertex,int Cur)
{
 int i,j,flag;
 Path[poz]=vertex;
 if (Cur>=Res) return;
 if (Cur<Res&&poz==M) { Res=Cur;return; }
 for (i=vertex+1;i<=N;i++) {
	for (flag=1,j=1;j<=poz;j++)
	   if (!A[i][Path[j]]) flag=0;
	if (flag) solve(poz+1,i,Cur+Value[i]); }
}



