#include <climits>
#include <iostream>

int** matrix;

int main()
{
	int N, M;
	std::cin >> N >> M;
	matrix = new int* [N];
	for (int i = 0; i < N; i++)
	{
		matrix[i] = new int [N];
		for (int j = 0; j < N; j++)
			matrix[i][j] = (INT_MAX-1)/2;
	}

	int A, B, C;
	for (int i = 0; i < M; i++)
	{
		std::cin >> A >> B >> C;
		matrix[A-1][B-1] = matrix[B-1][A-1] = C;
	}

	for (int i = 0; i < N; i++)
		for (int j = 0; j < N; j++)
			for (int k = 0; k < N; k++)
				if (matrix[i][k] + matrix[k][j] < matrix[i][j])
					matrix[i][j] = matrix[i][k] + matrix[k][j];

	for (int i = 0; i < N; i++)
	{
		int max = 0;
		for (int j = 0; j < N; j++)
			if (matrix[i][j] > max && i != j)
				max = matrix[i][j];
		std::cout << max << '\n';
	}

	for (int i = 0; i < N; i++)
		delete [] matrix[i];
	delete [] matrix;

	return 0;
}