#include <stdio.h>

#define MAX     100100

long n, m;
long *next[MAX], *value[MAX], num[MAX];
long list[MAX][3];

char used[MAX];
long ans[MAX], fart;

void DFS(long v, long sum)
{
   long i, cur;

   used[v]=1;

   if(sum>fart)
     fart=sum;

   for(i=0; i<num[v]; i++)
   {
      cur=next[v][i];

      if(!used[cur])
        DFS(cur, value[v][i]+sum);
   }
}

int main()
{
   long i, j, t, v1, v2;

   scanf("%ld%ld", &n, &m);

   for(i=0; i<m; i++)
   {
      scanf("%ld%ld%ld", &v1, &v2, &t);v1--;v2--;
      num[v1]++;
      num[v2]++;

      list[i][0]=v1;
      list[i][1]=v2;
      list[i][2]=t;
   }

   for(i=0; i<n; i++)
   {
      next[i]=(long*)malloc(sizeof(long)*num[i]);
      value[i]=(long*)malloc(sizeof(long)*num[i]);
      num[i]=0;
   }

   for(i=0; i<m; i++)
   {
      v1=list[i][0];
      v2=list[i][1];
      t=list[i][2];

      next[v1][num[v1]]=v2;
      value[v1][num[v1]]=t;

      next[v2][num[v2]]=v1;
      value[v2][num[v2]]=t;

      num[v1]++;
      num[v2]++;
   }

   for(i=0; i<n; i++)
   {
      memset(used, 0, sizeof(used));
      fart=0;
      DFS(i, 0);

      ans[i]=fart;
   }

   for(i=0; i<n; i++)
      printf("%ld\n", ans[i]);

   return 0;
}

