#include <stdio.h>
#include <stdlib.h>

#define MAXN            15
#define MAXK            15
#define MAXV            100010
#define MAXDEPTH		11500

int n,k;
int dp[MAXN][MAXK];
int vis[MAXV];
int par[MAXV][3];
int dist[MAXV];
int res;
int brt[MAXN];
int len;
int brans;
int ans[MAXV][2];
//int curp;
char index[MAXV][2];
int l;

void CalcDP()
{
  int i,i2,i3;

  for(i=0;i<=10;i++)
  {
    dp[i][0] = 1;
  }

  for(i=1;i<=10;i++)
    dp[0][i] = 0;

  for(i=1;i<=10;i++)
  {
    for(i2=1;i2<=10;i2++)
    {
      dp[i][i2] = 0;
      for(i3=0;i3<=i2;i3++)
        dp[i][i2] += dp[i-1][i2-i3];
    }
  }
}

void input()
{
  scanf("%d %d",&n,&k);
}

int CodeSit()
{
  int i,i2;
  int sum;
  int balls;

  sum = 0;
  balls = k;

  for(i=1;i<=n;i++)
  {
    for(i2=0;i2<brt[i];i2++)
    {
      sum += dp[n-i][balls-i2];
    }

    balls -= brt[i];
  }

  return sum;
}

void output()
{
  int i;
  int cur;
  int max,mind;

  max = -1;
  mind = -1;

  for(i=0;i<MAXV;i++)
  {
    if(dist[i]>max)
    {
      max = dist[i];
      mind = i;
    }
  }

  len = max;

  cur = mind;
  brans = 0;

  while(par[cur][0]!=-1)
  {
    ans[brans][0] = par[cur][1];
    ans[brans][1] = par[cur][2];
    brans++;
    cur = par[cur][0];
  }


  printf("%d\n",len);

  for(i=brans-1;i>=0;i--)
  {
    printf("%d %d\n",ans[i][0],ans[i][1]);
  }

  exit(0);
}

void DFS()
{
//  char i,i2;
  int curp;

  if(l>MAXDEPTH)
	  output();

  curp = CodeSit();
  vis[curp] = 1;

  for(index[l][0]=1;index[l][0]<=n;index[l][0]++)
    if(brt[index[l][0]]>0)
      for(index[l][1]=1;index[l][1]<=n;index[l][1]++)
        if(index[l][0]!=index[l][1])
        {
//          curp = CodeSit();
          brt[index[l][0]]--;
          brt[index[l][1]]++;
          res = CodeSit();
          if(!vis[res])
          {
            par[res][0] = curp;
//            if(res==90000)
//              printf("%d\n",curp);

            par[res][1] = index[l][0];
            par[res][2] = index[l][1];
            dist[res] = dist[curp]+1;
            l++;
            DFS();
            l--;
          }
          brt[index[l][0]]++;
          brt[index[l][1]]--;
        }
}


/*void DFS2()
{
  char i,i2;

  curp = CodeSit();
  vis[curp] = 1;


  for(i=1;i<=n;i++)
    if(brt[i]>0)
      for(i2=1;i2<=n;i2++)
        if(i!=i2)
        {
          curp = CodeSit();
          brt[i]--;
          brt[i2]++;
          res = CodeSit();
          if(!vis[res])
          {
            par[res][0] = curp;
            par[res][1] = i;
            par[res][2] = i2;
            dist[res] = dist[curp]+1;
            DFS();
          }
          brt[i]++;
          brt[i2]--;
        }
} */


void solve()
{
  int i;


  CalcDP();

  for(i=1;i<=n;i++)
    brt[i] = 0;

  brt[1] = k;

  for(i=0;i<MAXV;i++)
    vis[i] = 0;

  res = CodeSit();
  dist[res] = 0;
  par[res][0] = -1;

  l = 0;

  DFS();


}



int main()
{

  input();
  solve();
  output();

  return 0;
}

