#include <stdio.h>
#include <string.h>

int **iDist;
int iVC;

void load(){
    //FILE *fin = fopen("paths.in","r");
    FILE *fin = stdin;
    int iEC;

    fscanf(fin,"%d%d",&iVC,&iEC);

    iDist = new int*[iVC];
    for (int i=0;i<iVC;i++){
        iDist[i] = new int[iVC];
        memset(iDist[i],0,sizeof(int)*iVC);
    }
    for (int i=0;i<iEC;i++){
        int iV1,iV2,iC;

        fscanf(fin,"%d%d%d",&iV1,&iV2,&iC);
        iV1--;
        iV2--;
        iDist[iV1][iV2] = iC;
        iDist[iV2][iV1] = iC;
    }

    //fclose(fin);
}

void solve(){
    for (int iM=0;iM<iVC;iM++)
        for (int iV1=0;iV1<iVC;iV1++){
            if (iDist[iV1][iM] == 0 || iV1 == iM)
                continue;
            for (int iV2=0;iV2<iVC;iV2++) {
                if (iDist[iV2][iM] == 0 || iV2 == iM|| iV1 == iV2)
                    continue;
                if ((iDist[iV1][iM] + iDist[iM][iV2] < iDist[iV1][iV2]) ||
                    iDist[iV1][iV2] == 0) {
                    iDist[iV1][iV2] = iDist[iV1][iM] + iDist[iM][iV2];
                    iDist[iV2][iV1] = iDist[iV1][iM] + iDist[iM][iV2];
                }
            }
        }
}

inline int max(int i1,int i2){
    return i1 > i2 ? i1 : i2;
}

int getMax(int iV){
    int iR = 0;
    for (int i=0;i<iVC;i++)
        iR = max(iR,iDist[iV][i]);
    return iR;
}

void save(){
    for (int i=0;i<iVC;i++)
        printf("%d\n",getMax(i));
}

int main(){
   load();
   solve();
   save();

   delete []iDist;

   return 0;
}
