#include <fstream.h>
#include <stdlib.h>
using namespace std;

typedef unsigned long ul;

ul n, m;
ul ans = 0;
ul max = 0;

struct edge
{
   ul v;
   ul d;
   edge* next;
};

struct vert
{
  edge *edges;
} a[ 100001 ];

char visited[ 100001 ];
ul d[ 100001 ];


void addedge( int u, int v, int d )
{
	edge* t;
   t = new edge;

   t->v = v;
   t->d = d;
   t->next = a[ u ].edges;
   a[ u ].edges = t;
}


void init( )
{
 	ul i;
	ul u, v, dist;
// 	ifstream cin( "paths.in" );
   cin>>n>>m;

	for ( i=1; i<=n; i++ )
   {
		a[ i ].edges = NULL;
   }

	for ( i=1; i<=m; i++ )
   {
    	cin>>u>>v>>dist;
      addedge( u, v, dist );
      addedge( v, u, dist );
    }

	for ( i=1; i<=n; i++ )
    {
     	d[ i ] = 0;
      visited[ i ] = 0;
    }
}

struct queue
{
 ul v;
 ul len;
} q[ 100005 ];


void bfs( int u )
{
 	ul qend, qbeg;
   queue w;
   ul l, v;

   q[ 1 ].v = u;
   q[ 1 ].len = 0;
	qbeg = 1;
	qend = 2;
	ul maxl = 0;

	edge* t;
	visited[ u ] = 1;

   do
   {
		w = q[ qbeg++ ];
      l = w.len;
      v = w.v;

		if ( l > maxl )
      {
       	maxl	= l;
			max	= v;
      }

   	if ( l > d[ v ] )
       {
        	d[ v ] = l;
        }

      for ( t=a[ v ].edges; t != NULL; t=t->next )
      {
			if ( !visited[ t->v ] )
         {
	          	visited[ t->v ] = 1;
	            q[ qend ].v = t->v;
  		         q[ qend ].len = l + t->d;
  	   	      qend++;
         }
      }
   }
	while( qbeg != qend );
}


void solve( )
{
 	ul i;

 	bfs( 1 );

	for ( i=1; i<=n; i++ )
   {
    	visited[ i ] = 0;
   }

	bfs( max );
}


void outdata( )
{
 	ul i;
	for ( i=1; i<=n; i++ )
   {
    	cout<<d[ i ]<<endl;
   }
}


void main( )
{
 init( );
 solve( );
 outdata( );
}
