#include <stdio.h>
#include <malloc.h>
#include <time.h>

#define N (16)
#define M (1<<20)

typedef struct vex vex;
typedef struct edg edg;

struct vex{
  int n;
  edg *next;
};

struct edg{
  int x, y;
  edg *next;
  int v;
};



int fnk[10][10];
int a[N];
vex gr[M];
int pos[M];
int max;
int pyt[M][2];
int pm[M][2];
int np;

int kur;
int n, k;
int gn;
time_t *beg;
time_t *end;

int laino;

int f(int n, int k) {
  int ret, i;
  ret = 0;

  if(fnk[n][k] != -1) {
    return fnk[n][k];
  }
  else if(n == 1) {
    return 1;
  }
  else if(k == 0) {
    return 1;
  }
  else {
    for(i=0; i<=k; i++) {
      ret += f(n-1, i);
    }
    fnk[n][k] = ret;
    return ret;
  }
}

int ktoi(int b[N]) {
  int i, j, ret;
  ret = 0;

  for(j=1; j<n; j++) {
    for(i=0; i<b[j-1]; i++) {
      ret += f(n-j, k-i);
    }
  }
  return ret;
}

void itok(int i, int b[N]) {

  int j, l, m, s;

  for(j=0, s=0, m=i; j<n-1; j++) {

    for(l=k-s; l>=0; l--) {
      m-=f(n-j-1, l);
      if(m<0) {
        m+=f(n-j-1, l);
        break;
      }
    }
    a[j] = k-l-s;
    s+=k-l-s;
  }
  a[j] = k-s;
  for(i=0; i<n; i++) {
    b[i] = a[i];
  }
}


void bg(void) {
  int i, j, l, v;
  int konf[N];
  edg *t;

  for(i=0; i<gn; i++) {
    gr[i].n = 0;
    gr[i].next = NULL;
  }
  for(i=0; i<gn; i++) {
    itok(i, konf);

    for(j=0; j<n; j++) {
      for(l=0; l<n; l++) {
        if(l==j) continue;
        if(konf[j]-1 >= 0) {
          konf[j]--;
          konf[l]++;
          v = ktoi(konf);
          konf[j]++;
          konf[l]--;
          t = (edg *)malloc(sizeof(edg));
          t->next = gr[i].next;
          t->x = j+1;
          t->y = l+1;
          t->v = v;
          gr[i].next = t;
          gr[i].n++;
        }
      }
    }
  }
}

void dfs(int i, int hod) {
  edg *t;
  int v;

//  time(end);

  pos[i] = 1;
  if(max < hod) {
    kur = 0;
    max = hod;
    memmove(pm, pyt, sizeof(pyt[0])*np);
  }
  else if(hod == max) kur++;
  if(kur == 40) print();
  /*
  if(*end - *beg >= 2)
    print();
    */
  for(t = gr[i].next; t!=NULL; t = t->next) {
    if(t) {
      v = t->v;
      if(!pos[v]) {
        pyt[np][0] = t->x;
        pyt[np][1] = t->y;
        np++;
        if(laino) dfs(v, hod+1);
        np--;
      }
    }
  }
  pos[i] = 0;
}

void print(void) {
  int i;
  printf("%d\n", max);
  for(i=0; i<max; i++) {
    printf("%d %d\n", pm[i][0], pm[i][1]);
  }
  laino = 0;
}

int main() {
  int i, j;
  int konf[N];


//  time(beg);

//  freopen("kur.out", "w", stdout);

  kur = 0;

  for(i=0; i<10; i++) {
    for(j=0; j<10; j++) {
      fnk[i][j] = -1;
    }
  }

  laino = 1;
  scanf("%d%d", &n, &k);
  gn = f(n, k);
  bg();
  dfs(gn-1, 0);
  if(laino) print();
  return 0;
}
