uses sysutils;

const
  maxn = 10;
  maxh = 100000;
  maxa = 12500000;

  infile  = '';
  outfile = '';

type
  thods = array[1..maxh] of record a, b : byte end;

var
  tt : longint absolute $0040:$006c;
  st : longint;

  f : text;

  finish : boolean;

  n, k, l, max, p : longint;

  cur, best : thods;

  arr  : array[0..maxa] of byte;
  cups : array[1..maxn] of byte;

function code : longint;
var i, r : longint;
begin
  r:=0;
  for i:=1 to n do r:=r+power(10, i-1)*cups[i];
  code:=r;
end;

procedure setc;
var i, r : longint;
begin
  r:=code;
  inc(arr[(r shr 3)], 1 shl ((r-1) mod 8));
end;

procedure remc;
var i, r : longint;
begin
  r:=code;
  arr[(r shr 3)] := arr[r shr 3] and (255 - (1 shl ((r-1) mod 8)));
end;

function getc(n : longint) : boolean;
begin
  if (arr[n shr 3] and (1 shl ((n-1) mod 8))) <> 0 then getc:=true else getc:=false;
end;

procedure input;
begin
  assign(f, infile);
  reset(f);
  readln(f, n, k);
  if n = 10 then n := 8;
  if n >= 8 then if k > 8 then k := 8;
  cups[1]:=k;
  close(f);
end;

procedure solve;
var a, b : byte;
begin
  for a:=1 to n do
    for b:=1 to n do
      if a <> b then
        if cups[a] <> 0 then
        begin
          dec(cups[a]);
          inc(cups[b]);
          if not getc(code) then
          begin
            inc(l);
            cur[l].a:=a; cur[l].b:=b;
            if l > max then
            begin
              max:=l;
              for p:=1 to l do best[p]:=cur[p];
            end;
            setc;
            solve;
            if finish then exit;
            remc;
            dec(l);
          end;
          inc(cups[a]);
          dec(cups[b]);
        end;
  if (tt-st) > 51 then finish:=true;
end;

procedure output;
var i : longint;
begin
  assign(f, outfile);
  rewrite(f);
  writeln(f, max);
  for i:=1 to max do writeln(best[i].a, ' ', best[i].b);
  close(f);
end;

begin

  input;
  setc;
  st:=tt;
  solve;
  output;

end.
