#include <stdlib.h>
#include <stdio.h>
#define MAX (16)
#define MAXQ (100000)

int n, k, tx;
int a[MAX];
int b[MAX];
int f[MAX][MAX];
int ans, anse, cur;

int p[MAXQ];
int pm[MAXQ][2];
int v[MAXQ];
int o[MAXQ];

int code (int *a, int n)  {
  int i, j, t, r;

  t = k;
  r = 0;

  for (i = 1; i <= n; ++i)  {
    for (j = 0; j < a[i]; ++j)
      r += f[n - i][t - j];
    t -= a[i];
  }

  return r;
}

void decode (int *a, int n, int num)  {
  int i, j, t, r;

  t = k;
  for (i = 1; i <= n - 1; ++i)  {
    for (j = 0; ; ++j)  {
      if (num - f[n - i][t - j] < 0)  {
        a[i] = j;
        break;
      }
      num -= f[n - i][t - j];
    }
    t -= a[i];
  }

  a[n] = t;
}

void pset (int *a, int n)  {
  int i;

  for (i = 1; i <= n; ++i)
    printf ("%d%c", a[i], i == n ? '\n' : ' ');
}

void pans (int e)  {
  if (e == tx) return;
  pans (p[e]);
  printf ("%d %d\n", pm[e][0], pm[e][1]);
}

void init ()  {
  int i, j, p, t;

//freopen ("cups.in" , "r", stdin );
//freopen ("cups.out", "w", stdout);
  scanf ("%d%d", &n, &k);

  for (i = 0; i <= n; ++i)
    f[1][i] = 1;

  for (i = 2; i <= n; ++i)
    for (j = 0; j <= k; ++j)
      for (p = 0; p <= j; ++p)
        f[i][j] += f[i - 1][p];


  for (i = 1; i <= n; ++i)
    a[i] = 0;

  a[1] = k;
}

void dfs (int pe, int e)  {
  int i, j, t;

  if (ans < cur)  {
    ans = cur;
    anse = e;
  }

  v[e] = 1;

  decode (a, n, e);
  for (i = 1; i <= n; ++i)  {
    if (a[i] > 0)  {
      a[i] -= 1;
      for (j = 1; j <= n; ++j)
        if (i != j)  {
          a[j] += 1;
          t = code (a, n);
          if (!v[t] && o[t] < cur + 1)  {
            ++cur;
            o[t] = cur;
            p[t] = e;
            pm[t][0] = i;
            pm[t][1] = j;
            dfs (e, t);
            --cur;
          }
          a[j] -= 1;
        }
      a[i] += 1;
    }
  }
}

void think ()  {
  tx = code (a, n);
  dfs (-1, tx);
}

void print ()  {
  printf ("%d\n", ans);
  pans (anse);
}

int main ()  {
  init ();
  think ();
  print ();

  return 0;
}

