#include <stdio.h>
#include <limits.h>
#define MAX 64

typedef struct  {
  int vs[MAX], xs[MAX], xo[MAX], xn, vn;
} fun;

fun f[16];
int vo[MAX];
int xs[MAX], vn;
int a[MAX], ao[MAX];
int n, m, ans;

void init ()  {
  int i, j;

//freopen ("minval.in" , "r", stdin );
//freopen ("minval.out", "w", stdout);

  scanf ("%d%d", &m, &n);

  for (i = 1; i <= m; ++i)  {
    scanf ("%d", &f[i].xn);
    for (j = 1; j <= f[i].xn; ++j)  {
      scanf ("%d", &f[i].xs[j]);
      f[i].xo[f[i].xs[j]] = 1;
      vo[f[i].xs[j]] += 1;
    }
    f[i].vn = (1 << f[i].xn);
    for (j = 0; j < f[i].vn; ++j)
      scanf ("%d", &f[i].vs[j]);
  }

  for (i = 1; i <= n; ++i)  {
    if (vo[i] > 1)  {
      xs[++vn] = i;
      vo[i] = 1;
    }
    else
      vo[i] = 0;
  }
  ans = INT_MAX;
}

int ok (int i, int e)  {
  int j, t, p;

  t = i;
  for (j = f[e].xn; 1 <= j; --j)  {
    p = t & 1;
    if (vo[f[e].xs[j]] && a[f[e].xs[j]] != p)
      return 0;
    t >>= 1;
  }

  return 1;
}

int opt (int e)  {
  int i, j, r, p;

  r = INT_MAX;

  for (i = 0; i < f[e].vn; ++i)  {
    if (ok (i, e))  {
      if (r > f[e].vs[i])
        r = f[e].vs[i];
    }
  }

  return r;
}

int sum ()  {
  int i, r;

  r = 0;
  for (i = 1; i <= m; ++i)
    r += opt (i);

  return r;
}

void dfs (int e)  {
  int t;

  if (e == vn + 1)  {
    t = sum ();
    if (ans > t)
      ans = t;
    return;
  }

  dfs (e + 1);
  a[e] = 1;
  ao[xs[e]] = 1;

  dfs (e + 1);
  a[e] = 0;
  ao[xs[e]] = 0;
}

void think ()  {
  dfs (1);
}

void print ()  {
  printf ("%d\n", ans);
}

int main ()  {
  init ();
  think ();
  print ();

  return 0;
}

