const
   maxn = 100000;
type
   pnode = ^tnode;
   tnode = record
      v, w : longint;
      next : pnode;
   end;
var
   n, m : longint;
   a : array[1..maxn] of pnode;
   d : array[-1..maxn] of longint;
   u : array[1..maxn] of boolean;

function dist(v : longint) : longint;
var
   i, j, k : longint;
   p : pnode;
   min : longint;
   rr : longint;
begin
   for i:=1 to n do
      d[i]:=maxlongint;
   d[v]:=0;
   d[-1]:=maxlongint;
   fillchar(u, n, false);
   u[v]:=true;
   p:=a[v];
   while p <> nil do
   begin
      d[p^.v]:=p^.w;
      p:=p^.next;
   end;

   for k:=1 to n-1 do
   begin
      min:=-1;
      for i:=1 to n do
         if not u[i] then
            if d[i] < d[min] then
               min:=i;
      u[min]:=true;

      p:=a[min];
      while p <> nil do
      begin
         if not u[p^.v] then
            if d[min] + p^.w < d[p^.v] then
               d[p^.v]:=d[min] + p^.w;
         p:=p^.next;
      end;
   end;

   rr:=0;
   for i:=1 to n do
      if d[i] > rr then
         rr:=d[i];
   dist:=rr;
end;

var
   f : text;
   v1, v2, w : longint;
   p : pnode;
   i, j : longint;
begin
   assign(f, '');
   reset(f);
   readln(f, n, m);
   for i:=1 to m do
   begin
      readln(f, v1, v2, w);
      new(p);
      p^.v:=v2;
      p^.w:=w;
      p^.next:=a[v1];
      a[v1]:=p;
      new(p);
      p^.v:=v1;
      p^.w:=w;
      p^.next:=a[v2];
      a[v2]:=p;
   end;
   close(f);

   for i:=1 to n do
      writeln(dist(i));
end.
