const
  maxp = 9;
  maxn = 9;
  maxk = 500;

  infile  = '';
  outfile = '';

var
  f : text;

  p, n, k : longint;

  br : array[0..maxp, -maxp..maxp] of qword;
  r  : array[0..maxn, 0..maxp, -maxk..maxk] of qword;

procedure input;
begin
  assign(f, infile);
  reset(f);
  readln(n, p, k);
  close(f);
end;

procedure fillbr;
var vp, va, vb : longint;
begin
  for vp:=0 to p do
    for va:=0 to vp do
      for vb:=0 to vp do
      begin
        inc(br[vp, va-vb]);
      end;
end;

procedure solve;
var
  i, j : qword;
  vn, vk, vp, vi, vj : longint;

begin
  fillbr;

  for vi:=1 to p do
    for vj:=-p to p do
    begin
      r[1, vi, vj]:=br[vi, vj];
    end;

  for vn:=2 to n do
    for vp:=0 to p do
    begin
      for vk:=-vn*p to vn*p do
      begin
        i:=0;
        for vj:=-p to p do
        begin
//          if k+vj >= 0 then
          i:=i + (r[vn-1, vp, vk+vj] * br[vp, -vj]);
        end;
        r[vn, vp, vk]:=i;
      end;
    end;
end;

procedure output;
begin
  assign(f, outfile);
  rewrite(f);
  writeln(r[n, p, k]);
  close(f);
end;

begin
  input;
  solve;
  output;
end.
