const
  maxn = 1500;

  infile = '';
  outfile = '';

type
  tpict = record a, b : double; end;

var
  start : longint;
  time  : longint absolute $0040:$006C;

  f : text;

  finish : boolean;

  w       : double;

  n, brds, num : longint;

  tmp  : tpict;
  lw   : array[1..maxn] of double;
  lmax : array[1..maxn] of double;
  pict : array[1..maxn] of tpict;
  used : array[1..maxn] of boolean;

  y : double;

procedure sort(l,r: integer);
var
  i,j : integer;
  x : double;
begin
  i:=l; j:=r; x:=pict[(l+r) DIV 2].a;
  repeat
    while pict[i].a<x do i:=i+1;
    while x<pict[j].a do j:=j-1;
    if i<=j then
    begin
      tmp:=pict[i]; pict[i]:=pict[j]; pict[j]:=tmp;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

procedure input;
var i : longint;
begin
  assign(f, infile);
  reset(f);
  readln(f, n, w);

  for i:=1 to n do
  begin
    lw[i]:=w;
    readln(f, pict[i].a, pict[i].b);
    if pict[i].a > pict[i].b then
    begin
      y := pict[i].a;
      pict[i].a:=pict[i].b;
      pict[i].b:=y;
    end;
  end;

  sort(1, n);

  close(f);
end;

var cur, min : double;

procedure solve(l : word);
var
  p  : word;
begin
  if num=n then
    if cur+lmax[l] < min then begin min:=cur+lmax[l]; exit; end;

  for p:=1 to n do
  if not used[p] then
  begin
    if lw[l]=w then
    begin
      inc(num);
      lmax[l]:=pict[p].b;
      lw[l]:=w-pict[p].a;
      used[p]:=true;
      solve(l);
      if finish then exit;
      used[p]:=false;
      lw[l]:=w;
      dec(num);

      if (pict[p].b <= w)and(pict[p].a<>pict[p].b) then
      begin
        inc(num);
        lmax[l]:=pict[p].a;
        lw[l]:=w-pict[p].b;
        used[p]:=true;
        solve(l);
        if finish then exit;
        used[p]:=false;
        lw[l]:=w;
        dec(num);
      end;
    end
    else
    begin
      if pict[p].a > lw[l] then
      begin
        cur:=cur+lmax[l];
        if cur < min then solve(l+1);
        if finish then exit;
        cur:=cur-lmax[l];
        exit;
      end;

      if pict[p].b <= lmax[l] then
      begin
        inc(num);
        lw[l]:=lw[l] - pict[p].a;
        used[p]:=true;
        solve(l);
        if finish then exit;
        used[p]:=false;
        lw[l]:=lw[l] + pict[p].a;
        dec(num);
      end;

      if (pict[p].b <= lw[l])and(pict[p].a<>pict[p].b)and(pict[p].a <= lmax[l]) then
      begin
        inc(num);
        lw[l]:=lw[l] - pict[p].b;
        used[p]:=true;
        solve(l);
        if finish then exit;
        used[p]:=false;
        lw[l]:=lw[l] + pict[p].b;
        dec(num);
      end;
    end;
  end;

  if (time-start) > 18 then finish:=true;
end;

begin
  start := time;

  min:=maxlongint;

  input;
  solve(1);

  if min = maxlongint then writeln(pict[n].b:0:6) else writeln(min:0:6);
end.
