#include <stdio.h>

#define MAXN 10
#define MAXK 100
#define UNDEF -1

long long T[MAXN][2*MAXK];
int n,k,p;

long long Find(int n,int k)
  {
    int a,b;
    if (n == 0 && k == 0) return 1;
    if (n == 0) return 0;
    if (T[n][k + MAXK] != UNDEF) return T[n][k + MAXK];

    T[n][k + MAXK] = 0;
    for (a = 0;a <= p;a++)
      for (b = 0;b <= p;b++)
        T[n][k + MAXK] += Find(n - 1,k - (a - b));

    return T[n][k + MAXK];
  }

int main()
  {
    int i,j;

//    freopen("count.in","rt",stdin);

    scanf("%d%d%d",&n,&p,&k);

    for (i = 0;i < MAXN;i++)
      for (j = 0;j < 2*MAXK;j++)
        T[i][j] = UNDEF;

    printf("%lld\n",Find(n,k));
    return 0;
  }
