{
        Checker for the `strange' task (created by Veselin Georgiev)
        Expects: <input_file> <output_file> <judge_file>
        Does: Compare <output_file> and <judge_file>
}



function FileExists(FileName: String): Boolean;
{ Boolean function that returns True if the file exists;otherwise,
 it returns False. Closes the file if it exists. }
var
 F: file;
begin
 {$I-}
 Assign(F, FileName);
 FileMode := 0;
 Reset(F);
 Close(F);
 {$I+}
 FileExists := (IOResult = 0) and (FileName <> '');
end;  { FileExists }

var t1, t2 : text;
    s1, s2 : string;

BEGIN
if paramcount <> 3 then
   begin
        WriteLn('USAGE: format <in_file> <out_file> <judge_file>');
        halt(1);
   end;
if (Not FileExists(ParamStr(2))) or (Not FileExists(ParamStr(3))) then
   begin
        WriteLn('USAGE: format <in_file> <out_file> <judge_file>');
        halt(1);
   end;
assign(t1, paramstr(2));
assign(t2, paramstr(3));
reset(t1); reset(t2);
if eof(t1) then
   begin
        WriteLn(0);
        WriteLn('Bad Output');
        close(t1); close(t2); halt(0);
   end;
readln(t1, s1);
readln(t2, s2);
if not eof(t1) then
   begin
        WriteLn(0);
        WriteLn('Excess of output');
        close(t1); close(t2); halt(0);
   end;
close(t1); close(t2);
if s1 = s2 then
   begin
        WriteLn(10);
        WriteLn('OK');
   end else
   begin
        WriteLn(0);
        WriteLn('Wrong Solution');
   end;
END.
