#include "totolib.h"
#include <stdlib.h>

#define SIX_DIV 4

int found = 0;
int cnt = 0;
int fsol[6]; 
int slot[8];
int freeslot=7;


int ask(int base, int size)
{int i, x[6];
 for (i=0;i<6;i++) x[i] = freeslot*6+i+1;
 for (i=0;i<size;i++) x[i] = base+i;
 return (post_comb(x[0], x[1], x[2], x[3], x[4], x[5]));
}

int search(int base, int size, int count)
{int i, r, halfsz;
 if (count == 0) return 0;
 if (count == size) {
    for (i=base; i<base+size; i++)
	fsol[cnt++] = i;
    return 1;
    }
 if (size==6) halfsz = SIX_DIV;
         else halfsz = size/2;
 r = ask(base, halfsz);
 search(base, halfsz, r);
 search(base + halfsz, size - halfsz, count - r);
 }


int main(void)
{int r, i;
 for (i = 0; i < 8; i++) {
    // query slot:
    r = post_comb(i*6+1, i*6+2, i*6+3, i*6+4, i*6+5, i*6+6);
    found += r;
    slot[i] = r;
    if (r==0) freeslot=i;
    if (found==6) break;
    }
 // if the combination contains 49:
 if (found == 5)
    fsol[cnt++] = 49;

 // search every slot. empty ones will be just skipped by `search'    
 for (i = 0; i < 8; i++)
    search(i*6+1, 6, slot[i]);    
    
 // submit answer
    post_comb(fsol[0], fsol[1], fsol[2], fsol[3], fsol[4], fsol[5]);
 }
