/*
TASK:strange
LANG:C++
 */
#include <stdio.h>

#define N (1<<18)

typedef long long LLONG;

LLONG n,fr;
LLONG f[N],g[N];
LLONG fp,gp;

#define GP 2.618033988749894
#define FP 1.618033988749894

void init()
{
    f[1]=1;
    g[1]=2;
    f[2]=3;
    fp=3;
    gp=2;
    fr=4;
}

void gen()
{
    LLONG k;
    while(gp<=n)
    {
	k=f[gp];
	for(;fp<=k;fp++)f[fp]=fr++;
	g[gp++]=fr++;
    }
}

/*void fast()
{
    p=2;
    f=3;
    g=5;
    while(f<n)
    {
	p=f;
	f=g-1;
	g=f+p;
    }
}*/

/*void check()
{
    int i;
    for(i=n-100; i<n; i++)
    {
	printf("%.15f\n",(double)g[i]/(double)i);
    }
}*/

int main()
{
    LLONG f1,g1;
    scanf("%lld",&n);
    init();
    if(n<N/2)
    {
	gen();
	printf("%lld %lld\n",f[n],g[n]);
    }
    else
    {
	f1=FP*n;
	g1=GP*n;
	printf("%lld %lld\n",f1,g1);
    }
    //check();
    return 0;
}

