/*
TASK: toto
LANG: C++
*/

#include <vector>

#include "totolib.h"

int main()
{
	std::vector<int> query(49, 0);	/* Index 0 not used. */
	unsigned int qcount = 0;
	for (int i = 1; i < 48; i += 3)
	{
		query[i] = post_comb(i, i+1, i+2, (i+2)%48+1, (i+3)%48+1, (i+4)%48+1);
		qcount += query[i];
	}

	bool has_49 = (qcount == 10);
	int comb[6]; unsigned int comb_end = 0;
	bool flag = false;
	int empty_query;
	for (int i = 1; i < 48 && !flag; i += 3)
		if (!query[i])
		{
			empty_query = i;
			flag = true;
			comb[0] = i;
			comb[1] = i+1;
			comb[2] = i+2;
			comb[3] = (i+2)%48+1;
			comb[4] = (i+3)%48+1;
			comb[5] = (i+4)%48+1;
		}

	for (int i = empty_query-3; i > 0; i -= 3)
		query[i] -= query[(i+2)%48+1];

	for (int i = 46; i > empty_query; i -= 3)
		query[i] -= query[(i+2)%48+1];

	if (has_49) comb[5] = 49;

	for (int i = 1; i < 48; i += 3)
		if (query[i] == 1)
		{
			//std::printf("Case 1.\n");
			bool flag = false;
			comb[comb_end] = i;
			flag = post_comb(comb[0], comb[1], comb[2], comb[3], comb[4], comb[5]) > comb_end+has_49;
			if (!flag)
			{
				comb[comb_end]++;
				flag = post_comb(comb[0], comb[1], comb[2], comb[3], comb[4], comb[5]) > comb_end+has_49;
			}
			if (!flag) comb[comb_end]++;
			comb_end++;
		} else if (query[i] == 2)
		{
			//std::printf("Case 2.\n");
			bool flag = false;
			comb[comb_end] = i;
			flag = post_comb(comb[0], comb[1], comb[2], comb[3], comb[4], comb[5]) > comb_end+has_49;
			if (flag)
			{
				comb[comb_end+1] = i+1;
				flag = post_comb(comb[0], comb[1], comb[2], comb[3], comb[4], comb[5]) > comb_end+1+has_49;
				if (!flag)
					comb[comb_end+1]++;
			} else
			{
				comb[comb_end]++;
				comb[comb_end+1] = comb[comb_end]+1;
			}

			comb_end += 2;
		} else if (query[i] == 3)
		{
			//std::printf("Case 3.\n");
			comb[comb_end] = i;
			comb[comb_end+1] = i+1;
			comb[comb_end+2] = i+2;
			comb_end += 3;
		}

	post_comb(comb[0], comb[1], comb[2], comb[3], comb[4], comb[5]);

	return 0;
}
