/*
TASK:base
LANG:C++
*/

#include <stdio.h>
#include <vector>

using namespace std;

#define N (1<<14)
#define M (1<<17)

int n,m;
vector <int> al[N];
vector <int> ar[N];
int vis[N];
int pnum[N],p;
int order[N];
int com[N],c;
int str[M][2];

void readf()
{
    int i,j,k;
    scanf("%d %d",&n,&m);
    for(i=0; i<m; i++)
    {
	scanf("%d %d",&j,&k);
	j--;k--;
	al[j].push_back(k);
	ar[k].push_back(j);
	str[i][0]=j;
	str[i][1]=k;
    }
}

void dfs1(int v)
{
    unsigned int i;
    vis[v]=1;
    for(i=0; i<al[v].size(); i++)
	if(!vis[al[v][i]])
	    dfs1(al[v][i]);
    pnum[v]=p++;
    order[pnum[v]]=v;
}

void dfs2(int v)
{
    unsigned int i;
    vis[v]=2;
    com[v]=c;
    for(i=0; i<ar[v].size(); i++)
	if(vis[ar[v][i]]!=2)
	    dfs2(ar[v][i]);
}

void solve()
{
    int i,br=0;
    for(i=0; i<n; i++)
	if(!vis[i])dfs1(i);
    for(i=n-1; i>=0; i--)
	if(vis[order[i]]!=2)
	{
	    dfs2(order[i]);
	    c++;
	}
    for(i=0; i<m; i++)
	if(com[str[i][0]]!=com[str[i][1]])
	    br++;
    printf("%d\n",br);
}

int main()
{
    readf();
    solve();
    return 0;
}

