/*
TASK: base
LANG: C
*/
#include<stdio.h>

#define MAXN 16384
#define MAXM 131072
#define INF 1000000000

int n,m,beg[MAXN],num[MAXN],best[MAXN],used[MAXN],br,res;

struct edge
{
	int r,next;
} e[MAXM];

void DFS(int v1)
{
	int i,v2;
	used[v1]=1;
	num[v1]=br++;
	best[v1]=INF;
	for(i=beg[v1];i!=-1;i=e[i].next)
	{
		v2=e[i].r;
		if(!used[v2])
		{
			DFS(v2);
			if(best[v2]>num[v1]) res++;
			//if(best[v2]>num[v1]) printf("%d %d\n",v1+1,v2+1);
			best[v1]=(best[v1]<best[v2])?best[v1]:best[v2];
		}
		else best[v1]=(best[v1]<num[v2])?best[v1]:num[v2];
	}
}

int main()
{
	int i,l,r;
	//freopen("BASE.in","r",stdin);
	scanf("%d%d",&n,&m);
	for(i=0;i<n;i++) beg[i]=-1;
	for(i=0;i<m;i++)
	{
		scanf("%d%d",&l,&r);
		e[i].r=r-1;
		e[i].next=beg[l-1];
		beg[l-1]=i;
	}
	for(i=0;i<n;i++) if(!used[i]) DFS(i);
	printf("%d\n",res);
	return 0;
}