/*
TASK:mark
LANG:C++
*/
# include <stdio.h>
# include <stdlib.h>
# define MAXN 128
# define MAXZ 500
# define T bignum

struct bignum {
    int size;
    short data[MAXZ];
};

int d[MAXN];
int n, p, k,nnn;
long long a1, b1;
bignum a,b,nn;

void init(bignum *x) {
    x->size = 0;
    for ( int i=0 ; i<MAXZ ; i++ )
	x->data[i] = 0;
}

void print(bignum x) {
    if ( x.size==0 ) printf("0");
    else {
	for ( int i=x.size-1 ; i>=0 ; i-- ) {
	    printf("%d",x.data[i]);
	}
    }
    printf("\n");
}

void readf() {
    int x;
//    freopen("mark.in","r",stdin);
    scanf("%d %d %d",&n,&p,&k);
    for ( int i=0 ; i<k ; i++ ) {
	scanf("%d",&x);
	d[x] = 1;
    }
    scanf("%llu %llu",&a1,&b1);
    while (a1) {
	a.data[a.size++] = a1%10;
	a1/=10;
    }
    while (b1) {
	b.data[b.size++] = b1%10;
	b1/=10;
    }
    nnn = n;
    while ( nnn ) {
	nn.data[nn.size++] = nnn%10;
	nnn/=10;
    }
}

void sum(T *s, int ss, T *res) {
    int pre = 0, i=0;
    *res = *s;
    while ( pre || i==0 ) {
	res->data[i] += ss+pre;
	pre = res->data[i]/10;
	res->data[i] %= 10;
	i++;
    }
    if ( res->data[res->size]!=0 )
	res->size++;
}

void mult(T *s, T *ss, T *res) {
    int pre,l;
    init(res);
    for ( int i=0 ; i<s->size ; i++ ) {
	for ( int j=0 ; j<ss->size ; j++ ) {
	    res->data[i+j] += s->data[i]*ss->data[j];
	    pre = res->data[i+j]/10;
	    res->data[i+j]%=10;
	    l=1;
	    while ( pre ) {
		res->data[i+j+l] += pre;
		pre = res->data[i+j+l]/10;
		res->data[i+j+l] %= 10;
		l++;
	    }	    
	}
    }
    res->size = s->size+ss->size-1;
    while ( res->data[res->size] )
	res->size++;
}


int comp(T *X, T *X1) {
    if ( X->size != X1->size ) return  X->size - X1->size;
    for ( int i=X->size-1 ; i>=0 ; i-- ) {
	if ( X->data[i]!=X1->data[i] ) return X->data[i] - X1->data[i];
    }
    return 0;
}

int compf(T *x, T *y, T *x1, T *y1) {
//    T X = x*y1;
    T X;
    mult(x,y1,&X);
    
//    T X1 = x1*y;
    T X1;
    mult(x1,y,&X1);

/*    printf("compf ");
    print(*x); print(*y); print(*x1); print(*y1);
    

    printf("\nX ");
    print(X);
    printf("X1 ");
    print(X1);
    
    
  */  
    return comp(&X,&X1);
}

void solve(T a1, T b1, T an, T bn, int curp) {
/*    print(a1);
    print(b1);
    print(an);
    print(bn);*/
//    printf("%lld/%lld   %lld/%lld\n",a1,b1,an,bn);
    if ( curp==p ) {
	printf("0\n");
	exit(0);
    }
    T a2,b2,a3;
    init(&a2);
    init(&b2);
    init(&a3);
    //b2 = b1*n;
    mult(&b1,&nn,&b2);    
    //a1 = a1*n;
    mult(&a1,&nn,&a2);
//    printf("n ");
  //  print(nn);
//    printf("a2 ");
  //  print(a2);
//    printf("b2 ");
  //  print(b2);
    for ( int i=0 ; i<n ; i++ ) {
	sum(&a2,1,&a3);
//	printf("a3 ");
//	print(a3);
	if ( compf(&a,&b,&a3,&b2)<0 ) {
	    if ( d[i+1] ) {
		printf("%d\n",curp+1);
		exit(0);
	    } else {
		solve(a2,b2,a3,b2,curp+1);
	    }
	}
	a2 = a3;
    }
}

int main() {
    readf();
    T a1,b1,an,bn;
    init(&a1);
    init(&b1);
    init(&an);
    init(&bn);
    b1.size = 1;
    b1.data[0] = 1;
    an.size = 1;
    an.data[0] = 1;
    bn.size = 1;
    bn.data[0] = 1;    
    solve(a1,b1,an,bn,0);

    return 0;
}

