/*
TASK:mark
LANG:C++
*/

#include <iostream>
#include<algorithm>
using namespace std;
#define maxN 100
#define accr 0.00000000001

bool used[maxN+1];
int N,P,K;
long double A,B;

pair <pair<long double,long double>,int> scan(long double h,long double e);
void init();

int main()
{
 init();
 long double from=0;
 long double to=1;
 for (int i=1;i<=P;i++) {
    pair <pair<long double,long double>,int> F=scan(from,to);
    if (used[F.second]) { cout<<i<<endl;return 0; }
    from=F.first.first;
    to=F.first.second; }
 cout<<0<<endl;
 return 0;
}

pair <pair<long double,long double>,int> scan(long double h,long double e)
{
 long double step=(long double)(e-h)/N;
 for (int i=1;i<=N;i++)
    if (A+accr<h+step*i)
       return make_pair(make_pair(h+step*(i-1),h+step*i),i);
 return make_pair(make_pair(0,0),0);
}

void init()
{
 cin>>N>>P>>K;
 for (int i=1;i<=K;i++) {
    int x;
    cin>>x;
    used[x]=1; }
 cin>>A>>B;
 A/=B;
}
