/*
TASK:MARK
LANG:C++
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define LEN (1<<8)
#define N (1<<7)

char buf[LEN];

struct lnum
{
    char num[LEN];
    int l;
};

int p,k,n;
lnum nl;
int m[N];
lnum ch,zn,a,b;
lnum t1,t2;

void mult(lnum &l1, lnum &l2, lnum &ld)
{
    int i,j;
    ld.l=l1.l+l2.l+2;
    for(i=0; i<ld.l; i++)
	ld.num[i]=0;
    for(i=0; i<l1.l; i++)
	for(j=0; j<l2.l; j++)
	    ld.num[i+j]+=l1.num[i]*l2.num[j];
    ld.l=l1.l+l2.l;
    for(i=0; i<ld.l; i++)
    {
	ld.num[i+1]+=ld.num[i]/10;
	ld.num[i]=ld.num[i]%10;
    }
    while(ld.l>0 && !ld.num[ld.l-1])ld.l--;
}

void pp(lnum &ln)
{
    int i=0;
    while(++ln.num[i++]==10)
    {
	ln.num[i-1]=0;
    }
    if(ln.l<i)
    {
	ln.l=i;
    }
}

void mm(lnum &ln)
{
    int i=0;
    while(--ln.num[i++]== -1)
    {
	ln.num[i-1]=9;
    }
    if(ln.num[ln.l-1]==0) ln.l--;
}

void printnorm(lnum &ln)
{
    int i;
    for(i=0; i<ln.l; i++)
	buf[i]=ln.num[ln.l-1-i]+'0';
    buf[i]=0;
    printf("%s\n",buf);
}

void copy(lnum &ls, lnum &ld)
{
	int i;
	ld.l=ls.l;
	for(i=0; i<=ls.l; i++) ld.num[i]=ls.num[i];
}

int comp(lnum &l1, lnum &l2)
{
    int i;
    if(l1.l!=l2.l) return l1.l-l2.l;
    for(i=l1.l-1; i>=0; i--)
    	if(l1.num[i]!=l2.num[i])
	    return l1.num[i]-l2.num[i];
    return 0;
}

int solvel()
{
    int i;
   // printf("----\n");
    for(i=0; i<=n; i++)
    {
	//printnorm(ch);
	//printnorm(zn);
	//printf("-\n");
	mult(b,ch,t1);
	mult(a,zn,t2);
	if(comp(t1,t2)>0)
	{
	    mm(ch);
	    break;
	}
	pp(ch);
    }
    i--;
    if(i==n)
    {
	printf("error!\n");
	exit(0);
    }
    if(m[i]) return 1;
    return 0;
}

void ITOA(lnum &ls, int num)
{
    int i=0;
    while(num)
    {
	ls.num[i++]=num%10;
	num=num/10;
    }
    ls.l=i;
}

void readf()
{
    int i,j,l;
    scanf("%d %d %d",&n,&p,&k);
    for(i=0; i<k; i++)
    {
	scanf("%d",&j);
	m[j-1]=1;
    }
    
    /*itoa(n,buf,10);
    l=strlen(buf);
    for(i=0; i<l; i++)
	nl.num[i]=buf[l-1-i]-'0';
    nl.l=l;*/
    ITOA(nl,n);
    //printnorm(nl);
    
    scanf("%s",buf);
    l=strlen(buf);
    for(i=0; i<l; i++)
	a.num[i]=buf[l-1-i]-'0';
    a.l=l;
    
    scanf("%s",buf);
    l=strlen(buf);
    for(i=0; i<l; i++)
	b.num[i]=buf[l-1-i]-'0';
    b.l=l;
    //mult(a,b,t1);
    //pp(t1);
    //printnorm(t1);
}

void solve()
{
    int i;
    ch.num[0]=0;
    ch.l=1;
    copy(nl,zn);
    for(i=1; i<=p; i++)
    {
	if(solvel())
	{
	    printf("%d\n",i);
	    exit(0);
	}
	mult(nl,zn,t1);
	copy(t1,zn);
	//printf("zn="); printnorm(t1);
	mult(nl,ch,t1);
	copy(t1,ch);
	//printf("ch="); printnorm(t1);
    }
    printf("0\n");
}

int main()
{
    readf();
    solve();
    return 0;
}

