#include <stdio.h>
#include <vector>
#include <iostream>
using namespace std;
#define maxN 20
#define Ost 1000003
typedef struct cut { int x,y; };
FILE *f=freopen("t.txt","w",stdout);

cut C[maxN+1];
int N,cnt,A[maxN+1][maxN+1];
vector <cut> H[Ost];

void solve();
int lexi(int x,int y);
int intersect(int c,int x,int y);
void scan();
int dist(int a,int b) { return min(b-a,N+a-b); }

int main()
{
 cin>>N;N+=2;
 solve();
 int i,j,k;
 for (i=0,k=0;i<Ost;i++)
    if (H[i].size()>0) k++;
 printf("%d\n",k);
 for (i=0;i<Ost;i++)
    if (H[i].size()>0)
       for (j=0;j<H[i].size();j++) {
          printf("%d %d",H[i][j].x,H[i][j].y);
          if (j==H[i].size()-1) printf("\n");
             else printf(" "); }
 fclose(f);
 return 0;
}

void solve()
{
 if (cnt==N-3) { scan();return; }
 int i,j,k,fl;
 for (i=1;i<N;i++)
    for (j=i+1;j<=N;j++)
       if (lexi(i,j)&&dist(i,j)>1) {
          for (fl=0,k=1;k<=cnt&&!fl;k++)
             if (intersect(k,i,j)) fl=1;
          if (!fl) {
             cnt++;
             C[cnt].x=i;
             C[cnt].y=j;
             solve();
             C[cnt].x=0;
             C[cnt].y=0;
             cnt--; } }
}

int lexi(int x,int y)
{
 if (x>C[cnt].x) return 1;
 if (x<C[cnt].x) return 0;
 return (y>C[cnt].y);
}

int intersect(int c,int x,int y)
{
 if (C[c].x==x&&C[c].y==y) return 1;
 if (C[c].x<x&&C[c].y<y&&C[c].y>x) return 1;
 if (C[c].x>x&&C[c].y>y&&C[c].x<y) return 1;
 return 0;
}

void scan()
{
 int i,j,k,P[3];
 long long key=1,nkey;
 for (i=1;i<=N;i++)
    for (j=1;j<=N;j++) A[i][j]=0;
 for (i=1;i<=cnt;i++) A[C[i].x][C[i].y]=1;
 for (i=1;i<N;i++) A[i][i+1]=1;A[1][N]=1;
 for (i=1;i<=N-2;i++)
    for (j=i+1;j<=N-1;j++)
       if (A[i][j])
          for (k=j+1;k<=N;k++)
             if (A[i][k]&&A[j][k]) {
                P[0]=dist(i,j);
                P[1]=dist(i,k);
                P[2]=dist(j,k);
                sort(P,P+3);
                nkey=P[0]*N*N+P[1]*N+P[2];
                key=(long long)(key*nkey)%Ost; }
 if (H[key].size()==0)
    for (i=1;i<=cnt;i++) H[key].push_back(C[i]);
}
