#include <stdio.h>
#include <math.h>
#include <set>
#include <vector>

#define OUT "t.out"
#define IN "t.in"

#define X first
#define Y second
#define PII pair<int,int>
#define mp make_pair
#define pb push_back

using namespace std;

vector <PII > v;

int printans();
int add(int s,int a,int b);
int remove(int t);

int rec (int A,int B) {
    if (B-A <= 2) {
       if (B-A == 2) {
          v.pb(mp(A,B));
          printans();
          v.erase(--v.end());
       } else printans();
       return 0;
    }
    for (int i=A+2; i<=B-1; i++) {
        int temp = add(A,i,B-1);

        v.pb(mp(A+1,i));
        rec(A+1,i);
        v.erase(--v.end());

        remove(temp);
    }
    return 0;
}


int main (int argc, char *argv[]) {
//    freopen(OUT,"w",stdout);
//    freopen(IN,"r",stdin);

    int A = 1;
    int B = atoi(argv[1]);
    B+=2;

    rec(A,B);
    return 0;
}

int add(int s,int a,int b) {
    int ans = 0;
    for (int i=a; i<=b; i++) {
        ans ++;
        v.pb(mp(s,i));
    }
    return ans;
}
int remove (int a) {
    for (int i=1; i<=a; i++) {
        v.erase(--v.end());
    }
}


int printans() {

    set<PII > s;
    
    for (int i=0; i<v.size(); i++) {
        if (abs(v[i].X-v[i].Y) <= 1) continue;
        s.insert(v[i]);
    }

    for (set<PII >::iterator it = s.begin(); it != s.end(); it++) {
        if (it == s.begin()) printf("%d %d",(*it).X,(*it).Y);
        else printf(" %d %d",(*it).X,(*it).Y);

    }
    printf("\n");
    
    return 0;
}


