#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define N (1<<15)
#define DIST(p1,p2) ((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y))

#define ORAREA(x1,y1,x2,y2,x3,y3) ((x1-x3)*(y2-y3)-(x2-x3)*(y1-y3))
#define ORAREA2(p1,p2,p3) ORAREA(p1.x,p1.y,p2.x,p2.y,p3.x,p3.y)

struct Point
{
    int x,y;
};

int n,m;
Point ps[N];
int ptr[N];

int compare(const void *v1, const void *v2)
{
    return ps[*((int*)v1)].y-ps[*((int*)v2)].y;
}

void readf()
{
    int i;
    scanf("%d %d",&n,&m);
    for(i=0; i<n+m; i++)
    {
        ptr[i]=i;
        scanf("%d %d",&ps[i].x,&ps[i].y);
    }
    qsort(ptr,n+m,sizeof(int),compare);
}

double opt[N];

Point l,r;

void comp(int idx)
{
    int i;
    int o1,o2;
    double d;
    l.x=0;
    l.y=0;
    r.x=100000;
    r.y=0;
    for(i=idx+1; i<n+m; i++)
    {
        d=sqrt(DIST(ps[ptr[idx]],ps[ptr[i]]));
        //printf("%lf\n",d);
        o1=ORAREA2(ps[ptr[idx]],r,ps[ptr[i]]);
        o2=ORAREA2(ps[ptr[idx]],ps[ptr[i]],l);
        if(ptr[i]>=n)
        {
            if(o1>=0) r=ps[ptr[i]];
            if(o1>=0 && o2>=0)
            {
                if(opt[i]==0 || opt[i]>opt[idx]+d) opt[i]=opt[idx]+d;
            }
        }
        else
        {
            if(o2>=0) l=ps[ptr[i]];
            if(o1>=0 && o2>=0)
            {
                if(opt[i]==0 || opt[i]>opt[idx]+d) opt[i]=opt[idx]+d;
            }
        }
    }
}

void mindless()
{
    int i;
    for(i=0; i<n; i++)
    if(ptr[i]==0) break;
    for(; i<n+m; i++)
    {
        if(ptr[i]==n+m-1)
        {
            printf("%.4lf\n",opt[i]);
            return;
        }
        comp(i);
    }
}

int main()
{
    readf();
    mindless();
    return 0;
}
