// path.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <algorithm>

using namespace std;

struct figura{
	pair<unsigned long,unsigned long> dolu;
	pair<unsigned long,unsigned long> gore;
	bool operator<(const figura& a)const{
		return dolu<a.dolu;
	}
};

const N=200;
unsigned long n,m,k;
figura mas[501];
bool karta[N][N];
bool vis[N][N];

void Read();
void Stroi();
void Opimize();
void Greedy();
bool LqvoGore(unsigned long,unsigned long);
bool Dqsno(unsigned long,unsigned long);

int main(int argc, char* argv[])
{

	Read();
	Stroi();
	Greedy();

	return 0;
}

bool Dqsno(unsigned long x,unsigned long y)
{
	if(x==n)return true;
	if(karta[x][y]==false)return false;
	if(vis[x][y]==true)return false;
	vis[x][y]=true;
	return Dqsno(x+1,y)||Dqsno(x,y+1)||Dqsno(x-1,y)||Dqsno(x,y-1);
}

bool LqvoGore(unsigned long x,unsigned long y)
{
	if(x==0||y==0)return true;
	if(karta[x][y]==false)return false;
	if(vis[x][y]==true)return false;
	vis[x][y]=true;
	return LqvoGore(x+1,y)||LqvoGore(x,y+1)||LqvoGore(x-1,y)||LqvoGore(x,y-1);
}

void Greedy()
{
	for(int i=0;i<k;i++){
		if(mas[i].dolu.second==m){
			if(LqvoGore(mas[i].dolu.first,mas[i].dolu.second)){
				cout<<-1<<endl;
				return;
			}
		}
		if(mas[i].gore.second==0){
			Dqsno(mas[i].gore.first,0);
			cout<<-1<<endl;
			return;
		}
	}
}




void Stroi()
{
	for(int i=0;i<k;i++){
		for(unsigned long y=mas[i].gore.second;y<mas[i].dolu.second;y++){
			for(unsigned long x = mas[i].dolu.first;x<mas[i].gore.first;x++){
				karta[y][x]=true;
			}
		}
	}
}


void Read()
{
	unsigned long a,b;
	cin>>n>>m>>k;
	for(int i=0;i<k;i++){
		cin>>3a>>b;
		mas[i].dolu.first = a;
		mas[i].dolu.second = m-b;
		cin>>a>>b;
		mas[i].gore.first = a;
		mas[i].gore.second = m-b;
	}
	sort(mas,mas+k);
}

