Const MAX_N = 512;

Type Dt = Int64;

Var N : Integer;
    F : Array [0..MAX_N,0..MAX_N] Of Dt;

Procedure PrintF;
  Var i, j : Integer;
  Begin
    For i := 1 To N Do
      Begin
        For j := 1 To N Do
          Write (F[i,j]:4, ' ');
        WriteLn;
      End;
  End;

Function CalcF (k, l : Integer) : Dt;
  Begin
    CalcF := F[k, l-1];
    If (l<k) and (l>0) Then
      CalcF := CalcF + F[k-l, l-1];
    If l=k Then
      CalcF := CalcF + 1;
  End;

Procedure Calc;
  Var k, l : Integer;
  Begin
    For k:=3 To N Do
      For l:=1 To N Do
        {If (k>1) Or (l>1) Then}
          F[k,l] := CalcF (k,l);
  End;

Procedure InitF;
  Var i : Integer;
  Begin
    For i:=1 To N Do
      Begin
        F[1, i] := 1;
        F[2, i] := 1;
      End;
    F[2, 1] := 0;
  End;

Begin
  ReadLn (N);
  InitF;
  //PrintF;
  //WriteLn;
  Calc;
  //PrintF;
  WriteLn (F[N, N-1]);

  //ReadLn;
End.