const
  infile = '';
 maxn = 2010; {2000!}
type
  arrint = array[0..maxn,0..maxn] of longint;
  queue = array[1..1000000] of longint;
  wayyy = array[1..3000] of record x,y : real end;
var
  f : text;
  lab : arrint;
  x,y : queue;
  way : wayyy;
  n,m,k, i,j,max,p,q : longint;
  first,last : longint;

Procedure Input;
var
  x1,y1,x2,y2 : longint;
Begin
  assign(f,infile); reset(f);
  readln(f,n,m,k);
  if n > 2000 then
    begin writeln('-1'); halt end;

  for i:=0 to m+1 do
    begin lab[i,0]:=-1; lab[i,n+1]:=-1 end;
  for i:=0 to n+1 do
    begin lab[0,i]:=-1; lab[m+1,i]:=-1 end;

  for i:=1 to k do
    begin
      readln(f,x1,y1,x2,y2);
      for p:=m-y1 downto m-y2+1 do
        for q:=x1+1 to x2 do
          lab[p,q]:=-1;
    end;
  close(f)
End;

Procedure PrintLab;
Begin
  for i:=0 to m+1 do
    begin
      for j:=0 to n+1 do write(lab[i,j]:3);
      writeln
    end;
  writeln; writeln;
End;

Procedure Wave;
var
  cur,cur_last,queue_end : longint;
  ok : boolean;

Procedure Add(p1,q1 : longint);
Begin
  ok:=true;
  inc(queue_end);
  x[queue_end]:=p1;
  y[queue_end]:=q1;
  lab[p1,q1]:=max;
End;

Begin
  max:=2;
  cur:=1; queue_end:=1; cur_last:=1;
  while cur <= queue_end do
    begin
      ok:=false;
      for i:=cur to cur_last do
        begin
          p:=x[i]; q:=y[i];
          if (lab[p,q-1] = 0) then Add(p,q-1);
          if (lab[p-1,q] = 0) then Add(p-1,q);
          if (lab[p,q+1] = 0) then Add(p,q+1);
          if (lab[p+1,q] = 0) then Add(p+1,q);
        end;

      if ok = true then inc(max);

      cur:=cur_last+1;
      cur_last:=queue_end;
    end
End;

Procedure WayBack(x,cur,x1,y1 : longint);
Begin
  if cur > 1 then
    case x of
      1 : begin
            if lab[x1,y1-1] = cur-1 then
              begin
              WayBack(1,cur-1,x1,y1-1) end
            else
              begin
                way[first].x:=x1; way[first].y:=y1; dec(first);
                if lab[x1-1,y1] = (cur-1) then WayBack(2,cur-1,x1-1,y1)
                else if lab[x1,y1+1] = (cur-1) then WayBack(3,cur-1,x1,y1+1)
                else if lab[x1+1,y1] = (cur-1) then WayBack(4,cur-1,x1+1,y1)
              end;
          end;
      2 : begin
            if lab[x1-1,y1] = cur-1 then
              WayBack(2,cur-1,x1-1,y1)
            else
              begin
                way[first].x:=x1; way[first].y:=y1; dec(first);
                if lab[x1,y1-1] = (cur-1) then WayBack(1,cur-1,x1,y1-1)
                else if lab[x1,y1+1] = (cur-1) then WayBack(3,cur-1,x1,y1+1)
                else if lab[x1+1,y1] = (cur-1) then WayBack(4,cur-1,x1+1,y1)
              end;
          end;
      3 : begin
            if lab[x1,y1+1] = cur-1 then
              WayBack(3,cur-1,x1,y1+1)
            else
              begin
                way[first].x:=x1; way[first].y:=y1; dec(first);
                if lab[x1-1,y1] = (cur-1) then WayBack(2,cur-1,x1-1,y1)
                else if lab[x1,y1-1] = (cur-1) then WayBack(1,cur-1,x1,y1-1)
                else if lab[x1+1,y1] = (cur-1) then WayBack(4,cur-1,x1+1,y1)
              end;
          end;
      4 : begin
            if lab[x1+1,y1] = cur-1 then
              WayBack(4,cur-1,x1+1,y1)
            else
              begin
                way[first].x:=x1; way[first].y:=y1; dec(first);
                if lab[x1-1,y1] = (cur-1) then WayBack(2,cur-1,x1-1,y1)
                else if lab[x1,y1+1] = (cur-1) then WayBack(3,cur-1,x1,y1+1)
                else if lab[x1,y1-1] = (cur-1) then WayBack(1,cur-1,x1,y1-1)
              end;
          end;
    end;
End;

Procedure Solve;
Begin
  {PrintLab;}

  x[1]:=m; y[1]:=1; lab[m,1]:=1;
  Wave;
  dec(max);

  {PrintLab;}

  last:=2500; first:=last;
  if lab[1,n-1] = max-1 then WayBack(1,max,1,n); {nalqvo}
  if lab[2,n] = max-1 then WayBack(2,max,1,n); {nadolu}

  writeln(last-first);
  for i:=first+1 to last do
    writeln((way[i].y-0.5):0:2,' ',m-(way[i].x-0.5):0:2);
End;

Begin
  Input;
  Solve
End.
