const
  maxk = 500;
  maxkk = maxk * 10;

type
  trect = record
    x1, y1, x2, y2 : longint;
  end;

  tvert = record
    x, y : longint;
    used : boolean;
  end;

var
  f : text;

  fl : boolean;
  i, v, n, m, k : longint;

  rect : array[1..maxk] of trect;
  vert : array[1..maxkk] of tvert;

procedure addvertex(x, y : longint);
var p : byte;
begin
  for p:=1 to v do if (vert[p].x=x)and(vert[p].y=y) then exit;
  inc(v);
  vert[v].x:=x;
  vert[v].y:=y;
end;

function inrect(x, y : longint) : boolean;
var p : word;
begin
  inrect:=false;
  for p:=1 to k do
    if p<>i then
    if (x>=rect[p].x1)and(x<rect[p].x2)and(y>=rect[p].y1)and(y<rect[p].y2) then
      begin inrect:=true; break; end;
end;

function min(a, b : longint) : longint;
begin if a<b then min:=a else min:=b; end;

function max(a, b : longint) : longint;
begin if a>b then max:=a else max:=b; end;

var
  ax, ay, bx, by : longint;

function interact(a, b : word) : boolean;
var p : word;
begin
  ax:=min(vert[a].x, vert[b].x);
  bx:=max(vert[a].x, vert[b].x);
  ay:=min(vert[a].y, vert[b].y);
  by:=max(vert[a].y, vert[b].y);
  interact:=false;
  for p:=1 to k do
  begin
    dec(rect[p].x2);
    dec(rect[p].y2);
    if (rect[p].x1<=bx)and(rect[p].y2>=ay)and
       (rect[p].y1<=by)and(rect[p].x2>=ax) then
       begin interact:=true; inc(rect[p].x2);
                             inc(rect[p].y2);break; end;

    inc(rect[p].x2);
    inc(rect[p].y2);
  end;
end;

var
  found : boolean;
  l, kfor : word;
  path : array[1..maxkk] of word;

procedure dfs(vx : word);
var p : word;
begin
  inc(l);
  if l > kfor then begin dec(l); exit; end;
{  write(vert[vx].x, ' ',vert[vx].y);
  readln;}
  vert[vx].used:=true;
  path[l]:=vx;
  if not interact(vx, 2) then
  begin
    found:=true; inc(l);
    path[l]:=2; exit;
  end;
  for p:=3 to v do
    if not vert[p].used then
      if not interact(vx, p) then
      begin
        dfs(p);
        if found then exit;
      end;
  dec(l);
end;

begin
  assign(f, '');
  reset(f);
  readln(f, n, m, k);
  for i:=1 to k do
  begin
    readln(f, rect[i].x1, rect[i].y1, rect[i].x2, rect[i].y2);
  end;
  close(f);

  addvertex(0, 0);
  addvertex(n-1, m-1);

  dec(n); dec(m);
  for i:=1 to k do
    with rect[i] do
    begin
      dec(y2); dec(x2);
      {up-left}
      fl:=false;
      if (y2 < m)and(x1 > 0) then
        if not inrect(x1-1, y2+1) then begin addvertex(x1-1, y2+1); fl:=true; end;
      if (y2 < m)and(not fl) then
        if not inrect(x1, y2+1) then begin addvertex(x1, y2+1); fl:=true; end;
      if (x1 > 0)and(not fl) then
        if not inrect(x1-1, y2) then begin addvertex(x1-1, y2); fl:=true; end;

      {up-right}
      fl:=false;
      if (y2 < m)and(x2 < n) then
        if not inrect(x2+1, y2+1) then begin addvertex(x2+1, y2+1); fl:=true;end;
      if (y2 < m)and(not fl) then
        if not inrect(x2, y2+1) then begin addvertex(x2, y2+1); fl:=true;end;
      if (x2 < n)and(not fl) then
        if not inrect(x2+1, y2) then begin addvertex(x2+1, y2); fl:=true;end;

      {down-right}
      fl:=false;
      if (y1 > 0)and(x2 < n) then
        if not inrect(x2+1, y1-1) then begin addvertex(x2+1, y1-1); fl:=true;end;
      if (y1 > 0)and(not fl) then
        if not inrect(x2, y1-1) then begin addvertex(x2, y1-1); fl:=true;end;
      if (x2 < n)and(not fl) then
        if not inrect(x2+1, y1) then begin addvertex(x2+1, y1); end;

      {down-left}
      fl:=false;
      if (y1 > 0)and(x1 > 0) then
        if not inrect(x1-1, y1-1) then begin addvertex(x1-1, y1-1); fl:=true;end;
      if (y1 > 0)and(not fl) then
        if not inrect(x1, y1-1) then begin addvertex(x1, y1-1); fl:=true;end;
      if (x1 > 0)and(not fl) then
        if not inrect(x1-1, y1) then begin addvertex(x1-1, y1); end;

      inc(y2); inc(x2);
    end;

  inc(n); inc(m);
  kfor:=k * 4;
{  writeln;
  for i:=1 to v do writeln(vert[i].x, ' ', vert[i].y);}

  dfs(1);

  if found then
  begin
    writeln(l-1);
    for i:=2 to l do writeln((vert[path[i]].x+0.50):0:2, ' ', (vert[path[i]].y+0.50):0:2);
  end else writeln(-1);
end.