#include <stdio.h>

//#define M_DEB
/*
class BigNum{
public:
	BigNum(){
		l = 1;
		nums[0] = 0;
	}

	BigNum(const BigNum& bn){
		l = bn.l;
		for (int i = 0; i < l; ++i){
			nums[i] = bn.nums[i];
		}
	}

	BigNum(int a){
		nums[0] = a;
		l = 1;
	}

	void operator+=(const BigNum& a){
		unsigned char over = 0;
		int end = l > a.l ? a.l : l;
		
		for (int i = 0; i < end; ++i){
			nums[i] += a.nums[i] + over;
			over = nums[i] / 10;
			nums[i] = nums[i] % 10;
		}

		while(over && end <= l){
			if (end == l){
				nums[end] = over;
				++l;
				over = 0;
			}
			else{
				nums[end] += over;
				over = nums[end] / 10;
				nums[end] = nums[end] % 10;
				++end;
			}
		}
	}

	void show(){
		for (int i = l - 1; i >= 0; --i){
			int a = nums[i];
			printf("%d", a);
		}
	}

private:
	unsigned char nums[50];
	int l;
};
*/
typedef unsigned long type;

type a[501][501];

int n;

int main(){
	scanf("%d", &n);
	int i, j, k;
	a[1][0] = 0;
	a[0][0] = 1;
	
	for (i = 1; i <= n; ++i){
		a[0][i] = 1;
		a[1][i] = 1;
		for (j = 2; j <= n; ++j){
			a[j][0] = 0;
			a[j][1] = 0;
		}
	}

	//calculates a[i][j]
	for (i = 2; i <= n; ++i){
		for (j = 2; j <= n; ++j){
			if (j == i){
				a[i][j] = a[i][j - 1];
				a[i][j] += 1;
				continue;
			}
			
			if (j > i){
				a[i][j] = a[i][j - 1];
				continue;
			}

			type s = 0;
			for (k = j; k > 0; --k){
				s += a[i - k][k - 1];
			}

			a[i][j] = s;
/*#ifdef M_DEB
			printf("a[%d][%d] = ", i, j);
			a[i][j].show();
			printf("\n");
#endif*/
		}
	}
	
	/*a[n][n - 1].show();*/
	printf("%u\n", a[n][n - 1]);
	return 0;
}