#include<stdio.h>
#define MAX 500
#define LEN 20
#define BASE 200
int N;
class bigint {
   private:
      int carry[LEN];
   public:
      bigint() {
         for (int i=0;i<LEN;i++) carry[i]=0;
      }
      bigint(unsigned long x) {
       int m=x;
       int c=0;
         for (int i=0;i<LEN;i++) carry[i]=0;
         while (m>0) {
            carry[c]=m%BASE;
            m=m/BASE;
            c++;
         }
      }

      void append(bigint x) {
         for (int t=0;t<LEN;t++) {
            if (carry[t]+x.carry[t]>BASE) {
               carry[t+1]++;
            }
            carry[t]=(carry[t]+x.carry[t])%BASE;
         }
      }
      bigint& operator+(bigint n) {
         append(n);
         return *this;
      }
      bigint& operator-(bigint n) {
         for (int t=0;t<LEN;t++) {
            if (carry[t]<n.carry[t]) {
               if (carry[t+1]>0) {
                  carry[t+1]--;
                  carry[t]=(BASE-n.carry[t]+carry[t])%BASE;
               } else {
                  carry[t]=0;
               }
            } else {
               carry[t]=(BASE-n.carry[t]+carry[t])%BASE;
            }
         }
         return *this;
      }
};

unsigned long arr[MAX][MAX];
unsigned long ans[MAX];

int solve(int r) {
 int h=r-1;
 	if(r==3) {
		arr[1][3]=1;
		ans[r]=2;
		return -1;
	}
	solve(h);
   int i;
	for(i=1;i<=h/2;i++)
	{
		arr[i][r]=ans[r-i];
		for(int j=1;j<=i;j++) {
		   arr[i][r]=arr[i][r]-arr[j][r-i];
      }
		ans[r]=ans[r]+arr[i][r];
	}
	ans[r]=ans[r]+1;
}

int main() {
   scanf("%d",&N);
   //init
   for (int i=0;i<=N;i++) arr[i][i]=1;
   solve(N);
   ans[N]=ans[N]-1;
   printf("%lu",ans[N]);
   return 0;
}

