#include <stdio.h>
#include <stdlib.h>

#define MAXK 512

typedef struct nodes
{      int mate;
//       int lenght;
       struct nodes * next;
} node;

long double pos[2][4*MAXK];
long double k[2][4][MAXK];
node beg[4*MAXK];
node * cur[4*MAXK];
node * now;
int mates[4*MAXK];
int waiting[4*MAXK];
int visited[4*MAXK];
int father[4*MAXK];
int final[4*MAXK];

int N,M,K,br;
int start,end;

int orient(long double x1,long double y1,long double x2,long double y2,long double x3,long double y3)
{   return x1*y3-x1*y2+x2*y1-x2*y3-x3*y1+x3*y2;
}

int crossing(long double x11,long double y11,long double x12,long double y12,
             long double x21,long double y21,long double x22,long double y22)
{   if ( (orient(x21,y21,x22,y22,x11,y11)*orient(x21,y21,x22,y22,x12,y12)) <1)
       if ((orient(x11,y11,x12,y12,x21,y21)*orient(x11,y11,x12,y12,x22,y22))<1)
          return 1;
    return 0;
}

int main(int argc, char *argv[])
{   int i,j,OK,h,g;
    //freopen("input.txt","r",stdin);
    scanf("%d %d %d",&N,&M,&K);
    br=1;
    for (i=0;i<K;i++)
    {   scanf("%Lf %Lf %Lf %Lf",&k[0][0][i],&k[1][0][i],&k[0][2][i],&k[1][2][i]);
        k[0][1][i]=k[0][2][i];
        k[1][1][i]=k[1][0][i];
        k[0][3][i]=k[0][0][i];
        k[1][3][i]=k[1][2][i];
        for (j=0;j<4;j++)
        {   pos[0][br]=k[0][j][i]-0.5+(j==1)+(j==2);
            pos[1][br]=k[1][j][i]-0.5+(j>1);
            if ( (0<pos[0][br]) && (pos[0][br]<N) && (0<pos[1][br]) && (pos[1][br]<M) )
               br++;
        }
        
        //br=4*i;
    }
    br=br+1;
    pos[0][br-1]=N;
    pos[1][br-1]=M;
    for (i=0;i<br;i++)
        for (j=i+1;j<br;j++)
        {   OK=1;
            /*if ( (i==0) && (j==6) )
               OK=1;*/
            for (h=0;h<K;h++)
            {   for (g=0;g<4;g++)
                    if (crossing(pos[0][i],pos[1][i],pos[0][j],pos[1][j],/**/
                       k[0][g][h],k[1][g][h],k[0][(g+1)%4][h],k[1][(g+1)%4][h]))
                    {  OK=0;
                       break;
                    }
                if (OK==0) break;
            }
            if (OK)
            {  if (mates[i]==0) cur[i]=&beg[i];
               else
               {   cur[i]->next=(node *)malloc(sizeof(node));
                   cur[i]=cur[i]->next;
               }
               cur[i]->mate=j;
               mates[i]++;
               if (mates[j]==0) cur[j]=&beg[j];
               else
               {   cur[j]->next=(node *)malloc(sizeof(node));
                   cur[j]=cur[j]->next;
               }
               cur[j]->mate=i;
               mates[j]++;
            }
        }
    //BFS
    OK=0;
    end=1;
    visited[0]=1;
    for (i=0;i<end;i++)
    {   if (waiting[i]==br-1)
        {  OK=1;
           break;
        }
        now=&beg[waiting[i]];
        for (j=0;j<mates[waiting[i]];j++)
        {   if (visited[now->mate]==0)
            {  waiting[end]=now->mate;
               father[now->mate]=waiting[i];
               visited[now->mate]=1;
               end++;
            }
            now=now->next;
        }
    }
    
    if (OK)
    {  final[0]=br-1;
       for (i=1;;i++)
       {   final[i]=father[final[i-1]];
           if (final[i]==0)
              break;
       }
       i--;
       printf("%d\n",i);
       for (j=i;j>0;j--)
       {   printf("%Lf %Lf\n",pos[0][final[j]],pos[1][final[j]]);
       }

    }
    else printf("-1\n");
    return 0;
}
