#include <Stdio.h>
#include <Stdlib.h>

#define K 1024

int n,m,k;
int rects[K][4];

int lx,ly;
int listX[K],listY[K];
int field[K][K];

int pn;
int ps[8*K][2];

#define UP 0
#define LEFT 1
#define DOWN 2
#define RIGHT 3

void modDir(int x, int y, int &d)
{
	while(1)
	{
		d = (d+1)%4;
		if(d==UP)
		{
			if( field[x][y+1]==1 && field[x-1][y]==2 )
			{
				break;
			}
		}
		if(d==LEFT)
		{
			if( field[x-1][y]==1 && field[x][y-1]==2 )
			{
				break;
			}
		}
		if(d==DOWN)
		{
			if( field[x][y-1]==1 && field[x+1][y]==2 )
			{
				break;
			}
		}
		if(d==RIGHT)
		{
			if( field[x+1][y]==1 && field[x][y+1]==2 )
			{
				break;
			}
		}
	}
	if(x==ps[pn-1][0]&&y==ps[pn-1][1]) return;
	ps[pn][0]=x;
	ps[pn][1]=y;
	pn++;
}

void move(int &x, int &y, int &d)
{
	int mx,my;
	mx=0,my=0;
	if(d==UP) my=1;
	if(d==DOWN) my= -1;
	if(d==LEFT) mx= -1;
	if(d==RIGHT) mx= 1;
	while( field[x+mx][y+my]==1 )
	{
		mx=0,my=0;
		if(d==UP) my=1;
		if(d==DOWN) my= -1;
		if(d==LEFT) mx= -1;
		if(d==RIGHT) mx= 1;
		x+=mx;
		y+=my;
	}
}

void findPath()
{
	int x=1,y=1;
	int d = UP;
	ps[pn][0]=1;
	ps[pn][1]=1;
	pn++;
	while( x!= lx && y!= ly )
	{
	}
}

void readf()
{
	int i;
	scanf("%d %d %d",&n,&m,&k);
	for(i=0; i<k; i++)
	{
		scanf("%d %d %d %d"
			,&rects[i][0],&rects[i][1],&rects[i][2],&rects[i][3]);
	}
}

int *i1, *i2;
int compare( const void* v1, const void *v2)
{
	i1=(int*)v1;
	i2=(int*)v2;
	return (*i1) - (*i2);
}

void fX()
{
	int i,j;
	for(i=0; i<k; i++)
	{
		listX[lx++] = rects[i][0];
		listX[lx++] = rects[i][2];
	}
	listX[lx++]=0;
	listX[lx++]=1;
	qsort(listX,lx,sizeof(int),compare);
	i=1,j=1;
	for(; j<lx; j++)
	{
		if(listX[j]!=listX[i-1])
		{
			listX[i++] = listX[j];
		}
	}
	lx=i;
}

void fY()
{
	int i,j;
	for(i=0; i<k; i++)
	{
		listY[ly++] = rects[i][1];
		listY[ly++] = rects[i][3];
	}
	listY[ly++]=0;
	listY[ly++]=1;
	qsort(listY,ly,sizeof(int),compare);
	i=1,j=1;
	for(; j<ly; j++)
	{
		if(listY[j]!=listY[i-1])
		{
			listY[i++] = listY[j];
		}
	}
	ly=i;
}

void paint( int x1, int y1, int x2, int y2 )
{
	int i,j;
	for(i=0; i<lx; i++)
	{
		if(x1==listX[i])
		{
			x1=i;
			break;
		}
	}
	for(; i<lx; i++)
	{
		if(x2==listX[i])
		{
			x2=i;
			break;
		}
	}
	for(i=0; i<ly; i++)
	{
		if(y1==listY[i])
		{
			y1=i;
			break;
		}
	}
	for(; i<ly; i++)
	{
		if(y2==listY[i])
		{
			y2=i;
			break;
		}
	}
	for(i=x1+1; i<x2+1; i++)
	{
		for(j=y1+1; j<y2+1; j++)
		{
			field[i][j] = 2;
		}
	}
}

void buildField()
{
	int i,j;
	fX();
	fY();
	for(i=0; i<k; i++ )
	{
		paint(rects[i][0], rects[i][1], rects[i][2], rects[i][3]);
	}
	for(i=0; i<K; i++)
	{
		field[0][i]=2;
		field[i][0]=2;
		field[lx][i]=2;
		field[i][ly]=2;
	}
}

int q[K*K][2],r,w;
int isImossible()
{
	int x,y;
	if(field[1][1])return 1;
	field[1][1]=1;
	q[0][0]=1;
	q[0][1]=1;
	w=1;
	while(r<w)
	{
		x=q[r][0];
		y=q[r][1];
		if(!field[x][y+1])
		{
			field[x][y+1]=1;
			q[w][0]=x;
			q[w][1]=y+1;
			w++;
		}
		if(!field[x][y-1])
		{
			field[x][y-1]=1;
			q[w][0]=x;
			q[w][1]=y-1;
			w++;
		}
		if(!field[x+1][y])
		{
			field[x+1][y]=1;
			q[w][0]=x+1;
			q[w][1]=y;
			w++;
		}
		if(!field[x-1][y])
		{
			field[x-1][y]=1;
			q[w][0]=x-1;
			q[w][1]=y;
			w++;
		}
		r++;
	}
	return 0;
}

int main()
{
	readf();
	buildField();
	if( isImossible() )
	{
		printf("-1\n");
		return 0;
	}
	//findPath();
	return 0;
}
