program subseq;

const
	MAXN				= 500;

type
	Integer				= LongInt;

var
	F				: Array [0 .. MAXN, 0 .. MAXN] of Int64;
	N				: Integer;
	i, j				: Integer;

procedure readInput;
begin
	readln(N);
end;

procedure Init;
begin
	for i := 0 to N do
		for j := 0 to N do	
			F[i, j] := 0;
        for i := 0 to N do
        	F[0, i] := 1;
	for i := 1 to N do
        	F[1, i] := 1;
end;

procedure Solve;
begin
	for i := 2 to N do begin
        	j := 1;
                while (j <= i) do begin
			F[i, j] := F[i, j-1] + f[i-j, j-1];
                        j := j + 1;
                end;
                while (j <= N) do begin
                	F[i, j] := F[i, j-1];
                        j := j + 1;
                end;
        end;
end;

procedure writeOutput;
begin
	writeln(F[N, N-1]);
end;

begin
	readInput;
	Init;
	Solve;
	writeOutput;
end.