program Plate;
var
  a,b,c, M, N, K, S, removed : integer;
  Change            : boolean;
  left,right,rem    : array[1..100,1..100] of integer;
  PathsA,PathsB     : array[1..100] of integer;

{ *** function to check if the plate is good *** }
function Ready:boolean;
var
  a:integer;
  ret:boolean;
begin
  ret:=true;
  for a:=1 to M do
    if ((PathsA[a]<>2) OR (PathsB[a]>1)) then
    begin
      ret:=false; break;
    end;
  Ready:=ret;
end;

{ *** procedure to delete link to max linked dot *** }
procedure DelMax(p:integer);
var
  a,b,max,r,rpos:integer;
begin
  max:=0; r:=0; rpos:=0;
  for a:=1 to N do
  if Left[p,a]=1 then
    if ((PathsB[a]>max) and (rem[p,a]=0)) then begin max:=PathsB[a]; rpos:=a; end;

  rem[p,rpos]:=1;
  Dec(PathsA[p]);
  Dec(PathsB[rpos]);
  inc(removed);
end;

{ *** main code *** }
begin
readln(M,N,K);
S:=0;

for a:=1 to 100 do
begin
  PathsA[a]:=0;
  PathsB[a]:=0;
  for b:=1 to 100 do
  begin
    left[a][b]:=0;
    right[a][b]:=0;
    rem[a][b]:=0;
  end;
end;

for a:=1 to K do
begin
  readln(b,c);
  left[b][c]:=1;
  right[c][b]:=1;
  Inc(PathsA[b]);
  Inc(PathsB[c]);
end;

if Ready then
  writeln('0')
else
begin
  for a:=1 to M do
    if PathsA[a]<2 then begin writeln('NO'); exit; end;
  Change:=true;
  while (not Ready) do
  begin
    if Change=false then break;
    Change:=false;
    for a:=1 to M do
    if PathsA[a]>2 then
    begin
      DelMax(a);
      Change:=true;
    end;
  end;
end;
if Ready then
begin
  writeln(removed);
  for a:=1 to 100 do
  for b:=1 to 100 do
  if Rem[a,b]=1 then Writeln(a,' ',b);
end
else
  writeln('NO');
end.