#include <cstdio>
#include <cstdlib>

#define MAXN 110
#define MAXK 5000
#define NO_SOLUTION {printf("NO\n"); return;}

using namespace std;

typedef struct node{
        int need;
        int out;
}node;

typedef struct rib{
        int start;
        int end;
}rib;

int a[MAXN+1][MAXN];
node b[MAXN];
rib c[MAXK];
int M, N, K;
int pos;

void readInput(void);
void solve(void);
int cmp(const void *a, const void *b);

int main()
{
 readInput();
 solve();
 return 0;
}

void readInput(void)
{
 int _start, _end;

 //freopen("in.in", "rt", stdin);
 scanf("%d%d%d", &M, &N, &K);
 for(int i =0; i<K; i++)
 {
  scanf("%d%d", &_start, &_end);
  a[_start][_end] = 1;
  a[M+1][_end]++;
  b[_start].out++;
  b[_start].need = 2;
 }
}

void solve(void)
{
 if(N<M*2) NO_SOLUTION
 if(K<M*2) NO_SOLUTION
 int i, j, min;

 for(i=1; i<=N; i++)
 {  for(j=1, min = 0; j<=M; j++)
       if(a[j][i] == 1)
          min++;
    if(min == 1)
     for(j=1; j<=M; j++)
      if(a[j][i] == 1)
      {
        b[j].need--;
        b[j].out--;
        a[j][i] = 0;
      }
 }

 while(1)
 {
  min = 1;
  for(i=1; i<=M; i++)
   if(b[i].need!=0)
   {
    min = i;
    break;
   }
  for(i=1; i<=M; i++)
  {
      if(b[i].out < b[min].out && b[i].need)
          min = i;
  }
  if(b[min].need == 0) break;
  while(b[min].need!=0)
  {
   for(i=1; i<=N&b[min].need; i++)
    if(a[min][i] == 1)
    {
     a[min][i] = 0;
     b[min].need--;
     b[min].out--;
     for(j=1; j<=M; j++)
      if(a[j][i] == 1)
      {
       a[j][i] =0;
       c[pos].start = j;
       c[pos++].end = i;
       b[j].out--;
      }
    }
  }
  if(b[min].out)
  {
   for(i=1; i<=N; i++)
     if(a[min][i] == 1)
     {
     a[min][i] = 0;
     b[min].out--;
     c[pos].start = min;
     c[pos++].end = i;
     }
  }
 }
 qsort(c, pos, sizeof(rib), cmp);
 printf("%d\n", pos);
 for(i=0; i<pos; i++)
 {
  printf("%d %d\n", c[i].start, c[i].end);
 }
 return;
}

int cmp(const void *a, const void *b)
{
 rib *c, *d;
 c = (rib *)a;
 d = (rib *)b;
 if(c->start < d->start) return -1;
 if(c->start > d->start) return 1;
 if(c->end <d->end) return -1;
 return 1;
}
