/*
TASK: mirrors
LANG: C++
*/

#include <cstdio>

#include "module.h"
#define MAXP	128*4

int n, m, p;
int mirrors[6], states[6], romeo, juliet, num;
int Rmirr[MAXP][3], Rnum[MAXP], Rused[MAXP];
int Jmirr[MAXP][3], Jnum[MAXP], Jused[MAXP];
int mirrors_used[MAXP];

void rec2(int curr)
{
	int i;

	if(curr==num)
	{
		getView(num, mirrors, states, &romeo, &juliet);
		return;
	}

	for(i=0; i<3; i++)
	{
		states[curr]=i;
		rec2(curr+1);
	}
}

void find_answer(int pos)
{
	int i;

	for(i=0; i<Rnum[pos]; i++)
		mirrors_used[Rmirr[pos][i]]=1;
	for(i=0; i<Jnum[pos]; i++)
		mirrors_used[Jmirr[pos][i]]=1;

	for(i=0; i<p; i++)
		if(mirrors_used[i])
			mirrors[num++]=i;

	//printf("Second recursion entered!\n");

	rec2(0);
}

void rec(int curr_mirr, int next_mirr)
{
	int i, j;

	getView(curr_mirr, mirrors, states, &romeo, &juliet);

	Rused[romeo]=1;
	Rnum[romeo]=curr_mirr;
	for(i=0; i<curr_mirr; i++)
		Rmirr[romeo][i]=mirrors[i];

	Jused[juliet]=1;
	Jnum[juliet]=curr_mirr;
	for(i=0; i<curr_mirr; i++)
		Jmirr[juliet][i]=mirrors[i];

	if(Jused[romeo])
		find_answer(romeo);

	if(Rused[juliet])
		find_answer(juliet);

	if(curr_mirr==3 || next_mirr==p)
		return;

	for(i=next_mirr; i<p; i++)
		for(j=0; j<3; j++)
		{
			mirrors[curr_mirr]=i;
			states[curr_mirr]=j;
			rec(curr_mirr+1, i+1);
		}
}

int main()
{
	init();

	n=getN();
	m=getM();
	p=getP();

	rec(0, 0);

	return 0;
}
