/*
TASK:reliab
LANG:C++
*/
#include <stdio.h>
#include <time.h>
#include <math.h>
#include <map>


#define IN "reliab.in"
#define OUT "reliab.out"
#define LL long long

using namespace std;

unsigned _stklen  = (1024)*(1024)*26;
LL l,r,N,H;
LL mid;

map <pair<LL,LL>,LL> M;
map <pair<LL,LL>,LL>::iterator it;

int solve (LL h,LL n, LL m) {
//    LL k = 1;
    if (sqrt(h) <= n && m>=n) return 1;
    if (h <= m) return 1;
    if (n == 1) {
       if (h <= m);
       return 0;
    }
    it = M.find(make_pair(h,n));
    if (it != M.end()) {
       if ((*it).second >= m) return 1;
       else return 0;
    }

    LL l = 1;
    LL r = h;
    LL mid;
    while (r != l) {
          mid = (r+l)/2;
          if (!(mid*(mid+1)/2 >= h && solve(mid-1,n-1,m-1))) {
             r = mid;
          } else {
             l = mid+1;
          }
          if (clock() > 0.85*CLOCKS_PER_SEC) break;
    }
    M[make_pair(h,m)] = l;
    if (l*(l-1)/2 >= h) return 1;
    else return 0;
    
 /*   while (solve(k-1,n-1,m-1)) {
          if (k * (k+1)/2 >=h ) return 1;
          k++;
    }*/
}

int main () {
//    freopen(IN,"r",stdin);
//    freopen(OUT,"w",stdout);
    clock();
    scanf("%lld%lld",&N,&H);
    
    l = 1;
    r = H;
    while (l != r) {
          mid = (l+r)/2;
          if (solve(H,N,mid)) {
             r = mid;
          } else {
            l = mid + 1;
          }
    }
    printf ("%lld\n",l);
}
