/*
TASK:oper
LANG:C++
*/

#include <iostream>
using namespace std;
#define maxN 30
#define maxM 100

bool F[maxN+1][maxN+1][maxM+1],Viz[maxN+1][maxN+1];
int N,K,A[maxM+1][maxM+1],P[maxN+1];

void init();
void solve(int h,int e);

int main()
{
 init();
 solve(1,N);
 int rez=0;
 for (int br=1;br<=K;br++)
    if (F[1][N][br]) rez++;
 cout<<rez<<endl;
 return 0;
}

void init()
{
 int i,j;
 cin>>K;
 for (i=1;i<=K;i++)
    for (j=1;j<=K;j++) cin>>A[i][j];
 cin>>N;
 for (i=1;i<=N;i++) cin>>P[i];
 for (i=1;i<=N;i++) { F[i][i][P[i]]=true;Viz[i][i]=1; }
}

void solve(int h,int e)
{
 Viz[h][e]=1;
 if (h+1==e) {
    F[h][e][A[P[h]][P[e]]]=true;
    return; }
 int i,j,k;
 for (k=h;k<e;k++) {
    if (!Viz[h][k]) solve(h,k);
    if (!Viz[k+1][e]) solve(k+1,e);
    for (i=1;i<=K;i++)
       for (j=1;j<=K;j++)
          if (F[h][k][i]&&F[k+1][e][j])
             F[h][e][A[i][j]]=true; }
}
