/*
TASK:reliab
LANG:C++
*/

#include <iostream>
using namespace std;
#define maxBalls 35
#define maxProb 150000
long long H,F[maxBalls][maxProb];
int N;

int binlog(long long Num);
void solve();

int main()
{
 cin>>N;
 cin>>H;
 int C=binlog(H+1);
 if (C<=N) { cout<<C<<endl;return 0; }
 if (N==1) { cout<<H<<endl;return 0; }
 solve();
 for (int bci=1;bci<maxProb;bci++)
    if (F[N][bci]>H) { cout<<bci<<endl;return 0; }
 return 0;
}

int binlog(long long Num)
{
 int res;
 long long i;
 for (i=2,res=1;i<Num;i*=2,res++);
 return res;
}

void solve()
{
 int i,j;
 for (i=1;i<maxBalls;i++) F[i][1]=2;
 for (j=1;j<maxProb;j++) F[1][j]=j+1;
 for (j=2;j<maxProb;j++)
    for (i=2;i<=N;i++)
       F[i][j]=F[i-1][j-1]+F[i][j-1];
}
