/*
TASK:present
LANG:C++
 */
#include <stdio.h>
#include <queue>
#include <vector>
using namespace std;

typedef long long LLONG;

struct comp
{
    bool operator() (LLONG x, LLONG y) const
    {
	return x>y;
    }
};

typedef priority_queue < LLONG, vector<LLONG>, comp > Heap;

LLONG a,b,c,t,l,gf,cnt;
Heap heap;

void stupid()
{
    l = -2;
    heap.push(0);
    while(heap.size())
    {
	t = heap.top();
	heap.pop();
	if(t>c)
	{
	    gf=c;
	    break;
	}
	if(t==l) continue;
	if(t-l>1)
	{
	    gf=t-1;
	    cnt=1;
	}
	else
	{
	    cnt++;
	    if(cnt==a) break;
	}
	if(t==c) break;
	l=t;
	heap.push(t+a);
	heap.push(t+b);
	//exectime();
    }
}

LLONG evklid(LLONG l1, LLONG l2)
{
    if(l1<l2)
    {
	t=l1;
	l1=l2;
	l2=t;
    }
    while(l1%l2)
    {
	t=l2;
	l2=l1%l2;
	l1=t;
    }
    return l2;
}

void moreStupid()
{
    LLONG res,r;
    if( a==1 || b==1 )
    {
	printf("-1\n");
	exit(0);
    }
    res=evklid(a,b);
    if(res>1)
    {
	r=c%res;
	if(r)
	{
	    printf("%lld\n",c);
	    exit(0);
	}
	else
	{
	    printf("%lld\n",c-1);
	    exit(0);
	}
    }
}

int main()
{
    scanf("%lld %lld %lld",&a,&b,&c);
    if( a>b )
    {
	t=a;
	a=b;
	b=t;
    }
    moreStupid();
    stupid();
    printf("%lld\n",gf);
    return 0;
}

