/*
TASK:perm
LANG:C++
*/
#include <iostream>
#include <cstdlib>
#include <algorithm>
#include <ctime>
using namespace std;

#define max(a,b) ((a)>(b)?(a):(b))



using namespace std;
typedef char BigNum[100];

BigNum x;
void Dec2Big(int d,BigNum T) {
	int b=0;
    while(d)
    {
      T[++b] = d%10;
      d/=10;
    }
    T[0] =b;
}

void PrintB(BigNum T) {
     int i;
     for(i=T[0]; i>=1; i--) cout << (int)T[i];
     //cout << endl;
}

void AddBig(BigNum X, BigNum Y, BigNum Z) {
	int i,j;
    int m=max(X[0],Y[0]);
    if(X[0]>Y[0])  	for(i=Y[0]+1; i<=X[0]; i++) Y[i]=0;
    if(Y[0]>X[0])  	for(i=X[0]+1; i<=Y[0]; i++) X[i]=0;
    int Ost = 0;
    for(i=1; i<=m; i++)
    {
        int T = X[i]+Y[i]+Ost;
        Z[i]= T%10;
        Ost = T/10;
    }
    while(Ost)
    {
      Z[i++] = Ost%10;
      Ost/=10;
    }
    Z[0] = i-1;

}

BigNum F[64][64];
int N;
int A[64];
int P[64];
int Used[64];
int Cnt;

void Init(void) {
	int i;
    cin >> N;
	//scanf("%d",&N);
    for(i=1; i<=N; i++)
    {
    	cin >> A[i];
		//scanf("%d",&A[i]);
    }
}

int Check() {
	int i,j,k;
    for(i=1; i<=N; i++)
    	for(j=i+1; j<=N; j++)
        	for(k=j+1; k<=N; k++)
            	if(A[i]>A[j] && A[j]>A[k]) return 0;
	return 1;
}

void Print(void) {
	int i;
    for(i=1; i<N; i++)
    {
    	cout << A[i] << " ";
    }
    cout << A[N];
    cout << endl;
}

int NextPermutation(int P[]) {
	int Used[64];
	int i,j;
    for(i=1; i<=N; i++) Used[i]=0;
    for(i=N; i>=2; i--)
    {
        if(P[i]>P[i-1]) break;
        Used[P[i]]=1;
    }    
    if(i==1) return 1;

    Used[P[i-1]]=1;
    P[i-1] = P[i];
    
    for(j=1; j<=N; j++) if(Used[j]) P[i++] = j;
    return 0;
}

void Perm(int x) {
      int i;
      if(x==N+1)
      {
      	if(Check()) { Cnt++; /*Print();*/ }
      	return;
      }
      for(i=1; i<=N; i++)
      	if(Used[i]==0)
        {
        	Used[i]=1;
            P[x] = i;
            Perm(x+1);
            Used[i]=0;
        }
}

void Solve(void) {
	int i,j,k;
    Dec2Big(1,F[3][0]);
    Dec2Big(2,F[3][1]);
	Dec2Big(2,F[3][2]);
    /*F[3][0]=1;
    F[3][1]=2;
    F[3][2]=2;*/
    for(i=4; i<=N; i++)
    {
    	Dec2Big(1,F[i][0]);
    	//F[i][0] = 1;
    	for(j=1; j<i; j++)
        {
           // F[i][j] = F[i-1][j]*(i-j+1);
            for(k=0; k<=j; k++) AddBig(F[i][j],F[i-1][k],F[i][j]);// F[i][j]+=F[i-1][k];
        }
        //for(j=0; j<i; j++) F[i][j]+=F[i-1][j];
    }
//    long long Br=0;
	BigNum Br;
    Dec2Big(0,Br);
    for(i=0; i<=N; i++) AddBig(Br,F[N][i],Br);//Br+=F[N][i];

    /*for(i=3; i<=N; i++)
    	for(j=0; j<=i; j++)
            printf("F[%d][%d]=%ld\n",i,j,F[i][j]);*/

   	PrintB(Br);
    cout << endl;
//    Print();
	int flag=0;
	while(1)
    {
    	if(NextPermutation(A))  break;
        //Print(); cout << endl;
        if(Check()) { flag=1; break; }
        if((double)clock()/(double)CLOCKS_PER_SEC>=0.9) break;
        //if(exectime()>0.9) break;
    }
    if(flag==0)
    {
    	for(i=1; i<=N; i++) A[i]=i;
    }
   	Print();
}


int main(void) {
	clock();
	/*BigNum T;
    BigNum T1;
    BigNum T2;*/
    Init();
    int a,b;
    /*cin >> a >> b;
    Dec2Big(a,T);
    Dec2Big(b,T1);
    AddBig(T,T1,T2);
    
    PrintB(T);cout<<"+";PrintB(T1);cout<<"=";PrintB(T2);*/

    Solve();
   // Perm(1);
    //printf("%d\n",Cnt);
	return 0;
}
