{Baicu Ciprian}

{prezentarea algoritmului:
   Sa presupunem ca datele de intrare le citim din fisierul "amestec.in" sub
forma:
    n
    a1 b1 c1
    a2 b2 c2
    .
    .
    .
    an bn cn
    d1 d2 d3
   Trebuie sa aflam daca exista n numere naturale x1,x2,...,xn astfel incat
luand amestecul 1 in proportie de x1,amestecul 2 in proportie de x2,s.a.m.d.
sa obtinem amestecul de proportii d1:d2:d3.Deci trebuie sa rezolvam sistemul:

       a1*x1+a2*x2+...+an*xn=d1*k
       b1*x1+b2*x2+...+bn*xn=d2*k
       c1*x1+c2*x2+...+cn*xn=d3*k ,unde k reprezinta nr de amestecuri cu pro-
                                   portia ceruta care se obtine.

   Problema revine la a studia compatibilitatea acestui sistem(vezi manualul
de algebra clasa a XI-a).O alta conditie este aceea ca solutiile obtinute sa
fie numere nenegative.}

uses crt;
var i,j,k,n:longint;
    l:longint;
    a,b,c,d:array[1..100] of longint;
    x,p:array[1..3] of longint;
    sw:boolean;
    f:text;

procedure bine;
begin
assign(f,'amestec.out');
rewrite(f);write(f,'DA');
close(f);halt;
end;

procedure rau;
begin
assign(f,'amestec.out');
rewrite(f);write(f,'NU');
close(f);halt;
end;

BEGIN clrscr;
assign(f,'amestec.in');
reset(f);
readln(f,n);
if n=0 then rau;
for i:=1 to n do readln(f,a[i],b[i],c[i]);
read(f,d[1],d[2],d[3]);
close(f);
sw:=false;
for i:=1 to n-2 do
for j:=i+1 to n-1 do
for k:=j+1 to n do
  begin
  l:=a[i]*b[j]*c[k]+b[i]*c[j]*a[k]+c[i]*a[j]*b[k];
  l:=l-a[k]*b[j]*c[i]-b[k]*c[j]*a[i]-c[k]*a[j]*b[i];
  if l<>0 then begin
               sw:=true;
               l:=l div abs(l);
               x[1]:=d[1]*b[j]*c[k]+d[2]*c[j]*a[k]+d[3]*a[j]*b[k];
               x[1]:=x[1]-a[k]*b[j]*d[3]-b[k]*c[j]*d[1]-c[k]*a[j]*d[2];
               if (x[1]*l>=0) then begin
               x[2]:=a[i]*d[2]*c[k]+b[i]*d[3]*a[k]+c[i]*d[1]*b[k];
               x[2]:=x[2]-a[k]*d[2]*c[i]-b[k]*d[3]*a[i]-c[k]*d[1]*b[i];
               if (x[2]*l>=0) then begin
               x[3]:=a[i]*b[j]*d[3]+b[i]*c[j]*d[1]+c[i]*a[j]*d[2];
               x[3]:=x[3]-d[1]*b[j]*c[i]-d[2]*c[j]*a[i]-d[3]*a[j]*b[i];
               if (x[3]*l>=0) then bine;
                                   end;end;
               end;
  end;
if sw then rau
      else for i:=1 to n-1 do
            for j:=i+1 to n do
              begin
              l:=a[i]*b[j]*d[3]+b[i]*c[j]*d[1]+c[i]*a[j]*d[2];
              l:=l-d[1]*b[j]*c[i]-d[2]*c[j]*a[i]-d[3]*a[j]*b[i];
              if l<>0 then rau;
              p[1]:=a[i]*b[j]-a[j]*b[i];
              p[2]:=a[i]*c[j]-a[j]*c[i];
              p[3]:=b[i]*c[j]-b[j]*c[i];
              if p[1]<>0 then begin
                              sw:=true;
                              x[1]:=d[1]*b[j]-d[2]*a[j];
                              x[2]:=a[i]*d[2]-b[i]*d[1];
                              x[1]:=x[1]*p[1];x[2]:=x[2]*p[1];
                              if(x[1]>=0)and(x[2]>=0) then bine;
                              end;
              if p[2]<>0 then begin
                              sw:=true;
                              x[1]:=d[1]*c[j]-d[3]*a[j];
                              x[2]:=a[i]*d[3]-c[i]*d[1];
                              x[1]:=x[1]*p[2];x[2]:=x[2]*p[2];
                              if(x[1]>=0)and(x[2]>=0) then bine;
                              end;
              if p[3]<>0 then begin
                              sw:=true;
                              x[1]:=d[2]*c[j]-d[3]*b[j];
                              x[2]:=b[i]*d[3]-c[i]*d[2];
                              x[1]:=x[1]*p[3];x[2]:=x[2]*p[3];
                              if(x[1]>=0)and(x[2]>=0) then bine;
                              end;
              end;
if sw then rau
      else for i:=1 to n do
             begin
             p[1]:=a[i]*d[2]-d[1]*b[i];
             p[2]:=a[i]*d[3]-d[1]*c[i];
             p[3]:=b[i]*d[3]-d[2]*c[i];
             for j:=1 to 3 do if p[j]<>0 then rau;
             end;
bine;
END.