program Biletel;
{$B-,I-,R-,S-}
const KMax=4;
type Vector=array[0..KMax] of Integer;
     Str8=String[8];
var P, PRev:Vector;
    S, SRev:Str8;
    N, NSquares, K:Integer;


procedure ReadData;
begin
  Assign(Input, 'bilet.in'); Reset(Input);
  ReadLn(N, K);
  Close(Input);
  NSquares:=N*N;
end;

function BuildS(var P:Vector):Str8;
var i:Integer;
    S:Str8;
begin
  S:='';
  for i:=1 to K do S:=S+Chr(49+P[i] div N)+Chr(49+P[i] mod N);
  BuildS:=S;
end;

procedure ReverseP;
var R, i, j, Min:Integer;
begin
  for i:=1 to K do
    begin
      R:=P[i] mod N;
      PRev[i]:=P[i]-R+N-1-R;
    end;
  for i:=1 to K-1 do
    begin
      Min:=i;
      for j:=i+1 to K do
        if PRev[j]<PRev[Min] then Min:=j;
      R:=PRev[i]; PRev[i]:=PRev[Min]; PRev[Min]:=R;
    end;
end;

procedure Solution;
var i:Integer;
begin
  S:=BuildS(P);
  ReverseP;
  SRev:=BuildS(PRev);
  if S<=SRev then WriteLn(S);
end;

procedure Back(Level:Integer);
var i:Integer;
begin
  if Level>K
    then Solution
    else for i:=P[Level-1]+1 to NSquares+Level-K-1 do
           begin
             P[Level]:=i;
             Back(Level+1);
           end;
end;

begin
  ReadData;
  P[0]:=-1;
  Assign(Output, 'bilet.out'); Rewrite(Output);
  Back(1);
  Close(Output);
end.
