program BlackRoad;
const NMax=10;
type Matrix=array[-1..NMax+1, -1..NMax+1] of Integer;
     Compass=(North, East, South, West);
     CoordMatrix=array[Compass] of record
                                     DeltaL, DeltaC:Integer;
                                   end;
     DirMatrix=array[Compass, 1..3] of Compass;
     PieceVector=array[1..3] of Integer;
const Step:CoordMatrix= ((DeltaL: -1; DeltaC:0),
                      (DeltaL: 0; DeltaC:1),
                      (DeltaL: 1; DeltaC:0),
                      (DeltaL: 0; DeltaC:-1));
      D:DirMatrix= ((North, West, East),
                    (East, South, North),
                    (South, East, West),
                    (West, North, South));
var A:Matrix;
    P:PieceVector;
    N, N1, N2, N3:Integer;

procedure Init;
var i, j:Integer;
begin
  Assign(Input, 'black.in'); Reset(Input);
  Read(P[1], P[2], P[3]);
  Close(Input);
  N:=Round(Sqrt(P[1]+P[2]+P[3]));
  for i:=1 to N do
    for j:=1 to N do A[i,j]:=0;     { Initializam tabla cu piese goale }
  for i:=0 to N+1 do
    begin
      A[i,0]:=1; A[i,N+1]:=1;
      A[0,i]:=1; A[N+1,i]:=1;       { Bordam matricea }
    end;
end;

procedure Solution;
var i,j:Integer;
begin
  for i:=1 to N do
    begin
      for j:=1 to N do Write(A[i,j],' ');
      WriteLn;
    end;
  Close(Output);
  Halt;
end;

procedure Ariadna(L, C:Integer; Dir:Compass);
var NewL, NewC, i:Integer;
begin
  if (P[1] or P[2] or P[3]=0)
    then if (L=N) and (C=N) and (Dir in [South, East])
           then Solution
           else
    else if ((L<>N) or (C<>N))
           then begin
                  NewL:=L+Step[Dir].DeltaL;
                  NewC:=C+Step[Dir].DeltaC;
                  if A[NewL, NewC]=0
                    then begin
                           for i:=1 to 3 do
                             if P[i]>0
                               then begin
                                      Dec(P[i]);
                                      A[NewL, NewC]:=i;
                                      Ariadna(NewL, NewC, D[Dir, i]);
                                      Inc(P[i]);
                                    end;
                           A[NewL, NewC]:=0;
                         end;
                end;
end;

begin
  Init;
  Assign(Output, 'black.out'); Rewrite(Output);
  Ariadna(1, 0, East);
  Ariadna(0, 1, South);
  WriteLn('Imposibil');
  Close(Output);
end.
