#include <stdio.h>
#include <stdlib.h>
#define 	N	1
#define 	E	2
#define 	S	3
#define		W	4
#define DIM		5

int mat[DIM+1][DIM+1],can[4];
int used[DIM+1][DIM+1],i,j,black,code;

void done(void)
{
	FILE *fp;
	fp=fopen("black.out","wt");
	for (i=1;i<=DIM;i++)
		{
			for(j=1;j<=DIM;j++) fprintf(fp,"%d ",mat[i][j]);
			fprintf(fp,"\n");
		}
	fclose(fp);
	exit(0);
}

int go(int type,int dir)
{
	if (type==2)
		if ((dir==S)||(dir==N)) dir-=1;
		else dir+=1;
	if (type==3)
		if ((dir==S)||(dir==N)) dir+=1;
		else dir-=1;
	if (dir>4) dir-=4;
	if (dir<1) dir+=4;
	return dir;
}

int valid(int type,int i,int j,int dir)
{
	int newdir;
	if (can[type]<1) return 0;
	newdir=go(type,dir);
	if (used[i][j]) return 0;
	if (((i==1)&&(newdir==N))||((j==1)&&(newdir==W))) return 0;
	if (((j<DIM)&&(i==DIM)&&(newdir==S))||((i<DIM)&&(j==DIM)&&(newdir==E)))
		return 0;
	return newdir;
}

void back(int pi,int pj,int dir)
{
	int ni=pi,nj=pj;
	if ((pi==DIM)&&(pj==DIM))
		{
			if ((black==DIM*DIM)&&(pi==DIM)&&(pj==DIM)&&((dir==S)||(dir==E))) done();
        }
	else
		{
			switch(dir)	{
				case N : ni--; break;
				case S : ni++; break;
				case E : nj++; break;
				case W : nj--;
			}
			if (code=valid(1,ni,nj,dir))
				{
					can[1]--; black++; used[ni][nj]=1; mat[ni][nj]=1;
					back(ni,nj,code);
					can[1]++; black--; used[ni][nj]=0; mat[ni][nj]=0;
				}
			if (code=valid(2,ni,nj,dir))
				{
					can[2]--; black++; used[ni][nj]=1; mat[ni][nj]=2;
					back(ni,nj,code);
					can[2]++; black--; used[ni][nj]=0; mat[ni][nj]=0;
				}
			if (code=valid(3,ni,nj,dir))
				{
					can[3]--; black++; used[ni][nj]=1; mat[ni][nj]=3;
					back(ni,nj,code);
					can[3]++; black--; used[ni][nj]=0; mat[ni][nj]=0;
				}
		}
}

void main(void)
{
	FILE *fp;
	fp=fopen("black.in","rt");
	fscanf(fp,"%d%d%d",&can[1],&can[2],&can[3]);
	fclose(fp);
	for(i=1;i<=DIM;i++)
		for(j=1;j<=DIM;j++)
			used[i][j]=0;
	black=1;
	mat[1][1]=1; used[1][1]=1; can[1]--;
	back(1,1,E);
	back(1,1,S);
	mat[1][1]=2; can[1]++; can[2]--;
	back(1,1,S);
	fp=fopen("black.out","wt");
	fprintf(fp,"Imposibil\n");
	fclose(fp);
}