{ Dumitru Bogdan }

program eiffel;

const ni='eiffel.in';
      no='eiffel.out';
      nmax=200;
      eps=0.001;
      timelimit=5;

var f:text;
    xmic,ymic,xmare,ymare,huge,min,aux,x1,y1,r1,x,y,r,minx,miny,raze:real;
    vali,ariac,ariad,aria,x2,y2,r2,dd,d,supr,xh,yh,l1,l2,p,h,b,panta:real;
    raza,cx,cy,cxc,cyc,cxd,cyd:array [1..nmax] of real;
    s,sc,sd,ind:array [1..nmax] of integer;
    n,i,j,k,ax:integer;
    t:string;
    time:longint absolute $0000:$046C;
    alarm:longint;

procedure load;
begin
     alarm:=time+timelimit*17;
     assign(f,ni);reset(f);
     readln(f,xmare,ymare);
     readln(f,n);
     for i:=1 to n do begin
        readln(f,raza[i]);
        raza[i]:=raza[i]+eps;
                      end;
     close(f);
end;

procedure init;
begin
     xmic:=0;
     ymic:=0;
     huge:=1;
     for i:=1 to 30 do
        huge:=huge*10;
     for i:=1 to n do
        ind[i]:=i;
end;

procedure init_c;
begin
     for i:=1 to n do begin
        cx[i]:=0;
        cy[i]:=0;
                      end;
     for i:=1 to n do
        s[i]:=0;
end;

procedure init_d;
begin
     for i:=1 to n do begin
        cx[i]:=0;
        cy[i]:=0;
                      end;
     for i:=1 to n do
        s[i]:=0;
end;

procedure sort_d;
begin
     for i:=1 to n-1 do
        for j:=i+1 to n do
           if raza[i]<raza[j] then begin
             aux:=raza[i];
             raza[i]:=raza[j];
             raza[j]:=aux;
             ax:=ind[i];
             ind[i]:=ind[j];
             ind[j]:=ax;
                                   end;
end;

procedure sort_c;
begin
     i:=1;
     j:=n;
     while i<j do begin
          aux:=raza[i];
          raza[i]:=raza[j];
          raza[j]:=aux;
          ax:=ind[i];
          ind[i]:=ind[j];
          ind[j]:=ax;
          i:=i+1;
          j:=j-1;
                  end;
end;

function valid(x,y:real):boolean;
var h:integer;
begin
     valid:=false;
     if (x-raza[i]>=xmic) and (x+raza[i]<=xmare) and
        (y-raza[i]>=ymic) and (y+raza[i]<=ymare) then begin
         valid:=true;
         for h:=1 to i-1 do
            if s[h]=1 then begin
              d:=sqrt(sqr(cx[h]-x)+sqr(cy[h]-y));
              raze:=raza[h]+raza[i];
              if d<=raze then valid:=false;
                           end;
                                                      end;
end;

procedure actua(x,y:real);
begin
     minx:=x;
     if xmare-x<minx then minx:=xmare-x;
     miny:=y;
     if ymare-y<miny then miny:=ymare-y;
     if minx+miny<min then begin
       min:=minx+miny;
       cx[i]:=x;
       cy[i]:=y;
       s[i]:=1;
                           end;
end;

procedure latura_latura;
begin
     if valid(raza[i],raza[i]) then
       actua(raza[i],raza[i]);
     if valid(xmare-raza[i],raza[i]) then
       actua(xmare-raza[i],raza[i]);
     if valid(xmare-raza[i],ymare-raza[i]) then
       actua(xmare-raza[i],ymare-raza[i]);
     if valid(raza[i],ymare-raza[i]) then
       actua(raza[i],ymare-raza[i]);
end;

procedure latura_cerc;
begin
     for j:=1 to i-1 do
        if s[j]=1 then begin
          x1:=cx[j];
          y1:=cy[j];
          r1:=raza[j];
          r:=raza[i];

          y:=raza[i];
          vali:=sqr(r+r1)-sqr(y-y1);
          if vali>=0 then begin
            vali:=sqrt(vali);
            x:=-vali+x1;
            if valid(x,y) then actua(x,y);
            x:=vali+x1;
            if valid(x,y) then actua(x,y);
                          end;

          y:=ymare-raza[i];
          vali:=sqr(r+r1)-sqr(y-y1);
          if vali>=0 then begin
            vali:=sqrt(vali);
            x:=-vali+x1;
            if valid(x,y) then actua(x,y);
            x:=vali+x1;
            if valid(x,y) then actua(x,y);
                          end;

          x:=raza[i];
          vali:=sqr(r+r1)-sqr(x-x1);
          if vali>=0 then begin
            vali:=sqrt(vali);
            y:=-vali+y1;
            if valid(x,y) then actua(x,y);
            y:=vali+y1;
            if valid(x,y) then actua(x,y);
                          end;

          x:=xmare-raza[i];
          vali:=sqr(r+r1)-sqr(x-x1);
          if vali>=0 then begin
            vali:=sqrt(vali);
            y:=-vali+y1;
            if valid(x,y) then actua(x,y);
            y:=vali+y1;
            if valid(x,y) then actua(x,y);
                          end;

                       end;
end;

procedure cerc_cerc;
begin
     j:=i-1;
     while (s[j]=0) and (j>=1) do j:=j-1;
     if j>=1 then
       for k:=1 to j-1 do
          if s[k]=1 then begin
            x1:=cx[k];
            y1:=cy[k];
            r1:=raza[k];
            x2:=cx[j];
            y2:=cy[j];
            r2:=raza[j];
            r:=raza[i];

            dd:=sqr(x1-x2)+sqr(y1-y2);
            d:=sqrt(dd);
            if r1+r2+2*r>=d then begin
              l1:=r+r1;
              l2:=r+r2;
              p:=(d+l1+l2)*0.5;
              supr:=sqrt(p*(p-d)*(p-l1)*(p-l2));
              h:=(2*supr)/d;
              b:=sqrt(sqr(l1)-sqr(h));
              xh:=x1-(x1-x2)*(b/d);
              yh:=y1-(y1-y2)*(b/d);
              if y1=y2 then begin
                x:=xh;
                y:=yh-h;
                if valid(x,y) then actua(x,y);
                x:=xh;
                y:=yh+h;
                if valid(x,y) then actua(x,y);
                            end
              else
                  if x1=x2 then begin
                    x:=xh-h;
                    y:=yh;
                    if valid(x,y) then actua(x,y);
                    x:=xh+h;
                    y:=yh;
                    if valid(x,y) then actua(x,y);
                                end
                  else begin
                      panta:=(y1-y2)/(x1-x2);
                      panta:=(-1)/panta;
                      vali:=h/(sqrt(sqr(panta)+1));
                      x:=xh-vali;
                      y:=yh+panta*(x-xh);
                      if valid(x,y) then actua(x,y);
                      x:=xh+vali;
                      y:=yh+panta*(x-xh);
                      if valid(x,y) then actua(x,y);
                       end;
                                 end;
                         end;
end;

procedure work;
begin
     for i:=1 to n do
        s[i]:=0;
     for i:=1 to n do
        if time<alarm then begin
          min:=huge;
          latura_latura;
          latura_cerc;
          cerc_cerc;
                           end
        else i:=n;
end;

procedure calc_ariad;
begin
     ariad:=0;
     for i:=1 to n do
        if s[i]=1 then ariad:=ariad+sqr(raza[i]-eps);
     ariad:=pi*ariad;
     for i:=1 to n do begin
        cxd[ind[i]]:=cx[i];
        cyd[ind[i]]:=cy[i];
                      end;
end;

procedure calc_ariac;
begin
     ariac:=0;
     for i:=1 to n do
        if s[i]=1 then ariac:=ariac+sqr(raza[i]-eps);
     ariac:=pi*ariac;
     for i:=1 to n do begin
        cxc[ind[i]]:=cx[i];
        cyc[ind[i]]:=cy[i];
                      end;
end;

procedure alege;
begin
     if ariac>ariad then begin
       aria:=ariac;
       for i:=1 to n do begin
          cx[i]:=cxc[i];
          cy[i]:=cyc[i];
                        end;
                         end
     else begin
         aria:=ariad;
         for i:=1 to n do begin
            cx[i]:=cxd[i];
            cy[i]:=cyd[i];
                          end;
          end;
end;

procedure scrie;
begin
     assign(f,no);rewrite(f);
     str(aria:0:10,t);
     delete(t,length(t)-6,7);
     writeln(f,t);
     for i:=1 to n do begin
        str(cx[i]:0:10,t);
        delete(t,length(t)-6,7);
        write(f,t,' ');
        str(cy[i]:0:10,t);
        delete(t,length(t)-6,7);
        writeln(f,t);
                      end;
     close(f);
end;

begin {programul principal}
     load;
     init;
     init_d;
     sort_d;
     work;
     calc_ariad;
     init_c;
     sort_c;
     work;
     calc_ariac;
     alege;
     scrie;
end.

