{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{ Complexitate: O(M*N) }

Program MATRIX;

const filein='matrix.in';
      fileout='matrix.out';
      MAXN=701;
      BUFSIZE=50000;

type buffer=array[1..BUFSIZE] of char;

var fin,fout:text;
    up,uplast,stk,col:array[1..MAXN] of longint;
    i,j,k,m,n,nco,nst,amax:longint;
    vv:byte;
    buf:buffer;

begin
assign(fin,filein);
settextbuf(fin,buf,sizeof(buffer));
reset(fin);

readln(fin,m,n);

amax:=0;
nco:=0;

{ Process the first line }
for j:=1 to n do
  begin
    read(fin,uplast[j]);
    if (uplast[j]=0) then
      nco:=0
    else
      nco:=nco+1;

    if (nco>amax) then
      amax:=nco;
  end;

{ Process the rest of the lines }
for i:=2 to m do
  begin
    readln(fin);

    nst:=0;

    for j:=1 to n do
      begin
        read(fin,vv);
        case vv of
        0:begin
            { Empty the stack }
            while (nst>0) do
              begin
                nco:=stk[nst]*(j-col[nst]);
                if (nco>amax) then
                  amax:=nco;

                dec(nst);
              end;

            up[j]:=0;
          end;
        1:begin
            up[j]:=uplast[j]+1;

            k:=j;
            if (up[j]>amax) then
              amax:=up[j];

            { Empty the stack as long as its top is higher
              than the present value }
            while (nst>0) and (stk[nst]>=up[j]) do
              begin
                k:=col[nst];

                nco:=up[j]*(j-col[nst]+1);
                if (nco>amax) then
                  amax:=nco;

                nco:=(j-col[nst])*stk[nst];
                if (nco>amax) then
                  amax:=nco;

                dec(nst);
              end;

            { Insert value into stack }
            inc(nst);
            stk[nst]:=up[j];
            col[nst]:=k;
          end;
        end;
      end;

    { Empty the stack }
    while (nst>0) do
      begin
        nco:=stk[nst]*(j-col[nst]+1);
        if (nco>amax) then
          amax:=nco;

        dec(nst);
      end;

    move(up,uplast,sizeof(up));
  end;

close(fin);
assign(fout,fileout);
rewrite(fout);
write(fout,amax);
close(fout);
end.