
{---------------------------------
| PROBLEMA 28: Ordonare           |
| PUNCTAJ: 50 Dexteri             |
| DEADLINE: Luni, 6 Septembrie    |
| TIMP DE IMPLEMENTARE: 45 minute |
| TIMP DE EXECUTIE: 1 sec./test   |
 ---------------------------------

    Din fisierul "sir.in" se citeste un sir de numere naturale cuprinse
intre 1 si 60000. Se cere ordonarea crescatoare a acestui sir folosind
urmatoarea operatie: se fixeaza un element al sirului si apoi se rotesc
secventele din stanga si din dreapta lui.  De exemplu, daca in sirul
(6 5 7 8 9 4 6 5) se fixeaza elementul de pe pozitia 4 se va obtine sirul
(7 5 6 8 5 6 4 9) adica se roteste sirul (6 5 7) si sirul (9 4 6 5), siruri
aflate in stanga si respectiv in dreapta elementului de pe pozitia 4.

    Prima linie a fisierului "sir.in" contine un numar n (1<=n<=1000)
reprezentand dimensiunea sirului citit, iar pe urmatoarele n linii se afla
elementele sirului.

    Rezultatele se scriu in fisierul "sir.out". Pe fiecare linie este scrisa
pozitia care se fixeaza la un moment dat, pana se ajunge la solutie. Numarul
de linii din acest fisier nu trebuie sa fie mai mare decat 3n.

    Exemplu:

    sir.in                              sir.out (un fisier posibil)
    4                                   3
    20                                  2
    5
    50
    25

    Mult succes !}

{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65384,0,655360}

program Ordonare;

   var f:text;
       a,b:array[1..1001]of word;
       n:integer;

procedure Readdata;
   var i:integer;
   begin
    assign(F,'sir.in');
    reset(f);
    readln(f,n);
    for i:=1 to n do readln(f,a[i]);
    close(f);
   end;

procedure Roteste(k:integer);
   var i,j:integer;
   begin
    j:=0;
    for i:=k-1 downto 1 do
     begin
      inc(j);
      b[j]:=a[i];
     end;
    inc(j);
    b[j]:=a[j];
    for i:=n downto k+1 do
     begin
      inc(j);
      b[j]:=a[i];
     end;
    move(b,a,n*2);
   end;

procedure rezolva;
   var p,i,m,j:word;
   begin
    p:=0;
    assign(f,'sir.out');
    rewrite(f);
    while p<n do
     begin
      m:=61000;
      for i:=p+1 to n do if a[i]<m then
       begin m:=a[i]; j:=i; end;
      Roteste(j);
      Roteste(j+1);
      writeln(f,j);
      writeln(f,j+1);
      inc(p);
     end;
    writeln(f,n+1);
    close(f);
   end;

begin
 Readdata;
 rezolva;
end.