{ Dumitru Bogdan }

program pacman;

const ni='pacman.in';
      no='pacman.out';
      nmax=100;
      mmax=5000;
      vl:array [1..4] of integer=(-1,  1,  0,  0);
      vc:array [1..4] of integer=( 0,  0,  1, -1);
      move:array [1..4] of char =('N','S','E','V');
      timelimit=5;

type cell=record
                l,c,t:integer;
                m:char;
          end;
     pcell=^cell;
     vector=array [1..nmax*nmax] of pcell;
     mat=array [1..nmax,1..nmax] of integer;
     pmat=^mat;
     sir=array [1..nmax*nmax] of char;
     psir=^sir;

var f:text;
    a:array [1..nmax,1..nmax] of char;
    s:pmat;
    v:vector;
    drum:psir;
    n,m,moves,i,j,k,left,cirese,l,c,p,u,uu,lin,col,nlin,ncol:integer;
    lng,vali,eat,lungime,max:integer;
    found,stop:boolean;
    time:longint absolute $0000:$046C;
    alarm:longint;

procedure load;
begin
     alarm:=time+timelimit*17;
     assign(f,ni);reset(f);
     readln(f,n,m,moves);
     for i:=1 to n do begin
        for j:=1 to m do
           read(f,a[i,j]);
        readln(f);
                      end;
     close(f);
end;

procedure analyze(lng:integer);
begin
     eat:=0;
     for i:=1 to lng do
        if s^[v[i]^.l,v[i]^.c]=0 then
          if a[v[i]^.l,v[i]^.c]='%' then begin
            eat:=eat+1;
            s^[v[i]^.l,v[i]^.c]:=1;
                                         end;
     if eat>max then begin
       max:=eat;
       lungime:=lng-1;
       for i:=2 to lng do
          drum^[i-1]:=v[i]^.m;
                     end;
     for i:=1 to lng do
        s^[v[i]^.l,v[i]^.c]:=0;
end;

procedure rec(k:integer);
var q:integer;
begin
     if time>alarm then begin
       assign(f,no);rewrite(f);
       for i:=1 to lungime do
          write(f,drum^[i]);
       writeln(f);
       writeln(f,max);
       close(f);
       halt;
                        end;
     if k<=moves+1 then analyze(k);
     if k<moves+1 then
       for q:=1 to 4 do begin
          lin:=v[k]^.l+vl[q];
          col:=v[k]^.c+vc[q];
          if (1<=lin) and (lin<=n) and (1<=col) and (col<=m) then
            if (a[lin,col]='.') or (a[lin,col]='%') then begin
              v[k+1]^.l:=lin;
              v[k+1]^.c:=col;
              v[k+1]^.m:=move[q];
              rec(k+1);
                                                         end;
                        end;
end;

procedure bkt;
begin
     max:=0;
     lungime:=0;
     new(s);
     for i:=1 to n do
        for j:=1 to m do
           s^[i,j]:=0;
     for i:=1 to n*m do
        new(v[i]);
     new(drum);
     for i:=1 to n do
        for j:=1 to m do
           if (a[i,j]='p') or (a[i,j]='P') then begin
             l:=i;
             c:=j;
                                                end;
     a[l,c]:='.';
     v[1]^.l:=l;
     v[1]^.c:=c;
     rec(1);
     assign(f,no);rewrite(f);
     for i:=1 to lungime do
        write(f,drum^[i]);
     writeln(f);
     writeln(f,max);
     close(f);
end;

procedure init;
begin
     cirese:=0;
     for i:=1 to n do
        for j:=1 to m do begin
           if a[i,j]='%' then cirese:=cirese+1;
           if (a[i,j]='p') or (a[i,j]='P') then begin
             l:=i;
             c:=j;
                                                end;
                         end;
     left:=cirese;
     stop:=false;
     a[l,c]:='.';
     new(s);
     for i:=1 to n do
        for j:=1 to m do
           s^[i,j]:=0;
     for i:=1 to n*m do
        new(v[i]);
     new(drum);
end;

procedure search;
begin
     vali:=vali+1;
     s^[l,c]:=vali;
     v[1]^.l:=l;
     v[1]^.c:=c;
     v[1]^.t:=0;
     v[1]^.m:=' ';
     p:=1;
     u:=1;
     found:=false;
     while (p<=u) and (not found) do begin
          lin:=v[p]^.l;
          col:=v[p]^.c;
          for k:=1 to 4 do begin
             nlin:=lin+vl[k];
             ncol:=col+vc[k];
             if (1<=nlin) and (nlin<=n) and (1<=ncol) and (ncol<=m) then
               if s^[nlin,ncol]<>vali then
                 if (a[nlin,ncol]='.') or (a[nlin,ncol]='%') then begin
                   u:=u+1;
                   v[u]^.l:=nlin;
                   v[u]^.c:=ncol;
                   v[u]^.t:=p;
                   v[u]^.m:=move[k];
                   s^[nlin,ncol]:=vali;
                   if a[nlin,ncol]='%' then begin
                     found:=true;
                     k:=4;
                                            end;
                                                                  end;
                           end;
          p:=p+1;
                                     end;
     if not found then stop:=true
     else begin
         lng:=0;
         uu:=u;
         while u>1 do begin
              lng:=lng+1;
              drum^[lng]:=v[u]^.m;
              u:=v[u]^.t;
                      end;
         if lng>moves then stop:=true
         else begin
             a[v[uu]^.l,v[uu]^.c]:='.';
             l:=v[uu]^.l;
             c:=v[uu]^.c;
             for i:=lng downto 1 do
                write(f,drum^[i]);
             moves:=moves-lng;
             left:=left-1;
              end;
          end;
end;

procedure work;
begin
     assign(f,no);rewrite(f);
     while (time<alarm) and (left>0) and (not stop) do
          search;
     writeln(f);
     writeln(f,cirese-left);
     close(f);
end;

begin {programul principal}
     load;
     if moves<=10 then bkt
     else begin
        init;
        work;
          end;
end.
