{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

Program JOC_cu_piese;

uses crt;

type winvect=array[0..500] of boolean;

var fin,fout:text;
    poz:array[1..500] of integer;
    gram:array[1..500] of integer;
    i,j,p,k,m,n,nim1,nie1,turn,lg,lnp:integer;
    win:array[0..500] of^winvect;
    gresit:boolean;

function finish:boolean;
begin
finish:=true;
for j:=1 to n do
  if (gram[j]>0) then
    begin
      finish:=false;
      break;
    end;
end;

procedure ExecutaMutarea(pg,np:integer);
begin
  if (pg<=0) or (gram[pg]<np) or (np<=0) then
    begin
      gresit:=true;
      turn:=3-turn;
      fillchar(gram,sizeof(gram),0);
    end
  else
    begin
      if (pg mod 2=1) then
        begin
          if (gram[pg]=1) then
            begin
              nie1:=nie1-1;
            end
          else
            if (np=gram[pg]) then
              nim1:=nim1-1
            else
              if (np=gram[pg]-1) then
                begin
                  nim1:=nim1-1;
                  nie1:=nie1+1;
                end;
        end;
      gram[pg]:=gram[pg]-np;
      poz[pg]:=poz[pg]-np;

      if (pg-1>0) and ((pg-1) mod 2=1) then
        begin
          if (gram[pg-1]=1) then
            begin
              nie1:=nie1-1;
              nim1:=nim1+1;
            end
          else
            if (gram[pg-1]=0) then
              begin
                if (np=1) then
                  nie1:=nie1+1
                else
                  nim1:=nim1+1;
              end;
        end;

      if (pg>1) then
        gram[pg-1]:=gram[pg-1]+np;
    end;
end;

begin
assign(fin,'TABLA.IN');
reset(fin);
readln(fin,N,M); { numarul de piese & dimensiunea tablei }

for i:=1 to n do
  read(fin,poz[i]); { pozitiile pieselor, incepand cu cea mai
                      din dreapta }

close(fin);

gram[n]:=poz[n]-1;
for i:=n-1 downto 1 do
  gram[i]:=poz[i]-poz[i+1]-1;

nim1:=0;
nie1:=0;

for i:=1 to n do
  if (i mod 2=1) and (gram[i]>0) then
    begin
      if (gram[i]=1) then
        inc(nie1)
      else
        inc(nim1);
    end;

{ Am NIE1 gramezi pe pozitii impare cu 1 piesa si
  NIM1 gramezi pe pozitii impare cu mai mult de 1 piesa }

for i:=0 to 500 do
  begin
    new(win[i]);
    fillchar(win[i]^,sizeof(win[i]^),false);
  end;

{ DINAMICA }
win[0]^[0]:=false;

for i:=0 to nim1 do
  for j:=0 to nim1+nie1 do
    begin
      if (i>0) and (not win[i-1]^[j+1]) then
        win[i]^[j]:=true
      else
        if (i>0) and (not win[i-1]^[j]) then
          win[i]^[j]:=true
        else
          if (j>0) and (not win[i]^[j-1]) then
            win[i]^[j]:=true;
    end;
{ END DINAMICA }

{ Jocul propriu-zis }
turn:=1;
lg:=0; lnp:=0;
gresit:=false;

clrscr;
while (not finish) do
  begin
    case turn of
    1:begin
      if (win[nim1]^[nie1]) then
        begin

          if (nie1>0) and (not win[nim1]^[nie1-1]) then
            begin
              for i:=1 to n do
                if (i mod 2=1) and (gram[i]=1) then
                  begin
                    p:=i;
                    k:=1;
                    break;
                  end;
            end
          else
            if (nim1>0) and (not win[nim1-1]^[nie1]) then
              begin
                for i:=1 to n do
                  if (i mod 2=1) and (gram[i]>1) then
                    begin
                      p:=i;
                      k:=gram[p];
                      break;
                    end;
              end
            else
              if (nim1>0) and (not win[nim1-1]^[nie1+1]) then
                begin
                  for i:=1 to n do
                    if (i mod 2=1) and (gram[i]>1) then
                      begin
                        p:=i;
                        k:=gram[p]-1;
                        break;
                      end;
                end;
        end
      else
        begin

        if (lg>0) and (lg mod 2=0) then
          begin
            p:=lg-1; k:=lnp;
          end
        else
          begin
          { Mutare RANDOM }
            repeat
              p:=random(n)+1;
            until gram[p]>0;

            if (gram[p]=1) then
              k:=1
            else
              k:=gram[p]-1;
          end;
        end;
      end;
    2:begin
        writeln('POZITIILE PIESELOR:');
        writeln;
        for i:=n downto 1 do
          write(poz[i],' ');
        writeln;

        writeln('Ce piesa muti (',n,'...1) si cu cate patratele la stanga?');
        readln(p,k);
        writeln;
      end;
    end;


    case turn of
    1:writeln('PROGRAMUL muta piesa ',p,' cu ',k,' pozitii la stanga');
    2:writeln('HUMAN PLAYER-u muta piesa ',p,' cu ',k,' pozitii la stanga');
    end;
    writeln;

    ExecutaMutarea(p,k);

    if (gresit) then
      begin
        writeln('MUTARE GRESITA!!!');
        writeln;
      end;
    lg:=p; lnp:=k;
    turn:=3-turn;
  end;

case turn of
1:writeln('PROGRAMUL a pierdut!! A castigat HUMAN PLAYER-u');
2:writeln('PROGRAMUL a castigat!!');
end;

writeln;

writeln('POZITIA FINALA:');
for i:=n downto 1 do
  write(poz[i],' ');
{ END Joc }

end.