// not-so-Deep Blue v0.01
#include "sah.h"
#include <stdio.h>
#include <stdlib.h>

char *table;
int phase=1,iq,jq,ik,jk,imk,jmk,di,dj,reli,relj,ri,rj,first=0;
char mymove[4];

int Max(int x,int y) { if (x>=y) return x; else return y; }
int Min(int x,int y) { if (x<=y) return x; else return y; }

void checkphase(void)
{
	if (phase==1)
		if (((iq>imk)&&(iq<ik)) || ((iq>ik)&&(iq<imk)) ||
			((jq>jmk)&&(jq<jk)) || ((jq>jk)&&(jq<jmk))) phase=2;
	if (phase==2)
		if ((((abs(iq-ik)==1)&&(abs(jq-jk)==2))) ||
			((abs(iq-ik)==2)&&(abs(jq-jk)==1))) phase=3;
	if ((phase==2)||(phase==3))
		if (((ik==8)&&((jk==1)||(jk==8))) ||
			((ik==1)&&((jk==1)||(jk==8)))) phase=4;
	if (phase==4)
		{
			if (!(((ik==8)&&((jk==1)||(jk==8))) ||
				((ik==1)&&((jk==1)||(jk==8))))) phase=2;
			if (abs(iq-ik)+abs(jq-jk)<=4) phase=5;
		}
	if (iq<ik) di=1; else di=-1;
	if (jq<jk) dj=1; else dj=-1;
}

int accessible(int i,int j)
{
	if ((i<1)||(i>8)||(j<1)||(j>8)) return 0;
	if (i==iq)
		{ if (((jk>Min(jq,j))&&(jk<Max(jq,j))&&(ik==i)) ||
			  ((jmk>Min(jq,j))&&(jmk<Max(jq,j))&&(imk==i))) return 0;
		  else return 1; }
	if (j==jq)
		{ if (((ik>Min(iq,i))&&(ik<Max(iq,i))&&(jk==j)) ||
			  ((imk>Min(iq,i))&&(imk<Max(iq,i))&&(jmk==j))) return 0;
		  else return 1;
		}
	if ((abs(i-iq)==abs(j-jq)))
		{
			if ((abs(ik-iq)==abs(jk-jq)) &&
				((ik>Min(iq,i))&&(ik<Max(iq,i))&&(jk>Min(jq,j))&&(jk<Max(jq,j))))
					return 0;
			if ((abs(imk-iq)==abs(jmk-jq)) &&
				((imk>Min(iq,i))&&(imk<Max(iq,i))&&(jmk>Min(jq,j))&&(jmk<Max(jq,j))))
					return 0;
			return 1;
		}
	return 0;
}

void makemove(char who,int i,int j)
{
	mymove[0]=who;
	mymove[1]='A'+j-1;
	mymove[2]='0'+9-i;
	mymove[3]=0;
	if (who=='D') { iq=i; jq=j; }
	else { imk=i; jmk=j; }
	whitemove(mymove);
}

void closer(int ki,int kj)
{
	if (imk<ki) ri=1; else ri=-1;
	if (jmk<kj) rj=1; else rj=-1;
	if ((abs(imk-ki)>0)&&(abs(jmk-kj)>0))
		makemove('R',imk+ri,jmk+rj);
	else
		if (abs(imk-ki)==0) makemove('R',imk,jmk+rj);
		else makemove('R',imk+ri,jmk);
	if ((imk==ki)&&(jmk==kj)) phase=6;
}

void move(void)
{
	switch(phase) {
		case 1 : // "incadrarea" regelui negru
			{
				int i=0,j=0,ready=0;

				for (i=Min(ik,imk)+1;(i<Max(ik,imk))&&(!ready);i++)
					for (j=1;(j<=8)&&(!ready);j++)
						if (abs(j-jk)+abs(i-ik)>=3)
							if (accessible(i,j))
								{ makemove('D',i,j); ready=1; }
				for(j=Min(jk,jmk)+1;(j<Max(jk,jmk))&&(!ready);j++)
					for(i=1;(i<=8)&&(!ready);i++)
						if (abs(j-jk)+abs(i-ik)>=3)
							if (accessible(i,j))
								{ makemove('D',i,j); ready=1; }
				if (!ready)
					if (iq<8) makemove('D',iq+1,jq);
					else makemove('D',iq-1,jq);
			}; break;
		case 2 : // restrangerea variantelor de mutare pt negru
			{
				if ((iq>Min(ik,imk))&&(iq<Max(ik,imk))&&(abs(iq-ik)>1))
					if (abs(ik-(iq+di*(abs(iq-ik)-1)))+abs(jk-jq)>=3)
						makemove('D',iq+di*(abs(ik-iq)-1),jq);
					else makemove('D',iq+di*(abs(ik-iq)-2),jq);
				else
					if ((jq>Min(jk,jmk))&&(jq<Max(jk,jmk))&&(abs(jq-jk)>1))
						if (abs(ik-iq)+abs(jk-(jq+dj*(abs(jq-jk)-1)))>=3)
							makemove('D',iq,jq+dj*(abs(jk-jq)-1));
						else makemove('D',iq,jq+dj*(abs(jk-jq)-2));
					else
					  if (abs(ik-iq)>abs(jk-jq))
						  if (abs(ik-(iq+di*(abs(iq-ik)-1)))+abs(jk-jq)>=3)
							  makemove('D',iq+di*(abs(ik-iq)-1),jq);
						  else makemove('D',iq+di*(abs(ik-iq)-2),jq);
					  else
						  if (abs(ik-iq)+abs(jk-(jq+dj*(abs(jk-jq)-1)))>=3)
							  makemove('D',iq,jq+dj*(abs(jk-jq)-1));
						  else makemove('D',iq,jq+dj*(abs(jk-jq)-2));
			}; break;
		case 3 : // copiem fiecare mutare
			{
				if ((((abs(iq-ik)==1)&&(abs(jq-jk)==2))||
					 ((abs(iq-ik)==2)&&(abs(jq-jk)==1)))&&(!first))
				  {
					if (imk<8) makemove('R',imk+1,jmk);
					else makemove('R',imk-1,jmk);
                    first=1;
				  }
				else
				if (accessible(iq+reli,jq+relj))
					makemove('D',iq+reli,jq+relj);
				else
					if (abs(iq-ik)==1) makemove('D',iq+2*di,jq);
					else makemove('D',iq,jq+2*dj);
			}; break;
		case 4 :
			{
				if ((abs(ik-iq)>1)&&(abs(jk-jq)>1))
					if ((abs(ik-(iq+di*(abs(ik-iq)-1)))+abs(jk-jq)>3))
						makemove('D',iq+di*(abs(ik-iq)-1),jq);
					else makemove('D',iq,jq+dj*(abs(jk-jq)-1));
				else
					if (abs(iq-ik)>1)
						makemove('D',iq+(abs(iq-ik)-3)*di,jq);
					else makemove('D',iq,jq+dj*(abs(jk-jq)-3));
			};break;
		case 5 : // "the power of the man who will be King..."
			{
				if (abs(iq-ik)==1)
					if (((jq-jmk)*dj>=0)&&((iq-imk)*di<0))
						makemove('R',imk-di,jmk);
					else closer(iq-di,jq+2*dj);
				else
					if (((iq-imk)*di>=0)&&((jq-jmk)*dj<0))
						makemove('R',imk,jmk-dj);
					else closer(iq+2*di,jq-dj);
			};break;
		case 6 : // the show isn't over until the fat lady sings....
			{
				if (abs(iq-ik)==1) makemove('D',iq+di,jq);
				else makemove('D',iq,jq+dj);
                printf("That's checkmate !\n"); exit(1);
			};
	}
}

void main(void)
{
	table=init();
	imk=9+'0'-table[2]; jmk=table[1]-'A'+1;
	iq=9+'0'-table[5];  jq=table[4]-'A'+1;
	ik=9+'0'-table[8];  jk=table[7]-'A'+1;
	reli=0; relj=0;
	while (1==1) {
		checkphase();
		move();
		checkphase();
		table=NULL; table=blackmove();
		reli=9+'0'-table[2]-ik; relj=table[1]-'A'+1-jk;
		ik=9+'0'-table[2]; jk=table[1]-'A'+1;
	}
}