#include <fstream.h>
#define NMax 101

int P[NMax][NMax], S[NMax], D[NMax], OldD[NMax], N, V, M;

void ReadData(void)
{ ifstream F("solfegiu.in");
  int i, j;

  F >> V >> N;
  for (i=1;i<=V; i++)
    for (j=1; j<=N; F >> P[i][j++]);
  F >> M;
  for (i=1; i<=M; F >> S[i++]);
}

inline int Min(int A, int B, int C)
{ return A<B ? (A<C ? A : C) : (B<C ? B:C); }

int InSet(int K, int j)
/* 1 daca nota K se regaseste in nota j a partiturii, pe orice voce */
{ for (int i=1; i<=V;)
   if (P[i++][j]==K) return 1;
  return 0;
}

void Lowenstein(void)
{ int i, j;

  for (j=0; j<=N; j++) OldD[j]=j;
  for (i=1; i<=M; i++)
    {
      D[0]=i;
      for (j=1; j<=N; j++)
        D[j]=InSet(S[i], j) ? OldD[j-1] : 1 + Min(D[j-1], OldD[j-1], OldD[j]);
      for(j=0; j<=N; j++) OldD[j]=D[j];
    }
}

void main(void)
{
  ReadData();
  Lowenstein();
  if (D[N]) cout << "Solfegiul falseaza in " << D[N] << " locuri.\n";
    else cout << "Solfegiul se brodeste peste partitura.\n";
}
