{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$I-,R-,Q-,N+}
{$M 65000,0,655360}

Program Divider;

type BigNum=array[0..1000] of longint; { maxim 1000 de cifre alocate }

const avans=4;

var fin,fout:text;
    rezu,naux,nact,cmmmc:BigNum;
    num,res,i,rr,divy,dc,n:integer;
    vnum,vres:array[1..100] of integer; { N<=100 }
    rs:array[0..1000] of boolean;  { V[N]<=1000 }
    {
    t2:longint absolute 0:$046c;
    t1:longint;
    }
procedure adunanm(n1,n2:BigNum; var rez:BigNum);
var co,r:integer;
begin

fillchar(rez,sizeof(rez),0);

if (n1[0]>n2[0]) then r:=n1[0]
else r:=n2[0];

for co:=1 to r do
  rez[co]:=n1[co]+n2[co];

for co:=1 to r+avans do
  while (rez[co]>9) do
    begin
      rez[co+1]:=rez[co+1]+(rez[co] div 10);
      rez[co]:=rez[co] mod 10;
    end;

for co:=r+avans downto 1 do
  if (rez[co]>0) then
    begin
      rez[0]:=co;
      break;
    end;

if (rez[0]=0) then rez[0]:=1;
end;

procedure scadenm(n1:BigNum; x:integer; var rez:BigNum);
var co:integer;
begin

fillchar(rez,sizeof(rez),0);

rez[1]:=n1[1]-x;
for co:=2 to n1[0] do
  rez[co]:=n1[co];

for co:=1 to n1[0] do
  while (rez[co]<0) do
    begin
      if (rez[co]>-10) then
        begin
          rez[co]:=rez[co]+10;
          rez[co+1]:=rez[co+1]-1;
        end
      else
        begin
          rez[co+1]:=rez[co+1]+(rez[co] div 10);
          rez[co]:=rez[co] mod 10;
        end;
    end;

for co:=n1[0] downto 1 do
  if (rez[co]>0) then
    begin
      rez[0]:=co;
      break;
    end;

if (rez[0]=0) then rez[0]:=1;
end;

procedure inmulnm(n1:BigNum;x:integer;var rez:BigNum);
var co:integer;
begin

fillchar(rez,sizeof(rez),0);

for co:=1 to n1[0] do
  rez[co]:=n1[co]*x;

for co:=1 to n1[0]+avans do
  while (rez[co]>9) do
    begin
      rez[co+1]:=rez[co+1]+(rez[co] div 10);
      rez[co]:=rez[co] mod 10;
    end;

for co:=n1[0]+avans downto 1 do
  if (rez[co]>0) then
    begin
      rez[0]:=co;
      break;
    end;

if (rez[0]=0) then rez[0]:=1;
end;

procedure inmulnmnm(nn1,nn2:BigNum;var rrez:BigNum);
var c1,c2:integer;
begin

fillchar(rrez,sizeof(rrez),0);
rrez[0]:=1;

for c1:=1 to nn1[0] do
  begin
    inmulnm(nn2,nn1[c1],naux);

    for c2:=naux[0] downto 1 do
      naux[c2+c1-1]:=naux[c2];
    for c2:=1 to c1-1 do
      naux[c2]:=0;

    adunanm(naux,rrez,rrez);
  end;

end;

function rest(nn:BigNum;x:integer):integer;
var raux,cc:integer;
begin

raux:=nn[nn[0]] mod x;

for cc:=nn[0]-1 downto 1 do
  raux:=((raux*(10 mod x)) mod x + (nn[cc] mod x)) mod x;

rest:=raux;
end;

procedure impartenm(nn:BigNum;x:integer;var rrez:BigNum);
var co,cif,ncif:integer;
    act:longint;
    aux:BigNum;
begin

fillchar(rrez,sizeof(rrez),0);
fillchar(aux,sizeof(aux),0);

act:=0;
cif:=nn[0]+1;

repeat
cif:=cif-1;
act:=act*10+nn[cif];
until (act>=x) or (cif=1);

ncif:=1;
aux[1]:=act div x;
act:=act mod x;

for cif:=cif-1 downto 1 do
  begin
    act:=act*10+nn[cif];
    ncif:=ncif+1;
    aux[ncif]:=act div x;
    act:=act mod x;
  end;

for co:=1 to ncif do
  rrez[ncif-co+1]:=aux[co];

rrez[0]:=ncif;
end;

function cmmdc(a,b:integer):integer;
begin
if (a mod b=0) then cmmdc:=b
else cmmdc:=cmmdc(b,a mod b);
end;

procedure calccmmdc(nr:BigNum;x:integer);
var r:integer;
begin
r:=rest(nr,x);
if (r>0) then
  divy:=cmmdc(x,r)
else divy:=x;
end;

procedure nosol;
begin
assign(fout,'divider.out');
rewrite(fout);
writeln(fout,'-1');
close(fout);
{
writeln(t2-t1);
}
halt(0);
end;

begin
{
t1:=t2;
}
assign(fin,'divider.in');
reset(fin);
readln(fin,num,res);

n:=1;
vnum[1]:=num; vres[1]:=res;

rezu[0]:=1; rezu[1]:=1;
inmulnm(rezu,res,rezu);

cmmmc[0]:=1; cmmmc[1]:=1;
inmulnm(cmmmc,num,cmmmc);



while not seekeof(fin) do
  begin
    readln(fin,num,res);

    n:=n+1;
    vnum[n]:=num; vnum[n]:=res;

    fillchar(rs,sizeof(rs),false);

    rr:=rest(rezu,num);
    rs[rr]:=true;

    while (rr<>res) do
      begin
        adunanm(rezu,cmmmc,rezu);
        rr:=rest(rezu,num);

        if (rs[rr]) then
          begin
            nosol;
          end;
        rs[rr]:=true;

      end;

    calccmmdc(cmmmc,num); { intre cmmmc si num }
    inmulnm(cmmmc,num,cmmmc);
    impartenm(cmmmc,divy,cmmmc);

  end;

close(fin);

assign(fout,'divider.out');
rewrite(fout);

for i:=rezu[0] downto 1 do
  write(fout,rezu[i]);

writeln(fout);
close(fout);

{
writeln(t2-t1);
}
end.