{
  : .   
}

type
  Point = record x,y: longint; end;
  Segment = record A,B: Point; end;

var
  S: array[1..1000] of Segment;
  N,M: longint;
  TN: char;
  F: text;
  i: integer;

Procedure SwapPoint(var A,B: Point);
var
  W: Point;
begin
  W:=A;
  A:=B;
  B:=W;
end;


Function Det(A,B: Point): longint;
begin
  Det:=A.x*B.y-A.y*B.x;
end;


Function In_Shadow(T: Segment):Boolean;
var
  C: Point;
  Dist: longint;
  i: integer;

begin
  Dist:=T.A.x+T.A.y;

  C:=T.A;
  repeat
    for i:=1 to n do
      if   (S[i].A.x+S[i].A.y < Dist)
         and (Det(S[i].A,T.A)>=0)
         and (Det(T.A,S[i].B)>0)
         and (Det(C,S[i].B)>0)  then
        C:=S[i].B;
    if Det(C,T.A)=0 then
      begin
        In_Shadow:=false;
        exit;
      end;
    if Det(T.B,C)>=0 then
      begin
        In_Shadow:=true;
        exit;
      end;
    T.A:=C;
  until false;
end;


begin
   assign(F,'GLE.INP');
   reset(F);
   readln(F,N);
   for i:=1 to N do
     with S[i] do
       begin
         readln(F,A.x,A.y,B.x,B.y);
         if A.x < B.x then
           SwapPoint(A,B);
       end;
   close(F);

   M:=0;
   for i:=1 to N do
     if not In_Shadow(S[i]) then
       Inc(M);

   assign(F,'GLE.OUT');
   rewrite(F);
   writeln(F,M);
   close(F);
end.

