{     }

const
  scount = 48;
  gensq: array[1..scount] of string[3] = (
    'ai','ai' ,'aj' ,'aej','aek','afk','afl','agl','ag','ah', 'ah',
    'bi','bei','bej','bfj','bfk','bgk','bgl','bhl','bh',
    'ce','cei','cfi','cfj','cgj','cgk','chk','chl','cl',
    'de','de' ,'df' ,'dfi','dgi','dgj','dhj','dhk','dk','dl','dl',
    'ek','el' ,'el' ,'fl' ,
    'gi','hi' ,'hi' ,'hj');


Var
  maxs: array['a'..'l'] of integer;
  maxpossible: array[1..scount] of integer;
  given: array[1..scount] of integer;

procedure readIt;
Var
  F: text;
  c: char;
begin
  assign(F,'star.in'); reset(f);
  for c:='a' to 'l' do read(f, maxs[c]);
  close(f);
end;


function findMax: integer;
Var
  sum, i, min, j: integer;
  s: string;
begin
  sum:=0;

  for i:=1 to scount do
    begin
      s:=gensq[i]; min:=10;
      for j:=1 to length(s) do
        if maxs[s[j]] < min then min:=maxs[s[j]];

      given[i]:=min;
      maxpossible[i]:=min;
      sum := sum + min;
    end;
  findMax:=sum;
end;

function checkLetter(c: char): boolean;
Var
  i: integer;
begin
  checkLetter:=false;

  for i:=1 to scount do
    if pos(c, gensq[i]) <> 0 then
        if (given[i] > maxpossible[i]) or
           (given[i] > maxs[c]) then exit;

  checkLetter:=true;

  for i:=1 to scount do
    if pos(c, gensq[i]) <> 0 then
      if given[i] = maxs[c] then exit;

  checkLetter:=false;
end;

function check: boolean;
Var
  c: char;
begin
  check:=false;
  for c:='a' to 'l' do
    if not checkLetter(c) then exit;
  check:=true;
end;

function findMin: integer;
Var
  used: array['a'..'l'] of boolean;
  c: char;
  cover, maxcover, i2, i, result, saveI: integer;
  checkit, goOn: boolean;
  s: string;
begin
  fillChar(given, sizeOf(given), 0);
  fillChar(used, sizeOf(used), false);

  goOn:=true; result:=0;
  while goOn do
    begin
      goOn:=false; maxcover:=0;
      for c:='a' to 'l' do if not used[c] then
        begin
          for i:=1 to scount do
            begin
              s:=gensq[i];
              if pos(c, s) = 0 then continue;

              cover:=0; checkit:=true;

              for i2:=1 to ord(s[0]) do
                if not used[s[i2]] then
                  begin
                    if maxs[c] > maxs[s[i2]] then
                      begin checkit:=false; break; end;

                    if (maxs[c] = maxs[s[i2]]) and not used[s[i2]] then
                      inc(cover);
                  end;

              if checkIt then if maxcover < cover then
                begin
                  maxcover:=cover;
                  saveI:=i;
                end;
            end;

            if maxcover > 0 then
              begin
                s:=gensq[saveI];

                for i:=1 to ord(s[0]) do
                  if maxs[c] = maxs[s[i]] then
                    used[s[i]]:=true;

                inc(result, maxs[c]);

                goOn:=true;
              end;
            break;
        end;
    end;

  findMin:=result;
end;

Var
  min, max: integer;
  F: Text;
begin
  readIt;
  assign(F, 'STAR.OUT'); rewrite(F);
  max:=findMax;
  if not check then
    begin
      writeln(F, 'NO SOLUTION');
      close(F);
      exit;
    end;
  min:=findMin;
  writeln(F,min,' ',max);
  close(F);
end.