// Ilia Georgiev Trendafilov - Gabrovo  11-12 klas
#include <fstream.h>
#include <stdio.h>
#include <string.h>

#define RMAX 50

typedef int sum[32];

int n;
sum b,e;
int rc=0;
sum r[RMAX];
int mrc=RMAX;
sum mr[RMAX];

int m[4000];
int p[4000];

ifstream fin("sums.inp");
ofstream fout("sums.out");

int atoi(char *s)
{
  int x;
  sscanf(s,"%i",&x);
  return x;
}


void split(sum &a,char *s)
{
  char *t=strtok(s,"+");
  a[0]=0;
  while (t)
  {
    a[++a[0]]=atoi(t);
    t=strtok(NULL,"+");
  }
}

void sumout(sum x)
{
  fout << x[1];
  for (int i=2;i<=x[0];i++)
    fout << "+" << x[i];
  fout << endl;
}


void sumsort(sum &x)
{
  for (int i=1;i<=x[0];i++)
    for (int j=i+1;j<=x[0];j++)
      if (x[i]>x[j])
      {
	int y=x[i];x[i]=x[j];x[j]=y;
      }
}


int sumeq(sum a,sum b)
{
  int i=0;
  if (a[0]!=b[0]) return 0;
  while ((a[i]==b[i])&&(i<=a[0])) i++;
  return i>a[0];
}


sum mid;
sum cu;
sum pd;


void middel(int p)
{
  sum &x=mid;
  for (int i=p;i<x[0];i++)
  {
    x[i]=x[i+1];
    cu[i]=cu[i+1];
  }
  x[0]--;
}


void midsort()
{
  sum &x=mid;
  for (int i=1;i<=x[0];i++)
    for (int j=i+1;j<=x[0];j++)
      if (x[i]>x[j])
      {
	int y=x[i];x[i]=x[j];x[j]=y;
	y=cu[i];cu[i]=cu[j];cu[j]=y;
      }
}


void check()
{
  if (sumeq(mid,e))
  {
    if (mrc>rc)
    {
      mrc=rc;
      memcpy(mr,r,sizeof(mr));
    }
  }
}


void sumtry(int p)
{
  if (pd[p]) {sumtry(p+1);return;}
  if ((p>e[0])||(sumeq(mid,e))) {check();return;}

  sum x;
  int i,j;

  for (i=1;i<=mid[0];i++)
    if (cu[i]&&(mid[i]==e[p]))
    {
      cu[i]=0;
      sumtry(p+1);
      return;
    }

  for (i=1;i<=mid[0];i++)
    for (j=i+1;j<=mid[0];j++)
      if ((e[p]==mid[i]+mid[j])&&(cu[i])&&(cu[j]))
      {
	mid[i]+=mid[j];cu[i]=0;
	middel(j);
	midsort();
	memcpy(r[rc],mid,sizeof(mid));
	rc++;
	sumtry(p+1);
	rc--;
	return;
      }

  i=1;
  while ((mid[i]<e[p])&&(i<=mid[0])) i++;
  while ((cu[i]==0)&&(i<=mid[0])) i++;
  if (i<=mid[0])
  {
    mid[0]++;
    mid[mid[0]]=mid[i]-e[p];
    mid[i]=e[p];cu[i]=0;
    midsort();
    memcpy(r[rc],mid,sizeof(mid));rc++;
    sumtry(p+1);
    rc--;
    return;
  }

  i=1  ;while (!cu[i]) i++;
  j=i+1;while(!cu[j]) j++;
  mid[i]+=mid[j];
  middel(j);
  midsort();
  memcpy(r[rc],mid,sizeof(mid));
  rc++;
  sumtry(p);
  rc--;
}


void main()
{
  char s[100];
  fin >> n;
  fin >> s;split(b,s);
  fin >> s;split(e,s);
  sumsort(b);
  sumsort(e);
  if (sumeq(b,e))
  {
    fout << 0 << endl;
    return;
  }

  memset(pd,0,sizeof(pd));
  memcpy(mid,b,sizeof(mid));
  for (int i=1;i<=20;i++) cu[i]=1;

  for (i=1;i<=e[0];i++)
  {
    int j=1;
    while ((mid[j]!=e[i])&&(j<=mid[0])) j++;
    if (j<=mid[0])
    {
      cu[j]=0;
      pd[i]=1;
    }
  }

  sumtry(1);

  fout << mrc << endl;
  sumout(b);
  for (i=0;i<mrc;i++) sumout(mr[i]);
}