/*
   Vladimir Nikolaev Lalov
   NPMG "Akad. L. Chakalov", Sofia
   Compiler: BorlandC++ 3.1
*/

#include<stdio.h>
#include<stdlib.h>

#define MAX 101
#define TRUE 1
#define FALSE 0

int N;
int b[MAX];
int used[MAX];
int B[MAX];
int ans[MAX];

void load() {
 FILE *inp=fopen("stir.inp","r");
   fscanf(inp,"%d",&N);
   for (int i=1;i<=N-1;i++) {
      fscanf(inp,"%d",&b[i]);
   }
   fclose(inp);
}

int Gen() {
 int x;
   for (int i=1;i<=N-1;i++) {
      x=0;
      for (int j=i+1;j<=N;j++) {
	 if (ans[i]>ans[j]) x++;
      }
      B[i]=x;
   }
   for (int t=1;t<=N-1;t++) {
      if (B[t]!=b[t]) return 0;
   }
   return 1;
}

void Save() {
 FILE *out=fopen("stir.out","w");
   for (int i=1;i<=N;i++) {
      fprintf(out,"%d ",ans[i]);
   }
   fclose(out);
   exit(1);
}

void solve(int n) {
 int i;
   if (n>N) {
      if (Gen()==1) Save();
      else return;
   }

   for (i=b[n]+1;i<=N;i++) {
      if (used[i]==TRUE) continue;
      used[i]=TRUE;
      ans[n]=i;
      solve(n+1);
      used[i]=FALSE;
   }
}

void main() {
   load();
   for (int i=1;i<=N;i++) used[i]=FALSE;
   solve(1);
}