/*
  Vladimir Nikolaev Lalov
  NPMG "Akad. L. Chakalov", Sofia
  Compiler: BorlandC++ 3.1
*/
#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<ctype.h>

#define MAX 21
#define MAXSTR 100
typedef int Str[MAX];

int N;
int answer=0;
int nums1[MAX],nums2[MAX],deleted[MAX];
Str results[30];
int n1_len=0,n2_len=0,del_len=0;
char s1[MAXSTR];

void load() {
 FILE *inp=fopen("sums.inp","r");
 char str[MAXSTR],n[MAXSTR/2];
 int len,l;

   fscanf(inp,"%d",&N);

   fscanf(inp,"%s",str);
   len=strlen(str);
   strcpy(s1,str);

   for (int i=0;i<len;i++) {
      l=0;
      while (isdigit(str[i])) {
	 n[l]=str[i];
	 l++;
	 i++;
      }
      n[l]='\0';
      nums1[n1_len]=atoi(n);
      n1_len++;
   }
   //---------------------------------
   fscanf(inp,"%s",str);
   len=strlen(str);

   for (i=0;i<len;i++) {
      l=0;
      while (isdigit(str[i])) {
	 n[l]=str[i];
	 l++;
	 i++;
      }
      n[l]='\0';
      nums2[n2_len]=atoi(n);
      n2_len++;
   }
   fclose(inp);
   n1_len--;
   n2_len--;
}
void Bubble(int *arr,int len) {
 int t;
   for (int i=0;i<=len;i++) {
      for (int j=i+1;j<=len;j++) {
	 if (arr[i]<arr[j]) {
	    t=arr[i];
	    arr[i]=arr[j];
	    arr[j]=t;
	 }
      }
   }
}

void sort() {
   Bubble(nums1,n1_len);
   Bubble(nums2,n2_len);
   //qsort((void *)nums1,n1_len,1,comp);
   //qsort((void *)nums2,n2_len,1,comp);
}
//---------
int equal() {
   if (n1_len==0&&n2_len==0) return 1;
   //sort();
   if (n1_len!=n2_len) return 0;
   for (int i=1;i<=n1_len;i++) {
      if (nums1[i]!=nums2[i]) return 0;
   }
   return 1;
}
//----------
int in_nums2(int a) {
   for (int i=n2_len;i>=0;i--)
      if (nums2[i]==a) return i;
   return -1;
}

void del(int index,int *arr,int &len) {
   if (index==len) {
      arr[len]=0;
      len--;
      return;
   } else {
      for (int i=index;i<=len-1;i++) {
	 arr[i]=arr[i+1];
      }
      arr[len]=0;
      len--;
   }
}

void remove_eq() {
 int i,j;
   for (i=n1_len;i>=0;i--) {
      j=in_nums2(nums1[i]);
      if (j!=-1) {
	 deleted[del_len]=nums1[i];
	 del_len++;
	 del(i,nums1,n1_len);
	 del(j,nums2,n2_len);
      }
   }
}
void PrintMove() {
 int i,len=0;
   for (i=0;i<=n1_len;i++) {
      //printf("%d",nums1[i]);
      results[answer][len]=nums1[i];
      len++;
   }
   for (i=0;i<del_len;i++) {
      //printf("+%d",deleted[i]);
      results[answer][len]=deleted[i];
      len++;
      //if (i<del_len) printf("+");
   }
   results[answer][len]=-1;
}
//------------------
void solve() {
 int move_perf=0,d;
   while (!equal()) {
      remove_eq();
      sort();
      if (n1_len==-1) break;
      for (int i=0;i<=n1_len;i++) {
	 if (move_perf==1) break;
	 for (int j=0;j<=n2_len;j++) {
	    if (move_perf==1) break;

	    if (nums1[i]>nums2[j]) {
	       nums1[i]-=nums2[j];
	       nums1[n1_len+1]=nums2[j];
	       n1_len++;
	       move_perf=1;
	    } else {
	       //nums1[i]<nums2[j]
	       for (int x=i+1;x<=n1_len;x++) {
		  if (nums1[i]+nums1[x]<=nums2[j]) {
		     d=nums1[i]+nums1[x];
		     del(x,nums1,n1_len);
		     nums1[i]=d;
		     move_perf=1;
		     break;
		  }
	       }
	       /*
	       nums2[j]-=nums1[i];
	       nums2[n2_len+1]=nums1[i];
	       n2_len++;
	       move_perf=1;
	       */
	    }
	 }
      }
      answer++;
      move_perf=0;
      PrintMove();
   }
}
void DONE() {
 FILE *out=fopen("sums.out","w");
 int t;
   if (answer==0)
      fprintf(out,"0");
   else {
      fprintf(out,"%d\n",answer);
      fprintf(out,"%s\n",s1);
      for (int a=1;a<=answer;a++) {
	 t=0;
	 while (results[a][t]!=-1) {
	    fprintf(out,"%d",results[a][t]);
	    if (results[a][t+1]!=-1) fprintf(out,"+");
	    t++;
	 }
	 fprintf(out,"\n");
      }
   }

   fclose(out);
}

void main() {
   load();
   sort();
   solve();
   DONE();
   //printf("%d\n",answer);
}