{Maria Angelova}
{11-12 klas}
{gr.Pleven}
const inp = 'sums.inp';
      out = 'sums.out';

type TTarget = array[1..20] of byte;

     TBoolArr = array[1..20] of boolean;

     PNode = ^TNode;
     TNode = record
             d: byte;
             still: boolean;
             p: PNode;
             end;

     TRedA = record
             count: byte;
             el: array[1..20] of byte;
             end;

     TAnswer = record
             red: array[1.. 5000] of TRedA;
             br: integer;
             end;

var Fin, Fout: text;
    sum: byte;
    c: char;
    BrIn, BrOut: byte;
    target: TTarget;
    first, last: PNode;
    answer: TAnswer;
    still: TBoolArr;

{****************************************************************************}
Procedure Init;
var p: PNode;

  procedure CanStill;
  var j: byte;
  begin
  for j:=1 to BrOut do
    begin
    if still[j] then continue;
    if target[j] <> p^.d then continue;
    still[j]:= true;
    p^.still:= true;
    break;
    end;
  end;

begin
assign(Fin, inp); reset(Fin);
assign(Fout, out); rewrite(Fout);
readln(Fin, sum);
readln(Fin);
BrOut:= 0;
repeat
  inc(BrOut);
  read(Fin, c); Target[BrOut]:= ord(c) - 48;
  if eoln(Fin) then break;
  read(Fin, c); if c = '+' then continue;
  Target[BrOut]:= Target[BrOut]*10 + ord(c) - 48;
  if eoln(Fin) then break;
  read(Fin, c);
until false;
fillchar(still, sizeof(still), false);
close(Fin);

reset(Fin);
readln(Fin);
BrIn:= 0;
first:= new(PNode);
first^.d:= 0;
first^.p:= nil;
last:= first;
repeat
  inc(BrIn);
  p:= new(PNode);
  p^.p:= nil; p^.still:= false;
  last^.p:= p; last:= p;

  read(Fin, c); p^.d:= ord(c) - 48;
  if eoln(Fin) then
    begin CanStill; break; end;
  read(Fin, c);
  if c = '+' then
    begin CanStill; continue; end;
  p^.d:= p^.d * 10 + ord(c) - 48;
  if eoln(Fin) then
    begin CanStill; break; end;
  read(Fin, c);
  CanStill;
until false;

answer.br:= 0;
end;

{****************************************************************************}
Procedure Done;
var i, j: byte;
begin
writeln(Fout, answer.br-1);
for i:=1 to answer.br do
  with answer.red[i] do
    begin
    for j:=1 to count-1 do write(Fout, el[j], '+');
    writeln(Fout, el[count]);
    end;
close(Fin); close(Fout);
halt;
end;

{****************************************************************************}
procedure Print;
var p: PNode;
begin
inc(answer.br);
with answer.red[answer.br] do
  begin
  count:= 0;
  p:= first^.p;
  while p <> nil do
    begin
    inc(count);
    el[count]:= p^.d;
    p:= p^.p;
    end;
  end;
end;

{****************************************************************************}
procedure Split(var p: PNode; a,b: byte);
var pp: PNode;
begin
pp:= new(PNode);
pp^.d:= b;
pp^.still:= false;
p^.d:= a;
pp^.p:= p^.p;
p^.p:= pp;
end;

{****************************************************************************}
procedure Conn(var p1, p2: PNode);
var pp: PNode;
begin
p1^.d:= p1^.d + p2^.d;
if p2^.p<> nil then
  begin
  p2^.d:= p2^.p^.d;
  p2^.still:= p2^.p^.still;
  pp:= p2^.p;
  p2^.p:= pp^.p;
  dispose(pp); pp:= nil;
  end
else
  begin
  pp:=p1;
  while pp^.p^.p<>nil do pp:= pp^.p;
  dispose(pp^.p); pp^.p:= nil;
  last:= pp;
  end;
end;

{****************************************************************************}
function razbivane(d: byte; var ind1, ind2: byte): boolean;
var k: byte;
begin
for k:=1 to (d div 2) do
  begin
  ind1:= 1;
  while (ind1 <= BrOut)and((still[ind1])or(target[ind1] <> k)) do inc(ind1);
  if ind1 = BrOut+1 then continue;

  ind2:= 1;
  while (ind2 <= BrOut)and((still[ind2])or(target[ind2] <> d-k)or(ind1=ind2)) do inc(ind2);
  if ind2 = BrOut+1 then continue;

  razbivane:= true; exit;
  end;

razbivane:= false;
end;

{****************************************************************************}
function connect(p: PNode; var p2: PNode; var ind: byte): boolean;
var there: TBoolArr;
    i: byte;

begin
fillchar(there, sizeof(there), false);
for i:=1 to BrOut do
  begin
  if still[i] then continue;
  there[target[i]]:= true;
  end;

p2:= p^.p;
while p2<>nil do
  if there[p^.d + p2^.d] then
    begin
    for i:=1 to BrOut do
      if not still[i] then
        if target[i] = p^.d + p2^.d then break;
    ind:= i;
    connect:= true; exit;
    end
  else p2:= p2^.p;

connect:= false;
end;

{****************************************************************************}
Procedure Solve;
var i, j: byte;
    p, p2: PNode;

begin
print;
repeat
  p:= First^.p;
  while (p<>nil)and(p^.still) do p:= p^.p;
  if p = nil then DONE;

  if razbivane(p^.d, i, j) then
    begin
    still[i]:= true;
    still[j]:= true;
    split(p, target[i], target[j]);
    p^.still:= true;
    p^.p^.still:= true;
    print;
    continue;
    end;

  if connect(p, p2, i) then
    begin
    still[i]:= true;
    conn(p, p2);
    p^.still:= true;
    print;
    continue;
    end;

  i:=1; while still[i] do inc(i);
  if p^.d < target[i] then
    begin
    conn(p, p^.p);
    if p^.d = target[i] then
      begin p^.still:= true; still[i]:= true; end;
    print;
    continue;
    end;

  if p^.d = target[i] then
    begin
    p^.still:= true; still[i]:= true;
    print;
    continue;
    end;

  split(p, target[i], p^.d - target[i]);
  p^.still:= true; still[i]:= true;
  print;
until false;

end;

{****************************************************************************}
{****************************************************************************}
{****************************************************************************}
BEGIN
Init;
Solve;
Done;
END.
