#include <fstream>
#include <iostream>
#include <cstring>
#include <cstdio>

using namespace std;

#define min(a,b) (((a)<(b))?(a):(b))
#define INF 2000000

void readinp();
void gencombs(int num, int* pr, int prl, int last);
int thesame(int* p1, int *p2);
int dijkstra(int start, int end);

int n;
int pr1[20] = {0};
int pr2[20] = {0};
int pr1c = 0, pr2c = 0;
int pr1i = -1, pr2i = -1;
int comb[500][20];
int combc = 0;
int path[500][500];

//ofstream out("sums.out");

int main(){

  for(int i = 0; i < 500; i++){
    for(int j =0; j < 500; j++){
      path[i][j] =0;
    }
    for(int j = 0; j < 20; j++){
      comb[i][j] = 0;
    }
  }

  ofstream out("sums.out");

  readinp();

  if(thesame(pr1, pr2)){
    out << "0" << endl;
  }
  else{
    out << "1" << endl;
    int i;
    for(i = 0; i < pr1c-1; i++){
      out << pr1[i] << "+";
    }
    out << pr1[i] << endl;
    for(i = 0; i < pr2c-1; i++){
      out << pr2[i] << "+";
    }
    out << pr2[i] << endl;
  }

  int pr[20] = {0};
  gencombs(n, pr, 0, n);
  
//  dijkstra(pr1i, pr2i);
  
  return 0;
}

void readinp(){

  ifstream in("sums.inp");

  in >> n;
  char buff[200];
  in.getline(buff, 200);
  in.getline(buff, 200);
  char *start = buff;
  
  while(start[0] != 0){
    int tmp;
    sscanf(start, "%d", &tmp);
    pr1[pr1c++] = tmp;
    start = strchr(start, '+') + 1;
  }

  in.getline(buff, 200);
  start = buff;
  while(start[0] != 0){
    int tmp;
    sscanf(start, "%d", &tmp);
    pr2[pr2c++] = tmp;
    start = strchr(start, '+') + 1;
  }
}

void gencombs(int num, int* pr, int prl, int last){
  if(num == 0){
    for(int i = 0; i < prl; i++){
      comb[combc][i] = pr[i];
      //out << pr[i] << " ";
    }
    if(pr1i == -1 && thesame(pr, pr1)){
      pr1i =combc;
    }
    if(pr2i == -1 && thesame(pr, pr2)){
      pr2i = combc;
    }
    combc++;
    //out << endl;
  }
  for(int i = 1; i <= min(last, num); i++){
    pr[prl] = i;
    gencombs(num - i, pr, prl + 1, i);
  }
}

int thesame(int* p1, int *p2){
   int i;
   for(i = 0; p1[i] != 0 && p2[i] != 0; i++){
     if(p1[i] != p2[i])
       return 0;
   }
   if(p1[i] == 0 && p2[i] == 0)
     return 1;

   return 0;
}
/*
int dijkstra(int start, int end){
   int visited[500];
   int parent[500];
   int path[500];

   for(int i = 0; i < 500; i++){
     path[i] = INF;
     parent[i] = 0;
     visited[i] = 0;
   }

   path[start] = 0;
   parent[start] = -1;

   while(1){

     int bi = -1;
     int best;
     for(int i = 0; i < combc; i++){
       if(path[i] != INF && path[i] < best){
         best = path[i];
         bi = i;
       }
     }
     if(bi == -1) break;

     
   }
} */
