{
        Stoyan Tsonev Hristov 11 Klas
        MG Russe
}
Const
        InFile = 'sums.inp';
        OutFile = 'sums.out';

Type
        TSum = array[1..20] of byte;

Var
        FIn,FOut : Text;
        a,b      : TSum;
        sum,i,j  : byte;
        s        : string;
        best     : integer;
        bestPath : array [1..20] of TSum;
        Path     : array [1..20] of TSum;

function get(var s : string) : byte;
var
        s1 : string;
        i,j : integer;
begin
        while pos(' ',s) <> 0 do
                delete(s,pos(' ',s),1);
        s1 := copy(s,1,pos('+',s)-1);
        delete(s,1,pos('+',s));
        val(s1,i,j);
        get := i;
end;

function equal(a,b :  TSum) : boolean;
var
        i : integer;
begin
        for i := 1 to 20 do
                if a[i] <> b[i] then begin
                        equal := false;
                        exit;
                end;

        equal := true;
end;

function min(a,b : byte) : byte;
begin
        if a < b then
                min := a
        else
                min := b;
end;

procedure rem(var a,b : TSum);
var
        i,t : integer;
begin
        for i := 1 to 20 do begin
                t := min(a[i],b[i]);
                a[i] := a[i] - t;
        end;

end;

procedure rec(a,b : TSum; level : integer);
var
        i,j   : integer;
        c     : TSum;

begin
        if (level >= best) or (level > 7) then
                exit;

        path[level+1] := a;

        if equal(a,b) then begin
                best := level;
                for i := 1 to level+1 do
                        bestPath[i] := path[i];
                exit;
        end
        else begin
                c := a;
                rem(a,b);
                for i := 2 to 20 do begin
                        if a[i] > 0 then begin
                                dec(a[i]);      dec(c[i]);
                                for j := 1 to i div 2 do begin
                                        inc(c[j]);
                                        inc(c[i-j]);
                                        rec(c,b,level+1);
                                        dec(c[j]);
                                        dec(c[i-j]);
                                end;
                                inc(c[i]);
                                inc(a[i]);
                        end;
                end;
                for i := 1 to 20 do begin
                        if a[i] > 0 then begin
                                dec(a[i]); dec(c[i]);
                                for j := i to 20 do
                                        if a[j] > 0 then begin
                                                dec(c[j]);
                                                inc(c[j+i]);
                                                rec(c,b,level+1);
                                                inc(c[j]);
                                                dec(c[j+i]);
                                        end;

                                inc(c[i]);
                                inc(a[i]);
                        end;
                end;
        end;
end;

procedure solve;
var
        i   : integer;
        f   : boolean;
        j,k : integer;

begin
        if equal(a,b) then
                writeln(FOut,0)
        else begin
                best := maxint;
                rec(a,b,0);
                writeln(FOut,best);
                for i := 1 to best + 1 do begin
                    f := false;
                    for j := 1 to 20 do
                        for k := 1 to bestPath[i][j] do begin
                                if f then
                                        write(FOut,'+',j)
                                else begin
                                        write(FOut,j);
                                        f:= true;
                                end;
                        end;
                    writeln(FOut);
                end;
        end;
end;

Begin
        assign(FIn,InFile);     reset(FIn);
        assign(FOut,OutFile);   rewrite(FOut);
        readln(FIn,sum);

        fillchar(a,sizeof(a),0);
        fillchar(b,sizeof(b),0);

        readln(FIn,S); s := s + '+';
        i := 0;

        while i < sum do begin
                j := get(s);
                inc(a[j]);
                i := i + j;
        end;

        readln(Fin,S); s := s + '+';
        i := 0;
        while i < sum do begin
                j := get(S);
                inc(b[j]);
                i := i + j;
        end;
        close(FIn);
        solve;
        close(FOut);
End.
