{Georgy Hristov Kadrev}
{MG "Baba Tonka" - Ruse}
{11z klas}

const
 FIn  = 'COMP.INP';
 FOut = 'COMP.OUT';

 MaxN = 131072;

type
 Rec = Record
        Dist,
        Parent,
        Comps,
        Length : LongInt;
        Leave  : Boolean;
       End;

var
 F1,F2 : Text;
 A     : Array[1..MaxN] Of Rec;
 N,K,I : LongInt;

 Function Find(V : Integer) : LongInt;
 Var
  Res : LongInt;
  II  : Integer;
 Begin
  If A[V].Leave Then
   Begin
    If A[V].Comps = 0
     Then Res := 0
     Else
      Begin
       Res := A[V].Length * 2 * (A[V].Comps div K);
       If (A[V].Comps mod K) <> 0 Then Res := Res + A[V].Length * 2;
      End;

    Find := Res;
    Exit;
   End;

  Res := 0;

  For II:=1 To N Do
   If A[II].Parent = V Then
    Begin
     Res := Res + Find(II);
     A[V].Comps := A[V].Comps + A[II].Comps;

     If V <> 1 Then
      Begin
       If A[V].Comps = 0
       Then Res := 0
       Else
        Begin
         Res := Res + A[V].Length * 2 * (A[V].Comps div K);
         If (A[V].Comps mod K) <> 0 Then Res := Res + A[V].Length * 2;
        End;
      End;
    End;

  Find := Res;
 End;

Begin
 Assign(F1, FIn);
 Reset(F1);

 Readln(F1, N, K);

 For I:=1 To N Do
  A[I].Leave := True;

 While not EoF(F1) Do
  Begin
   Read(F1, I);
   Readln(F1, A[I].Parent, A[I].Comps, A[I].Length);
   A[A[I].Parent].Leave := False;
  End;

 Close(F1);

 Assign(F2, FOut);
 Rewrite(F2);

 Writeln(F2, Find(1));

 Close(F2);
End.
