{Dimitar Mitkov Kunchev, 11 nov klas, MG - Ruse}
  CONST FINN  = 'SUMS.inp';
        FOUTN = 'SUMS.out';

  Type Sum = Array [0..19] of Integer;

  Var Fin,Fout  : Text;
      N         : Integer;
      S1,S2     : Sum;
      S1L,S2L   : Integer;
      Table     : Array [1..36,1..840] of Sum;
      TL,TR     : Integer;

  Procedure Init;
      Var S         : String;
          C         : Char;
          EC        : Integer;
          k         : Integer;
    Begin
      Assign(Fin,FINN);
      Assign(Fout,FOUTN);
      Reset(Fin);
      Rewrite(Fout);
      Readln (Fin,N);
      While Not Eoln(Fin) Do
        begin
          S:='';
          Repeat
            If Not Eoln(Fin) Then Read (Fin,C);
            If (C='1') OR (C='2') OR (C='3') OR (C='4') Or (C='5') OR
               (C='6') OR (C='7') OR (C='8') OR (C='9') Or (C='0') Then Insert(C,S,Length(S)+1);
          Until (C='+') Or Eoln(Fin);
          Val (S,K,EC);
          Inc(S1L);
          S1[S1L]:=K;
        end;
      S2L:=0;
      While Not Eof(Fin) Do
        begin
          S:='';
          Repeat
            If Not Eof(Fin) Then Read (Fin,C);
            If (C='1') OR (C='2') OR (C='3') OR (C='4') Or (C='5') OR
               (C='6') OR (C='7') OR (C='8') OR (C='9') Or (C='0') Then
               Insert(C,S,Length(S)+1);
          Until (C='+') Or Eof(Fin);
          Val (S,K,EC);
          Inc(S2L);
          S2[S2L]:=K;
        end;
      Close(Fin);
    End;

  Procedure RemSim (var Old,Lt : Sum);
      var F,G,U,X : ShortInt;
          OL      : Integer;
          Res     : Boolean;
    begin
      OL:=0;
      U:=0;
      Repeat
        Inc(OL);
      Until Old[OL+1]=0;
      F:=0;
      Res:=False;
      repeat
        If Not Res Then Inc(F);
        G:=1;
        Res:=False;
        repeat
          If (Old[F]=Old[G]) And (F<>G) Then
            Begin
              Inc(U);
              Lt[U]:=Old[F];
              Dec (OL);
              For X:=F To OL Do
                Old[X]:=Old[X+1];
              Res:=true;
              Dec (F);
            end;
          Inc(G);
        until (G>=F) Or Res;
      until (F=OL) And not (Res);
    end;

  Procedure BuildTable;
      Var Q,J,NC,P,Z,K : Integer;
          OS           : Sum;
          Sim          : Sum;
          PCL,PCR      : Integer;
    Begin
      TL:=1;
      Table[1,1]:=S1;
      PCl:=1;
      Repeat
        Inc(TL);
        NC:=0;
        For Q:=1 To PCL Do
          Begin
            OS:=Table[TL-1,Q];
            RemSim(OS,Sim);
            J:=2;
            Repeat
              For Z:=1 To J-1 Do
                begin
                  Inc(NC);
                  For P:=1 To Z-1 Do Table[TL,NC][P]:=OS[P];
                  Table[TL,NC][Z]:=OS[J]+OS[Z];
                  For P:=Z+1 To J-1 Do
                    Table[TL,NC][P]:=OS[P];
                  Inc(P);
                  While (Not OS[P+1]=0) And (P<19) Do
                    begin
                      Table[Tl,NC][P]:=OS[P+1];
                      Inc(P);
                    end;
                  K:=1;
                  While Not Sim[K]=0 Do
                    begin
                      Table[TL,NC][P+K]:=Sim[K];
                      Inc(K);
                    end;
                  Table[TL,NC][0]:=Q;
                end;
              Inc(J);
            Until (Table[TL-1,Q][J+1]=0) Or (J=19);
            Inc(Q);
          End;
        PCL:=NC;
      Until Table[TL,1][2]=0;
{*********}
      TR:=36;
      Table[36,1]:=S2;
      PCR:=1;
      Repeat
        Dec(TR);
        Q:=1;
        NC:=0;
        For Q:=1 To PCR Do
          Begin
            OS:=Table[TR+1,Q];
            RemSim(OS,Sim);
            J:=2;
            Repeat
              For Z:=1 To J-1 Do
                begin
                  Inc(NC);
                  For P:=1 To Z-1 Do Table[TR,NC][P]:=OS[P];
                  Table[TR,NC][Z]:=OS[J]+OS[Z];
                  For P:=Z+1 To J-1 Do
                    Table[TR,NC][P]:=OS[P];
                  Inc(P);
                  While (Not OS[P+1]=0) And (P<19) Do
                    begin
                      Table[TR,NC][P]:=OS[P+1];
                      Inc(P);
                    end;
                  K:=1;
                  While Not Sim[K]=0 Do
                    begin
                      Table[TR,NC][P+K]:=Sim[K];
                      Inc(K);
                    end;
                  Table[TR,NC][0]:=Q;
                end;
              Inc(J);
            Until (Table[TR-1,Q][J+1]=0) Or (J=19);
            Inc(Q);
          End;
        PCR:=NC;
      Until Table[TR,1][2]=0;
    End;

  Procedure FindSimilar;
      Var I,J,Q,W,Z   : ShortInt;
          Found       : Boolean;
          FI,FJ,FQ,FW : Integer;
          M           : Array [1..38] of Sum;
          NQ,NW       : Integer;
    begin
      Found:=False;
      For I:=1 To Tl Do
        For J:=36 Downto TR Do
          begin
            Q:=1;
            while (Not Table[I,Q][1]=0) And (not Found) Do
              begin
                W:=0;
                while (not Table[J,W][1]=0) And (Not Found) Do
                  begin
                    Z:=1;
                    while Table[J,W][Z]=Table[I,Q][Z] Do
                      Inc(Z);
                    If Z=19 Then
                      Begin
                        Found:=True;
                        FI:=I;
                        FJ:=J;
                        FQ:=Q;
                        FW:=W;
                      End;
                  end;
              end;
          end;
      NQ:=FQ;
      NW:=FW;
      For I:=FI Downto 1 Do
        begin
          M[I]:=Table[I,NQ];
          NQ:=Table[I,NQ][0];
        end;
      For J:=FJ To 36 Do
        begin
          M[J]:=Table[J,NW];
          NW:=Table[J,NW][0];
        end;
      For I:=1 To 36 Do
        begin
          If M[I][1]<>0 Then
            begin
              J:=0;
              while (M[I][J+1]<>0) And (J<20) Do
                begin
                  Inc(J);
                  Write(Fout,M[I][J],'+');
                end;
              Writeln (Fout,M[I][J+1]);
            end;
        end;
      Close(Fout);
    end;

BEGIN
  Init;
  BuildTable;
  Findsimilar;

END.
