/*
NAME: Ivan Anev
SCHOOL: SMG
CLASS: 11a
PROBLEM: sums
*/

#include <stdio.h>

#define MAXN 20
#define MAXLEN 30000

char str[MAXLEN];
int len = 0;

void shl(int a[], int n, int p) {
     while (p < n - 1) {
           a[p] = a[p+1];
           ++p;
     }
}

void shr(int a[], int n, int p) {
     int i;

     for (i = n; i > p; --i)
         a[i] = a[i-1];
}

int numlen(int n) {
    int i;

    i = 0;
    while (n > 0) {
          n /= 10;
          ++i;
    }

    return i;
}

void print(int a[], int n) {
     int i;

     for (i = 0; i < n - 1; ++i) {
         sprintf(str + len, "%d+", a[i]);
         len += numlen(a[i]) + 1;
     }
     sprintf(str + len, "%d\n", a[i]);
     len += numlen(a[i]) + 1;
}

int main(void) {
    FILE *fin, *fout;
    int n, m, s, i, st[MAXN], en[MAXN];
    char c;

    fin = fopen("sums.inp", "r");
    fout = fopen("sums.out", "w");

    fscanf(fin, "%d\n", &n);
    s = 0;
    do {
       if (fscanf(fin, "%d%c", &st[s++], &c) == -1)
          break;
    }
    while (c == '+');

    i = 0;
    do {
       if (fscanf(fin, "%d%c", &en[i++], &c) == -1)
          break;
    }
    while (c == '+');

    m = 0;
    print(st, s);
    while (1) {
          for (i = 0; i < s && st[i] == en[i]; ++i)
              ;
          if (i == s)
             break;
          ++m;
          if (st[i] > en[i]) {
             shr(st, s, i + 1);
             ++s;
             st[i+1] = st[i] - en[i];
             st[i] = en[i];
          }
          else {
               if (st[i] + st[i+1] <= en[i]) {
                  st[i] += st[i+1];
                  shl(st, s, i + 1);
                  --s;
               }
               else {
                    shr(st, s, i + 2);
                    ++s;
                    st[i+2] = st[i] + st[i+1] - en[i];
                    st[i+1] -= st[i+2];
               }
          }
          print(st, s);
    }

    fprintf(fout, "%d\n", m);
    if (m > 0)
       fprintf(fout, "%s", str);

    fclose(fin);
    fclose(fout);
    
    return 0;
}
