/* Nikolai Krasimirov Marinov, Shumen */
#include <fstream.h>
#include <string>
#include <stdlib.h>

  int A[100];
  int abr;
  int B[100];
  int bbr;
  int n;
  int C[50][100];
  int cbr;
  string s1;
  string s2;

  ifstream fin ("sums.inp");
  ofstream fout ("sums.out");

  void ReadData ()
    {
      fin >> n;
      fin >> s1;
      fin >> s2;
      int bit = 1;
      for (int i = 0; i <= s1.length () - 1; i++)
        {
          if (!(i&bit))
            {
              char c = s1[i];
              A[abr] = atoi (&c);
              abr++;
            }
        }
      for (int i = 0; i <= s2.length () - 1; i++)
        {
          if (!(i&bit))
            {
              char c = s2[i];
              B[bbr] = atoi (&c);
              bbr++;
            }
        }
    }

  int comp (const void *e1, const void *e2)
    {
      return (*(int*)e1 - *(int*)e2);
    }

  int Ed ()
    {
      return (s1 == s2);
    }

  void Copy ()
    {
      for (int i = 1; A[i - 1]; i++)
        C[cbr][i] = A[i - 1];
      cbr++;
    }

  void Shift ()
    {
      for (int i = abr; A[i]; i++)
        {
          A[i] = A[i + 1];
        }
    }

  void Solve ()
    {
      abr--;
      bbr--;
      while (abr != 0 || bbr != 0)
        {
          if (A[abr] == B[bbr])
            {
              abr--;
              bbr--;
            }
              else
                if (A[abr] > B[bbr])
                  {
                    int x = A[abr];
                    A[abr] = B[bbr];
                    abr++;
                    A[abr] = x - B[bbr];
                    qsort (A, abr + 1, sizeof (int), comp);
                    qsort (B, bbr + 1, sizeof (int), comp);
                    Copy ();
                  }
                    else
                      {
                        for (int i = abr - 1; i >= 0; i--)
                          if (A[abr] + A[i] <= B[bbr])
                            {
                              A[i] += A[abr];
                              Shift ();
                            }
                        abr--;
                        qsort (A, abr + 1, sizeof (int), comp);
                        qsort (B, bbr + 1, sizeof (int), comp);
                        Copy ();
                      }
        }
    }

  void WriteData ()
    {
      fout << cbr << endl;
      if (cbr != 0)
        {
          fout << s1 << endl;
          for (int i = 0; i <= cbr; i++)
            {
              for (int j = 1; C[i][j]; j++)
                if (C[i][j + 1])
                  fout << C[i][j] << "+";
                    else
                      fout << C[i][j];
                  fout << endl;
            }
            }
    }

  int main ()
    {
      ReadData ();
      qsort (A, abr, sizeof (int), comp);
      qsort (B, bbr, sizeof (int), comp);
      if (Ed ())
        fout << 0 << endl;
          else
            {
              Solve ();
              WriteData ();
            }
      return 0;
    }
