/*
NAME   : Valentin Stoianov Mihov
CLASS  : 11/12
CITY   : Varna
TASK   : SUMS
*/

#include <stdio.h>
#include <vector>
#include <string.h>
#define INPF "sums.inp"
#define OUTF "sums.out"

int n,kind=0;
vector<int> pr1,pr2;
vector<int> add1,add2;
int ready1[200],ready2[200],br=0;
char lines[200][200];

void Init()
  {
    FILE *f=fopen(INPF,"rt");
    int num;
    char ch;
    fscanf(f,"%d",&n);
    do
      {
        fscanf(f,"%d%c",&num,&ch);
        pr1.push_back(num);
      }
    while(ch!='\n');
    do
      {
        fscanf(f,"%d%c",&num,&ch);
        pr2.push_back(num);
      }
    while(ch!='\n');
    fclose(f);
    memset(ready1,0,sizeof(ready1));
    memset(ready2,0,sizeof(ready2));
  }

void printMas(vector<int> p)
  {
    char a[100];
    br++;
    for(int i=0;i<p.size()-1;i++)
      {
        sprintf(a,"%d+",p[i]);
        strcat(lines[br],a);
      }
    sprintf(a,"%d\n",p[p.size()-1]);
    strcat(lines[br],a);
  }

void MarkReady()
  {
    for(int i=0;i<pr1.size();i++)
      for(int j=0;j<pr2.size();j++)
        if(pr1[i]==pr2[j] && !ready1[i] && !ready2[j]) ready1[i]=ready2[j]=1;
  }

void Solve()
  {
    int ost,found=0;
    printMas(pr1);
    MarkReady();
    do
      {
        found=0;
        for(int i=0;i<pr1.size() && !found;i++)
          for(int j=0;j<pr2.size() && !found;j++)
            if(pr1[i]>pr2[j] && !ready1[i] && !ready2[j])
              {
                ost=pr1[i]-pr2[j];
                pr1[i]=ost;
                pr1.push_back(pr2[j]);
                found=1;
              }
        MarkReady();
        if(found) printMas(pr1);
      }
    while(found);
    for(int i=0;i<pr1.size();i++)
      if(!ready1[i]) add1.push_back(i);
/*    for(int i=0;i<pr2.size();i++)
      if(!ready2[i]) add2.push_back(i);*/
    if(add1.size()>0)
    for(int j=0;j<add1.size()-1;j++)
      {
        pr1[add1[j]]+=pr1[add1[j+1]];
        for(int i=add1[j+1];i<pr1.size()-1;i++)
          pr1[i]=pr1[i+1];
        pr1.pop_back();
        printMas(pr1);
        for(int k=j;k<add1.size();k++)
           add1[k]--;
      }
//    if(pr1!=pr2) printMas(pr2);
  }

void Outputeq()
  {
    FILE *f=fopen(OUTF,"wt");
    fprintf(f,"0\n");
    fclose(f);
    exit(0);
  }

void Output()
  {
    FILE *f=fopen(OUTF,"wt");
    fprintf(f,"%d\n",br-1);
    if(kind==2)
      {
        for(int i=br;i>=0;i--)
          fprintf(f,"%s",lines[i]);
      }
     else
      {
        for(int i=0;i<=br;i++)
          fputs(lines[i],f);
      }
    fclose(f);
  }

void main()
  {
    Init();
    MarkReady();
    for(int i=0;i<pr1.size();i++)
      for(int j=0;j<pr2.size();j++)
        if(pr1[i]>pr2[j] && !ready1[i] && !ready2[j]) kind=1;
                     else if(pr2[i]>pr1[j] && !ready1[i] && !ready2[j]) kind=2;
    if(!kind) Outputeq();
    if(kind==2) pr1.swap(pr2);
    Solve();
    Output();
  }
