{TEODOR SASHEV PARVANOV, VELIKO TURNOVO, 11 class}
Program Sums;
Const InpFile = 'sums.inp';
      OutFile = 'sums.out';

Var F       : Text;
    N       : Byte;
    S1,S2   : String;
    Count   : Word;
    Opers   : Array[1..200] of String;
    L       : Integer;
    S1t,S2t : String;


Procedure LoadFromFile;
Begin
 Assign(F,InpFile);
 Reset(F);
 ReadLn(F,N);
 ReadLn(F,S1);
 ReadLn(F,S2);
 Close(F);
end;

Function IntToStr(Value : Integer) : String;
Var S : String;
Begin
 Str(Value,S);
 IntToStr := S;
end;

Function StrToInt(Value : String) : Integer;
Var Int       : Integer;
    ErrorCode : Integer;
Begin
 Val(Value,Int,ErrorCode);
 StrToInt := Int;
end;

Procedure SortString(Var S : String);
Var A      : Array[1..255] of Integer;
    Sorted : Boolean;
    I      : Integer;
    Temp   : String;
    C      : Integer;

  Procedure Swap(Var A,B : Integer);
  Var T : Integer;
   Begin
    T := A;
    A := B;
    B := T;
   end;

Begin
 I := 1;
 C := 0;
 While I <= Length(S) do
  Begin
   Temp := '';
   While (S[I] <> '+') and (I <= Length(S)) do Begin Temp := Temp + S[I]; Inc(I) end;
   Inc(I);
   Inc(C);
   A[C] := StrToInt(Temp);
  end;
 Repeat
  Sorted := TRUE;
  For I := 1 to C-1 do
  If A[I] < A[I+1] then
   Begin
    Swap(A[I],A[I+1]);
    Sorted := FALSE;
   end;
 until Sorted;
 S := '';
 For I := 1 to C do
  Begin
   S := S + IntToStr(A[I]);
   If I < C then S := S + '+';
  end;
end;

Procedure Step1(Var S : String; Position : Byte; Num1, Num2 : Integer);
Var I,C  : Byte;
Begin
 I := Position;
 C := 0;
 While (S[I] <> '+') and (I <= Length(S)) do Begin Inc(I); Inc(C); end;
 Delete(S,Position,C);
 Insert(IntToStr(Num2) + '+' + IntToStr(Num1 - Num2),S,Position);
end;

Procedure Step2(Var S : String; Position : Byte {The position of the + sign});
Var I,C   : Byte;
    Temp  : String;
    Num   : Integer;
    St    : Integer;
    Count : Integer;
    Start : Integer;
    Inver : String;

Begin
 Count := 0;
 I := Position;
 C := 0;
 Temp := '';
 Inc(I);
 While (S[I] <> '+') and (I <= Length(S)) do Begin Inc(C); Temp := Temp + S[I]; Inc(I); end;
 Inc(Count,C);
 Num := StrToInt(Temp);
 I := Position;
 C := 0;
 Temp := '';
 Dec(I);
 While (S[I] <> '+') and (I >= 1) do Begin Inc(C); Temp := Temp + S[I]; Dec(I); end;
 Start := I+1;
 Inc(Count,C+1);

 Inver := '';
 For I := Length(Temp) downto 1 do Inver := Inver + Temp[I];

 Inc(Num,StrToInt(Inver));
 Delete(S,Start,Count);
 Insert(IntToStr(Num),S,Start);
end;

Procedure Solve;
Var NumSteps  : Integer;
    IS1,IS2   : Byte;
    Num1,Num2 : Integer;

Function GetNextNumber(S : String; Var IS : Byte) : Integer;
Var Temp : String;
Begin
 Temp := '';
 Inc(IS);
 While (S[IS] <> '+') and (IS <= Length(S)) do Begin Temp := Temp + S[IS]; Inc(IS); end;
 GetNextNumber := StrToInt(Temp);
end;

Function GetPrevNumber(S : String; Var IS : Byte) : Integer;
Var Temp  : String;
    Inver : String;
    I     : Byte;
Begin
 Temp := '';
 Dec(IS);
 While (S[IS] <> '+') and (IS >= 1) do Begin Temp := Temp + S[IS]; Dec(IS); end;
 Inver := '';
 For I := Length(Temp) downto 1 do Inver := Inver + Temp[I];
 GetPrevNumber := StrToInt(Inver);
end;

Begin
 Opers[1] := S1t;
 Count := 1;
 Repeat
 IS1 := 0;
 IS2 := 0;

 While IS1 <= Length(S1) do
  Begin
   Num1 := GetNextNumber(S1,IS1);
   Num2 := GetNextNumber(S2,IS2);
   If (Num1 <> 0) and (Num2 <> 0) then
   Begin
   If Num1 < Num2 then Begin
                        Step2(S1,IS1);
                        Inc(Count);
                        Opers[Count] := S1;
                        SortString(S1); Break;
                       end;
   If Num1 > Num2 then Begin
                        GetPrevNumber(S1,IS1);
                        Step1(S1,IS1+1,Num1,Num2);
                        Inc(Count); Opers[Count] := S1;
                        SortString(S1); Break;
                       end;
   end;
  end;
{  SortString(S1);}
 until S1 = S2;
end;

Begin
 LoadFromFile;
 S1t := S1; S2t := S2;
 SortString(S1);
 SortString(S2);
 If S1 <> S2 then Solve
             else Count := 1;
 Assign(F,OutFile);
 Rewrite(F);
 Write(F,Count-1);
 If Count > 1 then WriteLn(F);
 Opers[1] := S1t;
 Opers[Count] := S2t;
 If Count > 1 then For L := 1 to Count do
 Begin
   Write(F,Opers[L]);
   If L < Count then WriteLn(F);
  end;
 Close(F);
end.
