{Haralamby Haralambiev | 10A klas | Burgas}
type
  point = record
     x1,y1,x2,y2 : longint;
  end;
  rect = record
    no : longint;
    dist : real;
  end;
var
  a                             : array[1..20] of point;
  b                             : array[1..20,1..20] of rect;
  n,k                           : longint;
  fi,fo                         : text;

procedure input;
var
  i : longint;
  t : point;
begin
  readln(fi,n);
  for i:=1 to n do begin
    readln(fi,a[i].x1,a[i].y1,a[i].x2,a[i].y2);
    with a[i] do begin
      if x1<=x2 then begin t.x1:=x1; t.x2:=x2; end else begin t.x1:=x2; t.x2:=x1; end;
      if y1<=y2 then begin t.y1:=y1; t.y2:=y2; end else begin t.y1:=y2; t.y2:=y1; end;
    end;
    a[i]:=t;
  end;
end;

procedure output;
var
  i,j : longint;
begin
  for i:=1 to n do begin
    for j:=1 to n-1 do if j<n-1 then write(fo,b[i,j].no,' ') else write(fo,b[i,j].no);
    writeln(fo);
  end;
end;

procedure sort(z,l,r:longint);
var
  i,j,tmp2 : longint;
  mid : real;
  tmp : rect;

begin
  i:=l; j:=r; mid:=b[z,((i+j) div 2)].dist;
  repeat
    while b[z,i].dist<mid do inc(i);
    while b[z,j].dist>mid do dec(j);
    if i<=j then begin
      tmp:=b[z,i]; b[z,i]:=b[z,j]; b[z,j]:=tmp;
      if (b[z,i].dist=b[z,j].dist) and (b[z,i].no>b[z,j].no) then
        begin tmp2:=b[z,i].no; b[z,i].no:=b[z,j].no; b[z,j].no:=tmp2; end;

      inc(i); dec(j);
    end;
  until i>j;

  if i<r then sort(z,i,r);
  if j>l then sort(z,l,j);
end;

procedure finddist(p,q : longint);
var
  dst : real;
  tmp,zz : longint;
begin
  zz:=p;
  if a[p].y1>a[q].y1 then begin tmp:=p; p:=q; q:=tmp; end;

  if (a[p].x1<=a[q].x1) and (a[p].x2>=a[q].x1) and (a[p].y2>=a[q].y1) then dst:=0 else
  if (a[p].x1<=a[q].x2) and (a[p].x2>=a[q].x2) and (a[p].y2>=a[q].y1) then dst:=0 else
  if (a[p].x1<=a[q].x1) and (a[p].x2>=a[q].x1) then dst:=abs(a[p].y2-a[q].y1) else
  if (a[p].x1<=a[q].x2) and (a[p].x2>=a[q].x2) then dst:=abs(a[p].y2-a[q].y1) else
  if (a[p].y2>=a[q].y1) then dst:=abs(a[p].x2-a[q].x1) else
  if (a[p].x2<a[q].x1) and (a[p].y2<a[q].y1) then dst:=sqrt(sqr(a[p].x2-a[q].x1)+sqr(a[p].y2-a[q].y1)) else
  if (a[p].x1>a[q].x2) and (a[p].y2<a[q].y1) then dst:=sqrt(sqr(a[p].x1-a[q].x2)+sqr(a[p].y2-a[q].y1));

  if zz<>p then begin tmp:=p; p:=q; q:=tmp; end;
  b[p,q].no:=q; b[p,q].dist:=dst;
end;

procedure go(x:longint);
var
  j : longint;
  temp : rect;
begin

  for j:=1 to n do if x<>j then finddist(x,j);
  temp:=b[x,x]; b[x,x]:=b[x,n]; b[x,n]:=temp;
  sort(x,1,n-1);
end;

begin
  assign(fi,'dist.inp'); reset(fi); assign(fo,'dist.out'); rewrite(fo);

  input;
  for k:=1 to n do go(k);
  output;

  close(fi); close(fo);
end.