{$MODE objfpc}

Uses
  SysUtils;

Var
  N : Integer;
  Pos : Array[1..300] Of Integer;
  leakspd : Array[1..300] Of Integer;
  closed : Array[1..300] Of Boolean;
  tmp : Integer;
  bestStart, bestleak : Integer;
  cleak : Integer;
  cleakspd : Integer;
  CStart : Integer;
  starttime : Word;

Const
  timeout = 88;

Procedure WriteOut(cl, start : Integer);

Var
  F : Text;

Begin
  ASSign(F, 'DRAIN.OUT');
  Rewrite(F);
  Writeln(F, cl);
  Writeln(F, start);
  Close(F);
  Halt;
End;

Procedure ReadIn;

Var
  F : Text;
  I : Integer;

Begin
  ASSign(F, 'DRAIN.INP');
  Reset(F);
  Readln(F, N);
  For I := 1 To N Do
    Readln(F, Pos[I], leakspd[I]);
  Close(F);
  If N = 1 Then
    WriteOut(0, 1);
End;

Procedure Dig(Q : Integer);

Var
  I : Integer;
  allclosed : Boolean;

Begin
  If (Word(MemW[$46C] - starttime)) > timeout Then
    Raise Exception.Create('');
  If cleak > bestleak Then
    Exit;
  closed[Q] := True;
  Dec(cleakspd, leakspd[Q]);

  allclosed := True;
  For I := Q + 1 To N Do
    If Not closed[I] Then
    Begin
      Try
        {$OVERFLOWCHECKS ON}
        tmp := cleak + (Pos[I] - Pos[Q]) * cleakspd;
        {$OVERFLOWCHECKS OFF}
        cleak := tmp;
        Dig(I);
        Dec(cleak, (Pos[I] - Pos[Q]) * cleakspd);
      Except
      End;
      allclosed := False;
      Break;
    End;
  For I := Q - 1 DownTo 1 Do
    If Not closed[I] Then
    Begin
      Try
        {$OVERFLOWCHECKS ON}
        tmp := (Pos[Q] - Pos[I]) * cleakspd;
        {$OVERFLOWCHECKS OFF}
        cleak := tmp;
        Dig(I);
        Dec(cleak, (Pos[Q] - Pos[I]) * cleakspd);
      Except
      End;
      allclosed := False;
      Break;
    End;
  If allclosed Then
  Begin
    If cleak < bestleak Then
    Begin
      bestleak := cleak;
      bestStart := CStart;
    End;
  End;

  Inc(cleakspd, leakspd[Q]);
  closed[Q] := False;
End;

Var
  I : Integer;

Begin
  starttime := MemW[$46C];
  ReadIn;
  bestStart := -1;
  bestleak := 1000000001;
  cleakspd := 0;
  For I := 1 To N Do
    Inc(cleakspd, leakspd[I]);
  FillChar(closed, SizeOf(closed), 0);
  Try
    For I := 1 To N Do
    Begin
      cleak := 0;
      CStart := I;
      Dig(I);
    End;
  Finally
    WriteOut(bestleak, bestStart);
  End;
End.
