#include <stdio.h>

int c;

int dupsd[301];
int dupsr[301];

int pozic[512][512][2];
char iscalc[512][512][2];

int tech[512][512];

int calcdeb(int ffr,int fto,int fps)
{
  int tmp,ct1,ct2,np;

  if (fps==ffr) { tmp=0; } else { tmp=1; }
  if (iscalc[ffr][fto][tmp]) { return pozic[ffr][fto][tmp]; }

  ct1 = 10000000;
  np = ffr-1;
  if (np>=0)
  {
    ct1 = calcdeb(np,fto,np) + (dupsr[fps]-dupsr[np]) * tech[ffr][fto];
  }
  ct2 = 10000000;
  np = fto+1;
  if (np<c)
  {
    ct2 = calcdeb(ffr,np,np) + (dupsr[np]-dupsr[fps]) * tech[ffr][fto];
  }

  if (ct2<ct1) { ct1=ct2; }
  iscalc[ffr][fto][tmp] = 1;
  pozic[ffr][fto][tmp] = ct1;
  return ct1;
}

int calctech(void)
{
  int i,j,kol,whole;

  whole = 0;
  for (i=0;i<c;i++)
  {
    whole+=dupsd[i];
  }
  
  for (i=0;i<c;i++)
  {
    kol = whole;
    for (j=i;j<c;j++)
    {
      kol-=dupsd[j];
      tech[i][j] = kol;
    }
  }
}

int main(void)
{
  FILE* f;
  int i,raz,deb,mindeb;
  f = fopen("drain.inp","rt");
  fscanf(f,"%d",&c);
  for (i=0;i<c;i++)
  {
    fscanf(f,"%d %d",&raz,&deb);
    dupsd[i] = deb;
    dupsr[i] = raz;
  }
  fclose(f);

  calctech();
  pozic[0][c-1][0] = 0;
  iscalc[0][c-1][0] = 1;
  pozic[0][c-1][1] = 0;
  iscalc[0][c-1][1] = 1;

  mindeb = 1000000000;
  for (i=0;i<c;i++)
  {
    deb = calcdeb(i,i,i);
    if (deb<mindeb) { mindeb=deb; raz=i; }
  } raz++;

  f = fopen("drain.out","wt");
  fprintf(f,"%d\n",mindeb);
  fprintf(f,"%d\n",raz);
  fclose(f);
  
  return 0;
}
