#include <stdio.h>
#include <process.h>
#include <string.h>
#define INPF "work.inp"
#define OUTF "work.out"
#define MAXM 5050
#define MAXN 1050

struct Usl
	  {
	    short i,j,c;
	  } u[MAXM];

short m,n;
short time[MAXN];

void Init()
  {
    FILE *f=fopen(INPF,"rt");
    fscanf(f,"%d%d",&n,&m);
    for(int i=0;i<m;i++)
      {
	fscanf(f,"%d%d%d",&u[i].i,&u[i].j,&u[i].c);
      }
    fclose(f);
  }

void Output()
  {
    FILE *f=fopen(OUTF,"wt");
    for(int i=1;i<=n;i++)
      fprintf(f,"%d\n",time[i]);
    fclose(f);
    exit(0);
  }

int Stava()
  {
    for(int i=0;i<m;i++)
      if(time[u[i].i]-time[u[i].j]>u[i].c || time[u[i].i]<0 || time[u[i].j]<0) return 0;
    return 1;
  }

void Solve()
  {
    int i;
    for(i=0;i<n;i++) time[i]=100;
    for(i=1;i<n;i++)
      {
	time[i]=0;
	for(i=0;i<m;i++)
	    if(time[u[i].i]-time[u[i].j]>u[i].c)
	      {
		if(time[u[i].j]+u[i].c<0) time[u[i].j]=time[u[i].i]-u[i].c;
				     else time[u[i].i]=time[u[i].j]+u[i].c;
	      }
	if(Stava()) Output();
      }
  }

int main()
  {
    Init();
    Solve();
    FILE *f=fopen(OUTF,"wt");
    fprintf(f,"NO SOLUTION\n");
    fclose(f);
    return 0;
  }