#include <fstream>
#include <queue>

using namespace std;

#define MAXN 1001
#define min(a,b) (((a) < (b))?(a):(b))
#define max(a,b) (((a) > (b))?(a):(b))


int n, m;
int tp[MAXN];
int t[MAXN][MAXN];
int job[MAXN][MAXN];
int jout[MAXN];
int jin[MAXN];
int prev[MAXN];
int vis[MAXN];

queue<int> vq;

int main(){

  for(int i = 0; i < MAXN; i++){
    for(int j = 0; j < MAXN; j++){
    
      t[i][j] = 0;
      job[i][j] = 0;
    }
    tp[MAXN];
    jout[i] = 0;
    jin[i] = 0;
    vis[i] = 0;
    prev[i] = 0;
  }


  ifstream in("work.inp");
  ofstream out("work.out");

  in >> n >> m;

  for(int i = 0; i < m; i++){
    int ti, tj, b;
    in >> ti >> tj >> b;

    if(b > 0){
      job[tj][jout[tj]++] = ti;
      t[tj][ti] = b;
      jin[ti]++;
    }
    else if(b < 0){
      job[ti][jout[ti]++] = tj;
      t[ti][tj] = -b;
      jin[tj]++;
    }
  }

  for(int i = 1; i <= n; i++){
    if(jin[i] == 0){
      vq.push(i);
    }
  }


  while(!vq.empty()){

    int v = vq.front(); vq.pop();
    if(vis[v]) continue;
    
    vis[v] = 1;

    for(int i = 0; i < jout[v]; i++){

      tp[job[v][i]] = max(tp[job[v][i]], tp[v] + t[v][job[v][i]]);

      if(++prev[job[v][i]] == jin[job[v][i]])
        vq.push(job[v][i]);
    }
  }

  for(int i = 1; i <= n; i++){
    if(!vis[i]){
      out << "NO SOLUTION" << endl;
      return 0;
    }
  }

  for(int i = 1; i <= n; i++){

    out << tp[i] << endl;
  }
  
  return 0;
}
