#include <stdio.h>

int wc, c, index;

int path[300][2];

int solveHole = -1;
int solveFuel = 3000001;
int UsedHoleCount;
int cf, ch, cp, fbpt;

struct {
  int Used;
  int FuelBurning;
  int Path;
  int Left, Right;
} hole[300];

void clearall(void)  {
  int i;
  UsedHoleCount = 0; cf = 0;
  for(i=0;i<wc;i++)  {
    hole[i].Used = 0;
    hole[i].Left = 0;
    hole[i].Right = 0;
  }
}

int noleft(int num)  {
  int i, j = 0;

  for(i=0;i<num && j == 0;i++)  j+=hole[i].Used;

  return j;
}

int noright(int num)  {
  int i, j = 0;

  for(i=num+1;i<wc && j == 0;i++)  j+=hole[i].Used;

  return j;
}

void solve(int vID, int cfb)  {
  int left = 1000000000, right = 1000000000;
  hole[vID].Used = 1;
  UsedHoleCount++;
  if(UsedHoleCount == wc)  {
    if(solveFuel > cf)  {
      solveFuel = cf;
      solveHole = ch;
    }
    return;
  }
  if(vID > 0)  left = (hole[vID].Path-hole[vID-1].Path)*cfb;
  if(noleft(vID)) left = 1000000000;
  if(vID < wc-1)  right = (hole[vID+1].Path-hole[vID].Path)*cfb;
  if(noright(vID)) right = 1000000000;
  if(left>right)  {
    cf += right;
    solve(vID+1, cfb-hole[vID+1].FuelBurning);
  } else {
    cf += left;
    solve(vID-1, cfb-hole[vID-1].FuelBurning);
  }
}

int main(void)  {
  FILE *fp;

  fp = fopen("drain.inp", "rt");

  fscanf(fp, "%d", &wc);

  for(c=0;c<wc;c++)  {
    fscanf(fp, "%d %d", &hole[c].Path, &hole[c].FuelBurning);
    hole[c].Used = 0;
    fbpt += hole[c].FuelBurning;
  }

  fclose(fp);

  for(c=0;c<wc;c++)   {
    clearall(); ch = c;
    solve(c, fbpt-hole[c].FuelBurning);
  }

  fp = fopen("drain.out", "w+");

  fprintf(fp, "%d\n%d", solveFuel, solveHole+1);

  fclose(fp);

  return 0;
}
