#include <stdio.h>
#include <stdlib.h>

#define TXT "temp"
#define MAX 1000000
#define SIZE 1000000

int x1[MAX],x2[MAX],y1[MAX],y2[MAX],c[MAX];
int n;
int nx1,ny1,nx2,ny2;
int ox1,oy1,ox2,oy2;

void readtemp () {
int i;
    FILE *f = fopen ( TXT , "r");
    n = 0;
    if (f!=NULL) {
       fscanf(f,"%d",&n);
       for (i=1;i<=n;i++)
           fscanf(f,"%d %d %d %d %d",&x1[i],&y1[i],&x2[i],&y2[i],&c[i]);
       fclose(f);
    }
}

void printboard () {
int i;
     x1[n+1] = nx1; y1[n+1] = ny1; x2[n+1] = nx2; y2[n+1] = ny2; c[n+1] = 1;
     printf("%d %d %d %d\n",nx1,ny1,nx2,ny2);
     FILE *f = fopen ( TXT , "w");
     fprintf(f,"%d\n",n+2);
     for (i=0;i<=n+1;i++)
         fprintf(f,"%d %d %d %d %d\n",x1[i],y1[i],x2[i],y2[i],c[i]);
     fclose(f);
     exit(0);
}


int used(int ax,int ay,int bx,int by) {
int i;
    if ((ax<0-SIZE)||(ay<(0-SIZE))||(bx<(0-SIZE))||(by<(0-SIZE))||
        (ax> SIZE)||(ay> SIZE)||(bx> SIZE)||(by> SIZE)
       ) return 1;
    for (i=1;i<=n;i++) {
        if ((x1[i]==ax)&&(y1[i]==ay)&&(x2[i]==bx)&&(y2[i]==by)) return 1;
        if ((x1[i]==bx)&&(y1[i]==by)&&(x2[i]==ax)&&(y2[i]==ay)) return 1;
    }
    return 0;
        
}

void makerandom() {
     while (1) {
           int nx1 = rand()%SIZE;
           int ny1 = rand()%SIZE;
           int nx2 = rand()%SIZE;
           int ny2 = rand()%SIZE;
           if (!used(nx1,ny1,nx2,ny2)) printboard();
     }
}

int l(int x,int y,int p,int q) {
    nx1 = x; ny1 = y; nx2 = x; ny2 = y-1;
    if (!used(nx1,ny1,nx2,ny2)) printboard();
    nx1 = p; ny1 = q; nx2 = p; ny2 = q-1;
    if (!used(nx1,ny1,nx2,ny2)) printboard();    
}

int r(int x,int y,int p,int q) {
    nx1 = x; ny1 = y; nx2 = x; ny2 = y+1;
    if (!used(nx1,ny1,nx2,ny2)) printboard();
    nx1 = p; ny1 = q; nx2 = p; ny2 = q+1;
    if (!used(nx1,ny1,nx2,ny2)) printboard();    
}

int u(int x,int y,int p,int q) {
    nx1 = x; ny1 = y; nx2 = x-1; ny2 = y;
    if (!used(nx1,ny1,nx2,ny2)) printboard();
    nx1 = p; ny1 = q; nx2 = p-1; ny2 = q;
    if (!used(nx1,ny1,nx2,ny2)) printboard();    
}

int d(int x,int y,int p,int q) {
    nx1 = x; ny1 = y; nx2 = x+1; ny2 = y;
    if (!used(nx1,ny1,nx2,ny2)) printboard();
    nx1 = p; ny1 = q; nx2 = p+1; ny2 = q;
    if (!used(nx1,ny1,nx2,ny2)) printboard();    
}

int lu(int x,int y,int p,int q) {
    nx1 = x; ny1 = y; nx2 = x-1; ny2 = y-1;
    if (!used(nx1,ny1,nx2,ny2)) printboard();
    nx1 = p; ny1 = q; nx2 = p-1; ny2 = q-1;
    if (!used(nx1,ny1,nx2,ny2)) printboard();    
}
int ru(int x,int y,int p,int q) {
    nx1 = x; ny1 = y; nx2 = x-1; ny2 = y+1;
    if (!used(nx1,ny1,nx2,ny2)) printboard();
    nx1 = p; ny1 = q; nx2 = p-1; ny2 = q+1;
    if (!used(nx1,ny1,nx2,ny2)) printboard();    
}

int ld(int x,int y,int p,int q) {
    nx1 = x; ny1 = y; nx2 = x+1; ny2 = y-1;
    if (!used(nx1,ny1,nx2,ny2)) printboard();
    nx1 = p; ny1 = q; nx2 = p+1; ny2 = q-1;
    if (!used(nx1,ny1,nx2,ny2)) printboard();    
}

int rd(int x,int y,int p,int q) {
    nx1 = x; ny1 = y; nx2 = x+1; ny2 = y+1;
    if (!used(nx1,ny1,nx2,ny2)) printboard();
    nx1 = p; ny1 = q; nx2 = p+1; ny2 = q+1;
    if (!used(nx1,ny1,nx2,ny2)) printboard();    
}

void findmove () {
int i;
int lx1,lx2,ly1,ly2,rx1,rx2,ry1,ry2,ux1,ux2,uy1,uy2,dx1,dx2,dy1,dy2;
int lux1,lux2,luy1,luy2,rux1,rux2,ruy1,ruy2,ldx1,ldx2,ldy1,ldy2;
int rdx1,rdx2,rdy1,rdy2;
int j;
     x1[0] = ox1;
     y1[0] = oy1;
     x2[0] = ox2;
     y2[0] = oy2;
     c[0]  = 2;
     for (i=0;i<=n;i++)
         if (c[i]==2) {
            lx1 = x1[i]-1; ly1 = y1[i];
            rx1 = x1[i]+1; ry1 = y1[i];
            ux1 = x1[i]; uy1 = y1[i]-1;
            dx1 = x1[i]; dy1 = y1[i]+1;
            lux1 = x1[i]-1; luy1 = y1[i]-1;
            rux1 = x1[i]-1; ruy1 = y1[i]+1;
            ldx1 = x1[i]+1; ldy1 = y1[i]-1;
            rdx1 = x1[i]+1; rdy1 = y1[i]+1;
            lx2 = x2[i]-1; ly2 = y2[i];
            rx2 = x2[i]+1; ry2 = y2[i];
            ux2 = x2[i]; uy2 = y2[i]-1;
            dx2 = x2[i]; dy2 = y2[i]+1;
            lux2 = x2[i]-1; luy2 = y2[i]-1;
            rux2 = x2[i]-1; ruy2 = y2[i]+1;
            ldx2 = x2[i]+1; ldy2 = y2[i]-1;
            rdx2 = x2[i]+1; rdy2 = y2[i]+1;            
            for (j=0;j<=n;j++)
                if (c[j]==2) {
                   if ((x1[j]==lx1)&&(y1[j]==ly1)) l(x1[i],y1[i],x2[i],y2[i]);
                   if ((x1[j]==rx1)&&(y1[j]==ry1)) r(x1[i],y1[i],x2[i],y2[i]);
                   if ((x1[j]==ux1)&&(y1[j]==uy1)) u(x1[i],y1[i],x2[i],y2[i]);
                   if ((x1[j]==dx1)&&(y1[j]==dy1)) d(x1[i],y1[i],x2[i],y2[i]);
                   if ((x1[j]==lux1)&&(y1[j]==luy1)) lu(x1[i],y1[i],x2[i],y2[i]);
                   if ((x1[j]==rux1)&&(y1[j]==ruy1)) ru(x1[i],y1[i],x2[i],y2[i]);
                   if ((x1[j]==ldx1)&&(y1[j]==ldy1)) ld(x1[i],y1[i],x2[i],y2[i]);
                   if ((x1[j]==rdx1)&&(y1[j]==rdy1)) rd(x1[i],y1[i],x2[i],y2[i]);
                   //
                   if ((x2[j]==lx1)&&(y2[j]==ly1)) l(x2[i],y2[i],x1[i],y1[i]);
                   if ((x2[j]==rx1)&&(y2[j]==ry1)) r(x2[i],y2[i],x1[i],y1[i]);
                   if ((x2[j]==ux1)&&(y2[j]==uy1)) u(x2[i],y2[i],x1[i],y1[i]);
                   if ((x2[j]==dx1)&&(y2[j]==dy1)) d(x2[i],y2[i],x1[i],y1[i]);
                   if ((x2[j]==lux1)&&(y2[j]==luy1)) lu(x2[i],y2[i],x1[i],y1[i]);
                   if ((x2[j]==rux1)&&(y2[j]==ruy1)) ru(x2[i],y2[i],x1[i],y1[i]);
                   if ((x2[j]==ldx1)&&(y2[j]==ldy1)) ld(x2[i],y2[i],x1[i],y1[i]);
                   if ((x2[j]==rdx1)&&(y2[j]==rdy1)) rd(x2[i],y2[i],x1[i],y1[i]);
////////////
                   if ((x1[j]==lx2)&&(y1[j]==ly2)) l(x1[i],y1[i],x2[i],y2[i]);
                   if ((x1[j]==rx2)&&(y1[j]==ry2)) r(x1[i],y1[i],x2[i],y2[i]);
                   if ((x1[j]==ux2)&&(y1[j]==uy2)) u(x1[i],y1[i],x2[i],y2[i]);
                   if ((x1[j]==dx2)&&(y1[j]==dy2)) d(x1[i],y1[i],x2[i],y2[i]);
                   if ((x1[j]==lux2)&&(y1[j]==luy2)) lu(x1[i],y1[i],x2[i],y2[i]);
                   if ((x1[j]==rux2)&&(y1[j]==ruy2)) ru(x1[i],y1[i],x2[i],y2[i]);
                   if ((x1[j]==ldx2)&&(y1[j]==ldy2)) ld(x1[i],y1[i],x2[i],y2[i]);
                   if ((x1[j]==rdx2)&&(y1[j]==rdy2)) rd(x1[i],y1[i],x2[i],y2[i]);
                   //
                   if ((x2[j]==lx2)&&(y2[j]==ly2)) l(x2[i],y2[i],x1[i],y1[i]);
                   if ((x2[j]==rx2)&&(y2[j]==ry2)) r(x2[i],y2[i],x1[i],y1[i]);
                   if ((x2[j]==ux2)&&(y2[j]==uy2)) u(x2[i],y2[i],x1[i],y1[i]);
                   if ((x2[j]==dx2)&&(y2[j]==dy2)) d(x2[i],y2[i],x1[i],y1[i]);
                   if ((x2[j]==lux2)&&(y2[j]==luy2)) lu(x2[i],y2[i],x1[i],y1[i]);
                   if ((x2[j]==rux2)&&(y2[j]==ruy2)) ru(x2[i],y2[i],x1[i],y1[i]);
                   if ((x2[j]==ldx2)&&(y2[j]==ldy2)) ld(x2[i],y2[i],x1[i],y1[i]);
                   if ((x2[j]==rdx2)&&(y2[j]==rdy2)) rd(x2[i],y2[i],x1[i],y1[i]);
                   
                }
     }
     for (i=0;i<=n;i++)
         if (c[i]==2) {
            l(x1[i],y1[i],x2[i],y2[i]);
            r(x1[i],y1[i],x2[i],y2[i]);
            u(x1[i],y1[i],x2[i],y2[i]);
            d(x1[i],y1[i],x2[i],y2[i]);
            lu(x1[i],y1[i],x2[i],y2[i]);
            ld(x1[i],y1[i],x2[i],y2[i]);
            ru(x1[i],y1[i],x2[i],y2[i]);
            rd(x1[i],y1[i],x2[i],y2[i]);            
         }
     makerandom();
}

int main () {
    scanf("%d%d%d%d",&ox1,&oy1,&ox2,&oy2);
    readtemp();
    findmove();
    printboard();
    return 0;
}
