#include <stdio.h>

#define RETTYP long long
#define FORMATOUT "%lld\n"

int inpn,inpk;

RETTYP resl;
RETTYP facts[21];
RETTYP sums[21];

RETTYP nach[21][21];

RETTYP dyn[21][21];
char iscalc[21][21];

int calcfactsandsums(void)
{
  int i;
  facts[0] = 1;
  facts[1] = 1;
  sums[1] = 1;
  for (i=2;i<21;i++)
  {
    facts[i] = i*facts[i-1];
    sums[i] = i+sums[i-1];
  }
}

int calcnach(void)
{
  int i,j,k;
  for (i=1;i<21;i++)
  {
    for (j=0;j<i;j++)
    {
      nach[i][j] = facts[i] / (facts[j]*facts[i-j]);
    }
    nach[i][i] = 1;
  }
}

int calc(int n1,int k1)
{
  int i,l1,l2;
  RETTYP t,t1;

  if ((k1<1) || (n1<k1))
  {
    dyn[n1][k1] = 0;
    return 0;
  }

  if (iscalc[n1][k1]) { return 0; }

  if (k1==1)
  {
    dyn[n1][1] = facts[n1-1];
    iscalc[n1][1] = 1;
    return 0;
  }

  t=0;
  
  if (k1==2)
  {
    l2 = n1-1;
    for (l1=1;l1<n1;l1++)
    {
      t+= facts[ l1-1 ] * facts[ l2-1 ] * nach[n1-1][l2];

      l2--;
    }
  } else {

    l2 = n1-1;
    for (l1=1;l1<n1;l1++)
    {
      calc(l2,k1-1);
      t1 = dyn[l2][k1-1];      
      t+= facts[ l1-1 ] * t1 * nach[n1-1][l2];
      l2--;
    }
    
  }
  dyn[n1][k1] = t;
  iscalc[n1][k1] = 1;
  return 0;
}

int main(void)
{
  FILE* f;
  int i;
  
  f = fopen("perm.inp","rt");
  fscanf(f,"%d %d",&inpn,&inpk);
  fclose(f);

  calcfactsandsums();
  calcnach();

  if (inpk==inpn) { resl=1; } else
  {
    resl = 0;
    calc(inpn,inpk);
    resl = dyn[inpn][inpk];
  }

  f = fopen("perm.out","wt");
  fprintf(f,FORMATOUT,resl);
  fclose(f);
  
  return 0;
}
