
 #include <fstream.h>
 #include <stdio.h>

 #define MAX 3500

 FILE *temp;

 typedef struct
  {
   long x1,y1,x2,y2;
  } seg;

 seg ots[MAX];
 long N;
 int sv1[4],sv2[4];

 void prn(long a,long b,long c,long d)
  {
   cout << a<<" "<<b<<" "<<c<<" "<<d<<endl;
  };

 void setmine(long x1,long y1,long x2,long y2)
  {
   long i;
   for (i=0;i<N;i++)
    {
     //left from pt1
     if (ots[i].x1==x1-1 && ots[i].y1==y1 && ots[i].x2==x1 && ots[i].y2==y1)
      sv1[3]=1;
     //right from pt1
     if (ots[i].x1==x1 && ots[i].y1==y1 && ots[i].x2==x1+1 && ots[i].y2==y1)
      sv1[2]=1;
     //up from pt1
     if (ots[i].x1==x1 && ots[i].y1==y1 && ots[i].x2==x1 && ots[i].y2==y1+1)
      sv1[0]=1;
     //doen from pt1
     if (ots[i].x2==x1 && ots[i].y2==y1 && ots[i].x1==x1 && ots[i].y1==y1-1)
      sv1[1]=1;

     //left from pt2
     if (ots[i].x1==x2-1 && ots[i].y1==y2 && ots[i].x2==x2 && ots[i].y2==y2)
      sv2[3]=1;
     //right from pt2
     if (ots[i].x1==x2 && ots[i].y1==y2 && ots[i].x2==x2+1 && ots[i].y2==y2)
      sv2[2]=1;
     //up from pt2
     if (ots[i].x1==x2 && ots[i].y1==y2 && ots[i].x2==x2 && ots[i].y2==y2+1)
      sv2[0]=1;
     //doen from pt2
     if (ots[i].x2==x2 && ots[i].y2==y2 && ots[i].x1==x2 && ots[i].y1==y2-1)
      sv2[1]=1;
    };
   if (x1==x2)
    {
     if (sv1[2]==0)
      {
       prn(x1,y1,x1+1,y1);
       return;
      };
     if (sv2[2]==0)
      {
       prn(x2,y2,x2+1,y2);
       return;
      };
     if (sv1[3]==0)
      {
       prn(x1,y1,x1-1,y1);
       return;
      };
     if (sv2[3]==0)
      {
       prn(x2,y2,x2-1,y2);
       return;
      };
     if (sv2[0]==0)
      {
       prn(x2,y2,x2,y2+1);
       return;
      };
     if (sv1[0]==0)
      {
       prn(x1,y1,x1,y1+1);
       return;
      };
     if (sv1[1]==0)
      {
       prn(x1,y1,x1,y1-1);
       return;
      };
     if (sv2[1]==0)
      {
       prn(x2,y2,x2,y2-1);
       return;
      };
    }
   else
    {
     if (sv2[0]==0)
      {
       prn(x2,y2,x2,y2+1);
       return;
      };
     if (sv1[0]==0)
      {
       prn(x1,y1,x1,y1+1);
       return;
      };
     if (sv1[1]==0)
      {
       prn(x1,y1,x1,y1-1);
       return;
      };
     if (sv2[1]==0)
      {
       prn(x2,y2,x2,y2-1);
       return;
      };
     if (sv1[2]==0)
      {
       prn(x1,y1,x1+1,y1);
       return;
      };
     if (sv2[2]==0)
      {
       prn(x2,y2,x2+1,y2);
       return;
      };
     if (sv1[3]==0)
      {
       prn(x1,y1,x1-1,y1);
       return;
      };
     if (sv2[3]==0)
      {
       prn(x2,y2,x2-1,y2);
       return;
      };

    };
  };

 void main()
  {
   if ((temp=fopen("temp","rt"))==NULL)
    {
     N=-1;
    }
   else
    {
     fseek(temp,SEEK_SET,0);
     fread(&N,4,1,temp);
     fread(ots,sizeof(seg),MAX,temp);
     fclose(temp);
    };
   long x1,y1,x2,y2;
   cin >> x1 >> y1 >> x2 >> y2;
   seg t;
   if (x1<x2)
    {
      t.x1=x1; t.x2=x2; t.y1=y1; t.y2=y2;
    }
   else
    if (x1>x2)
     {
      t.x1=x2; t.x2=x1; t.y2=y1; t.y1=y2;
     }
    else
     if (y1<y2)
      {
      t.x1=x1; t.x2=x2; t.y1=y1; t.y2=y2;
      }
     else
      {
       t.x1=x2; t.x2=x1; t.y2=y1; t.y1=y2;
      };
   x1=t.x1; x2=t.x2; y1=t.y1; y2=t.y2;
   N++;
   ots[N]=t;

   setmine(x1,y1,x2,y2);


   temp=fopen("temp","wt");
   fseek(temp,SEEK_SET,0);
   fwrite(&N,4,1,temp);
   fwrite(ots,sizeof(seg),MAX,temp);
   fclose(temp);
  };

