#include <stdio.h>

int x1[10001];
int y1[10001];
int x2[10001];
int y2[10001];
int count = 0;
int sign[20000];

void swap(int x, int y) {
	int t;
    
	t = x1[x]; x1[x] = x1[y]; x1[y] = t;
	t = x2[x]; x2[x] = x2[y]; x2[y] = t;
	t = y1[x]; y1[x] = y1[y]; y1[y] = t;
	t = y2[x]; y2[x] = y2[y]; y2[y] = t;
}

void sort(int start, int end) {
	int i, temp = start;

    if (start >= end)
    	return;
    for (i = start+1; i <= end; i++)
        if (x1[start] < x1[i])
        	swap(++temp, i);
            
    swap(temp, start);
    sort(start, temp-1);
    sort(temp+1, end);
}

inline int getsign(int i, int x0, int y0) {
	int s;
    
    s = x0*(y1[i]-y2[i]) + y0*(x2[i]-x1[i]) + (x1[i]*y2[i] - x2[i]*y1[i]);
    return s > 0 ? 0 : 1;
}

inline int hascommonpt(int i, int j) {
	if  ((getsign(i, x1[j], y1[j]) ^ getsign(i, x2[j], y2[j])) &&
    	(getsign(j, x1[i], y1[i]) ^ getsign(j, x2[i], y2[i])))
        return 1;
    return 0;
}

int main() {
    FILE *f;
    int j, k, i = 0;
	int tx1, tx2, ty1, ty2;

    f = fopen("ots.inp", "rt");
    while (1) {
    	  j = fscanf(f, "%i %i %i %i", &tx1, &ty1, &tx2, &ty2);
          if (tx1 < tx2) {
          	x1[i] = tx2, x2[i] = tx1;
            y1[i] = ty2, y2[i] = ty1;
          }
          else {
          	x1[i] = tx1, x2[i] = tx2;
            y1[i] = ty1, y2[i] = ty2;
          }
          if (j <= 0)
          	break;
          i++;
    }
    fclose(f);
    x1[i] = x2[i] = -1;
    sort(0, i);
	i--;

    for (j = 0; j < i; j++) {
        k = j+1;
        while (x2[j] <= x1[k]) {
        	if (hascommonpt(j, k))
				count++;
            k++;
		}
	}
    
    f = fopen("ots.out", "wt");
    fprintf(f, "%i\n", count);
    fclose(f);
    return 0;
}

