#include<math.h>
#include<string>
#include<cstdlib>
#include<fstream>
#define MAX 10000

using namespace std;
/****************************************************************************/
struct points {
  int x,y;
};
struct line {
  points p[2];
};
/****************************************************************************/
ifstream fin("ots.inp");
ofstream fout("ots.out");
/****************************************************************************/
line mas[MAX];
int N=0;
/****************************************************************************/
  void   init();
//  double rast(int x1,int y1,int x2,int y2);
  int    urav(int x1,int y1,int x2,int y2,int x,int y);
  int    det(int A1,int B1,int A2,int B2);
  int    detx(int C1,int B1,int C2,int B2);
  int    dety(int A1,int C1,int A2,int C2);
  int    max(int x,int y);
  int    min(int x,int y);
  int    ifpres(int ax1,int ay1,int ax2,int ay2,
                int bx1,int by1,int bx2,int by2);
  void   done();
/****************************************************************************/
void main(){
  init();

  done();
}
/****************************************************************************/
void init(){
  while (!fin.eof()) {
    fin>>mas[N].p[0].x>>mas[N].p[0].y>>mas[N].p[1].x>>mas[N].p[1].y;
    N++;
  }
  N--;
}
/****************************************************************************/
/*double rast(int x1,int y1,int x2,int y2){
  return sqrt(pow(y2-y1,2)+pow(x2-x1,2));
} */
/****************************************************************************/
int det(int A1,int B1,int A2,int B2){
  return A1*B2-A2*B1;
}
/****************************************************************************/
int detx(int C1,int B1,int C2,int B2){
  return B1*C2-B2*C1;
}
/****************************************************************************/
int dety(int A1,int C1,int A2,int C2){
  return A2*C1-A1*C2;
}
/****************************************************************************/
int urav(int A,int B,int C,int x,int y){
  int st=0;

  st=A*x+B*y+C;

  if (st==0) return 1;
  else return 0;
}
/****************************************************************************/
int max(int x,int y){
  if (x<y) return y;
  else return x;
}
/****************************************************************************/
int min(int x,int y){
  if (x>y) return y;
  else return x;
}
/****************************************************************************/
int ifpres(int ax1,int ay1,int ax2,int ay2,
           int bx1,int by1,int bx2,int by2){
  int A1,B1,C1,A2,B2,C2;
  double x0,y0;
  double d,dx,dy;
  A1=ay2-ay1;  B1=ax1-ax2;  C1=ay1*ax2-ay2*ax1;
  A2=by2-by1;  B2=bx1-bx2;  C2=by1*bx2-by2*bx1;

  if ((ax1==bx1)&&(ax2==bx2)&&(ay1==by1)&&(ay2==by2)) return 1;

  if ((urav(A1,B1,C1,bx1,by1))&&(urav(A1,B1,C1,bx2,by2)))
    if ((bx1>=min(ax1,ax2))&&(bx1<=max(ax1,ax2))) return 1;

  if ((urav(A2,B2,C2,ax1,ay1))&&(urav(A2,B2,C2,ax2,ay2)))
    if ((ax1>=min(bx1,bx2))&&(ax1<=max(bx1,bx2))) return 1;


  if ((ax1==ax2)&&(ay1==ay2)) {
    if ((urav(A2,B2,C2,ax1,ay1))&&(ax1<=max(bx1,bx2))&&(ax1>=min(bx1,bx2))&&
       (ay1<=max(by1,by2))&&(ay1>=min(by1,by2))) return 1;
    else return 0;
  }

  if ((bx1==bx2)&&(by1==by2)) {
    if ((urav(A1,B1,C1,bx1,by1))&&(bx1<=max(ax1,ax2))&&(bx1>=min(ax1,ax2))&&
       (by1<=max(ay1,ay2))&&(by1>=min(ay1,ay2))) return 1;
    else return 0;
  }

  
  d=det(A1,B1,A2,B2);
  if (d==0) return 0;
  else {
    dx=detx(C1,B1,C2,B2);
    dy=dety(A1,C1,A2,C2);
    x0=dx/d;
    y0=dy/d;

    if ((x0<=max(ax1,ax2))&&(x0>=min(ax1,ax2))&&
        (y0<=max(ay1,ay2))&&(y0>=min(ay1,ay2))&&
        (x0<=max(bx1,bx2))&&(x0>=min(bx1,bx2))&&
        (y0<=max(by1,by2))&&(y0>=min(by1,by2))) return 1;
    else return 0;
  }
}
/****************************************************************************/
void done(){
//  fout<<ifpres(2,1,4,1,1,1,6,1)<<endl;
  long br=0,k=0;

  for (int i=0;i<N;i++)
    for (int j=i+1;j<N;j++) {
      k=ifpres(mas[i].p[0].x,mas[i].p[0].y,mas[i].p[1].x,mas[i].p[1].y,
               mas[j].p[0].x,mas[j].p[0].y,mas[j].p[1].x,mas[j].p[1].y);

      if (k==1) br++;
    }


  fout<<br<<endl;
  fin.close();
  fout.close();
}
/****************************************************************************/

