#include <fstream>
#include <cstring>
#include <cstdio>

struct point {
  int x,y;
};

struct segment {
  point a,b;
};

int n=0;
unsigned long c=0;
segment s[10240];
ifstream fin("ots.inp");
ofstream fout("ots.out");


int ccw(point p0,point p1,point p2)
{
  int dx1=p1.x-p0.x;
  int dy1=p1.y-p0.y;
  int dx2=p2.x-p0.x;
  int dy2=p2.y-p0.y;
  if (dx1*dy2 > dx2*dy1) return +1;
  if (dx1*dy2 < dx2*dy1) return -1;
  if ((dx1*dx2<0)||(dy1*dy2<0)) return -1;
  if (dx1*dx1+dy1*dy1 < dx2*dx2+dy2*dy2) return +1;
  return 0;
}


int intersect(segment a,segment b)
{
  return ( (ccw(a.a,a.b,b.a)*
            ccw(a.a,a.b,b.b)<=0) &&
           (ccw(b.a,b.b,a.a)*
            ccw(b.a,b.b,a.b)<=0) );
}


int main()
{
/*
  point a={0,0};
  point b={10,10};
  point d={-1,-1};
  cout << ccw (d,a,b) << endl;
*//*
  segment a,b;
  a.a.x=0;a.a.y=0;a.b.x=10;a.b.y=10;
  b.a.x=100;b.a.y=10;b.b.x=5;b.b.y=5;
  cout << intersect(a,b) << endl;
  cin.get();
  return 0;
*/

  while (!fin.eof())
  {
    fin >> s[n].a.x >> s[n].a.y >> s[n].b.x >> s[n].b.y;
    n++;
  }
  n--;

  for (int i=0;i<n;i++)
    for (int j=i+1;j<n;j++)
      c+=intersect(s[i],s[j]);

  fout << c << endl;

  return 0;
}
