#include <stdio.h>

FILE *fn;

int vert[131072];
double st[131072];
double slope[131072];
int x1[131072];
int y1[131072];
int x2[131072];
int y2[131072];
int n, cnt;

int main(void) {
int i, j;
double t1, t2, t3, t4;

fn=fopen("OTS.INP", "r");
for (n=0; fscanf(fn, "%d %d %d %d", &x1[n], &y1[n], &x2[n], &y2[n])==4; n++) {
  if (x1[n]==x2[n]) {
    if (y2[n]<y1[n]) {
      y1[n]^=y2[n];
      y2[n]^=y1[n];
      y1[n]^=y2[n];
    }
    vert[n]=1;
    st[n]=x1[n];
  } else {
    if (x1[n]>x2[n]) {
      x1[n]^=x2[n];
      x2[n]^=x1[n];
      x1[n]^=x2[n];
      y1[n]^=y2[n];
      y2[n]^=y1[n];
      y1[n]^=y2[n];
    }
    slope[n]=(double)(y2[n]-y1[n])/(double)(x2[n]-x1[n]);
    st[n]=(double)y1[n]-(double)x1[n]*slope[n];
  }
}
fclose(fn);

for (i=0; i<n; i++) for (j=i+1; j<n; j++) {
  if (vert[i]) {
    if (vert[j]) {
      if (st[i]==st[j] && ((y1[i]>=y1[j] && y1[i]<=y2[j]) || (y2[i]>=y1[j] && y2[i]<=y2[j]) || (y1[j]>=y1[i] && y1[j]<=y2[i]) || (y2[j]>=y1[i] && y2[j]<=y2[i]))) cnt++;
    } else {
      if (x1[j]<=x1[i] && x2[j]>=x1[i]) {
        t1=st[j]+slope[j]*x1[i];
        if (t1>=y1[i] && t1<=y2[i]) cnt++;
      }
    }
  } else if (vert[j]) {
      if (x1[i]<=x1[j] && x2[i]>=x1[j]) {
        t1=st[i]+slope[i]*x1[j];
        if (t1>=y1[j] && t1<=y2[j]) cnt++;
      }
  } else {
    t1=st[j]+slope[j]*x1[i]-y1[i];
    t2=st[j]+slope[j]*x2[i]-y2[i];
    if ((t1<=0 && t2>=0) || (t1>=0 && t2<=0)) {
      t3=st[i]+slope[i]*x1[j]-y1[j];
      t4=st[i]+slope[i]*x2[j]-y2[j];
      if ((t3<=0 && t4>=0) || (t3>=0 && t4<=0)) cnt++;
    }
  }
}

fn=fopen("OTS.OUT", "w");
fprintf(fn, "%d\n", cnt);
fclose(fn);

return 0;
}
