type TOts=record
          A, B, C: LongInt;
          x1, y1, x2, y2: LongInt;
          end;

var ots: array[1..10000] of TOts;
    N: Integer;
    P: LongInt;

procedure Uravn(x1, y1, x2, y2: LongInt;var A, B, C: LongInt);
begin
  A:=y2-y1;
  B:=x1-x2;
  C:=x2*y1-y2*x1;
end;

function Razl(x1, y1, x2, y2, A, B, C: LongInt): Boolean;
var j1, j2: LongInt;
begin
  j1:=A*x1+B*y1+C;
  j2:=A*x2+B*y2+C;
  if j1<>0 then
    j1:=j1 div abs(j1);
  if j2<>0 then
    j2:=j2 div abs(j2);
  Razl:=abs(j1+j2)<2;
end;

procedure Init;
var i, j: Integer;
begin
  for i:=1 to N do
    Uravn(ots[i].x1, ots[i].y1, ots[i].x2, ots[i].y2, ots[i].A, ots[i].B, ots[i].C);
  P:=0;
  for i:=1 to N-1 do
    for j:=i+1 to N do
      begin
      if Razl(ots[i].x1, ots[i].y1, ots[i].x2, ots[i].y2, ots[j].A, ots[j].B, ots[j].C) and
         Razl(ots[j].x1, ots[j].y1, ots[j].x2, ots[j].y2, ots[i].A, ots[i].B, ots[i].C) then
           inc(P);
      end;
end;

procedure ReadData;
var F: Text; i: Integer;
begin
  Assign(F, 'ots.inp');
  Reset(F);
  i:=0;
  while not eof(F) do
    begin
    inc(i);
    readln(F, ots[i].x1, ots[i].y1, ots[i].x2, ots[i].y2);
    end;
  Close(F);
  N:=i;
end;

procedure WriteData;
var F: Text;
begin
  Assign(F, 'ots.out');
  Rewrite(F);
  writeln(F, P);
  Close(F);
end;

begin
  ReadData;
  Init;
  WriteData;
end.
