#include<fstream.h>
//#include<iostream.h>
#include<stdlib.h>
//#include<string.h>
#include<math.h>
#define bool int
#define true 1;
#define false 0;
#define min(a,b) ((a)<(b)?(a):(b))
#define max(a,b) ((a)>(b)?(a):(b))
#define INT long long int

const char inf[30]="ots.inp", outf[30]="ots.out";
struct cline
{
   INT x1,y1,x2,y2;
   INT a,b,c;
   bool f;
   cline() {f=false;};
};
const INT maxN=10002;

cline *line;
INT N;
void init()
{
   ifstream fin(inf);
   N=0;
   while(!fin.eof())
   {
      INT x1,y1,x2,y2;
      fin>>x1;
      if(fin.eof()) break;
      fin>>y1>>x2>>y2;
      if(x1>x2)
      {
	 INT t=x1;
	 x1=x2;
	 x2=t;
	 t=y1;
	 y1=y2;
	 y2=t;
      }
      line[N].x1=x1;
      line[N].y1=y1;
      line[N].x2=x2;
      line[N++].y2=y2;
   }
   fin.close();
}

void output(unsigned INT a)
{
   ofstream fout(outf);
      fout<<a<<endl;
   fout.close();
}

int sortfunc(const void* p1,const void *p2)
{
   cline *l1=(cline*)p1;
   cline *l2=(cline*)p2;
   if(l1->x1<l2->x1) return -1;
   if(l1->x1>l2->x1) return 1;
   return 0;
}
INT res;
void getline(INT i)
{
   if(line[i].f) return;
   INT a,b,c;
   line[i].a=line[i].y1-line[i].y2;
   line[i].b=line[i].x2-line[i].x1;
   line[i].c=line[i].x1*line[i].y2-line[i].x2*line[i].y1;
   line[i].f=true;
}

void solve()
{
   res=0;
   qsort(line,N,sizeof(cline),sortfunc);
   for(INT i=0; i<N; i++)
   {
      for(INT j=i+1; j<N; j++)
      {
	 if(line[j].x1>line[i].x2) break;
	 if(max(line[i].y1,line[i].y2)<min(line[j].y1,line[j].y2)) continue;
	 if(min(line[i].y1,line[i].y2)>max(line[j].y1,line[j].y2)) continue;
	 if((line[i].x2>=line[j].x2)&&
	    (min(line[j].y1,line[j].y2)<=min(line[i].y1,line[i].y2))&&
	    (max(line[j].y1,line[j].y2)>=max(line[i].y1,line[i].y2)))
	    {
	       res++;
	       continue;
	    }
	 getline(i);getline(j);
	 if(line[i].x1*line[j].a+line[i].y1*line[j].b+line[j].c==0)
	 {
	    res++;
	    continue;
	 }

	 INT d1,mx1,my1;
	 d1=line[i].b*line[j].a-line[j].b*line[i].a;
	 if(d1==0) continue;
	 mx1=line[i].c*line[j].b-line[j].c*line[i].b;
	 INT max1=line[j].x1,
	     min2=min(line[i].x2,line[j].x2);
	 if(d1>0)
	 {
	    if((max1*d1<=mx1)&&(min2*d1>=mx1)) {res++; continue;}
	 }
	 else
	 {
	    if((max1*d1>=mx1)&&(min2*d1<=mx1)) {res++; continue;}
	 }
      }
   }
}
int main()
{
   line=new cline[maxN];
   init();
   solve();
   output(res);
   delete [] line;
   return 0;
}