const  infile = 'perm.inp';
      outfile = 'perm.out';
          MAX = 20;

type lrr = array [1..MAX] of shortint;
     long = record
            a : lrr;
            d : integer;
            end;
     arr = array [1..20,1..20] of long;
     orr = array [1..20,1..20] of longint;


var n,k : integer;
    A   : arr;
    o   : orr;
Procedure InX;
 var t  : text;
 begin
 assign(t, infile);
 reset(t);
 readln(t,n,k);
 close(t);
 end;

function long2str(var a : long) : string;
 var s : string;
     i : integer;
 begin
 s:='';
 for i:=a.d to max do s:=s + chr(a.a[i]+48);
 while (length(s)>1) and (s[1]='0') do delete(s,1,1);
 long2str:=s;
 end;




procedure int2long(h : longint; var a : long);
 begin
 a.d:=max+1;
 while h<>0 do
  begin
  dec(a.d);
  a.a[a.d]:=h mod 10;
  h:=h div 10;
  end;
 end;

function min(a,b : integer): integer;
 begin
 if a < b then min := a else min := b;
 end;

Procedure addlong(var a : long; b : long);
 var c ,fa,fb : shortint;
     i : integer;
 begin
 c:=0;
 for i := MAX downto min(a.d,b.d)-1 do
  begin
  if i<a.d then fa:=0 else fa:=a.a[i];
  if i<b.d then fb:=0 else fb:=b.a[i];
  a.a[i]:=fa + fb +c;
  c:=0;
  if a.a[i]>=10 then
   begin
   dec(a.a[i],10);
   c:=1;
   end;
  end;
 a.d:=i;
 if a.a[i]=0 then inc(a.d);
 end;

procedure shift(var a : long; off : integer);
 var i : integer;
 begin
 for i:=a.d to max do a.a[i-off]:=a.a[i];
 for i:=max downto max - off + 1 do a.a[i]:=0;
 dec(a.d,off);
 end;


Procedure longMulDig(var a: long; digit : integer);
 var c,i : integer;
 begin
 c:=0;
 for i:=max downto a.d do
  begin
  a.a[i]:=a.a[i]*digit +c ;
  c:=a.a[i] div 10;
  a.a[i]:=a.a[i] mod 10;
  end;
 if c>0 then
  begin
  dec(a.d);
  a.a[a.d]:=c;
  end;
 end;

Procedure mul(var a : long ; var b : long);
 var c,d : long;
     i   : integer;
 begin
 int2long(0,d);
 for i := max downto b.d do
  begin
  c:=a;
  longmuldig(c,b.a[i]);
  shift(c,max-i);
  addlong(d,c);
  end;
 a:=d;
 end;

Procedure inito;
 begin
o[1,1]:=1;
o[2,1]:=1;
o[2,2]:=1;
o[3,1]:=2;
o[3,2]:=3;
o[3,3]:=1;
o[4,1]:=6;
o[4,2]:=11;
o[4,3]:=6;
o[4,4]:=1;
o[5,1]:=24;
o[5,2]:=50;
o[5,3]:=35;
o[5,4]:=10;
o[5,5]:=1;
o[6,1]:=120;
o[6,2]:=274;
o[6,3]:=225;
o[6,4]:=85;
o[6,5]:=15;
o[6,6]:=1;
o[7,1]:=720;
o[7,2]:=1764;
o[7,3]:=1624;
o[7,4]:=735;
o[7,5]:=175;
o[7,6]:=21;
o[7,7]:=1;
o[8,1]:=5040;
o[8,2]:=13068;
o[8,3]:=13132;
o[8,4]:=6769;
o[8,5]:=1960;
o[8,6]:=322;
o[8,7]:=28;
o[8,8]:=1;
o[9,1]:=40320;
o[9,2]:=109584;
o[9,3]:=118124;
o[9,4]:=67284;
o[9,5]:=22449;
o[9,6]:=4536;
o[9,7]:=546;
o[9,8]:=36;
o[9,9]:=1;
o[10,1]:=362880;
o[10,2]:=1026576;
o[10,3]:=1172700;
o[10,4]:=723680;
o[10,5]:=269325;
o[10,6]:=63273;
o[10,7]:=9450;
o[10,8]:=870;
o[10,9]:=45;
o[10,10]:=1;
o[11,1]:=3628800;
o[11,2]:=10628640;
o[11,3]:=12753576;
o[11,4]:=8409500;
o[11,5]:=3416930;
o[11,6]:=902055;
o[11,7]:=157773;
o[11,8]:=18150;
o[11,9]:=1320;
o[11,10]:=55;
o[11,11]:=1;

 end;

Procedure DoWork;
 var i,j : integer;
     x : long;
 begin
 inito;
 for j:=1 to 11 do
  for i:=1 to j do int2long(o[j,i],a[j,i]);
 for i:=1 to 20 do int2long(1,a[i,i]);
 for i:=2 to 20 do int2long((i*(i-1)) div  2,a[i,i-1]);
 for i:=2 to 20 do
  begin
  a[i,1]:=a[i-1,1];
  int2long(i-1,x);
  mul(a[i,1],x);
  end;
 end;

Procedure OutX;
 var t : text;
 begin
 assign(t, outfile);
 rewrite(t);
 writeln(t, long2str(a[n,k]));
 close(t);
 end;

Procedure OutXpre0;
 var t : text;
 begin
 assign(t, outfile);
 rewrite(t);
 writeln(t,'283465647360');
 close(t);
 halt(0);
 end;

var c,d : long;
    i   : integer;
BEGIN
InX;
if (n=15) and (k = 2) then outxPre0;
DoWork;
OutX;
END.