#include <stdio.h>
#include <string.h>

#define REGT unsigned long long

int outi[8192];
int outr[8192];
int outc;

int regsu;
int izrl;
int izrp;
char izr[512];

REGT regs[10000];


int sto(int p)
{
//  printf(">> STO %d\n",p);
  outi[outc] = 1;
  outr[outc] = p;
  outc++;
}

int loa(int p)
{
//  printf(">> LOA %d\n",p);
  outi[outc] = 2;
  outr[outc] = p;
  outc++;
  
}

int mul(int p)
{
//  printf(">> MUL %d\n",p);
  outi[outc] = 3;
  outr[outc] = p;
  outc++;
  
}

int add(int p)
{
//  printf(">> ADD %d\n",p);
  outi[outc] = 4;
  outr[outc] = p;
  outc++;
  
}

REGT calc(void)
{
  REGT w;
  int i,r;

  w = 0;

  for (i=0;i<outc;i++)
  {
    r = outr[i];
    switch (outi[i])
    {
      case 1 :
       regs[ r ] = w;
       break;
      case 2 :
       w = regs[ r ];
       break;
      case 3 :
       w *= regs[ r ];
       break;
      case 4 :
       w += regs[ r ];
       break;
    }
  }
  return w;
}

int parse(int ismain);

int expr1(void)
{
  int re;
  
  if (izr[izrp]=='(')
  {
    izrp++;
    re = parse(0);
  } else {
    if (izr[izrp]=='X')
    {
      izrp++;
      re = izr[izrp] - '0';
      izrp++;
    } // else { printf("Error in expression\n"); }
  }
  if (izr[izrp]=='*')
  {
    int re1,re2;
    
    regsu++;
    re1 = regsu;
    sto(re1); //   printf("STO %d\n",re1);

    loa(re); //printf("LOA %d\n",re);
    izrp++;
    mul(expr1()); //printf("MUL %d\n",expr1());

    regsu++;
    re2 = regsu;
    sto(re2); //printf("STO %d\n",re2);

    loa(re1); //printf("LOA %d\n",re1);

    return re2;
  } else { return re; }
}

int parse(int ismain)
{
  int inreg;

  int treg1,treg2;

  if (ismain==0)
  {
    regsu++;
    treg1 = regsu;
    sto(treg1); //printf("STO %d\n",treg1);
  }

  inreg = -1;

  while (izr[izrp]!=')') {
  
    switch (izr[izrp])
    {
      case '(' :
       izrp++;
       inreg = parse(ismain);
       if (inreg>0) { loa(inreg); }//printf("LOA %d\n",inreg); }
       break;
      case 'X' :
       izrp++;
       inreg = izr[izrp]-'0';
       loa(inreg); //printf("LOA %d\n",inreg);
       izrp++;
       break;
      case '+' :
       izrp++;
       add(expr1()); //printf("ADD %d\n",expr1());
       break;
      case '*' :
       izrp++;
       mul(expr1()); //printf("MUL %d\n",expr1());
       break;

      izrp++;
    }
  }
  izrp++;

  if (ismain==0)
  {
    regsu++;
    treg2 = regsu;
    sto(treg2); //printf("STO %d\n",treg2);
    loa(treg1); //printf("LOA %d\n",treg1);
    return treg2;
  } else { return 0; }
}

int main(void)
{
  FILE* f;
  int i,r;
  f = fopen("assem.inp","rt");
  for (i=1;i<=9;i++)
  {
    fscanf(f,"%lld",&regs[i]);
  }
  fscanf(f,"%s",izr);  
  fclose(f);

  regsu=9;

  izrl = strlen(izr);
  for (i=0;i<100;i++)
  {
    izr[izrl] = ')';
    izrl++;
  }

//  printf("Start\n");
  parse(1);

  f = fopen("assem.out","wt");
  fprintf(f,"%llu\n",calc());
  fprintf(f,"%d\n",outc);
  for (i=0;i<outc;i++)
  {
    r = outr[i];
    switch (outi[i])
    {
      case 1:
      fprintf(f,"STO %d\n",r);
      break;
      case 2:
      fprintf(f,"LOA %d\n",r);
      break;
      case 3:
      fprintf(f,"MUL %d\n",r);
      break;
      case 4:
      fprintf(f,"ADD %d\n",r);
      break;
      fprintf(f,"STO 10002\n");
    }
  }
  fclose(f);
}
