#include <fstream.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#define max(a, b) ((a) > (b) ? (a) : (b))

  ifstream fin ("assem.inp");
  ofstream fout ("assem.out");

  class Long
    {
      public:
        int dc;
        char A[1000];
        Long ();
        void dai (long long);
        void Add (Long &, Long &);
        void Po1 (int, Long &, int l);
        void Po  (Long &, Long &);
    };

  Long A[10002];
  char *s;
  char ST[300];
  char opz[300];
  long long opzbr = -1;
  long long c;
  long long stbr = -1;
  long long Sta [100000];
  long long sss = -1;
  char *a[100000];
  long long abr = -1;
  long long store = 9;

  Long::Long ()
    {
      int dc = -1;
      memset (A, 0, sizeof (A));
    }

  void Long::dai (long long x)
    {
      dc = -1;
      while (x != 0)
        {
          dc++;
          A[dc] = x % 10;
          x /= 10;
        }
    }

  void Long::Add (Long &x, Long &res)
    {
      int end = max (dc, x.dc);
      int carry = 0;
      for (int i = 0; i <= end; i++)
        {
          res.A[i] = A[i] + x.A[i] + carry;
          carry = res.A[i] / 10;
          res.A[i] %= 10;
        }
      res.dc = end;
      if (carry)
        {
          res.dc++;
          res.A[res.dc] = carry;
        }
    }

  void Long::Po1 (int x, Long &res, int l)
    {
      int end = dc;
      int carry = 0;
      for (int i = 0; i <= end; i++)
        {
          res.A[i + l] = A[i]*x + carry;
          carry = res.A[i + l] / 10;
          res.A[i + l] %= 10;
        }
      res.dc = end + l;
      if (carry)
        {
          res.dc++;
          res.A[res.dc] = carry;
        }
    }

  void Long::Po (Long &x, Long &res)
    {
      Long tz;
      for (int i = 0; i <= dc; i++)
        {
          memset (tz.A, 0, sizeof (tz.A));
          x.Po1 (A[i], tz, i);
          res.Add (tz, res);
        }
    }

  void ReadData ()
    {
      long long q;
      for (long long i = 1; i <= 9; i++)
        {
          fin >> q;
          A[i].dai (q);
        }
      s = new char [300];
      fin >> s;
    }

  void MakeOpz ()
    {
      long long end = strlen (s);
      while (c != end)
        {
          switch (s[c])
            {
              case '(':
                        {
                          stbr++;
                          ST[stbr] = '(';
                          c++;
                        } break;
              case ')':
                        {
                          while (ST[stbr] != '(')
                            {
                              opzbr++;
                              opz[opzbr] = ST[stbr];
                              stbr--;
                            }
                          stbr--;
                          c++;
                        } break;
              case 'X':
                        {
                          c++;
                          opzbr++;
                          opz[opzbr] = s[c];
                          c++;
                        } break;
              case '+':
                        {
                          c++;
                          while (ST[stbr] != '(' && stbr != -1)
                            {
                              opzbr++;
                              opz[opzbr] = ST[stbr];
                              stbr--;
                            }
                          stbr++;
                          ST[stbr] = '+';
                        } break;
              case '*':
                       {
                         c++;
                         while (ST[stbr] != '*' && stbr != -1)
                           {
                             opzbr++;
                             opz[opzbr] = ST[stbr];
                             stbr--;
                           }
                         stbr++;
                         ST[stbr] = '*';
                       }
            }
        }
      while (stbr != -1)
        {
          opzbr++;
          opz[opzbr] = ST[stbr];
          stbr--;
        }
    }

  void Solve ()
    {
      for (long long i = 0; i <= opzbr; i++)
        {
          if (isdigit (opz[i]))
            {
              sss++;
              char q = opz[i];
              Sta[sss] = atoi (&q);
            }
          if (opz[i] == '+')
            {
              Long sum;
              char *b;
              char *c;
              b = new char [10];
              itoa (Sta[sss - 1], b, 10);
              A[Sta[sss - 1]].Add (A[Sta[sss]], sum);
              abr++;
              a[abr] = new char [20];
              c = new char [20];
              c[0] = 'L';
              c[1] = 'O';
              c[2] = 'A';
              c[3] = ' ';
              c[4] = 0;
              a[abr] = c;
              strcat (a[abr], b);
              abr++;
              a[abr] = new char [20];
              a[abr][0] = 0;
              itoa (Sta[sss], b, 10);
              c = new char [20];
              c[0] = 'A';
              c[1] = 'D';
              c[2] = 'D';
              c[3] = ' ';
              c[4] = 0;
              a[abr] = c;
              strcat (a[abr], b);
              abr++;
              a[abr] = new char [20];
              c = new char [20];
              c[0] = 'S';
              c[1] = 'T';
              c[2] = 'O';
              c[3] = ' ';
              c[4] = 0;
              a[abr] = c;
              store++;
              itoa (store, b, 10);
              strcat (a[abr], b);
              sss--;
              Sta[sss] = store;
              A[store] = sum;
            }
          if (opz[i] == '*')
            {
              Long sum;
              char *b;
              char *c;
              b = new char [10];
              itoa (Sta[sss - 1], b, 10);
              A[Sta[sss - 1]].Po (A[Sta[sss]], sum);
              abr++;
              a[abr] = new char [20];
              c = new char [20];
              c[0] = 'L';
              c[1] = 'O';
              c[2] = 'A';
              c[3] = ' ';
              c[4] = 0;
              a[abr] = c;
              strcat (a[abr], b);
              abr++;
              a[abr] = new char [20];
              itoa (Sta[sss], b, 10);
              c = new char [20];
              c[0] = 'M';
              c[1] = 'U';
              c[2] = 'L';
              c[3] = ' ';
              c[4] = 0;
              a[abr] = c;
              strcat (a[abr], b);
              abr++;
              a[abr] = new char [20];
              c = new char [20];
              c[0] = 'S';
              c[1] = 'T';
              c[2] = 'O';
              c[3] = ' ';
              c[4] = 0;
              a[abr] = c;
              store++;
              itoa (store, b, 10);
              strcat (a[abr], b);
              sss--;
              Sta[sss] = store;
              A[store] = sum;
            }  
        }
    }

  ofstream & operator << (ofstream &os, Long &x)
    {
      for (int i = x.dc; i >= 0; i--)
        os << int (x.A[i]);
      return os;
    }

  void WriteData ()
    {
      fout << A[store] << endl;
      fout << abr + 1 << endl;
      for (long long i = 0; i <= abr; i++)
        fout << a[i] << endl;
    }

  long main ()
    {
      ReadData ();
      MakeOpz ();
      Solve ();
      WriteData ();
      return 0;
    }
