#include <stdio.h>
#define INPF "assem.inp"
#define OUTF "assem.out"
#define MAXCELLS 10000

struct Command
              {
                char cm[10];
              };

int cell[MAXCELLS]={0};
int used[MAXCELLS]={0};

int num[MAXCELLS];
char op[MAXCELLS];
int st1,st2;

Command cmds[MAXCELLS];
int br=0;


int acc=0;
FILE *f=fopen(INPF,"rt");
FILE *o=fopen(OUTF,"wt");

void DoOper2(char oper)
  {
    char ch;
    int tmp;
    ch=op[st2-1];
    st2--;
    while(st2 && ch==oper && ch!='(')
      {
        tmp=cell[num[st1-1]];
        sprintf(cmds[br++].cm,"LOA %d\n",num[st1-1]);
        st1--;
        if(oper=='+')
          {
            sprintf(cmds[br++].cm,"ADD %d\n",num[st1-1]);
            tmp+=cell[num[st1-1]];
          }
                 else
                   {
                     sprintf(cmds[br++].cm,"MUL %d\n",num[st1-1]);
                     tmp*=cell[num[st1-1]];
                   }
        st1--;
        for(int i=11;i<MAXCELLS;i++)
          if(!used[i])
            {
              sprintf(cmds[br++].cm,"STO %d\n",i);
              cell[i]=tmp;
              num[st1++]=i;
              used[i]=1;
              break;
            }
        ch=op[st2-1];
        st2--;
      }
    op[st2++]=ch;
  }

void DoOper()
  {
    int tmp;
    char ch;
    while(op[st2-1]!='(' && st2)
      {
        ch=op[st2-1];st2--;
        switch(ch)
          {
            case '+' :
              sprintf(cmds[br++].cm,"LOA %d\n",num[st1-1]);
              tmp=cell[num[st1-1]];
              st1--;
              sprintf(cmds[br++].cm,"ADD %d\n",num[st1-1]);
              tmp+=cell[num[st1-1]];
              st1--;
              for(int i=11;i<MAXCELLS;i++)
                if(!used[i])
                  {
                    sprintf(cmds[br++].cm,"STO %d\n",i);
                    cell[i]=tmp;
                    num[st1++]=i;
                    used[i]=1;
                    break;
                  }
              break;
            case '*' :
              sprintf(cmds[br++].cm,"LOA %d\n",num[st1-1]);
              tmp=cell[num[st1-1]];
              st1--;
              sprintf(cmds[br++].cm,"MUL %d\n",num[st1-1]);
              tmp*=cell[num[st1-1]];
              st1--;
              for(int i=11;i<MAXCELLS;i++)
                if(!used[i])
                  {
                    sprintf(cmds[br++].cm,"STO %d\n",i);
                    cell[i]=tmp;
                    num[st1++]=i;
                    used[i]=1;
                    break;
                  }
              break;
          }
      }
    if(op[st2-1]=='(') st2--;
  }

void Calc2()
  {
    char ch;
    int tmp;
    while(!feof(f))
      {
        fscanf(f,"%c",&ch);
        switch(ch)
          {
            case ')' : DoOper();break;
            case '+' :
              if(op[st2-1]=='*') DoOper2('*');
              if(st2 && op[st2-1]=='+') {DoOper2(ch);op[st2++]=ch;}
                                   else op[st2++]=ch;
              break;
            case '*' :
              if(st2 && op[st2-1]=='*') {DoOper2(ch);op[st2++]=ch;}
                                   else op[st2++]=ch;
              break;
            case 'X' :
              fscanf(f,"%d",&tmp);
              num[st1++]=tmp;
//              if(op[st2-1]=='*') DoOper2('*');
              break;
            case '(' : op[st2++]=ch;break;
          }
      }
  }

void main()
  {
    for(int i=1;i<=10;i++)
      fscanf(f,"%d",&cell[i]);
    Calc2();
    DoOper();
    sprintf(cmds[br++].cm,"LOA %d\n",num[st1-1]);
    fprintf(o,"%d\n%d\n",cell[num[st1-1]],br);
    char cmd1[10],cmd2[10],cl1,cl2;
    for(int i=1;i<br;i++)
        fprintf(o,"%s",cmds[i].cm);
    fclose(f);
    fclose(o);
  }
