#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#define INPF "pass.inp"
#define OUTF "pass.out"
#define MAXLEN 300000
#define MAXM 300
#define MIN(a,b) ((a)>(b)?(b):(a))
#define INF 300000

struct Area {
              int st,en;
            } areas[2*MAXLEN];


int lett[26]={0};
char word[MAXLEN];
char ws[300][300];
int n,m,br=0,res=0;
int T[2*MAXLEN];

int cmp(const void *a,const void *b)
  {
    Area aa=*((Area*)a);
    Area bb=*((Area*)b);
    return aa.en-bb.en;
  }

void Init()
  {
    FILE *f=fopen(INPF,"rt");
    fscanf(f,"%d%d",&n,&m);
    for(int i=0;i<n;i++)
      {
        fscanf(f," %c ",&word[i]);
        lett[word[i]-97]=1;
      }
    for(int i=0;i<m;i++)
      fscanf(f," %s ",ws[i]);
    fclose(f);
  }

void Output()
  {
    FILE *f=fopen(OUTF,"wt");
    fprintf(f,"%d\n",res);
    fclose(f);
  }

void FindAreas()
  {
    int pos;
    int len,smisyl;
    for(int i=0;i<m;i++)
      {
        len=strlen(ws[i]);
        smisyl=1;
        for(int k=0;k<len;k++)
          if(!lett[ws[i][k]-97]) {smisyl=0;break;}
        if(smisyl)
        for(int j=0;j<=n-len;j++)
          {
            pos=0;
            while(pos<len && word[j+pos]==ws[i][pos])
              pos++;
            if(pos==len) {areas[br].st=j;areas[br++].en=j+pos-1;}
          }
      }
  }

void Dinamic()
  {
    int curr;
    qsort(areas,br,sizeof(areas[0]),cmp);
    for(int i=0;i<br;i++)T[i]=INF;
    T[0]=areas[0].st;
    for(int i=0;i<br;i++)
      for(int j=0;j<i;j++)
        if(areas[j].en<areas[i].st) T[i]=MIN(T[i],T[j]+areas[i].st-areas[j].en-1);
  }
void main()
  {
    Init();
    FindAreas();
    Dinamic();
    res=n;
    for(int i=0;i<br;i++)T[i]+=n-areas[i].en-1;
    for(int i=0;i<br;i++)if(res>T[i]) res=T[i];
    Output();
  }
