#include <stdio.h>

int n;
double mind,mindsq;

double px[1024],py[1024];

int joind[1024];
int fifo[1024];

int count;

int canjoin(int a,int b)
{
  double d,d1;

  d = px[a]-px[b];
  if (d>mind) { return 0; }
  d*=d;
  d1 = py[a]-py[b];
  d1*=d1;
  d+=d1;

  if (d<mindsq+1e-7) { return 1; }
  return 0;
}

int join(int start)
{
  int ffrom,fto,fnext;
  int i,j,a;

  joind[start] = 1;

  fifo[0] = start;
  ffrom = 0;
  fnext = 1;
  fto = 1;

  do {
    for (j=ffrom;j<fto;j++)
    {
      a = fifo[j];

      for (i=0;i<n;i++)
      {
        if (joind[i]==0)
        {
          if (canjoin(a,i))
          {
            joind[i]=1;
            fifo[fnext] = i;
            fnext++;
          }
        }
      }
    }
    ffrom = fto;
    fto = fnext;
  } while (ffrom<fto);
}

int find(void)
{
  int i;

  for (i=n-1;i>=0;i--)
  {
    if (joind[i]==0)
    {
      join(i);
      count++;
    }
  }
  return 0;
}

int main(void)
{
  FILE* f;
  FILE* outf;
  int i;
  f = fopen("points.inp","rt");
  outf = fopen("points.out","wt");

  fscanf(f,"%d ",&n);
  while (n)
  {
    memset(joind,0,sizeof(int)*n);

    fscanf(f,"%lf ",&mind);

    mindsq = mind*mind;

    for (i=0;i<n;i++)
    {
      fscanf(f,"%lf %lf ",&px[i],&py[i]);
    }

    count = 0;
    find();

    fprintf(outf,"%d\n",count);

    fscanf(f,"%d ",&n);
  }
  fclose(f);
  fclose(outf);

  return 0;
}
