/*
NAME: Ivan Anev
SCHOOL: SMG
PROGRAM: shsh
*/

#include <stdio.h>
#include <math.h>

#define MAXN 32

double eps = 0.01;
double fact[MAXN], sh[MAXN];
int n, v, d[MAXN], c[MAXN], cl, used[MAXN];

int check(int cv) {
    int i;

    if (cv < v) {
       for (i = 0; i < n; ++i)
           if (used[i] == 0 && cv + d[i] >= v)
              sh[i] += fact[cl] * fact[n-cl-1];
    }
}

int comb(int l, int i, int cv) {
    if (l == 0) {
       check(cv);
    }
    else if (n - i >= l && cv < v) {
         --l;
         while (i < n) {
               used[i] = 1;
               c[l] = i;
               comb(l, i+1, cv + d[i]);
               used[i] = 0;
               ++i;
         }
    }
}

int main(void) {
    FILE *fin, *fout;
    int i, f;
    double t;

    fact[0] = fact[1] = 1.0;
    for (i = 2; i < MAXN; ++i)
        fact[i] = fact[i-1] * i;

    fin = fopen("shsh.inp", "r");
    fout = fopen("shsh.out", "w");

    f = 1;
    while (1) {
          fscanf(fin, "%d", &n);
          if (n == 0)
             break;
          if (f)
             f = 0;
          else
              fprintf(fout, "\n");
          fscanf(fin, "%d", &v);
          for (i = 0; i < n; ++i)
              fscanf(fin, "%d", &d[i]);
          for (i = 0; i < n; ++i)
              sh[i] = 0.0;
          for (cl = 1; cl < n; ++cl)
              comb(cl, 0, 0);
          for (i = 0; i < n; ++i) {
              t = 100.0 * sh[i] / fact[n] + 0.01;
              if (fabs(floor(t) - t) <= eps)
                 fprintf(fout, "%d\n", (int)t);
              else
                  fprintf(fout, "%.1f\n", t);
          }
    }

    fclose(fin);
    fclose(fout);

    return 0;
}
