#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


#define MAXN 32
#define EPS (1e-5)


int N, V;
int p[MAXN];
int used[MAXN];
double perc[MAXN];
double pts[MAXN];
double fact[MAXN];
char str[MAXN][20];
int P;
/*int st[MAXN];
int ist;*/
int ft = 1;


FILE *fin, *fout;


int read_all(void);
void do_all(void);
void bt(int u, int s, int n, int tocheck);
void write_all(void);




int main(void)
{
  fin  = fopen("shsh.inp", "rt");
  fout = fopen("shsh.out", "wt");
  while (read_all()) {
    do_all();
    write_all();
  }
  return 0;
}




int read_all(void)
{
  int i;

  if (fscanf(fin, "%d", &N) != 1)  return 0;
  if (N <= 0)  return 0;
  fscanf(fin, "%d", &V);
  for (i = 0; i < N; i++) {
    fscanf(fin, "%d", &p[i]);
  }
  return 1;
}




void do_all(void)
{
  int i, j, t;
  double drc;

  fact[0] = 1;
  for (i = 1; i <= 20; i++)  fact[i] = fact[i-1]*i;
  for (i = 0; i < N; i++) {
    pts[i] = 0;
  }
/*  ist = 0;*/
/*  for (i = 0; i < N; i++)  st[ist++] = i;*/
  memset(used, 0, sizeof(used));
  bt(0, 0, 0, 1);
  for (i = 0; i < N; i++) {
    perc[i] = 100*pts[i]/fact[N];
/*    perc[i] = 11.489;*/
    sprintf(str[i], "%.5lf", 10*perc[i]);
    for (j = 1; str[i][j]; j++) {
      if (str[i][j-1] == '.')  break;
    }
    sscanf(str[i], "%d", &t);
    if (str[i][j] >= '5')  t++;
    sprintf(str[i], "%d.%c", t/10, '0'+t%10);
    if (t%10 == 0) {
      sprintf(str[i], "%d", t/10);
    }
    perc[i] *= 1;
  }
}




void bt(int u, int s, int n, int tocheck)
{
  if (s >= V)  return;
  if (tocheck) {
    int i;
    for (i = 0; i < N; i++) {
      if (used[i])  continue;
      if (s+p[i] >= V) {
        pts[i] += fact[n]*fact[N-n-1];
      }
    }
  }
  if (u >= N)  return;
/*  st[ist++] = u;*/
  bt(u+1, s, n, 0);
/*  --ist;*/
  used[u] = 1;
  bt(u+1, s+p[u], n+1, 1);
  used[u] = 0;
}




void write_all(void)
{
  int i;

  if (ft == 0)  fprintf(fout, "\n");
  for (i = 0; i < N; i++) {
    fprintf(fout, "%s\n", str[i]);
  }
  ft = 0;
}

