#include <stdio.h>
#include <string.h>
#include <math.h>
#define INPF "shsh.inp"
#define OUTF "shsh.out"
#define MAXN 25

short vs[MAXN];
short used[MAXN];
long long br[MAXN];
long long facts[MAXN];
short n,v,ls,cr;
double res[100][MAXN];
int ns[100];

void C(int k,int sum,int last)
  {
    if(sum>=v) return;
    if(k)
      {
        for(int i=last+1;i<n;i++)
          if(!used[i])
            {
              used[i]=1;
              C(k-1,sum+vs[i],i);
              used[i]=0;
            }
      }
      else
        {
          for(int i=0;i<n;i++)
            if(!used[i] && sum+vs[i]>=v) br[i]+=facts[n-ls-1]*facts[ls];
        }
  }

void Solve()
  {
    for(ls=1;ls<=n-1;ls++)
      C(ls,0,-1);
  }

void Output2()
  {
    long long total;
    double tmp1,tmp2;
    char str[10];
    FILE *f=fopen(OUTF,"wt");
    for(int i=0;i<cr;i++)
      {
        for(int j=0;j<ns[i];j++)
          {
            total=1;
            for(int k=1;k<=ns[i];k++) total*=k;
            sprintf(str,"%0.1lf",(res[i][j]*1.0/total*1.0)*100);
            sscanf(str,"%lf",&tmp1);
            if(modf(tmp1,&tmp2)==0.0) fprintf(f,"%0.0lf\n",tmp1);
                                 else fprintf(f,"%0.1lf\n",tmp1);
          }
        if(i<cr-1) fprintf(f,"\n");
      }
    fclose(f);
  }

void Output()
  {
    for(int i=0;i<n;i++)
      res[cr][i]=br[i];
  }

void Init()
  {
    FILE *f=fopen(INPF,"rt");
    cr=0;
    while(1)
      {
        fscanf(f,"%d",&n);
        if(!n) {fclose(f);return;}
        ns[cr]=n;
        fscanf(f,"%d",&v);
        facts[0]=1;facts[1]=1;for(int i=2;i<=n;i++) facts[i]=facts[i-1]*i;
        for(int i=0;i<n;i++)
          fscanf(f,"%d",&vs[i]);
        memset(used,0,sizeof(used));
        memset(br,0,sizeof(br));
        Solve();
        Output();
        cr++;
      }
  }


int main()
  {
    Init();
    Output2();
    return 0;
  }
