{$MODE objfpc}

Uses
  SysUtils;

Const
  CacheSize = 3000000;

Type
  PList = ^TList;
  TList = Record
    size : Integer;
    l : Array[0..1000000] Of Integer;
  End;
{  TPr = Record
    prev, next : Integer;
    nm : Integer;
    dist : Integer;
  End;}

Var
  pd : Array[0..50] Of Integer;
  pdnum : Integer;
  _list1 : TList;
  _list2 : TList;
  _list3 : TList;
  limit_a, limit_b : Integer;
  QLimit : Integer;
  sum : Integer;
{  pr : Array[0..30000] Of TPr;}
  lbh : Array[0..30000] Of Integer;
  depth : Array[0..30000] Of Integer;
  bestnum, bestdepth : Integer;
  cache : Array[0..CacheSize] Of Integer;

Procedure Bahur;

Var
  list1, list2, list3 : PList;
  tmp : PList;
  a, b : Integer;
  sa, sb : Integer;
  I, J : Integer;
  pp : Integer;
  newp : Integer;
  newsum : Integer;

Begin
  list1 := @_list1;
  list2 := @_list2;
  list3 := @_list3;

  list1^.size := 1;
  list1^.l[1] := 1;
  For I := 1 To pdnum Do
  Begin
    pp := pd[I];
    list2^.size := 0;
    For J := 1 To list1^.size Do
    Begin
      newp := pp * list1^.l[J];
      If newp < QLimit Then
      Begin
        Inc(list2^.size);
        list2^.l[list2^.size] := newp;
      End
      Else
      Begin
        {...}
      End;
    End;

    list3^.size := 0;
    a := 1;
    b := 1;
    newsum := 0;
    While (a <= list1^.size) Or (b <= list2^.size) Do
    Begin
      If a <= list1^.size Then
        sa := list1^.l[a]
      Else
        sa := $7FFFFFFF;
      If b <= list2^.size Then
        sb := list2^.l[b]
      Else
        sb := $7FFFFFFF;
{      Writeln(sa, ' ', sb);}
      If sa <= sb Then
      Begin
        Inc(list3^.size);
        list3^.l[list3^.size] := sa;
        Try
          {$OVERFLOWCHECKS ON}
          Inc(newsum, sa);
          {$OVERFLOWCHECKS OFF}
        Except
          sum := $7FFFFFFF;
          Exit;
        End;
        Inc(a);
        If sa = sb Then
          Inc(b);
      End
      Else
      Begin
        Inc(list3^.size);
        list3^.l[list3^.size] := sb;
        Try
          {$OVERFLOWCHECKS ON}
          Inc(newsum, sb);
          {$OVERFLOWCHECKS OFF}
        Except
          sum := $7FFFFFFF;
          Exit;
        End;
        Inc(b);
      End;
      If newsum >= QLimit Then
      Begin
        sum := $7FFFFFFF;
        Exit;
      End;
    End;

{    For J := 1 To list3^.size Do
      Write(list3^.l[J], '"');
    Writeln;}


    tmp := list1;
    list1 := list3;
    list3 := tmp;

  End;
  sum := newsum;
{  For I := 1 To list1^.size Do
    Write(list1^.l[I], '"');
  Writeln;}
End;

Procedure ReadIn;

Var
  F : Text;

Begin
  ASSign(F, 'SEQ.INP');
  Reset(F);
  Readln(F, limit_a, limit_b);
  Close(F);
End;

Function FastS(Q : Integer) : Integer;

Var
  QQ : Integer;
  dv : Integer;
  limit : Integer;
  I : Integer;

Begin
  If Q = 1 Then
    Exit(0);
  QLimit := Q;
  pdnum := 0;
  QQ := Q;
  dv := 2;
  limit := Trunc(Sqrt(Q) + 2);
  Repeat
    If dv > QQ Then
      Break;
    If dv > limit Then
    Begin
      Inc(pdnum);
      pd[pdnum] := QQ;
{      Write('!');}
{      Write(' ', QQ, ' ');}
      Break;
    End;
    If (QQ Mod dv) = 0 Then
    Begin
      QQ := QQ Div dv;
      limit := Trunc(Sqrt(Q) + 2);
{      Write(' ', dv, ' ');}
      Inc(pdnum);
      pd[pdnum] := dv;
    End
    Else
      Inc(dv);
  Until False;
  Bahur;
  FastS := sum;

{  For I := 1 To pdnum Do
    Write(' ', pd[I]);
  Writeln;}
End;

Function FastS_cached(Q : Integer) : Integer;

Begin
  If Q > CacheSize Then
    FastS_cached := FastS(Q)
  Else
  Begin
    If cache[Q] <> $7F7F7F7F Then
      FastS_cached := cache[Q]
    Else
    Begin
      cache[Q] := FastS(Q);
      FastS_cached := cache[Q];
    End;
  End;
End;

Function S(Q : Integer) : Integer;

Var
  I : Integer;

Begin
  S := 0;
  For I := 1 To Q Div 2 Do
    If (Q Mod I) = 0 Then
    Begin
      Inc(S, I);
      If S >= Q Then
        Exit($7FFFFFFF);
    End;
End;

{Procedure UpdatePr(q : Integer);

Var
  news : Integer;
  p : PPr;

Begin
  If q.nm = 0 Then
  p := @pr[q];
  news := FastS(p.nm);
  If news < q.nm Then
  Begin
    q.nm := news;
    Inc();
  End;
End;}

Procedure LBahur;

Var
  I : Integer;
  ad : Boolean;
  news : Integer;
  F : Text;

Begin
  For I := limit_a To limit_b Do
  Begin
    lbh[I - limit_a + 1] := I;
    depth[I - limit_a + 1] := 1;
  End;

  Repeat
    ad := True;
    For I := limit_a To limit_b Do
    Begin
{      Writeln(lbh[I - limit_a + 1], ' ', depth[I - limit_a + 1]);}
      If lbh[I - limit_a + 1] <> 0 Then
      Begin
        ad := False;
        news := FastS_cached(lbh[I - limit_a + 1]);
        If news >= lbh[I - limit_a + 1] Then
        Begin
          news := 0;
        End;
        lbh[I - limit_a + 1] := news;
{        If news >= limit_a Then
        Begin
          If depth[I - limit_a + 1] > depth[news - limit_a + 1] Then
          Begin
            Inc(depth[I - limit_a + 1], depth[news - limit_a + 1]);
            lbh[I - limit_a + 1] := lbh[news - limit_a + 1];
            lbh[news - limit_a + 1] := 0;
            depth[news - limit_a + 1] := 0;
          End
          Else
          Begin
            If depth[I - limit_a + 1] < depth[news - limit_a + 1] Then
              Writeln('bug ', depth[I - limit_a + 1], ' ', depth[news - limit_a + 1]);
          End;
        End
        Else}
          If news <> 0 Then
            Inc(depth[I - limit_a + 1]);
        If depth[I - limit_a + 1] > bestdepth Then
        Begin
          bestdepth := depth[I - limit_a + 1];
          bestnum := I;
        End;
      End;
    End;
{    Readln;}
  Until ad;
  ASSign(F, 'SEQ.OUT');
  Rewrite(F);
  Writeln(F, bestnum, ' ', bestdepth);
  Close(F);
End;

Procedure Bahur2;

Begin
End;

Var
  I : Integer;
{  s1, s2 : Integer;}

Begin
  FillChar(cache, SizeOf(cache), $7F);
  bestnum := 0;
  bestdepth := 0;
  ReadIn;
  LBahur;
{  For I := 1 To 20 Do
    Writeln(I, ' ', FastS(I));}


{  For I := 2000000000 To 2000000020 Do
  Begin
    Write(I, ' ');
    s1 := FastS(I);
    Write(s1, ' ');}
{    s2 := S(I);
    Write(s2);
    If s1 <> s2 Then
    Begin
      Writeln('!!!');
      Halt;
    End;}
{    Writeln;
  End;}
{  For I := 2000000000 To 2000000020 Do
  Begin
    Write(I);
    FastS(I);
  End;}
End.
