#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#define MAXN 51
#define MAXK 16

int arr_[MAXK+1], *arr=arr_+1;
int iarr;
int cnt[MAXN];
int nnk[MAXN][MAXK];
int N, M;
int P;



void read_all(void);
void do_all(void);
void init(void);
void decode(int P);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i;
  char s[30];
  
/*  FILE *f = fopen("decode.inp", "rt");
  fscanf(f, "%[01]", s);
  for (i = 23; i >= 0; i--) {
    P += (s[i]-'0')<<(23-i);
  }
  fclose(f);*/
  scanf("%[01]", s);
  for (i = 23; i >= 0; i--) {
    P += (s[i]-'0')<<(23-i);
  }
}



void do_all(void)
{
  init();
  decode(P);
}



void init(void)
{
  int n, k, i;

  for (i = 0; i < MAXN; i++)  nnk[i][0] = 1;
  nnk[0][0] = 1;
  for (n = 1; n < MAXN; n++) {
    for (k = 1; k < MAXK; k++) {
      nnk[n][k] = nnk[n-1][k] + nnk[n-1][k-1];
    }
  }
}



void decode(int P)
{
  int i, j, k, c, c1, j1;
  int res;

  for (i = 0; i < 6; i++) {
    for (j = arr[i-1]+1; j+5-i <= 49; j++) {
      arr[i] = j;
      for (k = i+1; k < 6; k++) {
        arr[k] = arr[k-1]+1;
      }
      c = encode();
      if (c <= P) {
        c1 = c;
        j1 = j;
      }
    }
    arr[i] = j1;
  }
}



int encode(void)
{
  int i, j, c, m;
  int res;
  int arr1[MAXK];

  memmove(arr1, arr, sizeof(arr1));
  res = 0;
  m = 49;
  for (i = 0; i < 6; i++) {
    c = arr[i];
    for (j = 1; j < c; j++) {
      res += nnk[m-j][5-i];
    }
    for (j = i+1; j < 6; j++) {
      arr[j] -= c;
    }
    m -= c;
  }
  memmove(arr, arr1, sizeof(arr1));
  return res;
}



void write_all(void)
{
  int i;

  for (i = 0; i < 6; i++) {
    printf("%d%s", arr[i], (i==5)?"\n":" ");
  }
}
