#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>


#define MAXN 45100
#define MAXD 16

int sn[MAXN];
int pn[MAXN];
int npn;
int divi[MAXD][2];
int idivi;
int A, B;
int P, N;
/*int maxk[MAXN];*/



void read_all(void);
void do_all(void);
void init_pn(void);
int S(int n);
void bt(int ind, int cn, int *pres);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i;
  
  FILE *f = fopen("seq.inp", "rt");
  fscanf(f, "%d %d", &A, &B);
  fclose(f);
}



void do_all(void)
{
  int i, j, k, val;
  int rem[6]={2,4,3,1,5,0};
  int irem;

/*  for (i = 1; i <= 40; i++) {
    if (S(i) >= i)  continue;
    printf("%d : %d\n", i, S(i));
  }
  return;*/
  init_pn();
/*  for (i = 2e9; i < 2e9+20000; i++) {
    val = S(i);
  }
  return;*/
/*  A = 1000000;
  B = 20000+A;*/
  for (irem = 0; irem < 6; irem++) {
    for (i = A; i <= B; i++)  if (i%6 == rem[irem])  break;
    for (i = i; i <= B; i+=6) {
      for (j = i, k = 1; j >= 1; k++) {
        if (clock()/CLOCKS_PER_SEC >= 4.1)  return;
        val = S(j);
        if (val < j)  j = val;
        else  break;
        if (val == 0)  break;
      }
/*      if (k > maxk[i%6]) {
        maxk[i%6] = k;
      }               */
  /*    printf("%d : %d\n", i, k);*/
      if (k > P || (k == P && i < N)) {
        P = k;
        N = i;
      }
    }
  }
}



void init_pn(void)
{
  int i, j;

  for (i = 2; i < MAXN; i++) {
    if (sn[i])  continue;
    for (j = 2*i; j < MAXN; j+=i)  sn[j] = 1;
  }
  for (i = 2; i < MAXN; i++) {
    if (sn[i])  continue;
    pn[npn++] = i;
  }
}



int S(int n)
{
  int i, j, k;
  int res = -n;

  if (n == 1)  return 0;
  idivi = 0;
  for (i = 0; i < npn && pn[i] <= n; i++) {
    if (n%pn[i] == 0) {
      if (idivi-1 >= 0 && divi[idivi-1][0] == pn[i])  divi[idivi-1][1]++;
      else {
        divi[idivi][0] = pn[i];
        divi[idivi][1] = 1;
        idivi++;
      }
      n /= pn[i];
      i--;
    }
  }
  if (n > 1) {
    divi[idivi][0] = n;
    divi[idivi][1] = 1;
    idivi++;
  }
  bt(0, 1, &res);
  return res;
}



void bt(int ind, int cn, int *pres)
{
  int i;
  int cn1, res;

  if (ind >= idivi) {
    *pres += cn;
    return;
  }
  cn1 = cn;
  res = 1;
  for (i = 0; i <= divi[ind][1]; i++) {
    bt(ind+1, cn, pres);
    cn *= divi[ind][0];
  }
  cn = cn1;
}



void write_all(void)
{
  FILE *f = fopen("seq.out", "wt");
  fprintf(f, "%d %d\n", N, P);
  fclose(f);
}
