#include <stdio.h>
#include <math.h>

#define INP "seq.inp"
#define OUT "seq.out"

#define MAXP 10000

int a,b,primes,p[MAXP];

void init () {
FILE *f = fopen ( INP , "r");
     fscanf(f,"%d%d",&a,&b);
     fclose(f);
}

int prime (int x) {
int i;
    for (i=1; (i<=primes) && (p[i]*p[i]<=x) ; i++)
        if ((x%p[i])==0) return 0;
    return 1;
}

long long int pwr(int x,int y) {
long long int res = 1;
int i;
    for (i=1;i<=y;i++) res*=x;
    return res;
}

long long int C(int x,int power) {
     long long int st = pwr(x,power+1);
     st--;
     st/=x-1;
     return st;
}

long long sumdel(int x,int last) {
int i;
int c;
int fnd = 0;
long long sum = 0;
/*    for (i=1;i<=x;i++)
        if ((x%i)==0) sum+=i;*/
    if (x==1) return 1;
    for ( i = last+1;(i<=primes)&&(p[i]*p[i]<=x);i++)
        if ((x%p[i])==0) {
           c = 0;
           while ((x%p[i])==0) { x/=p[i]; c++; }
           fnd = 1;
           break;
        }
    if (!fnd) return x+1;
    sum = C(p[i],c);
    sum*=sumdel(x,i+1);
    return C(p[i],c)*sumdel(x,i);
}


void build_pt() {
int i;
     for (i=2;i*i<=b;i++)
         if (prime(i)) p[++primes] = i;
}

int len (int x) {
long long a = sumdel(x,0)-x;
    if (a<x) return 1+len(a); else return 0;
}

void solve () {
int bestl = 0;
int ind;
int i;
int l;
FILE *f;
     for (i=a;i<=b;i++) {
         l =  len(i);
         if (l>bestl) {
            bestl = l;
            ind = i;
         }
     }
     f = fopen ( OUT , "w");
     fprintf(f,"%d %d\n",ind,bestl);
     fclose(f);
}


int main () {
    init ();
    build_pt();
    solve();
    return 0;
}
