#include <fstream.h>
#include <math.h>
#include <time.h>

ifstream fin("seq.inp");
ofstream fout("seq.out");

unsigned long a,b,i,j,sb,maxn,maxc,count;
long huge B[20001]; // length if beginning with i+a
long huge D[20001];
long ii,sq,sbd,bb;

long SbDel(long nn)
{
  if (nn>=a&&nn<=b&&D[nn-a]) return D[nn-a];
  sq=sqrt(nn);
  sbd=1;
  for (ii=2;ii<=sq;ii++)
   if (nn%ii==0)
   {
    sbd+=ii;
    sbd+=nn/ii;
   }
  if (nn==sq*sq) sbd-=sq;
  if (nn>=a&&nn<=b) D[nn-a]=sbd;
  return sbd;
}

long GetC(long sb)
{
 if (sb>=a&&sb<=b&&B[sb-a]!=-1) return B[sb-a];
 bb=SbDel(sb);
 if (bb<sb&&bb>1)
  {
    if (sb>=a) { B[sb-a]=GetC(bb)+1; return B[sb-a]; }
    else return GetC(bb)+1;
  }
 else
  if (bb<=1)
  {
   if (sb>=a) B[sb-a]=bb+1;
   return bb+1;
  } else
  {
   if (sb>=a) B[sb-a]=1;
   return 1;
  }
}

time_t tim1,tim2;

void main()
{
 fin >> a >> b;
 for (i=0;i<=20000;i++) B[i]=-1;

 tim1=time(NULL);
 for (i=a;i<=b;i++)
  {
   if (i%100==0) { tim2=time(NULL); if (tim2-tim1>=5) break; }
   if (B[i-a]==-1)
    GetC(i);
  }
 maxc=0;
 j=i-1;
 for (i=a;i<=j;i++)
   if (B[i-a]>maxc)
    {
     maxc=B[i-a]; maxn=i;
    }
 //for (i=a;i<=a+300;i++)
 // if (D[i-a]>=i)
 // fout << i << " - " << D[i-a] << endl;
 fout << maxn << " " << maxc;
}