#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>



#define MAXN 1024
#define PNUM 100001



typedef struct {
  int arr1[MAXN];
} PER;



int N;
int arr[MAXN];
int issa[MAXN];
int isth[MAXN];
PER *used[PNUM];
int nused[PNUM];
int sz[PNUM];
int inds[MAXN];
int ninds;
int num[MAXN][2];
int put[MAXN];
int isp[MAXN];
int canput[MAXN];
int anew[MAXN];
int P;
int AA, AB;



int read_all(void);
int do_all(void);
int bt(int ind);
int check(int *pa, int *pb, int *pc);
void addused(void);
int isused(void);
int hash(void);
int cmp_num(const void *a, const void *b);
int write_all(void);



int main(void)
{
  read_all();
/*  for (N = 4; N <= 31; N++) {
    int i;

    memset(put, 0, sizeof(put));
    memset(isp, 0, sizeof(isp));
    memset(isth, 0, sizeof(isth));
    memset(issa, 0, sizeof(issa));*/
    do_all();
/*    for (i = 0; i < N; i++) {
      printf("%d%s", anew[i], (i == N-1)?"\n":" ");
    }
  }*/
  write_all();
  return 0;
}



int read_all(void)
{
  FILE *f = fopen("naver.inp", "rt");
  for (N = 0; fscanf(f, "%d", &arr[N]) == 1; N++)  ;
  fclose(f);
}



int do_all(void)
{
  int i, j, k;
  int a, b, c, ch, t, ch1, tt;

  clock();
  for (i = 0; i < N; i++)  isth[arr[i]]++;
  for (i = 0; i < N; i++) {
    for (j = i+1; j < N; j++) {
      if ((arr[i]+arr[j])%2 == 0) {
        k = (arr[i]+arr[j])/2;
        isth[arr[i]]--;
        isth[arr[j]]--;
        if (isth[k] > 0)  issa[k]++;
        isth[arr[i]]++;
        isth[arr[j]]++;
      }
    }
  }
  for (i = 0, j = N-1; i <= j; i++, j--) {
    inds[ninds++] = i;
    if (i < j)  inds[ninds++] = j;
  }
  for (i = 0; i < N; i++) {
    num[i][0] = arr[i];
    num[i][1] = issa[arr[i]];
  }
  qsort(num, N, sizeof(num[0]), cmp_num);
  for (i = 0; i < N; i++)  arr[i] = num[i][0];
  for (i = 0; i < N; i++)  canput[i] = 0;
  bt(0);
  return;
}



int bt(int ind)
{
  int i, j, c;

  if (ind == N) {
    int tt;
    int arr1[MAXN];

    return 1;
    /*
    memmove(arr1, arr, sizeof(arr));
    memmove(arr, anew, sizeof(arr));
    if (check(&tt, &tt, &tt) == 0)  return 1;
    memmove(arr, arr1, sizeof(arr));
    
    return 0;*/
  }
  for (i = 0; i < N; i++) {
    if (put[i])  continue;
    for (j = i+1; j < N; j++) {
      if (put[j])  continue;
      c = 2*arr[i]-arr[j];
      if (isp[c])   break;
    }
    if (j < N)  continue;
    else {
      anew[ind] = arr[i];
      isp[arr[i]]++;
      put[i] = 1;
      if (bt(ind+1))  return 1;
      put[i] = 0;
      isp[arr[i]]--;
      anew[ind] = 0;
    }
  }
  return 0;
}



int check(int *pa, int *pb, int *pc)
{
  int isth1[MAXN];
  int i, j, k, res;

  res = 0;
  memset(isth1, 0, sizeof(isth1));
  for (i = 0; i < N; i++) {
    isth1[arr[i]]++;
    for (j = i+1; j < N; j++) {
      isth1[arr[j]]++;
      k = 2*arr[j]-arr[i];
      if (k >= 0 && k < MAXN && isth[k] > isth1[k]) {
        *pa = i;
        *pb = j;
        res++;
      }
    }
    memset(isth1, 0, sizeof(isth1));
  }
  return res;
}



int cmp_num(const void *a, const void *b)
{
  return ((int *)b)[1]-((int *)a)[1];
}



int write_all(void)
{
  int i;
  
  FILE *f = fopen("naver.out", "wt");
  for (i = 0; i < N; i++) {
    fprintf(f, "%d%s", anew[i], (i == N-1)?"\n":" ");
  }
  fclose(f);
}

