#include <stdio.h>

FILE *fn;
int n, m, start, finish;
int neis[1024];
short nei[1024][1024];
int path[1024][1024];
char isp[1024][1024];
int heapsize=1;
short heapver[1048576];
int heaptime[1048576];
int heapspeed[1048576];
int inheap[1024];
int besttime[1024][1024];
int answer=2000000000;

int main(void) {
int i, t1, t2, t3, app, t4;

fn=fopen("HILL.INP", "r");
fscanf(fn, "%d %d", &n, &m);
for (i=0; i<m; i++) {
  fscanf(fn, "%d %d %d", &t1, &t2, &t3);
  if (!isp[t1][t2]) {
    nei[t1][neis[t1]]=t2;
    neis[t1]++;
    nei[t2][neis[t2]]=t1;
    neis[t2]++;
    isp[t1][t2]=isp[t2][t1]=1;
    path[t1][t2]=path[t2][t1]=t3;
  } else if (t3<path[t1][t2]) path[t1][t2]=path[t2][t1]=t3;
}
fscanf(fn, "%d %d", &start, &finish);
fclose(fn);

memset(besttime, 63, 1024*1024*4);
memset(besttime[start], 0, 4096);
heapver[heapsize]=start;
heaptime[heapsize]=0;
heapspeed[heapsize]=0;
heapsize++;
while (heapsize>1) {
  if (heapver[1]==finish) {
    answer=heaptime[1];
    break;
  } else {
    if (besttime[heapver[1]][heapspeed[1]]==heaptime[1]) for (i=0; i<neis[heapver[1]]; i++) {
      t1=nei[heapver[1]][i];
      if (heapspeed[1]>=2*path[heapver[1]][t1]) {
        t2=heaptime[1];
        t3=path[heapver[1]][t1];
      } else {
        t2=heaptime[1]+2*path[heapver[1]][t1]-heapspeed[1];
        t3=path[heapver[1]][t1];
      }
      if (t2<besttime[t1][t3]) {
        besttime[t1][t3]=t2;
        heapver[heapsize]=t1;
        heaptime[heapsize]=t2;
        heapspeed[heapsize]=t3;
        app=heapsize;
        heapsize++;
        while (app>1) {
          if (t2<heaptime[app/2] || (t2==heaptime[app/2] && t3>heapspeed[app/2])) {
            heapver[app]=heapver[app/2];
            heaptime[app]=heaptime[app/2];
            heapspeed[app]=heapspeed[app/2];
            app/=2;
            heapver[app]=t1;
            heaptime[app]=t2;
            heapspeed[app]=t3;
          } else break;
        }
      }
    }
    heapsize--;
    t1=heapver[1]=heapver[heapsize];
    t2=heaptime[1]=heaptime[heapsize];
    t3=heapspeed[1]=heapspeed[heapsize];
    t4=1;
    while (1) {
      if (t4*2>=heapsize) app=0;
      else if (t4*2+1==heapsize) app=t4*2;
      else if (heaptime[t4*2]<heaptime[t4*2+1] || (heaptime[t4*2]==heaptime[t4*2+1] && heapspeed[t4*2]>heapspeed[t4*2+1])) app=t4*2;
      else app=t4*2+1;
      if (app==0 || heaptime[app]>heaptime[t4] || (heaptime[app]==heaptime[t4] && heapspeed[app]<heapspeed[t4])) break;
      else {
        heapver[app]^=heapver[t4];
        heapver[t4]^=heapver[app];
        heapver[app]^=heapver[t4];
        heaptime[app]^=heaptime[t4];
        heaptime[t4]^=heaptime[app];
        heaptime[app]^=heaptime[t4];
        heapspeed[app]^=heapspeed[t4];
        heapspeed[t4]^=heapspeed[app];
        heapspeed[app]^=heapspeed[t4];
        t4=app;
      }
    }
  }
}

fn=fopen("HILL.OUT", "w");
if (answer<2000000000) fprintf(fn, "%.2lf\n", (double)answer/4);
else fprintf(fn, "0\n");
fclose(fn);

return 0;
}
