#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAX_N 30010

struct TStack{
 int node;
 struct TStack *next;
};

struct TStack *mas[MAX_N];
//int    br_nasl[MAX_N];
int      visited[MAX_N];

int res=0;
int n,m;
int count=0;

void input();
void solve();
int  max(int aa, int bb);
void DFS(int node);
void Add(struct TStack **stack, int node);
void FreeAll(struct TStack **el);

int main(void){
 int i;
 
// memset(br_nasl,0,sizeof(br_nasl));
 memset(visited,0,sizeof(visited));
 input();
 solve();
 for(i=1; i<=n; i++)
  FreeAll(&mas[i]);

 printf("%d\n", res);
 
 return 0;
}

void input(){
 int i;
 int a,b;

 scanf("%d %d", &n, &m);
 for(i=0; i<n; i++)
  mas[i]=NULL;
  
 for(i=0; i<m; i++){
  scanf("%d %d", &a, &b);
  Add(&mas[a], b);
  Add(&mas[b], a);
 }
}

void solve(){
 int i;

 for(i=1; i<=n; i++){
  if(!visited[i]) {
   count=0; DFS(i);
   res=max(res,count);
  }
 }
}

int max(int aa, int bb){
 return (aa>bb) ? aa:bb;
}

void DFS(int node){
 int i;
 struct TStack *tmp;

 visited[node]=1;
 count++;

 tmp=mas[node];
 while(tmp!=NULL){
  if(!visited[tmp->node]) DFS(tmp->node);
  tmp=tmp->next;
 }
 
}

void Add(struct TStack **stack, int node){
 struct TStack *tmp;

 tmp=(struct TStack *)malloc(sizeof(struct TStack));
 tmp->node=node;
 tmp->next=*stack;
 *stack=tmp;
}

void FreeAll(struct TStack **el){
 struct TStack *tmp;

 if(*el==NULL) return;
 while(*el!=NULL){
  tmp=*el;
  *el=(*el)->next;
  free(tmp);
 }
 
}

