#include <stdio.h>
#include <process.h>
#include <stdlib.h>

#define MAX     30010

struct LIST
    {
     long value;
     struct LIST *next;
    }*mas[MAX],*nlist;
    
long n,m,tekbr,res;
char pos[MAX];

void add_list(long i,long x)
{
 nlist=(struct LIST*)malloc(sizeof(struct LIST));
 if(nlist==NULL){printf("Not enough memory!!!\n");exit(1);}
 nlist->value=x;
 nlist->next=mas[i];
 mas[i]=nlist;
}

long remove_list(long i)
{long ret;
 struct LIST *tmp;
 if(mas[i]==NULL) return -1;
 ret=mas[i]->value;
 tmp=mas[i];
 mas[i]=mas[i]->next;
 free(tmp);
 return ret;
}

void DFS(long cur)
{long i,fr;
 pos[cur]=1;
 while(1)
  {
   fr=remove_list(cur);
   if(fr==-1) break;
   if(!pos[fr])
    {
     tekbr++;
     DFS(fr);
    }
  }
}

int main()
{long i,v1,v2;

 //freopen("TMP.IN","r",stdin);
 
 scanf("%ld%ld",&n,&m);
 for(i=0;i<m;i++)
 {
  scanf("%ld%ld",&v1,&v2);v1--;v2--;
  add_list(v1,v2);
  add_list(v2,v1);
 }
 
 for(i=0;i<n;i++)
  if(!pos[i])
  {
   tekbr=0;
   DFS(i);
   if(tekbr>res) res=tekbr;
  }

 for(i=0;i<n;i++)
  if(mas[i]!=NULL)
   {
    v1=remove_list(i);
    while(v1!=-1) v1=remove_list(i);
   }
   
 printf("%ld\n",res+1);
 
 return 0;
}

