#include <stdio.h>

#define MAXN            128

int free[MAXN];
int score[MAXN];
int count;

void read_data() {
        int i;
        char tmp;

        scanf("%d", &count);
        scanf("%c", &tmp);
        for (i = 1; i <= count; i++) {
                scanf("%c", &tmp);
                if (tmp == 'O')
                        free[i] = 1;
                else
                        free[i] = 0;
        }
}

void solve() {
        int i, j;
        int best = 0;

        score[0] = -10000;

        for (i = 2; i <= count; i+=2) {
                if (!free[i]) continue;
                for (j = 1; j < i; j++) {
                        if (!free[j]) continue;
                        if (i%j != 0) continue;
                        if (j%2 == 1)
                                score[i]++;
                        else
                                score[i]--;
                }
                if (score[i] > score[best])
                        best = i;
        }

        printf("%d\n", best);
}

int main() {
        read_data();
        solve();
        return 0;
}

