#include <cstdlib>
#include <iostream>
#include <new>

using namespace std;

typedef unsigned int Pos;

int* pa;
int* pb;
char buff[110];//JG da ima
Pos curpos;
int N;
int pp;
Pos mask[32 + 1];

/*
legenda
-1 stojnostta ne e izchislena
0 poziciqta e gubeshta
1..N poziciqta e pechelivsha, trqbva da se igrae chisloto ... (1..N)
*/

inline void prepare_masks() {

	for (int i = 1; i <= 32; i++) {
		mask[i] = 0;
		for (int j = 1; j <= i; j++) {
			if (i % j == 0) {
				mask[i] |= 1 << (j - 1);
			}
		}
		mask[i] = ~mask[i];
	}
}

int f_b(Pos pos);


int f_a(Pos pos) {
	//cout << "f_a(" << pos << ")" << endl;
	if (pa[pos] >= 0) return pa[pos];
	for (int i = 2; i <= N; i += 2) {//JG samo chetni za A!
		if ((pos & (1 << (i - 1))) != 0) {
		//if (pos & mask[i] != pos) {//JG
			if (f_b(pos & mask[i]) == 0) {
				return pa[pos] = i;
			}
		}
	}
	return pa[pos] = 0;
}

int f_b(Pos pos) {
	//cout << "f_b(" << pos << ")" << endl;
	if (pb[pos] >= 0) return pb[pos];
	for (int i = 1; i <= N; i += 2) {//JG
		if ((pos & (1 << (i - 1))) != 0) {
		//if (pos & mask[i] != pos) {//JG
			if (f_a(pos & mask[i]) == 0) {
				return pb[pos] = i;
			}
		}
	}
	return pb[pos] = 0;
}

int main() {
	cin >> N;
	if (N > 32) {
		cout << -1 << '\n';
		exit(EXIT_FAILURE);
	}
	pp = 1 << N;
	try {
		pa = new int[pp];
		pb = new int[pp];
	} catch (bad_alloc) {
		cout << -1 << '\n';
		exit(EXIT_FAILURE);
	}
	char tmpc;
	//cin >> tmpc;//JG
	cin.get();
	cin.getline(buff, sizeof buff);
	//cout << "buff=" << buff << '\n';
	curpos = 0;
	char* p = buff + N - 1;
	for (int i = 0; i < N; i++) {
		curpos <<= 1;
		if (*p == 'O')
			curpos |= 1;
		p--;
	}
	//cout << "curpos=" << curpos << '\n';
	for (int i = 0; i < pp; i++)
		pa[i] = -1;
	for (int i = 0; i < pp; i++)
		pb[i] = -1;
	prepare_masks();

	/*
	for (int i = 1; i <= 32; i++) {
		cout << "mask[" << i << "]=" << hex << mask[i] << '\n';
	}
	*/
	pa[0] = 0;
	pb[0] = 0;
	int tmp;
	tmp = f_a(curpos);
	if (tmp == 0) {
		//cout << "tmp is 0!\n";
		for (int i = 2; i <= N; i += 2) {
			if ((curpos & (1 << (i - 1))) != 0) {//JG nuzhda ot mnogo skobi
			//if (curpos & mask[i] != curpos) {//JG
				cout << i << '\n';
				exit(EXIT_SUCCESS);
			}
		}
	}
	cout << tmp << '\n';
}
