/* INCLUDES *****************************************************************/
   //DEBUG #include <iostream>
   //DEBUG #include <cstdlib>

   #include <queue>

   using namespace std;

/* CONSTANTS ****************************************************************/
/* CLASSES ******************************************************************/
   class node
   {
   public:
      node() {}
      node(int _num, int _k): num(_num), k(_k) {}
      node(node const& _n): num(_n.num), k(_n.k) {}
      node& operator = (node const& _n)
      {
         num = _n.num;
         k = _n.k;
         return *this;
      }
      ~node() {}

      bool operator < (node const& _n) const
      {
         return num > _n.num;
      }

      int num;
      int k;
   };

/* GLOBALS ******************************************************************/

   int answ;

   int k;

   priority_queue<node> pq;

/* FUNCTIONS ****************************************************************/
/****************************************************************************/
   extern void srv(int, int, int*);
/****************************************************************************/
   void done()
   {
      //DEBUG cout << "done..." << endl;

      //DEBUG cout << "Calling: srv(3, 0, &answ)..." << flush;
      srv(3, 0, &answ);
      //DEBUG cout << "done." << endl;

      //DEBUG cout << "...done." << endl;

      //DEBUG exit(0);
   }
/****************************************************************************/
   void init()
   {
      //DEBUG cout << "init..." << endl;

      //DEBUG cout << "Calling: srv(0, 0, &k)..." << flush;
      srv(0, 0, &k);
      //DEBUG cout << "done: k == " << k << endl;

      for (int i = 1; i <= k; ++i)
      {
         //DEBUG cout << "Calling: srv(1, " << i << ", &answ)..." << flush;
         srv(1, i, &answ);
         //DEBUG cout << "done: answ == " << answ << endl;

         if(answ >= 0)
         {
            pq.push(node(answ, i));
         }
      }

      //DEBUG cout << "...done." << endl;
   }
/****************************************************************************/
/****************************************************************************/
   void run()
   {
      //DEBUG cout << endl << "run..." << endl;

      while (!pq.empty())
      {
         node n = pq.top();
         pq.pop();

         //DEBUG cout << "Calling: srv(2, " << n.num << ", &answ)..." << flush;
         srv(2, n.num, &answ);
         //DEBUG cout << "done." << endl;

         //DEBUG cout << "Calling: srv(1, " << n.k << ", &answ)..." << flush;
         srv(1, n.k, &answ);
         //DEBUG cout << "done: answ == " << answ << endl;

         if (answ >= 0) pq.push(node(answ, n.k));
      }

      //DEBUG cout << "...done." << endl;
   }
/****************************************************************************/
   int main()
   {
      init();
      run();
      done();

      return 0;
   }
/****************************************************************************/

