#include <stdio.h>
#include <math.h>
#define MAX_N 40000

int  n, m;
int parents[MAX_N];
int times[MAX_N];
int max;
int findroot(int par) {

    while (parents[par] != 0) {
          par = parents[par];
    }

    return par;
}
void read() {
     int src, dest, tmp,i,new_src1,new_src2;
     
     scanf("%d %d", &n, &m);

     for (i =1; i<=m;i++) {
         scanf("%d %d", &src, &dest);
         if (src >dest) {
            tmp = src;
            src = dest;
            dest = tmp;
         }

         new_src1  = findroot(src);
         new_src2  = findroot(dest);

         if (new_src1 == new_src2)
            continue;
            
         if (new_src1 == src)
            if (new_src2 == dest) {
               parents[dest] = new_src1;
               continue;
            }

         if (new_src1 != src)
            if (new_src2 == dest) {
               parents[dest] = new_src1;
               continue;
            }
            
         if (new_src1 == src)
            if (new_src2 != dest) {
                parents[src] = new_src2;
                continue;
            }

         if (new_src2 != dest)
            if (new_src1 != src) {
               if (new_src1<new_src2) {
                  parents[new_src2] = new_src1;
                  parents[dest] = new_src1;
               }
               else{
                 parents[new_src1] = new_src2;
                 parents[src] = new_src2;
               }
               continue;
            }


     }
}

void solve() {
     int i, change, new_rt;
     change = 1;
     
     while (change) {
           change = 0;
           
           for (i = 1; i<=n;i++)
              if (parents[parents[i]] != 0) {
                 new_rt = findroot(i);
                 parents[parents[i]] = new_rt;
                 parents[i] = new_rt;
                 change = 1;
                 break;
              }           
     }
     
     for (i=1; i<=n;i++) {
         if (parents[i] != 0) {
            times[parents[i]]++;
         }
         else {
            times[i]++;
         }

     }

   max = 0;
   for (i = 1; i<=n;i++)
      if (times[i]>max){
         max = times[i];
      }
}

void write() {
     printf("%d\n", max);
}

int main() {
    read();
    solve();
    write();
    return 0;
}
