#include <stdio.h>

#define MAX 2000000666

extern void srv(int,int,int *);

int ar[201];
int min,k;

/* fetch next number from list K, save it in ar[k] */
void fetch(int k)
{
    srv(1,k,&ar[k]);
}

/* send ar[k] */
void send(int k)
{
    srv(2,ar[k],NULL);
}

/* find minimal element from ar[], save its value in min */
int find_min()
{
    int i;

    min=MAX;

    for (i=1;i<=k;i++)
        if (ar[i] < min) min=ar[i];
}

int main()
{
    int i,j,x;
    int finished=0;

    srv(0,0,&k);                    // get K

    for (i=1;i<=k;i++)              // fetch first numbers
        fetch(i);

    while (finished!=k)             // while there are still unfinished lists
    {
         find_min();                // find minimal "unsend" value

         for (i=1;i<=k;i++)         // look for it
             if (ar[i]==min)
             {
                send(i);            // send it
                fetch(i);           // fetch next from list
                if (ar[i]==-1)      // if list i is over,
                {
                    ar[i]=MAX;      // set ar[i] to MAX
                    finished++;     // increase finished lists' count
                }
             }
    }

    srv(3,0,NULL);                  // end
    
    return 0;
}
