program cube;

var
	s				: Array [1 .. 12] of Integer;
	used				: Array [1 .. 6, 1 .. 6, 1 .. 6, 1 .. 6] of Boolean;

procedure Init;
var
	a, b, c, d			: Integer;
begin
	for a := 1 to 6 do
		for b := 1 to 6 do
			for c := 1 to 6 do
				for d := 1 to 6 do
					used[a, b, c, d] := False;
end;

procedure readInput;
var
	i				: Integer;
begin
	for i := 1 to 12 do
		read(s[i]);	
end;

procedure Solve;
var
	a, b, c, d			: Integer;
	found				: Integer;
begin
	found := 0;
	for a := 1 to 9 do
		for b := a + 1 to 10 do
			for c := b + 1 to 11 do
				for d := c + 1 to 12 do
					if (not ((used[s[a], s[b], s[c], s[d]]) or 
					(used[s[b], s[c], s[d], s[a]]) or
					(used[s[c], s[d], s[a], s[b]]) or 
					(used[s[d], s[a], s[b], s[c]]))) then begin
						found := found + 1;
						used[s[a],s[b],s[c],s[d]] := True;
						used[s[b],s[c],s[d],s[a]] := True;
						used[s[c],s[d],s[a],s[b]] := True;
						used[s[d],s[a],s[b],s[c]] := True;
					end;
	found := found - 1;
	writeln(found);
end;

begin
	Init;
	readInput;
	Solve;
end.