#include <climits>
#include <iostream>

using namespace std;

/*
class X {
	public:
	char op;
	int n;
	X* left;
	X* right;
};
*/

int N;
int M;
int a[8];
int cache[3000][8 + 1];
char opcache[3000][8 + 1];
bool inSet[3000];

/*
X* f(int N, bool matr[8]) {

}
*/

const int INF = INT_MAX / 2;

int ff(int N, int k) {
	if (N <= 0 || N >= 3000) {
		//cout << "ERROR: N out of range\n";
		return INF;
	}
	if (cache[N][k] >= 0) return cache[N][k];
	//cout << "ff(N=" << N << ", k=" << k << ")\n";
	int best = ff(N, k + 1);
	int tmp;
	char op = 'N';
	//+: a[k] + ... = N
	if (N - a[k] >= 0) {
		tmp = 1 + ff(N - a[k], k + 1);
		if (tmp < best) {
			best = tmp;
			op = '+';
		}
	}
	//-: a[k] - ... = N
	if (a[k] - N >= 0) {
		tmp = 1 + ff(a[k] - N, k + 1);
		if (tmp < best) {
			best = tmp;
			op = '-';
		}
	}
	//-: ... - a[k] = N
	tmp = 1 + ff(a[k] + N, k + 1);
	if (tmp < best) {
		best = tmp;
		op = '~';
	}
	if (N % a[k] == 0) {
		//*: a[k] * ... = N
		tmp = 1 + ff(N / a[k], k + 1);
		if (tmp < best) {
			best = tmp;
			op = '*';
		}
	}
	///: a[k] / ... = N
	if (a[k] % N == 0) {
		tmp = 1 + ff(a[k] / N, k + 1);
		if (tmp < best) {
			best = tmp;
			op = '/';
		}
	}
	///: ... / a[k] = N
	tmp = 1 + ff(N * a[k], k + 1);
	if (tmp < best) {
		best = tmp;
		op = '\\';
	}
	if (N < 3000) {
		opcache[N][k] = op;
		return cache[N][k] = best;
	} else {
		return best;//JG ami op?
	}
}

void obr(int N, int k) {
	if (N <= 0 || N > 3000) {
		cout << "ERROR\n";
	}
	char op = opcache[N][k];
	if (op == 'N') {
		obr(N, k + 1);
	} else if (op == 'S') {
		cout << N;
	} else if (op == '+') {
		cout << '(';
		cout << a[k];
		cout << '+';
		obr(N - a[k], k + 1);
		cout << ')';
	} else if (op == '-') {
		cout << '(';
		cout << a[k];
		cout << '-';
		obr(a[k] - N, k + 1);
		cout << ')';
	} else if (op == '~') {
		cout << '(';
		obr(a[k] + N, k + 1);
		cout << '-';
		cout << a[k];
		cout << ')';
	} else if (op == '*') {
		cout << '(';
		cout << a[k];
		cout << '*';
		obr(N / a[k], k + 1);
		cout << ')';
	} else if (op == '/') {//JG
		cout << '(';
		cout << a[k];
		cout << '/';
		obr(a[k] / N, k + 1);
		cout << ')';
	} else if (op == '\\') {
		cout << '(';
		obr(N * a[k], k + 1);
		cout << '/';
		cout << a[k];
		cout << ')';
	} else {//JG
		cout << "###";
		cout << "N=" << N << " k=" << k << " op=" << op;
		cout << "###";
	}
}

void init_cache() {
	for (int i = 0; i < 3000; i++) {
		for (int j = 0; j < M; j++) {
			cache[i][j] = -1;
			opcache[i][j] = '?';
		}
		if (inSet[i]) {//JG
			int ind;
			for (int j = 0; j < M; j++)
				if (a[j] == i) {
					ind = j;
					break;
				}
			for (int j = 0; j <= ind; j++) {
				cache[i][j] =  0;
				opcache[i][j] = 'S';
			}
			cache[i][M] = INF;
			opcache[i][M] = 'I';
			/*
			cache[i][M - 1] = 0;
			opcache[i][M - 1] = 'S';
			cache[i][M] = INF;
			opcache[i][M] = 'I';
			*/
			//cache[i][M] = 0;
			//opcache[i][M] = 'S';
		} else {
			cache[i][M] = INF;
			opcache[i][M] = 'I';
		}
		//cache[i][M + 1] = INF;
	}
}

int main() {
	cin >> N;
	M = 0;
	while (cin >> a[M]) {
		M++;
	}
	for (int i = 0; i < 3000; i++)
		inSet[i] = false;
	for (int i = 0; i < M; i++)
		inSet[a[i]] = true;
	/*
	for (int i = 0; i < M; i++) {
		cout <<  "a[" << i << "]=" << a[i] << '\n';
	}
	*/
	//cout << flush;
	//bool matr[8];
	//X* p = f(N, matr);
	init_cache();
	ff(N, 0);
	//cout << "ff(" << N << ", 0)=" << ff(N, 0) << '\n';
	//cout << "kraj\n";
	obr(N, 0);
	cout << '\n';
	/*
	for (int i = 0; i <= N; i++)
		for (int j = 0; j <= M; j++) {
			cout << "opcache[" << i << "][" << j << "]=" << opcache[i][j] << '\n';
		}
	*/
}
