#include <stdio.h>

#define MAX 220

#define ERR -2

#define INF 2000000000

#define UNDEF 0
#define YES 1
#define NO 2

int a,b,c,d;
int t[MAX][MAX];
int v[MAX][MAX];
int ps[MAX][MAX];
int cap[3];
int x[MAX*MAX][10];
int price[MAX*MAX][10];
int nasl[MAX*MAX];

int min(int a,int b) { return (a<b)?a:b; }

void pos(int m[]) {
int i,j,prelt,code,newc;
     if (ps[m[0]][m[1]]==YES) return;
     m[2] = c-m[1]-m[0];
     ps[m[0]][m[1]] = YES;
     code = m[0]*(b+1)+m[1]+1;
     for (i=0;i<=2;i++)
         for (j=0;j<=2;j++)
             if (i!=j) {
                prelt = min(m[i],cap[j]-m[j]);
                if (prelt==0) continue;
                m[i]-=prelt;
                m[j]+=prelt;
                newc = m[0]*(b+1)+m[1]+1;
                price[code][nasl[code]] = prelt;
                x[code][nasl[code]++] =  newc;
                pos(m);
                m[i]+=prelt;
                m[j]-=prelt;
             }

}

void input() {
     scanf("%d%d%d%d",&a,&b,&c,&d);
     cap[0] = a;
     cap[1] = b;
     cap[2] = c;
}

void dijkstra() {
int visited[MAX*MAX];
int dist[MAX*MAX];
int n = (a+1)*(b+1);
int i;
int mind;
int mi,l;
int minp;
     for (i=1;i<=n;i++) {
         visited[i] = 0;
         dist[i] = INF;
     }
     dist[1] = 0;
     while (1) {
           mind = INF;
           mi = -1;
           for (i=1;i<=n;i++)
               if (dist[i]<mind && (!visited[i])) {
                  mind = dist[i];
                  mi = i;
               }
           if (mi==-1) break;
           visited[mi] = 1;
           for (i=0;i<nasl[mi];i++) {
           int tmp = x[mi][i];
               if ((dist[mi]+price[mi][i])<dist[tmp])
                  dist[tmp] = dist[mi]+price[mi][i];
           }
     }
     minp = mind = INF;
     for (l=1;l<=n;l++) {
     int i,j,k;
               if (dist[l]==INF) continue;
               i = l/(b+1);
               if (l%(b+1)==0) i--;
               j = l%(b+1)-1;
               if (j==-1) j = b;
               k = c-i-j;
               if (i<=d && ((d-i)<=mind)) {
                  if ((d-i)<mind) {
                      mind = d-i;
                      minp = dist[l];
                  } else
                  if (dist[l]<minp) minp = dist[l];
               }
               if (j<=d && ((d-j)<=mind)) {
                  if ((d-j)<mind) {
                      mind = d-j;
                      minp = dist[l];
                  } else
                  if (dist[l]<minp) minp = dist[l];
               }
               if (k<=d && ((d-k)<=mind)) {
                  if ((d-k)<mind) {
                      mind = d-k;
                      minp = dist[l];
                  } else
                  if (dist[l]<minp) minp = dist[l];
               }
     
     
     }
     printf("%d %d\n",minp,d-mind);
}

int main () {
int param[3];
int i,j,k;
int mind = INF;
int minp = INF;
    input();
    for (i=0;i<MAX;i++)
        for (j=0;j<MAX;j++)
            t[i][j] = -1;
    t[0][0] = 0;
    param[0] = param[1] = param[2] = 0;
    for (i=0;i<MAX;i++)
        for(j=0;j<MAX;j++)
                          ps[i][j] = UNDEF;
    pos(param);
    dijkstra();
    return 0;

}


/*int solve(int m[]) {
int best;
int i,j;
int prelt,y,code;
int m2[3];
     if (v[m[0]][m[1]]) return ERR;
     if (t[m[0]][m[1]]!=-1) return t[m[0]][m[1]];
     m[2] = c-m[0]-m[1];
     best = INF;
     v[m[0]][m[1]] = 1;
     code = m[0]*(b+1)+m[1]+1;
     for (i=0;i<nasl[code];i++) {
         y = x[code][i];
         m2[0] = y/(b+1);
         if (y%(b+1)==0) m2[0]--;
         
         m2[1] = y%(b+1)-1;
         if (m2[1]==-1) m2[1] = b;
         y = solve(m2);
         if (y==ERR)  continue;
         y += price[code][i];
         if (y<best) best = y;
         
     }
     v[m[0]][m[1]] = 0;
     if (best==INF) return ERR; else return t[m[0]][m[1]] = best;
}



int main () {
int param[3];
int i,j,k;
int mind = INF;
int minp = INF;
    input();
    for (i=0;i<MAX;i++)
        for (j=0;j<MAX;j++)
            t[i][j] = -1;
    t[0][0] = 0;
    param[0] = param[1] = param[2] = 0;
    for (i=0;i<MAX;i++)
        for(j=0;j<MAX;j++)
                          ps[i][j] = UNDEF;
    pos(param);
    dijkstra();
    for (i=0;i<=a;i++)
        for (j=0;j<=b;j++)
            if (ps[i][j]==YES) {
               param[0] = i;
               param[1] = j;
               solve(param);
               k = c-i-j;
               if (t[i][j]<0) continue;
               if (i<=d && ((d-i)<=mind)) {
                  if ((d-i)<mind) {
                      mind = d-i;
                      minp = t[i][j];
                  } else
                  if (t[i][j]<minp) minp = t[i][j];
               }
               if (j<=d && ((d-j)<=mind)) {
                  if ((d-j)<mind) {
                      mind = d-j;
                      minp = t[i][j];
                  } else
                  if (t[i][j]<minp) minp = t[i][j];
               }
               if (k<=d && ((d-k)<=mind)) {
                  if ((d-k)<mind) {
                      mind = d-k;
                      minp = t[i][j];
                  } else
                  if (t[i][j]<minp) minp = t[i][j];
               }
               
            }
    printf("%d %d\n",minp,d-mind);
    return 0;
}
  */
