#include <stdio.h>

#define MAX_N 202

typedef short unsigned int suint;
suint dyn_data[MAX_N][MAX_N][MAX_N];
suint visited[MAX_N][MAX_N][MAX_N];

suint a, b, c,d;

void read() {
     scanf("%d %d %d %d", &a, &b, &c, &d);
}

suint min2(suint a1, suint a2) {
    if (a1 == 255)
       return a2;

    if (a2 == 255)
       return a1;
       
    if (a1<a2)
       return a1;
    else
      return a2;
}

suint min(suint a1, suint a2, suint a3, suint a4, suint a5, suint a6) {
    return min2(min2(min2(min2(min2(a1,a2),a3),a4),a5),a6);
}

suint preliv(suint src_fill, suint dest_fill, suint dest_cap) {
    if (src_fill +dest_fill <= dest_cap) {
       return src_fill;
    }
    else {
       return dest_cap -dest_fill;
    }

}


suint solve(suint in_a, suint in_b, suint in_c) {
     suint min_ac, min_ca, min_ab, min_ba, min_bc, min_cb;
     suint pr;

     min_ac = 255;
     min_ca = 255;
     min_ab = 255;
     min_ba = 255;
     min_bc = 255;
     min_cb = 255;

     if (visited[in_a][in_b][in_c])
        return 255;
     
     if ((in_a == d)||(in_b == d)||(in_c == d))
        return 0;
        
     if (dyn_data[in_a][in_b][in_c] != 0)
        return dyn_data[in_a][in_b][in_c];

     visited[in_a][in_b][in_c] = 1;
     if (in_a != 0) {
            pr = preliv(in_a,in_c,c);
            min_ac = solve(in_a - pr, in_b, in_c+pr) +pr;
      }

      if (in_c != 0) {
            pr = preliv(in_c,in_a,a);
            min_ca = solve(in_a + pr, in_b, in_c- pr) + pr;
      }

      if (in_a != 0) {
      pr = preliv(in_a, in_b,b);
      min_ab = solve(in_a - pr, in_b + pr, in_c) + pr;
      }

      if (in_b != 0) {
      pr = preliv(in_b, in_a, a);
      min_ba = solve(in_a + pr, in_b - pr, in_c) + pr;
      }

      if (in_b != 0) {
      pr = preliv(in_b, in_c, c);
      min_bc = solve(in_a, in_b-pr, in_c+pr) + pr;
      }

      if (in_c != 0) {
            pr = preliv(in_c, in_b, b);
            min_cb = solve(in_a, in_b+pr, in_c-pr) + pr;
      }
      
      dyn_data[in_a][in_b][in_c] =  min(min_ac, min_ca, min_ab, min_ba, min_bc, min_cb);

      visited[in_a][in_b][in_c] = 0;
      
      return dyn_data[in_a][in_b][in_c];
}

void write() {
     printf("%d %d\n", dyn_data[0][0][c], d);
}

int max2( suint a1, suint a2) {
    if (a1>a2)
       return a1;
    else
       return a2;
}

int canfill(suint num) {
    if (( (a % num) == 0) ||
        ( (b % num) == 0) ||
        ( (c % num) == 0) ||
        ( (abs(a-b) % num) == 0)||
        ( (abs(a-c) % num) == 0)||
        ( (abs(b-c) % num) == 0))
           return 1;

    return 0;
}
void findclosest() {
     suint _max, _min,l,h;
     _max = max2(max2(a,b),c);
     _min = min2(min2(a,b),c);

     l = d;
     h = d;
     while ( (!canfill(l)) &&( !canfill(h))) {
           int one =0;
           if (l >0) {
             one =1;
             l--;
           }

           if (h <=_max) {
              one = 1;
              h++;
           }

           if (!one) {
             d = 0;
             printf("0 0");
             exit(0);
           }
     }

     if (canfill(l))
        d = l;
     else
        d = h;
}

int main() {
    read();
    findclosest();
    solve(0,0,c);
    write();
    return 0;
}
