#include <stdio.h>
#include <string.h>
#define maxn 201 // trq e 201
#define inf 400000000
#define min(a,b) ((a) < (b) ? (a) : (b))

  long A[maxn][maxn][maxn];
  long a,b,c,d;
  long tmp;

  void Init (long q)
    {
      long i,j,k;
      for (i = 0; i <= a; i++)
	for (j = 0; j <= b; j++)
	  for (k = 0; k <= c; k++)
	    A[i][j][k] = -1;
      for (i = 0; i <= a; i++)
	for (j = 0; j <= b; j++)
	  A[i][j][q] = 0;
      for (i = 0; i <= a; i++)
	for (j = 0; j <= c; j++)
	  A[i][q][j] = 0;
      for (i = 0; i <= b; i++)
	for (j = 0; j <= c; j++)
	  A[q][i][j] = 0;
    }

  long Solve (int aa, int bb, int cc, int dd)
    {
      long how;
      if (A[aa][bb][cc] != -1)
	return A[aa][bb][cc];
      A[aa][bb][cc] = inf;
      how = min(aa,b - bb);
      if (how)
	{
	  tmp = Solve (aa - how, bb + how, cc, dd) + how;
	  if (tmp < A[aa][bb][cc])
	    A[aa][bb][cc] = tmp;
	}
      how = min(aa,c - cc);
      if (how)
	{
	  tmp = Solve (aa - how, bb, cc + how, dd) + how;
	  if (tmp < A[aa][bb][cc])
	    A[aa][bb][cc] = tmp;
	}
      how = min(bb,a - aa);
      if (how)
	{
	  tmp = Solve (aa + how, bb - how, cc, dd) + how;
	  if (tmp < A[aa][bb][cc])
	    A[aa][bb][cc] = tmp;
	}
      how = min(bb,c - cc);
      if (how)
	{
	  tmp = Solve (aa, bb - how, cc + how, dd) + how;
	  if (tmp < A[aa][bb][cc])
	    A[aa][bb][cc] = tmp;
	}
      how = min(cc, a - aa);
      if (how)
	{
	  tmp = Solve (aa + how, bb, cc - how, dd) + how;
	  if (tmp < A[aa][bb][cc])
	    A[aa][bb][cc] = tmp;
	}
      how = min(cc, b - bb);
      if (how)
	{
	  tmp = Solve (aa, bb + how, cc - how, dd) + how;
	  if (tmp < A[aa][bb][cc])
	    A[aa][bb][cc] = tmp;
	}
      return A[aa][bb][cc];
    }

  int main ()
    {
      
      scanf ("%ld %ld %ld %ld",&a,&b,&c,&d);
if (a >= c && b >= c && d == c)
	printf ("0 %ld\n",d);
	  else
	    if (a >= c && b >= c && d > c)
	      printf ("0 %ld\n",c);
		else
   if (a >= c &&  b >= c && d < c)
  printf ("0 0\n");
else
      for (long i = d; i >= 0; i--)
	{
	  Init (i);
	  tmp = Solve (0,0,c,i);
	  if (tmp < inf)
	    {
	      printf ("%ld %ld\n",tmp,i);
	      break;
	    }
	}
      return 0;
    }