Const
  DataMax = 10;
  KMax = 6;
  NMax = 12;
Type
  TNdx = Integer;
  TData = LongInt;
  TK = 0..6;
  TN = 0..12;
  TStir = Array[TN, TK] Of TData;

Var
  Stir : TStir;


    Function Stirling(I, J :TNdx) : TData;
      Begin
        If Stir[I, J] = -1 Then
         Begin
           If ( I = 0) And (J = 0) Then
             Stir[I, J]:=1
           Else If ((I = 0) And (J > 0))
                    Or ( (I > 0) And (J = 0) )  Then
             Stir[I, J]:=0
           Else
             Stir[I, J]:=Stirling(I-1, J-1) + J*Stirling(I-1, J);
         End;
        Stirling:=Stir[I, J];
      End;

    Procedure InitStir;
      Var
        I, J: TNdx;
      Begin
        For I:=0 To NMax Do
          For J:=0 To KMax Do
            Stir[I, J]:=-1;
      End;

Begin
  InitStir;
  WriteLn(Stirling(12, 5));
End.