#include <stdio.h>


const long SUX = 5000000;//
const long N = 13;
const long M = 6;
const long n = 12;

long a[N];
long r[N]; // result
long i,j;

long fact[N];

long used[7];

char res[SUX];
long number;
long result;

void Input(){

	for(i=1; i<=12; i++){
		scanf("%d", &a[i]);
		used[a[i]]++;
	}

}


void RotateLeft(long a[N]){//4 left rotationst
	// 1  2  3  4  5  6  7  8  9 10 11 12
	// 2  3  4  1  9 10 11 12  8  7  6  5
	r[1] = a[2];    r[2] = a[3];    r[3] = a[4];    r[4] = a[1];
	r[5] = a[9];    r[6] = a[10];   r[7] = a[11];   r[8] = a[12];
	r[9] = a[8];    r[10] = a[7];   r[11] = a[6];   r[12] = a[5];
}


void RotateUp(long a[N]){//4 up rotations
	// 1  2  3  4  5  6  7  8  9 10 11 12
	// 6  7  8  5  1  2  3  4  12 9 10 11
	// 6  5  8  7  ----------  ----------
	r[1] = a[6];    r[2] = a[5];    r[3] = a[8];    r[4] = a[7];
	r[5] = a[1];    r[6] = a[2];    r[7] = a[3];    r[8] = a[4];
	r[9] = a[12];   r[10] = a[9];   r[11] = a[10];  r[12] = a[11];
}


void Print(){
	for(int i=1; i<N; i++)
		printf("%d ", a[i]);
	printf("\n");
}


void swap(long &a, long &b){
	int c = a;
	a = b;
	b = c;
}


long CodePerm(){
	long l;
	long num = 0;

	for(i=1; i<n; i++){
		l = 0;
		for(j=i+1; j<=n; j++)
			if(a[j] < a[i])
				l++;
		num += l*fact[n-i];
	}
	return num;
}

void Next_Perm(){

		i = n;

		while(a[i-1] >= a[i] && i > 1){i--;}

		swap(a[i-1], a[i]);

		for(j=1; j<=(N-i)/2; j++)
			swap(a[N-j], a[i+j]);

}

void Solve(){
	number = fact[N-1];

	res[0] = 1;
	result = 1;

	for(i=1; i<=6; i++)
		if(used[i])
			number /= fact[used[i]];

	for(long k=1; k<=number; k++){
		int match = 0;

		for(int i=1; i<=4 && !match; i++){

			RotateUp(a);
			for(long p=1; p<N; p++) a[p] = r[p];

			for(long j=1; j<=4; j++){
				RotateLeft(a);
				for(long p=1; p<N; p++) a[p] = r[p];

	//                      Print();
//                      res[
				int tmp = CodePerm();
//                              printf("%ld  ", tmp);
				if(res[tmp]){
					match = 1;
					break;
				}
				else
					res[tmp] = 1;
			}

		}
		if(!match)
			result++;
		Next_Perm();
	}

}

int main(){
	fact[1] = 1;
	for(i=2; i<N; i++)      fact[i] = i*fact[i-1];
	for(i=0; i<SUX; i++) res[i] = 0;
	Input();
	Solve();
	printf("%ld\n", result);

	return 0;
}
