#include <stdio.h>
#include <string.h>
#include <stdlib.h>

const int N = 3000;

struct Type{
	int  a,b;
	char oper;
	int level;
};

Type data[N];
int used[N];
int res[N];
int count=0;
int a[8];

int compare(const void *x, const void *y)
{
 if ( *(int *)x > *(int *)y ) return 1;
 else return -1;
}

void Output(int n)
{
	if (data[n].b!=0)
	{
		printf("(");
		Output(data[n].a);
		printf("%c",data[n].oper);
		Output(data[n].b);
		printf(")");
		return;
	}
	printf("%d",n);
}

int main()
{
	int n,m=0;
	int i,j,p,q;
	int level=0;

	memset(data,0,sizeof(data));
	scanf("%d",&n);
	int tmp;
	while (scanf("%d",&tmp) != EOF){
		a[m] = tmp;
		m++;
	}

	for (i=0;i<m;i++)
	{
		data[a[i]].a=a[i];
		data[a[i]].b=0;
		data[a[i]].oper='+';
		used[a[i]] = 1<<i;

		res[count++]=a[i];
	}

	while (used[n]==0){

		for (p=0;p<count;p++)
			for (q=p+1;q<count;q++)
			{
				i=res[p];
				j=res[q];

				if ( used[i] && used[j] && (used[i] & used[j])==0 && data[i].level<=level && data[j].level<=level){
					if (j-i>0 && used[j-i]==0){
						used[j-i] = used[i] | used[j];
						data[j-i].oper='-';
						data[j-i].a=j;data[j-i].b=i;
						data[j-i].level=level+1;
						res[count++]=j-i;
					}
					if (i+j<N && used[i+j]==0){
						used[i+j] =used[i] | used[j];
						data[i+j].oper='+';
						data[i+j].a=i;data[i+j].b=j;
						data[i+j].level=level+1;
						res[count++]=i+j;
					}
					if (i*j<N && used[i*j] ==0){
						used[i*j] = used[i] | used[j];
						data[i*j].oper='*';
						data[i*j].a=i;data[i*j].b=j;
						data[i*j].level=level+1;
						res[count++]=i*j;
					}
					if (j%i==0 && used[j/i]==0){
						used[j/i] = used[i] | used[j];
						data[j/i].oper='/';
						data[j/i].a=j;data[j/i].b=i;
						data[j/i].level=level+1;
						res[count++]=j/i;
					}
				}
			}
		level++;
		qsort(res,count,sizeof(int),compare);
	}
	Output(n);
	printf("\n");
	return 0;
}
