#include <stdio.h>

const int UNKNOWN = 9999;
const int N = 211;

int res[N];
int i,j,n;
int a,b,c,d;
int A,B,C;

int min_a, min_b, min_c;

inline void swap(int &x1, int &x2){
	int x3 = x1;
	x1 = x2;
	x2 = x3;
}

int min(int a, int b){
	return a < b ? a : b;
}

void Sol(int a, int b, int c){

	if(res[a] != UNKNOWN && a != 0)
		if(res[b] != UNKNOWN && b != 0)
			if(res[c] != UNKNOWN && c != 0)
				return;

	// c -> a
	int tmp = min(c,A-a);
	if(tmp){
		min_a = min(res[a+tmp], res[c] + tmp);
		min_c = min(res[c-tmp], res[c] + tmp);

		if(res[a+tmp] != min_a || res[c-tmp] != min_c){
			res[a+tmp] = min_a;
			res[c-tmp] = min_c;
			Sol(a+tmp, b, c-tmp);
		}
	}
	// c -> b
	tmp = min(c,B-b);
	if(tmp){
		min_b = min(res[b+tmp], res[c] + tmp);
		min_c = min(res[c-tmp], res[c] + tmp);
		if(res[b+tmp] != min_b || res[c-tmp] != min_c){
			res[c-tmp] = min_c;
			res[b+tmp] = min_b;
			Sol(a, b+tmp, c-tmp);
		}
	}
	// b -> a
	tmp = min(b,A-a);
	if(tmp){
		min_a = min(res[a+tmp], res[b] + tmp);
		min_b = min(res[b-tmp], res[b] + tmp);
		if(res[a+tmp] != min_a || res[b-tmp] != min_b){
			res[a+tmp] = min_a;
			res[b-tmp] = min_b;
			Sol(a+tmp, b-tmp, c);
		}
	}
	// b -> c
	tmp = min(b,C-c);
	if(tmp){
		min_c = min(res[c+tmp], res[b] + tmp);
		min_b = min(res[b-tmp], res[b] + tmp);
		if(res[c+tmp] != min_c || res[b-tmp] != min_b){
			res[b-tmp] = min_b;
			res[c+tmp] = min_c;
			Sol(a, b-tmp, c+tmp);
		}
	}
	// a -> b
	tmp = min(a,B-b);
	if(tmp){
		min_b = min(res[b+tmp], res[a] + tmp);
		min_a = min(res[a-tmp], res[a] + tmp);
		if(res[b+tmp] != min_b || res[a-tmp] != min_a){
			res[a-tmp] = min_a;
			res[b+tmp] = min_b;
			Sol(a-tmp, b+tmp, c);
		}
	}
	// a -> c
	tmp = min(a,C-c);
	if(tmp){
		min_c = min(res[c+tmp], res[a] + tmp);
		min_a = min(res[a-tmp], res[a] + tmp);
		if(res[a-tmp] != min_a || res[c+tmp] != min_c){
			res[a-tmp] = min_a;
			res[c+tmp] = min_c;
			Sol(a-tmp, b, c+tmp);
		}
	}
	return ;
}

int main(){
	scanf("%d%d%d%d", &A, &B, &C, &d);

	for(i=1; i<N; i++)
		res[i] = UNKNOWN;
	res[C] = 0;

	Sol(0,0,C);
	while(res[d] == UNKNOWN){
		d--;
	}
	printf("%d %d\n", res[d], d);

	return 0;
}