#include <stdio.h>
#include <stdlib.h>

#define nDEBUG

#ifdef DEBUG
   #define MAX_ENTRIES 1000
   #define MAX_PEOPLE  1000
   #define INPUT f
#else
   #define MAX_ENTRIES 1000000
   #define MAX_PEOPLE  1000000
   #define INPUT stdin
#endif

int c=0;
int n=0;
int result=0;

typedef struct student
	{
        int a,b;
	} student;

#ifdef DEBUG
     student ar[MAX_ENTRIES];
     int     ax[MAX_ENTRIES];
     FILE *f;
#else
     student *ar;
     int     *ax;
#endif    

int cmp(const void *x, const void *y)
{
	if ( ((student *)x)->a > ((student *)y)->a )   return  1;
                                                   return -1;
}

int cmp2(const void *x, const void *y)
{
    if ( *(int *)x > *(int *)y ) return  1;
                                 return -1;
}

void input()
{
#ifndef DEBUG
    ar=(student *)malloc(MAX_ENTRIES * sizeof(student));
    ax=(int *)malloc(MAX_ENTRIES * sizeof(int));
#else
    f=fopen("club.in","rt");
#endif


    fscanf(INPUT,"%d",&n);
    while (fscanf(INPUT,"%d %d",&ar[c].a,&ar[c].b)>0)
    {
          ax[c]=ar[c].a+ar[c].b;
          c++;
    }
}

void output()
{
#ifndef DEBUG
    free(ar);
    free(ax);
    fprintf(stdout,"%d\n",result);
#else
    fclose(f);
    fprintf(stdout,"\nWARNING: DEBUG VERSION!! Result: %d\n",result);
#endif    
}

void solve()
{
    int last=0;
    int i,j,ppl=0;

    qsort(ar,c,sizeof(student),cmp);
    qsort(ax,c,sizeof(int),cmp2);

    for (i=0;i<c;i++)
    {
        while (ax[last]<ar[i].a)
        {
            ppl--;
            last++;
        }

        if (ax[last]==ar[i].a)
        {
            while (ax[last]==ar[i].a)
            {
                ppl--;
                last++;
            }
            
            if (ppl>=n) result++;
        }

        ppl++;        // increase peoples's count
    }
}

int main()
{
    input();
    solve();
    output();

    return 0;
}