#include <stdio.h>

#define MAXN            210

int adj[MAXN][MAXN];
int count;
int visited[MAXN];
int cf[MAXN];
int groups[MAXN][MAXN];
int gc;

void read_data() {
     int i, j;

     scanf("%d\n", &count);
     for (i = 1; i < count; i++) {
         for (j = 0; j < i; j++) {
             scanf("%c", &adj[i][j]);
             adj[i][j] -= '0';
         }

         scanf("\n");
     }
}

void solve() {
     int i, j;
     int next;
     int tmp;

     for (i = count - 1; i >= 0; i--) {
         if (visited[i]) continue;

         visited[i] = 1;
         
         tmp = -2;
         groups[gc][0] = 1;
         groups[gc][1] = i + 1;
         for (j = 0; j < i; j++) {
             cf[j] = adj[i][j];
             if (cf[j]) tmp = j;
         }
         
         next = tmp;
         
         while (next >= 0) {
               visited[next] = 1;
               groups[gc][++groups[gc][0]] = next + 1;
               tmp = -2;
               for (j = 0; j < next; j++) {
                   cf[j] = cf[j] & adj[next][j];
                   if (cf[j]) tmp = j;
               }
               next = tmp;
         }
         gc++;
     }

     printf("%d\n", gc);
     for (i = 0; i < gc; i++) {
         printf("%d\n", groups[i][0]);
         printf("%d", groups[i][1]);
         for (j = 2; j <= groups[i][0]; j++)
             printf(" %d", groups[i][j]);

         printf("\n");
     }
}

int main() {
    read_data();
    solve();
    return 0;
}

