{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
const  infile = '';
      outfile = '';
         maxn = 200;
         maxt = 25;

type      arr = array [1..MAXN] of integer;
          grr = array [1..maxn,1..maxn] of BOOLEAN;
          urr = array [1..MAXN] of boolean;
          parr = ^arr;
          parrarr = array [0..maxn] of parr;

var   G : grr;
      n : integer;
      c : arr;
      m : integer;
      bestc : arr;
      bestm : integer;
      clk0  : longint absolute 0:$046C;
      clk   : longint;
     { mkx   : longint;}
      d     : arr;
      save  : parrarr;

Procedure InX;
 var t : text;
     s : string;
     j,i : integer;
 begin
 for i := 0 to maxn do new(save[i]);
 fillchar(g,sizeof(g),0);
 assign(t, infile);
 reset(t);
 readln(t,n);
 for j := 2 to n do
  begin
  readln(t, s);
  for i := 1 to j - 1 do if s[i]='1' then
   begin
   g[i,j] := TRUE;
   g[j,i] := TRUE;
   end;
  end;
 for i := 1 to n do g[i,i] := TRUE;
 close(t);
 end;

procedure check;
 begin
 if m < bestm then
  begin
  {YEAH!}
  bestm := m;
  bestc := c;
  end;
 end;

function isallfriend(node,group : integer):boolean;
 var i : integer;
 begin
 isallfriend := FALSE;
 for i := 1 to n do if (c[i]=group) and (not g[i,node]) then exit;
 isallfriend := TRUE;
 end;

Procedure fill(root : integer);
 var i,j,left,xn : integer;
 begin
 m := 0;
 fillchar(c,n*sizeof(integer),0);
 left := n;
 xn := root;
 repeat
 inc(m);
 c[xn] := m;
 dec(left);
 for i := 1 to n do if g[i,xn] and (c[i]=0) and isallfriend(i,m) then
  begin
  c[i] := m;
  dec(left);
  end;
 if left > 0 then while c[xn] <> 0 do xn := xn mod n + 1;
 until left = 0;
 Check;
 end;

procedure randfill(root : integer);
 var i,j,left,xn,ld : integer;
     done        : urr;
     x           : word;
 begin
 if clk0-clk > 30 then
  exit;
 m := 0;
 fillchar(c,n*sizeof(integer),0);
 left := n;
 xn := root;
 x := 0;
 repeat
 inc(m);
 c[xn] := m;
 dec(left);
 ld := left;
 fillchar(done,sizeof(done),0);
 if ld>0 then
 repeat
 repeat
 i := random(n)+1;
 inc(x);
 if x > 6553 then exit;
 until (not done[i]) and (c[i]=0);
 dec(ld);
 done[i] := TRUE;
 if g[i,xn] and isallfriend(i,m) then
  begin
  c[i] := m;
  dec(left);
  end;
 until ld = 0;
 if left > 0 then while c[xn] <> 0 do xn := xn mod n + 1;
 until left = 0;
 Check;
 end;


procedure Bt(node,lnode ,col,left,ccg : integer);
 var i : integer;
     w : boolean;
 begin
 if clk0-clk > maxt then exit;
 if col >= bestm then exit;
 if left = 0 then
  begin
  bestm := col;
  bestc := c;
  exit;
  end;
 c[node] := col;
 if ccg = 1 then fillchar(d,sizeof(d),0);
 for i := 1 to n do if g[node,i] then inc(d[i]);
 w := FALSE;
 for i := lnode+1 to n do if (c[i]=0) and (d[i]=ccg) then
  begin
  bt(i,node,col,left-1,ccg+1);
  w := TRUE;
  end;
 if not w then
  begin
  save[left]^ := d;
  for i := 1 to n do if c[i]=0 then bt(i,0,col+1,left-1,1);
  d := save[left]^;
  end;
 for i := 1 to n do if g[node,i] then dec(d[i]);
 c[node] := 0;
 end;

Procedure DoWork;
 var i : integer;
 begin
 bestm := n;
 for i := 1 to n do bestc[i] := i;
 for i := 1 to n do fill(i);
{ writeln('fill found solution with ',bestm,' groups.');}
 for i := 1 to n do randfill(i);
{ writeln('randfill:  solution with ',bestm,' groups.');}
{ if n < 30 then
  begin}
  fillchar(c,sizeof(c),0);
  Bt(1,0,1,n-1,1);
{  writeln('exhaust:   solution with ',bestm,' groups found.');}
{  end;}
 end;

Procedure OutX;
 var t : text;
     i,j,cnt : integer;
 begin
 assign(t, outfile);
 rewrite(t);
 m := bestm;
 c := bestc;
 writeln(t,m);
 for j := 1 to m do
  begin
  cnt := 0;
  for i := 1 to n do if c[i]=j then inc(cnt);
  writeln(t, cnt);
  for i := 1 to n do if c[i]=j then write(t,i,' ');
  writeln(t);
  end;
 close  (t);
 end;

BEGIN
mark(heapptr);
randseed := 666;
{mkx := clk0;}
InX;
clk := clk0;
DoWork;
OuTX;
{mkx := clk0-mkx;
writeln('working time: ',mkx/18.2:1:2,' seconds.');}
release(heapptr);
END.