#include <stdio.h>

#define MAX 2000

typedef struct node
	{
		int l,r;
	} node;


node tree[MAX+1];

int root;
int s[MAX];
int ar[MAX];
int n,m;

int find_max()
{
	int i,max=0;

	for (i=1;i<=n;i++)
	{
		if (s[i]>s[max]) max=i;else
		if (s[i]==s[max] && rand()%3==0) max=i;
	}

	return max;
}

void add(int x)
{
	int p=root;

	while (1)
	{
		if (x>p)
			if (tree[p].r==0)
			{
				tree[p].r=x;
				break;
			}
			else p=tree[p].r;
		else
			if (tree[p].l==0)
			{
				tree[p].l=x;
				break;
			}
			else p=tree[p].l;
	}
}

void build_tree(int r)
{
	int x;

	root=r;
	s[root]=0;

	while (s[x=find_max()])
	{
		add(x);
		s[x]=0;
	}
}

void show_tree()
{
	int i;

	printf("%d\n", root);

	for (i=1;i<=n;i++)
	{
		if (tree[i].l) printf("%d %d<\n", tree[i].l, i);
		if (tree[i].r) printf("%d %d>\n", tree[i].r, i);
	}

}

void prepare_tree()
{
	memset(tree,0,sizeof(tree));
	memcpy(&s[1],&ar[1],sizeof(int)*n);
}

int sum=0;

int cost()
{

}

void input()
{
	int i;

	scanf("%d %d", &n, &m);

	for (i=1;i<=n;i++)
		scanf("%d", &ar[i]);

	srand(666);
}

void output()
{
	show_tree();
}

void solve()
{
	prepare_tree();

	build_tree(find_max());
}

int main()
{
	input();
	solve();
	output();

	return 0;
}