// Copyright (c) 2003 Jordan Gordeev. All rights reserved
#include <stdlib.h>
#include <iostream.h>
#include <set.h>

int N;
//bool z[300 + 1];
int h[300 + 1];
//int r[300 + 1][150 + 1];
//int v[300 + 1];
//int nez;
set<int> vyz[300 + 1];
int broj[300 + 1];
int UPD[300 + 1];//JG inicializaciq s nuli
int next_upd;
int max_h[300 + 1];

void printans() {//JG ne razpoznava h[i] = -1
	int hind;
	int hmax = -1;
	for (int i = 0; i <= N; i++) {
		if (h[i] > hmax) {
			hmax = h[i];
			hind = i;
		}
	}
	cout << "-1 " << hind << ' ' << hmax << '\n';
}

inline set<int> intersect(const set<int>& a, const set<int>& b) {
	set<int> result;
	for (set<int>::iterator i = a.begin(); i != a.end(); i++) {
		if (b.count(*i)) result.insert(*i);//JG
	}
	return result;
}

inline int ask(int i) {
	cout << i << '\n';//JG endl?
	cout.flush();
	int tmp;
	cin >> tmp;
	return tmp;
}

void fill1(int x, set<int> s, int upd) {
	if (UPD[x] == upd) return;
	UPD[x] = upd;
	vyz[x] = intersect(s, vyz[x]);
	broj[x] = vyz[x].size();
	//JG
	if (broj[x] == 1) {
		h[x] = *(vyz[x].begin());//JG
	}
	max_h[x] = *(vyz[x].rbegin());//JG
	set<int> tmp;
	for (set<int>::iterator i = s.begin(); i != s.end(); i++) {
		int n1 = *i - 1;
		if (0 <= n1 && n1 <= N / 2) {
			tmp.insert(n1);
		}
		int n2 = *i + 1;
		if (0 <= n2 && n2 <= N / 2) {
			tmp.insert(n2);
		}
	}
	if (0 <= x - 1 && x - 1 <= N) {
		fill1(x - 1, tmp, upd);
	}
	if (0 <= x + 1 && x + 1 <= N) {
		fill1(x + 1, tmp, upd);
	}
}

inline bool ready() {//JG inline?
	int maxdh = -1;
	for (int i = 0; i <= N; i++) {
		if (h[i] >= 0) {
			if (h[i] > maxdh) {
				maxdh = h[i];
			}
		}
	}
	for (int i = 0; i <= N; i++) {
		if (h[i] < 0) {
			if (max_h[i] > maxdh) return false;
		}
	}
	return true;
}

inline bool better(int i, int j) {
	//return broj[i] > broj[j];
	if (max_h[i] != max_h[j]) return max_h[i] > max_h[j];
	else return broj[i] > broj[j];
}

void print_all() {
	for (int i = 0; i <= N; i++) {
		//cout << i << ':';
		cout << i << '(' << h[i] << ", " << max_h[i] << ')' << ':';
		for (set<int>::iterator it = vyz[i].begin(); it != vyz[i].end(); it++) {
			cout << ' ' << *it;
		}
		cout << '\n';
	}
}

int main() {
	next_upd = 1;
	for (int i = 0; i <= 300; i++) {
		UPD[i] = 0;
		h[i] = -1;
	}
	cin >> N;
	/*
	for (int i = 0; i <= N; i++) z[i] = false;
	z[0] = true;
	h[0] = 0;
	z[1] = true;
	h[1] = true;
	z[N] = true;
	h[N] = 0;
	z[N - 1] = true;
	h[N - 1] = 1;
	nez = N + 1 - 4;
	for (int i = 2; i < N - 1; i++) {
		for (int j = 0; j <= N / 2; j++) {
			r[i][j] = true;
		}
	}
	for (int j = 0; j <= N / 2; j++) {
		r[2][j] = false;
		r[N - 2][j] = false;
	}
	r[2][0] = true;
	r[2][2] = true;
	r[N - 2][0] = true;
	r[N - 2][2] = true;
	for ( ; ; ) {
		if (nez == 0) {
			printans();
		}
	}
	*/
	set<int> all;
	for (int i = 0; i <= N / 2; i++) {
		all.insert(i);
	}
	for (int i = 0; i <= N; i++) {
		vyz[i] = all;
		broj[i] = vyz[i].size();
	}
	set<int> tmp;
	tmp.insert(0);
	fill1(0, tmp, next_upd++);
	fill1(N, tmp, next_upd++);

	//print_all();

	for ( ; ; ) {
		//print_all();
		/*
		int maxind;
		int maxbroj = 0;
		for (int i = 0; i <= N; i++) {
			if (broj[i] > maxbroj) {
				maxbroj = broj[i];
				maxind = i;
			}
		}
		if (maxbroj == 1) {
			printans();
			exit(EXIT_SUCCESS);
		}
		*/
		if (ready()) {
			printans();
			exit(EXIT_SUCCESS);
		}
		int bestind = 0;
		for (int i = 1; i <= N; i++) {
			if (better(i, bestind)) {
				bestind = i;
			}
		}
		int H = ask(bestind);
		//h[bestind] = H;
		set<int> kk;
		kk.insert(H);
		fill1(bestind, kk, next_upd++);
	}
}