/* INCLUDES *****************************************************************/
   #include <iostream.h>
   #include <stdlib.h>
   #include <values.h>

/* CONSTANTS ****************************************************************/
   int const MAX = 2002;

/* CLASSES ******************************************************************/
/* GLOBALS ******************************************************************/

   int n;
   int m;

   int s[MAX];

   int ts[MAX][MAX];

/* FUNCTIONS ****************************************************************/
/****************************************************************************/
   void done()
   {
      exit(0);
   }
/****************************************************************************/
   void init()
   {
      cin >> n >> m;
      for (int i = 1; i <= n; ++i)
	 cin >> s[i];
   }
/****************************************************************************/
   void print(int j, int i)
   {
      if (j <= 1) return;

      if (ts[j][i] > i)
      {
	 cout << ts[ts[j][i] - i][i] << ' ' << ts[j][i] << ' ';
	 if (ts[ts[j][i] - i][i] < ts[j][i]) cout << '<'; else cout << '>';
	 cout << endl << flush;

	 print(ts[j][i] - i, i);
      }

      if (i + j - 1 - ts[j][i] > 0)
      {
	 cout << ts[i + j - 1 - ts[j][i]][ts[j][i] + 1] << ' ' << ts[j][i] << ' ';
	 if (ts[i + j - 1 - ts[j][i]][ts[j][i] + 1] < ts[j][i]) cout << '<'; else cout << '>';
	 cout << endl << flush;

	 print(i + j - 1 - ts[j][i], ts[j][i] + 1);
      }
   }
/****************************************************************************/
   long calc(int j, int i, int d)
   {
      if (j == 0) return 0;
      if (j == 1) return (s[i] * d);
      return (s[i] * d) + calc(ts[j][i] - i, i, d + 1) + calc(i + j - 1 - ts[j][i], ts[j][i] + 1, d + 1);
   }
/****************************************************************************/
   void run()
   {
      int i;
      int j;
      int k;

      for (i = 1; i <= n; ++i) ts[1][i] = i;

      for (j = 2; j <= n; ++j)
      {
	 for (i = 1; i <= (n - j + 1); ++i)
	 {
	    long minm = MAXLONG;
	    int minm_i;

	    for (k = i; k < i + j; ++k)
	    {
	       ts[j][i] = k;

	       long m = calc(j, i, 1);

	       if (m < minm)
	       {
		  minm = m;
		  minm_i = k;
	       }
	    }

	    ts[j][i] = minm_i;
	 }
      }

      cout << ts[n][1] << endl << flush;

      print(n, 1);

      /*
      for (j = 1; j <= n; ++j)
      {
	 for (i = 1; i <= n; ++i)
	    cout << ts[j][i] << ' ';
	 cout << endl << flush;
      }
      /**/
   }
/****************************************************************************/
   int main()
   {
      init();
      run();
      done();

      return 0;
   }
/****************************************************************************/
