#include <stdio.h>

#define	MAXN	310

int h[MAXN];
int n;

int best;

struct {
	int l;
	int r;
} stack[MAXN];
int s1, s2;

int ask(int k) {
	int tmp;

	printf("%d\n", k);
	fflush(stdout);
	scanf("%d", &tmp);

	return tmp;
}

void solve() {
	int i;
	int tmp;
	int max;
	int l, r;

	for (i = 0; i <= n; i++)
		h[i] = -1;

	h[0] = h[n] = 0;
	h[1] = h[n - 1] = 1;
        best = 1;

	stack[s2].l = 1; stack[s2].r = n -1; s2++;
	while (s1 < s2) {
		l = stack[s1].l; r = stack[s1].r; s1++;

		max = (r - l + h[l] + h[r])/2;

		if (max <= h[best])
			continue;

		tmp = ask( (l+r)/2 );
		h[(l+r)/2] = tmp;
		if (tmp > h[best])
			best = (l+r)/2;

		if (tmp == max)
			continue;

		stack[s2].l = l; stack[s2].r = (l+r)/2; s2++;
		stack[s2].l = (l+r)/2; stack[s2].r = r; s2++;
	}

	printf("-1 %d %d\n", best, h[best]);
}

int main() {

	scanf("%d", &n);
	solve();
	return 0;
}
