#include <stdio.h>
//#include <time.h>
#include <string.h>
#define MAXN 2001
#define INF 0x7FFFFFFF
#define ABS(a) ((a)>0?(a):-(a))
#define DEPTH 5

long s[MAXN];
long sum[MAXN];
long n,m;
long T[MAXN][MAXN];
short back[MAXN][MAXN];

long Find(int,int);
long Find2(int,int);
void Init(void);
void Preprocess(void);
void Solve(void);
void Output(void);
void OutS(int,int,int);
void OutL(int,int,int);

long MIN(long a,long b)
  {
    return (a>b?b:a);
  }

void Init()
  {
    int i;
//    freopen("bintree.in","rt",stdin);
    scanf("%ld%ld",&n,&m);
    for(i=1;i<=n;i++)
      scanf("%ld",&s[i]);
  }

void Preprocess()
  {
    int i;
    sum[0]=0;
    sum[1]=s[1];
    for(i=2;i<=n;i++)
      sum[i]=sum[i-1]+s[i];
  }

long Find(int k,int l)
  {
    long res=INF,i,tmp;
    if(k==l) return s[k];
    if(T[k][l]!=-1) return T[k][l];
    // Otdelno sluchaite za krainite elementi
//    tmp=Find(k+1,l)+sum[l]-sum[k]+s[k];
    res=Find(k+1,l)+sum[l]-sum[k]+s[k];
    back[k][l]=k;
    tmp=Find(k,l-1)+sum[l-1]-sum[k-1]+s[l];
    if(tmp<res) { res=tmp;back[k][l]=l; }
    for(i=k+1;i<l;i++)
      {
	tmp=Find(k,i-1)+sum[i-1]-sum[k-1]+s[i]+Find(i+1,l)+sum[l]-sum[i];
	if(tmp<res) { res=tmp;back[k][l]=i; }
      }
    T[k][l]=res;
    return res;
  }

long Find2(int k,int l)
  {
    long res,i,w;
    if(k<=0) return 0;
    if(l>n) return 0;
    if(k>l) return 0;
    if(k==l) return s[k];
    if(T[k][l]!=-1) return T[k][l];
    // Otdelno sluchaite za krainite elementi
    res=sum[l]-sum[k]+l-k;
    w=k;
    for(i=k+1;i<=l;i++)
      if(ABS(sum[i-1]-sum[k-1]+i-k-(sum[l]-sum[i]+l-i))<res)
	{
	  res=ABS(sum[i-1]-sum[k-1]+i-k-(sum[l]-sum[i]+l-i));
	  w=i;
	}
    T[k][l]=Find2(k,w-1)+sum[w-1]-sum[k-1]+s[w]+Find2(w+1,l)+sum[l]-sum[w];
    for(i=1;i<=DEPTH;i++)
      {
	if(w-i>=k)
	  {
	    w-=i;
	    T[k][l]=MIN(T[k][l],Find2(k,w-1)+sum[w-1]-sum[k-1]+s[w]+Find2(w+1,l)+sum[l]-sum[w]);
	    w+=i;
	  }
	if(w+i<=l)
	  {
	    w+=i;
	    T[k][l]=MIN(T[k][l],Find2(k,w-1)+sum[w-1]-sum[k-1]+s[w]+Find2(w+1,l)+sum[l]-sum[w]);
	    w-=i;
	  }
      }
    back[k][l]=w;
    return T[k][l];
  }

void Solve()
  {
    int i,j;
/*    for(i=0;i<=n;i++)
      for(j=0;j<=n;j++)
	T[i][j]=-1;
    Find(1,n);
    Output();*/
    for(i=0;i<=n;i++)
      for(j=0;j<=n;j++)
	T[i][j]=-1;
    Find2(1,n);
  }

void OutL(int x,int y,int p)
  {
    if(x>y) return;
    if(x==y)
      {
	printf("%d %d>\n",x,p);
	return;
      }
    printf("%d %d>\n",back[x][y],p);
    OutS(x,back[x][y]-1,back[x][y]);
    OutL(back[x][y]+1,y,back[x][y]);
  }


void OutS(int x,int y,int p)
  {
    if(x>y) return;
    if(x==y)
      {
	printf("%d %d<\n",x,p);
	return;
      }
    printf("%d %d<\n",back[x][y],p);
    OutS(x,back[x][y]-1,back[x][y]);
    OutL(back[x][y]+1,y,back[x][y]);
  }

void Output()
  {
    printf("%d\n",back[1][n]);
    OutS(1,back[1][n]-1,back[1][n]);
    OutL(back[1][n]+1,n,back[1][n]);
  }

int main()
  {
    Init();
    Preprocess();
    Solve();
    Output();
    return 0;
  }