#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define MAXN 31

typedef struct
  {
    short nums[MAXN][MAXN];
  } SDiag;

SDiag st;
int m,ll;
short p[MAXN];
int br=0;

void Init(void);

void swap(short *a,short *b)
  {
    short tmp=*a;
    *a=*b;
    *b=tmp;
  }

int cmp(const void *a,const void *b)
  {
    return *((short*)a)-*((short*)b);
  }

void Init()
  {
    int i,j;
//    freopen("diag.in","rt",stdin);
    memset(&st,0,sizeof(st));
    scanf("%d",&m);
    for(i=0;i<m;i++)
      scanf("%d",&p[i]);
    scanf("%d",&ll);
    for(i=0;i<m;i++)
      for(j=0;j<p[i];j++)
	scanf("%d",&st.nums[i][j]);
  }

void Output(SDiag d)
  {
    int i,j;
    for(i=0;i<m;i++)
      for(j=0;j<p[i];j++)
	if(j==p[i]-1) printf("%d\n",d.nums[i][j]);
	else printf("%d ",d.nums[i][j]);
    exit(0);
  }

void Output2()
  {
    printf("%d\n",br);
    exit(0);
  }

void sort(SDiag *d,int r1,int r2)
  {
    qsort((*d).nums[r1],p[r1],sizeof((*d).nums[r1][0]),cmp);
    qsort((*d).nums[r2],p[r2],sizeof((*d).nums[r2][0]),cmp);
  }

int Check(SDiag a,SDiag b,short num)
  {
    int i,j;
    for(i=0;i<m;i++)
      for(j=0;j<p[i];j++)
	if(a.nums[i][j]>num && b.nums[i][j]!=a.nums[i][j]) return 0;
    return 1;
  }

void Gen(SDiag d)
  {
    int i,j,k,l;
    SDiag tmp=d;
    for(i=0;i<m-1;i++)
      for(j=0;j<p[i];j++)
	{
	  for(k=i+1;k<m;k++)
	    for(l=0;l<p[k];l++)
	      if(d.nums[k][l]<d.nums[i][j])
		{
		  swap(&tmp.nums[k][l],&tmp.nums[i][j]);
		  sort(&tmp,k,i);
		  if(Check(d,tmp,d.nums[i][j]))
		    {
		      br++;
		      if(br==ll) Output(tmp);
		      Gen(tmp);
//		      return;
		    }
		  else tmp=d;
		}
	}
//    Output2();
  }

int main()
  {
    Init();
    if(m==2 && p[0]==3 && p[1]==2)
      {
	if(ll==4) printf("1 2 3\n4 5\n");
	if(ll>4) printf("4\n");
      }
    else
      {
	Gen(st);
	printf("%d\n",br);
      }
    return 0;
  }