/*
TASK:TRAV
LANG:C++
*/

#include <stdio.h>
#include <assert.h>
#include <vector>
#include <algorithm>
using namespace std;

const int N = 20;
const int M = 100;
const int inf = 1023456789;


bool used[N];
int perm[N];
int t[N][M];//time
int d[N][M];
int i, j, n, m;


void Input(){
//	freopen("trav.in2", "rt", stdin);
  scanf("%d%d", &n, &m);
  for(i=0; i<n; i++){
  	perm[i] = i;
		for(j=1; j<=m; j++)
    	scanf("%d", &t[i][j]);
  }
}

inline int max(int p, int q){
	return p > q ? p : q;
}

void Solve(){
	int res[N];
  int best = inf;
  int dist[M];

  for(i=0; i<n; i++)
  	for(j=1; j<=m; j++)
    	d[i][j] = d[i][j-1] + t[i][j];

  dist[0] = 0;
  do{

  	for(i=1; i<=m; i++)
    	dist[i] = t[perm[0]][i] + dist[i-1];

		int stop = 0;

    for(i=1; i<n; i++){
    	for(j=1; j<m; j++){
        if(dist[j] > stop + d[ perm[i] ][j]){
          stop = dist[j] - d[ perm[i] ][j];
        }
        else{
        	dist[j] = stop + d[ perm[i] ][j];
          stop = 0;
        }
      }
      if(dist[m] >= best){
        goto next;
      }
    }

    next:

  	if(dist[m] < best){
    	best = dist[m];
    	for(i=0; i<n; i++)
    		res[i] = perm[i];
    }




  }while(next_permutation(perm, perm+n));


  for(i=0; i<n; i++)
  	printf("%d ", res[i]+1);
  printf("\n");
}



int main(){

	Input();
  Solve();

	return 0;
}
