/*
TASK: trav
LANG: c
*/
#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#define MAXN (16)
#define MAXL (64)

int n, m, ans, ansi;
int p[MAXN];
int t[MAXN];
int f[MAXN];
int tsa[MAXN][MAXL];
int ts[MAXN][MAXL];
int tr[MAXN][MAXL];
int r[MAXN];

void pset (int *a, int n)  {
  int i;

  for (i = 1; i <= n; ++i)
    printf ("%d%c", a[i], i == n ? '\n' : ' ');
}

void decode (int *a, int n, int num)  {
  int i, j, k;

  for (i = 1; i <= n; ++i)
    t[i] = i;

  for (i = 1; i <= n; ++i)  {
    a[n - i + 1] = num % i;
    num /= i;
  }

  for (i = 1; i <= n; ++i)  {
    k = a[i] + 1;
    a[i] = t[k];
    memmove (t + k, t + k + 1, sizeof(int) * (n - i - k + 1));
  }
}

void init ()  {
  int i, j;

//freopen ("trav.in" , "r", stdin );
//freopen ("trav.out", "w", stdout);

  scanf ("%d%d", &n, &m);

  for (i = 1; i <= n; ++i)
    for (j = 1; j <= m; ++j)
      scanf ("%d", &tsa[i][j]);

  f[1] = 1;
  for (i = 2; i <= n; ++i)
    f[i] = f[i - 1] * i;
}

void reset ()  {
  int i;

  memcpy (ts, tsa, sizeof(tsa));

  for (i = 1; i <= n; ++i)
    r[i] = 1;

  r[0] = r[n + 1] = 100;

  memset (tr, 0, sizeof(tr));
}

int see ()  {
  int i, j, k, t, q, pt, s;

  for (k = 1; r[p[n]] < m + 1; ++k)  {
    s = 0;
    for (i = 1; i <= n; ++i)  {
      if (tr[p[i]][r[p[i]] - 1] + ts[p[i]][r[p[i]]] >= tr[p[i - 1]][r[p[i]]])
        tr[p[i]][r[p[i]]] = tr[p[i]][r[p[i]] - 1] + ts[p[i]][r[p[i]]];
      else
        tr[p[i]][r[p[i]]] = tr[p[i - 1]][r[p[i]]];
      s += tr[p[i]][r[p[i]]];
      r[p[i]] += 1;
      if (s > ans)
        return INT_MAX;
    }
  }

  return s;
}

void think ()  {
  int i, t;

  ans = INT_MAX;
  for (i = 0; i < f[n]; ++i)  {
    decode (p, n, i);
    reset ();
    t = see ();
    if (ans > t)  {
      ans = t;
      ansi = i;
    }
  }
}

void print ()  {
  decode (p, n, ansi);
  pset (p, n);
}

int main ()  {
  init ();
  think ();
  print ();

  return 0;
}

