/*
TASK: string
LANG: C
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define L 11
#define P 131071

struct he {
        char w[L];
        struct he *n;
        int c;
        int p;
};
struct he h[P];
struct he *m;
int n;

void add(char *w, int p) {
        int i;
        long long hn;
        struct he *c;

        hn = 1;
        for (i = 0; i < strlen(w); i++)
                hn *= w[i];
        hn %= P;

        c = &h[hn];
        while ((c->w[0] != 0) && (strcmp(c->w, w) != 0))
                c = c->n;

        if (c->w[0] == 0) {
                strcpy(c->w, w);
                c->n = malloc(sizeof(struct he));
                c->n->w[0] = 0;
                c->c = 1;
                c->p = p;
        } else {
                c->c++;
        }
}

void find_min() {
        int i;
        struct he *c;

        for (i = 0; i < P; i++)
                if (h[i].w[0] != 0)
                        break;
        m = &h[i];
        c = &h[i];
        while (c->w[0] != 0) {
                if ((c->c < m->c) || ((c->c == m->c) && (c->p < m->p)))
                        m = c;
                c = c->n;
        }

        for (i++; i < P; i++) {
                c = &h[i];
                while (c->w[0] != 0) {
                        if ((c->c < m->c) || ((c->c == m->c) && (c->p < m->p)))
                           m = c;
                        c = c->n;
                }
        }

        printf("%s\n", m->w);
}

int main() {
        int i;
        char str[16];

        scanf("%d", &n);
        fgets(str, 16, stdin);
        for (i = 0; i < n; i++) {
                fgets(str, 16, stdin);
                if (str[strlen(str)-1] == '\n')
                        str[strlen(str)-1] = 0;
                add(str, i);
        }

        find_min();
        return 0;
}
