#include <iostream.h>
#include <stdlib.h>
#include <math.h>

#define maxN 200
#define MAXF 1000000
#define MINF 0.0000001

struct point { double x,y;int org; } P[maxN+1];
int N,cnt=0,temp=0;
point A[maxN+2],T[maxN+1];
struct U { double St;int P1,P2; } Angle[maxN+1];

double dist(point A,point B);
int comp2(U FST,U SND);
double MIN(double fst,double snd);
double MAX(double fst,double snd);
void init();
void destroy_last();

int main()
{
 int i,j,k;
 U ddd;
 init();
 for (i=1;i<=N;i++) {
   Angle[i].St=dist(A[0],A[i])*dist(A[0],A[i]);
   Angle[i].St+=dist(A[0],A[i+1])*dist(A[0],A[i+1]);
   Angle[i].St-=dist(A[i],A[i+1])*dist(A[i],A[i+1]);
   Angle[i].St/=2*dist(A[0],A[i])*dist(A[0],A[i+1]);
   Angle[i].P1=A[i].org;
   Angle[i].P2=A[i+1].org; }
 Angle[0].St=1;Angle[0].P1=0;Angle[0].P2=0;
 destroy_last();
 for (i=1;i<N;i++)
   if (comp2(Angle[i],Angle[i+1])) {
      ddd=Angle[i];Angle[i]=Angle[i+1];Angle[i+1]=ddd;
      if (i>1) i-=2; }
 for (i=1;i<=N;i++)
   if (Angle[i].St!=1&&Angle[i].St!=-1)
       cout<<MIN(Angle[i].P1,Angle[i].P2)<<' '<<MAX(Angle[i].P1,Angle[i].P2)<<'\n';
 return 0;
}

void init ()
{
 int i,j;
 double mx,my;
 point dd;
 cin>>N;
 for (i=0;i<=N;P[i++].org=i-1) cin>>P[i].x>>P[i].y;
 for (mx=P[0].x,my=P[0].y,i=0;i<=N;i++) { P[i].x-=mx;P[i].y-=my; }

 //          I vi kvadrant

 for (i=1,temp=0,T[0].x=MAXF,T[0].y=MINF;i<=N;i++)
    if (P[i].x>0&&P[i].y>=0) T[++temp]=P[i];
 for (i=1;i<temp;i++)
    if (T[i].x/T[i].y<T[i+1].x/T[i+1].y) {
	dd=T[i];T[i]=T[i+1];T[i+1]=dd;
	if (i>1) i-=2; }
 for (i=1;i<=temp;i++) A[++cnt]=T[i];

 // Oy+

 for (i=1;i<=N;i++)
    if (P[i].x==0&&P[i].y>=0) A[++cnt]=P[i];

 //          II ri kvadrant

 for (i=1,temp=0,T[0].x=-MINF,T[0].y=MAXF;i<=N;i++)
    if (P[i].x<0&&P[i].y>=0) T[++temp]=P[i];
 for (i=1;i<temp;i++)
    if (T[i].x/T[i].y<T[i+1].x/T[i+1].y) {
	dd=T[i];T[i]=T[i+1];T[i+1]=dd;
	if (i>1) i-=2; }
 for (i=1;i<=temp;i++) A[++cnt]=T[i];

 //          III ti kvadrant

 for (i=1,temp=0,T[0].x=-MAXF,T[0].y=-MINF;i<=N;i++)
    if (P[i].x<0&&P[i].y<0) T[++temp]=P[i];
 for (i=1;i<temp;i++)
    if (T[i].x/T[i].y<T[i+1].x/T[i+1].y) {
	dd=T[i];T[i]=T[i+1];T[i+1]=dd;
	if (i>1) i-=2; }
 for (i=1;i<=temp;i++) A[++cnt]=T[i];

 // Oy-

 for (i=1;i<=N;i++)
    if (P[i].x==0&&P[i].y<=0) A[++cnt]=P[i];

 //          IV ti kvadrant

 for (i=1,temp=0,T[0].x=MINF,T[0].y=-MAXF;i<=N;i++)
    if (P[i].x>0&&P[i].y<0) T[++temp]=P[i];
 for (i=1;i<temp;i++)
    if (T[i].x/T[i].y<T[i+1].x/T[i+1].y) {
	dd=T[i];T[i]=T[i+1];T[i+1]=dd;
	if (i>1) i-=2; }
 for (i=1;i<=temp;i++) A[++cnt]=T[i];

 A[N+1]=A[1];
}


double dist(point A,point B)
{
 return sqrt((A.x-B.x)*(A.x-B.x)+(A.y-B.y)*(A.y-B.y));
}

int comp2(U FST,U SND)
{
 if (FST.St<SND.St) return 1;
 if (FST.St>SND.St) return 0;
 if (MIN(FST.P1,FST.P2)>MIN(SND.P1,SND.P2)) return 1;
 if (MIN(FST.P1,FST.P2)<MIN(SND.P1,SND.P2)) return 0;
 if (MAX(FST.P1,FST.P2)>MAX(SND.P1,SND.P2)) return 1;
 return 0;
}

double MIN(double fst,double snd)
{
 if (fst<snd) return fst;
 return snd;
}
double MAX(double fst,double snd)
{
 if (fst>snd) return fst;
 return snd;
}


void destroy_last()
{
 double a,b,c,r1,r2;
 a=A[N].y-A[N+1].y;
 b=A[N+1].x-A[N].x;
 c=A[N].x*A[N+1].y-A[N].y*A[N+1].x;
 r1=a*A[N+1].x+b*A[N+1].y+c;
 r2=a*A[2].x+b*A[2].y+c;
 if (r1*r2>0) N--;
}