#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <vector>
using namespace std;

const int maxn = 10001;

struct tnei {
	short int k,w;
};

vector<tnei> nei[maxn];

short int si[maxn];
short int d[maxn];
char unvis[maxn];
int n,m;

/*****************/
void input()
{
	int i,j,l,w;
	tnei p;
	
	memset(nei, 0, sizeof(nei));
	memset(si, 0, sizeof(si));

	scanf("%d%d",&n,&m);

	for(l=1; l<=m; l++) {
		scanf("%d%d%d",&i,&j,&w);
		p.k=j;
		p.w=w;
		nei[i].push_back(p);
		si[i]++;
		p.k=i;
		nei[j].push_back(p);
		si[j]++;
	}
}
/*****************/
void go()
{
	void output();
	
	memset(d, 0, sizeof(d));
	memset(unvis, 0x01, sizeof(unvis));
	
	int i,j,k,l,w;
	
	for(i=0; i<si[1]; i++) {
		if (nei[1][i].w>d[1]) d[1]=nei[1][i].w;
	}

	k=1;
	do {
		unvis[k]=0;
		if (k==n) {
			output();
			exit(0);
		}

		/* update */
		for(i=0; i<si[k]; i++) {
			j=nei[k][i].k;
			if (unvis[j]) {
				w=nei[k][i].w;
				if (d[k]<w) l=d[k];
				else l=w;

				if (d[j]<l) d[j]=l;
			}
		}

		/* choose k */
		k=-1; l=0;
		for(i=1; i<=n; i++) {
			if (unvis[i]) {
				if (d[i]>l) {
					l=d[i];
					k=i;
				}
			}
		}
	} while (k!=-1);

}
/*****************/
void output()
{
	printf("%d\n",d[n]);
}
/*****************/
int main()
{
	input();
	go();
	output();

	return 0;
}