#include <stdio.h>
#include <string.h>
#include <math.h>

const int maxn = 2001;
const double e = 0.000001;

struct tcoor {
	int x,y;
	double th;
} a[maxn];

int n;

int ths[maxn];
tcoor ans[maxn];
/*****************/
void input()
{
	int i;

	memset(a, 0, sizeof(a));
	
	scanf("%d",&n);

	for(i=0; i<=n; i++)
		scanf("%d%d",&a[i].x,&a[i].y);
}
/*****************/
char smallths(double p, double q)
{
	if (p+e<q) return 1;
	return 0;
}
/*****************/
void sortths(int l, int r)
{
	int i=l, j=r;
	double mid=a[ths[(i+j)/2]].th;

	do {
		while (smallths(mid,a[ths[i]].th)) i++;
		while (smallths(a[ths[j]].th,mid)) j--;
		if (i<=j) {
			int tmp=ths[i]; ths[i]=ths[j]; ths[j]=tmp;
			i++; j--;
		}
	} while (i<=j);

	if (i<r) sortths(i,r);
	if (l<j) sortths(l,j);
}
/*****************/
char smaller(tcoor p, tcoor q)
{
	if ((p.th+e>q.th) && (p.th-e<q.th)) {
		return ((p.x<q.x)||(p.x==q.x && p.y<q.y));
	}
	else if ((p.th+e<q.th))
		return 1;
	else return 0;
}
/*****************/
void sortans(int l, int r)
{
	int i=l, j=r;
	tcoor mid=ans[(i+j)/2];

	do {
		while (smaller(ans[i],mid)) i++;
		while (smaller(mid,ans[j])) j--;
		if (i<=j) {
			tcoor tmp=ans[i]; ans[i]=ans[j]; ans[j]=tmp;
			i++; j--;
		}
	} while (i<=j);

	if (i<r) sortans(i,r);
	if (l<j) sortans(l,j);
}
/*****************/
void theta(int k)
{
	int dx,dy,ax,ay;
	double t;

	dx=a[k].x-a[0].x; ax=abs(dx);
	dy=a[k].y-a[0].y; ay=abs(dy);
	if ((dx==0) && (dy==0)) t=0;
	else t=((double) dy)/(ax+ay);
	if (dx<0) t=2-t;
	else if (dy<0) t+=4;
	a[k].th=90.0*t;
}
/*****************/
void go()
{
	int i;
	for(i=1; i<=n; i++)
    	theta(i);

	for(i=1; i<=n; i++)
		ths[i]=i;
	sortths(1,n);

	for(i=1; i<n; i++) {
		ans[i].x=ths[i];
		ans[i].y=ths[i+1];
		ans[i].th=fabs(a[ths[i]].th-a[ths[i+1]].th);
		if (ths[i]>ths[i+1]) {
			ans[i].x=ths[i+1];
			ans[i].y=ths[i];
		}
	}
	if (ths[1] < ths[n]) {
		ans[n].x=ths[1];
		ans[n].y=ths[n];
	}
	else {
		ans[n].x=ths[n];
		ans[n].y=ths[1];
	}
	ans[n].th=fabs(360.0-a[ths[1]].th+a[ths[n]].th);
	sortans(1,n);
}
/*****************/
void output()
{
	int i;

	for(i=1; i<=n; i++) {
		if ((ans[i].th-e>0.0) && smallths(ans[i].th,180.0))
			printf("%d %d\n",ans[i].x,ans[i].y);
	}
}
/*****************/
int main()
{
	input();
	go();
	output();

	return 0;
}