// RAYS.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <math.h>
using namespace std;
int N;
struct cord;
struct corner;
struct corlist;
cord* a;
corlist* top=NULL;

struct corlist{
	corlist* next;
	corner cor;
}

struct corner{
	int nom1;
	int nom2;
	double corn;
};

struct cord{
	int nom;
	long int x;
	long int y;
};

long int min(unsigned int a,unsigned int b);
long int max(unsigned int a,unsigned int b);
void meassure(cord, cord);
void addtolist(corner);

int main(int argc, char* argv[])
{	
	cin>>N;
	a = new cord[N+1];
	for(int i=0;i<=N;i++){
		cin>>a[i].x>>a[i].y;
		a[i].nom=i;
	}
	for(i=1;i<=N;i++)
		for(int j=1;j<=N;j++)
		{
			if((a[i].y>a[0].y)&&(a[j].y>a[0].y))||((a[i].y<a[0].y)&&(a[j].y<a[0].y))
			{
				bool b=false;
				for(int q=1;q<=n;q++){
					if((a[q].x<max(a[i].x,a[j].x]))&&(a[q].x>min(a[i].x,a[j].x)))
						b=true;
				}
				if(!b){measure(a[i],a[j])}
			}
			else{
				bool b=false;
				for(int q=1;q<=n;q++){
					if((a[q].y<max(a[i].y,a[j].y]))&&(a[q].y>min(a[i].y,a[j].y)))
						b=true;
				}
				if(!b){measure(a[i],a[j])}
			}
		}

	return 0;
}

void addtolist(corner c)
{
	if(top==NULL){
		top= new corner;
		top->cor=c;
		top->next=NULL;
		
	}
	else{
		corlist* l;
		l=top;
		if(l->cor.corn>c.corn){
				corlist* n;
				n=new corlist;
				n->cor=c;
				n->next=l;
				top=n;
			}
		while(l!=NULL){
			if(l->next->cor.corn>c.corn){
				corlist* n;
				n=new corlist;
				n->cor=c;
				n->next=l->next;
				l->next=n;
			}
			else{
				l=l->next;
			}
		}
	}
}




void measure(cord c,cord b)
{
	int x,y;
	double ots1,ots2,ots;
	ots1=sqrt(sqr(abs(c.x-a[0].x))+sqr(abs(c.y-a[0].y)));
	ots2=sqrt(sqr(abs(b.x-a[0].x))+sqr(abs(b.y-a[0].y)));
	ots3=sqrt(sqr(abs(b.x-c.x))+sqr(abs(b.y-c.y)));
	corner cor;
	cor.nom1=c.nom;
	cor.nom2=b.nom;
	cor.corn=(sqr(ots1)+sqr(ots2)-sqr(ots3))/(2*ots1*ots2);
	addtolist(cor);
}

long int min(unsigned int a,unsigned int b)
{
	if(a<b){return a;}
	if(b<a){return b;}
	return a;
}


long int max(unsigned int a,unsigned int b)
{
	if(a<b){return b;}
	if(b<a){return a;}
	return a;
}

