program RAYS;

type
    point = record
          x : longint;
          y : longint;
    end;

    dpoint = record
         i : integer;
         j : integer;
         c : real;
    end;

var
   p : array[0..2000] of point;
   n : integer;
   a : array[0..3000] of dpoint;
   m : integer;

procedure input;
var
   i : integer;
begin
     readln(n);
     m := 0;
     for i := 0 to n do
         begin
              read(p[i].x);
              readln(p[i].y);
         end;
end;

function getcos(x1,y1 : longint; x2,y2 : longint) : real;
var
   a,b,c : real;
begin
     a := sqrt( sqr( p[0].x - x1 ) + sqr( p[0].y - y1 ) );
     b := sqrt( sqr( p[0].x - x2 ) + sqr( p[0].y - y2 ) );
     c := sqrt( sqr( x1 - x2 ) + sqr( y1 - y2 ) );
     getcos := ( sqr(a) + sqr(b) - sqr(c) ) / ( 2*a*b);
end;

procedure find;
var
   i,j,k : integer;
   la : dpoint;
   x : real;
   b : boolean;
begin
     for i := 1 to n-1 do
         begin
              b := false;
              la.i := 0;
              la.j := 0;
              la.c := -2;
              for j := i+1 to n do
                  begin
                       x := getcos(p[i].x, p[i].y, p[j].x, p[j].y);
                       if x >= la.c then
                          begin
                               b := true;
                               la.i := i;
                               la.j := j;
                               la.c := x;
                          end;
                  end;
              if b = true then
                 begin
                      a[m] := la;
                      m := m + 1;
                 end;
         end;
end;

procedure sort;
var
   i,j : integer;
   x : dpoint;
begin
     for i := 1 to m-2 do
         for j := i + 1 to m-1 do
             if a[i].c < a[j].c then
                begin
                     x := a[i];
                     a[i] := a[j];
                     a[j] := x;
                end;
end;

procedure output;
var
   i : integer;
begin
     for i := 0 to m-1 do
         writeln(a[i].i,' ',a[i].j);
end;

BEGIN
     input;
     find;
     sort;
     output;
END.