#include <stdio.h>
#include <stdlib.h>

#define MAXN 2001

typedef struct {
          int x, y;
        } TPoint;

typedef struct {
           int A, B;
           double Alfa; 
        } TAngle;    
             
TPoint A[MAXN];
TAngle Angle[4001];

int N, M;   
   
int S(TPoint P1, TPoint P2, TPoint P3) {
    return (P1.x-P2.x)*(P1.y+P2.y)+(P2.x-P3.x)*(P2.y+P3.y)+(P3.x-P1.x)*(P3.y+P1.y);
}
      
int S1(TPoint P1, TPoint P2, TPoint P3) {
    return 0.5*abs( (P1.x-P2.x)*(P1.y+P2.y)+(P2.x-P3.x)*(P2.y+P3.y)+(P3.x-P1.x)*(P3.y+P1.y) );
}
      
int Cross(TPoint A, TPoint B, TPoint X, TPoint Y) {
    int L1, L2;

    if ( S(A, B, X)*S(A, B, Y) < 0 && S(X, Y, B)*S(X, Y, A)<0 ) return 1;
    if( S(A, B, X)*S(A, B, Y) < 0 && ( S(X,B,A)*S(X,B,Y)<0 || S(Y,B,A)*S(Y,B,X)<0 )) return 1;
    return 0;
}
                   
void Init(void) {
   int i;
   scanf("%d", &N);
   for(i=0; i<=N; i++) scanf("%d %d", &A[i].x, &A[i].y);
   M = 0;
}
        
void Solve(void) {
      int i, j, k;
      for(i=1; i<=N-1; i++)
      {
        for(j=i+1; j<=N; j++)
         if(S(A[i],A[0],A[j])!=0)                
        {
/*          printf("***%d %d \n", i, j); */
          for(k=1; k<=N; k++) if(Cross(A[0], A[k], A[i], A[j]) ) break;
          if(k>N) { Angle[M].A = i; Angle[M++].B = j; }
        } 
      }    
            
           
}
        
int main(void) {
     int i;
     Init();
     Solve();
     for(i=0; i<M; i++) printf("%d %d \n", Angle[i].A, Angle[i].B);
     system("PAUSE");
     return 0;
}
