Program Fast;
Type
 OGR3 = 0..65000;{W}
 DataType = Longint;
 PRebro = ^TRebro;
 PVzel  = ^TVzel;
 TVzel  = Record
  Data    : DataType;
  Poseten : Boolean;
  Next,pred    : PVzel;
  Nasl    : PRebro;
 end;

 TRebro = Record
  Vz   : PVzel;
  W    : Ogr3;
  next : PRebro
 end;

Var  N,M:Longint;Head,Tail,p:PVzel;
     MaxW:Ogr3;

Procedure BuildEmptyGraph(Var Head,Tail:PVzel);
Begin Head:=new(PVzel);Tail:=Head end;

Function IsEmptyGraph(Head,Tail:PVzel):boolean;
Begin IsEmptyGraph:= (Head=Tail) end;

Function Find(Head,Tail:PVzel;Data:DataType):PVzel;
Var p:Pvzel;
Begin
 P:=Head;Tail^.data:=data;
 While p^.data<>data do p:=p^.next;
 Find:=p
end;

Function FoundVzel(Head,Tail:Pvzel;Data:DataType):Boolean;
Begin FoundVzel:= Find(Head,Tail,Data)<>Tail end;

Function Locate(Var Head,Tail:PVzel;Data:DataType):Pvzel;
Var p:PVzel;
Begin
 p:=Find(Head,Tail,Data);
 If p=tail then begin Tail^.nasl:=nil;Tail^.poseten:=False;Tail^.pred:=nil;
                      p:=Tail; Tail^.next:=new(Pvzel);Tail:=tail^.next
                end;
 Locate:=p
end;

Function FoundRebro(head,tail:Pvzel;X,Y:DataType):boolean;
Var Px,Py:PVzel;
    T:Prebro;
Begin
 Px:=Find(head,tail,x);
 If Px=nil{tail} then Foundrebro:=False
 else
  Begin
   t:=px^.nasl;
   While (T<>nil) and (T^.Vz^.data<>y) do t:=t^.next;
   FoundRebro:= (T^.Vz^.data=y);
  end
end;

Procedure AddRebro(Var Head,Tail:PVzel;x,y:dataType;W:OGR3);
Var t:PRebro;
    P,Q:PVzel;
Begin
 P:=Locate(head,tail,x);
 If X=Y then exit;
 t:=p^.nasl;
 While (T<>nil) and (t^.Vz^.data<>Y) do t:=t^.next;
 If t=nil then Begin
  q:=Locate(head,tail,y);T:=new(Prebro);
  T^.next:=P^.nasl; P^.nasl:=T;T^.Vz:=Q; T^.W:=W end;
end;

Procedure BuildGraph(Var Head,Tail:PVzel);
Var x,y:DataType;
    W:Ogr3;i:longint;
Begin
 BuildEmptyGraph(head,tail);
 For i:=1 to m do Begin
 Readln(x,y,w);
 AddRebro(head,tail,x,y,w);
 AddRebro(head,tail,y,x,w);
 end
end;

Function GetWid(P:PVzel):ogr3;
Var wid:ogr3;
Begin
 wid:=65000;
 While (p<>nil) and (p^.pred<>nil) do begin
  if wid>p^.pred^.nasl^.w then wid:=p^.pred^.nasl^.w;
  p:=p^.pred end;
  GetWid:=wid
end;

Procedure FindWay(P:PVzel);
Var T:Prebro;s:ogr3;
Begin
 P^.poseten:=true;
 If P^.data=N then Begin S:=GetWid(p); If s>MaxW then MaxW:=s;  end
 else
 begin
  t:=p^.nasl;
  while t<>nil do
  begin
   if not t^.Vz^.poseten then
    begin T^.Vz^.pred:=p;FindWay(T^.Vz);T^.Vz^.pred:=nil end;
  T:=T^.next
  end
 end;
P^.poseten:=False
end;

BEGIN
MaxW:=0;Readln(n,m);
BuildGraph(head,tail);
P:=Locate(head,tail,1);
FindWay(p);
Writeln(MaxW);
Readln;
END.






