const
   MAXN = 2000;
type
   tpoint = record x, y, i : longint; a : double; end;
   trec = record a : double; i, j : longint; end;
var
   n : longint;
   a : array[1..MAXN] of tpoint;
   z : array[1..MAXN*100] of trec;
   zn : longint;


function angle1(p : tpoint) : double;
begin
   if (p.x > 0) and (p.y > 0) then
      angle1:=arctan(p.y/p.x)
   else if (p.x < 0) and (p.y > 0) then
      angle1:=arctan(p.y/p.x)+pi
   else if (p.x < 0) and (p.y < 0) then
      angle1:=arctan(p.y/p.x)+pi
   else if (p.x > 0) and (p.y < 0) then
      angle1:=arctan(p.y/p.x)+pi+pi
   else if (p.x = 0) and (p.y > 0) then
      angle1:=pi/2
   else if (p.x = 0) and (p.y < 0) then
      angle1:=(3*pi)/2
   else if (p.x > 0) and (p.y = 0) then
      angle1:=0
   else if (p.x < 0) and (p.y = 0) then
      angle1:=pi;
end;

function angle(p1, p2 : tpoint) : double;
var a : double;
begin
   a:=p2.a - p1.a;
   if a < 0 then a:=a+2*pi;
   angle:=a;
{   if p2.a > p1.a then
      angle:=p2.a - p1.a
   else
      angle:=p1.a - p2.a;}
end;

procedure qsort1(l, r : longint);
var
   i,j : longint;
   x : double;
   y : tpoint;
begin
   i:=l; j:=r; x:=a[(l+r) div 2].a;
   repeat
      while a[i].a < x do inc(i);
      while x < a[j].a do dec(j);
      if not(i > j) then
      begin
         y:=a[i];
         a[i]:=a[j];
         a[j]:=y;
         inc(i);
         dec(j);
      end;
   until i>j;
   if l<j then qsort1(l,j);
   if i<r then qsort1(i,r);
end;

function less(a, b : trec) : boolean;
begin
   if a.a <> b.a then
      exit(a.a < b.a)
   else
      if a.i <> b.i then
         exit(a.i < b.i)
      else
         exit(a.j < b.j);
end;

procedure qsort2(l, r : longint);
var
   i,j : longint;
   x : trec;
   y : trec;
begin
   i:=l; j:=r; x:=z[(l+r) div 2];
   repeat
      while less(z[i], x) do inc(i);
      while less(x, z[j]) do dec(j);
      if not(i > j) then
      begin
         y:=z[i];
         z[i]:=z[j];
         z[j]:=y;
         inc(i);
         dec(j);
      end;
   until i>j;
   if l<j then qsort1(l,j);
   if i<r then qsort1(i,r);
end;

var
   p0 : tpoint;
   i, j : longint;
   min, t : double;
   minj : longint;
begin
   readln(n);
   readln(p0.x, p0.y);
   for i:=1 to n do
   begin
      readln(a[i].x, a[i].y);
      dec(a[i].x, p0.x); dec(a[i].y, p0.y);
      a[i].a:=angle1(a[i]);
      a[i].i:=i;
   end;

   qsort1(1, n);
   a[n+1]:=a[1];

   zn:=0;
   i:=1;
   while i <= n do
   begin
      t:=angle(a[i], a[i+1]);
      if (t < pi) and (t > 0) then
      begin
         inc(zn);
         z[zn].a:=t;
         if a[i].i < a[i+1].i then begin z[zn].i:=a[i].i; z[zn].j:=a[i+1].i; end
         else begin z[zn].i:=a[i+1].i; z[zn].j:=a[i].i; end;
      end;
      inc(i);
   end;

   qsort2(1, zn);

   for i:=1 to zn do
      writeln(z[i].i, ' ', z[i].j);
end.
