//Yordan Yankov Madjunkov 10a klas Mg "Geo milev" gr. pleven
{$I-,Q-,R-,S-}
const
   MaxN = 2000;
type
   TVer = record
      i,j : longint;
      ang : double;
   end;
   TType = TVer;
   HeapObj = object
      n,i,j : longint;
      d : TType;
      a : array[1..MaxN] of TType;
      procedure Push(var b : TType);
      procedure Pop (var b : TType);
   end;
procedure HeapObj.push(var b : TType);
begin
   inc(n);
   a[n]:=b;
   i:=n;
   while (i>1)and(a[i].ang<a[i shr 1].ang) do
      begin
         d:=a[i];
         a[i]:=a[i shr 1];
         i:=i shr 1;
         a[i]:=d;
      end;
end;

procedure HeapObj.pop(var b : TType);
begin
   b:=a[1];
   a[1]:=a[n];
   dec(n);
   i:=1;
   while (i<=n shr 1)and((a[i].ang>a[i shl 1].ang)or(a[i].ang>a[i shl 1 + 1].ang)) do
      begin
         i:= i shl 1;
         if a[i+1].ang<a[i].ang then inc(i);
         d:=a[i];
         a[i]:=a[i shr 1];
         a[i shr 1]:=d;
      end;
end;
type
   HeapObj2 = object
      n,i,j : longint;
      d : TType;
      a : array[1..MaxN] of TType;
      procedure Push(var b : TType);
      procedure Pop (var b : TType);
      function cmp(b,c : TType) : boolean;
   end;
function HeapObj2.cmp(b,c : TType) : boolean;
begin
   if b.ang<c.ang then cmp:=true else
      if (b.ang=c.ang)and(b.i*10000+b.j<c.i*10000+c.j) then cmp:=true else cmp:=false;
end;
procedure HeapObj2.push(var b : TType);
begin
   inc(n);
   a[n]:=b;
   i:=n;
   while (i>1)and cmp(a[i],a[i shr 1]) do
      begin
         d:=a[i];
         a[i]:=a[i shr 1];
         i:=i shr 1;
         a[i]:=d;
      end;
end;

procedure HeapObj2.pop(var b : TType);
begin
   b:=a[1];
   a[1]:=a[n];
   dec(n);
   i:=1;
   while (i<=n shr 1)and(cmp(a[i shl 1],a[i]) or cmp(a[i shl 1 + 1],a[i]) )do
      begin
         i:= i shl 1;
         if cmp(a[i+1],a[i]) then inc(i);
         d:=a[i];
         a[i]:=a[i shr 1];
         a[i shr 1]:=d;
      end;
end;

var
   a : array[1..MaxN] of TVer;
   n : longint;
   k : TType;
   h : HeapObj;
   h2 : HeapObj2;
procedure readfile;
var
   x0,y0 : double;
   o : longint;
   x,y : double;
   dist : double;
   sin, cos : double;

begin
   read(n);
   readln(x0,y0);
   k.j:=0;
   for o:=1 to n do with a[o] do
      begin
         readln(x,y);
         x:=x-x0;
         y:=y-y0;
         dist:=sqrt(sqr(x)+sqr(y));
         cos:=x/dist;
         sin:=y/dist;
         if cos = 0 then ang:=pi - sin*pi/2 else
         if cos>0 then ang:=arctan(sin/cos) else
            ang:= pi + arctan(sin/cos);

         if ang<0 then ang:=2*pi + ang;
         ang:=ang*180/pi;
         k.i:=o;
         k.ang:=ang;
         h.push(k);
      end;
end;
procedure solve;
var
   k,p,d : TType;
   t : longint;
begin
   h.Pop(p);
   p.ang:=p.ang+360;
   h.push(p);
   p.ang:=p.ang-360;
   while h.n>0 do
      begin
         h.Pop(k);
         d.i:=k.i;
         d.j:=p.i;
         d.ang:=k.ang-p.ang;
         if d.i>d.j then with d do begin t:=i;i:=j;j:=t; end;
         h2.push(d);
         p:=k;
      end;
end;
procedure writefile;
var
   k : TType;
begin
   while h2.n>0 do
      begin
         h2.pop(k);
         if k.ang<180 then if k.j<k.i then writeln(k.j,' ',k.i) else writeln(k.i,' ',k.j)
      end;
end;
begin
   readfile;
   solve;
   writefile;
end.
