#include <stdio.h>
#include <stdlib.h>

#define INF 1000000
#define min(a,b) ((a)<(b)?(a):(b))

struct crs{int name, minw;};
struct str{int beg, end, wid;};

str m[200004];
int N, M;
int a[10002];
int dist[10002];
int vis[10002];

crs pq[10002];
int ptrs[10002];
int pqsize=1;

int findbegcross(int name)
{
 int l=0, r=M;
 while(1){
  if(r<=l) return -1;
  if(m[(r+l)/2].beg==name) break;
  else if(m[(r+l)/2].beg>name)
   r=(r+l)/2;
  else l=(r+l)/2+1;
 }
 int pos=(r+l)/2;
 while(m[pos].beg==name&&pos>=0) pos--;
 return pos+1;
}

void swap(int pos, int npos){
  int tmpi=ptrs[pq[pos].name];
  ptrs[pq[pos].name]=ptrs[pq[npos].name];
  ptrs[pq[npos].name]=tmpi;
  crs tmp=pq[pos];
  pq[pos]=pq[npos];
  pq[npos]=tmp;
}

void push(int name, int minw)
{
 pq[pqsize].name=name;
 pq[pqsize].minw=minw;
 ptrs[name]=pqsize;
 int pos=pqsize++;
 while(pos!=1&&pq[pos].minw>pq[pos/2].minw)
 {
  swap(pos, pos/2);
  pos/=2;
 }
}

int cmp(const void * a, const void * b)
{
 return ((*(str *)a).beg-(*(str *)b).beg);
}

crs pop()
{
 crs res=pq[1];
 pq[1]=pq[--pqsize];
 int pos=1;
 while(pos*2<pqsize&&(pq[pos].minw<pq[pos*2].minw
                      ||pq[pos].minw<pq[pos*2+1].minw))
 {
  if(pq[pos*2].minw<pq[pos*2+1].minw)
   {swap(pos, pos*2+1);pos=pos*2+1;}
  else {swap(pos, pos*2);pos*=2;}
 }
 return res;
}

int empty(){return pqsize==1;}

void dijkstra()
{
 int b=1, i, j;
 push(b, INF);
 for(i=2;i<=N;i++) push(i, 0);
 while(!empty())
 {
//  printf("PASS ");
  crs current=pop();
//  printf("%d %d\n", current.name, current.minw);
  dist[current.name]=current.minw;
  for(i=findbegcross(current.name);(i!=-1)&&m[i].beg==current.name;i++)
  {
   if(vis[m[i].end]) continue;
   int endname=ptrs[m[i].end];
   if(pq[endname].minw<min(m[i].wid, current.minw))//ako promenqme...
   {
    pq[endname].minw=min(m[i].wid, current.minw);
    while(endname!=1&&(pq[endname].minw>pq[endname/2].minw))
    {swap(endname, endname/2); endname/=2;}
   }
  }
  vis[current.name]=1;
 }
}

int main()
{
 int i;
 crs t;
 str st;/*
 for (i=0;i<30;i++)
     push(i, rand()%100);
 printf("RES:\n");
 while(!empty())
 {
      t=pop();
      printf("%d %d\n", t.minw, t.name);
 }
 M=20;
 for (i=0;i<M;i++)
 {
      m[i].beg=rand()%10;
      m[i].end=rand()%10;
      m[i].wid=rand()%100;
 }
 qsort(m, M, sizeof(str), cmp);
 int curcross=0;
 printf("RES:\n");
 for (i=0;i<M;i++)
 {
      printf("%d %d %d\n", m[i].beg, m[i].end, m[i].wid);
 }
 printf("ptrs:\n");
 for (i=0;i<10;i++)
 {
      printf("%d %d\n", i, findbegcross(i));
 }        //*/
 scanf("%d%d", &N, &M);
 M*=2;
 for(i=0;i<M;i+=2)
 {
  scanf("%d%d%d", &m[i].beg, &m[i].end, &m[i].wid);
  m[i+1].beg=m[i].end;
  m[i+1].end=m[i].beg;
  m[i+1].wid=m[i].wid;
  //if(m[i].beg>m[i].end){int t=m[i].beg;m[i].beg=m[i].end;m[i].end=t;}
 }
 qsort(m, M, sizeof(str), cmp);
// printf("RES:\n");
// for (i=0;i<=M;i++)
// {
//      printf("%d %d %d\n", m[i].beg, m[i].end, m[i].wid);
// }
// printf("ptrs:\n");
// for (i=1;i<=N;i++)
// {
//      printf("%d %d\n", i, findbegcross(i));
// }
 dijkstra();
// for (i=0;i<=N+1;i++)
//     printf("%d ", dist[i]);
// printf("\n\n\n");
 //
 printf("%d\n", dist[N]);
 return 0;
}
