#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#define min(a,b) ((a)<(b)?(a):(b))
#define max(a,b) ((a)>(b)?(a):(b))

int N;

struct point{
 int x, y;
 float au;
 int name;
};
struct angle{
 int p1;
 int p2;
 float c_cos;
};

int cmppts(const void * a, const void *b)
{
 if(((*(point *)a).au-(*(point *)b).au)<0) return -1;
 else return 1;
}

int cmpang(const void *a, const void *b)
{
 if(((*(angle *)a).c_cos-(*(angle *)b).c_cos)<0.001)
 {
  if(((*(angle *)a).c_cos-(*(angle *)b).c_cos)>-0.001)
  {
   if((*(angle *)a).p1<(*(angle *)b).p1) return -1;
   else return 1;
  }
  else return 1;
 }
 else return -1;
}

double ua(int x, int y)
{
 double d=sqrt(x*x+y*y);
 if(y>=0) return 1-x/d;
 else return 3+x/d;
}

point pts[2048];
angle angles[2048];
int nangles=0;

int main(){
 int x0, y0, x, y, i, j;
 scanf("%d", &N);
 scanf("%d%d", &x0, &y0);
 for(i=0;i<N;i++)
 {
  scanf("%d%d", &x, &y);
  pts[i].x=x-x0;
  pts[i].y=y-y0;
  pts[i].au=ua(x-x0, y-y0);
  pts[i].name=i+1;
 }
// printf("res:\n");
 qsort(pts, N, sizeof(point), cmppts);
/* for(i=0;i<N;i++)
 {
  printf("%d %f\n", pts[i].name, pts[i].au);
 }*/
 for(i=0;i<(N-1);i++)   //do N, posledniq e v drug sluchay!!!
 {
  if((pts[i+1].au-pts[i].au) > 2) continue;
  //else
  angles[nangles].p1=min(pts[i].name, pts[i+1].name);
  angles[nangles].p2=max(pts[i].name, pts[i+1].name);
  double c=sqrt(pts[i+1].x*pts[i+1].x+pts[i+1].y*pts[i+1].y);
  double b=sqrt(pts[i].x*pts[i].x+pts[i].y*pts[i].y);
  double a=sqrt((pts[i].x-pts[i+1].x)*(pts[i].x-pts[i+1].x)
                +(pts[i].y-pts[i+1].y)*(pts[i].y-pts[i+1].y));
  angles[nangles].c_cos=(b*b+c*c-a*a)/(2*c*b);
  nangles++;
 }
 if((pts[N-1].au-pts[0].au) > 2){
  angles[nangles].p1=min(pts[N-1].name, pts[0].name);
  angles[nangles].p2=max(pts[N-1].name, pts[0].name);
  double c=sqrt(pts[0].x*pts[0].x+pts[0].y*pts[0].y);
  double b=sqrt(pts[N-1].x*pts[N-1].x+pts[N-1].y*pts[N-1].y);
  double a=sqrt((pts[N-1].x-pts[0].x)*(pts[N-1].x-pts[0].x)
                +(pts[N-1].y-pts[0].y)*(pts[N-1].y-pts[0].y));
  angles[nangles].c_cos=(b*b+c*c-a*a)/(2*c*b);
  nangles++;
 }
 //printf("res2\n");
 qsort(angles, nangles, sizeof(angle), cmpang);
 for(i=0;i<nangles;i++)
  printf("%d %d\n", angles[i].p1, angles[i].p2);
 return 0;
}
