#include <stdio.h>

#define MAXN	16

long long t[MAXN][MAXN][MAXN];
int n, k;

void find(int s, int l, int r) {
	int i;

	if (t[s][l][r] != -1)
		return;

	t[s][l][r] = 0;
	for (i = 1; i <= s; i++) {
		find(i-1, l+s-i, r);
		t[s][l][r] += t[i-1][l+s-i][r];
	}
	for (i = 1; i <= l; i++) {
		find(s+l-i, i-1, r-1);
		t[s][l][r] += t[s+l-i][i-1][r-1];
	}
}

int main() {
	int i, j, l;
	
	scanf("%d%d", &n, &k);
	for (i = 0; i < MAXN; i++)
		for (j = 0; j < MAXN; j++)
			for (l = 0; l < MAXN; l++)
				t[i][j][l] = -1;

	t[0][0][0] = 1;
	t[1][0][0] = 1;
	t[0][1][1] = 1;
	t[0][1][0] = 0;
	for (i = 0; i < MAXN; i++)
		for (j = 1; j < MAXN; j++)
			t[i][j][0] = 0;
			
	for (l = 1; l < MAXN; l++) {
		t[0][0][l] = 0;
		t[1][0][l] = 0;
	}


	find(n, 0, k);

	printf("%Li\n", t[n][0][k]);

	return 0;
}
