#include <stdlib.h>
#include <stdio.h>
#define N 100

struct point {long x,y; int num; float comp;};
point k1[N], k2[N], k3[N], k4[N], points[N];
struct angle {int i; int j; float comp;};
angle angles[N];
long x,y;
int n,j,k1i=0,k2i=0,k3i=0,k4i=0,i=0;

 int comp(const void *a, const void *b);
 void merge(void);

int main()
{
 scanf("%d", &n);

 for (j=0; j<n; j++)
  {
   scanf("%ld %ld", &x,&y);
   if (y>=0) if (x>=0) {k1[k1i].x=x; k1[k1i].y=y; k1[k1i].num=j; k1[k1i].comp=y/x; k1i++;}
	     else {k2[k2i].x=x; k2[k2i].y=y; k2[k2i].num=j; k2[k2i].comp=y/x; k2i++;}
   else if (x<0) {k3[k3i].x=x; k3[k3i].y=y; k3[k3i].num=j; k3[k3i].comp=-y/x; k3i++;}
	else {k4[k4i].x=x; k4[k4i].y=y; k4[k4i].num=j; k4[k4i].comp=y/x; k4i++;};
  }

 qsort(k1,k1i,sizeof(point),comp);
 qsort(k2,k2i,sizeof(point),comp);
 qsort(k3,k3i,sizeof(point),comp);
 qsort(k4,k4i,sizeof(point),comp);

 merge();

 for (i=0; i<n-1; i++)
  {
   angles[i].i=points[i].num;
   angles[i].j=points[i+1].num;
   angles[i].comp=(points[i].y/points[i].x-points[i+1].x/points[i+1].y)/
		 (1+(points[i].y/points[i].x)*(points[i+1].x/points[i+1].y));
  }

 angles[n-1].i=points[n].num;
 angles[n-1].j=points[0].num;
 angles[n-1].comp=(points[n].y/points[n].x-points[0].x/points[0].y)/
		  (1+(points[n].y/points[n].x)*(points[0].x/points[0].y));

  qsort(angles,n,sizeof(angle),comp);

 for (i=0; i<n; i++)
  printf("%d %d\n", angles[i].i, angles[i].j);

 return 0;
}

 int comp(const void *a, const void *b)
 {
  return ((point *)a)->comp-((point *)b)->comp;
 }

 void merge(void)
 {
  int j;

  for (j=0; j<k1i; j++) {points[i]=k1[j]; i++;};
  for (j=0; j<k2i; j++) {points[i]=k2[j]; i++;};
  for (j=0; j<k3i; j++) {points[i]=k3[j]; i++;};
  for (j=0; j<k4i; j++) {points[i]=k4[j]; i++;};
 }