#include <stdio.h>
#include <string.h>

#define maxw 65000
#define maxn 10000

struct rebro
{
 int to;
 unsigned int w;
 rebro* next;
};

struct node
{
 int vis;
 unsigned m;
 rebro* sp;
};

long n,m;
node gr[maxn];

unsigned int ma,mc;

void alldfs(int);

int main()
{
// freopen("fast.in","r",stdin);
 scanf("%ld%ld",&n,&m);
 memset(gr,0,maxn*sizeof(node));
 ma=mc=0;

 int x,y;
 unsigned w;
 int i,j;
 rebro* r;
 for(i=0;i<m;i++)
  {
   scanf("%d%d%u",&x,&y,&w);
   r=new rebro;
   r->to=--y;
   r->next=gr[--x].sp;
   r->w=w;
   gr[x].sp=r;
   r=new rebro;
   r->to=x;
   r->w=w;
   r->next=gr[y].sp;
   gr[y].sp=r;
  }
 gr[0].m=maxw;

 alldfs(0);

 printf("%u",gr[n-1].m);

 for(i=0;i<n;i++)
  {
   r=gr[i].sp;
   while(r!=NULL)
    {
     gr[i].sp=r->next;
     delete r;
     r=gr[i].sp;
    }
  }

 return 0;
}

void alldfs(int i)
{
 if(i==n-1){if(mc>gr[n-1].m)gr[n-1].m=mc;return;}
 if(i!=0)gr[i].m=mc;
 gr[i].vis=1;
 rebro*r;
 r=gr[i].sp;
 while(r!=NULL)
  {
   if(!gr[r->to].vis)
    {
     if(r->w<mc)mc=r->w;
     alldfs(r->to);
     mc=gr[i].m;
    }
   r=r->next;
  }
 gr[i].vis=0;
}