/*
NAME : Rostislav
PROG : rays
LANG : C
*/
#include <stdio.h>
#include <math.h>
#define pi 3.14159265358979323846
#define eps 0.0000000000001

 struct point
  {
   double ang;
   long x,y,ind;
  }heap[2048],a[2048],tmp;

 long n,c;

 double angle (long i)
  {
   double k;
   k=atan2(a[i].y-a[0].y,a[i].x-a[0].x);
   if (k>=0)
    return (k*180)/pi;
     else
      return 360+(k*180)/pi;
  }

 long check (long a,long b)
  {
   if (heap[a].ang>heap[b].ang || (heap[a].ang==heap[b].ang && (heap[a].x>heap[b].x || (heap[a].x==heap[b].x && heap[a].y>heap[b].y))))
    return 0;
     else
      return 1;
  }

 void add (struct point z)
  {
   long i;
   heap[++c]=z;
   i=c;
   while (i!=1)
    if (check(i/2,i)==0)
     {
      tmp=heap[i];
      heap[i]=heap[i/2];
      heap[i/2]=tmp;
      i/=2;
     }
      else
       break;
  }

 void del ()
  {
   long i,v;
   heap[1]=heap[c--];
   i=1;
   while (i*2<=c)
    {
     v=i*2;
     if (v!=c && check(v,v+1)==0)
      v++;
     if (check(i,v)==0)
      {
       tmp=heap[i];
       heap[i]=heap[v];
       heap[v]=tmp;
       i=v;
      }
       else
        break;
    }
  }

 int main ()
  {
   long i;
   scanf("%ld",&n);
   if (n==2)
    {
     printf("1 2\n");
     exit (0);
    }
   for (i=0;i<=n;i++)
    scanf("%ld%ld",&a[i].x,&a[i].y);
   for (i=1;i<=n;i++)
    {
     a[i].ang=angle(i);
     a[i].ind=i;
    }
   c=0;
   for (i=1;i<=n;i++)
    add(a[i]);
   for (i=1;i<=n;i++)
    {
     a[i]=heap[1];
     del();
    }
   c=0;
   for (i=2;i<=n;i++)
    if (a[i].ang-a[i-1].ang<180-eps)
     {
      tmp.ang=a[i].ang-a[i-1].ang;
      if (a[i].ind>a[i-1].ind)
       {
        tmp.x=a[i-1].ind;
        tmp.y=a[i].ind;
       }
        else        
         {
          tmp.y=a[i-1].ind;
          tmp.x=a[i].ind;
         }
      add(tmp);
     }
   if (a[1].ang+360-a[n].ang<180-eps)
    {
     tmp.ang=a[1].ang+360-a[n].ang;
     if (a[n].ind>a[1].ind)
      {
       tmp.x=a[1].ind;
       tmp.y=a[n].ind;
      }
       else
        {
         tmp.y=a[1].ind;
         tmp.x=a[n].ind;
        }
     add(tmp);
    }
   while (c!=0)
    {
     printf("%ld %ld\n",heap[1].x,heap[1].y);
     del();
    }    
   return 0;
  }
