program rays;
 var
  n: Word;
  a: array[0..2000, 1..2] of Longint;
  res: array[1..4000] of record
                            i1, i2: Word;
                            value: Real;
                           end;
  i, j, k, free: Word;
  have: Boolean;

  procedure inp;
   var
    i: Word;
   begin
    readln(n);
    for i := 0 to N do
     readln(a[i][1], a[i][2]);
   end;

  function angle(f1, f2, o1, o2, s1, s2: Longint): Real;
   var
    a, b, c: Real;
   begin
    a := sqrt( sqr( abs(f1 - o1) ) + sqr( abs(f2 - o2) ) );
    b := sqrt( sqr( abs(s1 - o1) ) + sqr( abs(s2 - o2) ) );
    c := sqrt( sqr( abs(f1 - s1) ) + sqr( abs(f2 - s2) ) );
    writeln(a:8:4, b:8:4, c:8:4);
    angle := (sqr(a) + sqr(b) - sqr(c)) / (2*a*b);
   end;

  function findX(x: Longint): Word;
   var
    i, res: Word;
   begin
    res := 0;
    for i := 1 to n do
     if a[i][1] = x then
      begin
       res := i;
       Break;
      end;
    findX := res;
   end;

  function findY(y: Longint): Word;
   var
    i, res: Word;
   begin
    res := 0;
    for i := 1 to n do
     if a[i][2] = y then
      begin
       res := i;
       Break;
      end;
    findY := res;
   end;

  procedure SearchAngle(code: Byte; ind: Word);
   var
    i: LongInt;
    fx, fy: Word;
    ready: Boolean;
   begin
    ready := False;

    if code = 1 then
     begin
      for i := a[ind][1] downto -100000 do
       begin
        fx := findX(i);
        if fx <> 0 then
         if ((a[0][2] > a[ind][2]) and (a[fx][2] > a[ind][2])) or ((a[0][2] < a[ind][2]) and (a[fx][2] < a[ind][2])) then
          begin
           res[free].i1 := (ind + fx + abs(ind - fx)) div 2;
           res[free].i2 := (ind + fx - abs(ind - fx)) div 2;
           res[free].value := Angle(a[ind][1], a[ind][2], a[0][1], a[0][2], a[fx][1], a[fx][2]);
           free := free + 1;
           ready := True;
           Break;
          end;
       end;
     end;

    if code = 2 then
     begin
      for i := a[ind][2] to 100000 do
       begin
        fx := findY(i);
        if fx <> 0 then
         if ((a[0][1] > a[ind][1]) and (a[fx][1] > a[ind][1])) or ((a[0][1] < a[ind][1]) and (a[fx][1] < a[ind][1])) then
          begin
           res[free].i1 := (ind + fx + abs(ind - fx)) div 2;
           res[free].i2 := (ind + fx - abs(ind - fx)) div 2;
           res[free].value := Angle(a[ind][1], a[ind][2], a[0][1], a[0][2], a[fx][1], a[fx][2]);
           free := free + 1;
           ready := True;
           Break;
          end;
       end;
     end;

    if code = 3 then
     begin
      for i := a[ind][1] to 100000 do
       begin
        fx := findX(i);
        if fx <> 0 then
         if ((a[0][2] > a[ind][2]) and (a[fx][2] > a[ind][2])) or ((a[0][2] < a[ind][2]) and (a[fx][2] < a[ind][2])) then
          begin
           res[free].i1 := (ind + fx + abs(ind - fx)) div 2;
           res[free].i2 := (ind + fx - abs(ind - fx)) div 2;
           res[free].value := Angle(a[ind][1], a[ind][2], a[0][1], a[0][2], a[fx][1], a[fx][2]);
           free := free + 1;
           ready := True;
           Break;
          end;
       end;
     end;

    if code = 4 then
     begin
      for i := a[ind][2] downto -100000 do
       begin
        fx := findY(i);
        if fx <> 0 then
         if ((a[0][2] > a[ind][2]) and (a[fx][2] > a[ind][2])) or ((a[0][2] < a[ind][2]) and (a[fx][2] < a[ind][2])) then
          begin
           res[free].i1 := (ind + fx + abs(ind - fx)) div 2;
           res[free].i2 := (ind + fx - abs(ind - fx)) div 2;
           res[free].value := Angle(a[ind][1], a[ind][2], a[0][1], a[0][2], a[fx][1], a[fx][2]);
           free := free + 1;
           ready := True;
           Break;
          end;
       end;
     end;

    if not ready then
     if code < 4 then SearchAngle(code + 1, ind)
    else
     SearchAngle(code, fx);
   end;

 begin
  inp;
  free := 1;
{  for i := 1 to n do
   for j := i+1 to n do
    begin
     have := false;
     for k := 1 to n do
      if a[i] <> [k]
    end;}

  writeln('Searching...');

  SearchAngle(1, 1);

  for i := 1 to free-1 do
   writeln(i, '.  ', res[i].i1, ' ', res[i].i2, ' - ', res[i].value:8:6);

  writeln('Search finished.');

{  writeln(angle(a[1][1], a[1][2], a[0][1], a[0][2], a[2][1], a[2][2]):8:6);}
  readln;
 end.