#include<stdio.h>
#include<values.h>
#define min(x,y) (((x)<(y))?(x):(y))

long **gr;
long N,M;
char *visited;
unsigned **w;

int load() {
 long a,b,c;
   scanf("%ld",&N);
   scanf("%ld",&M);


   gr=new (long**)[N];
   //if (gr==NULL) return 1;
   for (int x=0;x<N;x++) {
      gr[x]=new long[N];
      if (gr[x]==NULL) return 1;
   }

   w=new (unsigned**)[N];
   //if (gr==NULL) return 1;
   for (int x3=0;x3<N;x3++) {
      w[x3]=new unsigned[N];
      if (w[x3]==NULL) return 1;
   }

   visited=new char[N+1];
   if (visited==NULL) return 1;

   for (int x1=0;x1<N;x1++)
      for (int x2=0;x2<N;x2++) {
	gr[x1][x2]=0;
	w[x1][x2]=MAXINT;
      }

   for (int i=0;i<M;i++) {
      scanf("%ld %ld %ld",&a,&b,&c);
      gr[a][b]=c;
      gr[b][a]=c;
   }
   for (int ix=0;ix<N;ix++) visited[ix]=0;
   return 0;
}
void freeRAM() {
   for (int x=0;x<N;x++)
      delete gr[x];
   delete gr;
   for (int x1=0;x1<N;x1++)
      delete w[x1];
   delete w;

   delete visited;
}
void doit(int n) {
   for (int i=1;i<=N;i++) {
      if (n==i) continue;
      if (gr[n][i]==0) continue;
      if (visited[i]!=0) continue;
      visited[i]=1;
      w[n][i]=min(w[n][i],gr[n][i]);
      w[i][n]=min(w[i][n],gr[i][n]);
      doit(i);
      visited[i]=0;

   }
}
void main() {
/*
   freopen("fast.inp","r",stdin);
   if (load()==1) {
      printf("0\n");
      freeRAM();
      return;
   }
   fclose(stdin);
   visited[1]=1;
   doit(1);
   printf("%u",w[1][N]);
   freeRAM();
*/
   printf("0\n");
}