#include <stdio.h>

#define MAX 100

unsigned int n;
unsigned int climbs;
unsigned int perms = 0;
unsigned int mp[MAX];
unsigned int used[MAX];

void print_permutation ()
{
    unsigned int i;
    unsigned int count = 0;

    for ( i = 1; i < n; i++ )
        if ( mp[i] > mp[i-1] )
            count++;

    if ( count == climbs ) {
        perms++;
    }
};

void permute ( unsigned int k )
{
    unsigned int i;
    
    if ( k >= n ) {
        print_permutation ();
        return;
    }
    for ( i = 0; i < n; i++ ) {
        if ( !used[i] ) {
            used[i] = 1;
            mp[k] = i;
            permute ( k + 1 );
            used[i] = 0;
        }
    }
};

main ()
{
    unsigned int i;
    printf ( "number: " );
    scanf ( "%u", &n );
    printf ( "clibms: " );
    scanf ( "%u", &climbs );
    for ( i = 0; i < n; i++ )
        used[i] = 0;

    permute ( 0 );
    printf ( "all: %u\n", perms );
    getch ();

    return 0;
}
