#include <cstdio>
#include <vector>

class street
{
public:
	street(int a = 0, int b = 0) : to(a), width(b) {}

	int to;
	int width;
};

int main()
{
	int N, M, I, J, W;
	std::scanf("%d %d", &N, &M);
	std::vector<int> best(N, 0);
	std::vector<std::vector<street> > graph(N);
	for (int i = 0; i < M; i++)
	{
		std::scanf("%d %d %d", &I, &J, &W);
		graph[I-1].push_back(street(J-1, W));
		graph[J-1].push_back(street(I-1, W));
	}

	bool flag = true;
	best[0] = 65000;

	for (int i = 0; i < N-1; i++)
		for (int j = 0; j < graph[i].size(); j++)
			if (best[graph[i][j].to] < (best[i]<graph[i][j].width ? best[i] : graph[i][j].width))
				best[graph[i][j].to] = (best[i]<graph[i][j].width ? best[i] : graph[i][j].width);

	std::printf("%d", best[N-1]);

	return 0;
}
