/*
123
132
213
231
312
321

12
21

3412
3124

1342
1324

2341
2314

2413
2134

f (x, y) = 0									x = 1, y != 0
f (x, y) = 1                                    y = 0
f (x, y) = 0					     			x <= y
f (x, y) = 1									x = y + 1
f (x, y) = (y+1)*f(x-1, y) + (x-y)*f(x-1, y-1)

(1) f (1, 0) = 1
(1) f (2, 0) = 1
(1) f (2, 1) = 1
(1) f (3, 0) = 1
(4) f (3, 1) = 2*f(2, 1) + 2*f(2, 0) = 2*1 + 2*1 = 4
(1) f (3, 2) = 1


   00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 Y
00 00
01 01
02 01 01
03 01 04 01
04 01       01
05 01          01
06 01             01
07 01                01
08 01                   01
09 01                      01
10 01                         01
11 01                            01
12 01                               01
13 01                                  01
14 01                                     01
15 01                                        01

X
*/

#include <cstdio>

unsigned int table[16][16];

int main()
{
	table[0][0] = 0;
	for (int i = 1; i < 16; i++)
	{
		table[i][i] = 0;
		table[i][i-1] = 1;
		table[i][0] = 1;
	}

	for (int i = 3; i < 16; i++)
		for (int j = 1; j < i-1; j++)
			table[i][j] = (j+1)*table[i-1][j] + (i-j)*table[i-1][j-1];

	int n, k;
	std::scanf("%d %d", &n, &k);
	std::printf("%u\n", table[n][k]);

	return 0;
}
