#include <stdio.h>
#include <iostream.h>

#define MAXN 10000
unsigned n;
unsigned long k;
unsigned A[MAXN][MAXN];
unsigned len[MAXN];
int savePath[MAXN], maxDist[MAXN];
void input(void)
{ cin >> n >> k;
  unsigned long i;
  unsigned  x, y, w;
  for(i=0; i < k; i++)
  { cin >> x >> y >> w;
    A[x][y] = w;
    len[i] = w;
  }
}
void DFS(unsigned i)
{ int max, d;
  unsigned j;
  if (maxDist[i] > 0) return;
  max = maxDist[i];
  for (j = 0; j < n; j++)
    if (A[i][j]) {
      DFS(j);
      d = maxDist[j] + A[i][j];
      if (d > max) {
        max = d;
        savePath[i] = j;
      }
    }

  maxDist[i] = max;
}

void solve(void)
{ unsigned i, maxi;
  for (i = 0; i < n; i++) {
    maxDist[i] = 0;
    savePath[i] = -1;
  }

  for (i = 0; i < n; i++)
    if (maxDist[i] == 0) DFS(i);

  maxi = 0;
  for (i = 0; i < n; i++)
    if (maxDist[i] > maxDist[maxi]) maxi = i;
   unsigned long min = 2000000;
  while (savePath[maxi] >= 0) {
    if (len[maxi]<min) min = len[maxi];
    maxi = savePath[maxi];
  }
      if (len[maxi]<min) min = len[maxi];
      cout << min << endl;
}

int main(void)
{ input();
  solve();
  return 0;
}
