#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#define MAX 2222

int cal(int ii);
int pos(int ii, int pp);
void calc(int ii, int pp);
int cmp1(const void *e1, const void *e2);
int cmp2(const void *e1, const void *e2);

struct aaa
{
 int i;
 long x;
 long y;
} p[MAX];

int forw[MAX];
int back[MAX];

struct bbb
{
 double cos;
 int in1;
 int in2;
} ang[MAX];

int n,br;

int main()
{int i,pp;
 long a,b;

 scanf("%d%ld%ld",&n,&a,&b);
 for(i=0; i<n; i++)
  {
  scanf("%ld%ld",&p[i].x,&p[i].y);
  p[i].x-=a;
  p[i].y-=b;
  p[i].i=i;
  forw[i]=back[i]=0;
  }
 qsort(p,n,sizeof(p[0]),cmp1);
 br=0;
 for(i=0; i<n; i++)
  {
  pp=i+1;
  if(pos(i,(i+1)%n)) pp=cal(i);
  i=pp-1;
  }
 qsort(ang,br,sizeof(ang[0]),cmp2);
 for(i=0; i<br; i++) printf("%d %d\n",ang[i].in1+1,ang[i].in2+1);
return 0;
}

int cmp2(const void *e1, const void *e2)
{
 struct bbb *aa;
 struct bbb *bb;
 struct bbb a,b;

 aa=(struct bbb *)e1;
 bb=(struct bbb *)e2;
 a=*aa;
 b=*bb;
 if(a.cos<b.cos) return 1;
 if(a.cos>b.cos) return 0;
 if(a.in1<b.in1) return 0;
 if(a.in1>b.in1) return 1;
 if(a.in2<b.in2) return 0;
 if(a.in2>b.in2) return 1;
 printf("ohaa!\n");
 return 0;
}

int cal(int ii)
{int i,pp,cnt,beg1,beg2,end1,end2;

 beg1=end1=ii;
 end2=beg2=(ii+1)%n;
 cnt=0;
 while((back[p[beg1].i])&&(cnt<n)) {beg1=(beg1+n-1)%n; cnt++;}
 cnt=0;
 while((forw[p[end2].i])&&(cnt<n)) {end2=(end2+1)%n; cnt++;}
 for(i=beg1; i<=end1; i++)
  for(pp=beg2; pp<=end2; pp++) calc(i,pp);
 if(end2<=beg1) return n; else return end2;
}

void calc(int ii, int pp)
{
 double a,b,c,aa,bb,cc,su;
 a=pow(p[ii].x*p[ii].x+p[ii].y*p[ii].y,0.5);
 b=pow(p[pp].x*p[pp].x+p[pp].y*p[pp].y,0.5);
 c=pow(pow(p[ii].x-p[pp].x,2)+pow(p[ii].y-p[pp].y,2),0.5);
 aa=a*a;
 bb=b*b;
 cc=c*c;
 su=aa+bb;
 su=su-cc;
 ang[br].cos=su/(2.*a*b);
 if(p[ii].i<p[pp].i)
   {
   ang[br].in1=p[ii].i;
   ang[br].in2=p[pp].i;
   }else
   {
   ang[br].in1=p[pp].i;
   ang[br].in2=p[ii].i;
   }
 br++;
}

int cmp1(const void *e1, const void *e2)
{
 struct aaa *aa;
 struct aaa *bb;
 struct aaa a,b;
 int kva,kvb;

 aa=(struct aaa *)e1;
 bb=(struct aaa *)e2;
 a=*aa;
 b=*bb;

 if((a.x>0)&&(a.y>=0)) kva=0;
 if((a.x<=0)&&(a.y>0)) kva=1;
 if((a.x<0)&&(a.y<=0)) kva=2;
 if((a.x>=0)&&(a.y<0)) kva=3;
 if((b.x>0)&&(b.y>=0)) kvb=0;
 if((b.x<=0)&&(b.y>0)) kvb=1;
 if((b.x<0)&&(b.y<=0)) kvb=2;
 if((b.x>=0)&&(b.y<0)) kvb=3;

 if(kva<kvb) return 0;
 if(kva>kvb) return 1;
 if((kva==0)||(kva==2))
   {
   if((!a.y)&&(b.y)) return 0;
   if((a.y)&&(!b.y)) return 1;
   if((!a.y)&&(!b.y))
     {
     forw[a.i]=1;
     back[b.i]=1;
     return 0;
     }
   if((double)a.x/(double)a.y>(double)b.x/(double)b.y) return 0;
   if((double)a.x/(double)a.y<(double)b.x/(double)b.y) return 1;
   if((double)a.x/(double)a.y==(double)b.x/(double)b.y)
     {
     forw[a.i]=1;
     back[b.i]=1;
     return 0;
     }
   }
 if((double)a.x/(double)a.y>(double)b.x/(double)b.y) return 0;
 if((double)a.x/(double)a.y<(double)b.x/(double)b.y) return 1;
 if((double)a.x/(double)a.y==(double)b.x/(double)b.y)
   {
   forw[a.i]=1;
   back[b.i]=1;
   return 0;
   }
}

int pos(int ii, int pp)
{
 if(p[ii].x*p[pp].y-p[pp].x*p[ii].y>0) return 1; else return 0;
}
