#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#define MAX_N 2010

struct TPoint{
 int index,index2;
 int x,y;
 int x2,y2;
 double cosx;
};

struct TPoint mas[MAX_N],res[MAX_N];


int n;
int count=0;

int compare2(const void *a, const void *b);
int compare(const void *a, const void *b);
double dist1(int x1, int y1, int x2, int y2);
double dist2(int x1, int y1, int x2, int y2);
double area(int x1, int y1, int x2, int y2, int x3, int y3);
void Swap(int *a, int *b);

int main(void){
 int i;

// freopen("rays.in","r",stdin);
 scanf("%d", &n);
 for(i=0; i<=n; i++){
  scanf("%d %d", &mas[i].x, &mas[i].y);
  mas[i].index=i;
 }

 mas[1].cosx=10;

 for(i=2; i<=n; i++){
  if(area(mas[1].x,mas[1].y,mas[0].x,mas[0].y,mas[i].x,mas[i].y)<=0){
   mas[i].cosx=(-dist1(mas[1].x,mas[1].y,mas[i].x,mas[i].y)+ dist1(mas[1].x,mas[1].y,mas[0].x,mas[0].y)+ dist1(mas[0].x,mas[0].y,mas[i].x,mas[i].y))/
               (2*dist2(mas[1].x,mas[1].y,mas[0].x,mas[0].y)*dist2(mas[i].x,mas[i].y,mas[0].x,mas[0].y));
  }
  else{
   mas[i].cosx=-5-((-dist1(mas[1].x,mas[1].y,mas[i].x,mas[i].y)+ dist1(mas[1].x,mas[1].y,mas[0].x,mas[0].y)+ dist1(mas[0].x,mas[0].y,mas[i].x,mas[i].y))/
               (2*dist2(mas[1].x,mas[1].y,mas[0].x,mas[0].y)*dist2(mas[i].x,mas[i].y,mas[0].x,mas[0].y)));
  }
 }

 qsort(mas+1,n,sizeof(struct TPoint), compare);

 for(i=1; i<n; i++){
  res[count]=mas[i];
  res[count].index=mas[i].index;
  res[count].index2=mas[i+1].index;
  if(res[count].index > res[count].index2) continue;//Swap(&res[count].index, &res[count].index2);
  res[count].x2=mas[i+1].x; res[count].y2=mas[i+1].y;
  res[count].cosx=((-dist1(res[count].x,res[count].y,res[count].x2,res[count].y2)+ dist1(res[count].x,res[count].y,mas[0].x,mas[0].y)+ dist1(mas[0].x,mas[0].y,res[count].x2,res[count].y2))/
               (2*dist2(res[count].x,res[count].y,mas[0].x,mas[0].y)*dist2(res[count].x2,res[count].y2,mas[0].x,mas[0].y)));

  if(res[count].cosx==1) continue;
  count++;
 }

 qsort(res,n-1,sizeof(struct TPoint), compare2);

 for(i=0; i<count; i++){
  printf("%d %d\n", res[i].index, res[i].index2);
 }

 return 0;
}

int compare2(const void *a, const void *b){
 if(((struct TPoint *)a)->cosx > ((struct TPoint *)b)->cosx) return -1;
 else
  if(((struct TPoint *)a)->cosx < ((struct TPoint *)b)->cosx) return +1;
  else{
   if(((struct TPoint *)a)->index > ((struct TPoint *)b)->index) return 1;
   else
      if(((struct TPoint *)a)->index < ((struct TPoint *)b)->index) return -1;
      else{
        if(((struct TPoint *)a)->index2 > ((struct TPoint *)b)->index2) return 1;
        else return -1;
      }
  }
}

int compare(const void *a, const void *b){
 if(((struct TPoint *)a)->cosx > ((struct TPoint *)b)->cosx) return -1;
 else
  if(((struct TPoint *)a)->cosx < ((struct TPoint *)b)->cosx) return 1;
  else return 0;
}

double dist1(int x1, int y1, int x2, int y2){
 return ((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2));
}

double dist2(int x1, int y1, int x2, int y2){
 return sqrt(((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2)));
}

double area(int x1, int y1, int x2, int y2, int x3, int y3){
 return (x1*y2+y1*x3+x2*y3-x3*y2-y3*x1-x2*y1)/2.0;
}

void Swap(int *a, int *b){
 int tmp;

 tmp=*a; *a=*b; *b=tmp;
}

