type
    dot                 = record
                                x,y     : real
                          end;
    pro                 = record
                                a,b     : integer;
                                ed      : real;
                          end;
var
   M    : array[0..2000] of dot;
   i,j,N  : integer;
   F    : array[1..2000] of real;
   OT   : array[1..2000] of integer;
   EXN  : array[1..2000] of pro;


procedure trancl;
          begin
               for i := 2 to N+1 do
                   begin
                        M[i].x:=M[i].x-M[1].x;
                        M[i].y:=M[i].y-M[1].y;
                   end;
               M[1].x:=0;
               M[1].y:=0;
          end;

function CE(p   : dot) : real;
         var
            x,d,YY      : real;
         begin
              x:=(p.x)/(sqrt((p.x*p.x)+(p.y*p.y)));
              if (x=0) or (x=-1) then
                 begin
                      if (p.x>0) and (p.y=0) then
                         YY:=0;
                      if (p.x<0) and (p.y=0) then
                         YY:=pi;
                      if (p.x=0) and (p.y>0) then
                         YY:=pi/2;
                      if (p.x=0) and (p.y<0) then
                         YY:=pi+(pi/2)
                 end
              else
                  begin
                        d:=(sqrt(1-x*x))/x;
                        YY:=arctan(d);

                       if (p.x<0) and (p.y>0) then
                          YY:=YY+pi;
                       if (p.x<0) and (p.y<0) then
                          YY:=YY+pi;
                       if (p.x>0) and (p.y<0) then
                          YY:=YY+2*pi;
                  end;

              CE:=YY;
         end;

procedure do_F;
          begin
               for i := 2 to N+1 do
                   begin
                        F[i]:=CE(M[i]);
                        OT[i]:=i;
                       { writeln(F[i]:5:5);}
                   end;

          end;

procedure read_inp;
          begin
                M[0].x:=1;
                M[0].y:=0;
                readln(n);
                for i := 1 to N+1 do
                    readln(M[i].x,M[i].y);
          end;

procedure qsort;

          procedure sort(l,r: integer);
                    var
                       i,j,y: integer;
                       x        : real;
                       buf      : real;
                       p        : integer;
                    begin
                         i:=l;
                         j:=r;
                         x:=F[(l+r)div 2];
                         repeat
                               while F[i]<x do
                                     i:=i+1;
                               while x<F[j] do
                                     j:=j-1;
                               if i<=j then
                                  begin
                                       buf:=F[i];
                                       F[i]:=F[j];
                                       F[j]:=buf;
                                       p:=OT[i];
                                       OT[i]:=OT[j];
                                       OT[j]:=p;

                                       i:=i+1; j:=j-1;
                                  end;
                         until i>j;
                         if l<j then
                            sort(l,j);
                         if i<r then
                            sort(i,r);
                    end;
          begin
               sort(2,N+1);
          end;

procedure qsort2;

          procedure sort(l,r: integer);
                    var
                       i,j,y: integer;
                       x        : real;
                       p        : pro;
                    begin
                         i:=l;
                         j:=r;
                         x:=exn[(l+r)div 2].ed;
                         repeat
                               while exn[i].ed<x do
                                     i:=i+1;
                               while x<exn[j].ed do
                                     j:=j-1;
                               if i<=j then
                                  begin
                                       p:=exn[i];
                                       exn[i]:=exn[j];
                                       exn[j]:=p;

                                       i:=i+1; j:=j-1;
                                  end;
                         until i>j;
                         if l<j then
                            sort(l,j);
                         if i<r then
                            sort(i,r);
                    end;
          begin
               sort(2,N+1);
          end;


begin
     read_inp;
     trancl;
     do_F;
     qsort;
     for i := N+1 downto 3 do
         begin
                      exn[i].ed :=(F[i]-F[i-1]);
                      if (OT[i-1]<OT[i]) then
                         begin
                              exn[i].a  :=OT[i-1];
                              exn[i].b  :=OT[i];
                         end
                      else
                          begin
                               exn[i].a :=OT[i];
                               exn[i].b :=OT[i-1];
                          end;
         end;
     for i := 3 to N+1 do
         begin
              if (exn[i].ed>pi) then
                 exit;
              writeln(exn[i].a-1,' ',exn[i].b-1);
         end;
end.