#include <iostream.h>

struct bin
{ bool visited;
  int dist;
} air[1000];
int a[1000][1000];
int n,max;
long m;

void init()
{ long i;
  int j,x,y;
  cin>>n>>m;
  for(i=0;i<=n+1;i++)
    for(j=0;j<=n+1;j++)
      a[i][j]=0;
  for(i=1;i<=m;i++)
    { cin>>x>>y; a[x][y]=a[y][x]=1; }
}

void dfs(int u)
{ int v;
  air[u].visited=1;
  for(v=1;v<=n;v++)
    if(!air[v].visited && a[u][v])
      { if(air[v].dist==0)
          { air[v].dist=air[u].dist+1; dfs(v);  }
        else
          if(air[v].dist>air[u].dist+1)
            { air[v].dist=air[u].dist+1; dfs(v);  }
      }
}

void main()
{ int i,j;

  init();
  max=0;
  for(i=1;i<=n;i++)
    { for(j=1;j<=n;j++)
        { air[j].visited=0; air[j].dist=0; }
      dfs(i);
      int w=0;
      for(j=1;j<=n;j++)
        if(air[j].dist>w) w=air[j].dist;
      if(w>max) max=w;
    }
  cout<<max-2<<endl;
}
