#include <iostream>
using namespace std;
struct node
{
	short int d;
	bool v;
};

unsigned short int N, x, y;
int start,end;
unsigned int M;
node* port;								// 0
unsigned short int list[1000][1000];	// 1
unsigned short int queue[100000];				// 1
bool computed= false;
inline short Get()
{
	if (start<end)
		return queue[start++];
	else
		return-1;
}
inline void Put(unsigned short val)
{
	queue[end++]=val;
}

unsigned int Solve(unsigned int pos)
{
	int curmax=0;
	for(int a=1;a<=list[pos][0];++a)
		if(!port[list[pos][a]-1].v)
		{
			port[list[pos][a]-1].v=true;
			port[list[pos][a]-1].d=port[pos].d+1;
			Put(list[pos][a]-1);
			++end;
		}
	int g;
	while((g=Get())!=-1)
		curmax=Solve(g);
	
	if ((start=end)&&(!computed))
	{
		computed=true;
		for(int c=0;c<N;++c)
			curmax=curmax>port[c].d?curmax:port[c].d;
	}
 	return curmax;
}

unsigned int Dist()
{	
	unsigned int maxdist=0,curdist;
	for(int a=0;a<N;++a)
	{
		port[a].d=0;
		port[a].v=true;
		curdist = Solve(a);
		maxdist = maxdist>curdist?maxdist:curdist;
		computed=false;
		start=end=0;
		memset(port,0,sizeof(node)*N);
		memset(queue,0,sizeof(int)*1001);
	}

	return maxdist;
}

int main(int argc, char* argv[])
{
	cin >> N >> M;
	port = new node[N];
	memset(port,0,sizeof(node)*N);
	memset(list,0,sizeof(short int)*1000*1000);
	memset(queue,0,sizeof(int)*1001);
	for(int a=0;a<M;++a)
	{
		cin >> x >> y;
		++list[ x-1 ][ 0 ];
		++list[ y-1 ][ 0 ];
		list[ x-1 ][ list[x-1][0] ] = y;
		list[ y-1 ][ list[y-1][0] ] = x;
	}


	cout << Dist()-1;
	return 0;
}