/*

Anton Viktorov Evangelatov
SMG
Sofia
B

*/

#include <iostream>
#include <cmath>

using namespace std;

long X1, X2, X3, X4, Y1, Y2, Y3, Y4;

void Input ()
{
  cin >> X1 >> Y1 >> X2 >> Y2 >> X3 >> Y3 >> X4 >> Y4;
}

long long pointsSquare (long x1, long y1, long x2, long y2)
{
  long long A = abs (y1) - abs (y2) + 1;
  long long B = abs (x2) - abs (x1) + 1;

  long long allPoints = A*B;

  long long nResult = 0;

  if (allPoints % 2 == 0)
    nResult = (allPoints - 2) / 2;
  else
    nResult = (allPoints - 2) / 2 + 1;

  nResult += 2;

  return (allPoints - nResult);
}

long long Solve ()
{
  if (!(X1 < X2 && X2 < X3 &&
        X1 < X4 && X1 < X3 &&
        Y2 < Y3 && Y3 < Y4 &&
        Y2 < Y1 && Y1 < Y4)) return 0;

  long long allPoints = (abs (Y4) - abs (Y2) + 1) *
                        (abs (X3) - abs (X1) + 1);

  allPoints -= pointsSquare (X1, Y4, X4, Y1);
  allPoints -= pointsSquare (X4, Y4, X3, Y3);
  allPoints -= pointsSquare (X2, Y3, X3, Y2);
  allPoints -= pointsSquare (X1, Y1, X2, Y2);

  return allPoints;
}

int main ()
{
  Input ();

  cout << Solve () << '\n';

  return 0;
}

