/*
ID: Galen Terziysky
PROG: AVIO
*/

#include <iostream>
#include <climits>

using namespace std;

struct direct_flight
{
  int airport_a;
  int airport_b;
};

void bubble_sort(int[], int);

int main ()
{
  int N; cin >> N;
  int M; cin >> M;

  direct_flight v[M];

  for (int i = 0; i < M; i++)
    cin >> v[i].airport_a >> v[i].airport_b;

  int min[N][N];
  int a[N][N];
  int result[N*N];

  for (int i = 0; i < N ; i++)
    for (int j = 0; j < N; j++)
      a[i][j] = (INT_MAX/2) - 1;

  for (int i = 0; i < M; i++)
  {
    a[v[i].airport_a][v[i].airport_b] = 1;
    a[v[i].airport_b][v[i].airport_a] = 1;
  }

  for (int i = 0; i < N ; i++)
    for (int j = 0; j < N; j++)
    {
      min[i][j] = a[i][j];
    }

  for (int k = 0; k < N; k++)
    for (int i = 0; i < N ; i++)
      for (int j = 0; j < N; j++)
      {
        if ((min[i][k] + min[k][j]) < min[i][j])
          min[i][j] = min[i][k] + min[k][j];
      }

  int i = 0; int j = 0; int k = 0;

  for (i; i < N; i++)
    for (j; j < N; j++)
    {
      while (k < N*N)
        result[k] = min[i][j];
    }


  bubble_sort(result, (N*N));

  cout << result[N*N] << "\n";

system("pause");
return 0;
}

void bubble_sort(int arr[], int n)
{
   for (int i = 0; i <= n; i++)
     for (int j = 0; j <= n-i-1; j++)
      if (arr[j] > arr[j+1])
      {
	    int tmp = arr[j+1];
		arr[j+1] = arr[j];
		arr[j] = tmp;
      }
}
