#include <stdio.h>
#include <stdlib.h>

#define MAX 1002
#define mval 2002

int comp(const void *i, const void *j)
{
  return *(int *)i - *(int *)j;
}

int main(void)
{
  long N, M, i, j, k, a, b;
  long min[MAX][MAX], m[MAX];

  scanf("%ld%ld", &N, &M);

  for(i=0; i<N; i++)
    for(j=0; j<N; j++)
      min[i][j] = mval;

  for(i=0; i<M; i++)
  {
    scanf("%ld%ld", &a, &b);
    a--;
    b--;
    min[a][b] = 1;
    min[b][a] = 1;
  }

  for(k=0; k<N; k++)          // R. W. Floyd
    for(i=0; i<N; i++)
      for(j=0; j<N; j++)
         if(min[i][j] > (min[i][k] + min[k][j])) min[i][j] = (min[i][k] + min[k][j]);

  k = 0;
  for(i=0; i<N/2; i++)
    for(j=0; j<N/2; j++)
    {
      if(i!=j && min[i][j] != mval)
      {
        m[k] = min[i][j];
        k++;
      }
    }

  qsort(m, k, sizeof(long), comp);
  printf("%ld\n", m[k-1]);

  return 0;
}

