#include <iostream.h>
#include <stdlib.h>

int graph [1000] [1000] , visited [1000];
int m, n, max=1;


void DSF (int i, int score)
{
  visited [i] = 1;
  for(int k=0; k < n; k++)
   if ((graph [i] [k] == 1) && (visited [k] == 0))
   {
    visited [k] = 1;
    if (score + 1 > max) max = score + 1;
    DSF(k, score+1);
    visited [k] = 0;
   }
  visited [i] = 0;
}

int main()
{

  cin >> n >> m;

  for (i=0; i < n; i++)
  {
    visited [i] = 0;
    for (int j=0; j < n; j++)
        graph [i][j] = 0;
  }

  for (i=0; i < m; i++)
  {
    int tmp1, tmp2;
    cin >> tmp1 >> tmp2;

    graph [tmp1-1] [tmp2-1] = 1;
    graph [tmp2-1] [tmp1-1] = 1;
  }


  for (i=0; i < n; i++)
  {
      DSF(i, 0);
      for (int j=0; j < n; j++)
          visited[j] = 0;
  }
  cout << max;

  return 0;
}