program minval;

const
	MAXN				= 30;
	MAXM				= 10;
	MAXARR				= 30;
	MAXVS				= 32;

type
	Integer				= LongInt;
	TFunction			= record
		n			: Integer;
		arr			: Array [1 .. MAXARR] of Integer;
		vs			: Array [0 .. MAXVS] of Integer;
		sq			: Integer;
	end;

var
	F				: Array [1 .. MAXM] of TFunction;
	cond				: Array [1 .. MAXN] of Integer;
	notat				: Array [1 .. MAXARR] of Integer;
	min				: Integer;
	N, M				: Integer;
	i, j, k				: Integer;

procedure readInput;
begin
	readln(M, N);
	for k := 1 to M do begin
		readln(F[k].n);
		for i := 1 to F[k].n do
			read(F[k].arr[i]);
		F[k].sq := 1;
		readln;
		for i := 1 to F[k].n do
			F[k].sq := F[k].sq * 2;
		for j := 0 to F[k].sq - 1 do
			read(F[k].vs[j]);
		readln;
		F[k].sq := F[k].sq - 1;
	end;
end;

procedure go(c, sum: Integer);
var
	i, j, pos			: Integer;
	possible			: Boolean;
	oldcond				: Array [1 .. MAXN] of Integer;
begin
	if (c = M + 1) then begin
		if (sum < min) then
			min := sum;
		Exit;
	end else begin
		for i := 1 to N do
			oldcond[i] := cond[i];
		for i := 0 to F[c].sq do begin
			j := i;
			pos := F[c].n;
			while (pos > 0) do begin
				notat[pos] := j mod 2;
				j := j div 2;
				pos := pos - 1;
			end;
			possible := True;
			for j := 1 to F[c].n do
				if (notat[j] <> cond[F[c].arr[j]]) and
				(cond[F[c].arr[j]] <> -1) then begin
					possible := False;
					break;
				end;
			if (possible) then begin
				for j := 1 to F[c].n do
					cond[F[c].arr[j]] := notat[j];
				go(c + 1, sum + F[c].vs[i]);
				for j := 1 to N do
					cond[j] := oldcond[j];
			end;
		end;
	end;
end;

procedure Solve;
begin
	min := maxlongint;
	for i := 1 to N do
		cond[i] := -1;
	go(1, 0);
end;

procedure writeOutput;
begin
	writeln(min);
end;

begin
	readInput;
	Solve;
	writeOutput;
end.
	