#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define IN  "cups.in"
#define MAX_N 12
#define MAX_K 12
#define MAX_L 58000
#define MAX_NASL 50

struct TNasl{
 int node;
// char beg,end;
 char move;
};

int c_nodes[MAX_N][MAX_K];
int used[MAX_L];
struct TNasl mas[MAX_L][MAX_NASL];
int pos[MAX_N];
int br_nasl[MAX_L];
struct TNasl result[MAX_L];

int n,k;
int count=0;

int code(int v[]);
void BuildGraph();
void decode(int num, int v[]);
void DFS(int node);

int main(void){
 int ans=0;
 int i,j,h;

// freopen(IN,"r",stdin);

 scanf("%d %d", &n, &k);

 for(i=1; i<=n; i++)
  c_nodes[i][0]=1;

 for(i=0; i<=k; i++)
  c_nodes[1][i]=1;


 for(i=2; i<=n; i++){
  for(j=1; j<=k; j++){
   ans=0;
   for(h=0; h<=j; h++){
    ans+=c_nodes[i-1][j-h];
   }
   c_nodes[i][j]=ans;
  }
 }

 memset(used,0,sizeof(used));
 memset(pos,0,sizeof(pos));
 memset(br_nasl,0,sizeof(br_nasl));

 pos[0]=k;
 //pos[1]=1;
 //pos[n-1]=k;

 //decode(1,pos);
 i=code(pos);

 BuildGraph();

 memset(used,0,sizeof(used));

 DFS(i);

 return 0;
}

int code(int v[]){
 int i,j;
 int ans=0;
 int nn,kk;

 nn=n; kk=k;

 for(i=0; i<n; i++){
  for(j=0; j<v[i]; j++){
   ans+=c_nodes[nn-1][kk-j];
  }
  kk-=v[i];
  nn--;
 }

 return ans;
}

void BuildGraph(){
 int node1,node2;
 int i,j,h;

 //node1=code(v);

 for(h=0; h<c_nodes[n][k]; h++){
  decode(h,pos);
  node1=h;

  for(i=0; i<n; i++){
   if(pos[i]>0){
    for(j=0; j<n; j++){
     if(i==j) continue;
     pos[i]--;
     pos[j]++;
     node2=code(pos);
     mas[node1][br_nasl[node1]].move=i*11;
     mas[node1][br_nasl[node1]].move+=j;
     mas[node1][br_nasl[node1]++].node=node2;
     pos[i]++;
     pos[j]--;
    }
   }
  }
 }
}

void decode(int num, int v[]){
 int i,j;
 int nn,kk;
 int ans=0;
 int curans=0;

 nn=n-1; kk=k;

 for(i=0; i<n; i++){
  curans=0;
  if(i==n-1) {v[i]=kk; break;}
  for(j=0; j<=kk; j++){
   curans+=c_nodes[nn][kk-j];
   if(curans+ans>num){
    ans+=curans-c_nodes[nn][kk-j];
    v[i]=j;
    kk-=j;
    nn--;
    break;
   }
   /*else{
    if(curans+ans==num){
     v[i]=j; //ans+=c_nodes[nn][kk-j];
     ans+=curans;
     kk-=j; nn--;
     break;
    }
    //else ans+=curans;
   } */
  }
 }

}

void DFS(int node){
 int i;

 used[node]=1;
 for(i=0; i<br_nasl[node];i++){
  if(!used[mas[node][i].node]){
   result[count++]=mas[node][i];
   DFS(mas[node][i].node);
  }
 }

 printf("%d\n", count);
 for(i=0; i<count; i++){
  printf("%d %d\n", result[i].move/11+1, result[i].move%11+1);
 }

 exit(0);
}

