#include <ctime>
#include <cstdio>
#include <cstdlib>

using namespace std;

const long long int MAXLEN = static_cast<long long int>(2) << 15;
const double TTL = 2.5;

typedef unsigned int uint32_t;

int N;
int K;
long long int cache[20][20];
//long long int cache_g[100][100];
int a[20];
int len;
int best_len;
int move_p[MAXLEN];
int move_q[MAXLEN];
int best_move_p[MAXLEN];
int best_move_q[MAXLEN];
uint32_t visited[1 * 1000 * 1000];
long long int FIN;

long long int f(int k, int n) {
	if (cache[k][n] >= 0) return cache[k][n];
        /*
        if (n == 0) return 1;
        */
        if (n == 0) {
        	if (k == 0) return 1;
                else return 0;
        }
        long long int result = 0;
        for (int i = 0; i <= k; i++) {
        	result += f(k - i, n - 1);
        }
        return cache[k][n] = result;
}
/*
long long int g(int k, int n) {
	if (cache_g[k][n] >= 0) return cache_g[k][n];
	if (n == 0) {
        	if (k == 0) return 1;
                else return 0;
        }
        long long int result = 0;
        for (int i = 1; i <= k; i++) {
        	result += g(k - i, n - 1);
        }
        return cache_g[k][n] = result;
}
*/

long long int fc(int k, int n) {
	if (n == 0) return 0;
        //if (n == 1) return a[1];
        long long int result = 0;
        for (int i = 0; i < a[n]; i++) {
        	result += f(k - i, n - 1);
        }
        result += fc(k - a[n], n - 1);
        return result;
}

inline bool isVisited(long long int code) {
	int ind1 = code / 32;
        int ind2 = code % 32;
        return (visited[ind1] & (static_cast<uint32_t>(1) << ind2)) != 0;
}

inline void markVisited(long long int code) {
	int ind1 = code / 32;
        int ind2 = code % 32;
        visited[ind1] = visited[ind1] | (static_cast<uint32_t>(1) << ind2);
}

inline void markNotVisited(long long int code) {
	int ind1 = code / 32;
        int ind2 = code % 32;
        visited[ind1] = visited[ind1] & (~(static_cast<uint32_t>(1) << ind2));
}

void kraj() {
	//printf("kraj\n");
        a[1] = K;
	printf("%d\n", best_len - 1);
        /*
        for (int i = 2; i <= N; i++) {
        	a[i] = 0;
        }
        */
	for (int i = 0; i < best_len - 1; i++) {
        	printf("%d %d\n", best_move_p[i], best_move_q[i]);
                /*
                a[best_move_p[i]]--;
                a[best_move_q[i]]++;
                for (int j = 1; j <= N; j++) {
                	printf(" %d", a[j]);
                }
                printf("\n");
                */
        }
        exit(EXIT_SUCCESS);
}

void bt() {
	long long int cur_code = fc(K, N);
        //printf("cur_code=%lld\n", cur_code);
        if (isVisited(cur_code)) {
		long long int cur_clock = clock();
                if (len > best_len) {
                	for (int i = 0; i < len; i++) {
                        	best_move_p[i] = move_p[i];
                                best_move_q[i] = move_q[i];
                        }
                        best_len = len;
                }
        	if (cur_clock >= FIN || len >= MAXLEN) kraj();
        	return;
        }
        if (len >= MAXLEN) {
                if (len > best_len) {
                	for (int i = 0; i < len; i++) {
                        	best_move_p[i] = move_p[i];
                                best_move_q[i] = move_q[i];
                        }
                        best_len = len;
                }
        	kraj();
        }
        markVisited(cur_code);

        for (int i = 1; i <= N; i++) {
        	for (int j = 1; j <= N; j++) {
                	if (j != i) {
                        	if (a[i] > 0) {
                                	move_p[len] = i;
                                        move_q[len] = j;
                                        a[i]--;
                                        a[j]++;
                                        len++;
                                        bt();
                                        a[i]++;
                                        a[j]--;
                                        len--;
                                }
                        }
                }
        }
        markNotVisited(cur_code);
}

int main() {
	for (int i = 0; i < 20; i++) {
        	for (int j = 0; j < 20; j++) {
                	cache[i][j] = -1;
                        //cache_g[i][j] = -1;
                }
        }
        scanf("%d%d", &N, &K);
        FIN = static_cast<long long int>(clock() + static_cast<long double>(TTL) * static_cast<long double>(CLOCKS_PER_SEC));
        int tmp = f(K, N) / 32 + 1000;
        for (int i = 0; i < tmp; i++) {
        	visited[i] = 0;
        }
        len = 0;
        best_len = 0;
        a[1] = K;
        for (int i = 2; i <= N; i++) {
        	a[i] = 0;
        }
        bt();
        //printf("sled bt()\n");
        kraj();
#if 0
        int max = 0;
        for (int k = 1; k <= 10; k++) {
        	for (int n = 2; n <= 20; n++) {
                	if (f(k, n) > max) max = f(k, n);
                        /*
                        printf("f(%d, %d)=%lld\n", k, n, f(k, n));
                        printf("g(%d, %d)=%lld\n", k, n, g(k, n));
                        */
                }
        }
#endif
	/*
        scanf("%d%d", &N, &K);
        for (int i = N; i >= 1; i--) {
        	scanf("%d", &a[i]);
        }
        printf("%lld\n", fc(K, N));
        */

        //printf("%d\n", f(2, 3));
        //printf("%lld\n", MAXLEN);
}
