//Day 1 / Task 2 / PATHS
#include <stdio.h>
#include <vector>

using namespace std;

const int maxn = 100002;

struct ta {
	int max1,max2;
  int ind1,ind2;
};

struct tnei {
	int ind, c;
};


int tovis[maxn];
ta a[maxn];
vector<tnei> nei[maxn];

int n,m;

/*****************/
void input()
{
	scanf("%d%d",&n,&m);

  int i,j,k,c,tmp;

  for(k=1; k<=m; k++) {
    scanf("%d%d%d",&i,&j,&c);

    tmp = nei[i].size()+1;
    nei[i].resize(tmp);
    nei[i][tmp-1].ind=j;
    nei[i][tmp-1].c=c;

    tmp = nei[j].size()+1;
    nei[j].resize(tmp);
    nei[j][tmp-1].ind=i;
    nei[j][tmp-1].c=c;
  }

}
/*****************/
void update(int i, int j)
{
  int tmp,tmp2;


  if (a[nei[i][j].ind].ind1==i && a[nei[i][j].ind].ind2!=i) {
    tmp = a[nei[i][j].ind].max2 + nei[i][j].c;

    if (a[i].max1 < tmp) {
      a[i].max2=a[i].max1;
      a[i].ind2=a[i].ind1;

      a[i].max1=tmp;
      a[i].ind1=nei[i][j].ind;
    }
    else if (a[i].max1!=tmp && (a[i].max2<tmp)) {
      a[i].max2=tmp;
      a[i].ind2=nei[i][j].ind;
    }
  }
  else if (a[nei[i][j].ind].ind2==i && a[nei[i][j].ind].ind1!=i) {
    tmp = a[nei[i][j].ind].max1 + nei[i][j].c;
    if (a[i].max2!=tmp && a[i].max1 < tmp) {
      a[i].max2=a[i].max1;
      a[i].ind2=a[i].ind1;

      a[i].max1=tmp;
      a[i].ind1=nei[i][j].ind;
    }
    else if (a[i].max2 < tmp) {
      a[i].max2=tmp;
      a[i].ind2=nei[i][j].ind;
    }
  }
  else if (a[nei[i][j].ind].ind1!=i && a[nei[i][j].ind].ind2!=i){
    tmp = a[nei[i][j].ind].max1 + nei[i][j].c;
    tmp2 = a[nei[i][j].ind].max2 + nei[i][j].c;

    if (a[i].max1 < tmp2) {
      a[i].max1=tmp;
      a[i].max2=tmp2;
      a[i].ind1=nei[i][j].ind;
      a[i].ind2=nei[i][j].ind;
    }
    else if (a[i].max2!=tmp && a[i].max1 < tmp) {
      a[i].max2=a[i].max1;
      a[i].ind2=a[i].ind1;

      a[i].max1=tmp;
      a[i].ind1=nei[i][j].ind;
    }
    else if (a[i].max1!=tmp && a[i].max2 < tmp) {
      a[i].max2=tmp;
      a[i].ind2=nei[i][j].ind;
    }
  }
  else {
    tmp = nei[i][j].c;

    if (a[i].max1 < tmp) {
      a[i].max2=a[i].max1;
      a[i].ind2=a[i].ind1;

      a[i].max1=tmp;
      a[i].ind1=nei[i][j].ind;
    }
    else if (a[i].max2 < tmp) {
      a[i].max2=tmp;
      a[i].ind2=nei[i][j].ind;
    }
  }
}
/*****************/
void dfs(int x, int c, int tati)
{
  if (tovis[tati]==x) {
    tovis[tati]=-1;

  }
  if (tovis[x]==0) tovis[x]=tati;

	if (nei[x].size()==1) {
  	a[x].max1=nei[x][0].c;
    a[x].ind1=nei[x][0].ind;
    a[x].max2=0;
  }
  else {
    int k,tmp;

    for(k=0; k<nei[x].size(); k++) {
      if (nei[x][k].ind!=tati) {
        if (tovis[nei[x][k].ind]!=-1 && tovis[nei[x][k].ind]!=x) dfs(nei[x][k].ind,nei[x][k].c,x);

        //update
				update(x,k);
      }
    } //end for
  }
}
/*****************/
void go()
{
  int i,j,tmp;

  tovis[1]=-1;
  for(i=1; i<=n; i++)
    for(j=0; j<nei[i].size(); j++) {
  		if (tovis[nei[i][j].ind]!=-1 && tovis[nei[i][j].ind]!=i) dfs(nei[i][j].ind,nei[i][j].c,i);
      //update
      update(i,j);
    }
}
/*****************/
void output()
{
  int i;

  for(i=1; i<=n; i++)
  	printf("%d\n",a[i].max1);

}
/*****************/
int main()
{
	input();
  go();
  output();

	return 0;
}
