#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <time.h>

#define SIZE 8000000
typedef struct _node
{
 long long v;
 struct _node *left,*right,**parent;
} Node;
Node* tree;
void error();
void newnode(long long el,Node** t)
{
 Node* k=(Node*)malloc(sizeof(Node));
 if(k==NULL)
    error();
 k->parent=t;
 k->left=NULL;
 k->right=NULL;
 k->v=el;
 *t=k;
}
int add(long long el)
{
 Node* p;
 p=tree;
 if(tree==NULL)
 {
  newnode(el,&tree);
  return 1;
 }
 for(;;)
 {
  if(p->v==el)
              return 0;
  if(p->v<el)
  {
   if(p->right==NULL)
   {
      newnode(el,&(p->right));
      break;
   }
   else
       p=p->right;
  }
  else
  {
   if(p->left==NULL)
   {
      newnode(el,&(p->left));
      break;
   }
   else
       p=p->left;
  }
 }
 return 1;
}

void del(long long el)
{
 Node* p=tree,*t,*q;
 for(;;)
 {
  if(p==NULL)
             break;
  if(p->v==el)
  {
   if(p->left==NULL)
   {
    t=p;
    p->right->parent=p->parent;
    (*p->parent)=p->right;
    free(t);
   }
   else if(p->right==NULL)
   {
    t=p;
    p->left->parent=p->parent;
    (*p->parent)=p->left;
    free(t);
   }
   else
   {
    for(t=p->right;t->left!=NULL;t=t->left);
    p->v=t->v;
    q=t->right;
    q->parent=t->parent;
    (*t->parent)=q;
    free(t);
   }
   break;
  }
  if(p->v < el)
          p=p->right;
  else
          p=p->left;
 }
}
int n,k;
long long code(int a[])
{
 int x,i;
 long long res;
 for(res=0,x=1,i=0;i<n;i++,x*=10)
    res+=x*a[i];
 return res;
}
unsigned char m[SIZE];
int md;
unsigned char c[SIZE];
int cur[10];
float st;
#define TL (2.9)
int bt(int depth)
{
 long long cd=code(cur);
 float t=((float)clock() - st) / CLOCKS_PER_SEC;
 if(t > TL)
    return 1;
 if(depth>=SIZE)
    error();

 if(add(cd)==0)
 {
  if(depth>md)
  {
    memcpy(m,c,sizeof(char)*depth);
    md=depth;
  }
 }
 else
 {
  int i,j;
  for(i=0;i<n;i++)
     for(j=0;j<n;j++)
        if(i!=j && cur[i]>=1)
        {
         c[depth]=i*16 +j;
         cur[i]--;
         cur[j]++;
         if(bt(depth+1)==1)
            return 1;
         cur[i]++;
         cur[j]--;
        }
  del(cd);
 }
 return 0;
}
void error()
{
 int i;
 printf("%d\n",md-1);
 for(i=0;i<(md-1);i++)
    printf("%d %d\n",(int)m[i] +1 ,(int)m[i]+1 );
 exit(0);
}
int main()
{
 int i;
 scanf("%i %i",&n,&k);
 st=(float)clock();
 cur[0]=k;
 bt(0);
 printf("%d\n",md-1);
 for(i=0;i<(md-1);i++)
    printf("%d %d\n",(int)m[i]/16 +1 ,(int)m[i]%16+1 );
 return 0;
}
