#include <stdio.h>
#include <stdlib.h>

#define MAX 131072

struct bla
{
  int x, y, z;
}a[MAX];

unsigned long long n, i, j, visited[MAX], m, edno, dve, tri, pos[MAX], count, dist[MAX];

int comp(struct bla *i, struct bla *j)
{
  return i->x - j->x;
}

void DFS(int node)
{
  int i;

  visited[node] = 1;

  for(i = pos[node]; i < pos[node+1]; i++)
    if(!visited[a[i].y])
    {
      dist[a[i].y] = dist[a[i].x] + a[i].z;
      if(dist[a[i].y] > count)
        count = dist[a[i].y];
      DFS(a[i].y);
    }
}

int main()
{
  scanf("%llu %llu", &n, &m);
  for(i = 0; i < m; i++)
  {
    scanf("%llu %llu %llu", &edno, &dve, &tri);
    a[2*i].x = edno-1;
    a[2*i].y = dve-1;
    a[2*i].z = tri;
    a[2*i + 1].x = dve-1;
    a[2*i + 1].y = edno-1;
    a[2*i + 1].z = tri;
  }

  qsort(a, 2*m, sizeof(struct bla), comp);

  for(i = 1; i < 2*m; i++)
    if(a[i].x != a[i-1].x)
      pos[++count] = i;
  pos[n] = 2*m;

  for(i = 0; i < n; i++)
  {
    for(j = 0; j < n; j++)
    {
      dist[j] = 0;
      visited[j] = 0;
    }
    count = 0;
    for(j = 0; j < n; j++)
      dist[j] = 0;
    DFS(i);
    printf("%llu\n", count);
  }

  return 0;
}

