program count;

const
	MAXN                                    = 20;
	MAXP                                    = 10;
	MAXK                                    = 100;

var
	F                                       : Array [0 .. MAXN, - (MAXK * 2) .. (MAXK * 2)] of Int64;
	N, P, K                                 : Integer;

procedure readInput;
begin
	readln(N, P, K);
end;

procedure Solve;
var
	i, j, x, s                                      : Integer;
begin
	for i := 0 to N do
		for j := - (K * 2) to (K * 2) do
			F[i, j] := 0;
	for i := 0 to P do
		for j := 0 to P do
			F[1, (i - j)] := F[1, (i - j)] + 1;
	for i := 2 to N do
		for s := - 100 to 100 do
			for j := 0 to P do
				for x := 0 to P do
					F[i, s] := F[i, s] + F[i - 1, s - (j - x)];
end;

procedure writeOutput;
begin
	writeln(F[N, K]);
end;

begin
	readInput;
	Solve;
	writeOutput;
end.
