#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define MAX_N 1510
#define MAX_K 1000
#define MAX_VAL 1000000100
struct TPic{
 float a,b;
};

struct THeight{
 float height;
};

float sum[MAX_N];
struct TPic pics[MAX_N];
struct THeight mas[MAX_N][MAX_N];
int    floors[MAX_N];
float best[MAX_N][MAX_K];


int n;
float w;
float res=0;
float result=MAX_VAL;

float min(float aa, float bb);
float solve(int ind, int floor);

int main(void){
 int i;

 //freopen("pict.in","r",stdin);

 clock();

 memset(mas,0,sizeof(mas));
 memset(best,0,sizeof(best));

 scanf("%d %f", &n, &w);
 for(i=1; i<=n; i++){
  scanf("%f %f", &pics[i].a, &pics[i].b);
 }

 sum[0]=0;
 sum[1]=min(pics[0].a,pics[0].b);

 for(i=2; i<=n; i++){
  sum[i]=sum[i-1]+min(pics[i].a,pics[i].b);
 }

 memset(floors,0,sizeof(floors));

 res=solve(1,1);

 printf("%.6f\n", res);

 return 0;
}

float min(float aa, float bb){
 return (aa<bb) ? aa:bb;
}

float solve(int ind, int floor){
 int i,j,h;
 float width=0;
 float mini,maxi,height;
 float ans=0;

/* if(clock()/(double)CLOCKS_PER_SEC>0.9) {
  printf("%.6f\n", best[1][1]);
  exit(0);
 }
 */
 if(ind>n) return 0;

 if(floors[ind]!=0&&floors[ind]<floor) return MAX_VAL;
 if(floors[ind]==floor) return best[ind][floor];

 i=ind;
 while(1){
  if(i>n) break;
  if(sum[i]-sum[ind-1]>w) break;

  for(h=0; h<2; h++){
   if(h==0) height=pics[i].a;
   else height=pics[i].b;

   width=0;
   for(j=ind; j<=n; j++){
    if(pics[j].a<pics[j].b) {mini=pics[j].a; maxi=pics[j].b;}
    else {mini=pics[j].b; maxi=pics[j].a;}

    if(maxi<=height){
     width+=mini;
     if(width>w) {width-=mini; j--; break;}
    }
    else{
     if(mini<=height){
      width+=maxi;
      if(width>w) {width-=maxi; j--; break;}
     }
     else{
      j--;
      break;
     }
    }
   }

   /***********************/
   if(j<ind) continue;

   if(j>n) j--;

   if(mas[ind][j].height<height&&mas[ind][j].height!=0) {
    ans=mas[ind][j].height+solve(j+1,floor+1);
    if(best[ind][floor]>ans||best[ind][floor]==0) best[ind][floor]=ans;
    if(floors[ind]>floor||floors[ind]==0) floors[ind]=floor;
   }
   else{
    mas[ind][j].height=height;
    ans=height+solve(j+1,floor+1);
    if(best[ind][floor]>ans||best[ind][floor]==0) best[ind][floor]=ans;
    if(floors[ind]>floor||floors[ind]==0) floors[ind]=floor;
   }
   /***********************/
  }
  i++;
 }

 if(best[ind][floor]!=0) return best[ind][floor];
 else return MAX_VAL;

}

