#include <stdio.h>

#define MAXN            15
#define MAXP            15
#define MAXK            110

int n,p,k;
int ms;
int dp[MAXN][MAXP][MAXN*MAXP];
int ways[MAXN][MAXN];
long long ans;
long long dpall[MAXP*MAXN];

void input()
{
  scanf("%d %d %d",&n,&p,&k);
}

void CalcWays()
{
  int i,i2,i3;

  ways[0][0] = 1;

  for(i=1;i<=n+1;i++)
  {
    ways[0][i] = 0;
  }

  for(i=1;i<=n+1;i++)         // na i poz.
  {
    for(i2=0;i2<=n+1;i2++)    // slagame i2 neshta
    {
      ways[i][i2] = 0;

      for(i3=0;i3<=i2;i3++)   // na i poz. slagame i3 elementa
      {
        ways[i][i2] += ways[i-1][i2-i3];
      }
    }
  }
}

void solve()
{
  int i,i2,i3,i4;
  int tsum;
  int otsum;

//  CalcComb();
  CalcWays();

  ms = n*p;

  for(i=0;i<=n;i++)
  {
    dp[i][0][0] = 1;          // s i elem. do 0 pravim suma 0 po 1 nachin
    for(i2=1;i2<=ms;i2++)
    {
      dp[i][0][i2] = 0;       // s i elem. do 0 pravim suma i2 po 0 nachina
    }
  }

  for(i=0;i<=p;i++)
  {
    dp[0][i][0] = 1;          // s 0 elem. do i pravim suma 0 po 1 nachin
    for(i2=1;i2<=ms;i2++)
    {
      dp[0][i][i2] = 0;       // s 0 elem. do i pravim suma i2 po 0 nachina
    }
  }

  for(i=1;i<=n;i++)           // za vsichki dalzhini
    for(i2=1;i2<=p;i2++)      // za vsichki max chisla
      for(i3=0;i3<=ms;i3++)   // za vsichki sumi
      {
        tsum = i3;
        for(i4=i;i4>=0;i4--)
        {
          dp[i][i2][i3] += (dp[i4][i2-1][tsum]*ways[i4+1][i-i4]);
          tsum -= i2;
          if(tsum<0)
            break;
        }
      }

  for(i=0;i<=ms;i++)
  {
    dpall[i] = dp[n][p][i];
  }

  ans = 0;

  for(i=0;i<=ms;i++)
  {
    otsum = i-k;

    if(i-k>=0)
    {
      ans += (dpall[i]*dpall[otsum]);
    }
  }

}

void output()
{
  printf("%lld\n",ans);
}

int main()
{

  input();
  solve();
  output();

  return 0;
}

