#include <stdio.h>
#include <stdlib.h>

#define MAXN            1510

#define INF             2000000000.0

typedef struct s1
{
  int ind;
  double w,h;
} tpict;

int n;
double w;
tpict pics[MAXN];
tpict spics[MAXN];
double dp[MAXN];
//int used[MAXN];
tpict st[MAXN*2];
int brs;
int inv[MAXN];


void input()
{
  int i;
  int buf;

  scanf("%d %lf",&n,&w);

  for(i=1;i<=n;i++)
  {
    scanf("%lf %lf",&pics[i].w,&pics[i].h);

    pics[i].ind = i;

    if(pics[i].w>pics[i].h)
    {
      buf = pics[i].w;
      pics[i].w = pics[i].h;
      pics[i].h = buf;
    }
  }
}

int cmp(const void *e1, const void *e2)
{
  return ((tpict*)e1)->h - ((tpict*)e2)->h;
}

void solve()
{
  int i,i2;
  int ind;
  double sum;
  double len,tlen;
  double maxh;
//  int stopi;
  int lturn;
  int check;

  for(i=1;i<=n;i++)
    spics[i] = pics[i];

  qsort(spics+1,n,sizeof(tpict),cmp);

  dp[0] = 0;

  for(i=1;i<=n;i++)
  {
    dp[i] = INF;

    sum = 0;

    i2 = i+1;

    while(sum<=w && i2>0)    // dokato se pobirat kartinite na edin red
    {
      i2--;
      sum += pics[i2].w;
    }

    ind = i2+1;
    len = sum - pics[i2].w;
    brs = 0;

    for(i2=1;i2<=n;i2++)
    {
      if(spics[i2].ind>=ind && spics[i2].ind<=i)
      {
        st[brs] = spics[i2];
        inv[spics[i2].ind] = brs;
        brs++;
      }
    }

//    stopi = -1;

/*    for(i2=0;i2<brs-1;i2++)
      if(st[i2].h<=st[i2+1].w)
      {
        stopi = i;
        break;
      }*/

    brs--;
    maxh = st[brs].h;


    for(i2=ind;i2<=i;i2++)  // za vsiaka kartina kato parva v reda
    {
      tlen = len;
      lturn = -1;
      check = 1;

      while(brs>=0)
      {
        if(st[brs].h!=0.0)
        {
          if(lturn!=-1)
            if(st[lturn].w>=st[brs].h)     // niama smisal da obrashtame
            {
//              check = 0;
              break;
            }

          tlen += (st[brs].h-st[brs].w);
          if(tlen>w)
          {
            tlen -= (st[brs].h-st[brs].w);
            check = 0;
            break;
          }
          else
          {
            lturn = brs;
            brs--;
          }
        }
        else
          brs--;
      }

      if(brs<0)
        brs = 0;

      if(check)        // ako sme prekasnali
      {
        if(lturn!=-1)
        {
          len = tlen;
          maxh = st[lturn].w;
        }
      }
      else              // ako ne sme mogli da obarnem zaradi miastoto
      {
        len = tlen;
        maxh = st[brs].h;
      }


      if(dp[i]>dp[i2-1]+maxh)
      {
        dp[i] = dp[i2-1]+maxh;
      }

      st[inv[i2]].h = 0.0;

/*      if(brs!=stopi)
        len = tlen - (st[brs].h-st[brs].w);
      else*/
//        len = tlen - (st[l].h-st[brs+1].w);

/*      if(brs!=stopi)
        maxh = st[brs].h;
      else*/
//        maxh = st[brs+1].w;



    }
  }
}

void output()
{
  printf("%.6lf\n",dp[n]);
}

int main()
{
//  freopen("pictt.txt","r",stdin);

  input();
  solve();
  output();

  return 0;
}

