#include <stdio.h>
#include "module.h"

#define MAXN 100
// bacteria.inp

int n;
int mtrx[MAXN][MAXN];

void Init()
  {
    n = getSize();
  }

void Find(int x0,int y0,int x1,int y1,int count)
  {
    int h = y1 - y0,w = x1 - x0;
    int ans;

    if (count == 0) return;
    if (x0 == x1 && y0 == y1)
      {
        mtrx[y0][x0] = count;
        return;
      }

    if (h > w) // Split horizontally
      {
        int tmp = (y1 + y0) / 2;
        ans = ask(x0 + 1,x1 + 1,y0 + 1,tmp + 1);
        Find(x0,y0,x1,tmp,ans);
        Find(x0,tmp + 1,x1,y1,count - ans);
      }
    else  // Split vertically
      {
        int tmp = (x1 + x0) / 2;
        ans = ask(x0 + 1,tmp + 1,y0 + 1,y1 + 1);
        Find(x0,y0,tmp,y1,ans);
        Find(tmp + 1,y0,x1,y1,count - ans);
      }
  }

int main()
  {
    int i,j;

    Init();
    Find(0,0,n - 1,n - 1,ask(1,n,1,n));

    for (i = 0;i < n;i++)
      for (j = 0;j < n;j++)
        if (mtrx[i][j]) answer(j + 1,i + 1);
    return 0;
  }
