#include <stdio.h>

#include "module.h"

#define IN      "bacteria.inp"

#define MAX     200

long n;

char mat[MAX][MAX];

void myAnswer(long x, long y)
{
   if(mat[x][y])
     return;

   mat[x][y]=1;

   answer(x, y);
}

long myAsk(long x1, long y1, long x2, long y2)
{
   if(x1>x2 || y1>y2) return 0;

   return ask(x1, x2, y1, y2);
}

void go(long x1, long y1, long x2, long y2, long all)
{
   long s1, s2, s3, s4, i, j;
   long midx, midy;

   if(all==0) return;

   if(x1==x2 && y1==y2)
   {
     myAnswer(x1, y1);
     return;
   }

   if(x2-x1+1<=2 && y2-y1+1<=2)
   {
     for(i=x1; i<=x2; i++)
        for(j=y1; j<=y2; j++)
           if((i!=x2 || j!=y2) && ask(i, i, j, j))
           {
             myAnswer(i, j);
             all--;
           }

     if(all)
       myAnswer(x2, y2);

     return;
   }

   midx=(x2+x1)/2;
   midy=(y2+y1)/2;

   s1=myAsk(x1, y1, midx-1, midy-1);
   s2=myAsk(x1, midy, midx-1, y2);
   s3=myAsk(midx, y1, x2, midy-1);
   s4=all-s1-s2-s3;

   go(x1, y1, midx-1, midy-1, s1);
   go(x1, midy, midx-1, y2, s2);
   go(midx, y1, x2, midy-1, s3);
   go(midx, midy, x2, y2, s4);
}

int main()
{
   n=getSize();

   go(1, 1, n, n, ask(1, n, 1, n));

   return 0;
}

