unit Module;

interface

{
extern void init(long*, long*);
extern long ask(long, long);
extern void answer(long,long);
}

procedure init(var nnn : LongInt; var kkk : LongInt);
function ask(age : Longint; weight : LongInt) : LongInt;
procedure answer(age : LongInt; weight : LongInt);

implementation

uses SysUtils;

var
  phase, questions : Integer;
  inFile, outFile : Text;
  n, k : LongInt;
  tableSize, rage, rWeight : LongInt;
  t : array[0..1027,0..1027] of LongInt;
  asked : array[0..1027,0..1027] of Boolean;

procedure Output(code : integer; msg : string);
begin
  WriteLn(outFile, code);
  WriteLn(outFile, msg);
{    if (code<0) then raise Exception.Create('msg'); }
  Halt;
end;

procedure init(var nnn : LongInt; var kkk : LongInt);
var
  i,j:Integer;
begin
  if (phase=0) then
  begin
    assign(inFile, 'ceoi.in');
    reset(inFile);
    assign(outFile, 'ceoi.out');
    rewrite(outFile);
    read(inFile, n,rage,rweight);
    for i:=1 to n do for j:=1 to n do read(inFile, t[i,j]);

		tablesize := n*n;
    k := t[rage][rweight];
		kkk := k;
		nnn := n;
  end else Output(-1, 'More than one call to procedure init.');
	inc(phase);
end;

function ask(age : Longint; weight : LongInt) : LongInt;
begin
  if (phase=0) then Output(-1, 'Must call init() first!');
  inc(questions);
  if (questions>tablesize) then
    Output(-1, 'Too many calls to ask!');

  if (age<1) or (age>n) or (weight<1) or (weight>n) then
    Output(-1, 'Invalid age or weight : '+IntToStr(age)+' '+IntToStr(weight) );

  if (asked[age,weight]) then
    Output(-1, 'Two calls to ask with the same arguments : '+IntToStr(age)+' '+IntToStr(weight) );

  asked[age,weight]:=true;
  ask := t[age,weight]
end;

procedure answer(age : LongInt; weight : LongInt);
begin
  if (phase=0) then Output(-1, 'Must call init() first!');
  if (age<1) or (age>n) or (weight<1) or (weight>n) then
    Output(-1, 'Age/weight out of bounds!')
  else
  begin
    if (t[age,weight]=k) then
      Output(questions, 'Correct!')
    else
      Output(-1, IntToStr(k)+' friends required, '+
      IntToStr(t[age,weight])+' friends matching your answer!\n');
  end;
end;

initialization
  phase:=0;
  questions:=0;
finalization
  if (phase>0) then
  begin
    close(inFile);
    close(outFile);
  end;
end.
