/*
TASK:base
LANG:C
*/
#include <stdio.h>
#include <stdlib.h>

typedef struct Edge
{
	int to;
	struct Edge* next;
} Edge;

Edge* v[16000];
Edge* r[16000];
int num[16000];
int vis[16000];
int u[16000];
int comp[16000];
int es[120000],ed[120000];
int c=0;
int n,m;
void add_edge(int f,int t)
{
	Edge *p=(Edge*)malloc(sizeof(Edge));
	p->to=t;
	p->next=v[f];
	v[f]=p;

	p=(Edge*)malloc(sizeof(Edge));
	p->to=f;
	p->next=r[t];
	r[t]=p;
}

void pre_dfs(int x)
{
	Edge* p;
	vis[x]=1;
	num[c++]=x;
	for(p=v[x];p!=NULL;p=p->next)
		if(!vis[p->to])
			pre_dfs(p->to);
}

void cdfs(int x,int cmp)
{
	Edge* p;
	u[x]=cmp;
	for(p=r[x];p!=NULL;p=p->next)
		if(!u[p->to])
			cdfs(p->to,cmp);
}

int main()
{
	int i,f,t,cmp=0,count=0;
//	freopen("base.in","r",stdin);
	scanf("%d %d",&n,&m);
	for(i=0;i<m;i++)
	{
		scanf("%d %d",&es[i],&ed[i]);
		add_edge(es[i],ed[i]);
	}
	for(i=1;i<=n;i++)
		if(!vis[i])
			pre_dfs(i);
	for(i=0;i<c;i++)
		if(!u[num[i]])
		{
			cdfs(num[i],++cmp);
		}
	for(i=0;i<m;i++)
		if(u[es[i]]!=u[ed[i]])
			count++;

	printf("%d\n",count);
	return 0;
}