/*
TASK:monument
LANG:C++
*/
# include <stdio.h>
# include <math.h>
# include <stdlib.h>
# include <limits.h>
# define MAXN 404
# define Os(a,b,c) (a.x*b.y+a.y*c.x+b.x*c.y-a.x*c.y-a.y*b.x-b.y*c.x)
# define Os2(a,aa,b,bb,c,cc) (a*bb+aa*c+b*cc-a*cc-aa*b-bb*c)

struct point{
    int x,y;
};

point d[MAXN];
double len[MAXN];

double ans;
int n;

void readf() {
    ans = INT_MAX;
//    freopen("monument.in","r",stdin);
    scanf("%d",&n);
    for ( int i=0 ; i<n ; i++ ) {
	scanf("%d %d",&d[i].x,&d[i].y);
	if ( i!=0 ) len[i-1] = hypot(d[i].x-d[i-1].x,d[i].y-d[i-1].y);
    }
    d[n] = d[0];
    len[n-1] = hypot(d[n].x-d[0].x,d[n].y-d[0].y);
}

void pre() {
    int p,q;
    for ( int i=0 ; i<n-1 ; i++ )
	for ( int j=i+1 ; j<n ; j++ ) {
	    p = Os(d[i],d[i+1],d[j]);
	    q = Os(d[i],d[i+1],d[j+1]);
//	    printf("%d %d\n",p,q);
	    if ( p==q && ans > abs(p)/(len[i]*2))
		ans = abs(p)/(len[i]*2);	   
	}
}

void solve() {
    int p, q, p1, q1, p2, q2;
    double x1, y1, x2, y2, x3, y3, l1, l2, l3, r;
    for ( int i=0 ; i<n-2 ; i++ ) {
	for ( int j=i+1 ; j<n-1 ; j++ ) {
	    p = Os(d[i],d[i+1],d[j]);
	    q = Os(d[i],d[i+1],d[j+1]);
	    if ( p<=q ) break;

	    q = -q+p;
	    p = -p;
	    x1 = d[j].x+(p/q)*(d[j].x-d[j+1].x);
	    y1 = d[j].y+(p/q)*(d[j].y-d[j+1].y);
	    for ( int l=j+1 ; l<n ; l++ ) {
		p1 = Os(d[j],d[j+1],d[l]);
		q1 = Os(d[j],d[j+1],d[l+1]);
		if ( p1<=q1 ) break;
		p2 = Os(d[l],d[l+1],d[i]);
		q2 = Os(d[l],d[l+1],d[i+1]);
		if ( p2<=q2 ) break;
		q1 = -q1+p1;
		p1 = -p1;
		x2 = d[l].x+(p1/q1)*(d[l].x-d[l+1].x);
		y2 = d[l].y+(p1/q1)*(d[l].y-d[l+1].y);
		q2 = -q2+p2;
		p2 = -p2;
		x3 = d[i].x+(p2/q2)*(d[i].x-d[i+1].x);
		y3 = d[i].y+(p2/q2)*(d[i].y-d[i+1].y);
		l1 = hypot(x1-x2,y1-y2);
		l2 = hypot(x1-x3,y1-y3);
		l3 = hypot(x2-x3,y2-y3);
		r = fabs(Os2(x1,y1,x2,y2,x3,y3)/2.0)/((l1+l2+l3)/2);
//		printf(" r =%lf  pri %d %d %d\n",r,i,j,l);
//		printf(" %lf %lf ,  %lf %lf , %lf %lf  \n",x1,y1,x2,y2,x3,y3);
		if ( r<ans )
		    ans = r;
	    }
	}
    }    
}

int main() {
    readf();
    pre();
//    printf("%lf\n",ans);
    solve();

    printf("%lf\n",ans);

    return 0;
}

