/*
TASK:BURN
LANG:C++
*/
#include<iostream.h>
#include<stdlib.h>
#include<stdio.h>
#include<string.h>

#define min(a,b) ((a)<(b)? (a):(b))
#define maxv 6000
#define maxn 100
#define maxl 1000000000

long vc,nc,n[maxn],v[maxv][3];

long a[maxn][maxn],label[maxn],perm[maxn];

void inp(void)
{ long i,a,b,c;
  scanf("%ld%ld",&nc,&vc);
  for (i=0;i<vc;i++) { scanf("%ld%ld%ld",&a,&b,&c);
                       v[i][0]=a-1;
                       v[i][1]=b-1;
                       v[i][2]=c;
                     }
}
void filln(void)
{ long i;
  memset(n,0,sizeof(n));
  for (i=0;i<vc;i++) { n[v[i][0]]++;
                       n[v[i][1]]++;
                     }
}
void inita(void)
{ long i;
  memset(a,0,sizeof(a));
  for (i=0;i<vc;i++) if (a[v[i][0]][v[i][1]]==0 || a[v[i][0]][v[i][1]]>v[i][2])
                          { a[v[i][0]][v[i][1]]=v[i][2];
                            a[v[i][1]][v[i][0]]=v[i][2];
                          }
}
void initdij(long s)
{ long i;
  for (i=0;i<nc;i++) { label[i]=maxl;
                       perm[i]=0;
                     }
  perm[s]=1;
  label[s]=0;
}
long findminl(void)
{ long i,j,l;
  l=maxl;
  for (i=0;i<nc;i++) if ((!label[i]) && (label[i]<l)) { l=label[i];
                                                        j=i;
                                                      }
  return j;
}
void dij(long s)
{ long i,j,u,m;
  u=s;
  for (i=1;i<nc;i++)
    { for (j=0;j<nc;j++) if (!perm[j]) { m=label[u]+a[u][j]+n[j];
                                         if (m<label[j]) label[j]=m;
                                       }
      u=findminl();
    }
}
long findmaxl(void)
{ long i,j,l;
  l=0;
  for (i=0;i<nc;i++) if (label[i]>l) { l=label[i];
                                       j=i;
                                     }
  return j;
}
double findburn(long s)
{ long i,s1;
  double k,p;
  s1=findmaxl();
  k=(double)n[s]+(double)label[s1];
  for (i=0;i<vc;i++)
    { p=(double)labs(label[v[i][0]]-label[v[i][1]]);
      p=p+((double)(v[i][2]-(double)p)/(double)2);
      p=p+(double)n[s];
      p=p+min(label[v[i][0]],label[v[i][1]]);
      if (k<p) k=p;
    }
  return k;
}
double burn(void)
{ long i;
  double x[maxn],m;
  filln();
  inita();
  for (i=0;i<nc;i++) { initdij(i);
                      dij(i);
                      x[i]=findburn(i);
                    }
  m=x[0];
  for (i=0;i<nc;i++) if (x[i]<m) m=x[i];
  return m;
}
int main(void)
{ inp();
  cout<<burn()<<"\n";
  return 0;
}
