#include <stdio.h>
#include <vector>
#include <queue>
#define INF 1000000000
#define MAXN 102
using namespace std;

 priority_queue< pair<int,int> > heap;
 int n,m;
 vector<int> a[MAXN];
 vector<int> b[MAXN];
 int d[MAXN];
 int marked[MAXN];
 int c[MAXN];
 double res;

 int main ()
  {
   int o,q,p,i,w,tmp,j,k;
   double cur;
   scanf("%d%d",&n,&m);
   for (i=1;i<=m;i++)
    {
     scanf("%d%d%d",&p,&q,&o);
     a[p].push_back(q);
     a[q].push_back(p);
     b[p].push_back(o);
     b[q].push_back(o);
    }
   for (i=1;i<=n;i++)
    c[i]=a[i].size();
   res=INF;
   for (w=1;w<=n;w++)
    {
     for (i=1;i<=n;i++)
      {
       d[i]=INF;
       marked[i]=0;
      }
     d[w]=c[w];
     heap.push(make_pair(-d[w],w));
     while (!heap.empty())
      {
       tmp=heap.top().second;
       heap.pop();
       if (marked[tmp]==1) continue;
       marked[tmp]=1;
       for (i=0;i<c[tmp];i++)
        if (d[a[tmp][i]]>d[tmp]+b[tmp][i]+c[a[tmp][i]])
         {
          d[a[tmp][i]]=d[tmp]+b[tmp][i]+c[a[tmp][i]];
          heap.push(make_pair(-d[a[tmp][i]],a[tmp][i]));
         }
      }
     cur=-1;
     for (i=1;i<=n;i++)
      if (cur<d[i]) cur=d[i];
     for (i=1;i<=n;i++)
      for (j=0;j<c[i];j++)
       {
        k=a[i][j];
        if (d[i]<=d[k] && d[i]+b[i][j]>d[k] && cur<(double)d[k]+((double)(b[i][j]-(d[k]-d[i])))/2.0)
         cur=(double)d[k]+((double)(b[i][j]-(d[k]-d[i])))/2.0;
       }
     if (res>cur) res=cur;
    }
   printf("%.1lf\n",res);
   return 0;
  }
