#include <fstream>
#include <iomanip>
#include <iostream>
#include <math.h>
#include <vector>
using namespace std;
#define maxN 10000
#define accr 0.00001
#define maxDBL 2000000000
typedef struct point { double x,y; };

point Left[maxN+1],Right[maxN+1];
int N,M;
double L[maxN+1],R[maxN+1];

double dist(point A,point B);
void update(point A,double old,int ll,int rr);
int eq(double a,double b) { return (a-b>-accr&&a-b<accr); }

int main()
{
// ifstream fin("river.in");
 cin>>N>>M;
 int br;
 for (br=1;br<=N;br++)
     cin>>Left[br].x>>Left[br].y;
 for (br=1;br<=M;br++)
     cin>>Right[br].x>>Right[br].y;
// fin.close();
 int l,r;
 for (l=1;l<=N;l++) L[l]=maxDBL;
 for (r=1;r<=M;r++) R[r]=maxDBL;
 L[1]=0;
 for (l=1,r=1;l<=N||r<=M;) {
    if (Left[l].y-accr<Right[r].y&&l<=N) { update(Left[l],L[l],l+1,r);l++; }
       else { update(Right[r],R[r],l,r+1);r++; }
    if (r==1&&!eq(R[M],maxDBL)) { l=N+1;r=M+1; } }
 cout<<setiosflags(ios::fixed)<<setprecision(4)<<R[M]<<endl;
 return 0;
}

double dist(point A,point B)
{
 return sqrt((A.x-B.x)*(A.x-B.x)+(A.y-B.y)*(A.y-B.y));
}

void update(point A,double old,int ll,int rr)
{
 double mincos=-1,maxcos=1;
 int i,j,fl,ok;
 for (i=ll,j=rr;i<=N||j<=M;) {
    if (Left[i].y-accr<Right[j].y-accr&&i<=N) {
       fl=0;
       mincos=max(mincos,(Left[i].x-A.x)/dist(Left[i],A));
       ok=eq(mincos,(Left[i].x-A.x)/dist(Left[i],A)); } else {
       fl=1;
       maxcos=min(maxcos,(Right[j].x-A.x)/dist(Right[j],A));
       ok=eq(maxcos,(Right[j].x-A.x)/dist(Right[j],A)); }
    if (mincos-accr>maxcos) return;
    if (!fl) {
       if (ok) L[i]=min(L[i],old+dist(Left[i],A));
       i++; } else {
       if (ok) R[j]=min(R[j],old+dist(Right[j],A));
       j++; } }
}
