#include <stdio.h>
#include <math.h>

#define maxp 10001

typedef long double t1;

class point { public:
              long x,y;
              void operator = (const point &a)
                       { x=a.x;
                         y=a.y;
                       }
              t1 operator *(const point &a)
                       { return sqrt(((t1)(x-a.x))*((t1)(x-a.x))+((t1)(y-a.y))*((t1)(y-a.y)));
                       }
            };

point l[maxp],r[maxp],o[maxp*2];
long rc,o2c,lc,oc,o2[maxp*2];
int o1[maxp*2];

void inp(void)
{ long i;
  scanf("%ld%ld",&lc,&rc);
  for (i=0;i<lc;i++) scanf("%ld%ld",&l[i].x,&l[i].y);
  for (i=0;i<rc;i++) scanf("%ld%ld",&r[i].x,&r[i].y);
}
void join(void)
{ long i,j;
  i=1;j=1;
  o[0]=l[0];
  o1[0]=1;
  o[1]=r[0];
  o1[1]=0;
  oc=2;
  while (i<lc)
    if (l[i].y<=r[j].y) { o[oc]=l[i];o1[oc++]=1;i++;}
    else { o[oc]=r[j];o1[oc++]=0;j++;}
  while (j<rc) { o[oc]=r[j];o1[oc++]=0;j++;}
}
t1 S(point a,point b,point c)
{ //return (t1)a.x*(t1)b.y+(t1)b.x*(t1)c.y+(t1)a.y*(t1)c.x-(t1)c.x*(t1)b.y-(t1)b.x*(t1)a.y-(t1)a.x*(t1)c.y;
    return (t1)a.x*(t1)b.y+(t1)b.x*(t1)c.y+(t1)a.y*(t1)c.x-(t1)c.x*(t1)b.y-(t1)b.x*(t1)a.y-(t1)a.x*(t1)c.y;
}
void solve(long i,long j)
{ long i1=i-1;
  t1 x;
  while (i<j)
  { //printf("%ld %ld\n",i,j);
    x=S(o[i1],o[i],o[j]);
    if ((o1[i] && x<=0) || ((!o1[i]) && x>=0)) ++i;
    else break;
  }
  if (i==j) return;
  solve(i1+1,i);
  o2[o2c++]=i;
  solve(i+1,j);
}
void outp(void)
{ long i;
  t1 x=0;
  --o2c;
  for (i=0;i<o2c;i++) x=x+o[o2[i]]*o[o2[i+1]];
  printf("%Lf\n",x);
}
int main(void)
{ inp();
  join();
  o2[0]=0;
  o2c=1;
  solve(1,oc-1);
  o2[o2c++]=oc-1;
  outp();
  return 0;
}

