/*
KEYW: dynamical programming
*/

#include <cstdio>

const int MAXN = 1 << 10;

int K, N, M;
int vec[MAXN];
long long opt[MAXN];

int main () {
	scanf ("%d %d %d\n", &K, &N, &M);

	int i, j;
	for (i = 0; i < N; ++i) {
		scanf ("%d", &vec[i]);
	}

	opt[0] = 1ll;
	for (i = 0; i < N; ++i)
		for (j = (K-1 < i ? K-1 : i); j >= 0; --j) {
			opt[j+1] += opt[j] * vec[i];
			opt[j+1] %= M;
		}

	printf ("%Ld\n", opt[K]);

	return 0;
}
