program sum;

const
	MAXN					= 1000;

type
	Integer					= LongInt;

var
	f					: Array [1 .. MAXN, 1 .. MAXN] of Integer;
	x					: Array [1 .. MAXN] of Int64;
	c					: Array [1 .. MAXN] of Int64;
	M					: Int64;
	K, N, i, j, t				: Integer;

procedure readInput;
begin
	readln(K, N, t);
	M := t;
	for i := 1 to N do begin
		read(t);
		x[i] := t;
	end;
end;

procedure Solve;
begin
	for i := 1 to MAXN do
		for j := 1 to MAXN do
			f[i, j] := 0;
	for i := 1 to N do
		f[1, i] := x[i] mod M;
        c[N] := f[1, N];
        for i := (N-1) downto 1 do
        	c[i] := (f[1, i] + c[i+1]) mod M;
	for i := 2 to k do begin
		for j := 1 to (N-i+1) do
			f[i, j] := ((x[j] mod M) * c[j+1]) mod M;
		c[N] := f[i, N];
		for j := (N-1) downto 1 do
			c[j] := (f[i, j] + c[j+1]) mod M;
	end;
	writeln(c[1]);
end;

begin
	readInput;
	Solve;
end.