#include<iostream>
using namespace std;

const int M=600;
long long int b[M+1][M+1]; // 64 bits integers
int n;

/*
  b[i][j] counts representations of i as a sum
  composed by some elements taken from 1,2,...,i-1,
  being the first element equal to j.
*/

int main()
{
 cin >> n; 
 
 int i,j,k;
 long long int s;
 
 for(i=3;i<=n;i++)
 for(j=1;j<((i-1)/2 + 1);j++)
  { s=1;
    for(k=j+1;k<=((i-j-1)/2+1);k++) s += b[i-j][k];                    
    b[i][j] += s;
  } 

 s=0;
 for(j=1;j<=((n-1)/2+1);j++) s += b[n][j];        
 cout << s << "\n";
    
 return 0;
}


