type
   trect = record x1,y1,x2,y2 : longint; end;
var
   w, h, k : longint;
   a : array[1..500] of trect;
   b,tt : array[1..10000] of trect;
   ms : array[1..2000,1..2000] of boolean;
   pp : array[1..2000] of longint;
   npp : longint;
   c : longint;

function min(a, b : longint) : longint;
begin
   if a<b then min:=a else min:=b;
end;
function max(a, b : longint) : longint;
begin
   if a>b then max:=a else max:=b;
end;

procedure add(x1, y1, x2, y2 : longint);
begin
   if (x1 < x2) and (y1 < y2) then
   begin
      inc(c);
      b[c].x1:=x1;
      b[c].y1:=y1;
      b[c].x2:=x2;
      b[c].y2:=y2;
   end;
end;

procedure cut(n : trect);
var
   z : array[1..50000] of boolean;
   ccc, cc : longint;
   nz : longint;
   i, j : longint;
begin
   fillchar(z, sizeof(z[1])*c, false);
   ccc:=c;
   for i:=1 to ccc do
      with b[i] do
         if (n.x1 < x2) and (n.x2 > x1) and (n.y1 < y2) and (n.y2 > y1) then
         begin
            z[i]:=true;
            add(x1, y1, x2, n.y1);
            add(x1, n.y2, x2, y2);
            add(x1, max(y1,n.y1), n.x1, min(y2,n.y2));
            add(n.x2, max(y1,n.y1), x2, min(y2,n.y2));
         end;

   cc:=0;
   for i:=1 to c do
      if (not z[i]) or (i > ccc) then
      begin
         inc(cc);
         tt[cc]:=b[i];
      end;
   b:=tt;
   c:=cc;
end;

procedure path(v1, v2 : longint);
var
   q : array[1..3000] of record v,l : longint; end;
   u : array[1..3000] of boolean;
   i1, i2, i, j : longint;
begin
   npp:=0;
   fillchar(u, sizeof(u), false);
   u[v1]:=true;
   q[1].v:=v1;
   q[1].l:=0;
   i1:=1; i2:=2;
   while i1 < i2 do
   begin
      for i:=1 to c do
         if (not u[i]) and ms[i, q[i1].v] then
         begin
            if i = v2 then
            begin
               npp:=1;
               pp[1]:=v2;
               j:=i1;
               repeat
                  inc(npp);
                  pp[npp]:=q[j].v;
                  j:=q[j].l;
               until q[j].v=v1;
               inc(npp);
               pp[npp]:=v1;
               exit;
            end;
            q[i2].v:=i;
            q[i2].l:=i1;
            u[i]:=true;
            inc(i2);
         end;
      inc(i1);
   end;
end;

procedure fff(i,j : longint; var xa,ya,xb,yb : double);
var t : longint;
begin
   if max(b[i].x1, b[j].x1) < min(b[i].x2, b[j].x2) then
   begin
      xa:=(max(b[i].x1, b[j].x1) + min(b[i].x2, b[j].x2))/2;
      xb:=xa;
      if b[i].y1 = b[j].y2 then
      begin
         ya:=b[i].y1+0.01;
         yb:=b[i].y1-0.01;
      end
      else
      begin
         ya:=b[i].y2-0.01;
         yb:=b[i].y2+0.01;
      end;
   end
   else
   begin
      ya:=(max(b[i].y1, b[j].y1) + min(b[i].y2, b[j].y2))/2;
      yb:=ya;
      if b[i].x1 = b[j].x2 then
      begin
         xa:=b[i].x1+0.01;
         xb:=b[i].x1-0.01;
      end
      else
      begin
         xa:=b[i].x2-0.01;
         xb:=b[i].x2+0.01;
      end;
   end
end;

var
   fin, fout : text;
   i, j : longint;
   v1, v2 : longint;
   res,res2 : array[1..20000] of record x, y : double; end;
   nn : longint;
   xa,xb,ya,yb : double;
   last : double;
begin
   assign(fin, 'path.in');
   assign(fout, '');
   reset(fin);
   readln(fin, w, h, k);
   for i:=1 to k do
      readln(fin, a[i].x1, a[i].y1, a[i].x2, a[i].y2);
   close(fin);

   c:=0;
   add(0,0,w,h);
   for i:=1 to k do
      cut(a[i]);

   for i:=1 to c do
      if b[i].x1+b[i].y1 = 0 then
      begin
         v1:=i;
         break;
      end;
   for i:=1 to c do
      if (b[i].x2=w) and (b[i].y2=h) then
      begin
         v2:=i;
         break;
      end;

   for i:=1 to c do
      for j:=i+1 to c do
      begin
         if max(b[i].x1, b[j].x1) < min(b[i].x2, b[j].x2) then
         begin
            ms[i,j]:=(b[i].y1 = b[j].y2) or (b[i].y2 = b[j].y1);
            ms[j,i]:=ms[i,j];
         end;
         if max(b[i].y1, b[j].y1) < min(b[i].y2, b[j].y2) then
         begin
            ms[i,j]:=(b[i].x1 = b[j].x2) or (b[i].x2 = b[j].x1);
            ms[j,i]:=ms[i,j];
         end;
      end;

   path(v1, v2);
   if npp = 0 then
   begin
      writeln(-1);
      exit;
   end;

   nn:=2*(npp-1);
   for i:=0 to npp-2 do
   begin
      fff(pp[i+1],pp[i+2],xa,ya,xb,yb);
      res[i*2+1].x:=xa;
      res[i*2+1].y:=ya;
      res[i*2+2].x:=xb;
      res[i*2+2].y:=yb;
   end;
   res[2*(npp-1)+1].x:=-1;

   nn:=0;
   last:=-1;
   for i:=1 to 2*(npp-1) do
   begin
      if res[i].x <> last then
      begin
         inc(nn);
         res2[nn]:=res[i];
      end
      else
         if res[i+1].x <> last then
         begin
            inc(nn);
            res2[nn]:=res[i];
         end;
      last:=res[i].x;
   end;

   rewrite(fout);
   writeln(fout, nn);
   for i:=nn downto 1 do
      writeln(fout, res2[i].x:0:2, ' ', res2[i].y:0:2);
   close(fout);
end.
