#include <stdio.h>

#define MINN 3
#define MAXN 499

typedef long double num_type;

num_type ar1[MAXN+1]={1}, ar2[MAXN+1]={0}, *curr=ar1, *next=ar2;

inline void subseq(int n)
{
    int i;
    num_type a;
    memset(next,0,sizeof(num_type)*(MAXN+1));
    for (i=0;i+n<=MAXN;i++)
        next[i+n]=curr[i];
    for (i=0;i<=MAXN;i++)
        next[i]+=curr[i];
    if (curr==ar1) curr=ar2,next=ar1;
    else curr=ar1,next=ar2;
}

int main(void)
{
    int n,i;
    scanf("%d", &n);
    for (i=1;i<n;i++)
        subseq(i);
    printf("%.0Lf\n", curr[n]);
    return 0;
}

