/*
TASK:oper
LANG:C++
*/
#include <iostream>
#include <set>
#include <vector>
#define FOR(i,n) for(int i=0;i<n;i++)
#define debln(a) cout << #a << " : " << a << endl;
#define REP(i,f,t) for(int i=f;i<=t;i++)
using namespace std;

int A[102][102];
bool calc[102][102];
vector< vector< set<int> > > F;
vector<int> v;
int n,k;

void init() {
     cin >> k;
     REP(i,1,k) REP(j,1,k) cin >> A[i][j];
     int tmp;
     cin >> n;
     v.resize(n+1);
     REP(i,1,n) cin >> v[i];
     
     F.resize(n+1);
     REP(i,1,n) {
         F[i].resize(n+1);
         F[i][i].insert(A[v[i]][v[i]]);
         calc[i][i] = 1;
     }
     
}
void solve(int x,int y) {
     if(x==y-1) {
       F[x][y].insert(A[v[x]][v[y]]);
       calc[x][y] = 1;
       return;
     }
     calc[x][y] = 1;
     for(int k=x+1;k<y;k++) {
        if(!calc[x][k]) solve(x,k);
        if(!calc[k+1][y]) solve(k+1,y);
        set<int>::iterator it,it2;
        for(it=F[x][k].begin();it!=F[x][k].end();++it)
           for(it2=F[k+1][y].begin();it2!=F[k+1][y].end();++it2)
               F[x][y].insert(A[*it][*it2]);
     }
}
int main() {
    init();
    solve(1,n);
    cout<<F[1][n].size()<<endl;
    return 0;}
