/*
TASK:reliab
LANG:C++
*/

#include <iostream>
#include <cstdlib>
using namespace std;

#define max(a,b) ((a)>(b)?(a):(b))

long long N, H;

void Out(long long R) {
     cout << R;
     exit(0);
}

void Init(void) {
     cin >> N >> H;
     if(N==1) Out(H);
}

long long Check2(long long x, long long h) {
    long long i;
    long long s=0;
    long long c=0;
    long long oldx = x;
    //printf("%d\n",x);
    while(x)
    {
     s+=x;
     c++;
     x--;
//     printf("%d\n",s);
    }
//    printf("%d %d %d\n",h,s,c);
      if(s>=h) return x;
      return (h-s)+c;
}

void Solve2(long long h) {
   long long l=1; long long r=h;
   long long Best=0;
   long long mid;
   while(l<=r)
   {
    mid=(l+r)/2;
    if(Check2(mid,h)<=mid)
    {
     r = mid-1;
     Best = mid;
    }
    else l=mid+1;
   }
   cout << Best << endl;
}

void Solve(long long h) {
     long long nH=h;
     long long i;
     for(i=N; i>2; i--)
     {
         nH = max(nH/2,nH-nH/2);
     }
     Solve2(nH);
}


int main(void) {
    Init();
    Solve(H);
//    printf("%d\n",Check2(14,100));
    return 0;
}
