{
TASK:oper
LANG:Pascal
}
program oper;

const
	MAXK				= 100;
	MAXN				= 30;

type
	TDPTable			= record
		a			: Array [1 .. MAXK] of Boolean;
		b			: Array [1 .. MAXK] of Integer;
		n			: Integer;
	end;

var
	D				: Array [1 .. MAXN, 1 .. MAXN] of TDPTable;
	F				: Array [1 .. MAXK, 1 .. MAXK] of Integer;
	N, K, i, j, x, y		: Integer;
	a				: Array [1 .. MAXN] of Integer;

procedure readInput;
begin
	readln(K);
	for i := 1 to K do begin
		for j := 1 to K do
			read(F[i, j]);
		readln;
	end;
	readln(N);
	for i := 1 to N do
		read(a[i]);
end;

procedure writeOutput;
begin
	writeln(D[1, N].n);
end;

procedure Solve;
var
	l, p				: Integer;
begin
	for i := 1 to N do
		for j := 1 to N do begin
			D[i, j].n := 0;
			for x := 1 to K do
				D[i, j].a[x] := False;
		end;
	for i := 1 to N do begin
		D[i, i].n := 1;
		D[i, i].b[1] := a[i];
		D[i, i].a[a[i]] := True;
	end;
	for y := 1 to (N-1) do
		for i := 1 to (N-y) do begin
			j := i+y;
			for x := i to (j-1) do
				for l := 1 to D[i, x].n do
					for p := 1 to D[x+1, j].n do
						D[i, j].a[F[D[i,x].b[l], D[x+1, j].b[p]]] := True;
			for x := 1 to K do
				if (D[i, j].a[x]) then begin
					D[i, j].n := D[i, j].n + 1;
					D[i, j].b[D[i, j].n] := x;
				end;
		end;
end;

begin
	readInput;
	Solve;
	writeOutput;
end.