/*
TASK:reliab
LANG:C
*/
#include <stdio.h>
#include <string.h>
#include <math.h>

#define MAXN 5000

long n, h;
long f1[MAXN], f2[MAXN];

long max(long a, long b)
{
  if(a > b)
    return a;
  return b;
}

long min(long a, long b)
{
  if(a < b)
    return a;
  return b;
}


long log2(long a)
{
  long x;
  if(a == 0)
    return 0;
  for(x = 0; pow(2, x) < a; x++);
  return x;
}

int main(void)
{
  long i, j, x;
  scanf("%ld %ld", &n, &h);

  if(n == 1)
  {  printf("%ld\n", h); return 0;}
  if(n >= log2(h+1))
  {  printf("%ld\n", log2(h+1)); return 0;}
  if(n == 2)
  {
    printf("%ld\n", (long)ceil((sqrt(8*h+1)-1)/2));
    return 0;
  }
  for(i = 1; i <= h; i++)
    f2[i] = f1[i] = i;
  for(i = 2; i <= n; i++)
  {
    for(j = 3; j <= h; j++)
    {
      x = i;
      if(x < j>>1)
        f2[j] = h;
      for(; x < j/2; x++)
        f2[j] = min(f2[j], max(f1[x-1], f2[j-x])+1);
    }
    memcpy(f1, f2, (h+1)*sizeof(long));
  }
  printf("%ld\n", f1[h]);
  return 0;
}
