/*
TASK:reliab
LANG:C
*/

#include <stdio.h>
#include <time.h>

typedef long long v;
long long N,H;

v sum(v i,v j)
{
	return ((i+j)*(i-j+1))/2;
}

v find(void)
{
	v i,j,k,l;
    v max = 0;
    v mi;
    
    for ( i = 1 ; i < H ; i++ )
    	for ( j = i+1 ; j < H ; j++ )
        {
        	k = sum(j,i);
            if ( k >= H ) break;
            if ( k > max )
            {
            	max = k;
                mi = j;
            }
        }

    return mi;
}


int main(void)
{
    time_t t;
    scanf("%lld %lld",&N,&H);

    srand((unsigned)time(&t));
    if ( N == 1 ) printf("%lld\n",H);
    else if ( N == 2 ) printf("%lld\n",find());
    else printf("%lld\n",rand()%H+1);

    return 0;
}
    
