/*
TASK:perm
LANG:C++
*/

#include <iostream>
#include <iomanip>
#include <algorithm>
using namespace std;
#define maxN 50

long double F[maxN+1][maxN+1];
int N,P[maxN+1],STOP;
bool Small[maxN+1],Big[maxN+1];

void fill();
void solve();
void Try();
bool check();
void proceed(int poz);

int main()
{
 fill();
 solve();
 return 0;
}

void fill()
{
 F[1][0]=1;
 int i,j,k;
 for (i=2;i<=maxN;i++) {
    for (j=0;j<=maxN;j++) F[i][j]=F[i-1][j];
    for (j=1;j<i;j++)
       for (k=0;k<j;k++) F[i][j]+=F[i-1][k]; }
}

void solve()
{
 int br;
 cin>>N;
 long double Res=0;
 for (br=0;br<=maxN;br++) Res+=F[N][br];
 cout<<setiosflags(ios::fixed)<<setprecision(0);
 cout<<Res<<endl;
 for (br=1;br<=N;br++) cin>>P[br];
// for (br=1;br<=N;br++) P[br]=br;
// random_shuffle(P+1,P+N+1);
 if (!next_permutation(P+1,P+N+1)) {
   for (br=1;br<=N;br++) {
      if (br<N) cout<<br<<' ';
         else cout<<br<<endl; } return; }
   else Try();
 if (STOP) for (br=1;br<=N;br++) P[br]=br;
 for (br=1;br<=N;br++)
    if (br<N) cout<<P[br]<<' ';
       else cout<<P[br]<<endl;
}

void Try()
{
 if (check()) return;
 int i,j,k;
 bool bl,sl,stop=false;
 for (i=N;i>0;i--) {
    for (j=1,bl=0,sl=0;j<=N;j++) {
       if (P[j]<P[i]&&j>i) sl=1;
       if (P[j]>P[i]&&j<i) bl=1; }
    if (bl&&sl) {
       proceed(i);
       i=0; } }
 if (i==0) {
    if (P[1]==N) for (j=1;j<=N;j++) P[j]=j;
       else for (P[1]++,j=2,k=1;j<=N;j++,k++) {
           if (k==P[1]) k++;
           P[j]=k; }
    return; }
 Try();
}

bool check()
{
 int bci,bcj;
 if (STOP) return true;
 for (bci=1;bci<=N;bci++)
    for (bcj=1,Small[bci]=false;bcj<=N;bcj++)
       if (P[bcj]>P[bci]&&bcj<bci) Small[bci]=true;
 for (bci=1;bci<=N;bci++)
    for (bcj=1,Big[bci]=false;bcj<=N;bcj++)
       if (P[bcj]<P[bci]&&bcj>bci) Big[bci]=true;
 for (bci=1;bci<=N;bci++)
    if (Big[bci]&&Small[bci]) return false;
 return true;
}

void proceed(int poz)
{
 int best=maxN+1,uk=0,bci;
 for (bci=poz+1;bci<=N;bci++)
    if (P[bci]>P[poz]&&P[bci]<best) {
       best=P[bci];
       uk=bci; }
 if (best<maxN+1) {
    swap(P[poz],P[uk]);
    sort(P+poz+1,P+N+1);
    return; }
 sort(P+poz,P+N+1);
 for (best=maxN+1,uk=0,bci=poz;bci<=N;bci++)
    if (P[bci]>P[poz-1]&&P[bci]<best) {
       best=P[bci];
       uk=bci; }
 if (!uk) {
   if (poz==2) { STOP=1;return; }
   swap(P[poz-2],P[poz-1]);
   sort(P+poz-1,P+N+1);
   if (poz>3)
      for (bci=poz-1;bci<=N;bci++)
          if (P[poz-3]<P[bci]&&P[bci]<P[poz-2])
             swap(P[poz-2],P[bci]);
    sort(P+poz-1,P+N+1); }
    else swap(P[poz-1],P[uk]);
}
