
{ Dumitru Bogdan }

{ Explicatie scurta a rezolvarii.
  Problema se reduce la a rezolva un sistem de 3 ecuatii cu N
 necunoscute. Intrucat acest lucru este irealizabil pentru N>3, se
 incearca pe rand rezolvarea unui sistem de 3 ecuatii cu 1, 2 si apoi
 3 necunoscute. Algoritmul are astfel 3 etape :
 - se considera amestecul I (1 <= I <= N) si se incearca obtinerea
 amestecului final folosind doar acest amestec - O(N);
 - se considera amestecurile I si J (1 <= I < J <= N) si se incearca
 obtinerea amestecului final folosind doar aceste amestecuri - O(N^2);
 - se considera amestecurile I, J si K (1 <= I < J < K <= N) si se
 incearca obtinerea amestecului final folosind doar aceste amestecuri
 - O(N^3);
  Daca nici o tentativa nu reuseste, problema nu admite solutie.}

program alchimie;

const ni='amestec.in';
      no='amestec.out';
      nmax=100;

var f:text;
    a,b,c:array [1..nmax] of longint;
    r:array [1..3] of real;
    n,i,j,k,aa,bb,cc,l,aux,plus,minus,det,dx,dy,dz:longint;
    x,y,z:real;
    ok:boolean;

procedure load;
begin
     assign(f,ni);reset(f);
     readln(f,n);
     for i:=1 to n do
        readln(f,a[i],b[i],c[i]);
     readln(f,aa,bb,cc);
     close(f);
end;

procedure scrie(mesg:string);
begin
     assign(f,no);rewrite(f);
     write(f,mesg);
     close(f);
     halt;
end;

procedure try_1;
begin
     for i:=1 to n do begin
        ok:=true;
        l:=0;
        if aa=0 then begin
          if a[i]<>0 then ok:=false;
                     end
        else
            if a[i]=0 then ok:=false
            else begin
                l:=l+1;
                r[l]:=aa/a[i];
                 end;
       if bb=0 then begin
          if b[i]<>0 then ok:=false;
                     end
        else
            if b[i]=0 then ok:=false
            else begin
                l:=l+1;
                r[l]:=bb/b[i];
                 end;
        if cc=0 then begin
          if c[i]<>0 then ok:=false;
                     end
        else
            if c[i]=0 then ok:=false
            else begin
                l:=l+1;
                r[l]:=cc/c[i];
                 end;
        for j:=1 to l-1 do
           for k:=j+1 to l do
              if r[j]<>r[k] then ok:=false;
        if ok then scrie('DA');
                      end;
end;


procedure try_2;
begin
     for i:=1 to n-1 do
        for j:=i+1 to n do begin

           if (a[i]*b[j]<>a[j]*b[i]) and ((a[j]<>0) or (b[j]<>0))
             then begin
                 x:=(aa*b[j]-a[j]*bb)/(a[i]*b[j]-a[j]*b[i]);
                 if a[j]<>0 then y:=(aa-a[i]*x)/a[j]
                 else y:=(bb-b[i]*x)/b[j];
                 if (x>0) and (y>0) then
                   if c[i]*x+c[j]*y=cc then scrie('DA');
                 end;

           aux:=b[i];
           b[i]:=c[i];
           c[i]:=aux;
           aux:=b[j];
           b[j]:=c[j];
           c[j]:=aux;
           if (a[i]*b[j]<>a[j]*b[i]) and ((a[j]<>0) or (b[j]<>0))
             then begin
                 x:=(aa*b[j]-a[j]*bb)/(a[i]*b[j]-a[j]*b[i]);
                 if a[j]<>0 then y:=(aa-a[i]*x)/a[j]
                 else y:=(bb-b[i]*x)/b[j];
                 if (x>0) and (y>0) then
                   if c[i]*x+c[j]*y=cc then scrie('DA');
                  end;
           aux:=b[i];
           b[i]:=c[i];
           c[i]:=aux;
           aux:=b[j];
           b[j]:=c[j];
           c[j]:=aux;

           aux:=a[i];
           a[i]:=c[i];
           c[i]:=aux;
           aux:=a[j];
           a[j]:=c[j];
           c[j]:=aux;
           if (a[i]*b[j]<>a[j]*b[i]) and ((a[j]<>0) or (b[j]<>0))
             then begin
                 x:=(aa*b[j]-a[j]*bb)/(a[i]*b[j]-a[j]*b[i]);
                 if a[j]<>0 then y:=(aa-a[i]*x)/a[j]
                 else y:=(bb-b[i]*x)/b[j];
                 if (x>0) and (y>0) then
                   if c[i]*x+c[j]*y=cc then scrie('DA');
                  end;
           aux:=a[i];
           a[i]:=c[i];
           c[i]:=aux;
           aux:=a[j];
           a[j]:=c[j];
           c[j]:=aux;

                           end;
end;

procedure try_3;
begin
     for i:=1 to n-2 do
        for j:=i+1 to n-1 do
           for k:=j+1 to n do begin
              plus:=a[i]*b[j]*c[k]+b[i]*c[j]*a[k]+c[i]*a[j]*b[k];
              minus:=c[i]*b[j]*a[k]+a[i]*c[j]*b[k]+b[i]*a[j]*c[k];
              det:=plus-minus;
              if det<>0 then begin
                plus:=aa*b[j]*c[k]+bb*c[j]*a[k]+cc*a[j]*b[k];
                minus:=cc*b[j]*a[k]+aa*c[j]*b[k]+bb*a[j]*c[k];
                dx:=plus-minus;
                x:=dx/det;
                plus:=a[i]*bb*c[k]+b[i]*cc*a[k]+c[i]*aa*b[k];
                minus:=c[i]*bb*a[k]+a[i]*cc*b[k]+b[i]*aa*c[k];
                dy:=plus-minus;
                y:=dy/det;
                plus:=a[i]*b[j]*cc+b[i]*c[j]*aa+c[i]*a[j]*bb;
                minus:=c[i]*b[j]*aa+a[i]*c[j]*bb+b[i]*a[j]*cc;
                dz:=plus-minus;
                z:=dz/det;
                if (x>0) and (y>0) and (z>0) then scrie('DA');
                             end;
                              end;
end;

begin {programul principal}
     load;
     try_1;
     try_2;
     try_3;
     scrie('NU');
end.

