{ ---------------------------------------
| PROBLEMA 29: Amestecand... amestecuri |
| PUNCTAJ: 80 Dexteri                   |
| DEADLINE: Marti, 14 Septembrie        |
| TIMP DE IMPLEMENTARE: 70 minute       |
| TIMP DE EXECUTIE: 1 sec./test         |
 ---------------------------------------

   Pentru urmatoarele 70 de minute sunteti alchimist. Pentru a gasi
piatra filosofala, aurul divin, va trebuie multa maiestrie in potrivirea
elementelor. Asadar vi se dau 3 substante generic numite A,B,C, dar nu
separate, ci amestecate, cu proportii specificate.
   Acum sa vedem un exemplu de ce inseamna maiestrie: avem 2 amestecuri,
unul care contine substanta B in proportie de 2 ori mai mare decat A, si
C in proportie de 3 ori mai mare decat A - vom nota aceasta substanta cu
proportiile 1:2:3, iar cealalta substanta cu proportiile 3:7:1 (adica
substanta A e in proportie de 3 ori mai mare decat C, iar B de 7 ori mai
mare decat C). Amestecand cele 2 solutii in proportie de 1:2 (adica la o
parte din prima substanta, punem 2 parti din a doua) obtinem un amestec
cu proportiile 7:16:5. Nu avem cum sa obtinem doar din aceste 2 substante
un amestec cu proportiile 3:4:5. Dar daca am mai avea o a treia substanta
cu proportiile 2:1:2, atunci putem obtine 3:4:5, amestecand 8 parti din
1:2:3, o parte din 3:7:1 si 5 parti din 2:1:2.
   Si cum alchimia este o stiinta precisa vrem sa aflam daca dintr-un set
de substante cu proportii date putem obtine o alta substanta cu proportii
date.

   Fisierul de intrare are numele "amestec.in". Formatul este:
   - pe prima linie contine un intreg N ce reprezinta numarul de amestecuri
     date (0<=N<100)
   - urmatoarele N linii contin cate 3 numere naturale ce reprezinta
     proportiile de substante A,B, respectiv C asa cum apar in amestec.
     Cel putin unul dintre aceste numere este nenul.
   - linia N+2 contine 3 numere naturale ce reprezinta proportiile de
     substante A,B, respectiv C ale amestecului despre care trebuie sa
     determinam daca il putem obtine din primele N amestecuri. Din nou,
     cel putin unul dintre aceste numere este nenul.

   Fisierul de iesire va avea numele "amestec.out".  Fisierul va avea 2
   octeti si va contine "DA", daca se poate obtine amestecul N+1 din primele
   N sau "NU" daca nu este posibil.

   Vor exista grupuri de 3 pana la 5 teste. Punctajul pentru un test nu va fi
obtinut decat daca sunt trecute toate testele din grupul din care face parte
testul respectiv.

   Va urez sa va distrati si la multi bani.


   Exemplul 1:

    "amestec.in"                                "amestec.out"
    2                                            NU
    1 2 3
    3 7 1
    3 4 5

   Exemplul 2:

    "amestec.in"                                "amestec.out"
    3                                           DA                                 NU
    1 2 3
    3 7 1
    2 1 2
    3 4 5
}


{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65384,0,655360}

{
 ideea de rezolvare a fost crearea unui sistem de ecuatii,
 format din 3 ecuatii cu n necunoscute. se verifica apoi daca
 sistemul este compatibil sau incompatibil. Sper sa mearga
}


program Alchimistii_Ie_De_Baza_Sau_Goana_Dupa_Aur;

   var a:array[1..100,1..101]of real;
       f:text;
       n:integer;

procedure ReadData;
   var i,j:byte;
   begin
    assign(f,'amestec.in');
    for i:=1 to 100 do for j:=1 to 101 do a[i,j]:=0;
    reset(f);
    readln(f,n);
    for i:=1 to n+1 do
     begin
      readln(f,a[1,i],a[2,i],a[3,i]);
     end;
    if n<3 then
     begin
      for i:=1 to 3 do a[i,4]:=a[i,n+1];
      for i:=1 to 3 do a[i,n+1]:=0;
      n:=3;
     end;
    for i:=4 to n do a[i]:=a[3];
   end;

function OK_to_move(k:integer):boolean;
   var i,j:integer;
       aux:real;
   begin
    Ok_to_move:=true;
    if a[k,k]<>0 then exit;
    for i:=k+1 to n do if a[k,i]<>0 then
     begin
      for j:=1 to n do begin aux:=a[j,k]; a[j,k]:=a[j,i]; a[j,i]:=aux; end;
      exit;
     end;
    for i:=k+1 to n do if a[i,k]<>0 then
     begin
      for j:=1 to n+1 do begin aux:=a[k,j]; a[k,j]:=a[i,j]; a[i,j]:=aux; end;
      exit;
     end;
    OK_to_move:=false;
   end;

procedure No;
   begin
    assign(f,'amestec.out');
    rewrite(f);
    write(f,'NU');
    close(f);
    halt;
   end;

procedure Rezolva;
   var i,ii,j:integer;
   begin
    for i:=1 to n do
     if OK_to_move(i) then
      begin
       for ii:=1 to n do if ii<>i then
        for j:=n+1 downto i do a[ii,j]:=a[ii,j]-(a[ii,i]*a[i,j]/a[i,i]);
      end;
     for i:=1 to n do
      begin
       j:=0;
       for ii:=1 to n do if a[i,ii]<>0 then j:=1;
       if j=0 then if a[i,n+1]<>0 then No;
      end;
    assign(f,'amestec.out');
    rewrite(f);
    write(f,'DA');
    close(f);
   end;

begin
 ReadData;
 Rezolva;
end.