/*
Un farmacist are o balanta medicinala de mare finete, care poate
cantari greutati intre 1 si 10^100 grame. El are cate o singura
greutate-etalon de 1g, 3g, 9g, 27g, ... etc. (deci toate puterile lui 3
exprimate in grame).

Farmacistul primeste o mica pastila si este rugat sa ii verifice
greutatea. I se spune ca greutatea pastilutei este X. El trebuie sa
aseze greutati pe ambele mici talgere ale balantei pentru a echilibra
(teoretic) pastila. Daca balanta sta in echilibru, pastila are
greutatea corecta. Sa se spuna cum trebuie asezate greutati pe
talgere.

Fisierul de intrare PASTILA.IN contine un singur numar: greutatea
pilulei X, cuprinsa intre 1 si 10^100.

Fisierul de iesire PASTILA.OUT va contine doua linii. Pe prima linie
se vor indica greutatile care trebuie asezate pe acelasi talger cu
balanta, iar pe a doua linie se vor indica greutatile care trebuie
asezate pe celalalt talger. Ordinea greutatilor pe aceeasi linie nu
conteaza.

Exemple:

PASTILA.IN              PASTILA.IN
7                       34

PASTILA.OUT             PASTILA.OUT
3                       3
1 9                     9 1 27

*/

#include <stdio.h>
#include <ctype.h>

FILE *f;
int v[120], t[120];
int n,i, nv;

void readData(){
	char ch;

	f = fopen("Pastila.in", "rt");
	do{
		ch = getc(f);
	}while(!isdigit(ch));
	i = 0; v[0] = ch - '0';
	while(!feof(f)){
		ch = getc(f);
		if(isdigit(ch)){
			i++; v[i] = ch - '0';
		}
	};
	n = i;
	fclose(f);
	f = fopen("Pastila.out", "wt");
}

void init(){
	int j;
	for( i = 0; i<=n/2; i++){
		j = v[i]; v[i] = v[n-i]; v[n-i] = j;
	}
}

void base3(){
	int r;

	int j = 0;

	while(n>=0){
		r = 0;
		for(i=n; i>=0; i--){
			v[i] += r*10;
			r = v[i] % 3;
			v[i] = v[i]/3;
		}
		t[j] = r; j++;
		if (v[n] == 0) n--;
	}
	n = j;
}

void printV(){
	int k;
	for (k=nv - 1; k >= 0; k--)
		fprintf(f,"%i", v[k]);
	fprintf(f," ");
}

void v3(){
	int k; int r=0;
	for(k=0;k<nv;k++){
		v[k]= v[k]* 3 + r;
		if(v[k]>9){
			r = v[k]/10;
			v[k] = v[k] %10;
		}
		else r=0;
	}
	if (r){
		v[nv] = r;
		nv++;
	}
}

void calculate(){
	int j;
	v[0] = 1; nv = 1;

	for(i = 0; i<n; i++){
		if (t[i] == 2){
			printV();
			for(j = i; j<n; j++){
				t[j]++;
				if (t[j]<3)
					j = n ;
				else t[j] = 0;
			}
			if (t[n-1] == 0){
				t[n] = 1;
				n++;
			}
		}
		v3();
	}
}

void theOther(){
	int j;
	fprintf(f,"\n");
	for(i=0; i< n+1;i++)
		v[i] = 0;
	v[0] = 1; nv = 1;

	for(i = 0; i<=n; i++){
		if (t[i] == 1){
			printV();
		}
		v3();
	}
}



void main(){
	readData();
	init();
	base3();
	calculate();
	theOther();
	fclose(f);

}