// Raluca Sauciuc
#include <stdio.h>
#include <string.h>

#define NMax		200

typedef int Huge[NMax];
Huge N,N3,cfA,cfB,M;
FILE *fp;

void assign(Huge& A,Huge B) { for(int i=0;i<=B[0];i++) A[i]=B[i]; }
void clean(Huge& A) { memset(A,0,NMax-1); }

void load(void)
{
	char buf[NMax];
	fp=fopen("pastila.in","rt");
	fscanf(fp,"%s",&buf);
	clean(N);
	for(int i=strlen(buf)-1;i>=0;i--) N[++N[0]]=buf[i]-'0';
	fclose(fp);
}

int divide(Huge A,Huge& B)
{
	int i,t=0;
	clean(B); B[0]=A[0];
	for(i=A[0];i>=1;i--) { B[i]=(t*10+A[i])/3; t=(t*10+A[i])%3; }
	if (!B[B[0]]) B[0]--;
	return t;
}

void mult(Huge A,Huge& B)
{
	int i,t=0;
	clean(B);
	for(i=1;i<=A[0];i++) { B[i]=(3*A[i]+t)%10; t=(3*A[i]+t)/10; }
	B[0]=A[0];
	if (t) B[++B[0]]=t;
}

void print(Huge A)
{
	for(int i=A[0];i>=1;i--) fprintf(fp,"%d",A[i]);
	fprintf(fp," ");
}

void solve(void)
{
	int i,t;
	Huge aux;
	for(N3[0]=0;(N[0]);)
		{ N3[++N3[0]]=divide(N,aux); assign(N,aux);	}
	for(t=0,i=1;i<=N3[0];i++)
	{
		if (N3[i]+t<2) { cfA[i]=0; cfB[i]=N3[i]+t; t=0; }
		else { cfA[i]=(N3[i]+t==2) ? 1:0; cfB[i]=0; t=1;  }
	}
	cfA[0]=cfB[0]=N3[0];
	if (t) cfB[++cfB[0]]=1;

	fp=fopen("pastila.out","wt");
	clean(M); M[0]=M[1]=1;
	for(i=1;i<=cfA[0];i++)
		{ if (cfA[i]) print(M); mult(M,aux); assign(M,aux); }
	fprintf(fp,"\n");
	M[0]=M[1]=1;
	for(i=1;i<=cfB[0];i++)
		{ if (cfB[i]) print(M); mult(M,aux); assign(M,aux); }
	fclose(fp);
}

void main(void)
{
	load();
	solve();
}