program Imperiu;
{$M 65000,0,655360}
const NMax=3000;
type List=^Node;
     Node=record
            V, NNodes:Integer;
            Next:List;
          end;
     Tree=array[1..NMax] of List;
var T:Tree; { T[i] este lista vecinilor nodului i
              V indica numarul vecinului, iar NNodes indica numarul de
              noduri de la capatul dinspre V al muchiei i-V }
    N, Dummy, Capital, Level:Integer;
    MinSumDist:Longint;

procedure Add(X, Y:Integer);
var L:List;
begin
  New(L);
  L^.Next:=T[X];
  T[X]:=L;
  L^.V:=Y;
end;

procedure ReadData;
var i, X, Y:Integer;
begin
  Assign(Input, 'imperiu.in'); Reset(Input);
  ReadLn(N);
  for i:=1 to N do T[i]:=Nil;
  for i:=1 to N-1 do
    begin
      ReadLn(X,Y);
      Add(X,Y);
      Add(Y,X);
    end;
  Close(Input);
end;

function CountNodes(K,Father:Integer):Integer;
{ Afla numarul de noduri de pe muchia K-Father, dinspre nodul K }
var L, LSave:List;
    S:Integer;
begin
  S:=1;
  L:=T[K];
  while L<>Nil do
    begin
      if L^.V<>Father
        then begin
               L^.NNodes:=CountNodes(L^.V, K);
               Inc(S,L^.NNodes);
             end
        else LSave:=L;
      L:=L^.Next;
    end;
  if Father<>0 then LSave^.NNodes:=N-S;
  CountNodes:=S;
end;

function SumDist(K,Father:Integer):Longint;
{ Calculeaza recursiv suma distantelor de la un nod la toate celelalte }
var S:Longint;
    L:List;
begin
  Inc(Level);
  S:=0;
  L:=T[K];
  while L<>Nil do
    begin
      if L^.V<>Father then Inc(S, SumDist(L^.V, K));
      L:=L^.Next;
    end;
  SumDist:=S+Level;
  Dec(Level);
end;

procedure FindCapital(K, Father:Integer; SumK:Longint);
var L:List;
begin
  if SumK<MinSumDist
    then begin
           Capital:=K;
           MinSumDist:=SumK;
         end;
  L:=T[K];
  while L<>Nil do
    begin
      if L^.V<>Father then FindCapital(L^.V, K, SumK+N-2*L^.NNodes);
      L:=L^.Next;
    end;
end;

procedure Extensie;
{ Nu este o parte necesara a programului, ci numai o carpeala. Tipareste
  toate nodurile cu suma distantelor minima (toate solutiile) }
var i:Integer;
begin
  Write('Lista tuturor capitalelor posibile este:');
  for i:=1 to N do
    if SumDist(i, 0)=MinSumDist
      then Write(' ', i);
  WriteLn;
end;

begin
  ReadData;
  Dummy:=CountNodes(1,0);
  MinSumDist:=MaxLongint;
  Level:=-1;
  FindCapital(1, 0, SumDist(1,0));
  WriteLn(Capital, ' ', MinSumDist);
  { Extensie; }
end.
