#include <alloc.h>
#include <stdio.h>
#include <stdlib.h>

#define NMAX    3000

typedef struct Node_
                {
                        int son;
                        long int dist;
                        int nodes;
                        struct Node_ far *next;
                } Node;

typedef struct Nodeinfo_
                {
                        long int dist;
                        int nodes;
                } Nodeinfo;

int N,i,j,k;
Node far *a[NMAX+1];
Node far *aux;
Node far *t1;
Node far *t2;
int used[NMAX+1];
Nodeinfo c[NMAX+1];

void load(void)
{
        FILE *fp;
        fp=fopen("imperiu.in","rt");
        fscanf(fp,"%d",&N);
        for(i=1;i<N;i++)
                {
                        fscanf(fp,"%d%d\n",&j,&k);
                        aux=(Node far *)farmalloc(sizeof(struct Node_));
                        if (aux==NULL)
                                {
                                        printf("! Spuneai ca sunt 96Mb RAM ..... gee...\n");
                                        exit(0);
                                }
                        aux->son=k;     aux->dist=0; aux->nodes=0;
                        aux->next=a[j]; a[j]=aux;
                        aux=(Node far *)farmalloc(sizeof(struct Node_));
                        if (aux==NULL)
                                {
                                        printf("! Spuneai ca sunt 96Mb RAM ..... gee...\n");
                                        exit(0);
                                }
                        aux->son=j;     aux->dist=0; aux->nodes=0;
                        aux->next=a[k]; a[k]=aux;
                }
        fclose(fp);
}


void go(int k)
{
        Node far *aux;
        for(aux=a[k];(aux);aux=aux->next)
                if (!used[aux->son])
                {
                        used[aux->son]=1;
                        go(aux->son);
                        used[aux->son]=0;
                        aux->nodes=c[aux->son].nodes+1;
                        aux->dist=c[aux->son].dist+c[aux->son].nodes+1;
                        c[k].nodes+=aux->nodes;
                        c[k].dist+=aux->dist;
                }
}

void goback(int k)
{
        Node far *aux;

        for(aux=a[k];(aux);aux=aux->next)
                if (!used[aux->son])
                {
                        for(t1=a[aux->son];t1->son!=k;t1=t1->next);
                        for(t2=a[k];(t2);t2=t2->next)
                                if (t2->son!=aux->son)
                                        { t1->nodes+=t2->nodes; t1->dist+=t2->dist;     }
                        t1->dist=t1->nodes+t1->dist+1;
                        t1->nodes++;
                        used[aux->son]=1;
                        goback(aux->son);
                        used[aux->son]=0;
                }
}

void getitoverwith(void)
{
        Node far *aux;
        long int min=(long int)N*N;
        int nd;

        for(i=1;i<=N;i++)
                {
                        c[i].dist=0;
                        for(aux=a[i];aux;aux=aux->next) c[i].dist+=aux->dist;
                }
        for(i=1;i<=N;i++)
                if (c[i].dist<min) { min=c[i].dist; nd=i; }
        printf("%d %ld\n",nd,min);
}

void main(void)
{
        load();
        for(i=1;i<=N;i++) { c[i].dist=0; c[i].nodes=0; }
        used[1]=1;      go(1);  used[1]=0;
        for(i=1;i<=N;i++) { c[i].dist=0; c[i].nodes=0; }
        used[1]=1;      goback(1);      used[1]=0;
        getitoverwith();
}
