#include <alloc.h>
#include <stdio.h>
#include <stdlib.h>

#define NMAX    3000

typedef struct Node_
                {
                        int son;
                        long int dist;
                        int nodes;
                        struct Node_ far *next;
                } Node;

typedef struct Nodeinfo_
                {
                        long int dist;
                        int nodes;
                } Nodeinfo;

int N,i,j,k;
Node far *a[NMAX+1];
Node far *aux;
int used[NMAX+1];
Nodeinfo c[NMAX+1];

void load(void)
{
        FILE *fp;
        fp=fopen("imperiu.in","rt");
        fscanf(fp,"%d",&N);
        for(i=1;i<N;i++)
                {
                        fscanf(fp,"%d%d\n",&j,&k);
                        aux=(Node far *)farmalloc(sizeof(struct Node_));
                        if (aux==NULL)
                                {
                                        printf("! Spuneai ca sunt 96Mb RAM ..... gee...\n");
                                        exit(0);
                                }
                        aux->son=k;     aux->dist=0; aux->nodes=0;
                        aux->next=a[j]; a[j]=aux;
                        aux=(Node far *)farmalloc(sizeof(struct Node_));
                        if (aux==NULL)
                                {
                                        printf("! Spuneai ca sunt 96Mb RAM ..... gee...\n");
                                        exit(0);
                                }
                        aux->son=j;     aux->dist=0; aux->nodes=0;
                        aux->next=a[k]; a[k]=aux;
                }
        fclose(fp);
}


void go(int k)
{
        Node far *aux;
        for(aux=a[k];(aux);aux=aux->next)
                if (!used[aux->son])
                {
                        used[aux->son]=1;
                        go(aux->son);
                        used[aux->son]=0;
                        aux->nodes=c[aux->son].nodes+1;
                        aux->dist=c[aux->son].dist+c[aux->son].nodes+1;
                        c[k].nodes+=aux->nodes;
                        c[k].dist+=aux->dist;
                }
}

void restore(void)
{
        Node far *aux;
        int color[NMAX+1],q[NMAX+1],p[NMAX+1],head,tail,nod,t2;
        long int t1;

        for(i=1;i<=N;i++) { color[i]=0; p[i]=0; }
        head=1; tail=0; color[1]=2;
        for(aux=a[1];aux;aux=aux->next)
                {
                        q[++tail]=aux->son; color[aux->son]=1; p[aux->son]=1;
                        c[1].dist+=aux->dist;
                }
        // breadth-first
        while(head<=tail)
                {
                        nod=q[head++]; t1=0; t2=0;
                        for(aux=a[p[nod]];aux;aux=aux->next)
                                if (aux->son!=nod)
                                        {       t1+=aux->dist; t2+=aux->nodes;  }
                        t1=(t1+t2+1);
                        t2++;
                        c[nod].dist=t1;
                        c[nod].nodes=t2;
                        for(aux=a[nod];aux->son!=p[nod];aux=aux->next);
                        aux->dist=c[nod].dist; aux->nodes=c[nod].nodes;
                        for(aux=a[nod];aux;aux=aux->next)
                                if (color[aux->son]==0)
                                        {
                                                color[aux->son]=1;
                                                q[++tail]=aux->son;
                                                p[aux->son]=nod;
                                                c[nod].dist+=aux->dist;
                                                c[nod].nodes+=aux->nodes;
                                        }
                        color[nod]=2;
                }
}

void getitoverwith(void)
{
        long int min=(long int)N*N;
        int nd;

        for(i=1;i<=N;i++)
                if (c[i].dist<min) { min=c[i].dist; nd=i; }
        printf("%d %ld\n",nd,min);
}

void main(void)
{
        load();
        for(i=1;i<=N;i++) { c[i].dist=0; c[i].nodes=0; }
        used[1]=1;      go(1);  used[1]=0;
        for(i=1;i<=N;i++) { c[i].dist=0; c[i].nodes=0; }
        restore();
        getitoverwith();
}
