//Susu Alex

#include <stdio.h>
#include <dos.h>
#include <graphics.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>

#define PRECISION 1.0

typedef unsigned char boolean;

float dx,dy;
int n,nr_max_cercuri;
float r[100];
float x[100],y[100];
float deltay2[100],dist[100];
unsigned index[100]; //index[i]=pozitia actuala a elem r[i] din vechiul r inainte de sortare
const boolean draw=0;
const float infx=1000;
const float infy=1000;
const float frag=10; //Altfel: frag=dx/min(r[i])
const int wait=3;
boolean gasit_x;
boolean gasit_y;

void init_g()
{
   /* request auto detection */
   int gdriver = DETECT, gmode, errorcode;

   /* initialize graphics mode */
   initgraph(&gdriver, &gmode, "");

   /* read result of initialization */
   errorcode = graphresult();

   if (errorcode != grOk)  /* an error occurred */
   {
      printf("Graphics error: %s\n", grapherrormsg(errorcode));
      printf("Press any key to halt:");
      getch();
      exit(1);             /* return with error code */
   }
}

void afis_cerc(int x,int y,int r)
{
        setcolor(15);
        circle(x,479-y,r);
        delay(wait);
        setcolor(0);
        circle(x,479-y,r);
}

void afis_toate()
{
        int j;

        setcolor(15);
        line(0,479,dx,479);
        line(0,479-dy,dx,479-dy);
        line(0,479-dy,0,479);
        line(dx,479-dy,dx,479);
        for (j=0; j<=nr_max_cercuri; j++)
                circle(x[j],479-y[j],r[j]);
}

void read()
{
        FILE *fin;
        int i;

        fin=fopen("eiffel.in","rt");
        fscanf(fin,"%f%f",&dx,&dy);
        fscanf(fin,"%d",&n);
        for (i=0; i<n ; i++)
            fscanf(fin,"%f",&r[i]);
        fclose(fin);
}

void write()
{
        FILE *fout;
        int j;
        float supr=0;

        fout=fopen("eiffel.out","wt");
        for (j=0; j<n ; j++)
            if (index[j]<nr_max_cercuri) supr+=r[index[j]]*r[index[j]];
        supr*=M_PI;
        fprintf(fout,"%.3f\n",supr);
        for (j=0; j<n ; j++)
            if (index[j]<nr_max_cercuri)
               fprintf(fout,"%.3f %.3f\n",x[index[j]],y[index[j]],r[index[j]]);
            else fprintf(fout,"0 0\n");
        fclose(fout);
}

void sort()
{
        int i,j,minpos,aux1;
        float aux;
	unsigned index1[100]; //index1[i]=pozitia veche inainte de sortare a elem r[i] din actualul r
        for (i=0; i<n; i++) index1[i]=i;
        for (i=0; i<n; i++)
        {
                minpos=i;
                for (j=i+1; j<n; j++)
                    if (r[minpos]>r[j]) minpos=j;
                if (minpos==i) continue;

                /*index[index[minpos]]=i;
                index[index[i]]=minpos;*/

                aux1=index1[minpos];
                index1[minpos]=index1[i];
                index1[i]=aux1;

                aux=r[minpos];
                r[minpos]=r[i];
                r[i]=aux;
        }
        for (i=0; i<n; i++) index[index1[i]]=i;
}

void div_et_imp_x(float left, float right)
{
        int j;
        boolean gasit;
        float middle=left+(right-left)/frag;
        float deltax2;

        if (left>right) return;
        gasit=1;
        for (j=0; j<nr_max_cercuri; j++)
        {
                deltax2=x[j]-middle;
                deltax2*=deltax2;
                if ( deltax2+deltay2[j] < dist[j] )
                {
                        gasit=0;
                        break;
                }
        }
        if (right-left<PRECISION)
           if (gasit==0) return;
           else
           {
                x[nr_max_cercuri]=middle;
                gasit_x=1;
                return;
           }
        if (gasit==0)
        {
                if (x[nr_max_cercuri]>middle) div_et_imp_x(middle,right);
        }
        else
        {
                x[nr_max_cercuri]=middle;
                gasit_x=1;
                div_et_imp_x(left,middle);
        }
}

void div_et_imp_y(float down, float up)
{
        int j;
        boolean gasit;
        float middle=down+(up-down)/frag;
        float oldx;

        if (down>up) return;
        //precalculari pentru optimizare
        for (j=0; j<nr_max_cercuri; j++)
        {
                deltay2[j]=y[j]-middle;
                deltay2[j]*=deltay2[j];
                dist[j]=r[nr_max_cercuri]+r[j];
                dist[j]*=dist[j];
        }
        gasit_x=0;
        oldx=x[nr_max_cercuri];
        x[nr_max_cercuri]=infx;
        div_et_imp_x(r[nr_max_cercuri],dx-r[nr_max_cercuri]);
        if (gasit_x==0) x[nr_max_cercuri]=oldx;
        if (up-down<PRECISION)
        {
                if (gasit_x==1)
                {
                        gasit_y=1;
                        y[nr_max_cercuri]=middle;
                }
        return;
        }
        if (gasit_x==0) div_et_imp_y(middle,up);
        else
        {
                y[nr_max_cercuri]=middle;
                gasit_y=1;
                div_et_imp_y(down,middle);
        }
}

void doit()
{
        x[0]=r[0];
        y[0]=r[0];
        if (draw==1) circle(x[0],479-y[0],r[0]);
        nr_max_cercuri=1;
        //completam dreptunghiul cu cercuri de jos in sus, de la stanga la
        //dreapta
        while (nr_max_cercuri<n)
        {
                gasit_y=0;
                if (draw==1) y[nr_max_cercuri]=dy/2;
                div_et_imp_y(r[nr_max_cercuri],dy-r[nr_max_cercuri]);
                if (gasit_y==0) break;
                if (draw==1) afis_toate();
                nr_max_cercuri++;
        }
}

void main()
{
        read();
        sort();
        if (draw==1) init_g();
        doit();
        write();
        if (draw==1) getch();
        if (draw==1) closegraph();
}
