// Raluca Sauciuc
// -- A se compila in Large --

#include <stdio.h>

#define NMax	701

int m,n,blx,bly,brx,bry;
int c[NMax],st1[NMax],st2[NMax],k;
long maxarea;
FILE *fp;

long area(int llx,int lly,int urx,int ury)
{
	if ((llx>urx)||(lly>ury)) return 0;
	return ((long)urx-llx+1)*(ury-lly+1);
}

void update(void)
{
	int j,x;
	for(j=0;j<n;j++)
	{
		fscanf(fp,"%d",&x);
		c[j]=(x) ? c[j]+1 : 0;
	}
}

void push(int x,int y)
{
	st1[++k]=x; st2[k]=y;
}

void pop(int& x,int& y)
{
	x=st1[k]; y=st2[k--];
}

void solve(void)
{
	int i,j,width,y0,w0;

	blx=0; bly=0; brx=-1; bry=-1;
	for (i=0;i<m;i++)
	{
		update();
		width=0; k=0;
		for(j=0;j<=n;j++)
		{
			if (c[j]>width)
				{ push(j,width); width = c[j]; }
			else
			if (c[j]<width)
			{
				do
				{
					pop(y0,w0);
					if (width*((long)j-y0)>maxarea)
					{
						blx=i; bly=y0; brx=i+width-1; bry=j-1;
						maxarea=area(blx,bly,brx,bry);
					}
					width=w0;
				}while ((c[j]<width)&&(k>=1));
				if (c[j]) push(y0,width);
				width=c[j];
			}
		}
	}
}

void main(void)
{
	fp=fopen("matrix.in","rt");
	fscanf(fp,"%d%d",&m,&n);
	solve();
	fclose(fp);
	fp=fopen("matrix.out","wt");
	fprintf(fp,"%ld\n",maxarea);
	fclose(fp);
}