/* Algoritmul este foarte simplu: modulul cauta prima gramada libera si ia o
   piesa din ea */
#include <stdio.h>
#include <stdlib.h>

int heapcount=3, piececount[4]={0xDEAD,3,4,5}, myheap=1, ingame=0;

void Error(char *S)
{
  printf("*** Oroare: *** %s Zero puncte!\n", S);
  exit(1);
}

void m_start(void)
{
  if (ingame) Error("Iar ati apelat m_start?");
  ingame=1;
}

int m_heapcount(void)
{
  if (!ingame) Error("Ati uitat apelul lui m_start.");
  return heapcount;
}

int m_piececount(int heap)
{
  if (!ingame) Error("Ati uitat apelul lui m_start.");
  return (heap<1||heap>heapcount) ? 0 : piececount[heap];
}

void NextHeap(int Who)
/* Cineva a golit gramada din care obisnuia sa ia piese calculatorul
  (Who=False pentru om, Who=True pentru modul). Asa ca trebuie sa cautam
  urmatoarea gramada */
{
  while (!piececount[myheap] && myheap<heapcount) myheap++;
  if (!piececount[myheap]) // Nu mai e gramezi pline
    if (Who) Error("Te-am batut!");
    else { puts("** Bravo ** M-ai batut!");
           exit(0);
         }
}

void m_mymove(int heap, int count)
{
  if (!ingame) Error("Ati uitat apelul lui m_start.");
  if (heap<1||heap>heapcount) Error("Gramada inexistenta.");
  if (piececount[heap]<count) Error("N-aveti de unde!");
  piececount[heap]-=count;
  if (!piececount[heap] && heap==myheap) NextHeap(0);
}

void m_modulemove(int *heap, int *count)
{
  *heap=myheap; *count=1;
  if (!--piececount[myheap]) NextHeap(1);
}
