unit Nim;
{ Algoritmul este foarte simplu: modulul cauta prima gramada libera si ia o
  piesa din ea }

interface

procedure m_start;
function m_heapcount:Integer;
function m_piececount(heap:Integer):Integer;
procedure m_mymove(heap, count:Integer);
procedure m_modulemove(var heap, count:Integer);

implementation

const heapcount:Integer=3;
      piececount:array[1..3] of Integer=(3,4,5);
      myheap:Integer=1;
      ingame:Boolean=False;

procedure Error(S:String);
begin
  WriteLn('*** Oroare: *** ', S, ' Zero puncte!');
  Halt;
end;

procedure m_start;
begin
  if ingame then Error('Iar ati apelat m_start?');
  ingame:=True;
end;

function m_heapcount:Integer;
begin
  if not ingame then Error('Ati uitat apelul lui m_start.');
  m_heapcount:=heapcount;
end;

function m_piececount(heap:Integer):Integer;
begin
  if not ingame then Error('Ati uitat apelul lui m_start.');
  if (heap<1) or (heap>heapcount)
    then m_piececount:=0
    else m_piececount:=piececount[heap];
end;

procedure NextHeap(Who:Boolean);
{ Cineva a golit gramada din care obisnuia sa ia piese calculatorul
  (Who=False pentru om, Who=True pentru modul). Asa ca trebuie sa cautam
  urmatoarea gramada }
begin
  while (piececount[myheap]=0) and (myheap<heapcount) do Inc(myheap);
  if piececount[myheap]=0 { Nu mai e gramezi pline }
    then if Who then Error('Te-am batut!')
                else begin
                       WriteLn('** Bravo ** M-ai batut!');
                       Halt;
                     end;
end;

procedure m_mymove(heap, count:Integer);
begin
  if not ingame then Error('Ati uitat apelul lui m_start.');
  if (heap<1) or (heap>heapcount) then Error('Gramada inexistenta.');
  if piececount[heap]<count then Error('N-aveti de unde!');
  Dec(piececount[heap], count);
  if (piececount[heap]=0) and (heap=myheap)
    then NextHeap(False);
end;

procedure m_modulemove(var heap, count:Integer);
begin
  heap:=myheap; count:=1;
  Dec(piececount[myheap]);
  if piececount[myheap]=0 then NextHeap(True);
end;

end.
