#include <fstream.h>
#include <conio.h>
#include <string.h>

#define NMax 1001

typedef unsigned char boolean;

unsigned n;
unsigned sir[NMax];
unsigned ord[NMax]; //ord[i]=pozitia la care se gaseste al i-lea cel mai mic nr din sir in sirul rotit
unsigned ord1[NMax]; //ord1[i]=spune al catulea element este pe pozitia i in sir
unsigned sol[NMax*3],solPos;

void QuickSort(int l, int r)
{
  int i,j,x,y;
  i=l; j=r; x=sir[(l+r)>>1];
  do
  {
    while (sir[i]<x) i++;
    while (x<sir[j]) j--;
    if (i<=j)
    {
        y=sir[i]; sir[i]=sir[j]; sir[j]=y;
        y=ord[i]; ord[i]=ord[j]; ord[j]=y;
        i++; j--;
    }
  }
  while (i<=j);
  if (l<j) QuickSort(l, j);
  if (i<r) QuickSort(i, r);
}

void Roteste(unsigned pos)
{
        int i,j;
        unsigned tmp;

        if (sol[solPos]!=pos) sol[++solPos]=pos;
           else solPos--;

        i=1;
        j=pos-1;
        while (i<j)
        {
                tmp=ord[ord1[i]];
                ord[ord1[i]]=ord[ord1[j]];
                ord[ord1[j]]=tmp;
                tmp=ord1[i];
                ord1[i]=ord1[j];
                ord1[j]=tmp;
                i++;
                j--;
        }

        i=pos+1;
        j=n;
        while (i<j)
        {
                tmp=ord[ord1[i]];
                ord[ord1[i]]=ord[ord1[j]];
                ord[ord1[j]]=tmp;
                tmp=ord1[i];
                ord1[i]=ord1[j];
                ord1[j]=tmp;
                i++;
                j--;
        }
}

void doit()
{
        int i;

        for (i=1; i<=n; i++) ord[i]=i;
        QuickSort(1,n);
        for (i=1; i<=n; i++) ord1[ord[i]]=i;
        solPos=0;
        sol[0]=65535;
        for (i=1; i<n; i++)
        {
                if (ord[i]!=1) Roteste(ord[i]+1);
                Roteste(ord[i+1]);
        }
}

void read()
{
        ifstream fin("sir.in");
        fin>>n;
        for (int i=1; i<=n; i++) fin>>sir[i];
}

void write()
{
        ofstream fout("sir.out");

        for (int i=1; i<solPos; i++)
            fout<<sol[i]<<"\n";
        fout<<sol[i];
}

void main()
{
        clrscr();
        read();
        doit();
        write();
}