program Permutari;
{ Francu Catalin - Varianta dasteapta }
const NMax=45;
type Huge=array[0..26] of Byte;
     Vector=array[0..NMax*(NMax-1) div 2] of Huge;
var P, Q:Vector;
    N, K, i, j:Integer;

procedure InitNumber(var H:Huge; X:Integer);
{ H <- X }
begin
  FillChar(H, SizeOf(H), 0);
  H[0]:=1; H[1]:=X;
end;

procedure Add(var A, B:Huge);
{ A <- A+B }
var T, i:Integer;
begin
  T:=0;
  if B[0]>A[0] then A[0]:=B[0];
  for i:=1 to A[0] do
    begin
      T:=T+A[i]+B[i];
      A[i]:=T and $FF;
      T:=T shr 8;
    end;
  if T>0 then begin
                Inc(A[0]);
                A[A[0]]:=T;
              end;
end;

procedure Sub(var A, B:Huge);
{ A <- A-B }
var T, Aux, i:Integer;
begin
  T:=0;
  for i:=1 to A[0] do
    begin
      Aux:=Integer(A[i])-Integer(B[i])-T;
      if Aux<0 then begin
                      T:=1;
                      Aux:=Aux+256;
                    end
               else T:=0;
      A[i]:=Aux;
    end;
  while (A[A[0]]=0) and (A[0]>0) do Dec(A[0]);
end;

function Div10(var H:Huge):Integer;
{ H <- H div 10 si intoarce H mod 10 }
var R:Word;
    i:Integer;
begin
  R:=0;
  for i:=H[0] downto 1 do
    begin
      R:=(R shl 8)+H[i];
      H[i]:=R div 10;
      R:=R mod 10;
    end;
  while (H[H[0]]=0) and (H[0]>0) do Dec(H[0]);
  Div10:=R;
end;

procedure WriteNumber(H:Huge);
var i:Integer;
    S:String;
begin
  S:='';
  while H[0]>0 do S:=Chr(Div10(H)+48)+S;
  WriteLn(S);
end;

begin
  Assign(Input, 'perm.in'); Reset(Input);
  ReadLn(N, K);
  Close(Input);
  for i:=0 to N*(N-1) div 2 do InitNumber(P[i],0);
  InitNumber(P[0], 1);
  Q:=P;
  for i:=2 to N do
    begin
      for j:=0 to i*(i-1) div 2 do
        begin
          Add(Q[j], Q[j-1]);
          if (j>=i) then Sub(Q[j], P[j-i]);
        end;
      P:=Q;
    end;
  WriteNumber(Q[K]);
end.
