#pragma option -3 -f287 -O2

#define NDEBUG

#include<stdio.h>
#include<stdlib.h>
#include<mem.h>
#include<assert.h>
#define DIM 180

#define V(i) vec[(i)%1001]



struct atom
{
        int f,c;
        atom *next;
};

int (*d)[DIM]; // datele
int n, m, k;
unsigned char *fr;   // fortarete
//unsigned char *frl;  // fortarete
int *rez;
atom *vec[1001];



void intro()
{
        FILE *f = fopen("asezari.in","rt");
        int i, a, b, c;

        fscanf(f, "%d %d %d", &n, &m, &k);

        fr = new unsigned char[k]; assert(fr != NULL);
//        frl = new unsigned char[n]; assert(frl != NULL);
//        memset(frl, 0, n*sizeof(*frl));
        d = new int[n][DIM]; assert(d != NULL);
        memset(d, 0, n*sizeof(*d));
        memset(vec, 0, sizeof(vec));
        rez = new int[n]; assert(rez != NULL);

        for(i = 0; i < n; i++) rez[i] = -1;

        for(i = 0; i < k; i++)
        {
                fscanf(f,"%d",&a);
                fr[i] = a-1;
                rez[a-1] = -2;
//                frl[a-1]=1;
        }
        for(i = 0; i < m; i++)
        {
           fscanf(f,"%d %d %d", &a, &b, &c);
           a--; b--;
           d[a][b] = d[b][a] = c;
        }
        fclose(f);
}


inline void add(int f, int c, long l)
{
        atom *p = new atom; assert(p != NULL);

        p->f = f;
        p->c = c;
        p->next = V(l);
        V(l) = p;
}

void alg()
{
        int a, *flag = new int[n];
        long i, j;
        atom *p;


        for(i = 0; i < k; i++)
         for(j = 0; j < n; j++)
          if(rez[j] == -1 && (a = d[fr[i]][j])) add(fr[i], j, a);

        for(i = 0, j = 1000; i <= j; i++)
         if(p = V(i))
          {
           assert( i <= 180000);
           assert( j <= 180000);
           memset(flag, 0, n * sizeof(*flag));
           do
           {
                 int c = p->c, f = p->f;
                 V(i) = p->next;

                 delete p;

                 if(rez[c] == -1 || flag[c] && rez[c] > f) rez[c]=f,flag[c]=1;
                 else continue;


                 for(k = 0; k < n; k++)
                  if(rez[k] == -1 && d[c][k])
                    add(f, k, i + d[c][k]);

           } while(p = V(i));
           j = i + 1000;
          }
}

void afis()
{
        FILE *f = fopen("asezari.out", "wt");

        for(int i = 0; i< n; i++)
         if(rez[i] == -2) fprintf(f, "0 ");
          else fprintf(f, "%d ", rez[i]+1);

        fclose(f);
}



int main()
{

        intro();
        alg();
        afis();
        return 0;
}
